<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.16.2.8 $
 * $Author: tora60 $
 * $Date: 2008/01/29 20:49:32 $
 */

defined('mxMainFileLoaded') or die('access denied');

if (!mxGetAdminPref("radminsuper")) {
    mxErrorScreen("Access Denied");
    die();
}

$wysiwyg = 0;
include_once('spaw/spaw_control.class.php');

/**
 */
function BlocksAdmin($gvs = array())
{
    global $bgcolor3, $bgcolor2, $bgcolor1, $prefix, $currentlang;
    $img_activate = mxCreateImage("images/activate.gif", _ACTIVATE);
    $img_deactivate = mxCreateImage("images/deactivate.gif", _DEACTIVATE);
    $img_delete = mxCreateImage("images/delete.gif", _DELETE);
    $img_edit = mxCreateImage("images/edit.gif", _EDIT);
    $img_view = mxCreateImage("images/view.gif", _SHOW);
    $curpos = "";
    $i = 0;

    if (isset($gvs['filter'])) {
        if ($gvs['filter'] == -1) {
            mxSessionDelVar("blockfilter");
        } else {
            mxSessionSetVar("blockfilter", $gvs['filter']);
        }
    }
    $filterlink[] = (mxSessionGetVar("blockfilter") == 1) ? "<b>" . _BLOCKSHOWACTIVE . "</b>" : "<a href=\"admin.php?op=BlocksAdmin&amp;filter=1\">" . _BLOCKSHOWACTIVE . "</a>";
    $filterlink[] = (!mxSessionGetVar("blockfilter")) ? "<b>" . _BLOCKSHOWALL . "</b>" : "<a href=\"admin.php?op=BlocksAdmin&amp;filter=-1\">" . _BLOCKSHOWALL . "</a>";
    $filterlink[] = (mxSessionGetVar("blockfilter") == 2) ? "<b>" . _BLOCKSHOWDEACTIVE . "</b>" : "<a href=\"admin.php?op=BlocksAdmin&amp;filter=2\">" . _BLOCKSHOWDEACTIVE . "</a>";
    $filterlink = "[ " . implode(" | ", $filterlink) . " ]";

    if (mxSessionGetVar("blockfilter") == 1) {
        $qryfilter = " WHERE active = 1 ";
    } else if (mxSessionGetVar("blockfilter") == 2) {
        $qryfilter = " WHERE active = 0 ";
    } else {
        $qryfilter = "";
    }

    $qry = "SELECT bid, bkey, title, url, position, weight, active, blanguage, blockfile, view, refresh
            FROM ${prefix}_blocks " . $qryfilter . "
                    ORDER BY position, weight";
    $result = sql_query($qry);
    while ($block = sql_fetch_array($result)) {
        $temp = $block['position'];
        if (mxIsNewsBlockfile($block['blockfile'])) {
            $temp = "z";
        }

        $block['cachetime'] = getRefreshTimeString($block['refresh']);

        if ($temp == "c") $block['pos'] = _CENTERUP;
        else if ($temp == "d") $block['pos'] = _CENTERDOWN;
        else if ($temp == "r") $block['pos'] = _RIGHT;
        else if ($temp == "z") $block['pos'] = _RIGHTNEWS;
        else $block['pos'] = _LEFT;

        if (!empty($block['url'])) $block['type'] = "RSS/RDF";
        // else if (!empty($block['blockfile'])) $block['type'] = _BLOCKFILE2;
        else if (!empty($block['blockfile'])) $block['type'] = str_replace(".php", "", str_replace("block-", "", $block['blockfile'])) . " (" . _BLOCKFILE2 . ")";
        else $block['type'] = "HTML";

        if ($block['view'] == 0) $block['who_view'] = _MVALL;
        elseif ($block['view'] == 1) $block['who_view'] = _MVGROUPS2;
        elseif ($block['view'] == 2) $block['who_view'] = _MVADMIN;
        elseif ($block['view'] == 3) $block['who_view'] = _MVANON;

        $block['title'] = (empty($block['active'])) ? "<i>" . $block['title'] . "</i>" : $block['title'];
        $block['change'] = (empty($block['active'])) ? $img_activate : $img_deactivate;
        $block['active'] = (empty($block['active'])) ? "<i>" . _INACTIVE . "</i>" : _ACTIVE;

        if ($GLOBALS['multilingual']) {
            if (empty($block['blanguage'])) {
                $block['blanguage'] = _ALL;
            } else {
                $block['blanguage'] = ucfirst($block['blanguage']);
            }
        }
        $allblocks[$temp][$i] = $block;
        $i++;
    }
    $newblocks = array();
    if (isset($allblocks)) {
        ksort($allblocks);
        foreach ($allblocks as $array) {
            $newblocks = array_merge($newblocks, $array);
        }
        unset($allblocks);
    }

    include("header.php");
    // $colspan = 8;
    $colspan = 7;
    $headline = "<tr bgcolor=\"$bgcolor2\">"
     . "<td align=\"center\"><b>" . _BLOCKORDER . "</b></td>"
    // ."<td align=\"center\" colspan=\"2\"><b>"._WEIGHT."</b></td>"
    . "<td align=\"center\"><b>" . _TITLE . "</b></td>"
     . "<td align=\"center\"><b>" . _TYPE . "/" . _FILENAME . "</b></td>"
     . "<td align=\"center\"><b>" . _STATUS . "</b></td>"
     . "<td align=\"center\"><b>" . "Caching" . "</b></td>"
     . "<td align=\"center\"><b>" . _VIEW . "</b></td>";
    if ($GLOBALS['multilingual']) {
        $headline .= "<td align=\"center\"><b>" . _LANGUAGE . "</b></td>";
        $colspan++;
    }
    $headline .= "<td align=\"center\"><b>" . _FUNCTIONS . "</b></td></tr>";
    GraphicAdmin();
    title(_BLOCKSADMIN);
    OpenTable();
    echo "<center><span class=\"content\">" . $filterlink . "</span></center>";
    if (!count($newblocks)) {
        echo "<center><span class=\"content\"><br>" . _BLOCKNOBLOCKS . "</span></center>";
    }

    echo "<br>";
    if (count($newblocks)) {
        echo "<form action=\"admin.php\" method=\"post\">";
        echo "<input type=\"hidden\" name=\"op\" value=\"BlocksListWeigth\">";
        echo "<table border=\"0\" width=\"100%\" bgcolor=\"$bgcolor1\" cellpadding=\"1\" cellspacing=\"1\">";
        $i = 1;
        foreach ($newblocks as $block) {
            extract($block);
            if ($curpos != $pos) {
                echo "<tr bgcolor=\"$bgcolor2\"><td colspan=\"$colspan\"><font class=\"title\">" . _POSITION . ": <b><i>" . $pos . "</i></b></font></td></tr>\n" . $headline;
                $curpos = $pos;
                $i = 1;
            }
            echo "<tr bgcolor=\"$bgcolor3\">";
            echo "<td align=\"left\"><input type=\"text\" name=\"weight[" . $bid . "]\" value=\"" . $i . "\" size=\"3\" maxlength=\"3\"></td>";
            echo "<td>" . $title . "</td><td>" . $type . "</td><td>" . $active . "</td><td>" . $cachetime . "</td><td>" . $who_view . "</td>";
            if ($GLOBALS['multilingual']) {
                echo "<td>" . $blanguage . "</td>";
            }
            echo "<td nowrap><font class=\"content\"><a href=\"admin.php?op=BlocksEdit&amp;bid=" . $bid . "\">" . $img_edit . "</a> <a href=\"admin.php?op=ChangeStatus&amp;bid=" . $bid . "\">" . $change . "</a> ";
            if ($pos != _RIGHTNEWS) {
                echo " <a href=\"admin.php?op=BlocksDelete&amp;bid=" . $bid . "\">" . $img_delete . "</a> ";
                echo " <a href=\"admin.php?op=block_show&amp;bid=" . $bid . "\">" . $img_view . "</a> ";
            }
            echo "</font></td></tr>";
            $i++;
        }
        echo "<tr bgcolor=\"$bgcolor2\"><td colspan=\"$colspan\"><input type=\"submit\" value=\"" . _BLOCKSAVEORDER . "\"></td></tr>\n";
        echo "</table>";
        echo "</form>";
        // echo "<br>";
    }

    echo "<center>[&nbsp;<a href=\"admin.php?op=fixweight\">" . _FIXBLOCKS . "</a> | <a href=\"admin.php?op=resetBlockCache\">" . _BLOCKDELCACHE . "</a>&nbsp;]</center>";
    CloseTable();
    blockaddform("file");
    blockaddform("html");
    blockaddform("rss");
    include("footer.php");
}

/**
 */
function BlocksListWeigth($pvs)
{
    global $prefix;
    $i = 0;
    foreach ($pvs['weight'] as $bid => $weight) {
        $qry = "UPDATE ${prefix}_blocks SET weight=" . $weight . " WHERE bid=" . $bid . " AND weight<>" . $weight;
        $result = sql_query($qry);
        if ($result) $i++;
    }
    if ($i) {
        repairweigth();
    }
    mxRedirect('admin.php?op=BlocksAdmin', _ADMIN_SETTINGSAVED);
}

/**
 */
function blockaddform ($mode)
{
    static $groupselect;
    if (!isset($groupselect)) {
        $groupselect = getGroupSelect(0);
    }
    if ($mode == "file") $type = _BLOCKFILE;
    if ($mode == "html") $type = "(HTML)";
    if ($mode == "rss") $type = _RSSCONTENT;
    echo "<br>";
    OpenTable();
    echo "<fieldset><legend>" . _ADDNEWBLOCK . " " . $type . "</legend>";
    echo "<form action=\"admin.php\" method=\"post\">";
    echo "<table border=\"0\" width=\"100%\">";
    echo "<tr valign='top'><td width=\"20%\">" . _TITLE . ":</td><td width=\"80%\"><input type=\"text\" name=\"title\" size=\"30\" maxlength=\"60\"></td></tr>";
    if ($mode == "file") {
        echo "<tr valign='top'><td>" . _FILENAME . ":</td><td>" . mxGetBlockfileSelect("") . "</td></tr>";
    }
    if ($mode == "rss") {
        echo "<tr valign='top'><td>" . _RSSFILE . ":</td><td>" . getHeadlineSelect ("") . "</td></tr>";
    }
    if ($mode == "html") {
        if ($GLOBALS['wysiwyg']) {
            echo "<tr valign='top'><td colspan='2'>" . _CONTENT . ":<br />";
            $sw = new SPAW_Wysiwyg('content', '', _DOC_LANGUAGE, $GLOBALS['wysiwyg_toolbar'], $GLOBALS['wysiwyg_btnset'], '100%', '250');
            $sw->show();
        } else {
            echo "<tr valign='top'><td>" . _CONTENT . ":</td><td><textarea name=\"content\" cols=\"60\" rows=\"10\"></textarea>";
        }

        echo "</td></tr>";
    }
    echo "<tr valign='top'><td>" . _POSITION . ":</td><td>" . getPositionSelect("l") . "</td></tr>";
    echo "<tr valign='top'><td>" . _WEIGHT . ":</td><td><input type=\"text\" name=\"weight\" size=\"3\" maxlength=\"3\" value=\"0\"></td></tr>";
    if ($GLOBALS['multilingual']) {
        echo "<tr valign='top'><td>" . _LANGUAGE . ":</td><td>" . mxAdminLanguageSelect("blanguage") . "</td>";
    } else {
        echo "<input type=\"hidden\" name=\"blanguage\" value=\"\">";
    }
    echo "<tr valign='top'><td>" . _ACTIVATE2 . "</td><td>" . getActiveSelect(1) . "</td></tr>";
    echo "<tr valign='top'><td>" . _VIEWPRIV . "</td><td>" . getViewSelect(0) . "</td></tr>"; #</table><br><br>
    echo "<tr valign='top'><td><!-- " . _VIEWPRIV . " --></td><td>" . $groupselect . "</td></tr>";
    if ($mode == "rss") {
        echo "<tr valign='top'><td>" . _REFRESHTIME . ":</td><td>" . getRefreshSelect(3600, 0) . "</td></tr>";
    } else if ($mode == "file") {
        echo "<tr valign='top'><td>" . _REFRESHTIME . ":</td><td>" . getRefreshSelect(0, 1) . "</td></tr>";
    }
    echo "</table>";
    echo "<input type=\"hidden\" name=\"op\" value=\"BlocksAdd\">";
    echo "<input type=\"submit\" value=\"" . _CREATEBLOCK . "\">";
    echo "</form></fieldset>";
    CloseTable();
}

/**
 */
function BlocksEdit($gvs)
{
    global $bgcolor2, $bgcolor4, $prefix;
    $bid = (int)$gvs['bid'];
    $menu = (empty($gvs['menu'])) ? 0 : 1;
    $result = sql_query("select * from ${prefix}_blocks where bid=" . $bid);
    $block = sql_fetch_array($result);
    extract($block);
    $type = (empty($url)) ? "HTML" : _RSSCONTENT;
    $type = (empty($blockfile)) ? $type : _BLOCKFILE;
    $oldposition = $position;
    include("header.php");
    GraphicAdmin();
    title(_EDITBLOCK);
    OpenTable();
    echo "<fieldset><legend>" . _BLOCK . ": " . $title . " <em>" . $type . "</em></legend>"
     . "<form action=\"admin.php\" method=\"post\">"
     . "<table border=\"0\" width=\"100%\">"
     . "<tr valign='top'><td width=\"20%\">" . _TITLE . ":</td><td width=\"80%\"><input type=\"text\" name=\"title\" size=\"30\" maxlength=\"60\" value=\"" . mxEntityQuotes($title) . "\"></td></tr>";
    if ($type == _BLOCKFILE) {
        if (mxIsNewsBlockfile($blockfile)) {
            echo "<input type=\"hidden\" name=\"blockfile\" value=\"" . $blockfile . "\">";
        } else {
            echo "<tr valign='top'><td>" . _FILENAME . ":</td><td>" . mxGetBlockfileSelect($blockfile) . "</td></tr>";
        }
    } else if ($type == _RSSCONTENT) {
        echo "<tr valign='top'><td>" . _RSSFILE . ":</td><td>" . getHeadlineSelect ($url) . "</td></tr>";
    } else {
        echo "<tr valign='top'><td>" . _CONTENT . ":</td><td>";
        if ($GLOBALS['wysiwyg']) {
            $sw = new SPAW_Wysiwyg('content', $content, _DOC_LANGUAGE, $GLOBALS['wysiwyg_toolbar'], $GLOBALS['wysiwyg_btnset'], '100%', '250');
            $sw->show();
        } else {
            echo "<textarea name=\"content\" cols=\"60\" rows=\"10\">" . $content . "</textarea>";
        }
        echo "</td></tr>";
    }
    if (!mxIsNewsBlockfile($blockfile)) {
        echo "<tr valign='top'><td>" . _POSITION . ":</td><td>" . getPositionSelect($position) . "</td></tr>";
    } else {
        echo "<tr valign='top'><td>" . _POSITION . ":</td><td><b>" . _RIGHT . "</b><input type=\"hidden\" name=\"position\" value=\"r\"></td></tr>";
    }
    echo "<tr valign='top'><td>" . _WEIGHT . ":</td><td><input type=\"text\" name=\"weight\" size=\"5\" maxlength=\"3\" value=\"" . $weight . "\"></td></tr>";
    if ($GLOBALS['multilingual']) {
        echo "<tr valign='top'><td>" . _LANGUAGE . ":</td><td>" . mxAdminLanguageSelect("blanguage", $blanguage) . "</td></tr>";
    } else {
        echo "<input type=\"hidden\" name=\"blanguage\" value=\"\">";
    }
    echo "<tr valign='top'><td>" . _ACTIVATE2 . "</td><td>" . getActiveSelect($active) . "</td></tr>";
    echo "<tr valign='top'><td>" . _VIEWPRIV . "</td><td>" . getViewSelect($view) . "</td></tr>"; #</table><br><br>
    echo "<tr valign='top'><td><!-- " . _VIEWPRIV . " --></td><td>" . getGroupSelect($bid) . "</td></tr>";
    if ($type == _BLOCKFILE) {
        echo "<tr valign='top'><td>" . _REFRESHTIME . ":</td><td>" . getRefreshSelect($refresh, 1) . "</td></tr>";
    } else if ($type == _RSSCONTENT) {
        echo "<tr valign='top'><td>" . _REFRESHTIME . ":</td><td>" . getRefreshSelect($refresh, 0) . "</td></tr>";
    }
    echo "</table>";
    if ($type == _BLOCKFILE) {
        echo '<input type="hidden" name="content" value="' . $content . '">';
    }
    if ($menu == 1) {
        echo '<input type="hidden" name="menu" value="1">';
    }
    echo "<input type=\"hidden\" name=\"op\" value=\"BlocksEditSave\">"
     . "<input type=\"hidden\" name=\"oldposition\" value=\"" . $oldposition . "\">"
     . "<input type=\"hidden\" name=\"bid\" value=\"" . $bid . "\">"
     . "<input type=\"submit\" value=\"" . _SAVEBLOCK . "\">"
     . "</form></fieldset>";
    CloseTable();
    echo "<br>";
    block_editmenue ($block, _BLOCKACTIVATION, $menu);
    showpreview($block);
    include("footer.php");
}

/**
 */
function Blocksave($block)
{
    global $prefix;
    $block['active'] = (empty($block['active'])) ? 0 : 1;
    $block['weight'] = (empty($block['weight'])) ? 0 : (int)$block['weight'];
    $block['view'] = (empty($block['view'])) ? 0 : (int)$block['view'];
    $block['refresh'] = (empty($block['refresh'])) ? 0 : (int)$block['refresh'];
    $block['url'] = (empty($block['url'])) ? "" : $block['url'];
    $block['blockfile'] = (empty($block['blockfile'])) ? "" : $block['blockfile'];
    $block['blanguage'] = (empty($block['blanguage'])) ? "" : $block['blanguage'];
    $block['content'] = (empty($block['content'])) ? "" : $block['content'];
    $menu = (empty($block['menu'])) ? 0 : 1;

    if (!empty($block['headline'])) {
        $result = sql_query("select sitename, headlinesurl from " . $prefix . "_headlines where hid='" . $block['headline'] . "'");
        list ($xtitle, $block['url']) = sql_fetch_row($result);
        if (empty($block['title'])) $block['title'] = $xtitle;
    }
    $block['content'] = (empty($block['url'])) ? $block['content'] : mxGetRssContent($block['url']);
    if (empty($block['content']) && empty($block['blockfile']) && !empty($block['url'])) {
        rssfail();
        exit;
    }
    $block = mxAddSlashesForSQL($block);
    // mxdebugfuncvars($block);
    if ($block['op'] == "BlocksEditSave") {
        $qry = "UPDATE ${prefix}_blocks SET
                        title='" . $block['title'] . "',
                        blockfile='" . $block['blockfile'] . "',
                        content='" . $block['content'] . "',
                        url='" . $block['url'] . "',
                        position='" . $block['position'] . "',
                        weight=" . $block['weight'] . ",
                        active=" . $block['active'] . ",
                        refresh=" . $block['refresh'] . ",
                        blanguage='" . $block['blanguage'] . "',
                        view=" . $block['view'] . "
                        where bid=" . $block['bid'];
        switch ($menu) {
            case "1":
                $location = "admin.php?op=menu";
                break;

            default:
                $location = "admin.php?op=BlocksEdit&bid=" . $block['bid'];
                break;
        }
        if ($block['refresh'] && $block['blockfile']) {
            include_once('includes/mx_reset.php');
            resetBlockCache($block['bid']);
        }
    } else {
        $result1 = sql_query("SELECT Max(bid)+1 AS new FROM ${prefix}_blocks");
        list($block['bid']) = sql_fetch_row($result1);
        if (empty($block['bid'])) {
            $block['bid'] = 1;
        }

        $qry = "INSERT INTO ${prefix}_blocks
        (bid, title,content,url,position,weight,active,refresh,time,blanguage,blockfile,view) values
        (" . $block['bid'] . ", '" . $block['title'] . "','" . $block['content'] . "','" . $block['url'] . "','" . $block['position'] . "'," . $block['weight'] . "," . $block['active'] . "," . $block['refresh'] . ",0,'" . $block['blanguage'] . "','" . $block['blockfile'] . "'," . $block['view'] . ")";
        $location = "admin.php?op=BlocksAdmin";
    }
    $result = sql_query($qry);
    if ($result) {
        repairweigth();
        // Gruppen aktualisieren
        sql_query("DELETE FROM " . $prefix . "_groups_blocks WHERE block_id=" . $block['bid']);
        if ($block['view'] == 1) {
            // Sicherstellen, dass wirklich eine Gruppe selektiert wurde
            if (empty($block['groups'])) {
                $block['groups'] = array(intval($GLOBALS['default_group']));
            } else if (!is_array($block['groups'])) {
                $block['groups'] = array(intval($block['groups']));
            }
            if (empty($block['groups'][0])) {
                $block['groups'] = array(intval($GLOBALS['default_group']));
            }
            foreach ($block['groups'] as $groupid) {
                sql_query("INSERT INTO " . $prefix . "_groups_blocks (group_id, block_id) VALUES (" . $groupid . ", " . $block['bid'] . ")");
            }
        }
        // / RSS-Daten an Headlines anfuegen
        if (empty($block['headline']) && !empty($block['url']) && !empty($block['content']) && !empty($block['title']) && $result) {
            $result2 = sql_query("select headlinesurl from " . $prefix . "_headlines where headlinesurl='" . $block['url'] . "' OR sitename='" . $block['title'] . "'");
            list ($xurl) = sql_fetch_row($result2);
            if (empty($xurl)) {
                sql_query("INSERT INTO " . $prefix . "_headlines (sitename, headlinesurl) values ('" . $block['title'] . "', '" . $block['url'] . "')");
            }
        }
    }
    mxRedirect($location, _ADMIN_SETTINGSAVED);
}

/**
 */
function getActiveSelect($active = 1)
{
    $active = (int)$active;
    $out = "<input type=\"radio\" name=\"active\" value=\"1\"" . (($active == 1) ? " checked" : "") . ">" . _YES . " &nbsp;&nbsp;";
    $out .= "<input type=\"radio\" name=\"active\" value=\"0\"" . (($active == 0) ? " checked" : "") . ">" . _NO . "\n";
    return $out;
}

/**
 */
function getRefreshSelect($refresh = 0, $shownever = 0)
{
    $refresh = (int)$refresh;
    $out = "<select name=\"refresh\">";
    if ($shownever) {
        $out .= "<option value=\"0\"" . (($refresh == 0) ? ' selected="selected"' : '') . ">- " . _NEVER . "</option>";
    }
    $out .= "<option value=\"300\"" . (($refresh == 300) ? ' selected="selected"' : '') . ">5&nbsp;&nbsp; " . _MINUTES . "</option>"
     . "<option value=\"600\"" . (($refresh == 600) ? ' selected="selected"' : '') . ">10 " . _MINUTES . "</option>"
     . "<option value=\"1200\"" . (($refresh == 1200) ? ' selected="selected"' : '') . ">20 " . _MINUTES . "</option>"
     . "<option value=\"1800\"" . (($refresh == 1800) ? ' selected="selected"' : '') . ">30 " . _MINUTES . "</option>"
     . "<option value=\"3600\"" . (($refresh == 3600) ? ' selected="selected"' : '') . ">1&nbsp;&nbsp; " . _HOUR . "</option>"
     . "<option value=\"18000\"" . (($refresh == 18000) ? ' selected="selected"' : '') . ">5&nbsp;&nbsp; " . _HOURS . "</option>"
     . "<option value=\"36000\"" . (($refresh == 36000) ? ' selected="selected"' : '') . ">10&nbsp; " . _HOURS . "</option>"
     . "<option value=\"86400\"" . (($refresh == 86400) ? ' selected="selected"' : '') . ">24&nbsp; " . _HOURS . "</option>"
     . "<option value=\"172800\"" . (($refresh == 172800) ? ' selected="selected"' : '') . ">48&nbsp; " . _HOURS . "</option>"
     . "</select>";
    if ($shownever) {
        $out .= "<br><span class=\"tiny\">" . _BLOCKCACHEMSG . "</span>";
    }
    // ."&nbsp;<font class=\"tiny\">"._ONLYHEADLINES."</font>";
    return $out;
}

/**
 */
function getRefreshTimeString($refresh)
{
    $r = (int)$refresh;
    if ($r == 300) return "5 " . _MINUTES;
    else if ($r == 600) return "10 " . _MINUTES;
    else if ($r == 1200) return "20 " . _MINUTES;
    else if ($r == 1800) return "30 " . _MINUTES;
    else if ($r == 3600) return "1 " . _HOUR;
    else if ($r == 18000) return "5 " . _HOURS;
    else if ($r == 36000) return "10 " . _HOURS;
    else if ($r == 86400) return "24 " . _HOURS;
    else if ($r == 172800) return "48 " . _HOURS;
    else return "";
}

/**
 */
function getViewSelect($view = 0)
{
    $view = (int)$view;
    $out = "<select name=\"view\">"
     . "<option value=\"0\"" . (($view == 0) ? ' selected="selected"' : '') . ">" . _MVALL . "</option>"
     . "<option value=\"1\"" . (($view == 1) ? ' selected="selected"' : '') . ">" . _MVGROUPS . "</option>"
     . "<option value=\"2\"" . (($view == 2) ? ' selected="selected"' : '') . ">" . _MVADMIN . "</option>"
     . "<option value=\"3\"" . (($view == 3) ? ' selected="selected"' : '') . ">" . _MVANON . "</option>"
     . "</select>";
    return $out;
}

/**
 */
function getGroupSelect($blockid = 0)
{
    global $prefix;
    $blockid = (int)$blockid;
    if (!empty($blockid)) {
        $qry = "SELECT group_id FROM ${prefix}_groups_blocks WHERE block_id=" . $blockid;
        $result = sql_query($qry);
        while (list($group_id) = sql_fetch_row($result)) {
            $groups[] = $group_id;
        }
    }
    $groups = (empty($groups)) ? $GLOBALS['default_group'] : $groups;
    $groupoptions = getAllAccessLevelSelectOptions($groups);
    $cnt = substr_count($groupoptions, '<option') + 1;
    $out = '<select name="groups[]" size="' . $cnt . '" multiple>' . $groupoptions . '</select>';
    return $out;
}

/**
 */
function getPositionSelect($pos = "")
{
    $out = "<select name=\"position\">\n"
     . "<option value=\"l\"" . (($pos == "l") ? ' selected="selected"' : '') . ">" . _LEFT . "</option>\n"
     . "<option value=\"c\"" . (($pos == "c") ? ' selected="selected"' : '') . ">" . _CENTERUP . "</option>\n"
     . "<option value=\"d\"" . (($pos == "d") ? ' selected="selected"' : '') . ">" . _CENTERDOWN . "</option>\n"
     . "<option value=\"r\"" . (($pos == "r") ? ' selected="selected"' : '') . ">" . _RIGHT . "</option>\n"
     . "</select>\n";
    return $out;
}

/**
 */
function getHeadlineSelect ($url = "")
{
    global $prefix;
    // zur Sicherheit, die entities richtigstellen
    $url = str_replace('&', '&amp;', str_replace('&amp;', '&', $url));
    $res = sql_query("select hid, sitename, headlinesurl from " . $prefix . "_headlines ORDER BY sitename");
    $out = "<input type=\"text\" name=\"url\" size=\"30\" maxlength=\"200\" value=\"" . $url . "\">&nbsp;&nbsp;";
    $out .= "<select name=\"headline\">\n";
    $out .= "<option value=\"0\" selected=\"selected\">" . _CUSTOM . "</option>\n";
    while (list($hid, $htitle, $hurl) = sql_fetch_row($res)) {
        $out .= "<option value=\"" . $hid . "\"" . (($url == $hurl) ? ' selected="selected"' : '') . " >" . $htitle . "</option>\n";
    }
    $out .= "</select>\n&nbsp;[&nbsp;<a href=\"admin.php?op=HeadlinesAdmin\">Setup</a>&nbsp;]<br>\n";
    $out .= "<font class=\"tiny\">" . _SETUPHEADLINES . "</font>\n";
    return $out;
}

/**
 */
function block_editmenue($block, $optitle = "", $menu = 0)
{
    $menu = (empty($menu)) ? 0 : 1;
    $optitle = (empty($optitle)) ? _BLOCKSADMIN : $optitle;
    $active = ($block['active']) ?_DEACTIVATE : _ACTIVATE;

    switch ($menu) {
        case "1":
            $link[] = "<a href=\"admin.php?op=ChangeStatus&amp;bid=" . $block['bid'] . "&amp;menu=1\">" . $active . "</a>";
            $link[] = "<a href=\"admin.php?op=BlocksEdit&amp;bid=" . $block['bid'] . "&amp;menu=1\">" . _EDIT . "</a>";

            if (!mxIsNewsBlockfile($block['blockfile'])) {
                $link[] = "<a href=\"admin.php?op=BlocksDelete&amp;bid=" . $block['bid'] . "&amp;menu=1\">" . _DELETE . "</a>";
            } else {
                $link[] = _DELETE;
            }
            break;

        default:
            $link[] = "<a href=\"admin.php?op=ChangeStatus&amp;bid=" . $block['bid'] . "\">" . $active . "</a>";
            $link[] = "<a href=\"admin.php?op=BlocksEdit&amp;bid=" . $block['bid'] . "\">" . _EDIT . "</a>";

            if (!mxIsNewsBlockfile($block['blockfile'])) {
                $link[] = "<a href=\"admin.php?op=BlocksDelete&amp;bid=" . $block['bid'] . "\">" . _DELETE . "</a>";
            } else {
                $link[] = _DELETE;
            }
            break;
    }

    $link[] = "<a href=\"admin.php?op=BlocksAdmin\">" . _BLOCKSADMIN . "</a>";
    $links = implode(" | ", $link);
    OpenTable();
    echo "<center><font class=\"option\"><b>" . _BLOCKSADMIN . ": " . _FUNCTIONS . "</b></font><br><br>";
    echo "[ " . $links . " ]</center>";
    CloseTable();
    echo "<br>";
}

/**
 */
function block_show($gvs)
{
    global $prefix;
    $bid = (int)$gvs['bid'];
    $result = sql_query("select * from ${prefix}_blocks where bid=" . $bid);
    $block = sql_fetch_array($result);
    include("header.php");
    // GraphicAdmin();
    title(_BLOCKSADMIN);
    block_editmenue($block);
    showpreview($block);
    include("footer.php");
}

/**
 */
function showpreview($block)
{
    // mxDebugFuncVars($block);
    global $prefix;
    if (mxIsNewsBlockfile($block['blockfile'])) {
        $result = sql_query("select * from ${prefix}_stories LIMIT 0,1");
        $GLOBALS['story_blocks'] = sql_fetch_array($result);
        $GLOBALS['name'] = "News";
        @mxGetLangfile("News");
    }
    OpenTable();
    $block = mxGetBlockData($block, 1); // ohne cache
    echo "<p>" . _BLOCKPREVIEW . " &quot;<b>" . $block['title'] . "</b>&quot;:</p><br>\n";
    render_blocks($block);
    CloseTable();
    echo "<br>\n";
}

/**
 */
function fixweight()
{
    repairweigth();
    mxRedirect('admin.php?op=BlocksAdmin', _ADMIN_SETTINGSAVED);
    exit;
}

/**
 */
function repairweigth()
{
    global $prefix;
    $newweight = 0;
    $lastpos = "xyz";
    $qry = "select position,bid,weight
                    from ${prefix}_blocks
                    order by position, weight, bid";
    $result = sql_query($qry);
    while (list($pos, $bid, $weight) = sql_fetch_row($result)) {
        if ($lastpos != $pos) {
            $lastpos = $pos;
            $newweight = 0;
        }
        $newweight++;
        if ($newweight != $weight) {
            $qry = "update ${prefix}_blocks set weight = $newweight where bid=$bid";
            sql_query($qry);
        }
    }
}

/**
 */
function BlockOrder ($gvs)
{
    global $prefix;
    extract($gvs);
    $result = sql_query("update ${prefix}_blocks set weight='$weight' where bid='$bidrep'");
    $result2 = sql_query("update ${prefix}_blocks set weight='$weightrep' where bid='$bidori'");
    mxRedirect('admin.php?op=BlocksAdmin', _ADMIN_SETTINGSAVED);
}

/**
 */
function rssfail()
{
    include("header.php");
    GraphicAdmin();
    title(_BLOCKSADMIN);
    OpenTable();
    echo "<center><b>" . _RSSFAIL . "</b><br><br>" . _RSSTRYAGAIN . "<br><br>" . _GOBACK . "</center>";
    CloseTable();
    include("footer.php");
    die;
}

/**
 */
function ChangeStatus($gvs)
{
    global $prefix;
    $ok = (empty($gvs['ok'])) ? 0 : 1;
    $bid = (int)$gvs['bid'];
    $menu = (empty($gvs['menu'])) ? 0 : 1;
    $result = sql_query("select * from ${prefix}_blocks where bid='$bid'");
    $block = sql_fetch_array($result);
    extract ($block);
    if (($ok) OR ($block['active'] == 1)) {
        $active = (empty($block['active'])) ? 1 : 0;
        $result = sql_query("update ${prefix}_blocks set active='$active' where bid=" . $bid);
        switch ($menu) {
            case "1":
                mxRedirect('admin.php?op=menu', _ADMIN_SETTINGSAVED);
                break;

            default:
                mxRedirect('admin.php?op=BlocksAdmin', _ADMIN_SETTINGSAVED);
                break;
        }
    } else {
        include("header.php");
        GraphicAdmin();
        title(_BLOCKACTIVATION);
        OpenTable();
        echo "<center><br>" . _WANT2ACTIVATE . "<br><br>";
        switch ($menu) {
            case "1":
                echo "[&nbsp;<a href=\"admin.php?op=menu\">" . _NO . "</a> | <a href=\"admin.php?op=ChangeStatus&amp;bid=" . $bid . "&amp;ok=1&amp;menu=1\">" . _YES . "</a>&nbsp;]<br>";
                break;

            default:
                echo "[&nbsp;<a href=\"admin.php?op=BlocksAdmin\">" . _NO . "</a> | <a href=\"admin.php?op=ChangeStatus&amp;bid=" . $bid . "&amp;ok=1\">" . _YES . "</a>&nbsp;]<br>";
                break;
        }
        echo "</center>";
        CloseTable();
        echo "<br>";
        showpreview($block);
        block_editmenue ($block, _BLOCKACTIVATION, $menu);
        include("footer.php");
    }
}

/**
 */
function BlocksDelete($gvs)
{
    global $prefix;
    $ok = (empty($gvs['ok'])) ? 0 : 1;
    $bid = (int)$gvs['bid'];
    $menu = (empty($gvs['menu'])) ? 0 : 1;
    if ($ok) {
        sql_query("DELETE FROM ${prefix}_blocks where bid='$bid'");
        repairweigth();
        switch ($menu) {
            case "1":
                mxRedirect('admin.php?op=menu', _ADMIN_SETTINGSAVED);
                break;

            default:
                mxRedirect('admin.php?op=BlocksAdmin', _ADMIN_SETTINGSAVED);
                break;
        }
    }
    $result = sql_query("select * from ${prefix}_blocks where bid='$bid'");
    $block = sql_fetch_array($result);
    extract ($block);
    include("header.php");
    GraphicAdmin();
    title(_BLOCKSADMIN);
    OpenTableAl();
    echo "<center>" . _ARESUREDELBLOCK . " <i>$title</i>?";
    switch ($menu) {
        case "1":
            echo "<br><br>[&nbsp;<a href=\"admin.php?op=menu\">" . _NO . "</a> | <a href=\"admin.php?op=BlocksDelete&amp;bid=$bid&amp;ok=1&amp;menu=1\">" . _YES . "</a>&nbsp;]</center>";
            break;

        default:
            echo "<br><br>[&nbsp;<a href=\"admin.php?op=BlocksAdmin\">" . _NO . "</a> | <a href=\"admin.php?op=BlocksDelete&amp;bid=$bid&amp;ok=1\">" . _YES . "</a>&nbsp;]</center>";
            break;
    }
    CloseTableAl();
    echo "<br>";
    showpreview($block);
    block_editmenue ($block, _BLOCKACTIVATION, $menu);
    include("footer.php");
}

/**
 */
function HeadlinesAdmin()
{
    global $bgcolor1, $bgcolor2, $bgcolor3, $prefix;
    include ("header.php");
    GraphicAdmin();
    title(_HEADLINESADMIN);
    OpenTable();
    echo "<form action=\"admin.php\" method=\"post\">"
     . "<table border=0 cellspacing=1 cellpadding=2 bgcolor=\"$bgcolor2\">"
     . "<tr valign=\"top\" bgcolor=\"$bgcolor2\"><th>" . _SITENAME . "</th><th>" . _URL . "</th><th>" . _FUNCTIONS . "</th></tr>";
    $result = sql_query("select hid, sitename, headlinesurl from " . $prefix . "_headlines order by sitename");
    while (list($hid, $sitename, $headlinesurl) = sql_fetch_row($result)) {
        $headlinesurl = str_replace('&', '&amp;', str_replace('&amp;', '&', $headlinesurl));
        echo "<tr valign=\"top\" bgcolor=\"$bgcolor1\"><td class=\"content\">" . $sitename . "</td>"
         . "<td class=\"tiny\"><a href=\"$headlinesurl\" target=\"new\">$headlinesurl</a></td>"
         . "<td nowrap class=\"tiny\">[&nbsp;<a href=\"admin.php?op=HeadlinesEdit&amp;hid=$hid\">" . _EDIT . "</a> | <a href=\"admin.php?op=HeadlinesDel&amp;hid=$hid&amp;ok=0\">" . _DELETE . "</a>&nbsp;]</td></tr>";
    }
    echo "</table></form>";
    CloseTable();
    echo "<br>";
    OpenTable();
    echo "<font class=\"option\"><b>" . _ADDHEADLINE . "</b></font><br><br>"
     . "<form action=\"admin.php\" method=\"post\">"
     . "<table border=\"0\" width=\"100%\">"
     . "<tr valign=\"top\"><td>" . _SITENAME . ":</td><td><input type=\"text\" name=\"xsitename\" size=\"31\" maxlength=\"30\"></td></tr>"
     . "<tr valign=\"top\"><td>" . _RSSFILE . ":</td><td><input type=\"text\" name=\"headlinesurl\" size=\"50\" maxlength=\"200\"></td></tr>"
     . "</table>"
     . "<input type=\"hidden\" name=\"op\" value=\"HeadlinesAdd\">"
     . "<input type=\"submit\" value=\"" . _ADD . "\">"
     . "</form>";
    CloseTable();
    include("footer.php");
}

/**
 */
function HeadlinesEdit($gvs)
{
    global $prefix;
    $hid = intval($gvs['hid']);
    $result = sql_query("select sitename, headlinesurl from " . $prefix . "_headlines where hid=" . $hid);
    list($xsitename, $headlinesurl) = sql_fetch_row($result);
    include("header.php");
    GraphicAdmin();
    title(_HEADLINESADMIN);
    OpenTable();
    echo "<p class=\"option\" align=\"center\"><b>" . _EDITHEADLINE . "</b></p>
    <form action=\"admin.php\" method=\"post\">
    <table border=\"0\" width=\"100%\">
    <tr valign='top'><td>" . _SITENAME . ":</td><td><input type=\"text\" name=\"xsitename\" size=\"31\" maxlength=\"30\" value=\"" . mxEntityQuotes($xsitename) . "\"></td></tr>
    <tr valign='top'><td>" . _RSSFILE . ":</td><td><input type=\"text\" name=\"headlinesurl\" size=\"50\" maxlength=\"200\" value=\"" . mxEntityQuotes($headlinesurl) . "\"></td></tr>
    </table>
    <input type=\"hidden\" name=\"hid\" value=\"$hid\">
    <input type=\"hidden\" name=\"op\" value=\"HeadlinesSave\">
    <input type=\"submit\" value=\"" . _SAVECHANGES . "\">
    </form>";
    CloseTable();
    include("footer.php");
}

/**
 */
function HeadlinesSave($pvs)
{
    global $prefix;
    $hid = $pvs['hid'];
    // $xsitename = str_replace(" ", "", $xsitename);
    sql_query("update " . $prefix . "_headlines set sitename='" . mxAddSlashesForSQL($pvs['xsitename']) . "', headlinesurl='" . mxAddSlashesForSQL($pvs['headlinesurl']) . "' where hid='" . $hid . "'");
    mxRedirect('admin.php?op=HeadlinesAdmin', _ADMIN_SETTINGSAVED);
}

/**
 */
function HeadlinesAdd($pvs)
{
    global $prefix;
    // $xsitename = str_replace(" ", "", $xsitename);
    sql_query("INSERT INTO " . $prefix . "_headlines (sitename, headlinesurl) values ('" . mxAddSlashesForSQL($pvs['xsitename']) . "', '" . mxAddSlashesForSQL($pvs['headlinesurl']) . "')");
    mxRedirect('admin.php?op=HeadlinesAdmin', _ADMIN_SETTINGSAVED);
}

/**
 */
function HeadlinesDel($gvs)
{
    global $prefix;
    extract($gvs);
    $ok = (empty($ok)) ? 0 : 1;
    $hid = (int)$hid;
    if ($ok) {
        sql_query("DELETE FROM " . $prefix . "_headlines where hid=" . $hid);
        mxRedirect('admin.php?op=HeadlinesAdmin', _ADMIN_SETTINGSAVED);
    } else {
        include("header.php");
        GraphicAdmin();
        title(_HEADLINESADMIN);
        OpenTable();
        echo "<center><br>";
        echo "<font class=\"option\">";
        echo "<b>" . _SURE2DELHEADLINE . "</b></font><br><br>";
        echo "[&nbsp;<a href=\"admin.php?op=HeadlinesDel&amp;hid=" . $hid . "&amp;ok=1\">" . _YES . "</a> | <a href=\"admin.php?op=HeadlinesAdmin\">" . _NO . "</a>&nbsp;]<br><br>";
        CloseTable();
        include("footer.php");
    }
}

/**
 */
function mxGetBlockfileSelect($blockfile = "")
{
    global $prefix;
    $dbblocks = array();
    $result = sql_query("select blockfile from ${prefix}_blocks where blockfile<>''");
    while (list($bfs) = sql_fetch_row($result)) {
        $dbblocks[] = $bfs;
    }

    $handle = opendir('blocks');
    while (false !== ($block = readdir($handle))) {
        if (preg_match('#^block-(.+)\.php$#', $block, $matches)) {
            $bl = $matches[1];
            $mode = (in_array($block, $dbblocks)) ? 1 : 0;
            $is = ($mode) ? '* ': '';
            if (!mxIsNewsBlockfile($block)) {
                $options[$mode][strtolower($bl)] = ($blockfile == $block) ? '<option value="' . $block . '" selected="selected">' . $is . $bl . '</option>' : '<option value="' . $block . '">' . $is . $bl . '</option>';
            } else {
                // Falls ein neuer News-Block gefunden wurde, diesen automatisch in die Tabelle einfuegen
                if (!$mode) {
                    $caption = str_replace(MX_NEWSBLOCK_PREFIX, '', 'block-' . $bl);
                    $qry = "INSERT INTO `${prefix}_blocks` (`bid`, `bkey`, `title`, `content`, `url`, `position`, `weight`, `active`, `refresh`, `time`, `blanguage`, `blockfile`, `view`) VALUES(NULL, '', '" . $caption . "', NULL, '', 'r', 0, 0, 0, 0, '', '" . $block . "', 0);";
                    sql_query($qry);
                }
            }
        }
    }
    closedir($handle);
    if (empty($blockfile)) {
        $options[0][' '] = '<option value="" selected="selected"></option>';
    }
    $view = "";
    if (isset($options[0])) {
        ksort($options[0]);
        $view .= implode("\n", $options[0]);
    }
    if (isset($options[0]) && isset($options[1])) {
        $view .= "<option value=\"\">____________________________________</option>\n";
    }
    if (isset($options[1])) {
        ksort($options[1]);
        $view .= implode("\n", $options[1]);
    }
    $out = "<select name=\"blockfile\">" . $view . "</select>\n";
    $out .= "<br><span class=\"tiny\">" . _BLOCKINSYSTEM . "</span>";
    // $out .= "&nbsp;&nbsp;<font class=\"tiny\">"._FILEINCLUDE."</font>";
    return $out;
}

/**
 */
/* Was ist zu tun ? */
$op = (isset($_REQUEST['op'])) ? $_REQUEST['op'] : '';

switch ($op) {
    case "BlocksAdmin":
        BlocksAdmin($_GET);
        break;

    case "BlocksAdd":
        Blocksave($_POST);
        break;

    case "BlocksEdit":
        BlocksEdit($_GET);
        break;

    case "BlocksEditSave":
        Blocksave($_POST);
        break;

    case "ChangeStatus":
        ChangeStatus($_GET);
        break;

    case "BlocksDelete":
        BlocksDelete($_GET);
        break;

    case "BlockOrder":
        BlockOrder ($_GET);
        break;

    case "HeadlinesDel":
        HeadlinesDel($_GET);
        break;

    case "HeadlinesAdd":
        HeadlinesAdd($_POST);
        break;

    case "HeadlinesSave":
        HeadlinesSave($_POST);
        break;

    case "HeadlinesAdmin":
        HeadlinesAdmin();
        break;

    case "HeadlinesEdit":
        HeadlinesEdit($_GET);
        break;

    case "fixweight":
        fixweight();
        break;

    case "block_show":
        block_show($_GET);
        break;

    case "BlocksListWeigth":
        BlocksListWeigth($_POST);
        break;
}
