<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.7.2.11 $
 * $Author: siggi $
 * $Date: 2008/02/01 22:41:51 $
 */

defined('mxMainFileLoaded') or die('access denied');

if (!mxGetAdminPref("radminsuper")) {
    mxErrorScreen("Access Denied");
    die();
}

if (!class_exists('Mx_Menu_db')) {
    require_once("admin/modules/mxMenu/includes/mx_menu.db.php");
}

/**
 */
function modules()
{
    global $prefix, $bgcolor1, $bgcolor2;

    $menu_object = new Mx_Menu_db();
    /* modul-items in der menu db abgleichen */
    adjust_modul_items($menu_object);

    $img_activate = mxCreateImage("images/activate.gif", _ACTIVATE);
    $img_deactivate = mxCreateImage("images/deactivate.gif", _DEACTIVATE);
    $img_edit = mxCreateImage("images/edit.gif", _EDIT);
    $img_home = mxCreateImage("images/inhome.gif", _PUTINHOME);
    $img_view = mxCreateImage("images/view.gif", _SHOW);
    $mainmod = mxGetMainModuleName();
    $excludes = array('.', '..', 'CVS', 'index.html');
    $qry = "SELECT title, mid, custom_title, active, view, main_id FROM ${prefix}_modules";
    $result = sql_query($qry);
    while ($mods = sql_fetch_array($result)) {
        if (!@file_exists('modules/' . $mods['title'] . '/') || in_array($mods['title'], $excludes)) {
            sql_query("DELETE FROM ${prefix}_groups_modules WHERE module_id=" . $mods['mid'] . "");
            sql_query("DELETE FROM ${prefix}_modules WHERE mid=" . $mods['mid'] . "");
        } else {
            $dbmodlist[strtolower($mods['title'])] = $mods;
        }
    }
    unset($mods);
    $doublemod = array();
    $handle = opendir('modules');
    while (false !== ($file = readdir($handle))) {
        if (in_array(strtolower($file), $doublemod)) {
            $doublerror[] = _ADMIN_WARNDOUBLEMOD1 . $file . _ADMIN_WARNDOUBLEMOD2 . "<br>";
        }
        $doublemod[] = strtolower($file);
        if (!in_array($file, $excludes) && !isset($dbmodlist[strtolower($file)]) && @file_exists('modules/' . $file . '/index.php')) {
            /* If you copied a new module is the /modules/ directory, it will be added to the database */
            $ctitle = str_replace("_", " ", $file);
            $qry = "INSERT INTO ${prefix}_modules (title,custom_title,active,view) values ('" . $file . "', '" . $ctitle . "', 0, 0)";
            $result = sql_query($qry);
            if ($result) {
                $result1 = sql_query("select title, mid, custom_title, active, view, main_id from ${prefix}_modules WHERE title='" . $file . "'");
                $newmod = sql_fetch_array($result1);
                $dbmodlist[strtolower($newmod['title'])] = $newmod;
            }
        }
    }
    closedir($handle);
    unset($doublemod);
    if (empty($dbmodlist)) {
        mxErrorScreen("no modules installed!");
    }
    ksort($dbmodlist);

    include ("header.php");
    $menu_home = $menu_object->main_module_exists();
    $__alt = "Modules";

    foreach ($dbmodlist as $module) {
        extract($module);
        $act = (empty($active)) ? 1 : 0;
        $change = (empty($active)) ? $img_activate : $img_deactivate;
        $custom_title = (empty($custom_title)) ? str_replace("_", " ", $title) : $custom_title;

        if (!empty($menu_home)) {
            $__alt = ($menu_home['url'] == 'modules.php?name=' . $module['title']) ? "Menu_" . $menu_home['bid'] : "Modules";
        } else {
            $__alt = "Modules";
        }
        $main_id = (empty($main_id)) ? $__alt : $main_id;
        $main_id = ($main_id == "hided") ? "<span class=\"tiny\"><i>" . _COSTUMNAVIBLOCKHID . "</i></span>" : $main_id;
        if ($view == 1) $who_view = _MVGROUPS2;
        elseif ($view == 2) $who_view = _MVADMIN;
        elseif ($view == 3) $who_view = _MVANON;
        else $who_view = _MVALL;

        if (preg_match("/Menu_/i", $main_id)) {
            $tmp_a = explode("_", $main_id);
            if (intval($tmp_a[1]) > 0) {
                $menu_title = $menu_object->get_menu_title_db(intval($tmp_a[1]));
                if (!empty($menu_title)) {
                    $main_id = "<a href='admin.php?op=module_edit&amp;mid=" . $mid . "&amp;menu=1'>Menu (" . $menu_title . ")</a>";
                } else {
                    sql_query ("UPDATE ${prefix}_modules SET main_id = 'hided' WHERE mid = '" . $mid . "'");
                    $main_id = "<span class=\"tiny\"><i>" . _COSTUMNAVIBLOCKHID . "</i></span>";
                }
            }
        }

        if (isset($tmp_a)) {
            $is_menu = '&amp;menu=1';
            unset($tmp_a);
        } else {
            $is_menu = '';
        }

        if ($title != $mainmod) {
            $change = "<a href=\"admin.php?op=module_status&amp;mid=" . $mid . "&amp;active=" . $act . "\">" . $change . "</a>";
            $puthome = "<a href=\"admin.php?op=home_module&amp;mid=" . $mid . "\">" . $img_home . "</a>";
            $clickit = "<a href=\"modules.php?name=" . $title . "\" target=\"_blank\">" . $img_view . "</a>";
            if ($active) {
                $out_active[] = "<tr bgcolor=\"$bgcolor1\"><td>" . $title . "</td><td>" . $custom_title . "</td><td>" . $main_id . "</td><td>" . $who_view . "</td><td align='center'><a href=\"admin.php?op=module_edit&amp;mid=" . $mid . $is_menu . "\">" . $img_edit . "</a> &nbsp;" . $change . " &nbsp;" . $puthome . " &nbsp;" . $clickit . "</td></tr>"; #<td>".$active."</td>
            } else {
                $out_deact[] = "<tr bgcolor=\"$bgcolor1\"><td>" . $title . "</td><td>" . $custom_title . "</td><td>" . $main_id . "</td><td>" . $who_view . "</td><td align='center'><a href=\"admin.php?op=module_edit&amp;mid=" . $mid . $is_menu . "\">" . $img_edit . "</a> &nbsp;" . $change . " &nbsp;" . $puthome . " &nbsp;" . $clickit . "</td></tr>";
            }
        } else {
            $clickit = "<a href=\"index.php\" target=\"_blank\">" . $img_view . "</a>";
            $out_main[] = "<tr bgcolor=\"$bgcolor1\"><td>" . $title . "</td><td><b>" . _HOME . "</b></td><td>" . $main_id . "</td><td>" . _MVALL . "</td><td align='center'><a href=\"admin.php?op=module_edit&amp;mid=" . $mid . $is_menu . "\">" . $img_edit . "</a> &nbsp;" . $clickit . "</td></tr>";
        }
    }
    unset($dbmodlist);
    $headline = "<tr bgcolor=\"$bgcolor2\">
	<th class=\"content\">" . _TITLE . "</th>
	<th class=\"content\">" . _CUSTOMTITLE . "</th>
	<th class=\"content\">" . "Menu / Modul-Block" . "</th>
	<th class=\"content\">" . _VIEW . "</th>
	<th class=\"content\">" . _FUNCTIONS . "</th></tr>";
    GraphicAdmin();
    echo "<a name='additem' id='additem'></a>\n";
    title(_MODULESADMIN);
    if (isset($doublerror)) {
        OpenTableAl();
        echo "<center>" . implode("\n", $doublerror) . "<br><b>" . _ADMIN_WARNDOUBLEMOD3 . "</b></center>";
        CloseTableAl();
        echo "<br>";
    }
    OpenTable();
    echo "<table border=\"0\" width=\"100%\" bgcolor=\"$bgcolor2\" cellpadding=\"0\" cellspacing=\"0\"><tr><td>\n";
    echo "<table border=\"0\" width=\"100%\" bgcolor=\"$bgcolor2\" cellpadding=\"2\" cellspacing=\"1\">\n";
    if (isset($out_active)) {
        echo "<tr bgcolor=\"$bgcolor2\"><td class=\"title\" colspan=5>" . _ACTIVEMODULES . ":</td></tr>\n";
        echo $headline;
        echo implode("\n", $out_active);
    }
    if (isset($out_main)) {
        echo "<tr bgcolor=\"$bgcolor2\"><td class=\"title\" colspan=5>" . _DEFHOMEMODULE . ":</td></tr>\n";
        echo $headline;
        echo implode("\n", $out_main);
    }
    if (isset($out_deact)) {
        echo "<tr bgcolor=\"$bgcolor2\"><td class=\"title\" colspan=5>" . _NOACTIVEMODULES . ":</td></tr>\n";
        echo $headline;
        echo implode("\n", $out_deact);
    }
    echo "</table>\n";
    echo "</td></tr></table>\n";
    echo "<br><div class=\"content\">" . _MODULESACTIVATION . "<br><br>" . _MODULEHOMENOTE . "</div>";
    CloseTable();
    include ("footer.php");
}

/**
 */
function home_module($gvs)
{
    global $prefix;

    $ok = (empty($gvs['ok'])) ? 0 : 1;
    $mid = (int)$gvs['mid'];
    $old_m = mxGetMainModuleName();
    // TODO: das kann doch eigentlich raus, oder?
    /*
    $menu_object = new Mx_Menu_db();
    $hrow = array();
    $hrow = $menu_object->main_module_exists();
    if ($hrow != array()) {
        // $id = $menu_object->get_self($hrow['type']);
        // echo  "<h2>".$hrow['bid']."</h2>";
    }
    */

    $result = sql_query("select title from ${prefix}_modules where mid=" . $mid);
    list($new_m) = sql_fetch_row($result);

    if (empty($ok)) {
        include ("header.php");
        GraphicAdmin();
        title(_HOMECONFIG);
        OpenTable();
        echo "<center><b>" . _DEFHOMEMODULE . "</b><br><br>"
         . _SURETOCHANGEMOD . " <b>" . $old_m . "</b> " . _TO . " <b>" . $new_m . "</b>?<br><br>"
         . "[&nbsp;<a href=\"admin.php?op=modules\">" . _NO . "</a> | <a href=\"admin.php?op=home_module&amp;mid=" . $mid . "&ok=1\">" . _YES . "</a>&nbsp;]</center>";
        CloseTable();
        include("footer.php");
    } else {
        sql_query("DELETE FROM ${prefix}_main");
        sql_query("INSERT INTO ${prefix}_main values ('" . mxAddSlashesForSQL($new_m) . "')");
        sql_query("update ${prefix}_modules set active=1, view=0 where mid=" . $mid);
        header("Location: admin.php?op=modules");
    }
}

/**
 */
function module_status($mid, $active)
{
    global $prefix, $user_prefix;
    /*
    // Begonnen fuer automatische Installation des Moduls
    if ($active) {
        $result = sql_query("select * from ${prefix}_modules WHERE mid=" . intval($mid));
        $row = sql_fetch_assoc($result);
        mxDebugFuncVars($row);
        if (file_exists('modules/' . $row['title'] . '/core/install.tabledef.php')) {
            error_reporting(E_ALL);
            include_once('includes/mx_install.php');
            $tables = setupGetTables();
            mxDebugFuncVars($tables);
            include('modules/' . $row['title'] . '/core/install.tabledef.php');
        }
        exit;
    }
    */

    sql_query("update ${prefix}_modules set active='$active' where mid=" . intval($mid));

    $menu_object = new Mx_Menu_db();
    $id = $menu_object->get_item_id_by_mid_db($mid);
    if (!empty($id)) {
        sql_query("UPDATE ${prefix}_menu SET active='$active' WHERE id=" . intval($id));
    }

    header("Location: admin.php?op=modules");
}

/**
 */
function module_edit($mid)
{
    global $prefix;
    $mid = (int)$mid;
    $main_module = mxGetMainModuleName();
    $result = sql_query("select title, custom_title, active, view, main_id from ${prefix}_modules where mid=" . $mid);
    list($title, $custom_title, $active, $view, $main_id) = sql_fetch_row($result);
    $custom_title = (empty($custom_title)) ? str_replace("_", " ", $title) : $custom_title;
    include ("header.php");
    GraphicAdmin();
    title(_MODULEEDIT);
    OpenTable();
    echo "<fieldset><legend>" . _CHANGEMODNAME . ": " . $title . "</legend>"
     . "<form action=\"admin.php\" method=\"post\">"
     . "<table style=\"margin:auto\" border=\"0\" cellspacing=\"0\" cellpadding=\"3\">"
     . "<tr valign=\"top\"><td>" . _CUSTOMMODNAME . "</td>";
    if ($title == $main_module) {
        echo "<td><b>" . _HOME . "</b><input type=\"hidden\" name=\"custom_title\" value=\"" . mxEntityQuotes($custom_title) . "\"></td></td></tr>";
    } else {
        echo "<td><input type=\"text\" name=\"custom_title\" value=\"" . mxEntityQuotes($custom_title) . "\" size=\"50\" ></td></tr>";
    }
    echo "<tr valign=\"top\"><td>" . _VIEWPRIV . "</td><td>";
    if ($title == $main_module) {
        echo "<b>" . _MVALL . "</b> (" . _DEFHOMEMODULE . ")"
         . "<input type=\"hidden\" name=\"view\" value=\"0\">"
         . "<input type=\"hidden\" name=\"active\" value=\"1\">";
        // ."<input type=\"hidden\" name=\"main_id\" value=\"\">";
    } else {
        echo getViewSelect($view)
         . "</td></tr>"
         . "<tr valign='top'><td><!-- " . _VIEWPRIV . " --></td><td>" . getGroupSelect($mid) . "</td></tr>"
         . "<tr valign=\"top\"><td>" . _ACTIVE . "</td>"
         . "<td>" . getActiveSelect($active) . "</td></tr>"
         . "<tr valign=\"top\"><td>&nbsp;</td>"
         . "<td><input type=\"checkbox\" name=\"putinhome\" value=\"1\">&nbsp; " . _PUTINHOME . "</td></tr>";
    }
    echo "<tr valign=\"top\"><td>" . _COSTUMNAVIBLOCK . "</td>"
     . "<td>" . getModuleBlockSelect($main_id) . "</td></tr>";
    echo "</table><br><br>"
     . "<input type=\"hidden\" name=\"mid\" value=\"" . $mid . "\">"
     . "<input type=\"hidden\" name=\"title\" value=\"" . $title . "\">"
     . "<input type=\"hidden\" name=\"op\" value=\"module_edit_save\">"
     . "<input type=\"submit\" value=\"" . _SAVECHANGES . "\">"
     . "</form></fieldset>"
     . "<br><br><center>" . _GOBACK . "</center>";
    CloseTable();
    include("footer.php");
}

/**
 */
function module_edit_save($pvs)
{
    global $prefix;
    $pvs['mid'] = (int)$pvs['mid'];
    $pvs['putinhome'] = (empty($pvs['putinhome'])) ? 0 : 1;
    $pvs['active'] = ($pvs['putinhome']) ? 1 : (int)$pvs['active'];
    $pvs['view'] = ($pvs['putinhome']) ? 0 : (int)$pvs['view'];
    $pvs['custom_title'] = strip_tags($pvs['custom_title']);
    $pvs['custom_title'] = (empty($pvs['custom_title'])) ? str_replace("_", " ", $pvs['title']) : $pvs['custom_title'];
    $pvs['main_id'] = ($pvs['putinhome']) ? "" : $pvs['main_id'];
    $pvs['main_id'] = ($pvs['main_id'] == "Modules") ? "" : $pvs['main_id'];
    $qry = "update ${prefix}_modules set
            custom_title='" . $pvs['custom_title'] . "',
            view=" . $pvs['view'] . ",
            active=" . $pvs['active'] . ",
            main_id='" . $pvs['main_id'] . "'
            where mid=" . $pvs['mid'];
    $result = sql_query($qry);
    if ($result) {
        // Gruppen aktualisieren
        sql_query("DELETE FROM ${prefix}_groups_modules WHERE module_id=" . $pvs['mid']);
        if ($pvs['view'] == 1 && !$pvs['putinhome']) {
            // Sicherstellen, dass wirklich eine Gruppe selektiert wurde
            if (empty($pvs['groups'])) {
                // keine Gruppe gewaehlt > Standard eintragen
                $pvs['groups'] = array(intval($GLOBALS['default_group']));
            } else if (!is_array($pvs['groups'])) {
                // die Gruppe nicht als Array, sonder ID uebergeben > diese ID als Arraywert deklarieren
                $pvs['groups'] = array(intval($pvs['groups']));
            }
            // immernoch keine Gruppe gewaehlt > Standard eintragen
            if (empty($pvs['groups'][0])) {
                $pvs['groups'] = array(intval($GLOBALS['default_group']));
            }

            foreach ($pvs['groups'] as $groupid) {
                sql_query("INSERT INTO ${prefix}_groups_modules (group_id, module_id) VALUES (" . $groupid . ", " . $pvs['mid'] . ")");
            }
        }
        if ($pvs['putinhome']) {
            $old_m = mxGetMainModuleName();
            if (empty($old_m)) {
                $result = sql_query("INSERT INTO ${prefix}_main values ('" . mxAddSlashesForSQL($pvs['title']) . "')");
            } else {
                $result = sql_query("update ${prefix}_main set main_module='" . mxAddSlashesForSQL($pvs['title']) . "'");
            }
        }
    }
    mxRedirect('admin.php?op=modules', _ADMIN_SETTINGSAVED);
}

/**
 */
function getActiveSelect($active = 1)
{
    $active = (int)$active;
    $out = "<input type=\"radio\" name=\"active\" value=\"1\"" . (($active == 1) ? " checked" : "") . ">" . _YES . " &nbsp;&nbsp;";
    $out .= "<input type=\"radio\" name=\"active\" value=\"0\"" . (($active == 0) ? " checked" : "") . ">" . _NO . "\n";
    return $out;
}

/**
 */
function getViewSelect($view = 0)
{
    $view = (int)$view;
    $out = "<select name=\"view\">"
     . "<option value=\"0\"" . (($view == 0) ? ' selected="selected"' : '') . ">" . _MVALL . "</option>"
     . "<option value=\"1\"" . (($view == 1) ? ' selected="selected"' : '') . ">" . _MVGROUPS . "</option>"
     . "<option value=\"2\"" . (($view == 2) ? ' selected="selected"' : '') . ">" . _MVADMIN . "</option>"
     . "<option value=\"3\"" . (($view == 3) ? ' selected="selected"' : '') . ">" . _MVANON . "</option>"
     . "</select>";
    return $out;
}

/**
 */
function getGroupSelect($modid = 0)
{
    global $prefix;
    if (!empty($modid)) {
        $qry = "SELECT group_id FROM ${prefix}_groups_modules WHERE module_id=" . intval($modid);
        $result = sql_query($qry);
        while (list($group_id) = sql_fetch_row($result)) {
            $groups[] = $group_id;
        }
    }
    $groups = (empty($groups)) ? $GLOBALS['default_group'] : $groups;
    $groupoptions = getAllAccessLevelSelectOptions($groups);
    $cnt = substr_count($groupoptions, '<option') + 1;
    $out = "<select name='groups[]' id='groups' size='" . $cnt . "' multiple>" . $groupoptions . "</select>";
    return $out;
}

/**
 */
function getModuleBlockSelect($main_id = '')
{
    global $prefix;

    /* Sprachdatei auswaehlen */
    if (@file_exists(PMX_ADMIN_DIR . '/modules/mxMenu/language/lang-' . $GLOBALS['currentlang'] . '.php')) {
        include_once(PMX_ADMIN_DIR . '/modules/mxMenu/language/lang-' . $GLOBALS['currentlang'] . '.php');
    } else {
        include_once(PMX_ADMIN_DIR . '/modules/mxMenu/language/lang-german.php');
    }
    $menu_object = new Mx_Menu_db();
    $menu_home = $menu_object->main_module_exists();
    $__alt = ($menu_home != array()) && !empty($main_id) ? "Menu_" . $menu_home['bid'] : "Modules";

    $c = 0;
    $main_id = (empty($main_id)) ? $__alt : $main_id;
    $result = sql_query("SELECT bid, title, blockfile FROM ${prefix}_blocks WHERE blockfile LIKE 'block-modules%.php' OR blockfile='block-Menu.php'");
    while (list($bid, $btitle, $bfs) = sql_fetch_row($result)) {
        if ($bfs == 'block-Menu.php') {
            $dbblocks['block-Menu_' . strval($bid) . '.php'] = $btitle;
            $bid_a[++$c] = $bid;
        } else {
            $dbblocks[$bfs] = $btitle;
        }
    }
    $blocksdir = dir("blocks");
    $menus = $c;

    while ($block = $blocksdir->read()) {
        if (strtolower(substr($block, 0, 13)) == "block-modules")
            $block_a[] = $block;
    }
    for($i = 1;$i <= $c;$i++) {
        $block_a[] = 'block-Menu_' . strval($bid_a[$i]) . '.php';
    }
    foreach($block_a as $block) {
        if (strtolower(substr($block, 0, 13)) == "block-modules" || strtolower(substr($block, 0 , 10)) == "block-menu") {
            $mode = (isset($dbblocks[$block])) ? 1 : 0;
            $is = ($mode) ? " (" . $dbblocks[$block] . ")": "  *";
            $bl = str_replace("block-", "", $block);
            $bl = str_replace(".php", "", $bl);
            $sel = ($main_id == $bl) ? " selected" : "";
            $options[$mode][strtolower($bl)] = "<option value=\"" . $bl . "\" " . $sel . ">" . $bl . $is . "</option>";
        }
    }
    closedir($blocksdir->handle);
    // if (empty($main_id)) $options[] = "<option value=\"\" selected></option>";
    $view = "";
    $sel = ($main_id == "hided") ? " selected" : "";
    $options[1]["aaaaaa"] = "<option value=\"hided\" " . $sel . ">" . _COSTUMNAVIBLOCKHID . "</option>";
    if (isset($options[1])) {
        ksort($options[1]);
        $view .= implode("\n", $options[1]);
    }
    if (isset($options[0])) {
        ksort($options[0]);
        $view .= implode("\n", $options[0]);
    }
    $out = "\n<select name=\"main_id\">\n" . $view . "</select>\n";
    $out .= " <br>\n<span class=\"tiny\">" . _COSTUMNAVIEXAMPLE . "</span>\n";
    if ($menus > 0 && isset($_GET['menu'])) {
        $out .= "<br /><span style='font-size:80%; color:red;'>" . _MX_MENU_MOD_ILLEGALMOVE . "</span>\n";
    }
    return $out;
}

/* mxMenu function to handle links from the modules */
function adjust_modul_items($menu_object)
{
    global $prefix;

    $modules = array();
    $item = array();
    $sql = "SELECT * FROM ${prefix}_modules WHERE main_id LIKE 'Menu_%' ;";
    $result = sql_query($sql);
    while ($row = sql_fetch_assoc($result)) {
        $modules[] = $row;
    }
    if (count($modules > 0)) {
        foreach($modules as $module) {
            $tmp_a = explode("_", $module['main_id']);
            $item['bid'] = intval($tmp_a[1]);
            $item['pid'] = 0;
            $item['title'] = $module['custom_title'];
            $item['description'] = '';
            $item['url'] = 'modules.php?name=' . $module['title'];
            $item['weight'] = 0;
            $item['active'] = $module['active'];
            $item['type'] = "2|" . $module['mid'] . "|0";
            $item['id'] = $menu_object->get_item_id_by_mid_db($module['mid']);

            if (!in_array($module['mid'], $menu_object->get_module_ids_from_menus_db())) {
                $menu_object->add_item_db($item); # zum menu zugeordnete modullinks hinzufuegen, falls nicht vorhanden
            } else {
                // auf Aenderungen der modullinks pruefen und ggf. updaten
                sql_query("UPDATE ${prefix}_menu SET bid = '" . $item['bid'] . "' WHERE pid = '" . $item['id'] . "'");
                sql_query("UPDATE ${prefix}_menu SET bid = '" . $item['bid'] . "',
                    title = '" . $item['title'] . "',
                    active = '" . $item['active'] . "'
                    WHERE id = '" . $item['id'] . "' ;");
            }
            $item = array();
            unset($tmp_a);
        }
    }
    // arrays aus den mid's beider tabellen erzeugen...
    $menu_mids = array();
    $module_mids = array();
    $sql = "SELECT type FROM ${prefix}_menu";
    $result = sql_query($sql);
    while ($row = sql_fetch_array($result)) {
        if ($menu_object->get_member($row['type']) == 2) {
            $menu_mids[] = $menu_object->get_self($row['type']);
        }
    }
    $sql = "SELECT mid, main_id FROM ${prefix}_modules";
    $result = sql_query($sql);
    while ($row = sql_fetch_array($result)) {
        // if($row['main_id'] == 'hided'){
        if (substr($row['main_id'], 0, 4) != 'Menu') {
            $module_mids[] = $row['mid']; # nur module ins array, die nicht schon in einem menu stehen...
        }
    }

    $todelete = array_intersect($menu_mids, $module_mids); # ...schnittmenge der zu loeschenden items ermitteln...
    if (count($todelete) > 0)
        foreach ($todelete as $mid) {
        $id = $menu_object->get_item_id_by_mid_db($mid);
        $menu_object->delete_item_db($id); # ...und item(s) aus menu db loeschen wenn status hided
    }
}

/**
 */
switch ($_REQUEST['op']) {
    case "modules":
        modules();
        break;

    case "module_status":
        module_status($mid, $active);
        break;

    case "module_edit":
        module_edit($mid);
        break;

    case "module_edit_save":
        module_edit_save($_POST);
        break;

    case "home_module":
        home_module($_GET);
        break;
}

?>