<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.1.2.6 $
 * $Author: siggi $
 * $Date: 2008/02/01 22:47:46 $
 *
 * Menumanager for pragmaMx, written by Siggi Braunert
 * http://www.sb-websoft.com
 **/

defined('mxMainFileLoaded') or die('access denied');

require_once(dirname(__FILE__) . '/mx_menu.tables.php');

/* Menu item types */
define('MX_CUSTOM_ITEM', 1);
define('MX_MODULE_ITEM', 2);
define('MX_PAGE_ITEM', 3);
define('MX_STORY_ITEM', 4);

define('MX_MODULES_ALL', 1);
define('MX_MODULES_IN', 2);
define('MX_MODULES_OUT', 3);

define('MX_LIST_EXPAND_YES', 1);
define('MX_LIST_EXPAND_NO', 0);
/* @end */

class Mx_Menu_db {
    var $table = array();
    var $tree = array();
    var $title = "";

    function Mx_Menu_db()
    {
        global $menuT;

        $this->table = $menuT;
        $this->prefix = $GLOBALS['prefix'];
    }

    function is_installed_db()
    {
        $result = sql_query("SELECT id FROM " . $this->prefix . "_menu");
        if ($result == true)
            return 1;
        else
            return 0;
    }

    function install_db()
    {
        $sql = "CREATE TABLE " . $this->prefix . "_menu (";
        foreach($this->table['item'] as $key => $attr) {
            $sql .= "$key $attr, ";
        }
        $sql .= "PRIMARY KEY (id));";
        sql_query($sql);

        $sql = "CREATE TABLE " . $this->prefix . "_menu_var (";
        foreach($this->table['var'] as $key => $attr) {
            $sql .= "$key $attr, ";
        }
        $sql .= "PRIMARY KEY (id));";
        sql_query($sql);

        // variable fuer das aktivieren/deaktivieren der dynamischen Aufklappfunktion in der Menueliste
        $this->set_var_db('mnu_list_exp', MX_LIST_EXPAND_YES);
    }

    function deinstall_db()
    {
        sql_query("UPDATE " . $this->prefix . "_modules SET main_id = 'hided' WHERE main_id LIKE 'Menu_%' ;");
        $result = sql_query("DROP TABLE " . $this->prefix . "_menu;"); // loescht menue-tabelle mit allen items
        $result1 = sql_query("DROP TABLE " . $this->prefix . "_menu_var;"); //loescht alle menue-variablen
        $result2 = sql_query("DELETE FROM " . $this->prefix . "_blocks WHERE blockfile='block-Menu.php' ;");
        if ($result == true && $result1 == true && $result2 == true) {
            return 1;
        }
        return 0;
    }

    function get_menu_title_db($id)
    {
        $title = "";
        $result = sql_query("SELECT bid,title FROM " . $this->prefix . "_blocks WHERE bid='" . $id . "';");
        list($id, $title) = sql_fetch_row($result);
        return $title;
    }

    /* ------ Momentan nicht in Gebrauch --------------
  function max_item_id()
  {
   $result = sql_query("SELECT MAX(id) FROM ".$this->prefix."_menu ;");
   $row = sql_fetch_row($result);
   return intval($row[0]);
  }

  function import_pages($cat = "") # die Links aus dem content-Modul holen
  {
   $content = array();
   $sql = "SELECT pid, cid, title, active FROM ".$this->prefix."_pages ORDER BY title ASC ;";
   $result = sql_query($sql);
   while ($row = sql_fetch_assoc($result))
   {
    $content[]  = $row;
   }
   return $content;
  }
  -------------------------------------------------------------------    */

    function read_menus_db()
    {
        $content = array();
        $sql = "SELECT * FROM " . $this->prefix . "_blocks WHERE blockfile='block-Menu.php' ORDER BY title ASC ;";
        $result = sql_query($sql);
        while ($row = sql_fetch_assoc($result)) {
            $content[] = $row;
        }
        return $content;
    }

    /*
  function setTitles_db($arr)
  {
   if(count($arr) > 0)
   for($i=0;$i<count($arr);$i++)
   {
    $sql = "UPDATE ".$this->prefix."_menu_title SET name = '".$arr[$i]['name']."', active = '".$arr[$i]['active']."' WHERE id = '".$arr[$i]['id']."' ;";
    sql_query($sql);
   }
  }
  */

    function add_menu_db($title)
    {
        $result = sql_query("SELECT bid, title, blockfile FROM " . $this->prefix . "_blocks WHERE title='" . $title . "'");
        list($_id, $_title, $blockfile) = sql_fetch_row($result);
        if ($_title == $title && $blockfile == "block-Menu.php") {
            return -1;
        } else {
            sql_query("INSERT INTO " . $this->prefix . "_blocks (bid, bkey, title, content, url, position, weight, active, refresh, time, blanguage, blockfile, view)
    		                                 VALUES (NULL, '', '" . $title . "', '', '', 'l', '1', '0', '0', '0', '', 'block-Menu.php', '0'); ");
            return(sql_affected_rows());
        }
    }

    function update_menu_db($bid, $title)
    {
        $result = sql_query("SELECT bid, title, blockfile FROM " . $this->prefix . "_blocks WHERE title='" . $title . "'");
        list($_bid, $_title, $blockfile) = sql_fetch_row($result);
        if ($_title == $title && $blockfile == "block-Menu.php") {
            return -1;
        } else {
            sql_query("UPDATE " . $this->prefix . "_blocks SET title = '" . $title . "' WHERE bid='" . $bid . "' ;");
            return(sql_affected_rows());
        }
    }

    function change_menu_status_db($bid)
    {
        $result = sql_query("SELECT bid, title, active from " . $this->prefix . "_blocks WHERE bid='" . $bid . "'");
        $row = sql_fetch_array($result);
        $active = ($row['active'] == 1) ? 0 : 1;
        sql_query("UPDATE " . $this->prefix . "_blocks SET active='" . $active . "' WHERE bid='" . $bid . "'");
        $this->title = $row['title'];
        return $active;
    }

    function delete_menu_db($id)
    {
        $result = sql_query("SELECT bid, blockfile FROM " . $this->prefix . "_blocks WHERE bid='" . $id . "' ;");
        list($_id, $blockfile) = sql_fetch_row($result);
        if ($blockfile == "block-Menu.php") {
            sql_query("DELETE FROM " . $this->prefix . "_blocks WHERE bid = '" . $id . "';");
        }
        return(sql_affected_rows());
    }

    function get_bids_db($table = "menu")
    {
        $bids = array();
        $where = ($table == "blocks") ? "WHERE blockfile='block-Menu.php'" : "";
        $sql = "SELECT bid FROM " . $this->prefix . "_" . $table . " " . $where . " ;";
        $result = sql_query($sql);
        while ($row = sql_fetch_array($result)) {
            $bids[] = $row['bid'];
        }
        return $bids;
    }

    function get_item_title_db($id)
    {
        $title = "";
        $result = sql_query("SELECT id, title FROM " . $this->prefix . "_menu WHERE id='" . $id . "';");
        list($id, $title) = sql_fetch_row($result);
        return $title;
    }

    function get_item_db($id, $by = "")
    {
        $row = array();
        if (empty($by)) {
            $by = "id";
        }
        $result = sql_query("SELECT * FROM " . $this->prefix . "_menu WHERE $by='" . $id . "';");
        $row = sql_fetch_assoc($result);
        return $row;
    }

    function read_items_db($bid = "")
    {
        $content = array();
        $where = (empty($bid) ? "" : "WHERE bid='" . $bid . "' ");
        $sql = "SELECT * FROM " . $this->prefix . "_menu $where ORDER BY weight,title ASC ;";
        $result = sql_query($sql);
        while ($row = sql_fetch_assoc($result)) {
            $content[] = $row;
        }
        return $content;
    }

    function add_item_db($row)
    {
        $result = sql_query("SELECT id, bid, pid, title FROM " . $this->prefix . "_menu WHERE title='" . $row['title'] . "'");
        list($id, $bid, $pid, $title) = sql_fetch_row($result);
        if ($title == $row['title']) {
            return -1;
        }
        sql_query("INSERT INTO " . $this->prefix . "_menu (id, bid, pid, title, description, url, weight, active, type)
    		                                 VALUES (NULL, '" . $row['bid'] . "','" . $row['pid'] . "', '" . $row['title'] . "', '" . $row['description'] . "', '" . $row['url'] . "', '" . $row['weight'] . "', '" . $row['active'] . "', '" . $row['type'] . "'); ");

        if ($this->get_member($row['type']) == MX_CUSTOM_ITEM) {
            $type = "1|" . sql_insert_id() . "|" . $this->get_expanded($row['type']);
            sql_query("UPDATE " . $this->prefix . "_menu SET type = '" . $type . "' WHERE id = '" . sql_insert_id() . "';");
        }

        if ($this->get_member($row['type']) == MX_MODULE_ITEM) {
            $type = "2|" . $this->get_self($row['type']) . "|" . $this->get_expanded($row['type']);
            sql_query("UPDATE " . $this->prefix . "_menu SET type = '" . $type . "' WHERE id = '" . sql_insert_id() . "';");

            if (isset($row['self'])) {
                sql_query("UPDATE " . $this->prefix . "_modules SET custom_title = '" . $row['title'] . "',
                  main_id = 'Menu_" . $row['bid'] . "' WHERE mid = '" . $row['self'] . "' ;");
            }
        }

        return(sql_affected_rows());
    }

    function update_item_db($row)
    {
        $allitems = $this->read_items_db();
        foreach($allitems as $item) {
            if ($item['title'] == $row['title'] && $item['id'] != $row['id']) {
                return -1;
            }
            if ($item['bid'] == $row['bid']) {
                // falls item in anderen Block verschoben wird alle parent items mitnehmen, da sonst die parents
                // auf einen main item mit anderer Blockzugehoerigkeit verweisen wuerden
                sql_query("UPDATE " . $this->prefix . "_menu SET bid = '" . $row['bid'] . "' WHERE pid = '" . $item['id'] . "' ;");
                if ($row['member'] == MX_MODULE_ITEM) {
                    sql_query("UPDATE " . $this->prefix . "_modules SET custom_title = '" . $row['title'] . "',
                                                      main_id = 'Menu_" . $row['bid'] . "' WHERE mid = '" . $row['self'] . "' ;");
                }
            }
        }

        $row['type'] = $row['member'] . "|" . $row['self'] . "|" . $row['expanded'];

        sql_query("UPDATE " . $this->prefix . "_menu SET bid = '" . $row['bid'] . "',
   		                                pid = '" . $row['pid'] . "',
   		                                title = '" . $row['title'] . "',
  	                                    description = '" . $row['description'] . "',
  	                                    url = '" . $row['url'] . "',
  	                                    weight = '" . $row['weight'] . "',
  	                     		        active = '" . $row['active'] . "',
  	                     		        type = '" . $row['type'] . "' WHERE id = '" . $row['id'] . "' ;");
        return(sql_affected_rows());
    }

    /* ---------------- functions to handle links from the modules ----|begin|----------------- */

    function read_modules_db($mode = MX_MODULES_ALL)
    {
        switch ($mode) {
            case MX_MODULES_IN : $where = "WHERE main_id LIKE 'Menu_%'";
                break;
            case MX_MODULES_OUT : $where = "WHERE main_id NOT LIKE 'Menu_%'";
                break;
            default : $where = '';
        }
        $content = array();
        $sql = "SELECT * FROM " . $this->prefix . "_modules " . $where . " ORDER BY custom_title ASC ;";
        $result = sql_query($sql);
        while ($row = sql_fetch_assoc($result)) {
            $content[] = $row;
        }
        return $content;
    }

    function get_module_db($mid, $by = "")
    {
        $row = array();
        if (empty($by)) {
            $by = "mid";
        }
        $result = sql_query("SELECT * FROM " . $this->prefix . "_modules WHERE $by='" . $mid . "';");
        $row = sql_fetch_assoc($result);
        return $row;
    }

    function get_module_ids_from_menus_db()
    {
        $mids = array();
        $sql = "SELECT type FROM " . $this->prefix . "_menu ;";
        $result = sql_query($sql);
        while ($row = sql_fetch_array($result)) {
            if ($this->get_member($row['type']) == MX_MODULE_ITEM) {
                $mid = $this->get_self($row['type']);
                $mids[] = $mid;
            }
        }
        return $mids;
    }

    function get_item_id_by_mid_db($mid)
    {
        $ret = null;
        $sql = "SELECT id FROM " . $this->prefix . "_menu WHERE type LIKE '" . MX_MODULE_ITEM . "|" . $mid . "|%' ;";
        $result = sql_query($sql);
        if ($result == true) {
            $row = sql_fetch_object($result);
            if (isset($row->id)) {
                $ret = intval($row->id);
            }
        }
        return $ret;
    }

    function main_module_exists()
    {
        $home = mxGetMainModuleName();
        $result = sql_query("SELECT * FROM " . $this->prefix . "_menu WHERE url = 'modules.php?name=" . $home . "' ;");
        $row = sql_fetch_array($result);
        if ($result == true) {
            return $row;
        } else return array();
    }

    /*
  function get_main_module_db()
  {
   $result = sql_query("SELECT main_module FROM ".$this->prefix."_main ;");
   $row = sql_fetch_object($result);
   return $row->main_module;
  }


  function get_module_title_db($mid)
  {
   $result = sql_query("SELECT title FROM ".$this->prefix."_main WHERE mid = '".$mid."' ;");
   $row = sql_fetch_object($result);
   return $row->title;
  }
  */
    /* ---------------- functions to handle links from the modules ----|end|----------------- */

    function enable_item_db($id)
    {
        $row = $this->get_item_db($id);
        if ($this->get_member($row['type']) == MX_MODULE_ITEM) {
            $mid = $this->get_self($row['type']);
            sql_query("UPDATE " . $this->prefix . "_modules SET active = 1 WHERE mid='" . $mid . "' ;");
        }
        sql_query("UPDATE " . $this->prefix . "_menu SET active = 1 WHERE id='" . $id . "' ;");
        return(sql_affected_rows());
    }

    function disable_item_db($id)
    {
        $row = $this->get_item_db($id);
        if ($this->get_member($row['type']) == MX_MODULE_ITEM) {
            $mid = $this->get_self($row['type']);
            sql_query("UPDATE " . $this->prefix . "_modules SET active = 0 WHERE mid='" . $mid . "' ;");
        }
        sql_query("UPDATE " . $this->prefix . "_menu SET active = 0 WHERE id='" . $id . "' ;");
        return(sql_affected_rows());
    }

    function delete_item_db($id, $by = "id")
    {
        $row = $this->get_item_db($id);
        if ($this->get_member($row['type']) == MX_MODULE_ITEM) {
            $mid = $this->get_self($row['type']);

            sql_query("UPDATE " . $this->prefix . "_modules SET main_id = 'hided' WHERE mid='" . $mid . "' AND main_id LIKE 'Menu_%' ;");
        }
        // first reset parent items to Zero and deactivate them
        $result = sql_query("UPDATE " . $this->prefix . "_menu SET pid = 0, active = 0 WHERE pid = '" . $id . "';");
        // then delete item
        sql_query("DELETE FROM " . $this->prefix . "_menu WHERE $by = '" . $id . "';");

        return(sql_affected_rows());
    }

    function delete_abandoned_items_db()
    {
        // sucht alle items aus db menu nach bid's von einem in der BlockAdmin schon geloeschten Block
        // vergleicht sie mit den Eintraegen in den db blocks
        // und loescht diese gegebenenfalls auch aus der menu-tabelle
        $menu_bids = $this->get_bids_db('menu');
        $block_bids = $this->get_bids_db('blocks');
        $todelete = array_diff($menu_bids, $block_bids);
        if (count($todelete) > 0)
            foreach ($todelete as $id) {
            $this->delete_item_db($id, "bid");
        }
    }
    // treelist adds
    function read_items_4block_db($bid = '', $who = 0, $level = 0)
    {
        $and = (empty($bid) ? "" : "AND bid='" . $bid . "' ");
        if (!isset($tmp)) {
            $tmp = array();
        }
        $sql = "SELECT * FROM " . $this->prefix . "_menu WHERE pid='" . $who . "' " . $and . " ORDER BY weight,title ASC ;";
        $result = sql_query($sql);
        while ($parent = sql_fetch_array($result)) {
            if ($parent['active'] == 1) {
                $tmp['id'] = $parent['id'];
                $tmp['pid'] = $parent['pid'];
                $tmp['title'] = $parent['title'];
                $tmp['url'] = $parent['url'];
                $tmp['description'] = $parent['description'];

                $tmp['expanded'] = $this->get_expanded($parent['type']);
                $tmp['member'] = $this->get_member($parent['type']);
                $tmp['self'] = $this->get_self($parent['type']);

                $tmp['level'] = $level;
                $level++; # 1 level rauf
                $this->tree[] = $tmp;
                $this->read_items_4block_db($bid, $parent['id'], $level--); # funktion rekursiv aufrufen + level wieder 1 runter
            }
        }
        unset($tmp);
    }

    function read_items_4select_db($id , $bid = '', $who = 0, $ebene = '', &$arr)
    {
        $and = (empty($bid) ? "" : "AND bid='" . $bid . "' ");
        if (!isset($tmp)) {
            $tmp = array();
        }
        $sql = "SELECT * FROM " . $this->prefix . "_menu WHERE pid='" . $who . "' " . $and . " ORDER BY weight, title ASC ;";
        $result = sql_query ($sql);
        while ($parent = sql_fetch_array($result)) {
            $tmp['id'] = $parent['id'];
            $tmp['pid'] = $parent['pid'];
            $tmp['title'] = $ebene . " " . $parent['title'];
            if (!empty($id)) {
                if ($tmp['pid'] == $id) continue; 
                // falls gewaehlter Item Subitems hat, weiter, weil Subitems nicht als uebergeordnete menues fuer Items erscheinen koennen
            }
            $arr[] = $tmp;
            $this->read_items_4select_db($id, $bid, $parent['id'], $ebene . chr(187), $arr);
        }
        unset($tmp);
    }

    function read_items_4showall_db($bid = '', $who = 0, $ebene = '', &$arrall)
    {
        $and = (empty($bid) ? "" : "AND bid='" . $bid . "' ");
        if (!isset($tmp)) {
            $tmp = array();
        }
        $sql = "SELECT * FROM " . $this->prefix . "_menu WHERE pid='" . $who . "' " . $and . " ORDER BY weight, title ASC ;";
        // echo $sql;
        $result = sql_query ($sql);
        while ($parent = sql_fetch_array($result)) {
            $tmp['id'] = $parent['id'];
            $tmp['pid'] = $parent['pid'];
            if ($who == 0) {
                $parent['title'] = '<strong>' . $parent['title'] . '</strong>';
            }
            $tmp['title'] = $ebene . " " . $parent['title'];
            $tmp['url'] = $parent['url'];
            $tmp['description'] = $parent['description'];
            $tmp['weight'] = $parent['weight'];
            $tmp['active'] = $parent['active'];

            $tmp['type'] = $parent['type'];

            $arrall[] = $tmp;
            $this->read_items_4showall_db($bid, $parent['id'], $ebene . "-", $arrall);
        }
        unset($tmp);
    }

    function type2arr($string)
    {
        $ret_arr = array();
        $tmp_arr = explode("|", $string);
        if (!empty($string)) {
            $ret_arr = array('member' => trim($tmp_arr[0]), 'self' => trim($tmp_arr[1]), 'expanded' => trim($tmp_arr[2]));
        }
        unset($tmp_arr);
        return $ret_arr;
    }

    function set_type($array)
    {
        return implode("|", $array);
    }

    function get_member($t)
    {
        $type = $this->type2arr($t);
        return ($type == array() ? "" : $type['member']);
    }

    function get_self($t)
    {
        $type = $this->type2arr($t);
        return ($type == array() ? "" : $type['self']);
        // return $type['self'];
    }

    function get_expanded($t)
    {
        $type = $this->type2arr($t);
        return ($type == array() ? "" : $type['expanded']);
        // return $type['expanded'];
    }
    // ----------------- functions to have variables for the settings ---|begin|---------------
    function set_var_db($_name, $_value)
    {
        $result = sql_query("SELECT * FROM " . $this->prefix . "_menu_var WHERE name='" . $_name . "'");
        list($id, $name, $value) = sql_fetch_row($result);
        if ($name == $_name) {
            sql_query("UPDATE " . $this->prefix . "_menu_var SET value = '" . $_value . "' WHERE id = " . $id . ";");
        } elseif (!empty($_name)) {
            sql_query("INSERT INTO " . $this->prefix . "_menu_var (id, name, value) VALUES ('', '" . $_name . "', '" . $_value . "'); ");
        }
    }

    function get_var_db($name)
    {
        $sql = "SELECT * FROM " . $this->prefix . "_menu_var WHERE name='" . $name . "'";
        $result = sql_query($sql);
        list($id, $name, $value) = sql_fetch_row($result);
        if ($id) {
            return $value;
        } else return null;
    }

    function del_var_db($name)
    {
        if ($name == "*") {
            $sql = "SELECT COUNT(*) as number FROM " . $this->prefix . "_menu_var";
            $result = $this->sql_query($sql);
            $row = sql_fetch_assoc($result);
            if ($row['number']) {
                sql_query("TRUNCATE TABLE " . $this->prefix . "_menu_var");
            }
            return;
        }

        $sql = "SELECT * FROM " . $this->prefix . "_menu_var WHERE name='" . $name . "'";
        $result = sql_query($sql);
        list($id, $name, $value) = sql_fetch_row($result);
        if ($id) {
            sql_query("DELETE FROM " . $this->prefix . "_menu_var WHERE id = " . $id . ";");
        }
    }
    // ----------------- functions to have variables for the settings ---|end|-----------------
} #endofclass

?>