<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.1.2.5 $
 * $Author: tora60 $
 * $Date: 2008/02/03 12:48:28 $
 */

defined('mxMainFileLoaded') or die('access denied');

if (!mxGetAdminPref('radminsuper')) {
    mxErrorScreen('Access Denied');
    die();
}

/* Anzahl der geloeschten Benutzer pro Seite */
$DeletedUserPerPage = 15;

/* Maximale Seiten, die angezeigt / erzeugt werden sollen */
$DeletedUserMaxPage = 50;

/* Sprachdatei auswaehlen */
if (@file_exists('admin/language/reactivateuser/lang-' . $currentlang . '.php')) {
    include_once('admin/language/reactivateuser/lang-' . $currentlang . '.php');
} else {
    include_once('admin/language/reactivateuser/lang-german.php');
}

/**
 * Wandelt ein Datum vom englischen ins deutsche Format um
 *
 * @param  $UserRegdate
 * @access public
 * @return
 */
function ConvertUserRegdate($UserRegdate)
{
    $UserRegdate = date("d.m.Y", strtotime(substr($UserRegdate, 4, 2) . " " . substr($UserRegdate, 0, 3) . " " . substr($UserRegdate, 8, 4)));
    return $UserRegdate;
}

/**
 * Liste der geloeschten User erstellen
 *
 * @param  $page
 * @access public
 * @return
 */
function GetAllDeletedUsers($page)
{
    global $user_prefix, $DeletedUserPerPage, $DeletedUserMaxPage, $bgcolor1, $bgcolor2, $textcolor1;

    $UserFound = '';
    $min = $DeletedUserPerPage * ($page - 1);
    $max = $DeletedUserPerPage;
    $count = "SELECT COUNT(uid) AS TOTAL FROM " . $user_prefix . "_users ";
    $select = "SELECT uid, uname FROM " . $user_prefix . "_users ";
    $where = "WHERE uname <> 'Anonymous' AND user_stat=-1 ";
    $sort = "ORDER BY uname ASC ";
    $limit = "LIMIT " . $min . ", " . $max; //
    $count_result = sql_query($count . $where);
    list($num_rows_per_order) = sql_fetch_row($count_result);
    $result = sql_query($select . $where . $sort . $limit);
    $a = 0;
    $num_users = sql_num_rows($result);
    if ($num_rows_per_order > 0) {
        while ($DeletedUser = sql_fetch_array($result)) {
            $dcolor = ($a == 0 ? $bgcolor2 : $bgcolor1);
            $UserFound .= '<tr bgcolor="' . $dcolor . '"><td>' . $DeletedUser[1] . '</td><td align="center" width="20"><a href="admin.php?op=ReactivateEdit&amp;uid=' . $DeletedUser[0] . '"><img src="images/edit.gif" width="15" height="18" border="0" alt="' . _REACTIVATEEDIT . '" title="' . _REACTIVATEEDIT . '"></a></td></tr>';
            $a = ($dcolor == $bgcolor2 ? 1 : 0);
        }
        $UserFound .= '<tr><td colspan="2" align="right">'
         . '<br><br>'
         . '<table width="100%" cellspacing="0" cellpadding="0" border=0><tr>';
        if ($num_rows_per_order > $DeletedUserPerPage) {
            $total_pages = ceil($num_rows_per_order / $DeletedUserPerPage);
            $prev_page = $page - 1;
            if ($prev_page > 0) {
                $UserFound .= '<td align="left" width="15%"><a href="admin.php?op=ReactivateUser&amp;page=' . $prev_page . '">'
                 . mxCreateImage('images/back.gif', _REACTIVATEPREVIOUSPAGE . ' (' . $prev_page . ')')
                 . '</a></td>';
            } else {
                $UserFound .= '<td width="15%">&nbsp;</td>';
            }
            $UserFound .= '<td align="center" width="70%">'
             . '<font class="tiny">' . $num_rows_per_order . ' ' . _REACTIVATEUSERSFOUND . '<br>(' . $total_pages . ' ' . _REACTIVATEPAGES . ', ' . $num_users . ' ' . _REACTIVATEUSERSSHOWN . ')</font>'
             . '</td>';
            $next_page = $page + 1;
            if ($next_page <= $total_pages) {
                $UserFound .= '<td align="right" width="15%"><a href="admin.php?op=ReactivateUser&amp;page=' . $next_page . '">'
                 . mxCreateImage('images/next.gif', _REACTIVATENEXTPAGE . ' (' . $next_page . ')')
                 . '</a></td>';
            } else {
                $UserFound .= '<td width="15%">&nbsp;</td></tr>';
            }
            $UserFound .= '<tr><td colspan="3" align="center">'
             . ' <font class="tiny">[ </font>';
            for($n = 1; $n < $total_pages; $n++) {
                if ($n == $page) {
                    $UserFound .= '<font class="tiny"><b>' . $n . '</b></font>';
                } else {
                    $UserFound .= '<a href="admin.php?op=ReactivateUser&amp;page=' . $n . '">'
                     . '<font class="tiny">' . $n . '</font></a>';
                }
                if ($n >= $DeletedUserMaxPage) {
                    $break = true;
                    break;
                } else {
                    $UserFound .= '<font class="tiny"> | </font>';
                }
            }
            if (!isset($break)) {
                if ($n == $page) {
                    $UserFound .= '<font class="tiny"><b>' . $n . '</b></font>';
                } else {
                    $UserFound .= '<a href="admin.php?op=ReactivateUser&amp;page=' . $total_pages . '">'
                     . '<font class="tiny">' . $n . '</font></a>';
                }
            }
            $UserFound .= ' <font class="tiny">]</font> '
             . '</td></tr>';
        } else {
            $UserFound .= '<td align="center">'
             . '<font class="tiny">' . $num_rows_per_order . ' ' . _REACTIVATEUSERSFOUND . '</font>'
             . '</td></tr>';
        }
        $UserFound .= '</table>'
         . '</td></tr>';
    } else {
        $UserFound .= '<tr><td height="50" bgcolor="' . $bgcolor2 . '" colspan="2" align="center">'
         . '<b><font color="' . $textcolor1 . '">' . _REACTIVATENOUSERFOUND . '</font></b>'
         . '</td></tr>';
    }
    return $UserFound;
}

/**
 * Daten des zu reaktivierenden Users aus der DB auslesen
 *
 * @param  $uid
 * @access public
 * @return
 */
function GetDeletedUser($uid)
{
    global $user_prefix;

    $result = sql_query("SELECT uid, uname FROM " . $user_prefix . "_users WHERE uid = " . $uid . " LIMIT 1");
    $DeletedUser = sql_fetch_array($result);
    return $DeletedUser;
}

/**
 * Profildaten des zu reaktivierenden Users anzeigen
 *
 * @param  $ReactivateShowProfil
 * @access public
 * @return
 */
function ShowReactivateProfil($ReactivateShowProfil)
{
    global $user_prefix, $bgcolor2, $bgcolor3;

    require_once ("includes/mx_userfunctions.php");
    // require_once ("includes/mx_api.php");
    $result = sql_query("SELECT uid, name, uname, email, femail, url, user_avatar, user_regdate, user_icq, user_occ, user_from, user_intrest, user_sig, user_aim, user_yim, user_msnm, bio, newsletter, user_ingroup, user_lastvisit, user_regtime, user_lastip, user_bday, user_sexus FROM " . $user_prefix . "_users WHERE uname = '" . $ReactivateShowProfil . "' LIMIT 1");
    $ProfileData = sql_fetch_array($result);
    $Profileoutput = '<div align="center" style="font-weight: bold;">' . _REACTIVATEPROFIL . '<br><br></div>'
     . '<table align="center" border="0" cellpadding="3" cellspacing="0">'
     . '<tr><td bgcolor="' . $bgcolor2 . '" align="left" style="font-weight: bold;">' . _REACTIVATEPROFIL00 . '</td><td bgcolor="' . $bgcolor3 . '" align="left">' . $ProfileData['uid'] . '</td></tr>'
     . '<tr><td bgcolor="' . $bgcolor2 . '" align="left" style="font-weight: bold;">' . _REACTIVATEPROFIL01 . '</td><td bgcolor="' . $bgcolor3 . '" align="left">' . $ProfileData['name'] . '</td></tr>'
     . '<tr><td bgcolor="' . $bgcolor2 . '" align="left" style="font-weight: bold;">' . _REACTIVATEPROFIL02 . '</td><td bgcolor="' . $bgcolor3 . '" align="left">' . $ProfileData['uname'] . '</td></tr>';
    if (!empty($ProfileData['user_sexus'])) {
        if ($ProfileData['user_sexus'] == 1) {
            $Profileoutput .= '<tr><td bgcolor="' . $bgcolor2 . '" align="left" style="font-weight: bold;">' . _REACTIVATEPROFIL23 . '</td><td bgcolor="' . $bgcolor3 . '" align="left">' . _REACTIVATEPROFIL23f . '</td></tr>';
        } else {
            $Profileoutput .= '<tr><td bgcolor="' . $bgcolor2 . '" align="left" style="font-weight: bold;">' . _REACTIVATEPROFIL23 . '</td><td bgcolor="' . $bgcolor3 . '" align="left">' . _REACTIVATEPROFIL23m . '</td></tr>';
        }
    }
    if (!empty($ProfileData['user_bday'])) $Profileoutput .= '<tr><td bgcolor="' . $bgcolor2 . '" align="left" style="font-weight: bold;">' . _REACTIVATEPROFIL22 . '</td><td bgcolor="' . $bgcolor3 . '" align="left">' . vkpGetBdayString($ProfileData['user_bday']) . '</td></tr>';
    if (!empty($ProfileData['email'])) $Profileoutput .= '<tr><td bgcolor="' . $bgcolor2 . '" align="left" style="font-weight: bold;">' . _REACTIVATEPROFIL03 . '</td><td bgcolor="' . $bgcolor3 . '" align="left">' . $ProfileData['email'] . '</td></tr>';
    if (!empty($ProfileData['femail'])) $Profileoutput .= '<tr><td bgcolor="' . $bgcolor2 . '" align="left" style="font-weight: bold;">' . _REACTIVATEPROFIL04 . '</td><td bgcolor="' . $bgcolor3 . '" align="left">' . $ProfileData['femail'] . '</td></tr>';
    if (!empty($ProfileData['url'])) $Profileoutput .= '<tr><td bgcolor="' . $bgcolor2 . '" align="left" style="font-weight: bold;">' . _REACTIVATEPROFIL05 . '</td><td bgcolor="' . $bgcolor3 . '" align="left">' . $ProfileData['url'] . '</td></tr>';
    if (!empty($ProfileData['user_regdate'])) $Profileoutput .= '<tr><td bgcolor="' . $bgcolor2 . '" align="left" style="font-weight: bold;">' . _REACTIVATEPROFIL07 . '</td><td bgcolor="' . $bgcolor3 . '" align="left">' . ConvertUserRegdate($ProfileData['user_regdate']) . '</td></tr>';
    if (!empty($ProfileData['user_regtime'])) $Profileoutput .= '<tr><td bgcolor="' . $bgcolor2 . '" align="left" style="font-weight: bold;">' . _REACTIVATEPROFIL20 . '</td><td bgcolor="' . $bgcolor3 . '" align="left">' . date("d.m.Y - H:i:s", $ProfileData['user_regtime']) . '</td></tr>';
    if (!empty($ProfileData['user_ingroup'])) $Profileoutput .= '<tr><td bgcolor="' . $bgcolor2 . '" align="left" style="font-weight: bold;">' . _REACTIVATEPROFIL18 . '</td><td bgcolor="' . $bgcolor3 . '" align="left">' . mxGetGroupTitle($ProfileData['user_ingroup']) . '</td></tr>';
    if (!empty($ProfileData['user_lastvisit'])) $Profileoutput .= '<tr><td bgcolor="' . $bgcolor2 . '" align="left" style="font-weight: bold;">' . _REACTIVATEPROFIL19 . '</td><td bgcolor="' . $bgcolor3 . '" align="left">' . date("d.m.Y - H:i:s", $ProfileData['user_lastvisit']) . '</td></tr>';
    if (!empty($ProfileData['user_lastip'])) $Profileoutput .= '<tr><td bgcolor="' . $bgcolor2 . '" align="left" style="font-weight: bold;">' . _REACTIVATEPROFIL21 . '</td><td bgcolor="' . $bgcolor3 . '" align="left">' . $ProfileData['user_lastip'] . '</td></tr>';
    if (!empty($ProfileData['user_from'])) $Profileoutput .= '<tr><td bgcolor="' . $bgcolor2 . '" align="left" style="font-weight: bold;">' . _REACTIVATEPROFIL10 . '</td><td bgcolor="' . $bgcolor3 . '" align="left">' . $ProfileData['user_from'] . '</td></tr>';
    if (!empty($ProfileData['user_occ'])) $Profileoutput .= '<tr><td bgcolor="' . $bgcolor2 . '" align="left" style="font-weight: bold;">' . _REACTIVATEPROFIL09 . '</td><td bgcolor="' . $bgcolor3 . '" align="left">' . $ProfileData['user_occ'] . '</td></tr>';
    if (!empty($ProfileData['user_intrest'])) $Profileoutput .= '<tr><td bgcolor="' . $bgcolor2 . '" align="left" style="font-weight: bold;">' . _REACTIVATEPROFIL11 . '</td><td bgcolor="' . $bgcolor3 . '" align="left">' . $ProfileData['user_intrest'] . '</td></tr>';
    if (!empty($ProfileData['bio'])) $Profileoutput .= '<tr><td bgcolor="' . $bgcolor2 . '" align="left" style="font-weight: bold;">' . _REACTIVATEPROFIL16 . '</td><td bgcolor="' . $bgcolor3 . '" align="left">' . $ProfileData['bio'] . '</td></tr>';
    if (!empty($ProfileData['user_avatar'])) {
        if (substr($ProfileData['user_avatar'], -12, 6) == "avatar") {
            $ProfileData['user_avatar'] = mxCreateImage(MX_PATH_MEMBERAVATAR . "/" . $ProfileData['user_avatar'], $ProfileData['user_avatar']);
        } else {
            $ProfileData['user_avatar'] = mxCreateImage(MX_PATH_AVATAR . "/" . $ProfileData['user_avatar'], $ProfileData['user_avatar']);
        }
        $Profileoutput .= '<tr><td bgcolor="' . $bgcolor2 . '" align="left" style="font-weight: bold;">' . _REACTIVATEPROFIL06 . '</td><td bgcolor="' . $bgcolor3 . '" align="left">' . $ProfileData['user_avatar'] . '</td></tr>';
    }
    if (!empty($ProfileData['user_sig'])) {
        if (@file_exists('modules/Private_Messages/bbfunctions.php')) {
            include_once('modules/Private_Messages/bbfunctions.php');
            $ProfileData['user_sig'] = msg_smile(msg_bbencode(make_clickable($ProfileData['user_sig'])));
        }
        $ProfileData['user_sig'] = mxNL2BR(mxPrepareToDisplay($ProfileData['user_sig']));
        $Profileoutput .= '<tr><td bgcolor="' . $bgcolor2 . '" align="left" style="font-weight: bold;">' . _REACTIVATEPROFIL12 . '</td><td bgcolor="' . $bgcolor3 . '" align="left">' . $ProfileData['user_sig'] . '</td></tr>';
    }
    if (!empty($ProfileData['user_icq'])) $Profileoutput .= '<tr><td bgcolor="' . $bgcolor2 . '" align="left" style="font-weight: bold;">' . _REACTIVATEPROFIL08 . '</td><td bgcolor="' . $bgcolor3 . '" align="left">' . $ProfileData['user_icq'] . '</td></tr>';
    if (!empty($ProfileData['user_aim'])) $Profileoutput .= '<tr><td bgcolor="' . $bgcolor2 . '" align="left" style="font-weight: bold;">' . _REACTIVATEPROFIL13 . '</td><td bgcolor="' . $bgcolor3 . '" align="left">' . $ProfileData['user_aim'] . '</td></tr>';
    if (!empty($ProfileData['user_yim'])) $Profileoutput .= '<tr><td bgcolor="' . $bgcolor2 . '" align="left" style="font-weight: bold;">' . _REACTIVATEPROFIL14 . '</td><td bgcolor="' . $bgcolor3 . '" align="left">' . $ProfileData['user_yim'] . '</td></tr>';
    if (!empty($ProfileData['user_msnm'])) $Profileoutput .= '<tr><td bgcolor="' . $bgcolor2 . '" align="left" style="font-weight: bold;">' . _REACTIVATEPROFIL15 . '</td><td bgcolor="' . $bgcolor3 . '" align="left">' . $ProfileData['user_msnm'] . '</td></tr>';
    if (!empty($ProfileData['newsletter'])) {
        $Profileoutput .= '<tr><td bgcolor="' . $bgcolor2 . '" align="left" style="font-weight: bold;">' . _REACTIVATEPROFIL17 . '</td><td bgcolor="' . $bgcolor3 . '" align="left">ja</td></tr>';
    } else {
        $Profileoutput .= '<tr><td bgcolor="' . $bgcolor2 . '" align="left" style="font-weight: bold;">' . _REACTIVATEPROFIL17 . '</td><td bgcolor="' . $bgcolor3 . '" align="left">nein</td></tr>';
    }
    $Profileoutput .= '</table>';
    return $Profileoutput;
}

/**
 * Liste der geloeschten User anzeigen
 *
 * @param  $page
 * @access public
 * @return
 */
function DisplayDeletedUser($page)
{
    include ("header.php");
    GraphicAdmin();
    $UserFound = GetAllDeletedUsers($page);
    Title(_REACTIVATEUSER);
    OpenTable();
    echo '<div align="center" style="font-weight: bold;">' . _REACTIVATEUSERNAMES . '<br><br></div>'
     . '<table align="center" width="70%" border="1" cellpadding="3" cellspacing="0">';
    echo $UserFound;
    echo '</table>';
    CloseTable();
    include("footer.php");
}

/**
 * Geloeschten User reaktivieren
 *
 * @param  $uid
 * @access public
 * @return
 */
function ReactivateDeletedUser($uid)
{
    global $bgcolor2, $bgcolor3;

    include ("header.php");
    GraphicAdmin();
    Title(_REACTIVATEUSER);
    if ($uid <= 0) {
        OpenTableAl();
        echo _REACTIVATENOUID1 . " " . $uid . _REACTIVATENOUID2;
        CloseTableAl();
    } else {
        $UserFound = GetDeletedUser($uid);
        if (!$UserFound) {
            OpenTableAl();
            echo _REACTIVATENOUID1 . " " . $uid . _REACTIVATENOUID2;
            CloseTableAl();
        } else {
            OpenTable();
            echo '<form action="admin.php?op=ReactivateCheck" method="post">'
             . '<table align="center" width="90%" border="0" cellpadding="3" cellspacing="0">'
             . '<tr>'
             . '<td bgcolor="' . $bgcolor2 . '" align="right" width="30%" style="font-weight: bold;">' . _REACTIVATEUSERNAME . '</td>'
             . '<td bgcolor="' . $bgcolor3 . '" width="70%" align="left">' . $UserFound['uname'] . '</td>'
             . '</tr>'
             . '<tr>'
             . '<td bgcolor="' . $bgcolor2 . '"align="right" style="font-weight: bold;">' . _REACTIVATEUSEREMAIL . '</td>'
             . '<td bgcolor="' . $bgcolor3 . '" align="left"><input type="text" name="ReactivateEmail" value="" size="50" maxlength="100"></td>'
             . '</tr>'
             . '<tr>'
             . '<td bgcolor="' . $bgcolor2 . '"align="right" style="font-weight: bold;">' . _REACTIVATESENDERNAME . '<br><div style="font-size: 9px; font-weight: normal;">' . _REACTIVATEOPTIONAL . '</div></td>'
             . '<td bgcolor="' . $bgcolor3 . '" align="left"><input type="text" name="ReactivateSendername" value="" size="50" maxlength="100"></td>'
             . '</tr>'
             . '<tr>'
             . '<td bgcolor="' . $bgcolor2 . '"align="right" style="font-weight: bold;">' . _REACTIVATESHOWPROFIL . '</td>'
             . '<td bgcolor="' . $bgcolor3 . '" align="left"><input type="checkbox" name="ReactivateShowProfil" value="' . $UserFound['uname'] . '"></td>'
             . '</tr>'
             . '<tr>'
             . '<td bgcolor="' . $bgcolor2 . '"align="center" valign="middle" style="font-weight: bold;" colspan="2" height="50">'
             . '<input type="hidden" name="ReactivateUID" value="' . $UserFound['uid'] . '">'
             . '<input type="hidden" name="ReactivateUname" value="' . $UserFound['uname'] . '">'
             . '<input type="submit" value=" ' . _REACTIVATEUSER . ' ">'
             . '</td>'
             . '</tr>'
             . '</table>'
             . '</form>';
            CloseTable();
        }
    }
    include("footer.php");
}

/**
 * Neue Daten vor dem Speichern zur Kontrolle anzeigen
 *
 * @access public
 * @return
 */
function ChecktoSaveReactivatedUser()
{
    global $bgcolor2, $bgcolor3;
    global $ReactivateUID, $ReactivateUname, $ReactivateEmail, $ReactivateSendername, $ReactivateShowProfil;

    include ("header.php");
    GraphicAdmin();
    Title(_REACTIVATEUSER);
    $ReactivateError = 0;
    if (empty($ReactivateEmail)) {
        OpenTableAl();
        echo _REACTIVATEERRORNOEMAIL;
        CloseTableAl();
        $ReactivateError = 1;
    } elseif (!mxCheckEmail($ReactivateEmail)) {
        OpenTableAl();
        echo _REACTIVATEERRORINVEMAIL;
        CloseTableAl();
        $ReactivateError = 1;
    }
    if (ereg("[^a-zA-Z0-9 _-]", $ReactivateSendername) || is_numeric($ReactivateSendername)) {
        OpenTableAl();
        echo _REACTIVATEERRORINVSENDERNAME;
        CloseTableAl();
        $ReactivateError = 2;
    }
    if (!empty($ReactivateShowProfil)) {
        OpenTable();
        echo ShowReactivateProfil($ReactivateShowProfil);
        CloseTable();
    }
    echo '<br>';
    OpenTable();
    echo '<form action="admin.php" method="post">'
     . '<table align="center" border="0" cellpadding="3" cellspacing="0">'
     . '<tr>'
     . '<td bgcolor="' . $bgcolor2 . '" align="left" style="font-weight: bold;">' . _REACTIVATEUSERNAME . '</td>'
     . '<td bgcolor="' . $bgcolor3 . '" align="left">' . $ReactivateUname . '</td>'
     . '</tr>'
     . '<tr>'
     . '<td bgcolor="' . $bgcolor2 . '" align="left" style="font-weight: bold;">' . _REACTIVATEUSEREMAIL . '</td>'
     . '<td bgcolor="' . $bgcolor3 . '" align="left">';
    if ($ReactivateError == 1) {
        echo '<input type="text" name="ReactivateEmail" value="' . $ReactivateEmail . '" size="50" maxlength="100">';
    } else {
        echo '<input type="hidden" name="ReactivateEmail" value="' . $ReactivateEmail . '">' . $ReactivateEmail;
    }
    echo '</td></tr>';
    if (!empty($ReactivateSendername)) {
        echo '<tr>'
         . '<td bgcolor="' . $bgcolor2 . '" align="left" style="font-weight: bold;">' . _REACTIVATESENDERNAME . '<br>'
         . '</td><td bgcolor="' . $bgcolor3 . '" align="left" valign="top">';
        if ($ReactivateError == 2) {
            echo '<input type="text" name="ReactivateSendername" value="' . $ReactivateSendername . '" size="50" maxlength="100">';
        } else {
            echo '<input type="hidden" name="ReactivateSendername" value="' . $ReactivateSendername . '">' . $ReactivateSendername;
        }
        echo '</td></tr>';
    }
    echo '<tr>'
     . '<td bgcolor="' . $bgcolor2 . '" align="center" valign="middle" style="font-weight: bold;" colspan="2" height="50">'
     . '<input type="hidden" name="ReactivateUID" value="' . $ReactivateUID . '">'
     . '<input type="hidden" name="ReactivateUname" value="' . $ReactivateUname . '">'
     . '<input type="hidden" name="ReactivateShowProfil" value ="' . $ReactivateShowProfil . '">';
    if ($ReactivateError != 0) {
        echo '<input type="hidden" name="op" value="ReactivateCheck">'
         . '<input type="submit" value=" ' . _REACTIVATEUSER . ' ">';
    } else {
        echo '<input type="hidden" name="op" value="ReactivateSave">'
         . '<input type="submit" value=" ' . _REACTIVATEUSERSAVE . ' ">';
    }
    echo '</td></tr>'
     . '</table>'
     . '</form>';
    CloseTable();
    include("footer.php");
}

/**
 * User mit neuen Daten als aktiv in die DB eintragen
 *
 * @access public
 * @return
 */
function SaveReactivatedUser()
{
    global $user_prefix, $default_group, $ReactivateUID, $ReactivateUname, $ReactivateEmail, $ReactivateSendername;

    require_once ("includes/mx_userfunctions.php");
    $ReactivateName = "";
    $ReactivateUser_regtime = time();
    $ReactivateUser_regdate = mxGetNukeUserregdate($ReactivateUser_regtime);
    $ReactivatePass = makePass();
    $ReactivateUser_ingroup = $default_group;
    $ReactivateUser_stat = 1;
    $result = sql_query("UPDATE " . $user_prefix . "_users SET name='" . $ReactivateName . "', email='" . $ReactivateEmail . "', user_regdate='" . $ReactivateUser_regdate . "', pass= MD5('" . $ReactivatePass . "'), user_regtime='" . $ReactivateUser_regtime . "', user_ingroup='" . $ReactivateUser_ingroup . "', user_stat='" . $ReactivateUser_stat . "' WHERE uid='" . $ReactivateUID . "' LIMIT 1");
    include ("header.php");
    GraphicAdmin();
    Title(_REACTIVATEUSER);
    if (!$result) {
        OpenTableAl();
        echo _REACTIVATEERRORSAVE;
        CloseTableAl();
    } else {
        mxMail($ReactivateEmail, _REACTIVATESUBJECT, _REACTIVATEMESSAGE, $GLOBALS['adminmail'], "text");
        OpenTable2();
        echo '<table align="center" border="0" cellpadding="0" cellspacing="0"><tr>'
         . '<td>' . _REACTIVATESAVEOK . '</td>'
         . '</tr></table>';
        CloseTable2();
    }
    include("footer.php");
}

switch ($op) {
    case "ReactivateEdit":
        ReactivateDeletedUser($uid);
        break;

    case "ReactivateCheck":
        ChecktoSaveReactivatedUser();
        break;

    case "ReactivateSave":
        SaveReactivatedUser();
        break;

    default:
        $page = (!empty($page)) ? $page : 1;
        DisplayDeletedUser($page);
        break;
}

?>
