<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.13.2.5 $
 * $Author: tora60 $
 * $Date: 2008/02/02 10:41:47 $
 *
 * this file based on:
 * php-nuke Web Portal System - http://phpnuke.org/
 * Thatware - http://thatware.org/
 * Base on Reviews Addon
 * Copyright (c) 2000 by Jeff Lambert (jeffx@ican.net) http://www.qchc.com
 * More scripts on http://www.jeffx.qchc.com
 */

defined('mxMainFileLoaded') or die('access denied');

if (!defined('PMX_VERSION')) {
    mxErrorScreen('pragmaMx >= 0.1.10 is required');
}

if (!mxGetAdminPref('radminreviews')) {
    mxErrorScreen("Access Denied");
    die();
}

$wysiwyg = 0;
$wysiwyg_review = 0;
include_once('spaw/spaw_control.class.php');

$module_name = "Reviews";
require_once("modules/$module_name/config.php");
// #################################################################################
function reviews()
{
    global $prefix, $multilingual, $module_name, $revautoactivate;

    include_once("header.php");

    GraphicAdmin();
    title( _REVADMIN);
    
    OpenTable();
    echo "<center><p class=\"option\"><b>" . _REVWAITING . "</b></p>";
    $result = sql_query("select * from " . $prefix . "_reviews WHERE active='0' order by id");
    $numrows = sql_num_rows($result);
    if ($numrows > 0) {
        while (list($id, $date, $title, $text, $reviewer, $score, $cover, $url, $url_title, $hits, $rlanguage, $active) = sql_fetch_row($result)) {
            $id = (empty($id)) ? 0 : intval($id);
            for($i = 0; $i < 11; $i++) {
                if ($score == $i)
                    $select[$i] = "selected=\"selected\"";
                else
                    $select[$i] = "";
            }
            echo "<hr noshade size=\"1\"><br />"
             . ""
             . "<form action=\"admin.php\" method=\"post\">"
             . "<table border=\"0\" cellpadding=\"1\" cellspacing=\"2\" width=\"100%\">"
             . "<tr><td><b>" . _REVIEWID . ":</b></td><td><b>$id</b>"
             . "</td></tr>"
             . "<tr><td>" . _DATE . ":</td><td>" . mx_strftime(_DATESTRING . ' %H:%m', $date) . "</td></tr>"
             . "<tr><td>" . _PRODUCTTITLE . ":</td><td><input type=\"text\" name=\"title\" value=\"" . mxEntityQuotes($title) . "\" size=\"60\" maxlength=\"255\"></td></tr>";
            if ($multilingual == 1) {
                echo "<tr><td>" . _LANGUAGE . ":</td><td>" . mxLanguageSelect('rlanguage', $rlanguage, 'language', 1) . "</td></tr>";
            }
            echo "<tr valign='top'><td>" . _TEXT . ":</td><td>";
            if ($GLOBALS['wysiwyg'] && $GLOBALS['wysiwyg_review']) {
                $GLOBALS['show_pagebreak'] = true;
                $sw = new SPAW_Wysiwyg('text_' . $id, $text, _DOC_LANGUAGE, $GLOBALS['wysiwyg_toolbar'], $GLOBALS['wysiwyg_btnset'], '100%', '300');
                $sw->show();
            } else {
                echo "<textarea name=\"text_" . $id . "\" rows=\"15\" cols=\"60\">" . htmlspecialchars($text) . "</textarea>";
            }
            echo "<br /><span class=\"tiny\">" . _PAGEBREAK . "</span><br /><br />"
             . "</td></tr>"
             . "<tr><td>" . _RELATEDLINK . ":</td><td><input type=\"text\" name=\"url\" value=\"" . mxEntityQuotes($url) . "\" size=\"60\" maxlength=\"255\"></td></tr>"
             . "<tr><td>" . _LINKTITLE . ":</td><td><input type=\"text\" name=\"url_title\" value=\"" . mxEntityQuotes($url_title) . "\" size=\"60\" maxlength=\"255\"></td></tr>"
             . "<tr><td>" . _IMAGE . ":</td><td><input type=\"text\" name=\"cover\" value=\"" . mxEntityQuotes($cover) . "\" size=\"60\" maxlength=\"255\"><br /><i>" . _REVIMGINFO . "</i></td></tr>"
             . "<tr><td>" . _REVIEWER . ":</td><td><input type=\"text\" name=\"reviewer\" value=\"" . mxEntityQuotes($reviewer) . "\" size=\"30\" maxlength=\"255\"></td></tr>"
             . "<tr><td>" . _SCORE . "</td>
				<td>
					<select name=\"score\">
				    <option value=\"10\" $select[10]>10</option>
				    <option value=\"9\" $select[9]>9</option>
				    <option value=\"8\" $select[8]>8</option>
				    <option value=\"7\" $select[7]>7</option>
				    <option value=\"6\" $select[6]>6</option>
				    <option value=\"5\" $select[5]>5</option>
				    <option value=\"4\" $select[4]>4</option>
				    <option value=\"3\" $select[3]>3</option>
				    <option value=\"2\" $select[2]>2</option>
				    <option value=\"1\" $select[1]>1</option>
				    <option value=\"0\" $select[0]>0</option>
				 	</select>
				</td></tr>"
             . "</table><br />"
             . "<input type=\"hidden\" name=\"date\" value=\"$date\">"
             . "<input type=\"hidden\" name=\"id\" value=\"$id\">"
             . "<input type=\"hidden\" name=\"op\" value=\"add_review\">"
             . "<input type=\"submit\" value=\"" . _ADDREVIEW . "\">"
             . " - [&nbsp;<a href=\"admin.php?op=deleteNotice&amp;id=$id\">" . _DELETE . "</a>&nbsp;]"
             . "</form>";
        }
        echo "<hr noshade size=\"1\"><br /><br />";
    } else {
        echo "<br /><br /><i>" . _NOREVIEW2ADD . "</i><br /><br />";
        if ($revautoactivate) {
            echo _AUTOACTIVATENOTIC . "<br /><br />";
        }
    }
    echo "<p><a href=\"modules.php?name=$module_name&amp;rop=write_review\">" . _CLICK2ADDREVIEW . "</a></p></center>";
    CloseTable();
    echo "<br />";
    OpenTable();
    echo "<center><font class=\"option\"><b>" . _DELMODREVIEW . "</b></font><br /><br />" . _MODREVINFO . "</center>";
    CloseTable();
    echo "<br /><br />";
    include_once("footer.php");
}
// #################################################################################
function add_review()
{
    global $prefix;
    extract($_POST);
    $rlanguage = (empty($rlanguage)) ? '' : $rlanguage;
    $id = (empty($_POST['id'])) ? 0 : intval($_POST['id']);
    $text = $_POST['text_' . $id];
    sql_query("UPDATE " . $prefix . "_reviews SET title='" . mxAddSlashesForSQL($title) . "', text='" . mxAddSlashesForSQL($text) . "', reviewer='" . mxAddSlashesForSQL($reviewer) . "', score='$score', cover='" . mxAddSlashesForSQL($cover) . "', url='" . mxAddSlashesForSQL($url) . "', url_title='" . mxAddSlashesForSQL($url_title) . "', rlanguage='" . mxAddSlashesForSQL($rlanguage) . "', active='1' WHERE id='" . intval($id) . "'");
    header("Location: admin.php?op=reviews");
}
// #################################################################################
function deleteNotice($id)
{
    global $prefix;
    sql_query("DELETE FROM " . $prefix . "_reviews WHERE id = " . intval($id));
    header("Location: admin.php?op=reviews");
}
// #################################################################################
switch ($op) {
    case "add_review":
        add_review();
        break;

    case "deleteNotice":
        deleteNotice($id);
        break;

    case "mod_main":
    case "reviews":
    default:
        reviews();
        break;
}

?>