<?php
/**
 * This file is part of 
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.10.2.3 $
 * $Author: tora60 $
 * $Date: 2007/12/22 14:11:51 $
 */

if (!defined("mxMainFileLoaded")) die ("You can't access this file directly...");
/**
 * -------------MODIFY HERE TO CUSTOMIZE THE MENU------
 */

/**
 * link to homepage (alternate: index.php )
 */
$homelink = './';
/**
 * Show all active modules, or only this where set to this Block
 */
$showallmodules = 0;
/**
 * Show inaktive modules for admin to test it
 */
$showinaktive = 1;
/**
 * Show link to adminmenue
 */
$showadminlink = 1;
/**
 * image path relative to public root
 */
$image1 = "images/menu/rarrow.gif";
/**
 * image path relative to public root
 */
$image2 = "images/menu/oarrow.gif";
/**
 * image path relative to public root
 */
$image3 = "images/menu/barrow.gif";
/**
 * max. Number of charakters in Moduleslist
 */
$maxwordlen = 18;
/**
 * Heigth of the scrolling Layer for Moduleslist
 */
$listheigth1 = 0;
/**
 * Heigth of the scrolling Layer for inactive Moduleslist
 */
$listheigth2 = 60;
/**
 * Heigth of the scrolling Layer for hided Moduleslist
 */
$listheigth3 = 40;
/**
 * allow to cache this Block
 */
$mxblockcache = false;
/**
 * Design im pragmaMx.org Stil anzeigen?  Wird evtl. von
 * der entsprechenden Themeeinstellung ($themePmxStyle) ueberschrieben!!
 */
$pmxStyle = false;
/**
 * Breite der Tabelle im pragmaMx.org Stil.  Wird evtl. von
 * der entsprechenden Themeeinstellung ($themePmxStyleWidth) ueberschrieben!!
 */
$pmxStyleWidth = '146px';
/**
 * ---------END-MODIFY HERE TO CUSTOMIZE THE MENU------
 */

global $prefix;
$main_module = mxGetMainModuleName();

$thismodulblock = preg_replace('#^block-(.+)\.php$#', '\1', basename(__file__));

if ($pmxStyle) {
    $image1 = '';
    $image2 = '';
    $image3 = '';
    $menuline = '<tr%s><td class="leftmenu">%s<a href="%s">%s</a></td></tr>';
} else {
    $image1 = mxCreateImage($image1, '~');
    $image2 = mxCreateImage($image2, '~');
    $image3 = mxCreateImage($image3, '~');
    $menuline = '<tr%s><td>%s<a href="%s">%s</a></td></tr>';
}

$where = (MX_IS_ADMIN && $showinaktive) ? "WHERE title<>'CVS'" : "WHERE title<>'CVS' AND (main_id='" . $thismodulblock . "' OR main_id='') AND active=1";
$result = sql_query("select title, custom_title, active, main_id from ${prefix}_modules $where");
while (list($mod_name, $custom_title, $active, $main_id) = sql_fetch_row($result)) {
    $showit = ($showallmodules || empty($main_id) || ($main_id == $thismodulblock)) ? 1 : 0;

    if (MX_IS_ADMIN == true && $active && substr($main_id, 0, 4) == 'Menu') continue;

    switch (true) {
        case (MX_IS_ADMIN && $active && $main_id == "hided"):
            $cat = 'hidden';
            break;
        case (MX_IS_ADMIN && !$active):
            $cat = 'deaktiv';
            break;
        case ($active && $showit && (MX_IS_ADMIN || mxModuleAllowed($mod_name))):
            $cat = 'normal';
            break;
        default:
            $cat = '';
            break;
    }
    if ($cat) {
        if ($mod_name == $main_module) {
            $sorter = '00';
            $custom_title = _HOME;
            $link = $homelink;
            $img = $image2;
        } else {
            $sorter = strtolower($custom_title);
            $custom_title = (empty($custom_title)) ? str_replace("_", " ", $mod_name) : $custom_title;
            $link = 'modules.php?name=' . urlencode($mod_name);
            $img = ($mod_name === MX_MODULE) ? $image2 : $image1;
        }
        $view_title = mxCutString($custom_title, $maxwordlen, "..", "");
        $titleattribut = ($custom_title === $view_title) ? '' : ' title="' . $custom_title . '"';
        $opti[$cat][$sorter] = sprintf($menuline, $titleattribut, $img, $link, $view_title);
    }
}

if (MX_IS_ADMIN && $showadminlink) {
    $sorter = '01';
    $custom_title = _ADMINMENUEBL;
    $link = 'admin.php';
    $img = $image3;
    $view_title = mxCutString($custom_title, $maxwordlen, "..", "");
    $titleattribut = ($custom_title === $view_title) ? '' : ' title="' . $custom_title . '"';
    $opti['normal'][$sorter] = sprintf($menuline, $titleattribut, $img, $link, $view_title);
}

$content = '';
if (isset($opti['normal'])) {
    ksort($opti['normal'], SORT_STRING);
    if ($pmxStyle) {
        $content .= ($listheigth1) ? '<div align="right" valign="middle" style="height: ' . $listheigth1 . 'px; overflow : auto;">' : '<div>';
        $content .= '<table align="center" cellpadding="0" cellspacing="0" style="width:' . $pmxStyleWidth . ';">';
    } else {
        $content .= ($listheigth1) ? '<div style="height: ' . $listheigth1 . 'px; overflow : auto;">' : '<div>';
        $content .= '<table border="0" cellpadding="1" cellspacing="0" width="100%">';
    }
    $content .= str_replace('alt="~" title="~"', 'alt=""', implode("\n", $opti['normal']));
    $content .= '</table></div>';
}

if (isset($opti['deaktiv'])) {
    ksort($opti['deaktiv'], SORT_STRING);
    $content .= '<div class="tiny"><br>&nbsp;<b>' . _NOACTIVEMODULES . '</b><br>&nbsp;&nbsp;' . _FORADMINTESTS . '</div><br>';
    if ($pmxStyle) {
        $content .= ($listheigth2) ? '<div align="right" valign="middle" style="height: ' . $listheigth2 . 'px; overflow : auto;">' : '<div>';
        $content .= '<table align="center" cellpadding="0" cellspacing="0" style="width:' . $pmxStyleWidth . ';">';
    } else {
        $content .= ($listheigth2) ? '<div style="height: ' . $listheigth2 . 'px; overflow : auto;">' : '<div>';
        $content .= '<table border="0" cellpadding="1" cellspacing="0" width="100%">';
    }
    $content .= str_replace('alt="~" title="~"', 'alt=""', implode("\n", $opti['deaktiv']));
    $content .= '</table></div>';
}

if (isset($opti['hidden'])) {
    ksort($opti['hidden'], SORT_STRING);
    $content .= '<div class="tiny"><br>&nbsp;<b>' . _NOVIEWEDMODULES . '</b><br>&nbsp;&nbsp;' . _FORADMINTESTS . '</div><br>';
    if ($pmxStyle) {
        $content .= ($listheigth3) ? '<div align="right" valign="middle" style="height: ' . $listheigth3 . 'px; overflow : auto;">' : '<div>';
        $content .= '<table align="center" cellpadding="0" cellspacing="0" style="width:' . $pmxStyleWidth . ';">';
    } else {
        $content .= ($listheigth3) ? '<div style="height: ' . $listheigth3 . 'px; overflow : auto;">' : '<div>';
        $content .= '<table border="0" cellpadding="1" cellspacing="0" width="100%">';
    }
    $content .= str_replace('alt="~" title="~"', 'alt=""', implode("\n", $opti['hidden']));
    $content .= '</table></div>';
}

?>
