<?php
/**
 * pragmaMx SMF Integration
 * Copyright by A.Ellsel (Andi) - http://pragmaMx.org
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Id: block-smf_Center.php,v 1.14 2008/06/13 22:34:56 tora60 Exp $
 */

defined('mxMainFileLoaded') or die('access denied');

/**
 * // //////////  EINSTELLUNGEN DES BLOCKS ////////////////////////////////////
 */
// der Modulname (Ordner des Moduls)
$boardname = 'Forum';
// Anzahl der angezeigten neuesten Threads
$num_threads = 6;
// Boards die nicht angezeigt werden sollen, als Array
$exclude_boards = null;
// Thread-Icons in Liste anzeigen
$show_icons = 1;
// Anzahl, wie oft gelesen, in Liste anzeigen
$show_views = 1;
// Anzahl der Antworten in Liste anzeigen
$show_replies = 1;
// Name des Themenstarters in Liste anzeigen
$show_starter = 0;
// kleine Forumsstatistik anzeigen
$show_stats = 1;
// User-Onlinestatistik anzeigen
$show_online = 1;
// in Onlinestatistik die Buddies extra listen
$show_buddies = 1;
// Farben des Blocks
/**
 * //////////  ENDE DER EINSTELLUNGEN /////////////////////////////////////////
 */

/**
 * versch. globale Variablen vorher initialisieren, weil in Funktionen aufgerufen
 */
global $db_prefix, $settings, $context, $scripturl, $mxsmf;
global $bgcolor1, $bgcolor2, $bgcolor3, $bgcolor4, $textcolor1, $textcolor2;

/**
 * die SSI-Datei includen
 */
@include(dirname(dirname(__FILE__)) . '/modules/' . $boardname . '/mx_SSI.php');
if (!defined('SMF')) {
    // falls Bridge nicht installiert, oder Datei nicht gefunden, hier beenden
    return $content = @$mx_ssi_content;
}

if (!defined('PMX_VERSION') || version_compare(PMX_VERSION, '0.1.11', '<')) {
    pmxHeader::add("
<style type=\"text/css\" media=\"screen\">
table.smf-block.list {
   border: none;
   margin: 1.5em 0;
   background-color: $bgcolor2;
   color: inherit;
   font-size: 1em;
   border-spacing: 0;
   border-collapse: collapse;
}

table.smf-block.list th,
table.smf-block.list td {
   padding: .2em .3em;
   border: 1px solid $bgcolor1;
   line-height: normal;
}

table.smf-block.list th,
table.smf-block.list tr.head,
table.smf-block.list td.head {
   background-color: $bgcolor3;
   color: $textcolor2;
   font-weight: bold;
}

table.smf-block.list tr.alternate-a,
table.smf-block.list td.alternate-a {
   background-color: $bgcolor4;
   color: inherit;
}

table.smf-block.list tr.alternate-b,
table.smf-block.list td.alternate-b {
   background-color: $bgcolor1;
   color: inherit;
}
</style>
");
}

/**
 * Boardstatistik
 */
$boardstats = ssi_boardStats('array');
$boardstats = '
' . $txt[330] . ': ' . $boardstats['topics'] . ' |
' . $txt[95] . ': ' . $boardstats['posts'] . ' |
' . $txt[331] . ': <a href="modules.php?name=' . $boardname . '&amp;action=mlist" title="' . $txt['332'] . '">' . $boardstats['members'] . '</a>
';
// Anzahl der Spalten, abhaengig der Einstellungen
$colspan = intval($show_icons) + intval($show_views) + intval($show_replies) + intval($show_starter) + 2;
// Wer ist Online?
if ($show_online) {
    $whoonline = ssi_whosOnline('array');
    $whoonline_out = '' . $whoonline['guests'] . ' ' . (($whoonline['guests'] == 1) ? $txt['guest'] : $txt['guests']) . ', ' . $whoonline['num_users'] . ' ' . (($whoonline['num_users'] == 1) ? $txt['user'] : $txt['users']);
    // Hidden users. or buddies?
    if ($whoonline['hidden'] > 0 || $show_buddies) {
        $whoonline_out .= ' (' . ($show_buddies ? ($whoonline['buddies'] . ' ' . (($whoonline['buddies'] == 1) ? $txt['buddy'] : $txt['buddies'])) : '') . ($show_buddies && $whoonline['hidden'] ? ', ' : '') . (!$whoonline['hidden'] ? '' : $whoonline['hidden'] . ' ' . $txt['hidden']) . ')';
    }
    if (count($whoonline['users'])) {
        $whoonline_list = '';
        foreach ($whoonline['users'] as $user)
        $whoonline_list .= (($user['hidden']) ? '<i>' . $user['link'] . '</i>' : $user['link']) . (($user['is_last']) ? '' : '. ');
    }
}
// die Threads und Posts
$posts = ssi_recentTopics(intval($num_threads), $exclude_boards, 'array');
if ($show_starter || $show_replies || $show_views) {
    // / alle Thread-ID's vorher auslesen, fr Datenbankbedingung
    foreach ($posts as $post) {
        $topics[$post['topic']] = $post['topic'];
    }
    if (isset($topics)) {
        // / zustzliche Daten, die nicht von SSI bereitgestellt werden ermitteln
        $qry = "SELECT DISTINCT m.ID_MEMBER, m.posterName, t.numReplies, t.numViews, t.ID_TOPIC
				FROM {$db_prefix}topics AS t
				LEFT JOIN {$db_prefix}messages AS m ON ( m.ID_MSG = t.ID_FIRST_MSG )
				WHERE t.ID_TOPIC IN (" . implode(',', $topics) . ")
				LIMIT " . intval($num_threads) . "";
        $result = sql_query($qry);
        // / die zustzlichen Daten sind dann ber den Index des Arrays ansprechbar, dieser index entspricht der Thread-ID
        while ($row = sql_fetch_assoc($result)) {
            $row['link'] = (empty($row['ID_MEMBER'])) ? $row['posterName'] : '<a href="modules.php?name=' . $boardname . '&amp;action=profile;u=' . $row['ID_MEMBER'] . '" title="' . $txt[92] . ' ' . $row['posterName'] . '">' . $row['posterName'] . '</a>';
            $posts_more[$row['ID_TOPIC']] = $row;
        }
    }
}
// Der Tabellenkopf fr die Threads und Posts
$content = '<table width="100%" border="0" cellspacing="1" cellpadding="2" style="background: ' . $bgcolor2 . ';" class="smf-block list">
<tr>';
$content .= '<th colspan="' . (($show_icons) ? 2 : 1) . '">' . $txt['319'] . '</th>'; # Thema
if ($show_starter) {
    $content .= '<th>' . $txt['109'] . '</th>'; # Themenstarter
}
if ($show_replies) {
    $content .= '<th>' . $txt['110'] . '</th>'; # Antworten
}
if ($show_views) {
    $content .= '<th>' . $txt['301'] . '</th>'; # Aufrufe
}
$content .= '<th>' . $txt['111'] . '</th>'; # Letzter Beitrag
$content .= '
</tr>
';
// die Hauptliste der einzelnen Threads
$class = '';
foreach ($posts as $post) {
    $class = ($class == '') ? ' class="alternate-a"' : '';
    $new = (!$post['new']) ? ' <a href="modules.php?name=' . $boardname . '&amp;topic=' . $post['topic'] . '.msg' . $post['new_from'] . ';topicseen#new"><img src="' . $settings['images_url'] . '/' . $context['user']['language'] . '/new.gif" alt="' . $txt[302] . '" border="0" align="right"></a> ': '';
    $content .= '<tr' . $class . '>';
    if ($show_icons) {
        $content .= '<td width="1%" align="center">' . $post['icon'] . '</td>';
    }
    $content .= '<td>' . $new . '<a href="' . str_replace(';topicseen', '', $post['href']) . '">' . $post['subject'] . '</a><br /><em>' . $txt['smf88'] . ' ' . $post['board']['link'] . '</em></td>';
    if ($show_starter) {
        $content .= '<td width="1%" style="white-space: nowrap;">' . ((isset($posts_more[$post['topic']]['link'])) ? $posts_more[$post['topic']]['link'] : '') . '</td>';
    }
    if ($show_replies) {
        $content .= '<td width="1%" align="center">' . ((isset($posts_more[$post['topic']]['numReplies'])) ? $posts_more[$post['topic']]['numReplies'] : 0) . '</td>';
    }
    if ($show_views) {
        $content .= '<td width="1%" align="center">' . ((isset($posts_more[$post['topic']]['numViews'])) ? $posts_more[$post['topic']]['numViews'] : 0) . '</td>';
    }
    $content .= '<td>' . $post['time'] . '<br />' . $txt[525] . ' ' . $post['poster']['link'] . '</td>';
    $content .= '</tr>';
}
// Boardstatistik anzeigen
if ($show_stats) {
    $class = ($class == '') ? ' class="alternate-a"' : '';
    $content .= '
		<tr' . $class . '>
		<td colspan="' . $colspan . '" align="center">' . $boardstats . '</td>
		</tr>';
}
// Wer ist Online anzeigen
if ($show_online) {
    $class = ($class == '') ? ' class="alternate-a"' : '';
    $content .= '
		<tr' . $class . '>
		<td colspan="' . $colspan . '" align="center">' . $txt['who_title'] . ':&nbsp;&nbsp;' . $whoonline_out . '</td>
		</tr>';
}
// Wer ist Online anzeigen, die Liste der einzelnen User
if ($show_online && !empty($whoonline_list)) {
    $class = ($class != '') ? ' class="alternate-a"' : '';
    $content .= '
		<tr' . $class . '>
		<td colspan="' . $colspan . '">' . $whoonline_list . '</td>
		</tr>';
}
// Der Tabellenfuss fr die Threads und Posts
$content .= '</table>';
// Den Output fr pragmaMx aufbereiten (links usw. anpassen)
$content = mxSmfPrepareOutput($content);

?>