<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.19.2.10 $
 * $Author: tora60 $
 * $Date: 2008/01/29 00:41:42 $
 */

defined('mxMainFileLoaded') or die('access denied');

/**
 * definiert, dass diese Datei bereits includet wurde
 * nicht veraendern!
 */
$GLOBALS['header_is_shown'] = true;
$GLOBALS['header'] = 1;

/**
 * nur fuer nuke-Module noch drin!
 */
global $PHP_SELF, $pagetitle;

/**
 * rechte Bloecke ausblenden oder nicht
 */
if (defined('mxAdminFileLoaded')) {
    // in der Administration, die Bloecke NIE anzeigen
    $GLOBALS['index'] = 0;
} else if (!empty($GLOBALS['vkpBlocksRight'])) {
    if ($GLOBALS['vkpBlocksRight'] == 1) {
        // Bloecke immer anzeigen
        $GLOBALS['index'] = 1;
    } else if ($GLOBALS['vkpBlocksRight'] == 2) {
        // Bloecke NIE anzeigen
        $GLOBALS['index'] = 0;
    }
}

/**
 * Statistik aktualisieren
 */
mxCounter();

/**
 * Onlineliste aktualisieren
 */
online();

/**
 * das theme includen und die dort deklarierten Variablen in den globalen Scope importieren
 */
$themevars = includetheme();
foreach ($themevars as $key => $value) {
    global $$key;
    $$key = $value;
}

/* falls kein Seitentitel angegeben wurde, diesen aus dem Modulnamen generieren */
if (empty($pagetitle) && empty($GLOBALS['home']) && defined('MX_MODULE')) {
    $result = sql_query("SELECT custom_title FROM " . $GLOBALS['prefix'] . "_modules WHERE title='" . MX_MODULE . "' LIMIT 1");
    list($pagetitle) = sql_fetch_row($result);
    unset($result);
}
/* wenn kein Seitentitel, oder die Startseite, nur den Seitenname als Seitentitel anzeigen. */
$pagetitle = (empty($pagetitle) || !empty($GLOBALS['home'])) ? $GLOBALS['sitename'] : $GLOBALS['sitename'] . " - " . $pagetitle;
/* sicherstellen, dass der Seitentitel keine Tags enthaelt und Sonderzeichen nicht zerstueckelt werden */
$pagetitle = strip_tags(str_replace('&nbsp;', ' ', $pagetitle));

/**
 * alter Mist, nur noch zur Kompatibilitaet mit alten vkp-Themes vorhanden
 */
$VKPTheme = (empty($VKPTheme)) ? false : true;

/**
 * Die HTML-Ausgabe beginnen
 * Info zum Doctype:
 * - http://carsten-protsch.de/zwischennetz/doctype/einleitung.html
 */
$GLOBALS['DOCTYPE'] = (empty($GLOBALS['DOCTYPE'])) ? 0 : intval($GLOBALS['DOCTYPE']);
$doctype_arr = mxDoctypeArray($GLOBALS['DOCTYPE']);
echo $doctype_arr['value'], "\n";
if ($doctype_arr['xhtml']) {
    echo '<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="', _DOC_LANGUAGE, '" lang="', _DOC_LANGUAGE, '" dir="', _DOC_DIRECTION, '">';
} else {
    echo '<html lang="', _DOC_LANGUAGE, '" dir="', _DOC_DIRECTION, '">';
}

/**
 * der HTML-Beginn und Seitentitel
 * die Metatags
 */
?>
<head>
<title><?php echo $pagetitle ?></title>
<meta http-equiv="Content-Type" content="text/html; charset=<?php echo _CHARSET ?>">
<meta http-equiv="Content-Language" content="<?php echo _DOC_LANGUAGE ?>">
<meta http-equiv="Content-Style-Type" content="text/css">
<meta http-equiv="Content-Script-Type" content="text/javascript">
<meta http-equiv="expires" content="0">
<meta name="revisit-after" content="10 DAYS">
<meta name="robots" content="INDEX, FOLLOW">
<meta name="resource-type" content="DOCUMENT">
<meta name="distribution" content="GLOBAL">
<meta name="rating" content="general">
<meta name="author" content="<?php echo htmlentities(strip_tags($GLOBALS['sitename'])) ?>">
<meta name="keywords" content="<?php echo htmlentities($GLOBALS['metakeywords']) ?>, <?php echo MX_VERSION ?>">
<meta name="generator" content="<?php echo MX_VERSION ?> - by http://pragmaMx.org">
<meta name="copyright" content="Copyright (c) <?php echo Date("Y") ?> by <?php echo htmlentities(strip_tags($GLOBALS['sitename'])) ?>">
<meta name="description" content="<?php echo htmlentities(strip_tags($GLOBALS['slogan'])) ?>">
<?php
if (!empty($GLOBALS['mxGoogleMetaVeri'])) {
    echo '<meta name="verify-v1" content="' . htmlentities($GLOBALS['mxGoogleMetaVeri']) . '">';
}

/**
 * Zusaetze aus den Modulen und Themes
 * Bloecke werden evtl. erst in der footer.php beruecksichtigt,
 * dort wird die Funktion nochmals aufgerufen, falls etwas dazu gekommen ist.
 */
pmxHeader::show();

/* Platzhalter fuer spaetere Ersetzungen in der footer.php */
echo '<!-- pmx~header~' . MX_TIME . '~pmx -->';

/**
 * das favicon, versuchen aus dem Theme zu holen, wenn nicht...
 */
if (@file_exists('favicon.ico')) {
    echo '<link rel="shortcut icon" href="', MX_BASE_URL, 'favicon.ico" type="image/x-icon">', "\n";
} else if (@file_exists(MX_THEME_DIR . '/images/favicon.ico')) {
    echo '<link rel="shortcut icon" href="', MX_BASE_URL, MX_THEME_DIR . '/images/favicon.ico" type="image/x-icon">', "\n";
}

/**
 * die globale CSS-Datei des Themes muss immer vorhanden sein,
 * weitere koennen problemlos ueber die pmxHeader-Klasse eingebunden werden
 */
echo '<link rel="stylesheet" href="', MX_THEME_DIR, '/style/style.css" type="text/css">', "\n";

/**
 * zusaetzliche Datei fuer benutzerdefinierte Zusaetze im HTML-Headerbereich
 */
include('includes/my_header.php');

/**
 * HTML-Header Bereich beenden
 * - weiter geht es mit dem body-Tag in der Funktion themeheader()
 */
echo "\n</head>\n";

/**
 * den Siteservice als erstes anzeigen
 */
if (!empty($GLOBALS['mxSiteService']) || !empty($GLOBALS['mxDebugService'])) {
    mxSiteService();
}

/**
 * der Seitenkopf des Themes, 
 * evtl. mit Ausgabe der linken Bloecke in nuke-styled Thems
 */
themeheader();

/**
 * Ausgabe der oberen Center-Bloecke in nuke-styled Themes
 */
if (!empty($GLOBALS['home']) && !$VKPTheme) {
    blocks('center');
}




/* __________________________________________________________________________ */
/**
 * kompatibilitaet zu < nuke-themes
 */
function themecenterbox($title, $content, $block = array())
{
    if (function_exists ('thememiddlebox')) {
        /**
         * In pragmaMx Themes existiert normalerweise diese Funktion und wird stattdessen verwendet
         */
        thememiddlebox($title, $content, $block);
    } else {
        OpenTable();
        echo '<div class="title">', $title, '</div><br>', "\n", '<div class="content">', $content, "</div>\n";
        CloseTable();
        echo '<br>';
    }
}

/**
 * kompatibilitaet zu < VKP-Maxi-themes
 */
if (!function_exists('OpenTableAl')) {
    /**
     * In pragmaMx Themes existiert normalerweise diese Funktion und wird stattdessen verwendet
     */
    function OpenTableAl()
    {
        global $bgcolor1;
        echo '<table width="80%" border="1" cellspacing="1" cellpadding="0" bgcolor="#ff0000" align="center">
        <tr><td><table width="100%" border="0" cellspacing="1" cellpadding="0" bgcolor="', $bgcolor1, '">
        <tr><td>
        ';
    }
}

/**
 * kompatibilitaet zu < VKP-Maxi-themes
 */
if (!function_exists('CloseTableAl')) {
    /**
     * In pragmaMx Themes existiert normalerweise diese Funktion und wird stattdessen verwendet
     */
    function CloseTableAl()
    {
        echo '</td></tr></table>
        </td></tr></table>
        ';
    }
}

?>