<?php
/**
 * This file is part of 
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.11 $
 * $Author: tora60 $
 * $Date: 2008/01/29 20:28:52 $
 */

defined('mxMainFileLoaded') or die('access denied');
// ##############################################################################
// Konfiguration in Funktion gekapselt, um die Variablen nicht global zu setzen
function sqlCheckConfig()
{
    /**
     * die Konfiguration zwischenspeichern um nicht bei jedem Aufruf
     * das Prozedere zu durchlaufen
     */
    static $conf;
    if ($conf) {
        return $conf;
    }

    // /////////////////////////////////////////////////////////////////////////////
    // / ab hier beginnt die Konfiguration /////////////////////////////////////////
    // Typ der Logfunktion: file, sql oder both fr beide Typen
    // bei sql werden die Daten im normalen mxSecurelogging gespeichert
    // bei file, in der nachfolgend angegebenen Datei.
    $conf['logtype'] = 'file'; # file, sql, both
    
    // Pfad zur Logdatei
    // Diese Datei sollte in einem geschtzten Verzeichnis liegen!!
    $conf['logfile'] = PMX_DYNADATA_DIR . '/logfiles/detect.' . date('Y-m-d') . '.log';
    
	// Weiterleiten auf andere Seite oder leerlassen um mit Fehlermeldung direkt abzubrechen
    $conf['redirect'] = './'; #
	// $conf['redirect'] = 'http://www.google.de/'; #
    
	// mailadressen, wo die Detection hinversendet werden soll
    // weitere Adressen knnen nach dem gleichen Schema zugefgt werden
    // um kein Mail zu versenden, einfach diese Zeilen auskommentieren oder lschen
    $conf['sendmail'][] = $GLOBALS['adminmail']; // Standardadminmailadresse, kann auch mit anderem Wert belegt werden :-))
    $conf['sendmail'][] = 'ids@pragmamx.org'; // Falls das Entwicklerteam ebenfalls benachrichtigt werden soll
    
    // Minimale Lnge des RequestStrings, ab wann SQL-Abfrage berhaupt geprft werden soll
    // Der RequestString beinhaltet alle Variablen die per _GET, _POST und _COOKIE bergeben werden, ausser den Sessioncookies
    $conf['minlen_req'] = 12; #
    
    // Minimale Lnge der SQL-Abfrage, ab wann berhaupt geprft werden soll
    $conf['minlen_sql'] = 15; #
    
    // Session zerstren = logout falls User oder Admin
    $conf['killsession'] = 0;
    
	// IP-Adressen bannen
    // - 0 = kein Banning
    // - 1 = nur bereits gebannte IP-Adressen werden von der Seite ferngehalten
    // - 2 = wenn Angriffe festgestellt werden, wird die entsprechende IP automatisch gebannt
	$conf['ipbanning'] = 0;
    
    // Listendatei der gebannten IP's
    $conf['ipfile'] = PMX_DYNADATA_DIR . '/logfiles/banned.log';
    
	// Nachricht, die erscheint, wenn eine IP-Adresse gebannt ist
    // dies sollte eine komplette HTML-Seite sein
	$conf['ipbanmsg'] = "<html><head><title>banned</title></head><body bgcolor='#DDDDDD'>
		<table width='99%' height='99%' border='10' cellspacing='30' cellpadding='100'>
		<tr align='center' valign='middle'><td>
		<img src='images/logo.gif' alt='" . $GLOBALS['sitename'] . "' border='0'>
		<h2><font color='#800000'>sorry, ip " . MX_REMOTE_ADDR . " is banned from our site</font></h2>
		<h4><br /><a href='mailto:" . mxPrepareToDisplay($GLOBALS['adminmail']) . "'>" . mxPrepareToDisplay($GLOBALS['adminmail']) . "</a></h4>
		</td></tr></table>
		</body></html>";
    
	// logfile der gebannten IP's, die die Seite besuchen
    $conf['visitsfile'] = PMX_DYNADATA_DIR . '/logfiles/banned_visitors.' . date('Y-m-d') . '.log';
    
	
	// / ab hier nichts mehr ndern ;-)
    return $conf;
} 

?>