<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.18.2.11 $
 * $Author: joergk $
 * $Date: 2008/02/02 18:10:26 $
 */

defined('mxMainFileLoaded') or die('access denied');

/**
 * based on
 * SPAW Editor v.2 Config classes
 * @author Alan Mendelevich <alan@solmetra.lt>
 * @copyright UAB Solmetra
 */
class pmxHeader
{
  /**
   * Workaround for "static" class variable under php4
   * @access private
   */
  function &buf()
  {
    static $buf = array();

    return $buf;
  }

  /**
   * Adds code to output buffer
   * @param string $code code for output
   * @static
   */
  function add($code)
  {
    $buf = &pmxHeader::buf();
    if (is_array($code)) {
        foreach ($code as $item) {
            $buf[] = $item;
        }
    } else {
        $buf[] = $code;
    }
  }

  /**
   * Returns content of the output
   * @returns array
   * @static
   */
  function get()
  {
    $buf = &pmxHeader::buf();
    $buf = implode("\n", array_unique($buf));
    return $buf;
  }

  /**
   * Outputs content of the buffer and delete the buffer
   * @returns string
   * @static
   */
  function show()
  {
    // Puffer ausgeben
    echo pmxHeader::get();
    // Puffer loeschen
    $buf = &pmxHeader::buf();
    $buf = array();
  }


  /**
   * set meta description
   * @param string $code code for output
   * @static
   */
    function set_description($description) {
    }

  /**
   * set keywords
   * @param string $code code for output
   * @static
   */
    function set_keywords($keywords) {
    }

}

/**
 * die theme.php des eingestellten Themes includen
 */
function includetheme()
{
    static $themevars;
    if (!isset($themevars)) {
        ob_start();
        $themeok = include_once(MX_THEME_DIR . "/theme.php");
        ob_end_clean();
        if (!$themeok) @die("<br /><b>Error</b>: the theme '" . MX_THEME . "' is corrupted!<br /><br />");
        $themevars = get_defined_vars();
        unset($themevars['GLOBALS'], $themevars['themevars'], $themevars['theme_template'], $themevars['themeok']);
        // mxDebugFuncVars($themevars);
    }
    return $themevars;
}

/**
 * den benoetigten Code fuer die Klasse overlib nur einmal ausgeben
 */
if (!function_exists('printOverlibDiv')) {
    function printOverlibDiv()
    {
        if (!defined('_Overlib_Div')) {
            define('_Overlib_Div', 1);
            pmxHeader::add('<script type="text/javascript" src="includes/javascript/overlib.js"></script>');
            pmxHeader::add('<script type="text/javascript" src="includes/javascript/overlib_hideform.js"></script>');
            include_once('includes/javascript/class.overlib.php');
            echo '<div id="overDiv" style="position: absolute; visibility: hidden; z-index: 1000; background: transparent;"></div>', "\n", '<!-- overLIB (c) Erik Bosrup -->', "\n";
        }
        return true;
    }
}

/**
 * Standard-Fehlerseite
 */
function mxErrorScreen($msg = '', $title = 'Error', $goback = 1)
{
    if (!defined('MX_MODULE')) {
        // falls die Funktion bereits aufgerufen wird, bevor die Konstante
        // definiert ist, z.B. bei Fehlern in der modules.php
        define('MX_MODULE', '');
    }
    if ($title == "Error" && defined('_ERROROCCURS')) {
        $title = _ERROROCCURS;
    }
    $GLOBALS["pagetitle"] = "- $title";
    if (empty($GLOBALS["header"])) {
        include('header.php');
    }
    title($title);
    OpenTableAl();
    echo "<center><span class=\"content\">" . $msg . "<br />";
    if ($goback) echo "<br />" . _GOBACK . "<br />";
    echo "</span></center>";
    CloseTableAl();
    include_once('footer.php');
    die();
}

/**
 * Standard-Meldungsseite
 */
function mxMessageScreen($msg = "", $title = "", $goback = 1)
{
    if ($title) $GLOBALS["pagetitle"] = "- $title";
    if (empty($GLOBALS["header"])) {
        include('header.php');
    }
    if ($title) title($title);
    OpenTable();
    echo "<center><span class=\"content\">" . $msg . "<br />";
    if ($goback) echo "<br />" . _GOBACK . "<br />";
    echo "</span></center>";
    CloseTable();
    include_once('footer.php');
    die();
}

/**
 * Formatierung fuer die Site-Service Message
 */
function mxSiteServiceMessage($message, $width = "60%")
{
    $bgcolor = (empty($GLOBALS['bgcolor1'])) ? "#e9e9e9" : $GLOBALS['bgcolor1'];
    $textcolor = (empty($GLOBALS['textcolor1'])) ? "#cc0033" : $GLOBALS['textcolor1'];
    $out = '
	<!-- START mx_site_message -->
	<table border="0" width="' . $width . '" align="center" cellspacing="2">
	<tr bgcolor="red"><td>
	<table cellspacing="2" cellpadding="5" border="0" width="100%">
	<tr><td align="center" style="background-color: ' . $bgcolor . '; color: ' . $textcolor . '; font-weight: bold;">' . $message . '</td></tr>
	</table></td></tr></table><br />
	<!-- END mx_site_message -->
	';
    return $out;
}

function title($content)
{
    OpenTable();
    echo '<h2 class="title">' . $content . '</h2>';
    CloseTable();
    echo '<br />';
}

function formatAidHeader($aid)
{
    global $prefix;
    static $lastaid;
    if (isset($lastaid) && $aid == $lastaid) {
        echo $lastaid;
        return;
    }
    $lastaid = $aid;
    $result = sql_query("SELECT url, email FROM ${prefix}_authors where aid='" . mxAddSlashesForSQL($aid) . "'");
    if (!is_resource($result)) {
        echo $aid;
        return;
    }
    list($url, $email) = sql_fetch_row($result);
    if (!empty($url)) {
        $aid = "<a href=\"" . mxPrepareToDisplay($url) . "\" target=\"new\">" . $aid . "</a>";
    } else if (!empty($email)) {
        $aid = "<a href=\"mailto:" . mxPrepareToDisplay($email) . "\">" . $aid . "</a>";
    }
    echo $aid;
}

function vkpIpBanning()
{
    global $prefix, $sitename;
    $ban_ip_found = false;
    $GLOBALS['mxSkipSqlDetect'] = true;
    $result = sql_query("SELECT ban_val FROM " . $prefix . "_user_ban WHERE ban_type='ban_ip' AND ban_val='" . MX_REMOTE_ADDR . "'");
    list($ban_val) = sql_fetch_row($result);
    if ($ban_val == MX_REMOTE_ADDR || mxSessionGetVar("blocked")) {
        mxSessionDelVar("user");
        mxSetNukeCookie("user");
        mxSessionDelVar("admin");
        mxSetNukeCookie("admin");
        echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
	"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
		<html><head>
		<title>' . $sitename . '</title>
		</head><body>
		<table width="99%" height="99%" border="2" cellspacing="10" cellpadding="30">
		<tr align="center" valign="middle"><td>
		<h1>' . $sitename . '</h1><br />
		<h2>' . _BANNED . '</h2><br />
		<h3><a href="mailto:' . mxPrepareToDisplay($GLOBALS['adminmail']) . '">' . mxPrepareToDisplay($GLOBALS['adminmail']) . '</a></h3>
		</td></tr></table>
		</body></html>
		';
        die();
    }
}

function mxViewBench()
{
    $vkpendtime = microtime();
    $vkpendtime = explode(" ", $vkpendtime);
    $vkpendtime = $vkpendtime[1] + $vkpendtime[0];
    $difftime = round($vkpendtime - MX_TIME, 4);
    return _VKPBENCH1 . " " . $difftime . " " . _VKPBENCH2 . " " . $GLOBALS["mxQueryCount"] . " " . _VKPBENCH3;
}

function mxThemeShowDate()
{
    $themedate = ""
     . "\n<script type=\"text/javascript\">\n"
     . "\t<!--   // Array ofmonth Names\n"
     . "\tvar monthNames = new Array( \"" . _JANUARY . "\",\"" . _FEBRUARY . "\",\"" . _MARCH . "\",\"" . _APRIL . "\",\"" . _MAY . "\",\"" . _JUNE . "\",\"" . _JULY . "\",\"" . _AUGUST . "\",\"" . _SEPTEMBER . "\",\"" . _OCTOBER . "\",\"" . _NOVEMBER . "\",\"" . _DECEMBER . "\");\n"
     . "\tvar now = new Date();\n"
     . "\tthisYear = now.getYear();\n"
     . "\tif(thisYear < 1900) {thisYear += 1900}; // corrections if Y2K display problem\n"
     . "\tdocument.write(now.getDate() + \". \" + monthNames[now.getMonth()] + \" \" + thisYear);\n"
     . "\t// -->\n"
     . "</script>\n";
    return $themedate;
}

function mxCounter()
{
    global $prefix;
    /* Get the Browser data */
    $agent = "x" . strtolower(MX_USER_AGENT); /// x davor, dass strpos wahr zurueckgibt, wenn Suchstring am Anfang
    // if (strpos($agent, "firefox") || strpos($agent, "firefox")) $browser = "Firefox";
    // else if (strpos($agent, "safari")) $browser = "Safari";
    if (strpos($agent, "konqueror")) $browser = "Konqueror";
    else if (strpos($agent, "gecko") && !strpos($agent, "netscape")) $browser = "Mozilla";
    else if ((strpos($agent, "nav")) || (strpos($agent, "gold")) || (strpos($agent, "x11")) || (strpos($agent, "mozilla")) || (strpos($agent, "netscape")) AND (!strpos($agent, "msie") AND (!strpos($agent, "konqueror")))) $browser = "Netscape";
    else if (strpos($agent, "msie") || strpos($agent, "explorer")) $browser = "MSIE";
    else if (strpos($agent, "lynx")) $browser = "Lynx";
    else if (strpos($agent, "opera")) $browser = "Opera";
    else if (strpos($agent, "webtv")) $browser = "WebTV";
    else if ((strpos($agent, "bot")) || (strpos($agent, "google")) || (strpos($agent, "slurp")) || (strpos($agent, "scooter")) || (strpos($agent, "spider")) || (strpos($agent, "infoseek"))) $browser = "Bot";
    else $browser = "Other";

    if (strpos($agent, "win")) $os = "Windows";
    else if ((strpos($agent, "mac")) || (strpos($agent, "ppc"))) $os = "Mac";
    else if (strpos($agent, "linux")) $os = "Linux";
    else if (strpos($agent, "freebsd")) $os = "FreeBSD";
    else if (strpos($agent, "sunos")) $os = "SunOS";
    else if (strpos($agent, "irix")) $os = "IRIX";
    else if (strpos($agent, "beos")) $os = "BeOS";
    else if (strpos($agent, "os/2")) $os = "OS/2";
    else if (strpos($agent, "aix")) $os = "AIX";
    else $os = "Other";

    sql_query("update ${prefix}_counter set count=count+1 where (type='total' and var='hits') or (var='$browser' and type='browser') or (var='$os' and type='os')");

    $nowDate = (int)Date("d");
    $nowMonth = (int)Date("m");
    $nowYear = (int)Date("Y");
    $nowHour = (int)Date("H");
    $schaltjahr = (int)Date("L");

    $result = sql_query("select count(hour) from ${prefix}_stats where (year='$nowYear') and (month='$nowMonth') and (date='$nowDate')");
    list($c_hour) = sql_fetch_row($result);
    if (empty($c_hour)) {
        for ($z = 0; $z <= 23; $z++) {
            sql_query("REPLACE INTO ${prefix}_stats values('$nowYear','$nowMonth','$nowDate','$z','0')");
        }
    }

    sql_query("update ${prefix}_stats set hits=hits+1 where (year='$nowYear') and (month='$nowMonth') and (date='$nowDate') and (hour='$nowHour')");
}

/* footmsg() sollte im Theme aufgerufen werden */
function footmsg($asVariable = 0, $asTable = 0)
{
    $cspan = 0;
    $out = ($asTable) ? "<table border=\"0\"><tr valign=\"top\">" : "<span class=\"footmsg\">\n";
    for($i = 1; $i <= 4; $i++) {
        if ($GLOBALS['foot' . $i]) {
            $cspan++;
            if (defined($GLOBALS['foot' . $i])) $GLOBALS['foot' . $i] = constant($GLOBALS['foot' . $i]);
            $out .= ($asTable) ? "<td align=\"center\" class=\"footmsg\">" . $GLOBALS['foot' . $i] . "\n</td>" : $GLOBALS['foot' . $i] . "<br />\n";
        }
    }
    // Wurde der co-Link bisher nicht angezeigt, wird er in die footmsg() integriert.
    // Das Entfernen der Zeile verhindert nicht die Ausgabe, kann aber das Layout der Seite zerstoeren.
    $out .= ($asTable) ? "</tr></table>" : "</span>\n";
    if (empty($asVariable)) echo $out;
    return $out;
}

/**
 * ermittelt die verfuegbaren Sprachen
 */
function mxGetAvailableLanguages($folder = 'language')
{
    static $langlist;
    if (isset($langlist)) return $langlist;
    $langlist = array();
    $handle = @opendir($folder);
    if (!$handle) die("<h1>Error: the language-folder (<i>/" . $folder . "</i>) is missing!</h1>");
    while (false !== ($file = readdir($handle))) {
        if (preg_match("#^lang\-(.+)\.php$#", $file, $matches)) {
            $key = ucwords(str_replace("_", " ", str_replace("german", "deutsch", $matches[1])));
            $langlist[$key] = $matches[1];
        }
    }
    closedir($handle);
    if (!count($langlist)) die("<h1>Error: the language-folder (<i>/" . $folder . "</i>) is empty!</h1>");
    ksort($langlist);
    return $langlist;
}

/**
 * erstellt ein <select> Feld zur Auswahl der Sprache
 */
function mxLanguageSelect($selectname, $currentlang, $folder = 'language', $withempty = 0, $morepara = '')
{
    $languageslist = mxGetAvailableLanguages($folder);
    if ($withempty) {
        $languageslist[_ALL] = '';
        ksort($languageslist);
    }
    $clanguage = "";
    foreach($languageslist as $alt => $value) {
        $clanguage .= "<option value=\"" . $value . "\"" . (($value == $currentlang) ? ' selected="selected"' : '') . " >" . $alt . "</option>\n";
    }
    return "<select name=\"" . $selectname . "\" " . $morepara . ">\n" . $clanguage . "</select>\n";
}

/**
 * Datumselect-Gruppe
 *
 * erstellt eine Gruppe von <select> Feldern zur Eingabe eines Datums.
 * pragmamx.org
 *
 * @param string $username
 * @param string $password
 * @tables users, permissions
 * @author Andi
 */
function mxDateSelect($timestamp, $yearname = "year", $monthname = "month", $dayname = "day")
{
    // das Jahr
    // $yearopt = "";
    // $cur = date("Y", time());
    // for ($i = $cur; $i <= $cur + 1; $i++) {
    // $sel = ($i == date("Y", $timestamp)) ? 'selected="selected"' : '';
    // $yearopt .= "<option $sel value=\"$i\">$i\n</option>\n";
    // }
    // $yearopt = "<select name=\"$yearname\">\n$yearopt</select> \n";
    // der Monat
    $month = date("n", $timestamp);
    $monthopt = "";
    for ($i = 1; $i <= 12; $i++) {
        $monthopt .= "<option value=\"$i\"" . (($i == $month) ? 'selected="selected"' : '') . ">$i\n</option>\n";
    }
    $monthopt = "<select name=\"$monthname\">\n$monthopt</select> \n";
    // der Tag
    $day = date("j", $timestamp);
    $dayopt = "";
    for ($i = 1; $i <= 31; $i++) {
        $dayopt .= "<option value=\"$i\"" . (($i == $day) ? 'selected="selected"' : '') . ">$i\n</option>\n";
    }
    $dayopt = "<select name=\"$dayname\">\n$dayopt</select> \n";

    if (_SYS_INTERNATIONALDATES) {
        $out = $dayopt . $monthopt;
    } else {
        $out = $monthopt . $dayopt;
    }
    $out .= '<input type="text" name="' . $yearname . '" value="' . date("Y", $timestamp) . '" size="5" maxlength="4" />';
    return $out;
}

/**
 * header redirect
 */
function mxRedirectMessage($url, $message, $delay = 0)
{
    $themevars = includetheme();
    // alle im theme verfuegbaren Variablen global definieren
    foreach ($themevars as $key => $value) {
        global $$key;
        $$key = $value;
    }
    $favicon = '';
    if (@file_exists('favicon.ico')) {
        $favicon = '<link rel="shortcut icon" href="'. MX_BASE_URL. 'favicon.ico" type="image/x-icon" />';
    }
    $css = '';
    if (file_exists(MX_DOC_ROOT . '/' . MX_THEME_DIR . '/style/style.css')) {
        $css = '<link href="' . MX_THEME_DIR . '/style/style.css" rel="stylesheet" type="text/css" />';
    }

    ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
	"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=<?php echo _CHARSET ?>" />
<meta http-equiv="content-language" content="<?php echo _DOC_LANGUAGE ?>" />
<title><?php echo _REDIRECTMESS3 ?></title>
<?php echo $favicon ?>
<?php echo $css ?>
<meta http-equiv="refresh" content="<?php echo $delay ?>;URL=<?php echo $url ?>" />
</head>
<body bgcolor="<?php echo $bgcolor1 ?>">
<table width="100%" style="height: 85%;">
<tr>
  <td valign="middle">
	  <table border="1" cellspacing="1" cellpadding="10" align="center">
	  <tr>
		<td width="100%" nowrap="nowrap" bgcolor="<?php echo $bgcolor2 ?>">
		  <?php echo $message ?><br /><br /><?php echo _REDIRECTMESS1 ?><br /><br />
	      (<a href="<?php echo $url ?>"><?php echo _REDIRECTMESS2 ?></a>)
	    </td>
	  </tr>
	</table>
  </td>
</tr>
</table>
</body>
</html>
<?php

}

function mxDoctypeArray($doctype = null)
{
    // http://tidy.sourceforge.net/docs/quickref.html#doctype
    $types = array(0 => array('name' => 'HTML 4.01 Transitional, Quirks Mode',
            'value' => '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">',
            'tidy_doctype' => 'transitional',
            'html' => true,
            'xhtml' => false,
            ),
        1 => array('name' => 'HTML 4.01 Transitional, Almost Standards Mode',
            'value' => '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"' . "\n  " . '"http://www.w3.org/TR/html4/loose.dtd">',
            'tidy_doctype' => 'transitional',
            'html' => true,
            'xhtml' => false,
            ),
        2 => array('name' => 'HTML 4.01 Strict, Full Standards Mode',
            'value' => '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN"' . "\n  " . '"http://www.w3.org/TR/html4/strict.dtd">',
            'tidy_doctype' => 'strict',
            'html' => true,
            'xhtml' => false,
            ),
        3 => array('name' => 'XHTML 1.0 Transitional, Almost Standards Mode',
            'value' => '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"' . "\n  " . '"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">',
            'tidy_doctype' => 'transitional',
            'html' => false,
            'xhtml' => true,
            ),
        4 => array('name' => 'XHTML 1.0 Strict, Full Standards Mode',
            'value' => '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"' . "\n  " . '"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">',
            'tidy_doctype' => 'strict',
            'html' => false,
            'xhtml' => true,
            ),
        5 => array('name' => 'XHTML 1.1, Full Standards Mode',
            'value' => '<?xml version="1.0" encoding="' . _CHARSET . '"?>' . "\n" . '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN"' . "\n  " . '"http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">',
            'tidy_doctype' => 'strict',
            'html' => false,
            'xhtml' => true,
            ),
        );
    if ($doctype === null) {
        return $types;
    } else {
        return $types[intval($doctype)];
    }
}

?>