<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.2.2.1 $
 * $Author: tora60 $
 * $Date: 2008/02/01 23:56:11 $
 */

defined('mxMainFileLoaded') or die('access denied');

function resetPmxCache()
{
    /* nur Gott darf das ;) */
    if (!mxGetAdminPref('radminsuper')) {
        mxErrorScreen('<h1>Access Denied</h1>');
        exit;
    }
    error_reporting(E_ALL);
    /* alle Ausgaben abfangen, und spaeter verwerfen */
    ob_start();

    /* Blockcache zuruecksetzen */
    resetBlockCache('dummy_all_for');

    /* Themecache, jpCache, etc. zuruecksetzen */
    $cachedirs = array(
        PMX_DYNADATA_DIR . '/cache',
        MX_DOC_ROOT . '/themecache',
        MX_DOC_ROOT . '/modules/Forum/dynastyles',
        MX_DOC_ROOT . '/modules/Gallery/themes_styles',
        );
    $excludes = array('index.html', 'index.htm', '.htaccess', 'readme.txt');
    foreach ($cachedirs as $dir) {
        $dir = str_replace('/', DIRECTORY_SEPARATOR, $dir);
        if (file_exists($dir)) {
            $handle = opendir($dir);
            while (false !== ($file = readdir($handle))) {
                $filename = $dir . DIRECTORY_SEPARATOR . $file;
                if (is_file($filename) && !in_array($file, $excludes)) {
                    chmod($filename, 0777);
                    $x = unlink($filename);
                    if (!$x) {
                        echo '<li>ERROR: can\'t delete file <b>' . $filename . '</b></li>';
                    }
                }
            }
            closedir($handle);
        }
    }

    /* wenn Debugmodus abgeschaltet, alle Ausgaben verwerfen */
    if (empty($GLOBALS['mxDebugService'])) {
        ob_end_clean();
    }
    
    if ($_SERVER['HTTP_REFERER'] && !strpos($_SERVER['HTTP_REFERER'], 'resetPmxCache')) {
        mxRedirect($_SERVER['HTTP_REFERER'], _RESETPMXCACHEOK, 1);
    } else {
        mxRedirect('admin.php', _RESETPMXCACHEOK, 1);
    }
}

/**
 * cache nur fuer die Bloecke, bzw. einen Block, zuruecksetzen
 */
function resetBlockCache($bid = 0)
{
    global $prefix;
    $qrybid = (intval($bid)) ? ' AND bid=' . intval($bid) . ' ' : '';

    $fields = array();
    $result = mysql_query("SHOW COLUMNS FROM `${prefix}_blocks`");
    while ($row = sql_fetch_assoc($result)) {
        $fields[$row['Field']] = $row;
    }

    $handle = opendir('language');
    while (false !== ($file = readdir($handle))) {
        if (preg_match("/^lang\-(.+)\.php/", $file, $matches)) {
            $field = "cache_" . trim($matches[1]);
            if (isset($fields[$field])) {
                $set[] = " " . $field . "=''";
            }
        }
    }
    closedir($handle);

    if (isset($set)) {
        $sets = implode(", ", $set);
        $qry = "UPDATE ${prefix}_blocks SET " . $sets . " where blockfile<>'' " . $qrybid;
        sql_query($qry);
    }

    if (empty($bid)) {
        if ($_SERVER['HTTP_REFERER'] && !strpos($_SERVER['HTTP_REFERER'], 'resetPmxCache')) {
            mxRedirect($_SERVER['HTTP_REFERER'], _BLOCKDELCACHEOK, 1);
        } else {
            mxRedirect('admin.php?op=BlocksAdmin', _BLOCKDELCACHEOK, 1);
        }
    }
}

?>