<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.10.2.3 $
 * $Author: tora60 $
 * $Date: 2008/01/05 14:00:47 $
 */

defined('mxMainFileLoaded') or die('access denied');

global $dbi, $vkpIntranet;

function mxSessionInit()
{
    global $dbi, $prefix, $vkpIntranet;
    // nur, falls noch nicht bereits aufgerufen...
    if (!defined("MX_SESSION_NAME")) {
        define("MX_SESSION_NAME" , substr("mx" . strtoupper(md5(@MX_USER_AGENT . "s" . MX_BASE_URL)), 0, 32));
        define("MX_SAFECOOKIE_NAME_ADMIN" , substr("mx" . strtoupper(md5(MX_SESSION_NAME . "a")), 0, 32));
        define("MX_SAFECOOKIE_NAME_USER" , substr("mx" . strtoupper(md5(MX_SESSION_NAME . "u")), 0, 32));
        define("MX_SESSION_VARPREFIX" , 'mxSV');
        define("MX_SESSION_DBTABLE" , "${prefix}_sys_session");
        define("MX_SESSION_GARBAGE" , 10);
        /**
         * Session-Konfiguration
         * DIESE WERTE BITTE NUR VERAENDERN, WENN SIE WISSEN WAS SIE TUN !!
         * weitere Informationen:
         * - http://www.dclp-faq.de/ch/ch-version4_session.html
         * - http://www.php.net/manual/de/ref.session.php
         */
        @ini_set("session.auto_start" , '0'); // Auto-start session
        @ini_set("session.gc_probability" , MX_SESSION_GARBAGE); // Garbage collection in %
        @ini_set("session.serialize_handler", 'php'); // How to store data
        @ini_set("session.use_cookies" , '1'); // Use cookie to store the session ID
        @ini_set("session.gc_maxlifetime" , MX_SESSION_LIFETIME); // Sekunden Inactivity timeout for user sessions
        @ini_set("url_rewriter.tags" , ''); // verhindern, dass SID an URL gehaengt wird
    }
    session_name(MX_SESSION_NAME); // zur Sicherheit, falls ini_set() deaktiviert
    if (empty($vkpIntranet)) {
        session_set_cookie_params(MX_COOKIE_LIFETIME, MX_COOKIE_PATH, MX_COOKIE_DOMAIN);
    } else {
        session_set_cookie_params(MX_COOKIE_LIFETIME, MX_COOKIE_PATH);
    }
    if (MX_PHP_VERSION >= 430) {
        @ini_set('session.use_only_cookies', '1'); // Use only cookie to store the session ID
        @ini_set('session.cookie_httponly' , '1'); // Whether or not to add the httpOnly flag to the cookie, which makes it inaccessible to browser scripting languages such as JavaScript.
    }
    /**
     * ENDE Session-Konfiguration
     */
    session_module_name('user');
    session_set_save_handler("mx_sys_session_open",
        "mx_sys_session_close",
        "mx_sys_session_read",
        "mx_sys_session_write",
        "mx_sys_session_destroy",
        "mx_sys_session_gc");
}

function mx_sys_session_open($spath, $sname, $pers = false)
{
    global $dbi;
    // wenn bereits Datenbankverbindung besteht....
    if (is_resource($dbi)) return true;
    // ansonsten, Verbindung herstellen
    $dbi = @mysql_connect($GLOBALS['dbhost'], $GLOBALS['dbuname'], $GLOBALS['dbpass']);
    $ok = sql_select_db($dbi);
    return $ok;
}

function mx_sys_session_read($sesskey)
{
    global $dbi;
    // bei neuer Session braucht nicht gelesen zu werden
    if (defined('MX_SESSION_NEWSESS')) {
        define('MX_SESSION_CRCSESS', '');
        return '';
    }
    // sessionkey auf Gueltigkeit testen: nur Buchstaben und Zahlen, genau 32 Zeichen lang
    if (!preg_match('#^[[:alnum:]]{32}$#', $sesskey)) die('unaccepted Sessionkey: ' . $sesskey);
    $isdb = @mysql_select_db($GLOBALS['dbname'], $dbi);
    $qry = "SELECT sesskey, data FROM " . MX_SESSION_DBTABLE . " WHERE sesskey = '" . $sesskey . "' AND expiry >= " . time();
    $result = @mysql_query($qry, $dbi);
    if (is_resource($result)) {
        list($sess, $data) = mysql_fetch_row($result);
        @mysql_free_result($result);
        $data = (empty($data)) ? "" : rawurldecode($data);
        if (!defined('MX_SESSION_CRCSESS')) {
            define('MX_SESSION_CRCSESS', (empty($sess)) ? "" : $sess);
        }
        return $data;
    } else {
        $msg = str_replace($GLOBALS['prefix'], '{prefix}', strtolower("<div style=\"background-color: Red; color: Yellow; border: thin solid Black;\"><h1>Error:</h1><p>" . mysql_error() . "</p></div>"));
        $msg = str_replace(strtolower($GLOBALS['dbname']), '{dbname}', $msg);
        if (function_exists('mxpro_dberror')) {
            mxpro_dberror($msg);
        } else {
            echo $msg;
        }
        return false;
    }
}

function mx_sys_session_write($sesskey, $data)
{
    global $dbi;
    // sessionkey auf Gueltigkeit testen: nur Buchstaben und Zahlen, genau 32 Zeichen lang
    if (!preg_match('#^[[:alnum:]]{32}$#', $sesskey)) die('unaccepted Sessionkey: ' . $sesskey);
    $isdb = @mysql_select_db($GLOBALS['dbname'], $dbi);
    $timeadd = (mxSessionGetVar('user') || mxSessionGetVar('admin')) ? MX_SESSION_LIFETIME : MX_SESSION_LIFETIME_NOUSER;
    $expiry = time() + $timeadd;
    $is_sess = (defined('MX_SESSION_CRCSESS')) ? (MX_SESSION_CRCSESS == $sesskey) : false;
    $data = rawurlencode($data);
    if ($is_sess) {
        $qry = "UPDATE `" . MX_SESSION_DBTABLE . "` SET expiry = " . $expiry . ", data='" . $data . "' WHERE sesskey='" . $sesskey . "' AND expiry >= " . time();
    } else {
        $qry = "REPLACE INTO `" . MX_SESSION_DBTABLE . "` ( `sesskey`, `expiry`, `data` ) VALUES ('" . $sesskey . "', " . $expiry . ", '" . $data . "')";
    }
    $result = @mysql_query($qry, $dbi);
    return !empty($result);
}

function mx_sys_session_close()
{
    global $dbi;
    @mysql_close($dbi);
    unset($dbi);
    return true;
}

function mx_sys_session_destroy($sesskey)
{
    global $dbi;
    // sessionkey auf Gueltigkeit testen: nur Buchstaben und Zahlen, genau 32 Zeichen lang
    if (!preg_match('#^[[:alnum:]]{32}$#', $sesskey)) die('unaccepted Sessionkey: ' . $sesskey);
    $isdb = @mysql_select_db($GLOBALS['dbname'], $dbi);
    $qry = "DELETE FROM " . MX_SESSION_DBTABLE . " WHERE sesskey = '" . $sesskey . "' OR expiry < " . time();
    $result = mysql_query($qry, $dbi);
    return $result ? true : false;
}

function mx_sys_session_gc($maxlifetime)
{
    global $dbi;
    $isdb = @mysql_select_db($GLOBALS['dbname'], $dbi);
    $qry = "DELETE FROM " . MX_SESSION_DBTABLE . " WHERE expiry < " . time();
    @mysql_query($qry, $dbi);
    $opt_qry = 'OPTIMIZE TABLE ' . MX_SESSION_DBTABLE;
    @mysql_query($opt_qry, $dbi);
    return true;
}

/**
 * Initialise session
 */
function mxSessionStart()
{
    global $dbi;
    if (isset($GLOBALS['mxWithoutSession']) && !isset($_REQUEST['mxWithoutSession'])) {
        return true;
    }
    /**
     * Session initialisieren
     */
    mxSessionInit();
    // Testen ob bereits ein HTML-Header gesendet wurde
    if (MX_PHP_VERSION >= 430) {
        if (headers_sent($filename, $linenum)) {
            echo "<br><br>Headers already sent in " . str_replace(MX_DOC_ROOT, '', $filename) . " on line $linenum<br><br>";
            return false;
        }
    } else {
        if (headers_sent()) {
            echo "<br><br>Headers already sent<br><br>";
            return false;
        }
    }
    // wenn kein Session-Cookie vorhanden, eine neue Session-ID generieren
    // dabei aber pruefen, ob die neue ID nicht schon in der db vorhanden ist
    if (!isset($_COOKIE[MX_SESSION_NAME])) {
        session_id(mxGetNewSessionId());
        define('MX_SESSION_NEWSESS', '1');
    }
    // wenn unerlaubte Zeichen in der uebermittelten Session-ID vorhanden sind,
    // ebenfalls, eine neue Session-ID generieren
    else if (!preg_match('#^[[:alnum:]]{32}$#', $_COOKIE[MX_SESSION_NAME])) {
        session_id(mxGetNewSessionId());
    }
    $sess = session_start();
    return $sess;
}

/**
 * eine neue Session-ID generieren
 * dabei aber pruefen, ob die neue ID nicht schon in der db vorhanden ist
 */
function mxGetNewSessionId()
{
    global $dbi;
    $dbi = @mysql_connect($GLOBALS['dbhost'], $GLOBALS['dbuname'], $GLOBALS['dbpass']);
    $ok = sql_select_db($dbi);
    mt_srand((double)microtime() * 1000000);
    $i = 0;
    do {
        $i++;
        $newsess = md5(uniqid(mt_rand(), true));
        $qry = "SELECT sesskey, expiry FROM " . MX_SESSION_DBTABLE . " WHERE sesskey = '" . $newsess . "'";
        $result = @mysql_query($qry, $dbi);
        list($sesskey, $expiry) = @mysql_fetch_row($result);
        if (empty($sesskey) || $expiry < time()) {
            if ($expiry < time()) {
                $qry = "DELETE FROM " . MX_SESSION_DBTABLE . " WHERE expiry < " . time();
                @mysql_query($qry, $dbi);
            }
        }
    } while (!empty($sesskey) && $i < 6);
    return $newsess;
}

?>