<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.30.2.13 $
 * $Author: tora60 $
 * $Date: 2008/02/02 10:41:29 $
 */

defined('mxMainFileLoaded') or die('access denied');

/**
 * Versionsinformation
 */
define('PMX_VERSION', '0.1.10');
define('MX_VERSION', 'pragmaMx ' . PMX_VERSION);
// ////////////////////////////////////////////////////////////////////////////////
// ACHTUNG!! wird automatisch aus dem CVS-Header generiert !
@ $subrelease = "\$Id: mx_system.php,v 1.30.2.13 2008/02/02 10:41:29 tora60 Exp $";
@ preg_match('#v ([0-9\.]{2,})\s([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})#', $subrelease, $regs);
@ define("MX_VERSION_SUB", "$regs[1]/$regs[2]-$regs[3]-$regs[4]");
unset ($subrelease, $regs);
// ////////////////////////////////////////////////////////////////////////////////
@ ini_set("gpc_order", "GPCS"); // ohne Environment, kann ueber getenv() abgefragt werden
@ ini_set("magic_quotes_runtime", "0");
set_magic_quotes_runtime(0);
@ ini_set("magic_quotes_sybase", "0");

$GLOBALS['nukeurl'] = MX_HOME_URL;
$mxDemoMode = intval($GLOBALS['mxDemoMode']);
// die Variable mxSkipSqlDetect deklarieren, sie kann verwendet, um bei
// bestimmten Datenbankanfragen den sql_injection Schutz abzuschalten,
// z.B. bei allen Abfragen, wo keine Benutzereingaben ausgewertet werden
// Sie wird in der Funktion sql_query immer wieder auf FALSE gesetzt
global $mxSkipSqlDetect;
$mxSkipSqlDetect = false;

$GLOBALS['mxSecureKey'] = (isset ($GLOBALS['mxSecureKey'])) ? $GLOBALS['mxSecureKey'] : md5($GLOBALS['dbuname'] . '%#f4S' . __file__);

/**
 */
function mxSiteService($SiteServiceWidth = "60%")
{
    // Display SiteService
    if ($GLOBALS['mxSiteService'] && !empty ($GLOBALS['mxSiteServiceText'])) {
        echo mxSiteServiceMessage(mxNL2BR($GLOBALS['mxSiteServiceText']), $SiteServiceWidth);
    }
    // Display DebugService
    if ($GLOBALS['mxDebugService'] && MX_IS_ADMIN) {
        echo "\n<!-- START mx_debug_message -->\n" . "<div style=\"background-color: " . $GLOBALS['bgcolor1'] . "; color: " . $GLOBALS['textcolor1'] . "; padding: 5px;\"><b>" . MX_VERSION . " Debug-Mode</b>, PHP Error-Reporting (E_ALL) enabled";
        if (count($_GET)) {
            echo "<pre>GET: ";
            print_r($_GET);
            echo "</pre>";
        }
        if (count($_POST)) {
            echo "<pre>POST: ";
            print_r($_POST);
            echo "</pre>";
        }
        echo "</div>\n<!-- END mx_debug_message -->\n";
    }
}

/**
 * Online aktualisieren
 */
function online()
{
    global $prefix, $user_prefix;
    static $done;
    if (isset ($done))
        return true;
    $done = true;
    $past = time() - MX_SETINACTIVE_MINS;
    $lasttime = mxSessionGetVar('lasttime');
    $lastday = (time() - 86400);
    $url = preg_replace('#^' . dirname($_SERVER['PHP_SELF']) . '/#', '', $_SERVER['REQUEST_URI']);
    if ($lasttime < $lastday && $lasttime > 0) {
        $GLOBALS['mxSkipSqlDetect'] = true;
        sql_query("DELETE FROM " . $prefix . "_visitors
                WHERE (time < " . ($lastday * 10) . " AND uid <> 0)
                OR (time < " . ($lastday) . " AND uid=0)
                OR (time > " . (time() + 60) . ")
                ");
    }

    if (defined('mxModFileLoaded') && defined('MX_MODULE')) {
        if (mxModFileLoaded == 2) {
            // die index.php geladen
            $module = 'Home';
            $url = 'index.php';
        } else {
            // die modules.php geladen
            $module = MX_MODULE;
        }
    } else {
        $module = $url;
        if (defined('mxAdminFileLoaded')) {
            // die admin.php geladen
            $module = 'Admin';
        } else if (preg_match('#^(.+)\.php#i', $url, $matches)) {
            $module = $matches[1];
        }
        if (empty ($module) || $module == 'index' || $url == '/') {
            $module = 'Home';
            $url = 'index.php';
        }
    }
    // falls gerade ein Formular gesendet wurde und evtl. nicht alle Parameter in der url stehen..
    if ($_SERVER['REQUEST_METHOD'] == 'POST') {
        if (defined('mxModFileLoaded') && defined('MX_MODULE')) {
            $url = 'modules.php?name=' . MX_MODULE;
        }
    }

    if ($lasttime < $past || mxSessionGetVar("lastmodu") != $module) {
        mxSessionSetVar("lasttime", time());
        mxSessionSetVar("lastmodu", $module);
        $url = mxAddSlashesForSQL(htmlentities($url));
        $url = substr($url, 0, 255);
        if (MX_IS_USER) {
            $usersession = mxGetUserSession();
            $uid = intval($usersession[0]);
            $qry = "UPDATE ${user_prefix}_users set user_lastvisit=" . time() . ", user_lastmod='" . $module . "', user_lasturl='" . $url . "', user_lastip='" . MX_REMOTE_ADDR . "' where uid=" . $uid;
            $GLOBALS['mxSkipSqlDetect'] = true;
            $result = sql_query($qry);
        } else {
            $uid = 0;
        }
        // visitor-tabelle aktualisieren
        $GLOBALS['mxSkipSqlDetect'] = true;
        sql_query("UPDATE ${prefix}_visitors set uid=" . $uid . ", time=" . time() . ", module='" . $module . "', url='" . $url . "', ip='" . MX_REMOTE_ADDR . "' where ip='" . MX_REMOTE_ADDR . "'");
        if (!MX_IS_USER && !sql_affected_rows()) {
            $GLOBALS['mxSkipSqlDetect'] = true;
            sql_query("REPLACE INTO ${prefix}_visitors (time,ip,module,url,uid) VALUES (" . time() . ",'" . MX_REMOTE_ADDR . "','" . $module . "','" . $url . "'," . $uid . ")");
        }
    }
}

/**
 * HTTP-Referer Funktion
 */
function mxReferer()
{
    global $prefix;
    if (empty ($GLOBALS['httprefmax'])) {
        // referer abgeschaltet
        return;
    }
    if (empty ($_SERVER['HTTP_REFERER'])) {
        // kein referer
        return;
    }
    $ref = parse_url($_SERVER['HTTP_REFERER']);
    if (empty ($ref['host']) || empty ($ref['scheme'])) {
        // gefakter referer
        return;
    }
    if (empty ($ref['path'])) {
        $ref['path'] = '';
    } else {
        // nur den Pfad der URL extrahieren und gleich den letzten slash entfernen, Ergebnis in $x[1]
        preg_match('#(.*)/[^/]*#', $ref['path'], $x);
        if (isset($x[1])) {
            $ref['path'] = $x[1];
        }
    }

    $self = parse_url(PMX_HOME_URL . '/index.php');

    if (empty ($self['path'])) {
        $self['path'] = '';
    } else {
        preg_match('#(.*)/[^/]*#', $self['path'], $x);
        if (isset($x[1])) {
            $self['path'] = $x[1];
        }
    }
    // referer von eigener Seite
    if (preg_replace('#^www\.#i', '', $ref['host']) == preg_replace('#^www\.#i', '', $self['host'])) {
        /**
         * Pfade noch ueberpruefen
         * - wenn Serverpfad leer
         * - wenn Refererpfad leer
         * - wenn die Pfade gleich sind
         * - wenn Serverpfad in Refererpfad am Anfang enthalten ist
         * - wenn Refererpfad in Serverpfad am Anfang enthalten ist
         * dann diesen Referer nicht notieren
         */
        if (!$self['path'] || !$ref['path'] || $ref['path'] === $self['path'] || (strpos($ref['path'] . 'x', $self['path'] . 'x') === 0) || (strpos($self['path'] . 'x', $ref['path'] . 'x') === 0)) {
            return;
        }
    }
    // referer die unerwuenscht sind, ignorieren
    if (@file_exists('admin/.ignore_referer')) {
        $ignore = file_get_contents('admin/.ignore_referer');
        $ignore = preg_split('#\s*,\s*#m', trim($ignore));
        if (in_array($_SERVER['HTTP_REFERER'], $ignore) || in_array($ref['host'], $ignore)) {
            return;
        }
    }

    $now = time();
    $GLOBALS['mxSkipSqlDetect'] = true;
    $result = sql_query("select min(rid), avg(rid), count(rid) from " . $prefix . "_referer");
    list ($min, $avg, $count) = sql_fetch_row($result);
    if ($count >= $GLOBALS["httprefmax"]) {
        $olderror = $GLOBALS["mxSqlErrorDebug"];
        $GLOBALS["mxSqlErrorDebug"] = false;
        sql_query("UPDATE " . $prefix . "_referer SET rid='" . $now . "', url='" . mxAddSlashesForSQL($_SERVER['HTTP_REFERER']) . "' WHERE rid = " . $min . " LIMIT 1");
        $GLOBALS["mxSqlErrorDebug"] = $olderror;
        if ($count > $GLOBALS["httprefmax"]) {
            $GLOBALS['mxSkipSqlDetect'] = true;
            sql_query("DELETE FROM " . $prefix . "_referer WHERE rid < " . $avg);
        }
    } else {
        sql_query("REPLACE INTO " . $prefix . "_referer (rid, url) values (" . $now . ",'" . mxAddSlashesForSQL($_SERVER['HTTP_REFERER']) . "')");
    }
}

/**
 */
function mxSecureLog($log_eventid, $log_event, $withdata = 0)
{
    if (empty ($GLOBALS["vkpsec_logging"]))
        return;
    global $prefix;
    $aid = "";
    $uname = "";
    if (MX_IS_USER) {
        $usersession = mxGetUserSession();
        @ $uname = $usersession[1];
    }
    if (MX_IS_ADMIN) {
        extract(mxGetAdminSession()); ;
    }
    $data = (empty ($withdata)) ? "" : serialize($_REQUEST);
    $qry = "INSERT INTO ${prefix}_securelog
						(log_ip, log_time, log_eventid, log_event, uname, aid, request) VALUES
						('" . MX_REMOTE_ADDR . "', " . time() . ", '" . mxAddSlashesForSQL($log_eventid) . "', '" . mxAddSlashesForSQL($log_event) . "', '" . mxAddSlashesForSQL($uname) . "', '" . mxAddSlashesForSQL($aid) . "', '" . mxAddSlashesForSQL($data) . "')";
    $GLOBALS['mxSkipSqlDetect'] = true;
    sql_query($qry);
}

/**
 * sets a cookie to test the session-ID
 */
function mxSessionSafeCookie($CookieName, $inout)
{
    $type = ($CookieName == MX_SAFECOOKIE_NAME_ADMIN) ? 2 : 1;
    if ($GLOBALS["vkpSafeCookie" . $type]) {
        mt_srand((double) microtime() * 1000000);
        $checkId = mt_rand();
        $check = ($inout == 1) ? md5($checkId) : "";
        $CookieTime = ($inout == 1) ? 1 : -1;
        mxSetCookie($CookieName, $check, $CookieTime);
        mxSessionSetVar("ck" . $type, $checkId);
        $_COOKIE[$CookieName] = $check;
    }
    return true;
}

/**
 */
function mxGetAllBlocks($side)
{
    global $prefix;
    static $allblocks; // statisches Array
    if (!isset ($allblocks)) { // wenn statisches Array noch nicht initialisiert
        $allblocks = array (); // statisches Array initialisieren
        // Spracheinstellung fuer qry
        $querylang = ($GLOBALS["multilingual"]) ? "(blanguage='" . $GLOBALS["currentlang"] . "' OR blanguage='')" : "active = 1";
        if (MX_IS_USER) { // ist User ?
            $userinfo = mxGetUserData(); // gesamte Userdaten in Array lesen
            $user_acl = (int) $userinfo["user_ingroup"]; // Gruppenzugehoerigkeit auslesen
        }
        $user_acl = (empty ($user_acl)) ? 1 : $user_acl; // Gruppenzugehoerigkeit nur bei angemeldeten
        // rechte Bloecke von der Abfrage ausschliessen, wenn $index = 0
        $queryindex = (empty ($GLOBALS["index"])) ? 0 : 1;
        $queryindex = ($queryindex) ? "" : "AND (position <> 'r')";
        $queryhome = (empty ($GLOBALS["home"])) ? "AND position NOT IN('c','d')" : "";
        // linke Bloecke von der Abfrage ausschliessen, wenn $hide_left = 0
        $queryindex_l = (empty ($GLOBALS["hide_left"])) ? 0 : 1;
        $queryindex_l = ($queryindex_l) ? "AND (position <> 'l')" : "";
        // print ($queryindex);
        // die Mitteilungen fuer die Startseite in Array stellen
        $allmessages = (empty ($queryhome)) ? vkpGetMessages() : array ();
        // die (nuke) Standardblockberechtigungen feststellen und in ein array stellen
        $query_view[] = "(view = 0)"; // Alle Besucher
        // if (MX_IS_USER)  $query_view[] = "(view = 1 AND ${prefix}_groups_blocks.group_id=".$user_acl.")"; // Nur angemeldete Benutzer
        // if (MX_IS_USER)  $query_view[] = "(view = 1)"; // Nur angemeldete Benutzer
        if (MX_IS_ADMIN)
            $query_view[] = "(view = 2)"; // Nur Administratoren
        if (!MX_IS_USER)
            $query_view[] = "(view = 3)"; // Nur Anonyme Benutzer
        if (MX_IS_USER) {
            $qry = "SELECT block_id FROM ${prefix}_groups_blocks WHERE (group_id=" . intval($user_acl) . ")";
            $GLOBALS['mxSkipSqlDetect'] = true;
            $result = sql_query($qry);
            if (is_resource($result)) { // wenn erfolgreich
                while (list ($bid) = sql_fetch_row($result)) {
                    if ($bid)
                        $bids[] = $bid;
                }
            }
            sql_free_result($result);
            if (isset ($bids)) {
                $query_view[] = "(view = 1 AND bid in(" . implode(",", $bids) . "))";
            }
        }
        // aus dem array mit Berechtigungen eine Abfragebedingung konstruieren
        $queryview = implode(" OR ", $query_view);
        // die aus den Bedingungen zusammengesetzte SQL-Abfrage
        $qry2 = "SELECT * FROM ${prefix}_blocks
						WHERE (active=1) AND ($querylang) AND ($queryview) $queryindex $queryindex_l $queryhome
						ORDER BY position, weight ASC";
        // print $qry2;
        $GLOBALS['mxSkipSqlDetect'] = true;
        $result2 = sql_query($qry2); // sql ausfuehren
        if (is_resource($result2)) { // wenn erfolgreich
            $lastpos = ""; #$i=0;
            // Schleife, alle Blockdaten in array lesen
            while ($block = sql_fetch_assoc($result2)) {
                // ueberfluessige numerische Schluessel entfernen um Speicher zu sparen
                // foreach ($block as $key => $value) {
                // if(is_numeric($key)) unset($block[$key]);
                // }
                // den Inhalt und weitere Daten aus dem includeten blockfile bzw. cache  holen
                $block = mxGetBlockData($block);
                // wenn kein Blockinhalt, Schleife fortsetzen
                if (empty ($block['content']))
                    continue;
                // wenn eine andere Position, den Zaehler der Reihenfolge zuruecksetzen
                if ($block["position"] != $lastpos) {
                    $lastpos = $block["position"];
                    $i = (count($allmessages) && $block["position"] == "c") ? count($allmessages) : 0;
                    // $i = 0;
                }
                // Arrayschluessel 'order' mit diesem Wert belegen
                $block['order'] = $i;
                // jetzt endlich das statische Array mit den Blockdaten fuellen
                if ($block["position"] == 'r') {
                    // bei den rechten bloecken, unterscheiden zwischen den News- und Normalen-Bloecken
                    $isstoryblock = mxIsNewsBlockfile($block['blockfile']);
                    if ((!empty ($GLOBALS['story_blocks']) && $isstoryblock) || (empty ($GLOBALS['story_blocks']) && !$isstoryblock)) {
                        // print $block['blockfile']." = ".$block["position"]." = ".$isstoryblock."<br>";
                        $allblocks['r'][$i] = $block;
                    }
                } else {
                    $allblocks[$block["position"]][$i] = $block;
                }
                // den Zaehler der Reihenfolge erhoehen
                $i ++;
            }
            sql_free_result($result2);
        }
        // die Messages in die CenterBloecke einschleifen
        if (count($allmessages)) {
            // print ("<h1>Hallo</h1>");
            $allblocks["c"] = (isset ($allblocks["c"])) ? array_merge($allmessages, $allblocks["c"]) : $allmessages;
        }
    }
    if (isset ($allblocks[$side])) {
        // wenn Bloecke fuer diese Seite vorhanden, diese als Array zurueckgeben
        return $allblocks[$side];
    } else {
        // ansonsten ein leeres Array zurueckgeben
        return array ();
    }
}

/**
 */
function mxCacheBlocks($block)
{
    global $prefix;
    static $stat_langfield, $stat_langfound;
    $seperator = "@#!@";
    // aktuelle Sprache statisch speichern, falls ein Block die Variable $currentlang aendert
    if (!isset ($stat_langfield)) {
        // wenn multilingual abgeschaltet, das normale Feld content verwenden
        $stat_langfield = ($GLOBALS['multilingual']) ? "cache_" . trim($GLOBALS['currentlang']) : "content";
    }
    // wenn der Cache fuer die Sprache bereits vorhanden und Cache aktiviert
    if (!empty ($block[$stat_langfield]) && $block["refresh"]) {
        // den codierten Cachestring zerlegen
        $blockcontent = explode($seperator, $block[$stat_langfield]);
        $block["utime"] = (int) $blockcontent[0];
        if (isset($blockcontent[1])) {
            $block["title"] = base64_decode($blockcontent[1]);
            $block["content"] = base64_decode($blockcontent[2]);
        }
    } else {
        // wenn nicht, die letzte Aktualisierungszeit auf 0 setzen
        $block["utime"] = 0;
    }
    // feststellen ob der Cache aktualisiert werden muss
    $cachenew = (($block["utime"] <= time() && $block["refresh"]) || !isset ($block[$stat_langfield]));
    // wenn Cache aktualisiert werden muss und Cache aktiviert
    if (!$block["refresh"] || $cachenew || empty ($block[$stat_langfield])) {
        // blockfile includen
        include ("blocks/" . $block["blockfile"]);
        // die Variablen des Blocks in das Blockarray einlesen
        $block["title"] = (empty ($blockfiletitle)) ? $block["title"] : $blockfiletitle;
        $block["content"] = (empty ($content)) ? "" : $content;
        // die Variable $mxblockcache (aus dem blockfile) entscheidet, ob der Block gecached werden darf
        $mxblockcache = (isset ($mxblockcache)) ? $mxblockcache : false;
        // wenn der Block nicht gecached werden darf oder caching nicht aktiviert
        if (!$mxblockcache || !$block["refresh"]) {
            // / den Cache fuer die aktuelle Sprache loeschen, falls vorhanden
            if (!empty ($block[$stat_langfield]) && !$block["refresh"]) {
                $GLOBALS['mxSkipSqlDetect'] = true;
                sql_query("update `${prefix}_blocks` set `refresh` = 0 , `time` = 0 , `" . $stat_langfield . "` ='' WHERE bid = " . $block["bid"] . ";");
            }
            // / das Blockarray mit den Variablen des Blocks direkt ausgeben
            return $block;
        }
        // Variable $mxblockcache wieder zuruecksetzen
        $mxblockcache = false;
        // wenn das caching-Feld fuer diese Sprache noch nicht in der Tabelle
        if (!isset ($stat_langfound)) {
            $stat_langfound = isset ($block[$stat_langfield]);
            if (!$stat_langfound) {
                // / Das entsprechende Feld in der Tabelle erstellen
                $GLOBALS['mxSkipSqlDetect'] = true;
                $result = sql_query("ALTER TABLE `${prefix}_blocks` ADD `" . $stat_langfield . "` TEXT NOT NULL ;");
                // / Die statische Variable $stat_langfound verhindert, dass die Tabelle mehrmals geaendert wird
                if ($result) {
                    $stat_langfound = true;
                }
            }
        }
        // Wenn das caching-Feld fuer diese Sprache vorhanden ist
        if ($stat_langfound == true) {
            // / die Variablen des blockfiles und die naechste Refreshzeit (fuer diese Sprache)
            // / in dem caching-Feld speichern
            // / die base64 codierung wird benoetigt, weil im Blockfile Backslashes von Javascript-Funktionen
            // / enthalten sein koennen, die beim normalen Speichern und auslesen verloren gingen
            $blockcontent[0] = time() + (int) $block["refresh"];
            $blockcontent[1] = base64_encode($block["title"]);
            $blockcontent[2] = base64_encode($block["content"]);
            $blockcontent = implode($seperator, $blockcontent);
            $qry = "update `${prefix}_blocks` set `" . $stat_langfield . "` ='" . $blockcontent . "' WHERE bid = " . $block["bid"] . ";";
            $GLOBALS['mxSkipSqlDetect'] = true;
            $result_update = sql_query($qry);
        }
    }
    // das neu erstellte Blockarray zurueckgeben....
    return $block;
}

/**
 */
function vkpGetMessages()
{
    global $bgcolor1, $bgcolor2, $textcolor2, $prefix;
    $querylang = ($GLOBALS['multilingual'] == 1) ? " AND (mlanguage='" . $GLOBALS["currentlang"] . "' OR mlanguage='')" : "";
    $qry = "select mid, title, content, `date`, expire, view
		        FROM " . $prefix . "_message
						WHERE active=1
						AND title <> ''
						AND content <> ''
						" . $querylang . "
						ORDER BY `date` DESC";
    $GLOBALS['mxSkipSqlDetect'] = true;
    $result = sql_query($qry);
    if (!$result) {
        return;
    }
    $i = 0;
    $allmessages = array ();
    while (list ($mid, $title, $content, $mdate, $expire, $view) = sql_fetch_row($result)) {
        if (empty ($expire)) {
            $remain = _UNLIMITED;
        } else {
            $etime = (($mdate + $expire) - time()) / 3600;
            $etime = (int) $etime;
            if ($etime < 1) {
                $remain = _EXPIRELESSHOUR;
            } else {
                $remain = _EXPIREIN . " $etime " . _HOURS;
            }
        }
        if ($view == 4) { // nur Admins
            $viewfor = _MVIEWADMIN;
            $showit = MX_IS_ADMIN;
        } elseif ($view == 3) { // nur anonyme
            $viewfor = _MVIEWANON;
            $showit = (!MX_IS_USER);
        } elseif ($view == 2) { // nur angemeldete User
            $viewfor = _MVIEWUSERS;
            $showit = MX_IS_USER;
        } elseif ($view == 1) { // alle
            $viewfor = _MVIEWALL;
            $showit = 1;
        }
        if ($showit) {
            $content .= '<br>';
            if ($viewfor && MX_IS_ADMIN) {
                $content .= '<div align="right"><br><span class="tiny">[ ' . $viewfor . ' - ' . $remain . ' - <a href="admin.php?op=editmsg&amp;mid=' . $mid . '">' . _EDIT . '</a>&nbsp;]</span></div>';
            }
            $allmessages[$i]["title"] = $title;
            $allmessages[$i]["content"] = $content;
            $allmessages[$i]["position"] = "c";
            $allmessages[$i]["weight"] = $i;
            $allmessages[$i]["order"] = $i;
            $i ++;
        }
        if ($expire != 0) {
            $past = time() - $expire;
            if ($mdate < $past) {
                $GLOBALS['mxSkipSqlDetect'] = true;
                sql_query("UPDATE " . $prefix . "_message SET active=0 WHERE mid=" . intval($mid));
            }
        }
    }
    return $allmessages;
}

/**
 */
function render_blocks($block)
{
    if (!isset ($block['order']))
        $block['order'] = $block['weight'];
    if ($block["position"] == "c" || $block["position"] == "d") {
        themecenterbox($block["title"], $block["content"], $block);
    } else {
        themesidebox($block["title"], $block["content"], $block);
    }
    // }
}

/**
 */
function blocks($side)
{
    $side = strtolower($side[0]); // Uebergabeparameter in den ersten Kleinbuchstaben umwandeln
    $blocks = mxGetAllBlocks($side); // statisches Blockarray fuer diese Seite abholen
    // wenn array leer, Funktion beenden
    if (empty($blocks)) {
        return;
    }
    // in Schleife alle Bloecke fuer diese Seite ausgeben
    foreach ($blocks as $block) {
        render_blocks($block);
    }
}

/**
 * Gibt Copyright-Informationen aus
 */
function mxInfo()
{
    $intro = getcredithtml();
    if (!defined('DIR_mod_root'))
        define('DIR_mod_root', 'modules'); /// fuer pragma pmx's
    $design_info = "";
    $handle = @ opendir('themes');
    if ($handle) {
        while (false !== ($file = readdir($handle))) {
            if ((!ereg("[.]", $file)) && (!ereg("[CVS]{3}", $file))) {
                unset ($credits);
                $show = @ file_exists('themes/' . $file . '/setup.pmx.php');
                if ($show || MX_IS_ADMIN) {
                    $design_info .= '<br><p class="title">' . $file . '</p>';
                }
                if ($show) {
                    include ('themes/' . $file . '/setup.pmx.php');
                    if (!empty ($credits)) {
                        $credits = " " . strip_tags($credits);
                        $credits = preg_replace('/&(?![a-zA-Z]{2,6};|#[0-9]{2,3};)/', '&amp;', $credits);
                        $credits = preg_replace("#([\n ])([a-z]+?)://([^, \n\r]+)#i", "\\1 <a href=\"\\2://\\3\" target=\"_blank\">\\2://\\3</a> ", $credits);
                        $credits = preg_replace("#([\n ])www\.([a-z0-9\-]+)\.([a-z0-9\-.\~]+)((?:/[^, \n\r]*)?)#i", "\\1 <a href=\"http://www.\\2.\\3\\4\" target=\"_blank\">www.\\2.\\3\\4</a> ", $credits);
                        $credits = preg_replace("#([\n ])([a-z0-9\-_.]+?)@([^, \n\r]+)#i", "\\1<a href=\"mailto:\\2@\\3\">\\2@\\3</a>", $credits);
                        $credits = nl2br(trim($credits));
                        $design_info .= '<div class="content">' . $credits . '</div>';
                    }
                }
            }
        }
        closedir($handle);
    }

    $sql = "SELECT title, active FROM " . $GLOBALS['prefix'] . "_modules WHERE active=1 ORDER BY title;";
    $GLOBALS['mxSkipSqlDetect'] = true;
    $result = sql_query($sql);
    $module_info = "";
    while ($aktive = sql_fetch_assoc($result)) {
        unset ($credits);
        if (mxModuleAllowed($aktive['title'])) {
            $show = @ file_exists('modules/' . $aktive['title'] . '/setup.pmx.php');
            if ($show || MX_IS_ADMIN) {
                $module_info .= '<br><p class="title"><a href="modules.php?name=' . $aktive['title'] . '">' . $aktive['title'] . '</a></p>';
            }
            if ($show) {
                include ('modules/' . $aktive['title'] . '/setup.pmx.php');
                if (!empty ($credits)) {
                    $credits = " " . strip_tags($credits);
                    $credits = preg_replace('/&(?![a-zA-Z]{2,6};|#[0-9]{2,3};)/', '&amp;', $credits);
                    $credits = preg_replace("#([\n ])([a-z]+?)://([^, \n\r]+)#i", "\\1 <a href=\"\\2://\\3\" target=\"_blank\">\\2://\\3</a> ", $credits);
                    $credits = preg_replace("#([\n ])www\.([a-z0-9\-]+)\.([a-z0-9\-.\~]+)((?:/[^, \n\r]*)?)#i", "\\1 <a href=\"http://www.\\2.\\3\\4\" target=\"_blank\">www.\\2.\\3\\4</a> ", $credits);
                    $credits = preg_replace("#([\n ])([a-z0-9\-_.]+?)@([^, \n\r]+)#i", "\\1<a href=\"mailto:\\2@\\3\">\\2@\\3</a>", $credits);
                    $credits = nl2br(trim($credits));
                    $module_info .= '<div class="content">' . $credits . '</div>';
                }
            }
        }
    }

    $module_info = "<div class=\"title\"><strong>" . _SYSINFOMODULES . "</strong></div><br>\n" . $module_info . "<br>";
    $design_info = "<div class=\"title\"><strong>" . _SYSINFOTHEMES . "</strong></div><br>\n" . $design_info . "<br>";

    if (isset($_REQUEST['name']) && $_REQUEST['name'] == 'mxcredit') {
        echo $intro . $module_info . "<br>" . $design_info;
        return "";
    }
    $out['intro'] = $intro;
    $out['module_info'] = $module_info;
    $out['design_info'] = $design_info;
    return $out;
}

/**
 * dient nur zur Filterung von $_GET, $_POST, $_COOKIE
 */
function mxSecureValue($value)
{
    // return $value;
    if (is_array($value)) {
        // wenn array, dieses in Schleife rekursiv behandeln und zurueckgeben
        foreach ($value as $key => $val) {
            $value[$key] = mxSecureValue($val);
        }
        return $value;
    } else
    if (empty ($value) || is_numeric($value) || !is_string($value) || $value === session_id()) {
        // leere, numerische und nicht String Werte, sowie die session_id nicht behandeln
        return $value;
    }
    // Remove \x00 (nullbyte) from any passed variable for security reasons
    $value = str_replace("\x00", '', $value);

    if (!get_magic_quotes_gpc()) {
        // This will reproduce the option magic_quotes_gpc=1 // nur wenn String
        $value = addslashes($value);
    }

    if (MX_IS_ADMIN) {
        return $value;
    }
    // der Rest nur bei Nicht-Admins
    if (!empty ($GLOBALS['mxEntitieLevel'])) {
        // wenn level 2, dann alle unerlaubten html-Tags entfernen
        // die, die nur ohne Parameter verwendet werden duerfen, werden weiter unten trotzdem behandelt
        if ($GLOBALS['mxEntitieLevel'] === 2) {
            $allowedtags = '<' . join('><', mxGetAllowedHtml()) . '>';
            $value = strip_tags($value, $allowedtags);
        }
        // erlaubte HTML-Tags auslesen zum ersetzen (preg)
        $allowedhtml = mxGetAllowedHtml('preg');
        // Preparse var to mark the HTML that we want
        $value = preg_replace($allowedhtml, "\022\\1\024", $value);
        // Prepare var
        $value = str_replace(array ('<', '>'), array ('&lt;', '&gt;'), $value);
        // Fix the HTML that we want
        $value = preg_replace('/\022([^\024]*)\024/e', "'<' . stripslashes(strtr('\\1', array('&gt;' => '>','&lt;' => '<'))). '>';", $value);
    }

    if (strlen($value) > 10) {
        // javascript events aus Tags entfernen
        $value = preg_replace('#(<[^>]*)(on(blur|c(hange|lick)|dblclick|focus|keypress|(key|mouse)(down|up)|(un)?load|mouse(move|o(ut|ver))|reset|s(elect|ubmit)))([^<]*>)#is', '$1' . $GLOBALS['CensorReplace'] . '$11', $value);
        // Tags die immer verboten sind, entfernen
        $value = preg_replace('#(<)/?\s*(script|i?frame|style|object|meta|applet|link|embed)[^<]*(>)#si', $GLOBALS['CensorReplace'], $value);
        // Tags die ueber GET verboten sind, entfernen
        if ($_SERVER["REQUEST_METHOD"] == "GET") {
            $value = preg_replace('#(<)/?\s*(img|form|input|textarea)[^<]*(>)#si', $GLOBALS['CensorReplace'], $value);
            // / sonstige "boese" Parameter aus Tags entfernen
            $value = preg_replace('#(<[^>]*)(style)\s*(\=[^<]*>)#is', '$1' . $GLOBALS['CensorReplace'] . '$3', $value);
        }
    }
    // Die Wortzensur anwenden
    if ($_SERVER["REQUEST_METHOD"] == "POST") {
        $value = mxPrepareCensored($value);
    }
    // und weg damit ;-))
    return $value;
}

/**
 */
function getcredithtml()
{
    // Sprachdatei auswaehlen
    if (@file_exists('language/credits/lang-' . $GLOBALS['currentlang'] . '.php')) {
        include_once('language/credits/lang-' . $GLOBALS['currentlang'] . '.php');
    } else {
        include_once('language/credits/lang-german.php');
    }
    require_once('includes/mx_credits.php');

    sort($pmx_leader, SORT_STRING);
    sort($pmx_developer, SORT_STRING);
    sort($pmx_translator, SORT_STRING);
    $c_leader = '';
    $c_developer = '';
    $c_translator = '';
    for ($x = 0;$x < count($pmx_leader);$x++) {
        $c_leader .= ($x != 0) ? ', ' . $pmx_leader[$x] : $pmx_leader[$x];
    }
    for ($x = 0;$x < count($pmx_developer);$x++) {
        $c_developer .= ($x != 0) ? ', ' . $pmx_developer[$x] : $pmx_developer[$x];
    }
    for ($x = 0;$x < count($pmx_translator);$x++) {
        $c_translator .= ($x != 0) ? ', ' . $pmx_translator[$x] : $pmx_translator[$x];
    }
    $content = '<div class="credits">'
     . '<b>' . _CREDITS_TITLE . '</b><br /><br /><ul>'
     . '<li><b>' . _CREDITS_TITLE_LEADER . ':</b><br />' . $c_leader . '<br /><br /></li>'
     . '<li><b>' . _CREDITS_TITLE_DEVELOPER . ':</b><br />' . $c_developer . '<br /><br /></li>'
     . '<li><b>' . _CREDITS_TITLE_TRANSLATOR . ':</b><br />' . $c_translator . ' ' . _CREDITS_TRANSLATOR_MORE . '<br /><br /></li>'
     . '</ul></div>'
     . '<br />'
     . '<div class="credits">'
     . '<b>pragmaMx</b><br /><br /><ul>'
     . '<li>' . _CREDITS_INSPIRED . '<br /><br /></li>'
     . '<li>' . _CREDITS_LICENSE1 . '<br /><br /></li>'
     . '<li>' . _CREDITS_LICENSE2 . '<br /><br /></li>'
     . '<li>' . _CREDITS_MORE . '<br /><br /></li>'
     . '</ul></div>'
     . '<br />'
     . '<div class="credits">'
     . '<b>' . _CREDITS_TITLE_GRAFICS . '</b><br /><br /><ul>'
     . '<li><b>' . _CREDITS_TITLE_MOSTICONS . '</b><br />' . _CREDITS_MOSTICONS . '<br /><br /></li>'
     . '<li><b>' . _CREDITS_TITLE_SMALLICONS . '</b><br />' . _CREDITS_SMALLICONS . '<br /><br /></li>'
     . '</ul></div><br />';
    return $content;
}

/**
 */
function mxSystemInfo()
{
    if (mxDemoMode()) {
        die('sorry, not more in DemoMode');
    }
    phpinfo();
    exit;
}

?>