<?php
/**
 * This file is part of 
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.2.2.2 $
 * $Author: tora60 $
 * $Date: 2007/12/22 14:11:51 $
 */

/**
 * erst ab php 4.2.0 verfuegbar
 *           code von http://www.php.net/manual/de/function.array-chunk.php
 *           mick at vandermostvanspijk dot nl, 07-Apr-2004 03:02
 */
if (!function_exists('array_chunk')) {
    function array_chunk($input, $size, $preserve_keys = false)
    {
        @reset($input);

        $i = $j = 0;

        while (@list($key, $value) = @each($input)) {
            if (!(isset($chunks[$i]))) {
                $chunks[$i] = array();
            }

            if (count($chunks[$i]) < $size) {
                if ($preserve_keys) {
                    $chunks[$i][$key] = $value;
                    $j++;
                } else {
                    $chunks[$i][] = $value;
                }
            } else {
                $i++;

                if ($preserve_keys) {
                    $chunks[$i][$key] = $value;
                    $j++;
                } else {
                    $j = 0;
                    $chunks[$i][$j] = $value;
                }
            }
        }

        return $chunks;
    }
}

/**
 * erst ab php 4.2.0 verfuegbar
 *           code von http://www.php.net/manual/de/function.fmod.php
 *           by Jon, 09-May-2003 01:25
 */
if (!function_exists('fmod')) {
    function fmod($x, $y)
    {
        $i = floor($x / $y);
        // r = x - i * y
        return $x - $i * $y;
    }
}

/**
 * die entsprechende php-Funktion ist erst ab php 4.3.0 verfuegbar
 */
if (!function_exists("file_get_contents")) {
    function file_get_contents($filename, $use_include_path = 0)
    {
        $file = implode('', file($filename, $use_include_path));
        return $file;
    }
}

/**
 * die entsprechende php-Funktion ist erst ab php 4.3.0 verfuegbar
 */
if (!function_exists("ob_get_clean")) {
    function ob_get_clean()
    {
        $ob_contents = ob_get_contents();
        ob_end_clean();
        return $ob_contents;
    }
}

/**
 * die entsprechende php-Funktion ist erst ab php 4.3.0 verfuegbar
 */
if (!function_exists("array_change_key_case")) {
    if (!defined('CASE_UPPER')) define('CASE_UPPER', 1);
    if (!defined('CASE_LOWER')) define('CASE_LOWER', 2);
    if (!defined('CASE_FIRST')) define('CASE_FIRST', 3);
    /**
     *
     * @return array
     * @author Cocol
     * @desc change the key case , if found repeat keys, then  convert to array
     * for more detail please visit http://php.clickz.cn/array/array_change_key_case.html
     */
    function array_change_key_case($array = array(), $case = CASE_UPPER)
    {
        $secure = array();
        if ($case == CASE_UPPER) {
            foreach ($array as $key => $val) {
                $key = strtoupper($key);
                if (!array_key_exists($key, $secure)) {
                    $secure[$key][] = $val;
                } else {
                    $secure[$key][] = $val;
                }
            }
        } else if ($case == CASE_LOWER) {
            foreach ($array as $key => $val) {
                $key = strtolower($key);
                if (!array_key_exists($key, $secure)) {
                    $secure[$key][] = $val;
                } else {
                    $secure[$key][] = $val;
                }
            }
        }

        foreach ($secure as $key => $val) {
            if (count($secure[$key]) == 1) {
                $secure[$key] = $val[0];
            }
        }
        return $secure;
    }
}

?>