<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.12.2.4 $
 * $Author: tora60 $
 * $Date: 2008/01/28 19:17:38 $
 */

if (!defined('MX_TIME')) {
    $vstarttime = explode(' ', microtime());
    define('MX_TIME', (float)$vstarttime[1] + (float)$vstarttime[0]);
    unset($vstarttime);
}

/**
 * wenn $name uebergeben wurde, die modules.php verwenden
 */
if (isset($_GET['name']) || isset($_POST['name'])) {
    include('modules.php');
    return;
}

/**
 * jop, die modules.php ist geladen ;)
 */
define('mxModFileLoaded', '2');

/**
 * und noch die Startseite kennzeichnen...
 */
$home = 1; // nur noch nuke-Kompatibilitaet
define('MX_HOME_FILE', true);

/**
 * nur zum initialisieren der Variablen, wird durch das Modul berschrieben
 */
$index = 0;

/**
 * PHP_SELF macht auf manchen Servern Probleme bei mod_rewrite,
 * es wird die umgeschriebene URL verwendet anstatt modules.php
 * deshalb hier umschreiben, aber hier modules.php verwenden, wegen nuke-Kompatibilitt
 */
$_SERVER['PHP_SELF'] = preg_replace('#^[\\\\/]+#', '/', dirname($_SERVER['PHP_SELF']) . '/modules.php');

/**
 * pragmaMx Hauptdatei includen
 */
require_once('mainfile.php');

/**
 * jpCache laden, nur bei Anonymen Besuchern
 */
if ($mxJpCacheUse && !MX_IS_ADMIN && !MX_IS_USER && !isset($_REQUEST['noJpC'])) {
    include_once(PMX_SYSTEM_DIR . '/jpcache/mx_jpcache.php');
}

/**
 * einen Modulnamen verpassen
 */
$name = mxGetMainModuleName();
define('MX_MODULE', $name);

$modfile = 'modules/' . $name . '/index.php';
$op = 'modload';
$file = 'index';

if (!@file_exists($modfile)) {
    $index = 1;
    if (MX_IS_ADMIN) {
        mxErrorScreen('<b>' . _HOMEPROBLEM . '</b><br><br>[&nbsp;<a href="admin.php?op=modules">' . _ADDAHOME . '</a>&nbsp;]');
    } else {
        mxErrorScreen(_HOMEPROBLEMUSER);
    }
    die();
}

/**
 * Moduldatei includen
 */
include_once($modfile);

?>