<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.33.2.8 $
 * $Author: tora60 $
 * $Date: 2008/01/28 14:01:31 $
 */

/**
 * Ausgabepuffer auf jeden Fall starten, wird am Ende dieser Datei
 * wieder geloescht und evtl. der ob_gzhandler gestartet
 */
ob_start();

/**
 * Benchmarkanzeige initialisieren
 */
if (!defined('MX_TIME')) {
    $vstarttime = explode(' ', microtime());
    define('MX_TIME', (float)$vstarttime[1] + (float)$vstarttime[0]);
    unset($vstarttime);
}

/**
 * killt Variablen, die bei register_globals=ON uebergeben werden koennen
 */
foreach ($_REQUEST as $key => $value) {
    if (!in_array($key, array('GLOBALS', '_SERVER', '_GET', '_POST', '_COOKIE', '_FILES', '_ENV', '_REQUEST', '_SESSION'))) {
        unset($$key);
    }
}
unset($value);

/**
 * verschiedene Grundeinstellungen
 */
define('mxMainFileLoaded', '1');

/**
 * verschiedene absolute Pfade zu Systemordnern definieren. Alle hier
 * generierten Pfade muessen ohne Slash am Ende sein!
 */
// der wichtigste Pfad: zum mx-Root
define('MX_DOC_ROOT', dirname(__FILE__));
define('PMX_REAL_BASE_DIR', MX_DOC_ROOT);
// Ordner mit den Systemdateien
define('PMX_SYSTEM_DIR', PMX_REAL_BASE_DIR . '/includes');
// Ordner mit den Administrationsdateien
define('PMX_ADMIN_DIR', PMX_REAL_BASE_DIR . '/admin');
// Ordner mit dynamischen Inhalten (Logdatein, Cache, etc.)
define('PMX_DYNADATA_DIR', PMX_REAL_BASE_DIR . '/dynadata');

/**
 * Nur Parsefehler melden
 */
error_reporting(E_PARSE);

/**
 * paresfehler in config.php abfangen
 */
if (!@include(PMX_REAL_BASE_DIR . '/config.php')) {
    $msg = '<img src="images/logo.gif" alt="pragmaMx-Error" /><ul>';
    if (@file_exists('setup') && !is_file(PMX_REAL_BASE_DIR . '/config.php')) {
        $msg .= '
		<li>pragmaMx seems not to be installed correctly, or you\'re running pragmaMx for the first time. <br />Click <a href="setup/" rel="nofollow"><b>here</b></a> to run the installer.<br /><br /></li>
		<li>pragmaMx scheint nicht korrekt installiert zu sein oder Sie starten pragmaMx zum erstem Mal. <br />Klicken Sie <a href="setup/" rel="nofollow"><b>hier</b></a>, um den Installer zu starten.<br /><br /></li>
		<li>pragmaMx semble ne pas &ecirc;tre install&eacute; correctement, ou vous ex&eacute;cutez pragmaMx pour la premi&egrave;re fois. <br />Cliquer <a href="setup/" rel="nofollow"><b>ici</b></a> pour commencer l\'installation.<br /><br /></li>
		';
    } else {
        $msg .= '
		<li>The config-file is missing or corrupted!<br /></li>
		<li>Die Konfigurationsdatei fehlt oder ist besch&auml;digt!<br /></li>
		<li>Le fichier config.php est absent ou corrompu!<br /></li>
		';
    }
    $msg .= '</ul>';
    die($msg);
}
// Alle Fehler ausser E_NOTICE melden
// Dies ist die Standardeinstellung in php.ini
error_reporting(E_ALL ^ E_NOTICE);
// Systemkonstanten definieren, diese Datei kann in gewissem Masse angepasst werden
require_once(PMX_SYSTEM_DIR . '/mx_baseconfig.php');
// zu alte php-Version
if (MX_PHP_VERSION < 410) {
    die('<br />Sorry, PHP-Version > 4.1.0 is required.');
}
// alte php-Version, aber ist noch kompatibel zu machen...
if (MX_PHP_VERSION < 430) {
    require_once(PMX_SYSTEM_DIR . '/php_compatible.php');
}
// mainfile direkt aufgerufen? Erst hier, wegen php-Version!
if (eregi('mainfile.php', $_SERVER['PHP_SELF'])) {
    die ("You can't access this file directly...");
}
// System-Funktionen und unveraenderbare Grundeinstellungen laden
require_once(PMX_SYSTEM_DIR . '/mx_system.php');
// API's einbinden
require_once(PMX_SYSTEM_DIR . '/mx_api.php');
// in dieser Datei befinden sich Anzeige-Funktionen, die editiert werden koennten
require_once(PMX_SYSTEM_DIR . '/mx_api_2.php'); 

/**
 * nur wenn die mod.php aufgerufen wurde ist die Funktion aus der mx_modrewrite.php
 * hier bereits vorhanden, dann die uebergabeparameter aus der mod.php behandeln.
 */
if (function_exists('mxUndoModRewrite')) {
    mxUndoModRewrite();
}

/**
 * Datenbankverbindung herstellen
 */
require_once(PMX_SYSTEM_DIR . '/sql_layer.php');
$dbi = sql_connect($GLOBALS['dbhost'], $GLOBALS['dbuname'], $GLOBALS['dbpass']);
if (empty($dbi)) {
    die('<br /><br />Selection from database failed!<br /><br />Kein Zugriff auf die Datenbank moeglich, bitte ueberpruefen Sie die Einstellungen.');
}

/**
 * Session starten
 */
require_once(PMX_SYSTEM_DIR . '/mx_session.php');
if (!mxSessionStart()) {
    die('<strong>Session: initialisation failed</strong><br /><br />');
}

/**
 * Detection System starten
 */
if ($vkpSafeSqlinject) {
    include_once(PMX_SYSTEM_DIR . '/mx_detect.php');
}

/**
 * Userberechtigungen
 */
define('MX_IS_ADMIN', mxIsAdmin()); // Adminberechtigung initialisieren
define('MX_IS_USER' , mxIsUser()); // Userberechtigung  initialisieren

/**
 * restrictor von http://www.bot-trap.de/
 */
if (!defined('mxDontLoadPageRestritor') && ((!MX_IS_ADMIN && !MX_IS_USER) || (MX_IS_ADMIN && isset($_GET['pres']))) && file_exists('./restrictor/page.restrictor.php')) {
    if (!MX_IS_ADMIN) {
        unset($_GET['pres']);
    }
    @chdir('./restrictor');
    @include_once('./page.restrictor.php');
    @chdir(dirname(__file__));
    unset($forbiddenIPs, $forbiddenIPRanges, $forbiddenUAs, $forbiddenReferers);
}

/**
 * nur fuer phpNuke-Kompatibilitaet
 */
if (empty($mxDeactNukeCompatible)) {
    $mainfile = 1;
    // phpNuke6.5 Datenbanklayer einbinden, falls vorhanden
    if (@is_file(PMX_SYSTEM_DIR . '/db/db.php')) {
        include_once(PMX_SYSTEM_DIR . '/db/db.php');
    }
    // phpNuke Api einbinden (alte mainfile)
    if (@is_file(PMX_SYSTEM_DIR . '/nukefunctions.php')) {
        include_once(PMX_SYSTEM_DIR . '/nukefunctions.php');
    }
}

/**
 * Debug-Mode
 */
if (!empty($mxDebugService) && MX_IS_ADMIN) {
    @ini_set('display_errors', true);
    error_reporting(E_ALL);
} else {
    // Nur noch schwerere Fehler melden
    error_reporting(E_ERROR | E_PARSE);
}

/**
 * Demomode bei berechtigten Admins wieder abschalten
 */
$mxDemoMode = mxDemoMode();

/**
 * Request Variablen zwischenspeichern, fuer Module, die eine eigene Behandlung der Superglobals vorsehen
 */
$_MX_UNCLEAN_GET = $_GET;
$_MX_UNCLEAN_POST = $_POST;
$_MX_UNCLEAN_COOKIE = $_COOKIE;
$_MX_UNCLEAN_FILES = $_FILES;

/**
 * - simuliert magic_quotes_gpc=1
 * - ersetzt bestimmte Sonderzeichen durch ihren HTML-Code
 */
$_GET = mxSecureValue($_GET);
$_POST = mxSecureValue($_POST);
$_COOKIE = mxSecureValue($_COOKIE);
// irgend etwas spinnt da bei PHP 4.4.1, count($_POST) zeigt 1, obwohl eigentlich nix vorhanden ist
if (count($_GET) > 0 && empty($_GET)) {
    $_GET = array();
}
if (count($_POST) > 0 && empty($_POST)) {
    $_POST = array();
}
if (count($_FILES) && !empty($_FILES)) {
    foreach ($_FILES as $upfile => $upfile_data) {
        if (is_array($upfile_data['name'])) {
            foreach ($upfile_data['name'] as $key => $upfile_name) {
                $upfile_name = mxSecureValue($upfile_name); // (das gleiche wie $upfile_data['name'][$key])
                ${$upfile}[$key] = $upfile_data['tmp_name'][$key];
                ${$upfile.'_name'}[$key] = $upfile_name;
                ${$upfile.'_type'}[$key] = $upfile_data['type'][$key];
                ${$upfile.'_size'}[$key] = $upfile_data['size'][$key];
                $_FILES[$upfile]['name'][$key] = $upfile_name;
            }
        } else {
            $upfile_name = mxSecureValue($upfile_data['name']);
            $$upfile = $upfile_data['tmp_name'];
            ${$upfile.'_name'} = $upfile_name;
            ${$upfile.'_type'} = $upfile_data['type'];
            ${$upfile.'_size'} = $upfile_data['size'];
            $_FILES[$upfile]['name'] = $upfile_name;
        }
    }
    unset($upfile, $upfile_name, $upfile_data);
}
// fileupload im Demomode verhindern
if ($mxDemoMode || (count($_FILES) > 0 && empty($_FILES))) {
    $_FILES = array();
}
// Speicher aufraeumen
unset($key);
if (!$mxSiteService) {
    unset($mxSiteServiceText);
}
if (MX_IS_USER) {
    mxSessionDelVar('vkpnewuser');
}

/**
 * Request-Variablen zur Kompatibilitaet neu erstellen
 */
$HTTP_GET_VARS = &$_GET;
$HTTP_POST_VARS = &$_POST;
$HTTP_COOKIE_VARS = &$_COOKIE;
$HTTP_POST_FILES = &$_FILES;
// Servervariablen zur Kompatibilitaet neu erstellen
$HTTP_SERVER_VARS = &$_SERVER;
// neue globale Request-Variablen erstellen
$_REQUEST = array_merge($_GET, $_POST); /// ohne Cookie, weil unnoetig
// die jetzt fertig behandelten Request-Variablen in den globalen Scope schreiben
extract($_REQUEST, EXTR_SKIP);
// neue globale Server-Variablen erstellen, falls register_globals aus
if (!mxIniGet('register_globals')) {
    extract($_SERVER, EXTR_OVERWRITE);
}
/**
 * ENDE ... simuliert magic_quotes_gpc=1...
 */

/**
 * 4nc
 */
if (isset($ko) && $ko == 1 && (isset($table) || isset($f) || isset($datei) || isset($ok))) {
    unset($ko, $_REQUEST['ko'], $_POST['ko'], $_GET['ko'], $f, $ok, $table, $datei);
    mxSecureLog('Hack-Attack', '4n-Community-hack', 'with_request');
    $mxDemoMode = 1;
}

/**
 * zur Kompatiblitaet mit Nuke-Modulen
 */
// den Admin-Cookie simulieren
$_COOKIE['admin'] = mxSessionGetVar('admin');
$admin = $_COOKIE['admin'] ;
// den User-Cookie simulieren
$_COOKIE['user'] = mxSessionGetVar('user');
$user = $_COOKIE['user'];

/**
 * Sprache einstellen
 */
$language = (empty($language)) ? 'german' : $language; // $language kommt aus config.php
$lang = (mxSessionGetVar('lang')) ? mxSessionGetVar('lang') : $language;
if (isset($_REQUEST['newlang'])) {
    $_REQUEST['newlang'] = preg_replace('#[^a-z_]#', '_', strtolower($_REQUEST['newlang']));
    $currentlang = (@file_exists('language/lang-' . $_REQUEST['newlang'] . '.php')) ? $_REQUEST['newlang'] : $language;
} else if (@file_exists('language/lang-' . $lang . '.php')) {
    $currentlang = $lang;
} else {
    $currentlang = $language;
}
mxSessionSetVar('lang', $currentlang);
mxSetNukeCookie('lang', $currentlang, 1);
$lang = $currentlang;
$_COOKIE['lang'] = $currentlang;
include_once('language/lang-' . $currentlang . '.php');

/**
 * Theme definieren
 */
define('MX_THEME', mxGetTheme());
define('MX_THEME_DIR', 'themes/' . MX_THEME);

/**
 * Website Tracking aktualisieren
 */
if (@$GLOBALS['vkpTracking'] && @file_exists(PMX_SYSTEM_DIR . '/trackhack.php')) {
    include_once(PMX_SYSTEM_DIR . '/trackhack.php');
}

/**
 * Referer aktualisieren
 */
mxReferer();

/**
 * Bannfunktion ausfuehren
 */
vkpIpBanning();

/**
 * output-handling
 * falls bereits ausgaben erfolgt, diese zwischenspeichern und Puffer beenden
 */
$obtemp = trim(@ob_get_contents());
ob_end_clean();
// Pufferhandler ermitteln
$mxoutputhandler = mxGetOutputHandler();
// Ausgabepuffer starten und evtl. Ausgabe komprimieren
ob_implicit_flush(0);
if ($mxoutputhandler) {
    ob_start($mxoutputhandler);
}
unset($mxoutputhandler);
// Ausgabepuffer auf jeden Fall ein 2tes mal starten, dass bei Fehlern, die Ausgabe,
// auch erst am Ende des scripts in den komprimierten Handler geschrieben werden
// dies verhindert fruehzeitiges senden von HTTP-Headern (session)
ob_start();
// evtl. bereits vorhandene zwischengespeicherte Ausgaben jetzt erst ausgeben
if (!empty($obtemp)) {
    echo $obtemp;
}
unset($obtemp);

/**
 * hier kann die Systemkonfiguration ueberprueft werden
 * einfach folgende Zeile einkommentieren
 */
// mxSystemInfo();
// mxDebugFuncVars($GLOBALS);

?>