<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.13.2.5 $
 * $Author: tora60 $
 * $Date: 2008/02/02 10:42:39 $
 */

if (!defined('MX_TIME')) {
    $vstarttime = explode(' ', microtime());
    define('MX_TIME', (float)$vstarttime[1] + (float)$vstarttime[0]);
    unset($vstarttime);
}

/**
 * jop, die modules.php ist geladen ;)
 */
define('mxModFileLoaded', '1');

/**
 * nur zum initialisieren der Variablen, wird durch das Modul berschrieben
 */
$index = 0;

/**
 * PHP_SELF macht auf manchen Servern Probleme bei mod_rewrite,
 * es wird die umgeschriebene URL verwendet anstatt modules.php
 * deshalb hier umschreiben
 */
$_SERVER['PHP_SELF'] = preg_replace('#^[\\\\/]+#', '/', dirname($_SERVER['PHP_SELF']) . '/' . basename(__file__));

/**
 * pragmaMx Hauptdatei includen
 */
require_once('mainfile.php');

if (empty($_REQUEST['name'])) {
    define('MX_MODULE', '');
    mxErrorScreen('Sorry, you can\'t access this file directly, parameter &quot;name&quot; is required...', _ACCESSDENIED);
}

$name = $_REQUEST['name'];
$op = (isset($_REQUEST['op'])) ? $_REQUEST['op'] : 'modload';
$file = (isset($_REQUEST['file'])) ? trim($_REQUEST['file']) : 'index';

/**
 * jpCache laden, nur bei Anonymen Besuchern
 */
if ($mxJpCacheUse && !MX_IS_ADMIN && !MX_IS_USER && !isset($_REQUEST['noJpC']) && $name != 'Your_Account') {
    include_once('includes/jpcache/mx_jpcache.php');
}

/**
 * pruefen von ungueltigen request-Variablen
 */
if ($file != 'index' || $op != 'modload') {
    if (preg_match('#(:)|(\.\.)|(\/)|(\\\)#', $file . $op)) {
        define('MX_MODULE', '');
        mxYoubad('Bad Request');
        die();
    }
}

/**
 * Ausgabe der Informationen des vkp-Developer-Team
 * Das Entfernen der Zeilen verhindert nicht die Ausgabe,
 * zerstrt aber das Layout der Seite
 */
if ($name == 'mxcredit') {
    define('MX_MODULE', 'mxcredit');
    include('header.php');
    OpenTable();
    echo '<div align="left" style="height: 530px; overflow: auto; width: 100%;">';
    echo mxInfo();
    echo '</div>';
    CloseTable();
    include('footer.php');
    die();
}

/**
 * falsch uebergebene name's mit 2 Fragezeichen fixen
 */
if ($_SERVER['REQUEST_METHOD'] == 'GET') {
    if (strpos($name, '?') !== false && preg_match('#([^?]*)\?([^?]*)#', $name, $matches)) {
        header('Location: modules.php?name=' . $matches[1] . '&' . $matches[2]);
        exit;
    }
}

/**
 * Daten des Moduls aus der Datenbank lesen
 */
$qry = "select mid, title, active, view from " . $prefix . "_modules where title='" . mxAddSlashesForSQL($name) . "'";
$result = sql_query($qry);
if (!is_resource($result)) {
    $msg = (MX_IS_ADMIN) ? 'Unable to select from Database (table: ' . $prefix . '_modules)!' : '<b>' . _MODULENOTACTIVE . '</b><br>';
    mxErrorScreen($msg);
}

list($mod_id, $mod_title, $mod_active, $mod_view) = sql_fetch_row($result);
$modfile = 'modules/' . $mod_title . '/' . $file . '.php'; // $mod_title verwenden wegen Gross/Kleinschreibung
$file = (@file_exists($modfile)) ? $file : 'index';
$modfile = 'modules/' . $mod_title . '/' . $file . '.php';

if ((($mod_active != 1) && (!MX_IS_ADMIN)) || empty($mod_id)) {
    mxErrorScreen('<b>' . _MODULENOTACTIVE . '</b><br>', '');
} else if (!@file_exists($modfile)) {
    $msg = (MX_IS_ADMIN) ? 'Sorry, the file &quot;' . $modfile . '&quot; doesn\'t exist!' : 'Sorry, such file doesn\'t exist...';
    mxErrorScreen($msg);
} else if ($mod_view == 2 && !MX_IS_ADMIN) {
    mxErrorScreen('<b>' . _RESTRICTEDAREA . '</b><br><br>' . _MODULESADMINS, _ACCESSDENIED);
} else if ($mod_view == 1 && !MX_IS_ADMIN && !MX_IS_USER) {
    mxErrorScreen('<b>' . _RESTRICTEDAREA . '</b><br><br>' . _MODULEUSERS, _ACCESSDENIED);
} else if ($mod_view == 1 && !MX_IS_ADMIN && !mxModuleAllowed($mod_title)) {
    mxErrorScreen('<b>' . _GROUPRESTRICTEDAREA . '</b><br>', _ACCESSDENIED);
} else {
    unset($result, $qry, $mod_view, $mod_active, $mod_title, $mod_id);
    /**
     * einen festen Modulnamen verpassen
     */
    define('MX_MODULE', $name);
    define('MX_MODULE_FILE', $file);
    /**
     * Moduldatei includen
     */
    include_once($modfile);
}

?>