<?php
/**
 * This file is part of 
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.3 $
 * $Author: tora60 $
 * $Date: 2007/12/22 14:15:56 $
 */

defined('mxMainFileLoaded') or die('access denied');
$modname = basename(dirname(dirname(__FILE__)));

unset($sqlqry);

if (!isset($tables["${prefix}_banner"])) {
    $sqlqry[] = "
CREATE TABLE `${prefix}_banner` (
  `bid` int(11) NOT NULL auto_increment,
  `cid` int(11) NOT NULL default '0',
  `imptotal` int(11) NOT NULL default '0',
  `impmade` int(11) NOT NULL default '0',
  `clicks` int(11) NOT NULL default '0',
  `imageurl` varchar(255) NOT NULL default '',
  `clickurl` varchar(255) NOT NULL default '',
  `alttext` varchar(200) NOT NULL default '',
  `typ` tinyint(1) NOT NULL default '1',
  `script` blob,
  `active` tinyint(1) NOT NULL default '1',
  `datestart` datetime NOT NULL default '0000-00-00 00:00:00',
  `dateend` datetime default NULL,
  PRIMARY KEY  (`bid`),
  KEY `typ` (`typ`),
  KEY `active` (`active`),
  KEY `cid` (`cid`)
) TYPE=MyISAM;";
}

if (!isset($tables["${prefix}_bannerclient"])) {
    $sqlqry[] = "
CREATE TABLE `${prefix}_bannerclient` (
  `cid` int(11) NOT NULL auto_increment,
  `name` varchar(60) NOT NULL default '',
  `contact` varchar(60) NOT NULL default '',
  `email` varchar(60) NOT NULL default '',
  `login` varchar(10) NOT NULL default '',
  `passwd` varchar(10) NOT NULL default '',
  `extrainfo` text NULL,
  PRIMARY KEY  (`cid`),
  KEY `name` (`name`)
) TYPE=MyISAM;";
}
// mxDebugFuncVars($tables); exit;
// check fuer phpNuke 8.x
if (isset($tables["${prefix}_banner"])) {
    $tf = setupGetTableFields("${prefix}_banner");
    if (isset($tf['name'])) {
        $sqlqry[] = "ALTER TABLE `${prefix}_banner` DROP `name` ";
    }
    if (isset($tf['date'])) {
        if (isset($tf['datestart'])) {
            $sqlqry[] = "ALTER TABLE `${prefix}_banner` DROP `date` ";
        } else {
            $sqlqry[] = "ALTER TABLE `${prefix}_banner` CHANGE `date` `datestart` datetime NOT NULL default '0000-00-00 00:00:00'";
        }
    }

    if (isset($tf['position'])) {
        if (isset($tf['typ'])) {
            $sqlqry[] = "ALTER TABLE `${prefix}_banner` DROP `position` ";
        } else {
            $sqlqry[] = "ALTER TABLE `${prefix}_banner` CHANGE `position` `typ` tinyint(1) NOT NULL default '1'";
        }
    }

    if (isset($tf['ad_code'])) {
        if (isset($tf['script'])) {
            $sqlqry[] = "ALTER TABLE `${prefix}_banner` DROP `ad_code` ";
        } else {
            $sqlqry[] = "ALTER TABLE `${prefix}_banner` CHANGE `ad_code` `script` blob";
        }
    }
    if (isset($tf['ad_class'])) $sqlqry[] = "ALTER TABLE `${prefix}_banner` DROP `ad_class` ";
    if (isset($tf['ad_width'])) $sqlqry[] = "ALTER TABLE `${prefix}_banner` DROP `ad_width` ";
    if (isset($tf['ad_height'])) $sqlqry[] = "ALTER TABLE `${prefix}_banner` DROP `ad_height` ";
    // if ($tf['title']['Default'] !== null || $tf['content']['Default'] !== null || $tf['content']['Type'] != 'longtext') {
    // $sqlqry[] = "ALTER TABLE `${prefix}_seccont`
    // CHANGE `title` `title` text NULL,
    // CHANGE `content` `content` longtext NULL";
    // }
    // if ($tf['extrainfo']['Default'] !== null) {
    // $sqlqry[] = "ALTER TABLE `${prefix}_bannerclient`
    // CHANGE `extrainfo` `extrainfo` text NULL";
    // }
}
if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}
// $tf = setupGetTableFields("${prefix}_banner");
// mxDebugFuncVars($sqlqry, $tf); exit;
// pruefen ob Bannertabelle bereits auf aktuellem Stand von vkpMx 2.1
// die Tabelle wurde erst mit vkpMx 2.1 geaendert, bei 2.0 war Original-Nuke 5.5
$newfound = 0;
if (isset($tables["${prefix}_banner"]) && isset($tables["${prefix}_bannerclient"])) {
    $tf = setupGetTableFields("${prefix}_banner");
    $newfields = array('alttext', 'typ', 'script', 'active', 'datestart', 'dateend');
    foreach ($newfields as $newfield) {
        if (isset($tf[$newfield])) $newfound++;
    }
    // ab hier nur ausfuehren, wenn Bannertabelle nicht auf dem aktuellen Stand
    if ($newfound != count($newfields)) {
        $newfound = 0;

        $bannertemptable = RENAME_PREFIX . "${prefix}_banner_temp";

        if (isset($tables["${prefix}_banner_neu"])) {
            $sqlqry[] = "TRUNCATE TABLE `${prefix}_banner_neu`";
        } else {
            $sqlqry[] = "CREATE TABLE `${prefix}_banner_neu` (
  `bid` int(11) NOT NULL auto_increment,
  `cid` int(11) NOT NULL default '0',
  `imptotal` int(11) NOT NULL default '0',
  `impmade` int(11) NOT NULL default '0',
  `clicks` int(11) NOT NULL default '0',
  `imageurl` varchar(255) NOT NULL default '',
  `clickurl` varchar(255) NOT NULL default '',
  `alttext` varchar(200) NOT NULL default '',
  `typ` tinyint(1) NOT NULL default '1',
  `script` blob,
  `active` tinyint(1) NOT NULL default '1',
  `datestart` datetime NOT NULL default '0000-00-00 00:00:00',
  `dateend` datetime default NULL,
  PRIMARY KEY  (`bid`),
  KEY `typ` (`typ`),
  KEY `active` (`active`),
  KEY `cid` (`cid`)
			) TYPE=MyISAM ;";
        }
        // temporre Tabelle erstellen    $bannertemptable
        if (isset($tables[$bannertemptable])) {
            $sqlqry[] = "TRUNCATE TABLE `$bannertemptable`";
        } else {
            $sqlqry[] = "CREATE TABLE `$bannertemptable` (
			  `name` varchar(60) default NULL,
			  `contact` varchar(60) default NULL,
			  `email` varchar(60) default NULL,
			  `login` varchar(10) default NULL,
			  `passwd` varchar(10) default NULL,
			  `extrainfo` text,
			  `imptotal` mediumint(9) NOT NULL default '0',
			  `impmade` mediumint(9) NOT NULL default '0',
			  `clicks` mediumint(9) NOT NULL default '0',
			  `imageurl` varchar(255) default NULL,
			  `clickurl` varchar(255) default NULL,
			  `alttext` varchar(200) default NULL,
			  `impressions` mediumint(9) NOT NULL default '0',
			  `finish_clicks` mediumint(9) NOT NULL default '0',
			  `date` datetime default NULL,
			  `datestart` datetime default NULL,
			  `dateend` datetime default NULL,
			  `bid` int(11) NOT NULL default '0',
			  `cid` int(11) NOT NULL default '0',
			  `typ` int(11) NOT NULL default '1',
			  `active` int(11) NOT NULL default '1',
			  `id_temp` int(10) unsigned NOT NULL auto_increment,
			  PRIMARY KEY  (`id_temp`)
			) TYPE=MyISAM;";
        }

        if (isset($tables["${prefix}_bannerclient_neu"])) {
            $sqlqry[] = "TRUNCATE TABLE `${prefix}_bannerclient_neu`";
        } else {
            $sqlqry[] = "CREATE TABLE `${prefix}_bannerclient_neu` (
			  `cid` int(11) NOT NULL auto_increment,
			  `name` varchar(60) NOT NULL default '',
			  `contact` varchar(60) NOT NULL default '',
			  `email` varchar(60) NOT NULL default '',
			  `login` varchar(10) NOT NULL default '',
			  `passwd` varchar(10) NOT NULL default '',
			  `extrainfo` text NULL,
			  PRIMARY KEY  (`cid`),
			  KEY `name` (`name`)
			) TYPE=MyISAM ;";
        }

        $tf = setupGetTableFields("${prefix}_banner");
        $newfields = array('alttext');
        $newfound = 0;
        if (!isset($tf["alttext"])) {
            $sqlqry[] = "ALTER TABLE `${prefix}_banner` ADD `alttext` varchar(200) default NULL;";
        }

        if (isset($tables["${prefix}_bannerfsz"])) {
            $tf = setupGetTableFields("${prefix}_bannerfsz");
            $newfields = array('alttext');
            $newfound = 0;
            if (!isset($tf["alttext"])) {
                $sqlqry[] = "ALTER TABLE `${prefix}_bannerfsz` ADD `alttext` varchar(200) default NULL;";
            }
        }
        // temporre Tabelle fllen
        if (isset($tables["${prefix}_bannerfsz"]) && isset($tables["${prefix}_bannerclientfsz"]) && isset($tables["${prefix}_bannerfinishfsz"])) {
            $sqlqry[] = "REPLACE INTO $bannertemptable( name, contact, email, login, passwd, extrainfo, imptotal, impmade, clicks, imageurl, clickurl, alttext, `date`, impressions, finish_clicks, datestart, dateend, typ )
			SELECT DISTINCTROW bcf.name, bcf.contact, bcf.email, bcf.login, bcf.passwd, bcf.extrainfo, bf.imptotal, bf.impmade, bf.clicks, bf.imageurl, bf.clickurl, bf.alttext, bf.date, bff.impressions, bff.clicks AS fc, bff.datestart, bff.dateend, 2 AS typ
			FROM ( ${prefix}_bannerclientfsz AS bcf
			LEFT JOIN ${prefix}_bannerfsz AS bf ON bcf.cid = bf.cid )
			LEFT JOIN ${prefix}_bannerfinishfsz AS bff ON bcf.cid = bff.cid
			ORDER BY bcf.name, bf.imageurl";
        }

        if (isset($tables["${prefix}_bannerfinish"])) {
            $sqlqry[] = "REPLACE INTO $bannertemptable( name, contact, email, login, passwd, extrainfo, imptotal, impmade, clicks, imageurl, clickurl, alttext, `date`, impressions, finish_clicks, datestart, dateend, typ )
			SELECT DISTINCTROW bch.name, bch.contact, bch.email, bch.login, bch.passwd, bch.extrainfo, bh.imptotal, bh.impmade, bh.clicks, bh.imageurl, bh.clickurl, bh.alttext, bh.date, bfh.impressions, bfh.clicks AS fc, bfh.datestart, bfh.dateend, 1 AS typ
			FROM ( ${prefix}_bannerclient AS bch
			LEFT JOIN ${prefix}_banner AS bh ON bch.cid = bh.cid )
			LEFT JOIN ${prefix}_bannerfinish AS bfh ON bch.cid = bfh.cid
			ORDER BY bch.name, bh.imageurl";
        } else { // nur bei nuke > 5.5
            $sqlqry[] = "REPLACE INTO $bannertemptable( name, contact, email, login, passwd, extrainfo, imptotal, impmade, clicks, imageurl, clickurl, alttext, `date`, impressions, finish_clicks, datestart, dateend )
			SELECT DISTINCTROW bch.name, bch.contact, bch.email, bch.login, bch.passwd, bch.extrainfo, bh.imptotal, bh.impmade, bh.clicks, bh.imageurl, bh.clickurl, bh.alttext, bh.date, bh.impmade, bh.clicks AS fc, bh.date, bh.dateend
			FROM ( ${prefix}_bannerclient AS bch
			LEFT JOIN ${prefix}_banner AS bh ON bch.cid = bh.cid )
			ORDER BY bch.name, bh.imageurl";
        }
        // die Abfragen im Array $sqlqry muessen bereits vorher ausgefuehrt werden,
        // weil die dabei erstellten Tabellen fuer weitere Abfragen benoetigt werden
        // der Rueckgabewert $msg wird in der Funktion setupDoAllQueries statisch zwischengespeichert
        if (isset($sqlqry)) {
            setupDoAllQueries($sqlqry);
            unset($sqlqry);
        }

        $bi2 = 0;
        $tmpname = "";
        $tmpnamelast = "fgdfgerdfgerfdgersadgesd";
        $result = mysql_query("select * from $bannertemptable ORDER BY name, contact, imageurl");
        while ($row = mysql_fetch_array($result)) {
            if ($tmpnamelast != $row['name']) {
                $bi2++;
                $tmpnamelast = $row['name'];
                $sqlqry[] = "REPLACE INTO `${prefix}_bannerclient_neu` (`cid` , `name` , `contact` , `email` , `login` , `passwd` , `extrainfo` )
				       VALUES ('" . $bi2 . "', '" . $row['name'] . "', '" . $row['contact'] . "', '" . $row['email'] . "', '" . $row['login'] . "', '" . $row['passwd'] . "', '" . $row['extrainfo'] . "');";
            }
            // $row['typ'] = 1;
            if (isset($row['type'])) { // nur bei nuke > 5.5
                $row['typ'] = ($row['type'] == 0) ? 1 : 4; // 1 = headerbanner 4 = Banner im Seitenblock
            }
            $row['cid'] = $bi2;
            $arr_url = parse_url($row['clickurl']);
            $row['alttext'] = (empty($row['alttext'])) ? @$arr_url['host'] : $row['alttext'];
            $row['datestart'] = (empty($row['datestart'])) ? $row['date'] : $row['datestart'];

            $sqlqry[] = "UPDATE $bannertemptable SET
				datestart  = '" . $row['datestart'] . "',
				alttext    = '" . $row['alttext'] . "',
				typ        = '" . $row['typ'] . "',
				cid        = '" . $row['cid'] . "'
				WHERE id_temp=" . $row['id_temp'] . "";
        }

        $sqlqry[] = "REPLACE INTO ${prefix}_banner_neu( cid, imageurl, imptotal, impmade, clicks, clickurl, alttext, datestart, typ, active )
		SELECT tmp.cid, tmp.imageurl, Sum( tmp.imptotal ) AS imptotal, Sum( tmp.impmade ) AS impmade, Sum( tmp.clicks ) AS clicks, Max( tmp.clickurl ) AS clickurl, Max( tmp.alttext ) AS alttext, Min( tmp.datestart ) AS datestart, Min( tmp.typ ) AS typ, 1 AS active
		FROM `$bannertemptable` AS tmp
		GROUP BY tmp.cid, tmp.imageurl
		HAVING (((tmp.imageurl) <> '') AND ((Sum( tmp.impressions )) = 0) AND ((Sum( tmp.finish_clicks )) = 0))";

        $sqlqry[] = "REPLACE INTO ${prefix}_banner_neu( cid, imageurl, imptotal, impmade, clicks, clickurl, alttext, datestart, dateend, typ, active )
		SELECT tmp.cid, tmp.imageurl, Sum( tmp.imptotal ) AS imptotal, Sum( tmp.impressions ) AS impressions, Sum( tmp.finish_clicks ) AS clicks, Max( tmp.clickurl ) AS clickurl, Max( tmp.alttext ) AS alttext, Min( tmp.datestart ) AS datestart, Max( tmp.dateend ) AS dateend, Min( tmp.typ ) AS typ, 0 AS active
		FROM `$bannertemptable` AS tmp
		GROUP BY tmp.cid, tmp.imageurl
		HAVING (((tmp.imageurl) <> '') AND ((Sum( tmp.finish_clicks )) > 0))
		OR (((tmp.imageurl) <> '') AND ((Sum( tmp.impressions )) > 0))";

        $sqlqry[] = "UPDATE ${prefix}_banner_neu SET dateend=NULL WHERE dateend='0000-00-00 00:00:00'";

        if (isset($tables["${prefix}_bannerfsz"])) $sqlqry[] = "RENAME TABLE `${prefix}_bannerfsz`       TO `" . RENAME_PREFIX . "${prefix}_bannerfsz`;";
        if (isset($tables["${prefix}_bannerclientfsz"])) $sqlqry[] = "RENAME TABLE `${prefix}_bannerclientfsz` TO `" . RENAME_PREFIX . "${prefix}_bannerclientfsz`;";
        if (isset($tables["${prefix}_bannerfinishfsz"])) $sqlqry[] = "RENAME TABLE `${prefix}_bannerfinishfsz` TO `" . RENAME_PREFIX . "${prefix}_bannerfinishfsz`;";
        if (isset($tables["${prefix}_banner"])) $sqlqry[] = "RENAME TABLE `${prefix}_banner`          TO `" . RENAME_PREFIX . "${prefix}_banner`;";
        if (isset($tables["${prefix}_bannerclient"])) $sqlqry[] = "RENAME TABLE `${prefix}_bannerclient`    TO `" . RENAME_PREFIX . "${prefix}_bannerclient`;";
        if (isset($tables["${prefix}_bannerfinish"])) $sqlqry[] = "RENAME TABLE `${prefix}_bannerfinish`    TO `" . RENAME_PREFIX . "${prefix}_bannerfinish`;";

        $sqlqry[] = "RENAME TABLE `${prefix}_bannerclient_neu` TO `${prefix}_bannerclient`;";
        $sqlqry[] = "RENAME TABLE `${prefix}_banner_neu`       TO `${prefix}_banner`;";

        $sqlqry[] = "DROP TABLE IF EXISTS `$bannertemptable`";
    }
    // END IF (ab hier nur ausfuehren, wenn Bannertabelle nicht auf dem aktuellen Stand)
}

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}

if (isset($tables["${prefix}_bannerclient"])) {
    $tf = setupGetTableFields("${prefix}_bannerclient");
    if ($tf['extrainfo']['Default'] !== null) {
        $sqlqry[] = "ALTER TABLE `${prefix}_bannerclient`
                CHANGE `extrainfo` `extrainfo` text NULL";
    }
}

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}

?>