<?php
/**
 * This file is part of 
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.3 $
 * $Author: tora60 $
 * $Date: 2007/12/22 14:15:56 $
 */

defined('mxMainFileLoaded') or die('access denied');
$modname = basename(dirname(dirname(__FILE__)));

unset($sqlqry);

if (!isset($tables["${prefix}_pages"])) {
    $sqlqry[] = "
CREATE TABLE `${prefix}_pages` (
  `pid` int(10) NOT NULL auto_increment,
  `cid` int(10) NOT NULL default '0',
  `title` varchar(255) NOT NULL default '',
  `subtitle` varchar(255) NOT NULL default '',
  `active` int(1) NOT NULL default '0',
  `page_header` text NULL,
  `text` longtext NULL,
  `page_footer` text NULL,
  `signature` text NULL,
  `date` datetime NOT NULL default '0000-00-00 00:00:00',
  `counter` int(10) NOT NULL default '0',
  `clanguage` varchar(30) NOT NULL default '',
  PRIMARY KEY  (`pid`),
  KEY `date` (`date`),
  KEY `active` (`active`),
  KEY `cid` (`cid`),
  KEY `title` (`title`)
) TYPE=MyISAM;";
}

if (!isset($tables["${prefix}_pages_categories"])) {
    $sqlqry[] = "
CREATE TABLE `${prefix}_pages_categories` (
  `cid` int(10) NOT NULL auto_increment,
  `title` varchar(255) NOT NULL default '',
  `description` text NULL,
  PRIMARY KEY  (`cid`),
  KEY `title` (`title`)
) TYPE=MyISAM;";
}

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}

if (isset($tables["${prefix}_pages"])) {
    // Felder aktualisieren
    $tf = setupGetTableFields("${prefix}_pages");
    if (!isset($tf['cid'])) $sqlqry[] = "ALTER TABLE `${prefix}_pages` ADD `cid` INT( 10 ) NOT NULL DEFAULT '0' AFTER `pid`";
    // ab 0.1.10
    if ($tf['text']['Type'] != 'longtext') $sqlqry[] = "ALTER TABLE `${prefix}_pages` CHANGE `text` `text` longtext NULL ";
    // Ende ab 0.1.10
    $indexes = setupGetTableIndexes("${prefix}_pages");
    if (!isset($indexes['date'])) $sqlqry[] = "ALTER TABLE `${prefix}_pages` ADD INDEX `date` ( `date` ) ";
    if (!isset($indexes['active'])) $sqlqry[] = "ALTER TABLE `${prefix}_pages` ADD INDEX `active` ( `active` ) ";
    if (!isset($indexes['cid'])) $sqlqry[] = "ALTER TABLE `${prefix}_pages` ADD INDEX `cid` ( `cid` ) ";
    if (!isset($indexes['title'])) $sqlqry[] = "ALTER TABLE `${prefix}_pages` ADD INDEX `title` ( `title` ) ";
}

if (isset($tables["${prefix}_pages_categories"])) {
    $indexes = setupGetTableIndexes("${prefix}_pages_categories");
    if (!isset($indexes['title'])) $sqlqry[] = "ALTER TABLE `${prefix}_pages_categories` ADD INDEX `title` ( `title` ) ";
}

if (isset($tables["${prefix}_pages"])) {
    $tf = setupGetTableFields("${prefix}_pages");
    if ($tf['page_header']['Default'] !== null || $tf['text']['Default'] !== null || $tf['page_footer']['Default'] !== null || $tf['signature']['Default'] !== null) {
        $sqlqry[] = "ALTER TABLE `${prefix}_pages`
                CHANGE `page_header` `page_header` text NULL,
                CHANGE `text` `text` longtext NULL,
                CHANGE `page_footer` `page_footer` text NULL,
                CHANGE `signature` `signature` text NULL";
    }
}

if (isset($tables["${prefix}_pages_categories"])) {
    $tf = setupGetTableFields("${prefix}_pages_categories");
    if ($tf['description']['Default'] !== null) {
        $sqlqry[] = "ALTER TABLE `${prefix}_pages_categories`
                CHANGE `description` `description` text NULL";
    }
}

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}

?>