<?php
/**
 * pragmaMx SMF Integration
 * Copyright by A.Ellsel (Andi) - http://pragmaMx.org
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Id: mx_functions.php,v 1.62 2008/06/28 22:50:27 tora60 Exp $
 */

function mxSmfCleanRequest()
{
    global $mxsmf, $boardurl;

    // Schrott entfernen
    unset($_REQUEST['modules_php?name'], $_GET['modules_php?name'], $_POST['modules_php?name']);

    if (isset($_REQUEST['action'])) {

// TODO: check im Standallone Modus ??
        if (mxDemoMode()) {
            /* Whitelist der Aktionen, die im Demomodus erlaubt sind */
            $allowed = array(
                'activate',
                'admin',
                'announce',
                'ban',
                'boardrecount',
                'buddy',
                'calendar',
                'cleanperms',
                'collapse',
                'deletemsg',
                'detailedversion',
                'display',
                'dlattach',
                'editpoll',
                'editpoll2',
                'featuresettings',
                'featuresettings2',
                'findmember',
                'help',
                'helpadmin',
                'im',
                'lock',
                'lockVoting',
                'login',
                'login2',
                'logout',
                'manageboards',
                'managecalendar',
                'managesearch',
                'markasread',
                'membergroups',
                'mergetopics',
                'mlist',
                'modifycat',
                'modifykarma',
                'modlog',
                'movetopic',
                'movetopic2',
                'news',
                'notify',
                'notifyboard',
                'permissions',
                'pm',
                'post',
                'post2',
                'postsettings',
                'printpage',
                'profile',
                'profile2',
                'quotefast',
                'quickmod',
                'quickmod2',
                'recent',
                'register',
                'register2',
                'reminder',
                'removetopic2',
                'removeoldtopics2',
                'removepoll',
                'repairboards',
                'reporttm',
                'reports',
                'requestmembers',
                'search',
                'search2',
                'sendtopic',
                'smstats',
                'spellcheck',
                'splittopics',
                'stats',
                'sticky',
                'unread',
                'unreadreplies',
                'viewmembers',
                'viewprofile',
                'vote',
                'who',
                '.xml',
                );
            if (!in_array($_REQUEST['action'], $allowed)) {
                mxErrorScreen('Sorry, this action is not allowed in Demomode.');
                exit;
            }
        }

        // unerwuenschte Aktionen umschreiben..
        $false_action = array('convertutf8' => 'maintain',
            'convertentities' => 'maintain',
            );
        if (isset($false_action[$_REQUEST['action']])) {
            $_REQUEST['action'] = $false_action[$_REQUEST['action']];
            if (isset($_GET['action'])) $_GET['action'] = $_REQUEST['action'];
            if (isset($_POST['action'])) $_POST['action'] = $_REQUEST['action'];
        }
        // unerwuenschte Aktion per $action => Umleitung nach..
        $false_action = array('setreserve' => 'admin.php?op=Configure',
            'setreserve2' => 'admin.php?op=Configure',
            'regcenter' => 'admin.php?op=mod_users',
            'register' => 'modules.php?name=User_Registration',
            'register2' => 'modules.php?name=User_Registration',
            'reminder' => 'modules.php?name=Your_Account&op=pass_lost',
            'login' => 'modules.php?name=Your_Account',
            'login2' => 'modules.php?name=Your_Account',
            'logout' => 'modules.php?name=Your_Account&op=logout',
            );
        if (isset($false_action[$_REQUEST['action']])) {
            header('Refresh: 0; URL=' . MX_BASE_URL . strtr($false_action[$_REQUEST['action']], array(' ' => '%20', ';' => '%3b')));
            exit;
        }
        // sonstige kritische Aktionen ueber $sa (sub-Action) abfangen
        if (isset($_REQUEST['sa'])) {
            // deleteAccount und Zugangseinstellungen abfangen
            $false_sa = array('deleteAccount' => 'modules.php?name=Your_Account',
                'account' => 'modules.php?name=Your_Account',
                );
            if (isset($false_action[$_REQUEST['sa']])) {
                header('Refresh: 0; URL=' . MX_BASE_URL . strtr($false_action[$_REQUEST['sa']], array(' ' => '%20', ';' => '%3b')));
                exit;
            }
        }
        // beim Speichern der Servereinstellungen wird unbedingt $_POST['boardurl'] benoetigt :-((
        if (($_REQUEST['action'] === 'modsettings2' || $_REQUEST['action'] === 'serversettings2') && isset($_POST['mtitle']) && isset($_POST['mbname'])) {
            $_POST['boardurl'] = $boardurl;
        }
        // verhindern, dass eine Systemgruppe angefuegt werden kann
        if (isset($_REQUEST['generalgroup']) && $_REQUEST['generalgroup'] > 0) {
            $_POST['generalgroup'] = 0;
            // $_REQUEST['generalgroup'] = 0;
            $_POST['postgroup'] = 1;
            // $_REQUEST['postgroup'] = 1;
        }
        if (($_REQUEST['action'] === 'membergroups;sa=add' && !isset($_REQUEST['min_posts']) && isset($_REQUEST['copyperm'])) || (isset($_REQUEST['min_posts']) && $_REQUEST['min_posts'] < 0)) {
            $_POST['min_posts'] = 1;
            // $_REQUEST['min_posts'] = 1;
            unset($_REQUEST['copyperm'], $_REQUEST['perm_type'], $_REQUEST['level']);
            unset($_POST['copyperm'], $_POST['perm_type'], $_POST['level']);
        }
        // verhindern, dass eine Systemgruppe angefuegt werden kann
        if ($_REQUEST['action'] == 'membergroups;sa=add' && !isset($_REQUEST['postgroup']) && !isset($_REQUEST['generalgroup'])) {
            $_POST['postgroup'] = 1;
            $_POST['generalgroup'] = 0;
        }
    }
    // fuer das mX kritische Formularwerte wieder zurueck wandeln
    // $file
    if (isset($_GET['mxsmf_file'])) {
        $_GET['file'] = $_GET['mxsmf_file'];
        unset($_GET['mxsmf_file']);
    }
    if (isset($_POST['mxsmf_file'])) {
        $_POST['file'] = $_POST['mxsmf_file'];
        unset($_POST['mxsmf_file']);
    }
    // $name
    if (isset($_GET['mxsmf_name'])) {
        $_GET['name'] = $_GET['mxsmf_name'];
        unset($_GET['mxsmf_name']);
    }
    if (isset($_POST['mxsmf_name'])) {
        $_POST['name'] = $_POST['mxsmf_name'];
        unset($_POST['mxsmf_name']);
    }
    /* Zeilenumbruch in URL ist unsinnig, bug-id: 441 */
    if (isset($_GET['delim']) && $_GET['delim'] == 'backspace') {
        $_GET['delim'] = "\\\\n";
    }
    if (isset($_POST['delim']) && $_POST['delim'] == 'backspace') {
        $_POST['delim'] = "\\\\n";
    }
    // Request neu schreiben
    $_REQUEST = array_merge($_REQUEST, $_GET, $_POST);
    // $_REQUEST['start'] sollte immer vorhanden sein
    if (!isset($_REQUEST['start']) || $_REQUEST['start'] < 0) {
        $_REQUEST['start'] = 0;
    }
}

/**
 * extra ausgelagert weil in index.php und in mx_SSI.php verwendet
 */
function mxSmf_loadConstants()
{
    if (defined('PRAGMA_SMF_DBTABLE_ADMIN')) {
        return true;
    }
    global $prefix, $user_prefix, $mxsmf;
    // Prefix and names for the database tables
    define('PRAGMA_SMF_DBTABLE_ADMIN', $prefix . '_authors'); // The members table
    define('PRAGMA_SMF_DBTABLE_USER', $user_prefix . '_users'); // The members table
    // if (defined('MX_VERSION_NUM')) { // ab mX2.2 wird hier der User-Prefix verwendet, MX_VERSION_NUM ist erst ab 2.2 definiert
    // define('PRAGMA_SMF_DBTABLE_GROUPS', $user_prefix . '_groups_access'); // The groups table
    // } else {
    define('PRAGMA_SMF_DBTABLE_GROUPS', $prefix . '_groups_access'); // The groups table
    // }
    define('PRAGMA_SMF_DBTABLE_AVATARS', $prefix . '_avatar'); // The Avatar table
    // Group definitions
    define('PRAGMA_SMF_GROUP_DEFAULT' , 0);
    define('PRAGMA_SMF_GROUP_ADMINISTR', 1);
    define('PRAGMA_SMF_GROUP_GLOBALMOD', 2);
    define('PRAGMA_SMF_GROUP_MODERATOR', 3);
    // mod_rewrite aktiv?
    if ((
            (!empty($GLOBALS['mxUseModrewrite']['anony']) && !MX_IS_USER && !MX_IS_ADMIN) ||
                (!empty($GLOBALS['mxUseModrewrite']['users']) && MX_IS_USER && !MX_IS_ADMIN) ||
                (!empty($GLOBALS['mxUseModrewrite']['admin']) && MX_IS_ADMIN)
                ) && file_exists('.htaccess')) {
        define('PRAGMA_SMF_USE_MODREWRITE', true);
        if (!isset($modrew_alternate)) {
            $modrew_alternate = '~';
        }
    } else {
        define('PRAGMA_SMF_USE_MODREWRITE', false);
    }
}

/**
 * Anpassen der HTML Ausgaben (integrate_exit)
 */
function mxSmf_display($show_header_footer = true)
{
    global $context, $mxsmf, $smfoutputcleaned;
    // bestaetigen, dass die Funktion ausgefuehrt wurde
    $smfoutputcleaned = true;
    // bei bestimmten Aktionen, hier das script beenden
    if ($context['current_action'] == 'dlattach') {
        exit;
    }
    // vorher initialisierten Zwischenspeicher in eine Variable lesen und den Zwischenspeicher loeschen.
    $smfContent = ob_get_clean();
    // wenn keine Ausgabe erfolgt ist, hier die Funktion beenden
    if (!$smfContent) {
        return;
    }
    // den rss-Feed extra behandeln
    if ($context['current_action'] == '.xml') {
        $smfContent = mxSmfPrepareOutput_RSS($smfContent);
        echo $smfContent;
        return;
    }
    // feststellen ob header.php und footer.php eingebunden werden muessen
    // $show_header_footer wird beim Aufruf in Funktion obExit() uebergeben
    if (!$show_header_footer || !in_array('main', $context['template_layers']) || !empty($mxsmf['hide_pragma_header'])) {
        echo $smfContent;
        return;
    }
    // die HTML-Ausgabe ueberarbeiten
    $smfContent = mxSmfPrepareOutput($smfContent);
    // die style.css des mx-Themes einbinden
    $smfContent = mxSmfPrepareStylesheet($smfContent);
    // den eigentlichen Output (body) und Headbereich extrahieren <body></body> muss komplett enthalten sein)
    preg_match("#(.*)<body[^>]*?>(.*?)</body>#siU", $smfContent, $matches);
    if (empty($matches[2])) {
        die('<b>SMF-port Template error</b><br />Failed to find valid theme body-tag in:<br /><pre>' . htmlspecialchars($smfContent) . '</pre>');
    }
    // Inhalt des Head-Bereichs, Teile davon werden spaeter in den mx-Headbereich integriert, der Rest verworfen
    $smfHeader = trim($matches[1]);
    // Inhalt zwischen <body> und </body>
    $smfContent = trim($matches[2]);
    // alle Link-Tags im SMF-Headbereich ermitteln
    if (preg_match_all("#<link[^>]*rel[^>]*>#si", $smfHeader, $matches)) {
        if ($context['current_action'] === 'help') {
            /* die Hilfe verwendet eine extra css Datei, diese hier rausfiltern und aendern (bug-id: 767)*/
            foreach ($matches[0] as $value) {
                if (strpos($value, '/help.css')) {
                    $value = '<link rel="stylesheet" type="text/css" href="' . PMX_HOME_URL . '/modules/' . $mxsmf['module_name'] . '/mx_help.css" />';
                }
                pmxHeader::add($value);
            }
        } else {
            pmxHeader::add($matches[0]);
        }
    }
    // alle style-Tags im SMF-Headbereich ermitteln und an den neuen Text anfuegen
    if (preg_match_all("#<style.*</style>#siU", $smfHeader, $matches)) {
        pmxHeader::add($matches[0]);
    }
    // alle script-Tags im SMF-Headbereich ermitteln und an den neuen Text anfuegen
    if (preg_match_all("#<script.*</script>#siU", $smfHeader, $matches)) {
        pmxHeader::add($matches[0]);
    }
    // versch. Metatags des pragmaMx durch die entsprechenden vom Forum ersetzen
    if (preg_match('#<meta[^>]*description[^>]*content=\s*["\']?([^"\']+)["\']?[^>]*>#is', $smfHeader, $matches)) {
        pmxHeader::set_description($matches[1]);
    }
    if (preg_match('#<meta[^>]*keywords[^>]*content=\s*["\']?([^"\']+)["\']?[^>]*>#is', $smfHeader, $matches)) {
        $matches = preg_split('#\s*,\s*#', $GLOBALS['metakeywords'] . ',' . $matches[1]);
        $matches = implode(',', array_unique($matches));
        pmxHeader::set_keywords($matches);
    }
    // den Titel des Forums auslesen und damit den mx-Titel ersetzen
    if (isset($context['page_title'])) {
        $GLOBALS['pagetitle'] = $context['page_title'];
    } else {
        if (preg_match("#<title>(.*)</title>#si", $smfHeader, $matches)) {
            $GLOBALS['pagetitle'] = $matches[1];
        }
    }
    unset($smfHeader);

    /* hier beginnt die eigentliche Ausgabe! */
    include_once('header.php');
    // Die Platzhalter fuer die Variablen aus der (mx) theme.php ersetzen durch ihren realen Wert
    // Die Platzhalter muessen folgendes Format haben: {{theme_var_VARIABLENNAME}} z.B. {{theme_var_bgcolor3}}
    if (preg_match_all('#\{\{theme_var_([[:alnum:]]*)\}\}#', $smfContent, $matches)) {
        // erst hier sind dann die Themefarben verfuegbar...
        $find = array_unique($matches[0]);
        $replace = array_unique($matches[1]);
        foreach ($replace as $i => $var) {
            $replace[$i] = $$var;
        }
        $smfContent = str_replace($find, $replace, $smfContent);
    }
    OpenTable();
    echo "\n\n<!-- SMF/pragmaMx Bridge by tora60 -->\n<!-- SMF OUTPUT BEGIN -->\n" . $smfContent . "\n<!-- SMF OUTPUT END -->\n\n";
    unset($smfContent, $find, $replace, $i, $var, $matches);
    CloseTable();
    include_once('footer.php');
}
/* end function mxSmf_display() */

/**
 * mxSmf_preLoad
 *
 * ueberschreiben von bestimmten Konfigurationseinstellungen.
 * dynamisch in reloadSettings() aktiviert durch $modSettings['integrate_pre_load']
 * pragmaMx.org
 *
 * @author Andi
 */
function mxSmf_preLoad()
{
    global $mxsmf, $modSettings;
    if (!defined('SMF_IN_PRAGMAMX'))
        return;
    // der Browser wird bereits in der mx-session gecheckt
    $modSettings['disableCheckUA'] = 1;
    // Ersatz Redirekt Funktion anstatt der smf-Funktion
    $modSettings['integrate_redirect'] = 'mxSmf_redirect';
    // logout fuer Admin und User, damit nicht unendlich umgeleitet wird, z.B. bei Banning
    $modSettings['integrate_logout'] = 'mxSmf_logout';
    // Ersatz Redirekt Funktion anstatt der smf-Funktion
    $modSettings['integrate_exit'] = 'mxSmf_display';
    // im pragmaMx werden immer backslashes angefuegt, deswegen hier 1....
    // $modSettings['integrate_magic_quotes'] = 1;
    // Das Passwort ueberpruefen, weil im pragmaMx nur md5
    $modSettings['integrate_verify_password'] = 'mxSmf_verify_password';
    // bei Aenderung der Userdaten, diese auch in pragmaMx anpassen
    $modSettings['integrate_change_member_data'] = 'mxSmf_change_member_data';
    // Ausgabe fuer eMail-Output
    $modSettings['integrate_outgoing_email'] = 'mxSmf_outgoing_email';
    // Probleme bei der charset-Konvertierung in eMails fixen
    $modSettings['disableQuotedPrintable'] = intval($mxsmf['disableQuotedPrintable']);
    // die restlichen kommen aus einem Array, welches auch zum Speichern der Settings verwendet wird
    $modSettings = array_merge($modSettings, mxsmf_getHidedSettings());
    // fuer den relativen Pfad vom mx-root zum Avatarordner, die benoetigten ../ erstellen
    $check = preg_split('#[\\\/]#', str_replace(dirname(dirname(dirname(__file__))), '', $modSettings['avatar_directory']), -1, PREG_SPLIT_NO_EMPTY);
    $mxsmf['DirsToAvatar'] = str_repeat('../', count($check));
}

/**
 * mxSmf_redirect
 *
 * Behandlung der URL und weitere Einstellungen zum redirect des SMF
 * dynamisch in redirectexit() aktiviert durch $modSettings['integrate_redirect']
 * pragmaMx.org
 *
 * @author Andi
 */
function mxSmf_redirect($setLocation, $refresh)
{
    global $scripturl, $mxsmf;
    if (!defined('SMF_IN_PRAGMAMX'))
        return true;
    $mxsmf['hide_pragma_header'] = true;
    $setLocation = mxSmfCreatePmxUrl($setLocation);
    // Removing leading slashes from redirect url
    $setLocation = rtrim($setLocation, '/ ');
    // change &amp; to &
    $setLocation = str_replace('&amp;', '&', $setLocation);
    // Debugging.
    if (isset($GLOBALS['db_show_debug']) && $GLOBALS['db_show_debug'] === true)
        $_SESSION['debug_redirect'] = &$GLOBALS['db_cache'];
    @session_write_close();
    // Clear out the stat cache.
    trackStats();
    // We send a Refresh header only in special cases because Location looks better. (and is quicker...)
    if ($refresh)
        header('Refresh: 0; URL=' . strtr($setLocation, array(' ' => '%20', ';' => '%3b')));
    else
        header('Location: ' . str_replace(' ', '%20', $setLocation));
    exit;
}

/**
 * mxSmf_outgoing_email
 *
 * Die Ausgabe von Mails behandeln
 *
 * @author Andi
 */
function mxSmf_outgoing_email(&$subject, &$message, &$headers)
{
    global $mxsmf, $scripturl, $boardurl;
    // eventuelle URL's in der Nachricht fixen
    $message = mxSmfPrepareOutput(mxHtmlEntityDecode($message), false);
    // &amp; wieder durch & ersetzen
    $message = preg_replace('#(' . preg_quote(MX_BASE_URL, '#') . 'modules\.php\?name=' . $mxsmf['module_name'] . ')&amp;#', '\1&', $message);
    // if (MX_IS_ADMIN) {
    // mxDebugFuncVars($subject, $message, $headers);
    // exit;
    // }
}

/**
 * mxSmf_logout
 *
 * loggt den User / Admin auch im pragmaMx aus
 * dies wird z.B. in der Userbanning-Funktion benoetigt
 * pragmaMx.org
 *
 * @author Andi
 */
function mxSmf_logout($memberName)
{
    if (MX_IS_ADMIN || MX_IS_USER) {
        mxSessionDestroy();
    }
}

/**
 * Admin.php:
 * das sind Optionen des Konfigurationsmenues, die nicht angezeigt werden sollen,
 * aber durch einen Standardwert vorbelegt werden muessen
 */
function mxsmf_getHidedSettings()
{
    if (!defined('SMF_IN_PRAGMAMX'))
        return true;

    global $mxsmf;

    $hidedsettings['lastActive'] = MX_SETINACTIVE_MINS / 60; // Zeit der Benutzeranzeige unter 'Wer ist online' (in Minuten)
    // gZip wird ueber das mX gesteuert, also hier immer 0
    $hidedsettings['enableCompressedOutput'] = 0; // Komprimierte Ausgabe aktivieren
    $hidedsettings['allow_editDisplayName'] = 0; // Benutzern erlauben, den angezeigten Namen zu aendern?
    $hidedsettings['failed_login_threshold'] = 0; // Fehlerhafte Login Versuche
    $hidedsettings['databaseSession_enable'] = 1; // Benutze datenbankgestuetzte Sitzungen
    // Zeit bevor eine Sitzung ablaeuft (in Sekunden)
    $hidedsettings['databaseSession_lifetime'] = max(60, ini_get('session.gc_maxlifetime'));
    $hidedsettings['localCookies'] = 0; // Aktiviere lokales Speichern der Cookies
    $hidedsettings['globalCookies'] = 0; // Subdomain unabhaengige Cookies verwenden?
    $hidedsettings['cache_enable'] = 0; // mmcache fuer Session verwenden, falls vorhanden?
    $hidedsettings['cookieTime'] = 60; // Gueltigkeitsdauer des Login Cookies (in Minuten)
    $hidedsettings['enableVBStyleLogin'] = 0; // VB Style Login deaktivieren
    // der ganze Block:
    $hidedsettings['registration_method'] = 3; // Registrierungsmethode bei neuen Mitgliedern // 3 = deaktiviert
    $hidedsettings['notify_on_new_registration'] = 0; // Administrator benachrichtigen, wenn sich ein neuer Benutzer anmeldet?
    $hidedsettings['send_validation_onChange'] = 0; // Neues Passwort per E-Mail zusenden, wenn ein Benutzer die E-Mail Adresse aendert?
    $hidedsettings['send_welcomeEmail'] = 0; // Willkommens E-Mail auch senden, wenn 'Neues Passwort zusenden' nicht aktiviert ist?
    $hidedsettings['approveAccountDeletion'] = 1; // Zustimmung des Administrators benoetigt, wenn ein Mitglied seinen Zugang loescht?
    $hidedsettings['userLanguage'] = 1; // Individuelle Benutzersprache erlauben (1, damit die Sprachumstellung mit den mx-Einstellungen laeuft)
    $hidedsettings['timeLoadPageEnable'] = 0; // Aktiviere Zeitmessung beim Erstellen von Seiten
    $hidedsettings['queryless_urls'] = 0; // Zeige URLs ohne "?" Nur Apache!
    // Mailsettings:
    if ($GLOBALS['mailauth'] == 'smtp' && $GLOBALS['mailuname']) {
        $hidedsettings['mail_type'] = 'SMTP';
        $hidedsettings['smtp_host'] = $GLOBALS['mailhost'];
        $hidedsettings['smtp_port'] = $GLOBALS['mailport'];
        $hidedsettings['smtp_username'] = $GLOBALS['mailuname'];
        $hidedsettings['smtp_password'] = $GLOBALS['mailpass'];
    } else {
        $hidedsettings['mail_type'] = 'sendmail';
        $hidedsettings['smtp_host'] = '';
        $hidedsettings['smtp_port'] = '';
        $hidedsettings['smtp_username'] = '';
        $hidedsettings['smtp_password'] = '';
    }
    // if ($mxsmf['skip_check_doublepost']) {
    // - Mitglied beim Antworten warnen, wenn eine neuer Beitrag geschrieben worden ist?
    // $hidedsettings['enableNewReplyWarning'] = 1;
    // - TODO: diese Option bleibt eingeschaltet, solange das Problem in der
    // Security.php (Funktion checkSubmitOnce) nicht behoben ist
    // }
    // sonstige, die nicht im Adminmenue stehen
    $hidedsettings['requireAgreement'] = 0; // Nutzungsbedingungen anzeigen und bei Registrierung Zustimmung verlangen?.
    return $hidedsettings;
}

/**
 * mxSmfLoadUserSettings
 *
 * Authentifizierung und Benutzerdatenabgleich.
 * pragmaMx.org
 *
 * @author Andi
 */
function mxSmfLoadUserSettings()
{
    global $db_prefix, $cookiename, $ID_MEMBER, $modSettings, $mxsmf;

    if (!defined('SMF_IN_PRAGMAMX'))
        return true;

    static $smfinfo;
    if (isset($smfinfo))
        return $smfinfo;

    if (isset($_COOKIE[$cookiename])) unset($_COOKIE[$cookiename]);
    $userInGroups = array();
    $changed = false;
    $ID_MEMBER = 0;
    $isadmin = false;
    if (MX_IS_USER) {
        $mxinfo = mxGetUserData();
        $ID_MEMBER = intval($mxinfo['uid']);
    }

    if (MX_IS_ADMIN) {
        $admindata = mxGetAdminData();
        if (!$ID_MEMBER && !empty($admindata['user_uid'])) {
            // Admin, nicht als User eingeloggt, aber mit autologin-id im Adminprofil
            $mxinfo = mxGetUserDataFromUid($admindata['user_uid']);
            $ID_MEMBER = intval($mxinfo['uid']);
        } else if ($ID_MEMBER && (!empty($admindata['user_uid']) && $admindata['user_uid'] !== $ID_MEMBER)) {
            // Admin, als User eingeloggt, aber mit anderem USeraccount als die autologin-id im Adminprofil
            $mxinfo = mxGetUserDataFromUid($admindata['user_uid']);
            $ID_MEMBER = intval($mxinfo['uid']);
        }
        if ($ID_MEMBER) {
            $isadmin = true;
        }
    }
    // Grundeinstellung der Sprache vom pragmaMx uebernehmen
    unset($_REQUEST['language']);
    $lang = $GLOBALS['currentlang'];
    // fallback Du-Version
    if ($lang == 'german_du') {
        if (@file_exists($mxsmf['path_themes'] . '/default/languages/index.' . $mxsmf['german_du_convention'] . '.php')) {
            $lang = $mxsmf['german_du_convention'];
        } else {
            $lang = 'german';
        }
    }
    // fallback, falls Sprache nicht vorhanden, immer auf english stellen
    if (@!file_exists($mxsmf['path_themes'] . '/default/languages/index.' . $lang . '.php')) {
        $lang = 'english';
    }
    $_SESSION['language'] = $lang;
    // wenn kein angemeldeter User, Funktion hier beenden und
    // zur Sicherheit die Sprache zusaetzlich in Request speichern
    if (!$ID_MEMBER || !isset($mxinfo)) {
        $_REQUEST['language'] = $lang;
        return array('ID_MEMBER' => 0);
    }
    // sicherstellen, dass die Gruppentabellen abgeglichen sind
    if (mxSmfMustCheckUser()) {
        mxSmfSynchronizeGroups();
    }

    $smfinfo = mxSmfGetUserData($mxinfo['uid']);

    $setinfo['ID_GROUP'] = $smfinfo['u_ID_GROUP'];
    $setinfo['additionalGroups'] = $smfinfo['u_additionalGroups'];
    $setinfo['gender'] = $smfinfo['u_gender'];
    $setinfo['birthdate'] = $smfinfo['u_birthdate'];
    $setinfo['memberName'] = $mxinfo['uname'];
    $setinfo['passwd'] = $mxinfo['pass'];
    $setinfo['emailAddress'] = $mxinfo['email'];
    $setinfo['realName'] = $mxinfo['uname'];
    $setinfo['websiteUrl'] = $mxinfo['url'];
    $setinfo['websiteTitle'] = ''; // $mxinfo['url'];
    $setinfo['location'] = $mxinfo['user_from'];
    $setinfo['ICQ'] = $mxinfo['user_icq'];
    $setinfo['AIM'] = $mxinfo['user_aim'];
    $setinfo['YIM'] = $mxinfo['user_yim'];
    $setinfo['MSN'] = $mxinfo['user_msnm'];
    // $smfinfo['avatar'] = 'http://localhost/dev-SMF/pragmaMx/html/images/forum/member_avatar/Andi.avatar.1.jpg';
    // $smfinfo['avatar'] = 'http://localhost/dev-SMF/pragmaMx/html/images/forum/avatar/006.gif';
    // $smfinfo['avatar'] = '';
    // mxDebugFuncVars($setinfo);
    // falls ein Admin unter einem anderen Usernamen als dem im Adminprofil angegebenen eingeloggt ist,
    // fuer diese Sitzung die Adminberechtigung entziehen aber die Datenbank trotzdem richtig pruefen u. aktualisieren
    if (!$isadmin && ($smfinfo['u_ID_GROUP'] == PRAGMA_SMF_GROUP_ADMINISTR || $smfinfo['u_ID_GROUP'] == $mxsmf['group_admin_or_moderator'])) {
        $isadmin = false;
    }
    // ab smf 1.1 sind die Passwoerter sha1 verschluesselt, dazu wird ein saltwert in der tabelle gespeichert.
    // da durch die Userkonvertierung dort aber nur md5-Passwoerter vom pragmaMx drin stehen, muss der salt-Wert leer sein,
    // damit das Login in der Standallone Version fuer Admins noch funktioniert. Diese Option muss aber in der config.php
    // der Forums-Bridge freigeschaltet sein
    if ($isadmin && $mxsmf['allow_standallone_login']) {
        $setinfo['passwordSalt'] = '';
    }

    if (!empty($smfinfo['ID_MEMBER'])) {
        // bestehender Datensatz
        // falls von einer Konvertierung, der eigentlich lokale Avatar mit URL eingetragen wurde, diesen umwandeln
        if (strpos($smfinfo['avatar'], MX_BASE_URL) !== false) {
            $check = str_replace(array(MX_BASE_URL . MX_PATH_AVATAR, MX_BASE_URL . MX_PATH_MEMBERAVATAR), '', $smfinfo['avatar']);
            if ($check != $smfinfo['avatar']) {
                if (file_exists(MX_PATH_AVATAR . $check)) {
                    $setinfo['avatar'] = $mxsmf['DirsToAvatar'] . MX_PATH_AVATAR . $check;
                } else if (mxsmf_AvatarModEnabled() && file_exists(MX_PATH_MEMBERAVATAR . $check)) {
                    $setinfo['avatar'] = $mxsmf['DirsToAvatar'] . MX_PATH_MEMBERAVATAR . $check;
                }
            }
        }
        // die Teile der AQL-Anfrage erstellen
        foreach ($setinfo as $key => $value) {
            if ($smfinfo[$key] != $value) {
                $sqlpart[] = "`$key`='" . mysql_real_escape_string($value) . "'";
            }
        }
        // den bestehenden Datensatz aktualisieren
        if (isset($sqlpart)) {
            $qry = "UPDATE {$db_prefix}members SET " . implode(', ', $sqlpart) . " WHERE ID_MEMBER = $ID_MEMBER";
            db_query($qry, __FILE__, __LINE__);
            // das Rueckgabearray aktualisieren
            $smfinfo = array_merge($smfinfo, $setinfo);
            /* Daten wurden geaendert */
            $changed = true;
        }
    } else {
        // neuer Datensatz
        $setinfo['ID_POST_GROUP'] = mxSmfGetMinPostgroup(); // die Post-Gruppe mit der kleinsten Anzahl Posts
        $setinfo['ID_MEMBER'] = intval($mxinfo['uid']);
        $setinfo['dateRegistered'] = intval($mxinfo['user_regtime']);
        $setinfo['lastLogin'] = time();
        $setinfo['memberIP'] = $mxinfo['user_lastip'];
        $setinfo['is_activated'] = 1;
        $setinfo['hideEmail'] = ((empty($mxinfo['femail']) || $mxinfo['user_viewemail']) ? 1 : 0);
        $setinfo['signature'] = strip_tags(preg_replace('#<br\s*/*>\s*#i', "\n", $mxinfo['user_sig']));
        // den Avatar entsprechend konvertieren
        if (empty($mxinfo['user_avatar']) || $mxinfo['user_avatar'] == 'blank.gif') {
            $setinfo['avatar'] = '';
        } else {
            if (mxsmf_AvatarModEnabled() && file_exists(MX_PATH_MEMBERAVATAR . '/' . $mxinfo['user_avatar'])) {
                $setinfo['avatar'] = $mxsmf['DirsToAvatar'] . MX_PATH_MEMBERAVATAR . '/' . $mxinfo['user_avatar'];
            } else if (file_exists(MX_PATH_AVATAR . '/' . $mxinfo['user_avatar'])) {
                $setinfo['avatar'] = $mxsmf['DirsToAvatar'] . MX_PATH_AVATAR . '/' . $mxinfo['user_avatar'];
            } else {
                $setinfo['avatar'] = '';
            }
        }
        // die Teile der SQL-Anfrage erstellen
        foreach ($setinfo as $key => $value) {
            $sqlpart[] = "`$key`='" . mysql_real_escape_string($value) . "'";
        }
        // den neuen Datensatz einfuegen
        if (isset($sqlpart)) {
            $qry = "REPLACE INTO {$db_prefix}members SET " . implode(', ', $sqlpart) . "";
            db_query($qry, __FILE__, __LINE__);
            // Checkvariable fuer Statistik aktualisieren (Vergleich mit $modSettings['latestMember'])
            updateSettings(array('pmxLatestMember' => $setinfo['ID_MEMBER']));
            // das Rueckgabearray aktualisieren
            $result = db_query("
				SELECT mem.*, IFNULL(a.ID_ATTACH, 0) AS ID_ATTACH
				FROM {$db_prefix}members AS mem
					LEFT JOIN {$db_prefix}attachments AS a ON (a.ID_MEMBER = $ID_MEMBER)
				WHERE mem.ID_MEMBER = $ID_MEMBER
				LIMIT 1", __FILE__, __LINE__);
            $smfinfo = mysql_fetch_assoc($result);
            /* Daten wurden geaendert */
            $changed = true;
            if ($smfinfo) {
                // falls einer mit gleichem Namen existiert, diesen loeschen (zwar unwahrscheinlich, aber man weiss nie)
                db_query("DELETE FROM {$db_prefix}members WHERE memberName = '" . mysql_real_escape_string($smfinfo['memberName']) . "' AND ID_MEMBER <> " . intval($smfinfo['ID_MEMBER']) . "", __FILE__, __LINE__);
                // Postinganzahl aktualisieren, falls der User bereits "aeltere" Posts hat
                $result = db_query("SELECT count( ID_MSG ) AS cnt FROM {$db_prefix}messages WHERE ID_MEMBER = " . intval($smfinfo['ID_MEMBER']) . " AND posterName = '" . mysql_real_escape_string($smfinfo['memberName']) . "'", __FILE__, __LINE__);
                $row = mysql_fetch_assoc($result);
                if ($row) {
                    db_query("UPDATE {$db_prefix}members SET `posts`=" . $row['cnt'] . " WHERE `ID_MEMBER`=" . intval($smfinfo['ID_MEMBER']) . " AND `posts`<>" . $row['cnt'] . "", __FILE__, __LINE__);
                }
                // PM aktualisieren, falls der User bereits "aeltere" Nachrichten hat
                $result = db_query("SELECT count( ID_PM ) AS cnt FROM {$db_prefix}pm_recipients WHERE ID_MEMBER = " . intval($smfinfo['ID_MEMBER']), __FILE__, __LINE__);
                $row = mysql_fetch_assoc($result);
                if ($row) {
                    db_query("UPDATE {$db_prefix}members SET `instantMessages`=" . $row['cnt'] . " WHERE `ID_MEMBER`=" . intval($smfinfo['ID_MEMBER']) . " AND `instantMessages`<>" . $row['cnt'] . "", __FILE__, __LINE__);
                }
            }
            mysql_free_result($result);
        }
    }

    // zur Sicherheit nochmal Sprachuebernahme vom mX
    $smfinfo['lngfile'] = $lang;

    if (!$isadmin) {
        $smfinfo['ID_GROUP'] = intval($smfinfo['additionalGroups']);
    }
    // die SMF-Standardgruppe "Normale Mitglieder" (id=0) noch anfuegen, falls die 0 noch nicht vorhanden
    $smfinfo['additionalGroups'] = implode(',', array_unique(explode(',', $smfinfo['additionalGroups'] . ',0')));

    if ($changed || mxSmfMustCheckUser($ID_MEMBER)) {
        mxsmf_ConvertUsers($ID_MEMBER);
    }

    return $smfinfo;
}

/**
 * Group table synchronisation
 */
function mxSmfSynchronizeGroups()
{
    global $db_prefix, $context, $smfdefaultgroups, $sourcedir;
    // checken ob Funktion bereits ausgefuehrt wurde, falls ja, beenden
    static $isrunned;
    if (isset($isrunned)) {
        return;
    }
    // global $prefix, $CONFIG;
    $MX_GROUPS = array();
    $SMF_GROUPS = array();

    $sql = "SELECT access_id as ID_GROUP, access_title as group_name FROM " . PRAGMA_SMF_DBTABLE_GROUPS . " WHERE access_id<>'" . intval($GLOBALS['default_group']) . "'";
    $result = db_query($sql, __FILE__, __LINE__);
    while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
        $MX_GROUPS[$row['ID_GROUP']] = $row['group_name'];
    }
    mysql_free_result($result);

    $qry = "SELECT ID_GROUP, mx_group
					FROM {$db_prefix}membergroups AS smf
					WHERE minPosts<0
					ORDER BY ID_GROUP ASC";
    $result = db_query($qry, __FILE__, __LINE__);
    while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
        // weil spaeter als Arrayindex verwendet, in Zahl wandeln, falls NULL
        $row['mx_group'] = intval($row['mx_group']);
        // wenn Gruppen-ID kleiner als 1, die Gruppe loeschen (unwahrscheinlich)
        if ($row['ID_GROUP'] <= 0) {
            $delGroupArray[] = $row['ID_GROUP'];
            // mxDebugFuncVars(2);
        }
        // wenn eine mx-ID eingetragen ist, den Wert spaeter entfernen
        else if ($row['ID_GROUP'] <= 3 && !empty($row['mx_group'])) {
            $setNullArray[] = $row['ID_GROUP'];
            $SMF_GROUPS[$row['ID_GROUP']] = $row;
            // mxDebugFuncVars(3);
        }
        // wenn mx-Gruppe, aber keine mx-ID eingetragen, die Gruppe loeschen
        else if ($row['ID_GROUP'] > 3 && empty($row['mx_group'])) {
            $delGroupArray[] = $row['ID_GROUP'];
            // mxDebugFuncVars(4);
        }
        // wenn mx-ID nicht in mx Tabelle existiert, die Gruppe loeschen
        else if (!isset($MX_GROUPS[$row['mx_group']]) && !empty($row['mx_group'])) {
            $delGroupArray[] = $row['ID_GROUP'];
            // mxDebugFuncVars(5);
        }
        // ansonsten, die Gruppe an das SMF-Gruppenarray anfuegen
        else {
            $SMF_GROUPS[$row['ID_GROUP']] = $row;
            // mxDebugFuncVars(6);
            if ($row['mx_group']) {
                $RELATIONGROUP[$row['mx_group']] = $row;
                // mxDebugFuncVars(7);
            }
        }
    }
    mysql_free_result($result);

    if (isset($delGroupArray)) {
        $deleted = false;
        // wenn fehlerhafte SMF-Gruppen vorhanden, diese loeschen
        // und die Zuordnungen aus anderen Tabellen (User etc.) entfernen
        foreach ($delGroupArray as $delgroupid) {
            if ($delgroupid > 3) {
                mxsmf_DeleteMembergroup($delgroupid);
                $deleted = true;
            }
        }
        // wenn Gruppen geloescht wurden, die Tabelle gleich optimieren
        if ($deleted) {
            db_query('OPTIMIZE TABLE `{$db_prefix}membergroups` ', __FILE__, __LINE__);
        }
    }
    // wenn mx-Gruppen in SMF-Standard-Gruppen eingetragen, diese entfernen
    if (isset($setNullArray)) {
        $setNullArray = implode(',', $setNullArray);
        $sql = "UPDATE {$db_prefix}membergroups SET mx_group=0 WHERE ID_GROUP in ({$setNullArray})";
        db_query($sql, __FILE__, __LINE__);
    }
    // SMF-Standard-Gruppen ueberpruefen und ggf. eingetragen
    for ($i = 1; $i <= 3; $i++) {
        if (!isset($SMF_GROUPS[$i])) {
            // Anfuegebefehl erstellen
            $qry = "INSERT INTO {$db_prefix}membergroups (" . implode(",", array_keys($smfdefaultgroups[$i])) . ") VALUES ('" . implode("','", $smfdefaultgroups[$i]) . "')";
            db_query($qry, __FILE__, __LINE__);
        }
    }
    // Scan pragmaMx groups that need to be created inside SMF table
    $request = db_query("SELECT MAX(ID_GROUP) FROM {$db_prefix}membergroups", __FILE__, __LINE__);
    list ($insertid) = mysql_fetch_row($request);
    mysql_free_result($request);
    foreach($MX_GROUPS as $i_group_id => $i_group_name) {
        // die restlichen Usergruppen des mX anfuegen
        if (!isset($RELATIONGROUP[$i_group_id])) {
            $insertid++;
            // die Standardwerte fuer eine neue mx-Gruppe
            $newgroup = $smfdefaultgroups['DEFAULT_NEW_MX_GROUP'];
            $newgroup['groupName'] = mysql_real_escape_string($i_group_name);
            $newgroup['mx_group'] = intval($i_group_id);
            $newgroup['ID_GROUP'] = $insertid;
            // eventuell verweiste Zuordnungen aus anderen Tabellen (User etc.) entfernen
            mxsmf_DeleteMembergroup($insertid);
            // Datensatz anfuegen
            $qry = "INSERT INTO {$db_prefix}membergroups (" . implode(",", array_keys($newgroup)) . ") VALUES ('" . implode("','", $newgroup) . "')";
            db_query($qry, __FILE__, __LINE__);
            // Set default permission level.
            mxsmf_setPermissionLevel($insertid, 'standard');
        }
    }
    // Update mx-Group Names
    foreach($MX_GROUPS as $i_group_id => $i_group_name) {
        if (isset($RELATIONGROUP[$i_group_id]) && isset($RELATIONGROUP[$i_group_id]['groupName'])) {
            if ($RELATIONGROUP[$i_group_id]['groupName'] != $i_group_name) {
                // ID_GROUP   	  groupName   	  onlineColor   	  minPosts   	  maxMessages   	  stars   	  mx_group
                $sql = "UPDATE {$db_prefix}membergroups SET groupName = '" . mysql_real_escape_string($i_group_name) . "' WHERE mx_group = '$i_group_id' AND ID_GROUP = '" . $RELATIONGROUP[$i_group_id]['ID_GROUP'] . "' AND minPosts='-1' LIMIT 1";
                db_query($sql, __FILE__, __LINE__);
            }
        }
    }
}

/**
 */
function mxSmfGetUserData($ID_MEMBER)
{
    global $db_prefix, $mxsmf;
    $mxinfo = array();
    if ($ID_MEMBER) {
        $validadmins = explode(',', $mxsmf['valid_admingoups']);
        if (count($validadmins)) {
            $validadmins = ",IF((a." . implode('=1 OR a.', $validadmins) . "=1)";
        } else {
            $validadmins = "";
        }
        $qry = "SELECT u.uid as uid,
			IF(a.radminsuper=1," . PRAGMA_SMF_GROUP_ADMINISTR . "" . $validadmins . "," . $mxsmf['group_admin_or_moderator'] . ",IFNULL(mg.ID_GROUP," . PRAGMA_SMF_GROUP_DEFAULT . "))) AS u_ID_GROUP,
			IFNULL(mg.ID_GROUP,'" . PRAGMA_SMF_GROUP_DEFAULT . "') AS u_additionalGroups,
			IF(u.user_sexus,IF(u.user_sexus=1,2,1),0) AS u_gender,
			IF(u.user_bday,u.user_bday,'0000-00-00') AS u_birthdate,
			m.*,
			IFNULL(atm.ID_ATTACH,0) AS ID_ATTACH
		FROM (((" . PRAGMA_SMF_DBTABLE_USER . " AS u
			LEFT JOIN {$db_prefix}members AS m ON u.uid = m.ID_MEMBER)
			LEFT JOIN " . PRAGMA_SMF_DBTABLE_ADMIN . " AS a ON u.uid = a.user_uid)
			LEFT JOIN {$db_prefix}membergroups AS mg ON u.user_ingroup = IF(mg.mx_group<=0,-1,mg.mx_group))
			LEFT JOIN {$db_prefix}attachments AS atm ON u.uid = atm.ID_MEMBER
		WHERE (((u.uid)=" . intval($ID_MEMBER) . ") AND ((u.user_stat)=1))
		LIMIT 1";
        $request = db_query($qry, __FILE__, __LINE__);
        $mxinfo = mysql_fetch_assoc($request);
    }
    if (empty($mxinfo['uid'])) {
        $mxinfo['uid'] = 0;
        $mxinfo['ID_MEMBER'] = 0;
    }
    return $mxinfo;
}

/**
 * mxPort.php
 * Hilfsfunktion zum Abgleich der Benutzergruppen
 * hier werden noch die Zuordnungen aus anderen Tabellen (User etc.) entfernt
 */
function mxsmf_DeleteMembergroup($id)
{
    global $sourcedir, $mxsmf;
    // benoetigte Funktion includen
    if (!function_exists('deleteMembergroups')) {
        require_once($sourcedir . '/Subs-Members.php');
    }
    // normale Loeschfunktion aufrufen
    $mxsmf['skip_isAllowedTo'] = true;
    deleteMembergroups(intval($id));
    $mxsmf['skip_isAllowedTo'] = false;
}

/**
 * Security.php
 * Moeglichkeit zum beeinflussen von bestimmten Berechtigungen
 * $mxCheckVar = mxsmf_Security_allowedTo();
 */
function mxsmf_Security_allowedTo($permission)
{
    // TODO: abbrechen wegen Problem beim automatischen Loeschen von verwaisten Usern im mx-port
    return null;
    // $a['profile_remove_any'] = FALSE;
    // $a['profile_remove_own'] = FALSE;
    // $a['profile_identity_own'] = FALSE;
    // $a['profile_extra_own'] = FALSE;
    if (is_array($permission)) {
        foreach ($permission as $key) {
            if (isset($a[$key])) {
                return $a[$key];
            }
        }
    } else if (isset($a[$permission])) {
        return $a[$permission];
    }
    return null;
}

/**
 * Set default permission level.
 */
function mxsmf_setPermissionLevel($id, $level = 'standard')
{
    global $sourcedir;
    if (!function_exists('setPermissionLevel')) {
        require_once($sourcedir . '/ManagePermissions.php');
    }
    setPermissionLevel($level, $id);
}

/**
 * Userdaten abgleichen
 */
function mxsmf_ConvertUsers($exclude_id = 0)
{
    global $db_prefix, $prefix, $user_prefix, $sourcedir, $mxsmf, $modSettings;
    static $isrunned;
    if ($isrunned) {
        return;
    }
    $isrunned = true;
    $affected = 0;
    // verwaiste User aus smf-Memberliste entfernen
    $affected += mxsmf_ConvertUsersDelete($exclude_id);
    if ($mxsmf['auto_insert_user']) {
        @set_time_limit(300);
        // neue User in smf-Memberliste eintragen
        $affected += mxsmf_ConvertUsersInsert($exclude_id);
        // geaenderte User in smf-Memberliste aktualisieren
        $affected += mxsmf_ConvertUsersUpdate($exclude_id);
    }
    $date = date('Ymd');
    if ($affected || $modSettings['latestMember'] != $modSettings['pmxLatestMember'] || $date != $modSettings['pmxLastDate']) {
        updateSettings(array('pmxLatestMember' => $modSettings['latestMember']));
        updateSettings(array('pmxLastDate' => $date));
        updateStats('member');
        mxsmf_UpdateRegisterd();
    }
    updateSettings(array('pmxLastUserCheck' => time()));
}

/**
 * Registrierungs-Statistik aktualisieren
 */
function mxsmf_UpdateRegisterd()
{
    global $db_prefix, $prefix, $user_prefix, $sourcedir, $mxsmf, $modSettings;
    if (empty($modSettings['trackStats'])) {
        return;
    }
    /* aktuelle Registrierungs-Statistik */
    $qry = "SELECT log.date, log.registers
        FROM {$db_prefix}log_activity as log
        ORDER BY log.date DESC
    ";
    $request = db_query($qry, __FILE__, __LINE__);
    while (list($reg, $anz) = mysql_fetch_row($request)) {
        $arr[$reg]['current'] = $anz;
    }
    /* neue Werte fuer Registrierungs-Statistik */
    $qry = "SELECT FROM_UNIXTIME(dateRegistered, '%Y-%m-%d') AS reg, Count( ID_MEMBER ) AS anz
        FROM {$db_prefix}members AS m
        WHERE dateRegistered < " . time() . " AND dateRegistered > 100000
        GROUP BY reg
    ";
    $request = db_query($qry, __FILE__, __LINE__);
    while (list($reg, $anz) = mysql_fetch_row($request)) {
        if (isset($arr[$reg]['current']) && $arr[$reg]['current'] == $anz) {
            unset($arr[$reg]);
            continue;
        }
        $arr[$reg]['set'] = $anz;
    }
    foreach ($arr as $reg => $data) {
        switch (true) {
          case (isset($data['current']) && !isset($data['set'])):
            /* stat vorhanden, aber kein set >> set auf 0 stellen */
            $data['set'] = 0;
          case (isset($data['current']) && isset($data['set'])):
            /* stat vorhanden, aber nicht aktuell >> Update */
            db_query("
                UPDATE {$db_prefix}log_activity
                SET registers = " . intval($data['set']) . "
                WHERE {$db_prefix}log_activity.date = '" . $reg . "'
                LIMIT 1", __FILE__, __LINE__);

          break;
          case (!isset($data['current']) && isset($data['set'])):
            /* stat nicht vorhanden, aber set >> Insert */
            db_query("
                INSERT IGNORE INTO {$db_prefix}log_activity
                (date, registers) VALUES
                ('" . $reg . "', " . intval($data['set']) . ")",
                __FILE__, __LINE__);

          break;
        }
    }
}

/**
 * verwaiste User aus smf-Memberliste entfernen
 */
function mxsmf_ConvertUsersDelete($exclude_id = 0)
{
    global $db_prefix, $prefix, $user_prefix, $sourcedir, $mxsmf, $anonymous, $modSettings;
    $request = db_query("
		SELECT m.ID_MEMBER AS ID_MEMBER
		FROM " . PRAGMA_SMF_DBTABLE_USER . " AS u
        INNER JOIN {$db_prefix}members AS m
        ON m.ID_MEMBER = u.uid
		WHERE (u.uid Is Null
            OR u.uname='' OR u.uname Is Null
            OR u.user_stat < 0
		)", __FILE__, __LINE__);
    while ($row = mysql_fetch_assoc($request)) {
        $users[] = $row['ID_MEMBER'];
    }
    mysql_free_result($request);
    $affected = 0;
    if (isset($users)) {
        /* Die Gruppenzugehoerigkeit entfernen, sonst loescht die SMF-Loeschfunktion keine Admins */
        $qry = "UPDATE {$db_prefix}members SET ID_GROUP='0', additionalGroups='0' WHERE ID_MEMBER IN(" . implode(',', $users) . ")";
        db_query($qry, __FILE__, __LINE__);
        /* benoetigte Funktion includen */
        if (!function_exists('deleteMembers')) {
            require_once($sourcedir . '/Subs-Members.php');
        }
        /* Moderatorenlog abschalten */
        $temp = $modSettings['modlog_enabled'];
        $modSettings['modlog_enabled'] = false;
        $mxsmf['skip_isAllowedTo'] = true;
        /* normale SMF-Loeschfunktion aufrufen */
        deleteMembers($users);
        $mxsmf['skip_isAllowedTo'] = false;
        /* Moderatorenlog an schalten */
        $modSettings['modlog_enabled'] = $temp;
        $affected = count($users);
    }
    return $affected;
}

/**
 * neue User in smf-Memberliste eintragen
 */
function mxsmf_ConvertUsersInsert($exclude_id = 0)
{
    global $db_prefix, $prefix, $user_prefix, $sourcedir, $modSettings, $mxsmf;
    $affected = 0;

    $validadmins = explode(',', $mxsmf['valid_admingoups']);
    if (count($validadmins)) {
        $validadmins = ",IF((a." . implode('=1 OR a.', $validadmins) . "=1)";
    } else {
        $validadmins = "";
    }
    $qry1 = "
	REPLACE INTO {$db_prefix}members (
		ID_MEMBER,
		memberName,
		dateRegistered,
		ID_GROUP,
		additionalGroups,
		lastLogin,
		realName,
		passwd,
		emailAddress,
		gender,
		birthdate,
		websiteUrl,
		location,
		ICQ,
		AIM,
		YIM,
		MSN,
		hideEmail,
		signature,
		memberIP,
		is_activated,
		secretAnswer,
		ID_POST_GROUP
		) ";
    $qry2 = "
	SELECT
		u.uid AS ID_MEMBER,
		u.uname AS memberName,
		IF(u.user_regtime,u.user_regtime,0) AS dateRegistered,
		IF(a.radminsuper=1," . PRAGMA_SMF_GROUP_ADMINISTR . "" . $validadmins . "," . $mxsmf['group_admin_or_moderator'] . ",IFNULL(mg.ID_GROUP," . PRAGMA_SMF_GROUP_DEFAULT . "))) AS ID_GROUP,
		IFNULL(mg.ID_GROUP,'" . PRAGMA_SMF_GROUP_DEFAULT . "') AS additionalGroups,
		IF(u.user_lastvisit,u.user_lastvisit,UNIX_TIMESTAMP()) AS lastLogin,
		u.uname AS realName,
		u.pass AS passwd,
		u.email AS emailAddress,
		IF(u.user_sexus,IF(u.user_sexus=1,2,1),0) AS gender,
		IF(u.user_bday,u.user_bday,'0000-00-00') AS birthdate,
		u.url AS websiteUrl,
		u.user_from AS location,
		u.user_icq AS ICQ,
		u.user_aim AS AIM,
		u.user_yim AS YIM,
		u.user_msnm AS MSN,
		1 AS hideEmail,
		u.user_sig AS signature,
		u.user_lastip AS memberIP,
		1 AS is_activated,
		FROM_UNIXTIME(u.user_regtime, '%Y-%m-%d') AS secretAnswer,
		" . mxSmfGetMinPostgroup() . " AS ID_POST_GROUP
	FROM ((" . PRAGMA_SMF_DBTABLE_USER . " AS u
		LEFT JOIN {$db_prefix}members AS m ON u.uid = m.ID_MEMBER)
		LEFT JOIN " . PRAGMA_SMF_DBTABLE_ADMIN . " AS a ON u.uid = a.user_uid)
		LEFT JOIN {$db_prefix}membergroups AS mg ON u.user_ingroup = IF(mg.mx_group<=0,-1,mg.mx_group) ";
    $where = " WHERE ((m.ID_MEMBER Is Null)
		AND (u.user_stat=1)
		AND (u.uid>1)
		AND (u.uname<>'')
		AND (u.uname<>'Anonymous')
		AND (u.uname<>'" . $GLOBALS['anonymous'] . "')
		AND (u.uid<>" . intval($exclude_id) . ")	)
        ORDER BY u.user_regtime DESC";
    // vor mysql 4.0.15 waren sub-selects, in der die einzufuegende Tabelle selbst vorkommt, nicht erlaubt
    if (version_compare(MX_SQL_VERSION, '4.0.15', '>=')) {
        // die Anzahl auf 600 begrenzen, wegen max_execution_time
        db_query($qry1 . $qry2 . $where . ' LIMIT 600', __FILE__, __LINE__);
        $affected = $affected + db_affected_rows();
    } else {
        // die Anzahl auf 30 begrenzen, wegen max_execution_time
        $result = db_query($qry2 . $where . ' LIMIT 30', __FILE__, __LINE__);
        while ($row = mysql_fetch_assoc($result)) {
            $row = addslashes__recursive($row);
            $qry = $qry1 . " VALUES ('" . implode("','", $row) . "')";
            db_query($qry, __FILE__, __LINE__);
            $affected += db_affected_rows();
        }
    }
    return $affected;
}

/**
 * neue User in smf-Memberliste eintragen
 */
function mxsmf_ConvertUsersUpdate($exclude_id = 0)
{
    global $db_prefix, $prefix, $user_prefix, $sourcedir, $mxsmf;
    $affected = 0;
    $validadmins = explode(',', $mxsmf['valid_admingoups']);
    if (count($validadmins)) {
        $validadmins = ",IF((a." . implode('=1 OR a.', $validadmins) . "=1)";
    } else {
        $validadmins = "";
    }
    $tables = " ((" . PRAGMA_SMF_DBTABLE_USER . " AS u
		LEFT JOIN {$db_prefix}members AS m ON u.uid = m.ID_MEMBER)
		LEFT JOIN " . PRAGMA_SMF_DBTABLE_ADMIN . " AS a ON u.uid = a.user_uid)
		LEFT JOIN {$db_prefix}membergroups AS mg ON u.user_ingroup = IF(mg.mx_group<=0,-1,mg.mx_group) ";
    $set = " SET
		m.memberName = u.uname,
		m.realName = u.uname,
		m.dateRegistered = if(u.user_regtime,u.user_regtime,0),
		m.ID_GROUP = IF(a.radminsuper=1," . PRAGMA_SMF_GROUP_ADMINISTR . "" . $validadmins . "," . $mxsmf['group_admin_or_moderator'] . ",IFNULL(mg.ID_GROUP," . PRAGMA_SMF_GROUP_DEFAULT . "))),
		m.additionalGroups = IFNULL(mg.ID_GROUP,'" . PRAGMA_SMF_GROUP_DEFAULT . "'),
		m.passwd = u.pass,
		m.emailAddress = u.email,
		m.gender = if(u.user_sexus,if(u.user_sexus=1,2,1),0),
		m.birthdate = IF(u.user_bday,u.user_bday,'0000-00-00'),
		m.websiteUrl = u.url,
		m.location = u.user_from,
		m.ICQ = u.user_icq,
		m.AIM = u.user_aim,
		m.YIM = u.user_yim,
		m.MSN = u.user_msnm,
		m.is_activated = (IF((u.user_stat=1 AND u.email<>'' AND u.uname<>''),1,0))
        ";
    $where = " WHERE ((((m.memberName)<>u.uname))
		OR (((m.realName)<>u.uname))
		OR (((m.dateRegistered)<>if(u.user_regtime,u.user_regtime,0)))
		OR (((m.ID_GROUP)<>if(a.radminsuper=1," . PRAGMA_SMF_GROUP_ADMINISTR . "" . $validadmins . "," . $mxsmf['group_admin_or_moderator'] . ",IFNULL(mg.ID_GROUP," . PRAGMA_SMF_GROUP_DEFAULT . ")))))
		OR (((m.additionalGroups)<>IFNULL(mg.ID_GROUP,'" . PRAGMA_SMF_GROUP_DEFAULT . "')))
		OR (((m.passwd)<>u.pass))
		OR (((m.emailAddress)<>u.email))
		OR (((m.gender)<>if(u.user_sexus,if(u.user_sexus=1,2,1),0)))
		OR (((m.birthdate)<>IF(u.user_bday,u.user_bday,'0000-00-00')))
		OR (((m.websiteUrl)<>u.url))
		OR (((m.location)<>u.user_from))
		OR (((m.ICQ)<>u.user_icq))
		OR (((m.AIM)<>u.user_aim))
		OR (((m.YIM)<>u.user_yim))
		OR (((m.MSN)<>u.user_msnm))
        OR (((m.is_activated)<>(IF((u.user_stat=1 AND u.email<>'' AND u.uname<>''),1,0))))
		) AND (u.uid<>" . intval($exclude_id) . ") AND (u.user_stat=1)
		";
    // vor mysql 4.0.15 waren sub-selects, in der die einzufuegende Tabelle selbst vorkommt, nicht erlaubt
    if (version_compare(MX_SQL_VERSION, '4.0.15', '>=')) {
        $qry = "UPDATE " . $tables . $set . $where;
        db_query($qry, __FILE__, __LINE__);
        $affected = $affected + db_affected_rows();
    } else {
        $fields = " u.uid AS ID_MEMBER,
		u.uname AS memberName,
		u.uname AS realName,
		IF(u.user_regtime,u.user_regtime,0) AS dateRegistered,
		IF(a.radminsuper=1," . PRAGMA_SMF_GROUP_ADMINISTR . "" . $validadmins . "," . $mxsmf['group_admin_or_moderator'] . ",IFNULL(mg.ID_GROUP," . PRAGMA_SMF_GROUP_DEFAULT . "))) AS ID_GROUP,
		IFNULL(mg.ID_GROUP,'" . PRAGMA_SMF_GROUP_DEFAULT . "') AS additionalGroups,
		u.pass AS passwd,
		u.email AS emailAddress,
		IF(u.user_sexus,IF(u.user_sexus=1,2,1),0) AS gender,
		IF(u.user_bday,u.user_bday,'0000-00-00') AS birthdate,
		u.url AS websiteUrl,
		u.user_from AS location,
		u.user_icq AS ICQ,
		u.user_aim AS AIM,
		u.user_yim AS YIM,
		u.user_msnm AS MSN,
        (IF((u.user_stat=1 AND u.email<>'' AND u.uname<>''),1,0)) AS is_activated
         ";
        // die Anzahl auf 30 begrenzen, wegen max_execution_time
        $result = db_query("SELECT " . $fields . " FROM " . $tables . $where . ' LIMIT 30', __FILE__, __LINE__);
        while ($row = mysql_fetch_assoc($result)) {
            $row = addslashes__recursive($row);
            foreach ($row as $key => $value) {
                if ($key != 'ID_MEMBER') {
                    $sqlpart[] = "`$key` = '" . mysql_real_escape_string($value) . "'";
                }
            }
            if (isset($sqlpart)) {
                $qry = "UPDATE {$db_prefix}members SET " . implode(', ', $sqlpart) . " WHERE ID_MEMBER = " . intval($row['ID_MEMBER']) . "";
                db_query($qry, __FILE__, __LINE__);
                $affected += db_affected_rows();
            }
        }
    }
    return $affected;
}

/**
 * bei Aenderung der Userdaten, diese auch in pragmaMx anpassen
 * (integrate_change_member_data)
 */
function mxSmf_change_member_data($memberNames, $var, $data)
{
    global $db_prefix, $prefix, $user_prefix, $sourcedir, $mxsmf;
    // keine Ahnung, wo die herkommen, aber da sind einfache Anfuehrungszeichen drumrum...
    if (is_string($data) && preg_match("#^'(.*)'$#", $data, $matches)) {
        $data = $matches[1];
    }
    // die WHERE Bedingung, je nach Anzahl der zu aktualisierenden User
    $where = (count($memberNames) > 1) ? "IN ('" . implode("','", $memberNames) . "')" : "= '" . mysql_real_escape_string($memberNames[0]) . "'";
    // Switch ist zwar umstaendlich, aber sehr flexibel, damit die Daten bei Bedarf noch angepasst werden koennen
    switch ($var) {
        /*
		case ('memberName'):
		case ('realName'):
		case ('emailAddress'):
		case ('websiteTitle'):
		case ('timeFormat'):
		case ('timeOffset'):
		case ('avatar'):
		case ('lngfile'):
		case ('avatar'):
		case ('avatar_choice'):
		case ('cat'):
		case ('userpicpersonal'):
		case ('file'):
		case ('hideEmail'):
			return;
		 */
        case ('gender'):
            $data = (empty($data)) ? 0 : ((intval($data) === 1) ? 2 : 1);
            $setting = "`user_sexus`=" . $data . "";
            break;
        case ('birthdate'):
            $setting = "`user_bday`='" . $data . "'";
            break;
        case ('websiteUrl'):
            $setting = "`url`='" . mysql_real_escape_string($data) . "'";
            break;
        case ('location'):
            $setting = "`user_from`='" . mysql_real_escape_string($data) . "'";
            break;
        case ('ICQ'):
            $setting = "`user_icq`='" . mysql_real_escape_string($data) . "'";
            break;
        case ('AIM'):
            $setting = "`user_aim`='" . mysql_real_escape_string($data) . "'";
            break;
        case ('MSN'):
            $setting = "`user_msnm`='" . mysql_real_escape_string($data) . "'";
            break;
        case ('YIM'):
            $setting = "`user_yim`='" . mysql_real_escape_string($data) . "'";
            break;
        case ('signature'):
            $setting = "`user_sig`='" . mysql_real_escape_string($data) . "'";
            break;
        case ('avatar'):
            $avatar = '';
            if ($data) {
                $check = str_replace(array($mxsmf['DirsToAvatar'] . MX_PATH_AVATAR, $mxsmf['DirsToAvatar'] . MX_PATH_MEMBERAVATAR), '', $data);
                if ($check != $data) {
                    if (file_exists(MX_PATH_AVATAR . $check)) {
                        $avatar = trim($check, '\\/');
                    } else if (mxsmf_AvatarModEnabled() && file_exists(MX_PATH_MEMBERAVATAR . $check)) {
                        $avatar = trim($check, '\\/');
                        db_query("UPDATE " . PRAGMA_SMF_DBTABLE_AVATARS . " SET werist='" . mysql_real_escape_string($avatar) . "' WHERE `aid` " . $where . "", false, false);
                    }
                }
            }
            if ($avatar) {
                $setting = "`user_avatar`='" . mysql_real_escape_string($avatar) . "'";
            } else {
                return;
            }
            break;
        default:
            return;
    }
    // die Datenbankanfrage erstellen
    $qry = "UPDATE `" . PRAGMA_SMF_DBTABLE_USER . "` SET " . $setting . " WHERE `uname` " . $where . "";
    // die Datenbankanfrage ausfuehren
    db_query($qry, __FILE__, __LINE__);
}

/**
 * die Post-Gruppe mit der kleinsten Anzahl benoetigter Posts ermitteln
 */
function mxSmfGetMinPostgroup()
{
    global $db_prefix;
    $request = db_query("
		SELECT ID_GROUP, minPosts
		FROM {$db_prefix}membergroups
		WHERE minPosts <> -1
		ORDER BY minPosts ASC
		LIMIT 1", __FILE__, __LINE__);
    $post_groups = array();
    $row = mysql_fetch_assoc($request);
    mysql_free_result($request);
    return intval($row['ID_GROUP']);
}

/**
 * Admin.php:
 */
function mxsmf_Admin_ModifySettings($config_vars)
{
    global $scripturl, $context, $txt, $sc;
    global $language_dir, $boarddir;

    global $mx_db_prefix, $db_prefix, $prefix;
    $config_vars = array(
        array('mbname', &$txt[350], 'text', 30),
        'language' => array('language', &$txt['default_language'], 'select', array()),
        '',
        array('maintenance', &$txt[348], 'check'),
        array('mtitle', &$txt['maintenance1'], 'text', 36),
        array('mmessage', &$txt['maintenance2'], 'text', 36),
        '',
        array('db_prefix', &$txt['smf54'], 'text'),
        array('db_error_send', &$txt['db_error_send'], 'check'),
        '',
        );

    /**
     * array('webmaster_email', &$txt[355], 'text', 30),
     * array('cookiename', &$txt[352], 'text', 20),
     * 'language' => array('language', &$txt['default_language'], 'select', array()),
     * '',
     */
    return $config_vars;
}

/**
 * ModSettings.php:
 */
function mxsmf_ModSettings_defineSettings($config_vars)
{
    $hidedsettings = mxsmf_getHidedSettings();
    // 0: type, 1: name, 2:desc, 3:helptext, 4:size/values.
    foreach ($config_vars as $k => $config_var) {
        if (isset($config_var[1])) {
            if (isset($hidedsettings[$config_var[1]])) {
                unset($config_vars[$k]);
            }
        }
    }
    return $config_vars;
}

/**
 * Subs.php
 * verschiedene Optionen im Adminmenue ausblenden
 */
function mxsmf_Subs_adminIndex($admin_areas)
{
    if (isset($admin_areas['members']['areas']['registration_center']))
        unset($admin_areas['members']['areas']['registration_center']);
    if (isset($admin_areas['members']['areas']['edit_reserved_names']))
        unset($admin_areas['members']['areas']['edit_reserved_names']);
    if (isset($admin_areas['config']['areas']['edit_agreement']))
        unset($admin_areas['config']['areas']['edit_agreement']);
    if (isset($admin_areas['config']['areas']['edit_censored']))
        unset($admin_areas['config']['areas']['edit_censored']);
    return $admin_areas;
}

/**
 * alle normalen URL's anpassen im Output
 * Fallback Funktion fuer preg_replace()
 */
function mxSmfFixBoardUrl($beginn, $quest, $rest)
{
    global $scripturl, $boardurl, $mxsmf;
    $beginn = $beginn . MX_BASE_URL . 'modules.php?name=' . $mxsmf['module_name'] . '';

    if ($quest) {
        $out = $beginn . '&amp;' . $rest;
    } else {
        $out = $beginn . $rest;
    }
    // if(MX_IS_ADMIN) mxDebugFuncVars($beginn, $quest, $rest);
    // TODO: irgendwie werden da manchmal Variablen interpretiert?
    // deswegen erstmal das str_replace...
    $out = str_replace('$', '\\$', mxStripSlashes($out));
    return $out;
}

/**
 * macht aus einer Original smf-url eine pragmaMx URL
 *      beruecksichtigt gleich mod_rewrite..
 * wird auch in SMF-Funktion redirectexit() verwendet
 */
function mxSmfCreatePmxUrl($url)
{
    global $mxsmf;

    $part = explode('?', $url);
    if (empty($part[1])) {
        if (PRAGMA_SMF_USE_MODREWRITE) {
            return MX_BASE_URL . $mxsmf['module_name'] . '.html';
        } else {
            return MX_BASE_URL . 'modules.php?name=' . $mxsmf['module_name'];
        }
    } else {
        if (PRAGMA_SMF_USE_MODREWRITE) {
            return mxSmfModrewriteUrl(MX_BASE_URL . 'modules.php?name=' . $mxsmf['module_name'] . '&amp;' . $part[1]);
        } else {
            return MX_BASE_URL . 'modules.php?name=' . $mxsmf['module_name'] . '&amp;' . $part[1];
        }
    }
}

/**
 * alle Ausgaben fuer RSS anpassen
 */
function mxSmfPrepareOutput_RSS($smfContent)
{
    global $forum_copyright, $context, $forum_version, $mxsmf, $txt, $boardurl, $scripturl, $settings;
    // moegliche Aufrufsformate: 'smf', 'rss', 'rss2', 'atom', 'rdf'
    // alle normalen Links, eingebettet in > < oder " "
    $smfContent = preg_replace('#([">])(' . preg_quote($scripturl, '#') . ')(\?*)([^"<]*["<])#e', 'mxSmfFixBoardUrl("$1","$3","$4")', $smfContent);
    // Bilder usw. fixen
    $smfContent = str_replace('"' . $mxsmf['path'] . '/', '"' . $boardurl . '/', $smfContent);
    // mod_rewrite Rules
    if (PRAGMA_SMF_USE_MODREWRITE) {
        // alle normalen Links, eingebettet in > < oder " "
        preg_match_all('!([">])((?:' . preg_quote(MX_BASE_URL, '!') . ')(?:modules|index)\.php\?(?:[a-zA-Z0-9=&;.-_/#]+)?)(["<])!', $smfContent, $matches);
        foreach ($matches[2] as $key => $request) {
            if (isset($dynachanges[$matches[0][$key]])) {
                continue;
            }
            $new = mxSmfModrewriteUrl($request);
            if ($new) {
                $dynachanges[$matches[0][$key]] = $matches[1][$key] . $new . $matches[3][$key];
            }
        }
        if (isset($dynachanges)) {
            $smfContent = str_replace(array_keys($dynachanges), array_values($dynachanges), $smfContent);
        }
    }
    // raus damit
    return $smfContent;
}

/**
 * alle Ausgaben anpassen
 */
function mxSmfPrepareOutput($smfContent, $is_html = true)
{
    global $forum_copyright, $context, $forum_version, $mxsmf, $txt, $boardurl, $scripturl, $settings, $currentlang, $modrew_alternate, $pmxHTML;
    if (!$scripturl) {
        $scripturl = $boardurl . '/index.php';
    }
    // wird eigentlich nur fuer die alten smf-mx-Ports benoetigt
    // $smfContent = str_replace('/forum.php/index.php?', '/modules.php?name=' . $mxsmf['module_name'] . '&amp;', $smfContent);
    // fehlerhaft abgespeicherte URL, wenn REQUEST_STRING verwendet wurde, z.B. beim Errorlog
    $smfContent = preg_replace('#(' . preg_quote($scripturl, '#') . '\?name=' . $mxsmf['module_name'] . ')(&amp;amp;|;)#', '\1&amp;', $smfContent);
    if ($is_html) {
        // alle normalen URL's anpassen
        // - by AE: hier entstehen ab und zu Meldungen im Fehlerlog, die ich nicht nachvollziehen kann, deswegen der Klammeraffe...
        $smfContent = @preg_replace('#([\'"])(' . preg_quote($scripturl, '#') . ')(\?*)([^\'">]*[\'"])#e', 'mxSmfFixBoardUrl("$1","$3","$4")', $smfContent);
    } else {
        // Achtung, auf die spaces im regex, die werden fuer mails nenoetigt
        $smfContent = @preg_replace('#([\'"]|\s)(' . preg_quote($scripturl, '#') . ')(\?*)([^\'" >]*(?:[\'"]||\s))#e', 'mxSmfFixBoardUrl("$1","$3","$4")', $smfContent);
    }
    // den Link zu den Zugangseinstellungen aendern auf das entsprechende pragmaMx Modul
    preg_match('#<a[^>]+&amp;action=profile;u=([0-9]+);sa=account[^>]+>#i', $smfContent, $matches);
    if (!empty($matches[1])) {
        if (MX_IS_ADMIN && mxGetAdminPref('radminuser')) {
            $smfContent = preg_replace('#<a[^>]+&amp;action=profile;u=([0-9]+);sa=account[^>]+>#i', '<a href="admin.php?chng_uid=\1&amp;op=modifyUser" target="_blank" title="edit in new window">', $smfContent);
        } else {
            $smfContent = preg_replace('#<a[^>]+&amp;action=profile;u=([0-9]+);sa=account[^>]+>#i', '<a href="modules.php?name=Your_Account&amp;op=edituser">', $smfContent);
        }
    }
    // fehlerhafte Theme-URL's anpassen, wenn das Forum auf verschiedenen URL's gleichzeitig verwendet wird.
    static $replace;
    $host = parse_url(MX_BASE_URL);
    $host = $host['host'];
    $patharray = array('default_theme_url', 'theme_url', 'default_images_url', 'actual_theme_url', 'actual_images_url');
    if (!isset($replace)) {
        foreach ($patharray as $key) {
            $new = parse_url($settings[$key]);
            if ($new['host'] !== $host) {
                $new = $new['scheme'] . '://' . $host . '' . $new['path'];
                $replace[$settings[$key]] = $new;
            }
        }
    }
    if (isset($replace)) {
        $smfContent = str_replace(array_keys($replace), array_values($replace), $smfContent);
    }
    // ab hier nur bei HTML, nicht bei mail!
    if ($is_html) {
        // eMailadressen in der Ausgabe unkenntlich machen...
        if ($mxsmf['encodeEmailAdresses']) {
            $smfContent = preg_replace_callback('#(<a[^>]*href=[\'"])(mailto:)([^\@<>]+\@[^\'"<>]+)([\'"]>)(.+)(</a>)#iU', 'mxsmf_ReplaceMail', $smfContent);
        }
        // Autolinks bei movetopic, etc.
        $smfContent = @preg_replace('#(<a\s[^>]+' . preg_quote(MX_BASE_URL, '#') . '[^>]+>)(' . preg_quote($scripturl) . '\?*)([^>]+)(</a>)#ie', 'mxSmfFixBoardUrl("$1","$2","$3","$4")', $smfContent);
        // versch. Javascripte
        $smfContent = preg_replace('#(sa=(?:collapse|expand);?\#)([0-9]+)#i', '$1c$2', $smfContent);
        // der Quickjumper und die PM-Liste
        $smfContent = preg_replace('#(value=["\'])\?(board=)#i', '$1&amp;$2', $smfContent);
        // Ankernamen (#) duerfen lt. W3C nicht mit einer Zahl beginnen, hier versuchen das zu fixen:
        if ($context['current_action'] != 'membergroups') {
            $smfContent = preg_replace('#((?:value|href)=["\'])\#([0-9]+["\'])#i', '$1#c$2', $smfContent);
            $smfContent = preg_replace('#(href=["\'][^"\']*' . $mxsmf['module_name'] . ')\#([0-9]+["\'])#i', '$1#c$2', $smfContent);
            // das Gegenstueck zu den Links
            $smfContent = preg_replace('#(name=["\'])([0-9]+["\'])#i', '$1c$2', $smfContent);
        }
        // fehlerhafte Links in z.B. RepairBoards.php
        $smfContent = preg_replace('#(href=["\'])\?(action=)#i', '$1modules.php?name=' . $mxsmf['module_name'] . '&amp;$2', $smfContent);
        // Formularfeldnamen "file" und "name" abaendern in "mxsmf_file"
        $smfContent = preg_replace('#(name\s*=\s*["\'])(file|name)(["\'\[])#i', '$1mxsmf_$2$3', $smfContent);
        // in themes der mx-Themeengine gibt es meist eine CSS-Klasse 'searchform', das Suchformular im SMF heisst meist genauso
        // deshalb hier diesen String ersetzen
        $smfContent = preg_replace('#([."\'])searchform(\1)#', '$1search_form$1', $smfContent);
        // bei Formularen, die mit _GET versendet werden, wird der Modulname mit in die URL aufgenommen
        // dadurch wird der Modulname dann in der modules.php nicht erkannt
        // Deswegen vorsorglich in jedes Formular das hidden-Feld "name" einschliessen
        $smfContent = preg_replace('#(<form[^>]+name=' . $mxsmf['module_name'] . '[^>]+>)#i', '$1<input type="hidden" name="name" value="' . $mxsmf['module_name'] . '"/>', $smfContent);
        // die Generierung des hashPasswortes per Javascript verhindern, damit das Login mit dem md5-Passwort funktioniert
        // $smfContent = preg_replace('#\s*onsubmit\s*=\s*["\']hashPassword\s*\([^)]*\)\s*;*["\']\s*#is', '', $smfContent);
        $smfContent = preg_replace('#<script[^>]*sha1.js[^>]*>[^>]*</script>#is', '', $smfContent);
        $smfContent = preg_replace('#\s*onsubmit\s*=\s*["\']hash[[:alnum:]]*Password\s*\([^)]*\)\s*;*["\']\s*#is', '', $smfContent);
        // versch. korrupte URL's fixen
        // das Loginfeld fuer Your_Account wird oben beschaedigt, dies fixen...
        $smfContent = preg_replace('#(<input[^>]*["\'])mxsmf_name(["\'][^>]*["\']Your_Account["\']\s*\?>)#i', '$1name$2', $smfContent);
        $smfContent = preg_replace('#;modules_php\?name=' . $mxsmf['module_name'] . '#i', '', $smfContent);
        $smfContent = preg_replace('#name=' . $mxsmf['module_name'] . '&(amp;)?name=' . $mxsmf['module_name'] . '#i', 'name=' . $mxsmf['module_name'] . '', $smfContent);
        // der Quickjumper verursacht in manchen Themes einen scriptfehler, weil back-slashes zuviel sind
        $smfContent = preg_replace('#window\.location\.href\s*=.*modules\.php.*' . $mxsmf['module_name'] . '.*\+#iUe', "stripslashes('$0')", $smfContent);
        // verschiedene Links innerhalb von Javascripten, z.B. in den Statistiken
        $smfContent = preg_replace('#smf_scripturl\s*\+\s*"\?action\=#i', 'smf_scripturl + "&action=', $smfContent);
        // die Javascripte, welche auf javascripte von smf.org Zugreifen
        $smfContent = preg_replace('#window\.smfLatest(Smileys|Packages|Themes)\);#i', 'window.smfLatest$1.replace(/name=' . $mxsmf['module_name'] . '\?/, "name=' . $mxsmf['module_name'] . '&amp;"));', $smfContent);
        // versch. HTML-Fehler fixen
        $smfContent = str_replace('<span class="smalltext"></span>', '', $smfContent);
        // Bilder bei german_du
        if ($currentlang == 'german_du' && $context['user']['language'] == $mxsmf['german_du_convention']) {
            $smfContent = preg_replace('#(<img[^>]+/)' . preg_quote($mxsmf['german_du_convention'], '#') . '(/[^>]+>)#si', '$1german$2', $smfContent);
        }
        // das war vorher in mxSmf_display()
        // versch. spezielle HTML-Ausgaben veraendern
        // den Submitbuttons eine extra css-Klasse zuweisen
        $smfContent = str_replace('<input type="submit"', '<input type="submit" class="formbutton"', $smfContent);
        // Tabellenbreite im profil-Template anpassen
        $smfContent = str_replace('<table border="0" width="85%"', '<table border="0" width="98%"', $smfContent);
        // small eine eigene CSS-Klasse zuweisen
        $smfContent = str_replace('<small>', '<small class="smalltext">', $smfContent);
        // Link zur erweiterten Suche fixen, aber nur wenn mod_rewrite an ist...
        if (PRAGMA_SMF_USE_MODREWRITE) {
            $smfContent = str_replace('onclick="this.href += \';', 'onclick="this.href += \'?', $smfContent);
        }
        // versch. Ausgaben der Sprachdateien korrigieren
        if (isset($GLOBALS['txt'][644])) {
            if (strpos($smfContent, $GLOBALS['txt'][644])) {
                $repl = str_replace('http://www.simplemachines.org/community/', 'http://www.pragmamx.org/forum.html', $GLOBALS['txt'][644]);
                $smfContent = str_replace($GLOBALS['txt'][644], $repl, $smfContent);
            }
        }
        /* Zeilenumbruch in URL ist unsinnig, ACHTUNG: das wird in der Funktion mxSmfCleanRequest() wieder rueckgaengig gemacht, bug-id: 441 */
        $smfContent = str_replace(';delim=\n;', ';delim=backspace;', $smfContent);

        /* Anpassungen zu ganz bestimmten Aktionen */
        switch ($context['current_action']) {
          case 'helpadmin':
            // bei den Hilfepopups, einen andersfarbigen Rahmen um den Text legen
            $smfContent = preg_replace('#(<body[^>]*>)(.*)(</body>)#si', '$1<div class="tborder" style="padding: 1ex;><div class="windowbg2">$2</div></div>$3', $smfContent);
            break;
          case 'help':
            // Hilfe, #main kollidiert mit manchen Themes...
            $smfContent = str_replace(array('id="main"', '#main"'), array('id="smfmenu"', '#smfmenu"'), $smfContent);
            break;
          case 'theme':
            // Themepreview
            $smfContent = str_replace('(url.indexOf("?") == -1 ? "?" : ";")', '(url.indexOf("?") == -1 ? "?" : "&")', $smfContent);
            break;
          case 'profile':
            /* Leere Zeile "Aktionen" im profil entfernen */
            $search = '#<tr>\s*<td[^>]*>' . $GLOBALS['txt']['profileAction'] . '</td>\s*</tr>\s*<tr[^>]*>\s*<td[^>]*>\s*<br[^>]*>\s*</td>\s*</tr>#';
            $smfContent = preg_replace($search, '', $smfContent);
            break;
          case 'membergroups':
            $search = array(
                preg_quote($txt['membergroups_members_add'], '#'),
                preg_quote($txt['membergroups_members_remove'], '#'),
            );
            foreach ($search as $pattern) {
                $pattern ='#<input[^>]+' . $pattern . '[^>]+>#';
                $smfContent = preg_replace($pattern, '', $smfContent);
            }
            break;
        }
    }

    /* mod_rewrite Rules */
    if ($smfContent && PRAGMA_SMF_USE_MODREWRITE) {
        if ($is_html) {
            preg_match_all('!(<(?:a|link)[^>]+href=")((?:' . preg_quote(MX_BASE_URL, '!') . ')?modules\.php\?(?:[^"\'' . preg_quote($modrew_alternate, '!') . ']+)?)(["\'])!', $smfContent, $matches);
        } else {
            preg_match_all('!(\s)((?:' . preg_quote(MX_BASE_URL, '!') . ')(?:modules|index)\.php\?(?:[a-zA-Z0-9=&;.-_/#]+)?)(\s)!', $smfContent, $matches);
        }
        foreach ($matches[2] as $key => $request) {
            if (isset($dynachanges[$matches[0][$key]])) {
                continue;
            }
            $new = mxSmfModrewriteUrl($request);
            if ($new) {
                $dynachanges[$matches[0][$key]] = $matches[1][$key] . $new . $matches[3][$key];
            }
        }
        if (isset($dynachanges)) {
            $smfContent = str_replace(array_keys($dynachanges), array_values($dynachanges), $smfContent);
        }
    }

    return $smfContent;
}

/**
 * Die Funktion mxSmfPrepareOutput() rekursiv aufrufen
 */
function mxSmfPrepareOutput_recursive($mx_ssi_return)
{
    global $scripturl;
    foreach ($mx_ssi_return as $key => $value) {
        if (is_array($value)) {
            $mx_ssi_return[$key] = mxSmfPrepareOutput_recursive($value);
        } else if (is_string($value)) {
            $mx_ssi_return[$key] = mxSmfPrepareOutput($value);
            $mx_ssi_return[$key] = @preg_replace('#^(' . preg_quote($scripturl, '#') . ')(\?*)(.*)#e', 'mxSmfFixBoardUrl("","$2","$3")', $mx_ssi_return[$key]);
        } else {
            $mx_ssi_return[$key] = $value;
        }
    }
    return $mx_ssi_return;
}

/**
 * Anpassen der Links zu den Stylesheets
 */
function mxSmfPrepareStylesheet($smfContent, $add = false)
{
    global $mxsmf;
    preg_match('#<link[^>]*' . preg_quote($mxsmf['path_themes'], '#') . '/([^/]*)/style\.css(?:\?[^"\']*)?[^>]*>#si', $smfContent, $matches);
    if (empty($matches[0])) {
        return $smfContent;
    }
    // Pfad/Dateiname fuer die dynamische style.css
    $dynastyle = PMX_HOME_URL . '/modules.php?name=' . $mxsmf['module_name'] . '&file=style&st=' . $matches[1];
    // das dynamische Stylesheet per @import einbinden, das ist sicherer wegen
    // dem Zusammenspiel von Browsercache und Mime-Type
    $new = '<style type="text/css" media="all">
/*<![CDATA[*/
   @import "' . $dynastyle . '";
/*]]>*/
</style>
';
    if ($add) {
        $new = $matches[0] . "\n" . $new;
    }
    // den Aufruf von style.css durch den Aufruf von style.php ersetzen
    $smfContent = str_replace($matches[0], $new, $smfContent);

    return $smfContent;
}

/**
 * Benutzerpasswort verifizieren
 */
function mxSmf_verify_password($username, $password)
{
    $qry = "SELECT uid FROM " . PRAGMA_SMF_DBTABLE_USER . " WHERE uname='" . mysql_real_escape_string(substr($username, 0, 25)) . "' AND pass='" . md5($password) . "' AND user_stat=1";
    if (sql_num_rows(sql_query($qry))) {
        return true;
    }
    return false;
}

/**
 * Die Themevariablen auslesen
 */
// TODO: wird evtl. garnicht mehr verwendet!!
function mxSmfGetThemeVars($mxtheme = '')
{
    static $themevars;
    if (empty($themevars)) {
        if (empty($mxtheme)) {
            $mxtheme = $mxsmf['pmxtheme'];
        }
        include('themes/' . $mxtheme . '/theme.php');
        $themevars = get_defined_vars();
        unset($themevars['themevars'], $themevars['GLOBALS'], $mxtheme);
    }
    return $themevars;
}

/**
 * Links mit eMail-Adressen maskieren
 */
function mxsmf_ReplaceMail($matches)
{
    static $lastmatches;
    /*
    [0] => <a href="mailto:name@irgendwas.com">E-Mail</a>
    [1] => <a href="
    [2] => mailto:
    [3] => name@irgendwas.com
    [4] => ">
    [5] => E-Mail
    [6] => </a>
     */
    // falls schonmal ersetzt...
    if (isset($lastmatches[$matches[0]])) {
        return $lastmatches[$matches[0]];
    }
    // Zusatzparameter (subject etc.) sollten nicht maskiert werden, deswegen
    // diese hier ausfiltern
    preg_match('!^(.*)(\?.*)$!', $matches[3], $match);
    if (empty($match[2])) {
        $address_encode = mxsmf_EncodeString($matches[3], 3);
    } else {
        $address_encode = mxsmf_EncodeString($match[1], 3) . $match[2];
    }
    // wenn der Linktext, gleich der Adresse ist, diesen Text auch maskieren
    if ($matches[3] == $matches[5]) {
        $text_encode = mxsmf_EncodeString($matches[3], 3);
    } else {
        $text_encode = $matches[5];
    }
    // den String "mailto:" auch maskieren
    $mailto = mxsmf_EncodeString($matches[2], 3);
    // den Ausgabestring wieder zusammensetzen
    $lastmatches[$matches[0]] = $matches[1] . $mailto . $address_encode . $matches[4] . $text_encode . $matches[6];
    // und raus damit...
    return $lastmatches[$matches[0]];
}

/**
 * prueft ob das Avatarmodul von BowlingX vorhanden ist
 */
function mxsmf_AvatarModEnabled()
{
    static $return;
    if (!isset($return)) {
        $return = (mxModuleAllowed('Avatar') && @file_exists('modules/Avatar/index.php') && @file_exists(MX_PATH_MEMBERAVATAR));
    }
    return $return;
}

/**
 * Encode email addresses to make it harder for spammers to harvest them.
 *
 * Spam-me-not PHP version by Rolf Offermanns
 * inspired by the Spam-me-not JavaScript by Andreas Neudecker
 *
 * version: 2003-09-28
 *
 * Spam-me-not Javascript Homepage:
 *
 *            http://www.zapyon.de/
 */
function mxsmf_EncodeString($originalString, $encodeMode)
{
    $encodedString = "";
    $originalLength = strlen($originalString);

    for ($i = 0; $i < $originalLength; $i++) {
        if ($encodeMode == 3) {
            mt_srand(microtime() * 1000000);
            $encodeMode = mt_rand(1, 2);
        }
        switch ($encodeMode) {
            case 1: // Decimal code
                $encodedString .= "&#" . ord($originalString[$i]) . ";";
                break;
            case 2: // Hexadecimal code
            default:
                $encodedString .= "&#x" . dechex(ord($originalString[$i])) . ";";
                break;
        }
    }
    return $encodedString;
}

function mxSmfModrewriteUrl($url, $text = '')
{
    global $modrew_alternate;
    $delemiter = '-';
    $new = '';
    $name = '';
    preg_match('!(?:^(.*)(?:modules|index)\.php\?)?([^#]+)(#.*)?$!' , $url, $matches);
    // Extralange Parameter ignorieren
    if (strlen($matches[2]) >= 255) {
        return $url;
    }
    $beginn = (empty($matches[1])) ? '' : $matches[1];
    $anchor = (empty($matches[3])) ? '' : $matches[3];
    $request = str_replace(array($delemiter, '&amp;', '&'), array($modrew_alternate, ';', ';'), $matches[2]);
    $request = explode(';', $request);

    foreach ($request as $part) {
        // PM's nicht uebersetzen
        // if ($part == 'action=pm' && count($request) > 2) {
        // return $url;
        // }
        // $part = str_replace('==', '~+~#~', $part); // base64
        $parts = explode('=', $part);
        if (!isset($parts[1])) {
            // falls kein Wert zum Parameter vorhanden ist
            $parts[1] = '';
        } else if (isset($parts[2])) {
            // falls zusaetzliche IstGleich-Zeichen im Wert vorhanden sind
            $uups = $parts;
            array_shift($uups);
            // das Array neu zusammensetzen
            $parts = array($parts[0], implode('=', $uups));
        }
        // den Modulnamen extra behandeln
        if (!empty($parts[1]) && $parts[0] === 'name') {
            $name = $parts[1];
            continue;
        } else {
            $start = '';
            if ($parts[0]) {
                if (($parts[0] === 'board' || $parts[0] === 'topic') && strpos($parts[1], '.')) {
                    $part = explode('.', $parts[1]);
                    if (!empty($part[1])) {
                        $start = $delemiter . 'start' . $delemiter . $part[1];
                    }
                    $parts[1] = intval($part[0]) . $start;
                }
                if (!isset($parts[1])) {
                    $parts[1] = '';
                }
                $new .= $delemiter . $parts[0] . $delemiter . $parts[1];
            }
        }
    }

    if ($name) {
        if ($new) {
            $new = rtrim($new, $delemiter);
        }
        $name = $name . $new . $text . '.html';
        // if (strlen($name) >= 255) {
        // return $url;
        // }
        return $beginn . $name . $anchor;
    } else {
        return $url;
    }
}

/* pruefen, ob Userdaten abgeglichen werden muessen */
function mxSmfMustCheckUser($uid = 0)
{
    $last = (time()- 600); /* 10 Minuten */
    switch (true) {
      /* Debugmodus eingeschaltet, immer abgleichen */
      case (!empty($GLOBALS['mxDebugService'])):
        return true;
      /* globale Differenz seit letztem Abgleich ueberschritten */
      case ($GLOBALS['modSettings']['pmxLastUserCheck'] < $last):
        return true;
      /* fremdes Profil und Sessionsperre abgelaufen */
      case (isset($_REQUEST['action']) &&  $_REQUEST['action'] == 'profile') && (isset($_REQUEST['u']) &&  $_REQUEST['u'] != $uid):
        if (isset($_SESSION['timeOnlineUpdated']) && $_SESSION['timeOnlineUpdated'] < $last) {
            return true;
        }
      /* ansonsten, nicht abgleichen */
      default:
        return false;
    }
}
?>