<?php
/**
 * pragmaMx SMF Integration
 * Copyright by A.Ellsel (Andi) - http://pragmaMx.org
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * $Id: upgrade.php,v 1.21 2008/06/03 18:48:43 tora60 Exp $
 */

error_reporting(E_ALL);
// Version information...
define('SMF_VERSION', '1.1.5');
#define('SMF_LANG_VERSION', '1.1');

// Konstante definieren, mit der die pragmaMx-spezifischen Aenderungen in den SMF-Datein wirksam werden
if (!defined('SMF_IN_PRAGMAMX'))
    define('SMF_IN_PRAGMAMX', 1);

// die pragmaMx spezifischen Einstellungen laden
require_once(dirname(__FILE__) . '/config.php');

$file = preg_replace('#\.php$#', '', basename(__FILE__));

ob_start();

if (!is_file($mxsmf['boarddir'] . '/upgrade.php')) {
    die('file "' . $mxsmf['path'] . '/upgrade.php" is missing');
    exit;
} 

if (isset($_GET['delete'])) {
    @unlink(__FILE__);
} 

@require($mxsmf['boarddir'] . '/upgrade.php');

$smfContent = ob_get_clean();

if ($smfContent) {
    // den Link zum Forum aendern
    $smfContent = str_replace($mxsmf['path'] . '/index.php', '' . $mxsmf['path'] . '/../index.php', $smfContent);
} 

echo $smfContent;
// / Tabellenaenderungen nur bei step=1
if (empty($_REQUEST['step'])) {
    return;
} 

ob_start();
// /  Fehlerhafte Queries noch einbringen
$qry = array();
// / das Feld ban_ids stammt von einem alten fehlerhaften Update
$fields = setupGetTableFields("{$db_prefix}log_banned");
if (in_array('ban_ids', $fields)) {
    $qry[] = "ALTER TABLE `{$db_prefix}log_banned` DROP `ban_ids` ";
} 
// / die SMF-Gruppentabelle um ein Feld erweitern
$fields = setupGetTableFields("{$db_prefix}membergroups");
if (!in_array('mx_group', $fields)) {
    $qry[] = "ALTER TABLE {$db_prefix}membergroups ADD `mx_group` INT( 10 ) DEFAULT '0' NOT NULL";
    $qry[] = "ALTER TABLE {$db_prefix}membergroups ADD INDEX mx_group( `mx_group` )";
} 
// / versch. Felder in versch. Tabellen, die in aelteren Updates nicht korrekt waren
$fields = setupGetTableFields("${db_prefix}members");
if ($fields['pm_ignore_list']['Type'] != 'tinytext')
    $qry[] = "ALTER TABLE `{$db_prefix}members` CHANGE `pm_ignore_list` `pm_ignore_list` TINYTEXT NOT NULL ";

$fields = setupGetTableFields("${db_prefix}boards");
if ($fields['memberGroups']['Type'] != 'varchar(255)')
    $qry[] = "ALTER TABLE `{$db_prefix}boards` CHANGE `memberGroups` `memberGroups` VARCHAR( 255 ) DEFAULT '-1,0' NOT NULL ";
if (isset($fields['use_local_permissions']) && !isset($fields['permission_mode']))
    $qry[] = "ALTER TABLE `{$db_prefix}boards` CHANGE `use_local_permissions` `permission_mode` TINYINT( 4 ) UNSIGNED DEFAULT '0' NOT NULL ";

$fields = setupGetTableFields("${db_prefix}settings");
if ($fields['value']['Type'] != 'text')
    $qry[] = "ALTER TABLE `{$db_prefix}settings` CHANGE `value` `value` TEXT NOT NULL ";

$indexes = setupGetTableIndexes("{$db_prefix}boards");
if (!isset($indexes['memberGroups'])) {
    $qry[] = "ALTER TABLE `{$db_prefix}boards` ADD INDEX `memberGroups` ( `memberGroups` ) ";
} 
foreach ($indexes as $key => $ind) {
    if (preg_match('#^memberGroups_[0-9]+#', $key)) {
        $qry[] = "ALTER TABLE `{$db_prefix}boards` DROP INDEX `$key` ";
    } 
} 

$indexes = setupGetTableIndexes("{$db_prefix}log_online");
if (!isset($indexes['logTime'])) {
    $qry[] = "ALTER TABLE `{$db_prefix}log_online` ADD INDEX `logTime` (`logTime`)";
} 
if (isset($indexes['online'])) {
    $qry[] = "ALTER TABLE `{$db_prefix}log_online` DROP INDEX `online` ";
} 

$indexes = setupGetTableIndexes("{$db_prefix}log_search_results");
if (isset($indexes['relevance'])) {
    $qry[] = "ALTER TABLE `{$db_prefix}log_search_results` DROP INDEX `relevance` ";
} 

$indexes = setupGetTableIndexes("{$db_prefix}topics");
if (!isset($indexes['lastMessage'])) {
    $qry[] = "ALTER TABLE `{$db_prefix}topics` ADD UNIQUE `lastMessage` ( `ID_LAST_MSG` , `ID_BOARD` ) ";
} 
if (!isset($indexes['firstMessage'])) {
    $qry[] = "ALTER TABLE `{$db_prefix}topics` ADD UNIQUE `firstMessage` ( `ID_FIRST_MSG` , `ID_BOARD` ) ";
} 
// / versch. Settingswerte
if (!isset($modSettings['enable_buddylist']))
    $qry[] = "INSERT INTO `{$db_prefix}settings` VALUES ('enable_buddylist', '1')";
if (!isset($modSettings['guest_hideContacts']))
    $qry[] = "INSERT INTO `{$db_prefix}settings` VALUES ('guest_hideContacts', '1')";
if (!isset($modSettings['search_cache_size']))
    $qry[] = "INSERT INTO `{$db_prefix}settings` VALUES ('search_cache_size', '50')";
if (!isset($modSettings['send_welcomeEmail']))
    $qry[] = "INSERT INTO `{$db_prefix}settings` VALUES ('send_welcomeEmail', '0')";
// GAANZ wichtig, dass die pragmaMx-Initialisierung am Anfang der Bridge ueberhaupt durchgefuehrt wird
if (!isset($modSettings['integrate_pre_load']) || $modSettings['integrate_pre_load'] !== 'mxSmf_preLoad')
    $qry[] = "REPLACE INTO `{$db_prefix}settings` ( `variable` , `value` ) VALUES ('integrate_pre_load', 'mxSmf_preLoad')";

/* 
print('<pre>');
print_r($fields);
print_r($qry);
print_r($modSettings);
print('</pre>');
exit;
 */

foreach ($qry as $oneqry) {
    mysql_query($oneqry);
} 
ob_end_clean();
// #########################################################################################
// #########################################################################################
// liest alle Felder einer Tabelle in ein assoziatives Array
// der Feldname dient als Index
function setupGetTableFields($tablename)
{
    global $tables; 
    // print "<h5>$tablename</h5>";
    $fields = array();
    $result = mysql_query("SHOW COLUMNS FROM `${tablename}`;");
    while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
        $fields[$row['Field']] = $row;
    } 
    return $fields;
} 
// #########################################################################################
// liest alle indexe einer Tabelle in ein Array
function setupGetTableIndexes($tablename)
{
    $result = mysql_query("SHOW INDEXES FROM `${tablename}`");
    $indexes = array();
    while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
        if (!isset($indexes[$row['Key_name']])) {
            $indexes[$row['Key_name']] = $row;
        } 
        $indexes[$row['Key_name']]['all_fields'][$row['Column_name']] = $row['Seq_in_index'];
    } 
    // mxDebugFuncVars($indexes);
    return $indexes;
} 

?>