<?php
/**
 * This file is part of 
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.3 $
 * $Author: tora60 $
 * $Date: 2007/12/22 14:15:56 $
 */

defined('mxMainFileLoaded') or die('access denied');
$modname = basename(dirname(dirname(__FILE__)));

unset($sqlqry);

if (!isset($tables["${prefix}_nukebook"])) {
    $sqlqry[] = "
CREATE TABLE `${prefix}_nukebook` (
  `id` int(9) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL default '',
  `email` varchar(60) NOT NULL default '',
  `url` varchar(70) NOT NULL default '',
  `date` int(11) NOT NULL default '0',
  `host` varchar(60) NOT NULL default '',
  `comment` text NULL,
  `nukeuser` smallint(1) default '0',
  PRIMARY KEY  (`id`),
  KEY `name` (`name`),
  KEY `date` (`date`)
) TYPE=MyISAM;";
}

if (!isset($tables["${prefix}_nukebook_queue"])) {
    $sqlqry[] = "
CREATE TABLE `${prefix}_nukebook_queue` (
  `id` int(9) NOT NULL auto_increment,
  `name` varchar(50) NOT NULL default '',
  `email` varchar(60) NOT NULL default '',
  `url` varchar(70) NOT NULL default '',
  `date` int(11) NOT NULL default '0',
  `host` varchar(60) NOT NULL default '',
  `comment` text NULL,
  `nukeuser` smallint(1) default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;";
}

if (isset($tables["${prefix}_nukebook"])) {
    $tf = setupGetTableFields("${prefix}_nukebook");
    if ($tf['comment']['Default'] !== null) {
        $sqlqry[] = "ALTER TABLE `${prefix}_nukebook`
                CHANGE `comment` `comment` text NULL";
    }
}

if (isset($tables["${prefix}_nukebook_queue"])) {
    $tf = setupGetTableFields("${prefix}_nukebook_queue");
    if ($tf['comment']['Default'] !== null) {
        $sqlqry[] = "ALTER TABLE `${prefix}_nukebook_queue`
                CHANGE `comment` `comment` text NULL";
    }
}

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}

$indexes = setupGetTableIndexes("${prefix}_nukebook");
if (!isset($indexes['name'])) $sqlqry[] = "ALTER TABLE `${prefix}_nukebook` ADD INDEX `name` ( `name` ) ";
if (!isset($indexes['date'])) $sqlqry[] = "ALTER TABLE `${prefix}_nukebook` ADD INDEX `date` ( `date` ) ";

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}

?>