<?php
/**
 * This file is part of 
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.3 $
 * $Author: tora60 $
 * $Date: 2007/12/22 14:15:56 $
 */

defined('mxMainFileLoaded') or die('access denied');
$modname = basename(dirname(dirname(__FILE__)));

unset($sqlqry);
// Zusatz fuer Review-Modul
if (!isset($tables["${prefix}_reviews"])) {
    $sqlqry[] = "
CREATE TABLE `${prefix}_reviews` (
  `id` int(11) NOT NULL auto_increment,
  `date` varchar(11) NOT NULL default '0',
  `title` varchar(80) NOT NULL default '',
  `text` text NULL,
  `reviewer` varchar(25) NOT NULL default '',
  `score` tinyint(2) NOT NULL default '0',
  `cover` text,
  `url` varchar(255) default NULL,
  `url_title` varchar(80) default NULL,
  `hits` int(7) NOT NULL default '0',
  `rlanguage` varchar(40) NOT NULL default '',
  `active` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;
";
}

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}

if (isset($tables["${prefix}_reviews"])) {
    // Felder aktualisieren
    $tf = setupGetTableFields("${prefix}_reviews");
    if ($tf['title']['Default'] === null || $tf['title']['Type'] != 'varchar(80)' || $tf['text']['Default'] !== null || $tf['reviewer']['Default'] === null || $tf['reviewer']['Type'] != 'varchar(25)' || $tf['rlanguage']['Default'] === null || $tf['rlanguage']['Type'] != 'varchar(40)') {
        $sqlqry[] = "ALTER TABLE `${prefix}_reviews`
                CHANGE `title` `title` varchar(80) NOT NULL default '',
                CHANGE `text` `text` text NULL,
                CHANGE `reviewer` `reviewer` varchar(25) NOT NULL default '',
                CHANGE `rlanguage` `rlanguage` varchar(40) NOT NULL default ''
                ";
    }
    if ($tf['id']['Type'] != 'int(11)') $sqlqry[] = "ALTER TABLE `${prefix}_reviews` CHANGE `id` `id` INT(11) NOT NULL auto_increment;";
    if ($tf['date']['Type'] != 'varchar(11)') $sqlqry[] = "ALTER TABLE `${prefix}_reviews` CHANGE `date` `date` varchar(11) NOT NULL default '0';";
    if ($tf['score']['Type'] != 'tinyint(2)') $sqlqry[] = "ALTER TABLE `${prefix}_reviews` CHANGE `score` `score` tinyint(2) NOT NULL default '0';";
    if ($tf['cover']['Type'] != 'text') $sqlqry[] = "ALTER TABLE `${prefix}_reviews` CHANGE `cover` `cover` text ;";
    if ($tf['url']['Type'] != 'varchar(255)') $sqlqry[] = "ALTER TABLE `${prefix}_reviews` CHANGE `url` `url` varchar(255) ;";
    if ($tf['url_title']['Type'] != 'varchar(80)') $sqlqry[] = "ALTER TABLE `${prefix}_reviews` CHANGE `url_title` `url_title` varchar(80) ;";
    if ($tf['hits']['Type'] != 'int(7)') $sqlqry[] = "ALTER TABLE `${prefix}_reviews` CHANGE `hits` `hits` int(7) NOT NULL default '0' ;";
    // Felder anfuegen / loeschen
    if (isset($tf['email'])) $sqlqry[] = "ALTER TABLE `${prefix}_reviews` DROP `email`;";
    // wenn das neue Feld active noch nicht vorhanden war, alle Testberichte aktivieren
    if (!isset($tf['active'])) {
        $sqlqry[] = "ALTER TABLE `${prefix}_reviews` ADD `active` tinyint(1) NOT NULL default '0' AFTER `rlanguage`;";
        $sqlqry[] = "UPDATE `${prefix}_reviews` SET `active` = 1 WHERE `active` = 0;";
    }
}
// Kommentare
if (!isset($tables["${prefix}_reviews_comments"])) {
    $sqlqry[] = "
CREATE TABLE `${prefix}_reviews_comments` (
  `cid` int(11) NOT NULL auto_increment,
  `rid` int(11) NOT NULL default '0',
  `username` varchar(25) NOT NULL default '',
  `date` varchar(11) NOT NULL default '0',
  `comments` text NULL,
  `score` tinyint(2) NOT NULL default '0',
  PRIMARY KEY  (`cid`),
  KEY `username` (`username`)
) TYPE=MyISAM;";
}
// // unnoetige Tabellen umbenennen
if (isset($tables["${prefix}_reviews_add"])) $sqlqry[] = "RENAME TABLE `${prefix}_reviews_add` TO `" . RENAME_PREFIX . "${prefix}_reviews_add`;";
if (isset($tables["${prefix}_reviews_main"])) $sqlqry[] = "RENAME TABLE `${prefix}_reviews_main` TO `" . RENAME_PREFIX . "${prefix}_reviews_main`;";

if (isset($tables["${prefix}_reviews_comments"])) {
    // Felder aktualisieren
    $tf = setupGetTableFields("${prefix}_reviews_comments");
    if (isset($tf['userid'])) {
        if (isset($tf['username'])) {
            $sqlqry[] = "ALTER TABLE `${prefix}_reviews_comments` DROP `userid` ;";
        } else {
            $sqlqry[] = "ALTER TABLE `${prefix}_reviews_comments` CHANGE `userid` `username` VARCHAR( 25 ) NOT NULL default '';";
        }
        if (isset($sqlqry)) {
            setupDoAllQueries($sqlqry);
            unset($sqlqry);
        }
        // Felder neu einlesen
        $tf = setupGetTableFields("${prefix}_reviews_comments");
    }
    if ($tf['username']['Default'] === null || $tf['username']['Type'] != 'varchar(25)' || $tf['comments']['Default'] !== null || $tf['comments']['Type'] != 'text') {
        $sqlqry[] = "ALTER TABLE `${prefix}_reviews_comments`
                CHANGE `username` `username` varchar(25) NOT NULL default '',
                CHANGE `comments` `comments` text NULL";
    }
    if ($tf['cid']['Type'] != 'int(11)') $sqlqry[] = "ALTER TABLE `${prefix}_reviews_comments` CHANGE `cid` `cid` INT( 11 ) NOT NULL AUTO_INCREMENT;";
    if ($tf['rid']['Type'] != 'int(11)') $sqlqry[] = "ALTER TABLE `${prefix}_reviews_comments` CHANGE `rid` `rid` int(11) NOT NULL default '0';";
    if ($tf['date']['Type'] != 'varchar(11)') $sqlqry[] = "ALTER TABLE `${prefix}_reviews_comments` CHANGE `date` `date` varchar(11) NOT NULL default '0' ;";
    if ($tf['score']['Type'] != 'tinyint(2)') $sqlqry[] = "ALTER TABLE `${prefix}_reviews_comments` CHANGE `score` `score` tinyint(2) NOT NULL default '0' ;";
    // Indexe aktualisieren
    $indexes = setupGetTableIndexes("${prefix}_reviews_comments");
    if (isset($tf['userid'])) {
        if (isset($indexes['userid'])) $sqlqry[] = "ALTER TABLE `${prefix}_reviews_comments` DROP INDEX `userid` ";
        if (isset($indexes['username'])) $sqlqry[] = "ALTER TABLE `${prefix}_reviews_comments` DROP INDEX `username` ;";
    }
    if (!isset($indexes['username'])) $sqlqry[] = "ALTER TABLE `${prefix}_reviews_comments` ADD INDEX username( `username` ) ;";
}

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}

?>