<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.17.2.11 $
 * $Author: tora60 $
 * $Date: 2008/02/03 12:47:19 $
 *
 * this file based on:
 * php-nuke Web Portal System - http://phpnuke.org/
 * Thatware - http://thatware.org/
 * Base on Reviews Addon
 * Copyright (c) 2000 by Jeff Lambert (jeffx@ican.net) http://www.qchc.com
 * More scripts on http://www.jeffx.qchc.com
 */

defined('mxMainFileLoaded') or die('access denied');

if (!defined('PMX_VERSION')) {
    mxErrorScreen('pragmaMx >= 0.1.10 is required');
}

$module_name = basename(dirname(__FILE__));
require_once("modules/$module_name/config.php");
require("includes/captcha/settings.php");
mxGetLangfile($module_name);

$page = (empty($page)) ? 1 : intval($page);
$date = (empty($date)) ? time() : intval($date);
$date = (empty($date)) ? time() : $date;
$hits = (empty($hits)) ? 0 : intval($hits);
$id = (empty($id)) ? 0 : intval($id);
$field = (empty($field)) ? "" : $field;
$order = (empty($order)) ? "ASC" : $order;
$title = (empty($title)) ? "" : strip_tags($title);
$text = (empty($text)) ? "" : $text;
$cover = (empty($cover)) ? "" : $cover;

$wysiwyg = 0;
$wysiwyg_review = 0;
include_once('spaw/spaw_control.class.php');
// Security-Check
function reviewActionIsAllowed()
{
    global $anonpost;

    if (!MX_IS_USER && !$anonpost && !mxGetAdminPref('radminreviews')) {
        mxErrorScreen(_REVIEWNOANO, _REVIEWERROR);
        exit;
    } else {
        return true;
    }
}
// Builds the alphabetic sorting-options, index-page
function alpha()
{
    global $module_name, $anonpost, $prefix;
    $alphabet = array ("A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M",
        "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z", "", "", "", "1", "2", "3", "4", "5", "6", "7", "8", "9", "0");
    $num = count($alphabet) - 1;
    $result = sql_query("SELECT DISTINCT left( title, 1 ), count(id) FROM `" . $prefix . "_reviews` GROUP BY left( title, 1 )");
    $letters = array();
    while (list($letter, $count) = sql_fetch_row($result)) {
        $letters[strtoupper($letter)] = $count;
    }
    echo "<center>[ ";
    $counter = 0;
    while (list(, $ltr) = each($alphabet)) {
        if (isset($letters[$ltr])) {
            echo "<a href='modules.php?name=$module_name&amp;rop=$ltr' title='" . $letters[$ltr] . " " . _REVIEWS . "'>$ltr</a>";
        } else {
            echo $ltr;
        }
        if ($counter == ceil($num / 2)) {
            echo " ]\n<br>\n[ ";
        } elseif ($counter != $num) {
            echo "&nbsp;|&nbsp;\n";
        }
        $counter++;
    }
    echo " ]</center><br><br>\n";

    if (mxGetAdminPref('radminreviews') || MX_IS_USER || $anonpost) {
        echo "<center>[&nbsp;<a href=\"modules.php?name=$module_name&amp;rop=write_review\">" . _WRITEREVIEW . "</a>&nbsp;]</center><br><br>\n\n";
    }
}
// Formats score-display
function display_score($score)
{
    $bad = "<img src=\"images/td.gif\" alt=\"\">";
    $image = "<img src=\"images/blue.gif\" alt=\"\">";
    $halfimage = "<img src=\"images/bluehalf.gif\" alt=\"\">";
    $full = "<img src=\"images/star.gif\" alt=\"\">";

    if ($score == 10) {
        for ($i = 0; $i < 5; $i++)
        echo "$full";
    } elseif ($score % 2) {
        $score -= 1;
        $score /= 2;
        for ($i = 0; $i < $score; $i++)
        echo "$image";
        echo "$halfimage";
    } elseif ($score && $score != 1) {
        $score /= 2;
        for ($i = 0; $i < $score; $i++)
        echo "$image";
    } elseif ($score) {
        echo "$halfimage";
    } else {
        echo $bad;
    }
}
// Displays form to write new reviews
function write_review()
{
    global $sitename, $prefix, $user_prefix, $currentlang, $multilingual, $module_name, $anonpost, $reviewson, $captchauseron;
    if (MX_IS_USER) {
        $cookie = mxGetUserSession();
        $thisuser = $cookie[1];
    } else {
        $thisuser = $GLOBALS['anonymous'];
    }

    reviewActionIsAllowed();

    include_once('header.php');
    OpenTable();

    echo "<fieldset><legend>" . _WRITEREVIEWFOR . " $sitename</legend>
	<i>" . _ENTERINFO . "</i><br><br>
	<form method=\"post\" action=\"modules.php?name=$module_name\">
	<b>" . _PRODUCTTITLE . ":</b><br>
	<input type=\"text\" name=\"title\" size=\"60\" maxlength=\"255\"><br>
	<i>" . _NAMEPRODUCT . "</i><br>";
    if ($multilingual == 1) {
        echo "<br><b>" . _LANGUAGE . ": </b>"
         . mxLanguageSelect('rlanguage', $currentlang, 'language', 1) . "<br><br>";
    } else {
        echo "<input type=\"hidden\" name=\"rlanguage\" value=\"\"><br><br>";
    }
    if (isset($_POST['text'])) {
        $c_text = $_POST['text'];
    } else {
        $c_text = "";
    }
    echo "<b>" . _REVIEW . ":</b><br>";
    if ($GLOBALS['wysiwyg'] && $GLOBALS['wysiwyg_review']) {
        $GLOBALS['show_pagebreak'] = true;
        $sw = new SPAW_Wysiwyg('text', $c_text, _DOC_LANGUAGE, $GLOBALS['wysiwyg_toolbar'], $GLOBALS['wysiwyg_btnset'], '100%', '300');
        $sw->show();
    } else {
        echo "<textarea name=\"text\" rows=\"15\" cols=\"60\">{$c_text}</textarea>";
        if (!MX_IS_ADMIN) {
            echo "<br><i>" . _ALLOWEDHTML . "<br>" . revAllowedHtml() . "</i>";
        }
    }
    echo "<br><span class=\"tiny\">" . _PAGEBREAK . "</span><br><i>" . _CHECKREVIEW . "</i>
	<br><br>
	<b>" . _SCORE . "</b>&nbsp;
	<select name=\"score\">
	<option value=\"10\">10</option>
	<option value=\"9\">9</option>
	<option value=\"8\">8</option>
	<option value=\"7\">7</option>
	<option value=\"6\">6</option>
	<option value=\"5\" selected=\"selected\">5</option>
	<option value=\"4\">4</option>
	<option value=\"3\">3</option>
	<option value=\"2\">2</option>
	<option value=\"1\">1</option>
	<option value=\"0\">0</option>
	</select><br>
	<i>" . _SELECTSCORE . "</i><br><br>
	<b>" . _RELATEDLINK . ":</b><br>
	<input type=\"text\" name=\"url\" size=\"60\" maxlength=\"255\" value=\"\"><br>
	<i>" . _PRODUCTSITE . "</i><br><br>
	<b>" . _LINKTITLE . ":</b><br>
	<input type=\"text\" name=\"url_title\" size=\"60\" maxlength=\"255\"><br>
	<i>" . _LINKTITLEREQ . "</i><br><br>
	";
    if (mxGetAdminPref('radminreviews')) {
        echo "
		<b>" . _COVERIMAGE . ":</b><br>
		<input type=\"text\" name=\"cover\" size=\"60\" maxlength=\"255\"><br>
		<i>" . _RIMAGEFILEREQ . "</i><br><br>
		";
    }
    echo "<i>" . _CHECKINFO . "</i><br><br>";

    if (MX_IS_USER) {
        $name = $thisuser;
    } else {
        $name = $GLOBALS['anonymous'];
    }
    echo "<input type=\"hidden\" name=\"reviewer\" value=\"$name\">";
    echo "<input type=\"hidden\" name=\"rop\" value=\"preview_review\">
	<input type=\"hidden\" name=\"name\" value=\"$module_name\">
	<input type=\"submit\" value=\"" . _PREVIEW . "\"> ";
    echo "<input type=\"button\" onClick=\"history.go(-1)\" value=\"" . _CANCEL . "\"></form></fieldset>";
    CloseTable();
    include_once("footer.php");
}
// Displays review-preview before committing it
function preview_review($date, $title, $text, $reviewer, $score, $cover, $url, $url_title, $hits, $id, $rlanguage)
{
    global $sitename, $multilingual, $module_name, $anonpost, $reviewson, $captchauseron;
    $error = (empty($error)) ? "" : $error;
    $reverrormsg = (empty($reverrormsg)) ? "" : $reverrormsg;

    reviewActionIsAllowed();

    if (strstr($text, "<!--pagebreak-->")) {
        $text = str_replace("<!--pagebreak-->", "&lt;!--pagebreak--&gt;", $text);
    }
    $title = strip_tags(mxPrepareToDisplay(mxStripSlashes($title)));
    $text = mxPrepareToDisplay(mxStripSlashes($text));
    // $text = mxNL2BR($text);
    $reviewer = mxPrepareToDisplay(mxStripSlashes($reviewer));
    $cover = mxPrepareToDisplay(mxStripSlashes($cover));
    $url = mxPrepareToDisplay(mxStripSlashes($url));
    $url_title = mxPrepareToDisplay(mxStripSlashes($url_title));

    if (empty($title)) {
        $error = true;
        $reverrormsg = _INVALIDTITLE . "<br>";
    }
    if (empty($text)) {
        $error = true;
        $reverrormsg .= _INVALIDTEXT . "<br>";
    }
    if (($score < 0) || ($score > 10)) {
        $error = true;
        $reverrormsg .= _INVALIDSCORE . "<br>";
    }
    if (($hits < 0) && !empty($id)) {
        $error = true;
        $reverrormsg .= _INVALIDHITS . "<br>";
    }
    if (empty($reviewer)) {
        $error = true;
        $reverrormsg .= _CHECKNAME . "<br>";
    }
    if ((!empty($url_title) && empty($url)) || (empty($url_title) && !empty($url))) {
        $error = true;
        $reverrormsg .= _INVALIDLINK . "<br>";
    } else if (!empty($url) && !(eregi('(^http[s]*:[/]+)(.*)', $url))) {
        $url = "http://" . $url;
    }

    include_once('header.php');
    $titlezeile = _WRITEREVIEWFOR . ' ' . $sitename;
    title($titlezeile); // angepasst an Layout
    OpenTable();
    echo (!$error) ? "<form method=\"post\" action=\"modules.php?name=$module_name\">" : "";
    /* If the user ommited the http, this nifty eregi will add it */
    if ($error) { // Fehler ausgeben - angepasst an Layout
        OpenTableAl();
        echo '<h3 style="text-align: center;">' . $reverrormsg . '</h3>';
        CloseTableAl();
    } else {
        if (empty($date)) $date = time();
        $fdate = date("d.m.Y, H:m", $date);
        echo "<table border=\"0\" width=\"100%\"><tr><td colspan=\"2\">";
        echo "<p><font class=\"title\"><i><b>" . $title . "</b></i></font><br><br>";
        if ($reviewer == $GLOBALS['anonymous']) {
            echo _POSTEDBY . " $reviewer " . _ON . " $fdate<br>";
        } else {
            echo _POSTEDBY . " <a href=\"modules.php?name=Userinfo&amp;uname=" . urlencode($reviewer) . "\">$reviewer</a> " . _ON . " $fdate<br>";
        }
        echo "<b>" . _SCORE . "</b> ";
        display_score($score);
        echo "&nbsp;&nbsp;($score " . _REVIEWOF . " 10)";

        if ($multilingual == 1) {
            echo "<br><b>" . _LANGUAGE . ":</b> $rlanguage";
        }
        if (!empty($url)) {
            echo "<br><b>" . _RELATEDLINK . ":</b> <a href=\"$url\" target=\"new\">$url_title</a>";
        }
        if (!empty($id)) {
            echo "<br><b>" . _REVIEWID . ":</b> $id<br>";
            echo "<b>" . _HITS . ":</b> $hits<br>";
        }
        echo "<hr noshade size=1>";
        if ($cover != "") {
            echo "<img src=\"images/reviews/$cover\" align=\"right\" border=\"1\" vspace=\"2\" alt=\"\">";
        }
        echo "$text";
        echo "</td></tr></table>";
        echo "<hr noshade size=1>";
        echo "<p><i>" . _LOOKSRIGHT . "</i><br><br>";
        echo "<input type=\"hidden\" name=\"id\" value=$id>
		<input type=\"hidden\" name=\"hits\" value=\"$hits\">
		<input type=\"hidden\" name=\"rop\" value=\"send_review\">
		<input type=\"hidden\" name=\"date\" value=\"$date\">
		<input type=\"hidden\" name=\"title\" value=\"" . rawurlencode($title) . "\">
		<input type=\"hidden\" name=\"text\" value=\"" . rawurlencode($text) . "\">
		<input type=\"hidden\" name=\"reviewer\" value=\"$reviewer\">
		<input type=\"hidden\" name=\"score\" value=\"$score\">
		<input type=\"hidden\" name=\"url\" value=\"$url\">
		<input type=\"hidden\" name=\"url_title\" value=\"" . rawurlencode($url_title) . "\">
		<input type=\"hidden\" name=\"cover\" value=\"$cover\">";
        echo "<input type=\"hidden\" name=\"rlanguage\" value=\"$rlanguage\">";
        if (($reviewson) && ((!MX_IS_USER) || ((MX_IS_USER) && ($captchauseron))) && (!MX_IS_ADMIN)) {
            require("includes/captcha/captcha_java.php");
            echo "<br /><br /><img id=\"captchaimage\" src=\"includes/captcha/captchaimg.php?" . md5(crypt(uniqid(''))) . "\" alt=\"\"><br /><br />";
            echo "<b>" . _CAPTCHAINSERT . "</b><br />";
            echo "<input type=\"text\" name=\"captcha\" value=\"\" size=\"20\" maxlength=\"20\"><br><br>";
        }
        echo "<input type=\"submit\" name=\"rop\" value=\"" . _YES . "\">";
        // echo "<input type=\"submit\" name=\"rop\" value=\"" . _YES . "\">&nbsp;&nbsp;<input type=\"button\" onClick=\"history.go(-1)\" value=\"" . _NO . "\">&nbsp;&nbsp;";
        if (($reviewson) && ((!MX_IS_USER) || ((MX_IS_USER) && ($captchauseron))) && (!MX_IS_ADMIN)) {
            echo '<input type="button" value="' . _CAPTCHARELOAD . '" onclick="do_reload(); return false;"> ';
        }
        echo "</form>";
        if (mxGetAdminPref('radminreviews')) {
            echo "<br><br><b>" . _NOTE . "</b> " . _ADMINLOGGED . ".";
        }
    }
    // Auf jeden Fall Kann der User das Bericht bearbeiten
    // Formular ausgeben und fllen
    echo '<form method="post" action="modules.php?name=' . $module_name . '">';
    echo '<p style="background-color:' . $bgcolor2 . ';font-style:italic;padding:3px;">' . _REVIEWMOD . '</p>';
    // Produktname
    echo '<div>' . _PRODUCTTITLE . '</div>';
    echo '<input type="text" name="title" size="60" maxlength="255" value="' . $title . '" />';
    echo '<br /><span style="font-style:italic;">' . _NAMEPRODUCT . '</span>';
    // Sprache
    if ($multilingual == 1) {
        echo '<p><b>' . _LANGUAGE . ': </b>'
         . mxLanguageSelect('rlanguage', $rlanguage, 'language', 1) . '</p>';
    } else {
        echo '<input type="hidden" name="rlanguage" value="' . $rlanguage . '">';
    }
    // Beschreibung
    echo "<b>" . _REVIEW . ":</b><br>";
    if ($GLOBALS['wysiwyg'] && $GLOBALS['wysiwyg_review']) {
        $GLOBALS['show_pagebreak'] = true;
        $sw = new SPAW_Wysiwyg('text', $text, _DOC_LANGUAGE, $GLOBALS['wysiwyg_toolbar'], $GLOBALS['wysiwyg_btnset'], '100%', '300');
        $sw->show();
    } else {
        echo "<textarea name=\"text\" rows=\"15\" cols=\"60\">{$text}</textarea>";
        if (!MX_IS_ADMIN) {
            echo "<br><i>" . _ALLOWEDHTML . "<br>" . revAllowedHtml() . "</i>";
        }
    }
    // Anmerkungen
    echo '<div class="tiny">' . _PAGEBREAK . '<br />' . _CHECKREVIEW . '</div>';
    // Wertung des Produkts
    echo '<p><span style="font-weight:bold;">' . _SCORE . '</span> <select name="score">';
    for ($i = 10; $i >= 0; $i--) {
        echo '<option value="' . $i . '"';
        if ($i == $score) {
            echo ' selected="selected"';
        }
        echo '>' . $i . '</option>';
    }
    echo '</select> <span class="tiny">' . _SELECTSCORE . '</span></p>';
    // Zugehriges Link
    echo '<div style="font-weight:bold;">' . _RELATEDLINK . ':</div>';
    echo '<input type="text" name="url" size="60" maxlength="255" value="' . $url . '" />';
    echo '<br /><span class="tiny">' . _PRODUCTSITE . '</span>';
    // Link Bezeichnung
    echo '<p><span style="font-weight:bold;">' . _LINKTITLE . ':</span><br />';
    echo '<input type="text" name="url_title" size="60" maxlength="255" value="' . $url_title . '" />';
    echo '<br /><span class="tiny">' . _LINKTITLEREQ . '</span></p>';
    // Cover Bild
    if (mxGetAdminPref('radminreviews')) {
        echo '<div style="font-weight:bold;">' . _COVERIMAGE . '</div>';
        echo '<input type="text" name="cover" size="60" maxlength="255" value="' . $cover . '" />';
        echo '<br /><span class="tiny">' . _RIMAGEFILEREQ . '</span>';
    }
    // Bitte berprfen Angaben
    echo '<p style="font-style:italic;">' . _CHECKINFO . '</p>';
    // Informant
    echo '<input type="hidden" name="reviewer" value="' . $reviewer . '" />';
    // Submit zu Preview
    echo '<input type="hidden" name="rop" value="preview_review" />
			  <input type="hidden" name="name" value="' . $module_name . '" />
			  <input type="submit" value="' . _PREVIEW . '">';
    CloseTable();
    include_once("footer.php");
}
// Insert new review or changes into the database
function send_review($date, $title, $text, $reviewer, $score, $cover, $url, $url_title, $hits, $id, $rlanguage)
{
    global $prefix, $module_name, $anonpost, $revallowedit, $revautoactivate, $reviewson, $captchauseron, $passphraselenght, $storagetype;

    reviewActionIsAllowed();
    if (($reviewson) && ((!MX_IS_USER) || ((MX_IS_USER) && ($captchauseron))) && (!MX_IS_ADMIN)) {
        require_once("includes/captcha/__captcha/PhraseFactory.php");
        if ((!isset($_POST['captcha'])) || (empty($_POST['captcha']))) {
            $_POST['captcha'] = "abc!!def";
        }
        $givenCaptcha = $_POST['captcha'];
        $storedCaptcha = PhraseFactory::get('', $passphraselenght, $givenCaptcha, $storagetype);
        if ($givenCaptcha !== $storedCaptcha) {
            include("header.php");
            OpenTable();
            echo "<center><b>" . _CAPTCHAWRONG . "</b><br><br>" . _GOBACK . "</center>";
            CloseTable();
            include("footer.php");
            exit;
        }
    }
    include_once('header.php');
    // Prepare SQL-Insert
    if (strstr($text, "<!--pagebreak-->")) {
        $text = str_replace("<!--pagebreak-->", "&lt;!--pagebreak--&gt;;", $text);
    }
    $title = trim(mxAddSlashesForSQL(rawurldecode($title)));
    $text = trim(mxAddSlashesForSQL(rawurldecode($text)));
    // $text = str_replace("<br>", "\n", $text);
    // ob dieses Pagebrake sein muss, muss man noch gucken
    if (strstr($text, "&lt;!--pagebreak--&gt;")) {
        $text = str_replace("&lt;!--pagebreak--&gt;", "<!--pagebreak-->", $text);
    }
    $reviewer = mxAddSlashesForSQL($reviewer);
    $cover = mxAddSlashesForSQL($cover);
    $url = mxAddSlashesForSQL($url);
    $url_title = mxAddSlashesForSQL(rawurldecode($url_title));

    OpenTable();

    echo "<br><center>" . _RTHANKS;
    if (!empty($id))
        echo " " . _MODIFICATION . "<br>";
    else
        echo ", $reviewer.<br>";
    // Admin-Reviews sofort freischalten
    if ((mxGetAdminPref('radminreviews') || $revautoactivate) && empty($id)) {
        sql_query("INSERT INTO " . $prefix . "_reviews VALUES (NULL, '$date', '$title', '$text', '$reviewer', '$score', '$cover', '$url', '$url_title', '1', '$rlanguage', '1')");
        echo _ISAVAILABLE;
        // Admin-Aenderungen uebernehmen
    } elseif (!empty($id) && (mxGetAdminPref('radminreviews') || (MX_IS_USER && $reviewer == $thisuser && $revallowedit))) {
        sql_query("UPDATE " . $prefix . "_reviews SET title='$title', text='$text', reviewer='$reviewer', score='$score', cover='$cover', url='$url', url_title='$url_title', hits='$hits', rlanguage='$rlanguage' where id = " . intval($id));
        echo _ISAVAILABLE;
        // sonst in die Freischalt-Liste eintragen
    } else {
        sql_query("INSERT INTO " . $prefix . "_reviews SET date='$date', title='$title', text='$text', reviewer='$reviewer', score='$score', url='$url', url_title='$url_title', rlanguage='$rlanguage'");
        echo _EDITORWILLLOOK;
    }
    echo "<br><br>[&nbsp;<a href=\"modules.php?name=$module_name\">" . _RBACK . "</a>&nbsp;]<br></center>";

    CloseTable();
    include_once("footer.php");
}
// Module index-page
function reviews_index()
{
    global $bgcolor4, $bgcolor2, $bgcolor1, $prefix, $multilingual, $currentlang, $module_name, $anonpost;

    if ($GLOBALS["multilingual"] == 1) {
        if (ereg("german", $GLOBALS["currentlang"])) $thislang = "german";
        else $thislang = $GLOBALS["currentlang"];
        $querylang = "AND (rlanguage LIKE '$thislang%' OR rlanguage = '')";
    } else {
        $querylang = "";
    }

    include_once('header.php');
    OpenTable();

    echo "<table border=\"0\" width=\"95%\" cellpadding=\"2\" cellspacing=\"4\" align=\"center\">
	    <tr><td colspan=\"2\"><center><font class=\"title\">" . _RWELCOME . "</font></center><br><br>";
    alpha();
    echo "</td></tr>";
    echo "<tr><td width=\"50%\" bgcolor=\"$bgcolor2\"><b>" . _10MOSTPOP . "</b></td>";
    echo "<td width=\"50%\" bgcolor=\"$bgcolor2\"><b>" . _10MOSTREC . "</b></td></tr>";
    $result_pop = sql_query("select id, title, hits from " . $prefix . "_reviews WHERE active='1' $querylang order by hits DESC limit 10");
    $result_rec = sql_query("select id, title, date, hits from " . $prefix . "_reviews WHERE active='1' $querylang order by date DESC limit 10");
    $y = 1;
    for ($x = 0; $x < 10; $x++) {
        $myrow = sql_fetch_array($result_pop);
        $id = $myrow["id"];
        $title = mxPrepareToDisplay($myrow["title"]);
        $hits = $myrow["hits"];
        echo "<tr><td width=\"50%\" bgcolor=\"$bgcolor1\">$y) <a href=\"modules.php?name=$module_name&amp;rop=showcontent&amp;id=$id\">" . strip_tags($title) . "</a></td>";
        $myrow = sql_fetch_array($result_rec);
        $id = $myrow["id"];
        $title = mxPrepareToDisplay($myrow["title"]);
        $hits = $myrow["hits"];
        echo "<td width=\"50%\" bgcolor=\"$bgcolor1\">$y) <a href=\"modules.php?name=$module_name&amp;rop=showcontent&amp;id=$id\">" . strip_tags($title) . "</a></td></tr>";
        $y++;
    }
    echo "<tr><td colspan=\"2\"><br></td></tr>";
    $result = sql_query("SELECT * FROM " . $prefix . "_reviews WHERE active='1' $querylang");
    $numresults = sql_num_rows($result);
    echo "<tr><td colspan=\"2\"><br><center>" . _THEREARE . " $numresults " . _REVIEWSINDB . "<br><br>
	    	" . _REVIEWINTRO . "<br><br></center></td></tr></table>";

    CloseTable();
    include_once("footer.php");
}
// List reviews fitting to sorting-letter or number
function reviews($letter, $field, $order)
{
    global $bgcolor2, $bgcolor1, $sitename, $prefix, $multilingual, $currentlang, $module_name;
    $okrops = array ("A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z", "1", "2", "3", "4", "5", "6", "7", "8", "9", "0");
    $letter = (in_array($letter, $okrops)) ? $letter : "A";
    $listorders = array('DESC', 'ASC', 'desc', 'asc');
    $order = (in_array($order, $listorders)) ? $order : 'ASC';

    include_once('header.php');

    if ($GLOBALS["multilingual"] == 1) {
        if (ereg("german", $GLOBALS["currentlang"])) $thislang = "german";
        else $thislang = $GLOBALS["currentlang"];
        $querylang = "AND (rlanguage LIKE '$thislang%' OR rlanguage = '')";
    } else {
        $querylang = "";
    }

    OpenTable();

    echo "<div align='center'><b>$sitename " . _REVIEWS . "</b></div><br><br>";
    echo "<i>" . _REVIEWSLETTER . " \"<b>$letter</b>\"</i><br><br>";
    switch ($field) {
        case "reviewer":
            $result = sql_query("SELECT id, title, hits, reviewer, score FROM " . $prefix . "_reviews WHERE UPPER(title) LIKE '" . $letter . "%' AND active='1' $querylang ORDER by reviewer " . $order);
            break;

        case "score":
            $result = sql_query("SELECT id, title, hits, reviewer, score FROM " . $prefix . "_reviews WHERE UPPER(title) LIKE '" . $letter . "%' AND active='1' $querylang ORDER by score " . $order);
            break;

        case "hits":
            $result = sql_query("SELECT id, title, hits, reviewer, score FROM " . $prefix . "_reviews WHERE UPPER(title) LIKE '" . $letter . "%' AND active='1' $querylang ORDER by hits " . $order);
            break;

        default:
            $result = sql_query("SELECT id, title, hits, reviewer, score FROM " . $prefix . "_reviews WHERE UPPER(title) LIKE '" . $letter . "%' AND active='1' $querylang ORDER by title $order");
            break;
    }

    $numresults = sql_num_rows($result);
    if ($numresults == 0) {
        echo "<i><b>" . _NOREVIEWS . " \"$letter\"</b></i><br><br>";
    } elseif ($numresults > 0) {
        echo "<table border=\"0\" width=\"100%\" cellpadding=\"2\" cellspacing=\"4\">
				<tr>
				<td width=\"50%\" bgcolor=\"$bgcolor2\">
				<p align=\"left\"><a href=\"modules.php?name=$module_name&amp;rop=$letter&amp;field=title&amp;order=ASC\"><img src=\"images/up.gif\" border=\"0\" width=\"15\" height=\"9\" alt=\"" . _SORTASC . "\"></a><b> " . _PRODUCTTITLE . " </b><a href=\"modules.php?name=$module_name&amp;rop=$letter&amp;field=title&amp;order=DESC\"><img src=\"images/down.gif\" border=\"0\" width=\"15\" height=\"9\" alt=\"" . _SORTDESC . "\"></a>
				</p>
				</td>
				<td width=\"18%\" bgcolor=\"$bgcolor2\">
				<p align=\"center\"><a href=\"modules.php?name=$module_name&amp;rop=$letter&amp;field=reviewer&amp;order=ASC\"><img src=\"images/up.gif\" border=\"0\" width=\"15\" height=\"9\" alt=\"" . _SORTASC . "\"></a><b> " . _REVIEWER . " </b><a href=\"modules.php?name=$module_name&amp;rop=$letter&amp;field=reviewer&amp;order=desc\"><img src=\"images/down.gif\" border=\"0\" width=\"15\" height=\"9\" alt=\"" . _SORTDESC . "\"></a>
				</p>
				</td>
				<td width=\"18%\" bgcolor=\"$bgcolor2\">
				<p align=\"center\"><a href=\"modules.php?name=$module_name&amp;rop=$letter&amp;field=score&amp;order=ASC\"><img src=\"images/up.gif\" border=\"0\" width=\"15\" height=\"9\" alt=\"" . _SORTASC . "\"></a><b> " . _SCORE . " </b><a href=\"modules.php?name=$module_name&amp;rop=$letter&amp;field=score&amp;order=DESC\"><img src=\"images/down.gif\" border=\"0\" width=\"15\" height=\"9\" alt=\"" . _SORTDESC . "\"></a>
				</p>
				</td>
				<td width=\"14%\" bgcolor=\"$bgcolor2\">
				<p align=\"center\"><a href=\"modules.php?name=$module_name&amp;rop=$letter&amp;field=hits&amp;order=ASC\"><img src=\"images/up.gif\" border=\"0\" width=\"15\" height=\"9\" alt=\"" . _SORTASC . "\"></a><b> " . _HITS . " </b><a href=\"modules.php?name=$module_name&amp;rop=$letter&amp;field=hits&amp;order=DESC\"><img src=\"images/down.gif\" border=\"0\" width=\"15\" height=\"9\" alt=\"" . _SORTDESC . "\"></a>
				</p>
				</td>
				</tr>";
        while ($myrow = sql_fetch_array($result)) {
            $title = mxPrepareToDisplay($myrow["title"]);
            $id = $myrow["id"];
            $reviewer = $myrow["reviewer"];
            $score = $myrow["score"];
            $hits = $myrow["hits"];
            echo "<tr>
				    <td width=\"50%\" bgcolor=\"$bgcolor1\"><a href=\"modules.php?name=$module_name&amp;rop=showcontent&amp;id=$id\">" . strip_tags($title) . "</a></td>
				    <td width=\"18%\" bgcolor=\"$bgcolor1\">";
            if ($reviewer != "")
                echo "<center>$reviewer</center>";
            echo "</td><td width=\"18%\" bgcolor=\"$bgcolor1\"><center>";
            display_score($score);
            echo "</center></td><td width=\"14%\" bgcolor=\"$bgcolor1\"><center>$hits</center></td>
				  </tr>";
        }
        echo "</table>";
        echo "<br>$numresults " . _TOTALREVIEWS . "<br><br>";
    }
    echo "[&nbsp;<a href=\"modules.php?name=$module_name\">" . _RETURN2MAIN . "</a>&nbsp;]";

    CloseTable();
    include_once("footer.php");
}
// Display form to write review-comment
function postcomment($id)
{
    global $module_name, $anonpost, $reviewson, $captchauseron, $commentson;
    if (MX_IS_USER) {
        $cookie = mxGetUserSession();
        $thisuser = $cookie[1];
    } else {
        $thisuser = $GLOBALS['anonymous'];
    }

    reviewActionIsAllowed();
    $title = revGetReviewTitle($id);
    include_once("header.php");
    OpenTable();

    echo "<center><font class=option><b>" . _REVIEWCOMMENT . " $title</b><br><br></font></center>";
    echo "<form action='modules.php?name=$module_name' method='post'>";
    if (!MX_IS_USER) {
        echo "<b>" . _YOURNICK . "</b> " . $GLOBALS['anonymous'] . " [ " . _RCREATEACCOUNT . " ]<br><br>
			<input type=\"hidden\" name=\"xanonpost\" value=\"true\">";
        $uname = $GLOBALS['anonymous'];
    } else {
        echo "<b>" . _YOURNICK . "</b> $thisuser<br>";
        if ($anonpost) {
            echo "<input type='checkbox' name='xanonpost' value=''> " . _POSTANON . "<br><br>";
        } else {
            echo "<input type=\"hidden\" name=\"xanonpost\" value=\"\"><br>";
        }
        $uname = $thisuser;
    }
    echo "
	    <input type='hidden' name='uname' value='$uname'>
	    <input type='hidden' name='id' value='$id'>
	    <input type='hidden' name='name' value='$module_name'>
	    <input type='hidden' name='rop' value='savecomment'>
	    <b>" . _SELECTSCORE . "</b>
	    <select name=\"score\">
	    <option value=\"10\">10</option>
	    <option value=\"9\">9</option>
	    <option value=\"8\">8</option>
	    <option value=\"7\">7</option>
	    <option value=\"6\">6</option>
	    <option value=\"5\" selected=\"selected\">5</option>
	    <option value=\"4\">4</option>
	    <option value=\"3\">3</option>
	    <option value=\"2\">2</option>
	    <option value=\"1\">1</option>
	    <option value=\"0\">0</option>
	    </select><br><br>
	    <b>" . _YOURCOMMENT . "</b><br>
	    <textarea cols='60' rows='15' name='comments'></textarea><br><br>
	    <i>" . _ALLOWEDHTML . "<br>";
    echo revAllowedHtml();
    echo "</i><br><br>";
    if (($commentson) && ((!MX_IS_USER) || ((MX_IS_USER) && ($captchauseron))) && (!MX_IS_ADMIN)) {
        require("includes/captcha/captcha_java.php");
        echo "<br /><br /><img id=\"captchaimage\" src=\"includes/captcha/captchaimg.php?" . md5(crypt(uniqid(''))) . "\" alt=\"\"><br /><br />";
        echo "<b>" . _CAPTCHAINSERT . "</b><br />";
        echo "<input type=\"text\" name=\"captcha\" value=\"\" size=\"20\" maxlength=\"20\"><br><br>";
    }
    echo "<input type=\"submit\" value=\"" . _REVIEWSEND . "\">&nbsp;&nbsp;<input type=\"button\" onClick=\"history.go(-1)\" value=\"" . _CANCEL . "\">&nbsp;&nbsp;";
    if (($reviewson) && ((!MX_IS_USER) || ((MX_IS_USER) && ($captchauseron))) && (!MX_IS_ADMIN)) {
        echo '<input type="button" value="' . _CAPTCHARELOAD . '" onclick="do_reload(); return false;"> ';
    }
    echo "</form>";
    CloseTable();
    include_once("footer.php");
}
// Save review-comment into the database
function savecomment($xanonpost, $uname, $id, $score, $comments)
{
    global $prefix, $module_name, $anonpost, $reviewson, $captchauseron, $passphraselenght, $storagetype;
    if (($commentson) && ((!MX_IS_USER) || ((MX_IS_USER) && ($captchauseron))) && (!MX_IS_ADMIN)) {
        require_once("includes/captcha/__captcha/PhraseFactory.php");
        if ((!isset($_POST['captcha'])) || (empty($_POST['captcha']))) {
            $_POST['captcha'] = "abc!!def";
        }
        $givenCaptcha = $_POST['captcha'];
        $storedCaptcha = PhraseFactory::get('', $passphraselenght, $givenCaptcha, $storagetype);
        if ($givenCaptcha !== $storedCaptcha) {
            include("header.php");
            OpenTable();
            echo "<center><b>" . _CAPTCHAWRONG . "</b><br><br>" . _GOBACK . "</center>";
            CloseTable();
            include("footer.php");
            exit;
        }
    }
    if ($xanonpost && $anonpost) {
        $uname = $GLOBALS['anonymous'];
    }

    $comments = mxAddSlashesForSQL($comments);
    $uname = mxAddSlashesForSQL($uname);
    $date = time();

    if (empty($comments)) {
        mxErrorScreen(_INVALIDTEXT, _REVIEWERROR);
        exit;
    } elseif (reviewActionIsAllowed()) {
        sql_query("insert into " . $prefix . "_reviews_comments SET rid='$id', username='$uname', date='$date', comments='$comments', score='$score'");
        header("Location: modules.php?name=$module_name&amp;rop=showcontent&amp;id=$id");
    }
}
// Sub-function, list all comments of a review
function r_comments($id, $title)
{
    global $prefix, $module_name, $revcommentssort;
    $title = _REVIEWRE . $title;
    $result = sql_query("select cid, username, date, comments, score from " . $prefix . "_reviews_comments where rid='" . intval($id) . "' ORDER BY date $revcommentssort");
    while (list($cid, $uname, $date, $comments, $score) = sql_fetch_row($result)) {
        OpenTable();
        $date = date("d.m.Y, H:m", $date);
        echo "
			<b>" . strip_tags($title) . "</b><br>";
        if ($uname == $GLOBALS['anonymous']) {
            echo _POSTEDBY . " $uname " . _ON . " $date<br>";
        } else {
            echo _POSTEDBY . " <a href=\"modules.php?name=Userinfo&amp;uname=" . urlencode($uname) . "\">$uname</a> " . _ON . " $date<br>";
        }
        echo _MYSCORE . " ";
        display_score($score);
        echo "&nbsp;&nbsp;($score " . _REVIEWOF . " 10)";
        if (mxGetAdminPref('radminreviews')) {
            echo "<br><b>" . _ADMIN . "</b> [&nbsp;<a href=\"modules.php?name=$module_name&amp;rop=del_comment&amp;cid=$cid&amp;id=$id\">" . _DELETE . "</a>&nbsp;]<hr noshade size=1>";
        } else {
            echo "<hr noshade size=1>";
        }
        $comments = mxNL2BR(mxPrepareToDisplay($comments));
        echo $comments;
        CloseTable();
        echo "<br>";
    }
}
// Display review with all comments, multipage if needed
function showcontent($id, $page)
{
    global $uimages, $prefix, $module_name, $anonpost, $revallowemail, $revallowedit, $pagetitle;
    if (MX_IS_USER) {
        $cookie = mxGetUserSession();
        $thisuser = $cookie[1];
    } else {
        $thisuser = $GLOBALS['anonymous'];
    }
    $next_page = "";

    if ($page == 1 || empty($page)) {
        sql_query("UPDATE " . $prefix . "_reviews SET hits=hits+1 WHERE id=" . intval($id));
    }
    $result = sql_query("SELECT * FROM " . $prefix . "_reviews WHERE id=" . intval($id));
    $myrow = sql_fetch_array($result);
    $id = $myrow["id"];
    $date = date("d.m.Y, H:m", $myrow["date"]);
    $orgtitle = $myrow["title"];
    $title = mxPrepareToDisplay(strip_tags($orgtitle));
    $text = $myrow["text"];
    $cover = $myrow["cover"];
    $reviewer = $myrow["reviewer"];
    $hits = $myrow["hits"];
    $url = mxPrepareToDisplay($myrow["url"]);
    $url_title = mxPrepareToDisplay($myrow["url_title"]);
    $score = $myrow["score"];
    $rlanguage = $myrow["rlanguage"];
    $contentpages = explode("<!--pagebreak-->", $text);
    $pageno = count($contentpages);
    if (empty($page) || $page < 1)
        $page = 1;
    if ($page > $pageno)
        $page = $pageno;
    $arrayelement = (int)$page;
    $arrayelement --;

    $pagetitle = _REVIEW . ': ' . $title . (($page < 2) ? '' : ', ' . _PAGE . " $page");
    include_once('header.php');
    OpenTable();

    echo "<p><font class=\"title\"><i><b>" . $title . "</b></i></font><br><br>";
    if ($reviewer == $GLOBALS['anonymous'])
        echo _POSTEDBY . " $reviewer " . _ON . " $date<br>";
    else
        echo _POSTEDBY . " <a href=\"modules.php?name=Userinfo&amp;uname=" . urlencode($reviewer) . "\">$reviewer</a> " . _ON . " $date<br>";
    echo "<b>" . _SCORE . "</b> ";
    display_score($score);
    echo "&nbsp;&nbsp;($score " . _REVIEWOF . " 10)";
    if (!empty($url))
        echo "<br><b>" . _RELATEDLINK . ":</b> <a href=\"$url\" target=new>$url_title</a>";
    echo "<br><b>" . _HITS . ":</b> $hits";
    echo "<br><b>" . _LANGUAGE . ":</b> $rlanguage";
    if ($pageno > 1)
        echo "<br><b>" . _PAGE . ":</b> $page/$pageno<br>";
    if (mxGetAdminPref('radminreviews'))
        echo "<br><b>" . _ADMIN . "</b> [&nbsp;<a href=\"modules.php?name=$module_name&amp;rop=mod_review&amp;id=$id\">" . _EDIT . "</a> | <a href=\"modules.php?name=$module_name&amp;rop=del_review&amp;id_del=$id\">" . _DELETE . "</a>&nbsp;]<br>";
    if (!mxGetAdminPref('radminreviews') && MX_IS_USER && $reviewer == $thisuser && $revallowedit)
        echo "<br><b>" . _REVIEWER . "</b> [&nbsp;<a href=\"modules.php?name=$module_name&amp;rop=mod_review&amp;id=$id\">" . _EDIT . "</a>&nbsp;]<br>";
    echo '<hr noshade="noshade" size="1" />';
    if (!empty($cover))
        echo "<img src=\"images/reviews/$cover\" align=right border=1 vspace=2 alt=\"\">";
    // echo mxNL2BR(mxPrepareToDisplay($contentpages[$arrayelement])) . "<p>";
    echo mxPrepareToDisplay($contentpages[$arrayelement]) . "<br><br>";

    if ($page >= $pageno) {
        $next_page = "";
    } else {
        $next_pagenumber = $page + 1;
        if ($page != 1)
            $next_page .= "<img src=\"images/blackpixel.gif\" width=\"10\" height=\"2\" border=\"0\" alt=\"\"> &nbsp;&nbsp; ";
        $next_page .= "<a href=\"modules.php?name=$module_name&amp;rop=showcontent&amp;id=$id&amp;page=$next_pagenumber\">" . _NEXT . " ($next_pagenumber/$pageno)</a> <a href=\"modules.php?name=$module_name&amp;rop=showcontent&amp;id=$id&amp;page=$next_pagenumber\"><img src=\"images/next.gif\" border=\"0\" alt=\"" . _NEXT . "\"></a>";
    }

    if ($page <= 1) {
        $previous_page = "";
    } else {
        $previous_pagenumber = $page - 1;
        $previous_page = "<a href=\"modules.php?name=$module_name&amp;rop=showcontent&amp;id=$id&amp;page=$previous_pagenumber\"><img src=\"images/back.gif\" border=\"0\" alt=\"" . _PREVIOUS . "\"></a> <a href=\"modules.php?name=$module_name&amp;rop=showcontent&amp;id=$id&amp;page=$previous_pagenumber\">" . _PREVIOUS . " ($previous_pagenumber/$pageno)</a>";
    }

    echo "<center>$previous_page &nbsp;&nbsp; $next_page<br><br>";
    echo "[&nbsp;";
    if ($revallowemail)
        echo "<a href=\"modules.php?name=$module_name&amp;rop=premail_review&amp;id=$id\">" . _REVIEWFWD . "</a> | ";
    echo "<a href=\"modules.php?name=$module_name\">" . _RBACK . "</a>";
    if (mxGetAdminPref('radminreviews') || MX_IS_USER || $anonpost)
        echo " | <a href=\"modules.php?name=$module_name&amp;rop=postcomment&amp;id=$id\">" . _REPLYMAIN . "</a>";
    echo "&nbsp;]</center>";

    CloseTable();
    if ($page == 1 || empty($page)) {
        echo "<br>";
        r_comments($id, $title);
    }
    include_once("footer.php");
}
// Edit review, only allowed by admin or reviewer himself
function mod_review($id)
{
    global $prefix, $module_name, $revallowedit;

    if (MX_IS_USER) {
        $cookie = mxGetUserSession();
        $thisuser = $cookie[1];
    } else {
        $thisuser = $GLOBALS['anonymous'];
    }

    include_once('header.php');
    OpenTable();

    $result = sql_query("select * from " . $prefix . "_reviews where id = " . intval($id));
    if ($myrow = sql_fetch_array($result)) {
        $id = $myrow["id"];
        $date = $myrow["date"];
        $title = mxPrepareToDisplay($myrow["title"]);
        $text = mxPrepareToDisplay($myrow["text"]);
        $cover = mxPrepareToDisplay($myrow["cover"]);
        $reviewer = mxPrepareToDisplay($myrow["reviewer"]);
        $hits = $myrow["hits"];
        $url = mxPrepareToDisplay($myrow["url"]);
        $url_title = mxPrepareToDisplay($myrow["url_title"]);
        $score = $myrow["score"];
        $rlanguage = mxPrepareToDisplay($myrow["rlanguage"]);
    }

    if (!mxGetAdminPref('radminreviews') && (!MX_IS_USER || $thisuser != $reviewer || !$revallowedit)) {
        mxErrorScreen(_REVIEWNORIGHTS, _REVIEWERROR);
        exit;
    }

    if ($reviewer == $GLOBALS['anonymous'])
        $author = _POSTEDBY . " $reviewer " . _ON . " " . date("d.m.Y, H:m", $date) . "<br>";
    else
        $author = _POSTEDBY . " <a href=\"modules.php?name=Userinfo&amp;uname=" . urlencode($reviewer) . "\">$reviewer</a> " . _ON . " " . date("d.m.Y, H:m", $date) . "<br>";

    echo "<fieldset><legend>" . _REVIEWMOD . "</legend>";
    echo "<form action='modules.php?name=$module_name' method='post'>
		<input type='hidden' name='id' value='$id'>
		<input type='hidden' name='name' value='$module_name'>";
    echo "<table width='100%' border='0'>
			<tr>
				<td width='12%'><b>" . _RDATE . "</b></td>
				<td>
					<input type='hidden' name='date' value='$date'>
					<input type='hidden' name='reviewer' value='$reviewer'>
					$author
				</td>
			</tr>
			<tr>
				<td width='12%'><b>" . _RTITLE . "</b></td>
				<td><input type='text' name='title' value='$title' size='60' maxlength='255'></td>
			</tr>
			<tr>";
    echo "<td width='12%'><b>" . _LANGUAGE . ":</b></td>
				<td>" . mxLanguageSelect('rlanguage', $rlanguage, 'language', 1) . "</td></tr>";

    for($i = 0; $i < 11; $i++) {
        if ($score == $i)
            $select[$i] = "selected=\"selected\"";
        else
            $select[$i] = "";
    }

    echo "<tr valign='top'>
				<td width='12%'><b>" . _RTEXT . "</b></td>
				<td>";
    if ($GLOBALS['wysiwyg'] && $GLOBALS['wysiwyg_review']) {
        $GLOBALS['show_pagebreak'] = true;
        $sw = new SPAW_Wysiwyg('text', $text, _DOC_LANGUAGE, $GLOBALS['wysiwyg_toolbar'], $GLOBALS['wysiwyg_btnset'], '100%', '300');
        $sw->show();
    } else {
        echo "<textarea cols=\"60\" rows=\"15\" name=\"text\">$text</textarea>";
    }
    echo "<br><span class=\"tiny\">" . _PAGEBREAK . "</span><br><br>";
    if (!$GLOBALS['wysiwyg'] && !$GLOBALS['wysiwyg_review']) {
        echo "<i>" . _ALLOWEDHTML . "<br>";
        echo revAllowedHtml();
        echo "</i><br><br>";
    }
    echo "</td>

			</tr>
			<tr>
				<td width='12%'><b>" . _SCORE . "</b></td>
				<td>
				    <select name='score'>
				    <option value=\"10\" $select[10]>10</option>
				    <option value=\"9\" $select[9]>9</option>
				    <option value=\"8\" $select[8]>8</option>
				    <option value=\"7\" $select[7]>7</option>
				    <option value=\"6\" $select[6]>6</option>
				    <option value=\"5\" $select[5]>5</option>
				    <option value=\"4\" $select[4]>4</option>
				    <option value=\"3\" $select[3]>3</option>
				    <option value=\"2\" $select[2]>2</option>
				    <option value=\"1\" $select[1]>1</option>
				    <option value=\"0\" $select[0]>0</option>
				    </select>
				</td>
			</tr>
			<tr>
				<td width='12%'><b>" . _RLINK . "</b></td>
				<td><input type='text' name='url' value='$url' size='60' maxlength='255'></td>
			</tr>
			<tr>
				<td width='12%'><b>" . _RLINKTITLE . "</b></td>
				<td><input type='text' name='url_title' value='$url_title' size='60' maxlength='255'></td>
			</tr>
			<tr>
				<td width='12%'><b>" . _COVERIMAGE . "</b></td>
				<td><input type='text' name='cover' value='$cover' size='60' maxlength='255'></td>
			</tr>";
    if (mxGetAdminPref('radminreviews')) {
        echo "	<tr>
					<td width='12%'><b>" . _HITS . ":</b></td>
					<td><input type='text' name='hits' value='$hits' size='5' maxlength='5'></td>
				</tr>
			</table>";
    } else {
        echo "<input type=\"hidden\" name=\"hits\" value=\"$hits\"></table>";
    }
    echo "<br><input type='hidden' name='rop' value='preview_review'>
		<input type=\"submit\" value=\"" . _PREMODS . "\">&nbsp;&nbsp;
		<input type='button' value='" . _CANCEL . "' onClick='history.go(-1)'></form></fieldset>";

    CloseTable();
    include ("footer.php");
}
// Delete review with all comments, admin only
function del_review($id_del)
{
    global $prefix, $module_name;
    if (mxGetAdminPref('radminreviews')) {
        sql_query("delete from " . $prefix . "_reviews where id = " . intval($id_del));
        sql_query("delete from " . $prefix . "_reviews_comments where rid='" . intval($id_del) . "'");
        header("Location: modules.php?name=$module_name");
    } else {
        mxErrorScreen(_REVIEWNORIGHTS, _REVIEWERROR);
        exit;
    }
}
// Delete review-comment, admin only
function del_comment($cid, $id)
{
    global $prefix, $module_name;
    if (mxGetAdminPref('radminreviews')) {
        sql_query("delete from " . $prefix . "_reviews_comments where cid='" . intval($cid) . "'");
        header("Location: modules.php?name=$module_name&amp;rop=showcontent&amp;id=$id");
    } else {
        mxErrorScreen(_REVIEWNORIGHTS, _REVIEWERROR);
        exit;
    }
}
// Displays review-email formular
function premail_review($id)
{
    global $module_name, $revallowemail, $captchauseron, $reviewson;

    if (!$revallowemail) {
        mxErrorScreen(_REVIEWNORIGHTS, _REVIEWERROR);
        exit;
    }
    $title = revGetReviewTitle($id);
    include_once('header.php');
    OpenTable();

    echo "<form action='modules.php?name=$module_name' method='post'>";
    echo "<center><b>" . _REVIEWMAIL . "</b></center><br><br>";

    echo _REVIEWNAME . "<br><br>";
    echo "<b>" . $title . "</b><br><br>";

    if (MX_IS_USER) {
        $cookie = mxGetUserData();
        $from = $cookie['name'];
        $sender = $cookie['email'];
        echo _YOURNAME . ":<br><input type=\"text\" name=\"from\" value=\"$from\" size=\"60\"><br><br>" .
        _REMAIL . ":<br><input type=\"text\" name=\"sender\" value=\"$sender\" size=\"60\"><br><br>";
    } else {
        echo _YOURNAME . ":<br><input type=\"text\" name=\"from\" value=\"" . $GLOBALS['anonymous'] . "\" size=\"60\"><br><br>" .
        _REMAIL . ":<br><input type=\"text\" name=\"sender\" value=\"\" size=\"60\"><br><br>";
    }

    echo _REVIEWTO . "<br>";
    echo "<input type=\"hidden\" name=\"name\" value=\"" . $module_name . "\">";
    echo "<input type=\"hidden\" name=\"id\" value=\"" . $id . "\">";
    echo "<input type=\"text\" name=\"receiver\" value=\"\" size=\"60\"><br><br>";
    echo "<input type=\"hidden\" name=\"rop\" value=\"mail_review\">";
    if (($reviewson) && ((!MX_IS_USER) || ((MX_IS_USER) && ($captchauseron))) && (!MX_IS_ADMIN)) {
        require("includes/captcha/captcha_java.php");
        echo "<br /><br /><img id=\"captchaimage\" src=\"includes/captcha/captchaimg.php?" . md5(crypt(uniqid(''))) . "\" alt=\"\"><br /><br />";
        echo "<b>" . _CAPTCHAINSERT . "</b><br />";
        echo "<input type=\"text\" name=\"captcha\" value=\"\" size=\"20\" maxlength=\"20\"><br><br>";
        echo '<input type="button" value="' . _CAPTCHARELOAD . '" onclick="do_reload(); return false;">&nbsp;&nbsp;';
    }
    echo "<input type=\"submit\" value=\"" . _REVIEWSEND . "\">&nbsp;&nbsp;<input type=\"button\" onClick=\"history.go(-1)\" value=\"" . _CANCEL . "\">";
    echo "</form>";

    CloseTable();
    echo "<br>";
    include_once("footer.php");
}
// Sends review-link to an email-address
function mail_review($from, $sender, $receiver, $id)
{
    global $sitename, $slogan, $module_name, $revallowemail, $reveventlog, $passphraselenght, $storagetype, $reviewson, $captchauseron;
    $reverror = false;
    if (($reviewson) && ((!MX_IS_USER) || ((MX_IS_USER) && ($captchauseron))) && (!MX_IS_ADMIN)) {
        require_once("includes/captcha/__captcha/PhraseFactory.php");
        if ((!isset($_POST['captcha'])) || (empty($_POST['captcha']))) {
            $_POST['captcha'] = "abc!!def";
        }
        $givenCaptcha = $_POST['captcha'];
        $storedCaptcha = PhraseFactory::get('', $passphraselenght, $givenCaptcha, $storagetype);
        if ($givenCaptcha !== $storedCaptcha) {
            include("header.php");
            OpenTable();
            echo "<center><b>" . _CAPTCHAWRONG . "</b><br><br>" . _GOBACK . "</center>";
            CloseTable();
            include("footer.php");
            exit;
        }
    }
    if (!$revallowemail) {
        mxErrorScreen(_REVIEWNORIGHTS, _REVIEWERROR);
        exit;
    }

    $title = revGetReviewTitle($id);
    $from = mxStripSlashes($from);
    $sender = mxStripSlashes($sender);
    $receiver = mxStripSlashes($receiver);

    if (!mxCheckEmail($sender)) {
        $reverror = true;
        $reverrormes = _INVALIDEMAIL . ": $sender<br>";
    }

    if (!mxCheckEmail($receiver)) {
        $reverror = true;
        $reverrormes = _INVALIDEMAIL . ": $receiver<br>";
    }

    if (empty($from)) {
        $reverror = true;
        $reverrormes = _REVIEWFROMNEEDED;
    }

    include_once('header.php');

    OpenTable();
    echo "<center><b>" . _REVIEWMAIL . "</b></center><br><br>";

    if ($reverror) {
        echo "<b>" . _REVIEWERROR . "</b><br><br>";
        echo $reverrormes;
        echo "<br><br>" . _GOBACK;
    } else {
        $revlink = MX_HOME_URL . "/modules.php?name=$module_name&amp;rop=showcontent&amp;id=$id";
        $revsubject = "Fwd: " . $title;
        $revmessage = mxHtmlEntityDecode(_REVIEWMAIL1 . "\n\n" . _REVIEWMAIL2 . "\t" . $title . "\n" . _RLINK . "\t" . $revlink . "\n\n" . _REVIEWMAIL3 . $from . " (" . $sender . ")\n\n" .
            _REVIEWMAIL4 . _REVIEWMAILSEP . _REVIEWMAIL5 . "\n" . $sitename . " (" . MX_HOME_URL . ")\n" . $slogan);
        $sendfrom = $sender;
        // mxDebugFuncVars($revmessage);
        if (!mxMail($receiver, $revsubject, $revmessage, $sendfrom, "text", $reveventlog, $from)) {
            echo _REVIEWERROR;
            echo "<br><br>" . _GOBACK;
        } else {
            echo _REVIEWMAILOK . $receiver;
            echo "<br><br>[&nbsp;<a href=\"modules.php?name=$module_name&amp;rop=showcontent&amp;id=" . $id . "\">" . _RBACK2 . "</a> | <a href=\"modules.php?name=$module_name\">" . _RBACK . "</a>&nbsp;]";
        }
    }

    CloseTable();
    include_once("footer.php");
}

function revGetReviewTitle($id)
{
    global $prefix;
    static $title, $lastid;
    if ($lastid != $id || !isset($title)) {
        $result = sql_query("select title from " . $prefix . "_reviews WHERE id=" . intval($id));
        list($title) = sql_fetch_row($result);
        $lastid = $id;
    }
    return strip_tags($title);
}

function revAllowedHtml()
{
    $allowed = "";
    while (list($key, $access) = each($GLOBALS['AllowableHTML'])) {
        if ($access > 0) {
            $allowed .= " &lt;" . $key . "&gt;";
        }
    }
    return "<font class=\"tiny\">" . $allowed . "</font>";
}

$rop = (isset($rop)) ? $rop : '';

if (strlen($rop) == 1) {
    if (preg_match('#[a-zA-Z0-9]#', $rop)) {
        $pagetitle = _REVIEWSLETTER . ' ' . $rop;
        reviews(strtoupper($rop), $field, $order);
        exit;
    }
}

$pagetitle = _REVIEWS;
switch ($rop) {
    case "showcontent":
        showcontent($id, $page);
        break;

    case "write_review":
        $pagetitle = _WRITEREVIEWFOR . ' ' . $sitename;
        write_review();
        break;

    case "preview_review":
        $pagetitle = _WRITEREVIEWFOR . ' ' . $sitename;
        preview_review($date, $title, $text, $reviewer, $score, $cover, $url, $url_title, $hits, $id, $rlanguage);
        break;

    case _YES:
        $pagetitle = _WRITEREVIEWFOR . ' ' . $sitename;
        send_review($date, $title, $text, $reviewer, $score, $cover, $url, $url_title, $hits, $id, $rlanguage);
        break;

    case "del_review":
        del_review($id_del);
        break;

    case "mod_review":
        mod_review($id);
        break;

    case "postcomment":
        postcomment($id);
        break;

    case "savecomment":
        savecomment($xanonpost, $uname, $id, $score, $comments);
        break;

    case "del_comment":
        del_comment($cid, $id);
        break;

    case "premail_review":
        premail_review($id);
        break;

    case "mail_review":
        mail_review($from, $sender, $receiver, $id);
        break;

    default:
        reviews_index();
        break;
}

?>
