<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.10.2.7 $
 * $Author: tora60 $
 * $Date: 2008/02/02 10:40:53 $
 *
 * Based on an earlier Idea for phpNuke 4.4 from Jeff Lambert (jeffx@ican.net)
 * Totally rewritten by FrankySZ (info@cnfsz.eu)
 */

defined('mxMainFileLoaded') or die('access denied');

if (!defined('PMX_VERSION')) {
    mxErrorScreen('pragmaMx >= 0.1.10 is required');
}

$module_name = basename(dirname(__FILE__));

mxGetLangfile($module_name);
$pagetitle = _SAMODULENAME;

function update_nav($function)
{
    global $prefix, $sitename, $module_name;
    if (MX_IS_ADMIN) {
        title($sitename.': '._SAMODULENAME);
        echo '<div align="center">[';
        echo '<a href="modules.php?name=' . $module_name . '">Index</a>] - [';
        if ($function != 1) echo '<a href="modules.php?name=' . $module_name . '&amp;op=add_update">';
        echo _ADDUPDATE;
        if ($function != 1) echo '</a>';
        echo '] - [';
        if ($function != 2) echo '<a href="modules.php?name=' . $module_name . '&amp;op=mod_update">';
        echo _MODUPDATE;
        if ($function != 2) echo '</a>';
        echo '] - [';
        if ($function != 3) echo '<a href="modules.php?name=' . $module_name . '&amp;op=del_update">';
        echo _DELUPDATE;
        if ($function != 3) echo '</a>';
        echo ']</div><br /><br />';
    }
}

function display_update_box($pvs)
{
    global $bgcolor1, $bgcolor2, $bgcolor3, $bgcolor2, $textcolor1, $textcolor2, $prefix, $module_name;
    extract($pvs);
    $mod = (empty($mod)) ? 0 : $mod;
    $del = (empty($del)) ? 0 : $del;
    $date = (empty($date)) ? "" : $date;
    $email = (empty($email)) ? "" : $email;
    echo '<table border="0" width="100%" bgcolor="'.$bgcolor1.'" cellpadding="3" cellspacing="1">
						<tr>
							<td colspan="2" bgcolor="'.$bgcolor2.'"><font color="'.$textcolor1.'"><b>' . $date . ' ' . _BYSU . ' <a href="mailto:' . mxPrepareToDisplay($email) . '">' . $aid . '</a></b></font></td>
						</tr>
						<tr>
							<td width="150" bgcolor="'.$bgcolor2.'"><font color="'.$textcolor1.'">' . _EMAILSU . ' </font></td>
							<td bgcolor="'.$bgcolor3.'">' . mxPrepareToHTMLDisplay($email) . '</td>
						</tr>
						<tr>
							<td width="150" bgcolor="'.$bgcolor2.'">' . _MODFILES . ':</td>
							<td bgcolor="'.$bgcolor3.'">' . mxNL2BR(mxPrepareToHTMLDisplay($files)) . '</td>
						</tr>
						<tr><td width="150" bgcolor="'.$bgcolor2.'">' . _UPDETAIL . ':</td>
							<td bgcolor="'.$bgcolor3.'">' . mxNL2BR(mxPrepareToHTMLDisplay($updates)) . '</td>
						</tr>';
    if (!empty($bugs)) {
        echo '<tr>
								<td width="150" bgcolor="'.$bgcolor2.'">' . _POSSBUGS . ':</td>
								<td bgcolor="'.$bgcolor3.'">';
        echo mxNL2BR(mxPrepareToHTMLDisplay($bugs)) . '</td></tr>';
    }
    if (MX_IS_ADMIN) {
        if ($mod == 1) {
            echo '<tr><td bgcolor="'.$bgcolor1.'" colspan="2"><b>[&nbsp;<a href="modules.php?name=' . $module_name . '&amp;op=mod_update&amp;id=' . $id . '">' . _MODEINTRAG . '</a>&nbsp;]</b></td></tr>';
        } else if ($del == 1) {
            echo '<tr><td bgcolor="'.$bgcolor1.'" colspan="2"><b>[&nbsp;<a href="modules.php?name=' . $module_name . '&amp;op=del_update&amp;id=' . $id . '">' . _DELEINTRAG . '</a>&nbsp;]</b></td></tr>';
        } else {
            $op = (isset($_REQUEST['op'])) ? $_REQUEST['op'] : '';
            if ($op != "del_update" && $op != "add") {
                echo '<tr><td bgcolor="'.$bgcolor1.'" colspan="2" align="right">[&nbsp;<a href="modules.php?name=' . $module_name . '&amp;op=mod_update&amp;id=' . $id . '">' . _MODEINTRAG . '</a> | <a href="modules.php?name=' . $module_name . '&amp;op=del_update&amp;id=' . $id . '">' . _DELEINTRAG . '</a>&nbsp;]</td></tr>';
            }
        }
    }
    echo '</table>';
}

function add_update()
{
  global $bgcolor1, $bgcolor2, $bgcolor3, $bgcolor2, $textcolor1, $textcolor2, $module_name;

	if (MX_IS_ADMIN) {
    include ('header.php');
    OpenTable();
    update_nav(1);
        echo '<div align="center">
								<form method="post" action="modules.php">
									<input type="hidden" name="name" value="' . $module_name . '">
									<input type="hidden" name="op" value="add">
									<table width="100%" border="0" cellspacing="1" cellpadding="2">
										<tr>
											<td colspan="3" bgcolor="'.$bgcolor2.'"><i>' . _PLZENTER . '</i></td>
										</tr>
										<tr>
											<td width="15%"><b>' . _EMAILSU . ':</b></td><td width="45%"><input type="text" name="email" size="55" maxlength="50" value=""></td><td width="40%">&nbsp;</td>
										</tr>
										<tr>
											<td width="15%"><b>' . _MODFILES . ':</b></td><td width="45%"><input type="text" name="files" size="55" maxlength="50"></td><td width="40%">' . _EG3 . '</td>
										</tr>
										<tr>
											<td width="15%"><b>' . _UPDETAIL . ':</b></td><td width="45%"><textarea class="textbox" name="updates" rows="10" cols="55"></textarea></td><td width="40%">' . _SHORTDES . '</td>
										</tr>
										<tr>
											<td width="15%"><b>' . _POSSBUGS . ':</b></td><td width="45%"><textarea class="textbox" name="bugs" rows=5 cols=55></textarea></td><td width="40%">' . _NOBUGS . '</td>
										</tr>
										<tr>
											<td colspan="3" bgcolor="'.$bgcolor2.'"><i>' . _MAKESURE . '</i><br /></td>
										</tr>
										<tr>
											<td colspan="3">
												<input type="submit" value="' . _PREVUPDATE . '">
												<input type="button" onClick="history.go(-1)" value="' . _CANCEL . '">
											</td>
										</tr>
									</table><br />
								</form>
							</div>';
      CloseTable();
      include ('footer.php');
  } else {
			mxErrorScreen(_NOACCESS);
  }
}

function add($pvs, $msg = '')
{
  global $bgcolor1, $bgcolor2, $bgcolor3, $bgcolor2, $textcolor1, $textcolor2, $prefix, $sitename, $module_name;

  if (MX_IS_ADMIN) {
    $pvs = array_merge(mxStripSlashes($pvs), mxGetAdminSession());
    extract($pvs);
    include ('header.php');
    OpenTable();
    if (empty($files)) {
      $msg = _INVFILES;
    }
    if (empty($updates)) {
      $msg = _INVUPD;
    }

    if (!(ereg ('^[-!#$%&\'*+\\./0-9=?A-Z^_`a-z{|}~]+' . '@' . '[-!#$%&\'*+\\/0-9=?A-Z^_`a-z{|}~]+\.' . '[-!#$%&\'*+\\./0-9=?A-Z^_`a-z{|}~]+$', $email))) {
			$msg = _INVEMAIL;
    }
    update_nav(1);
    if ($msg) {
      OpenTableAl();
        echo '<h3 style="text-align: center;">' . $msg . '</h3>';
      CloseTableAl();
        echo '<br />';
    } else {
				echo '<div align="center"><form method="post" action="modules.php">';
        echo '<input type="hidden" name="name" value="' . $module_name . '">';
        display_update_box($pvs);
        echo '<p><i>' . _INPUTOK . '</i></p>';
        echo '<input type="hidden" name="op" value="add_update_send">
							<input type="hidden" name="files" value="' . mxEntityQuotes($files) . '">
							<input type="hidden" name="updates" value="' . mxEntityQuotes($updates) . '">
							<input type="hidden" name="bugs" value="' . mxEntityQuotes($bugs) . '">
							<input type="hidden" name="email" value="' . mxEntityQuotes($email) . '">
							<input type="submit" value="' . _YESSU . '">';
        echo '<br /><br /></form></div>';
		}
    echo '<div align="center">
						<form method="post" action="modules.php">
							<input type="hidden" name="name" value="' . $module_name . '">
							<input type="hidden" name="op" value="add">
							<table width="100%" border="0" cellspacing="1" cellpadding="2">';
		if ($msg) {
					echo '<tr>
									<td colspan="3" bgcolor="'.$bgcolor2.'"><i>' . _PLZCORRECT . '</i></td>
								</tr>';
		} else {
					echo '<tr>
									<td colspan="3" bgcolor="'.$bgcolor2.'"><i>' . _PLZENTER . '</i></td>
								</tr>';
		}
					echo '<tr>
									<td width="15%"><b>' . _EMAILSU . ':</b></td><td width="45%"><input type="text" name="email" size="55" maxlength="50" value="' . mxEntityQuotes($email) . '"></td><td width="40%">&nbsp;</td>
								</tr>
								<tr>
									<td width="15%"><b>' . _MODFILES . ':</b></td><td width="45%"><input type="text" name="files" size="55" maxlength="50" value="' . mxEntityQuotes($files) . '"></td><td width="40%">' . _EG3 . '</td>
								</tr>
								<tr>
									<td width="15%"><b>' . _UPDETAIL . ':</b></td><td width="45%"><textarea class="textbox" name="updates" rows="10" cols="55">' . mxEntityQuotes($updates) . '</textarea></td><td width="40%">' . _SHORTDES . '</td>
								</tr>
								<tr>
									<td width="15%"><b>' . _POSSBUGS . ':</b></td><td width="45%"><textarea class="textbox" name="bugs" rows="5" cols="55">' . mxEntityQuotes($bugs) . '</textarea></td><td width="40%">' . _NOBUGS . '</td>
								</tr>
								<tr>
									<td colspan="3" bgcolor="'.$bgcolor2.'"><i>' . _MAKESURE . '</i><br /></td>
								</tr>
								<tr>
									<td colspan="3"><input type="submit" value="' . _PREVUPDATE . '"></td>
								</tr>
							</table><br>
						</form>
					</div>';
        CloseTable();
        include ('footer.php');
    } else {
        mxErrorScreen(_NOACCESS);
    }
}

function add_update_send($pvs)
{
  global $prefix, $module_name;

  if (MX_IS_ADMIN) {
    $pvs = mxAddSlashesForSQL($pvs);
    extract($pvs);
    extract(mxGetAdminSession());
    $qry = "INSERT INTO ${prefix}_siteupdate (name,email,date,files,updates,bugs) VALUES ('". mxAddSlashesForSQL($aid) ."', '" . mxAddSlashesForSQL($email) . "', now(), '" . $files . "', '" . $updates . "', '" . $bugs . "')";
    sql_query($qry);
    header("Location: modules.php?name=" . $module_name);
    } else {
        mxErrorScreen(_NOACCESS);
    }
}

function del_update($id)
{
  global $bgcolor1, $bgcolor2, $bgcolor3, $bgcolor2, $textcolor1, $textcolor2, $prefix, $module_name;

	if (MX_IS_ADMIN) {
		$id = (int)$id;
    include ('header.php');
    OpenTable();
    update_nav(3);
    if ($id == 0) {
      list_updates(0, 1);
    } else if ($id != 0) {
				$result = sql_query("SELECT * FROM ${prefix}_siteupdate WHERE id='" . intval($id) . "'");
        $myrow = sql_fetch_array($result);
        $myrow['aid'] = $myrow['name'];
        display_update_box($myrow);
        echo '<form method="post" action="modules.php">
              <i>' . _SUREDEL . '</i>
              <input type="hidden" name="name" value="' . $module_name . '">
							<input type="hidden" name="op" value="del_update_send">
							<input type="hidden" name="id" value="' . $myrow['id'] . '">
              <p><input type="submit" value="' . _YESSU . '">&nbsp;&nbsp;<input type="button" onClick="history.go(-1)" value="' . _NOSU . '"></p>
							</form>';
        }
        CloseTable();
        include ('footer.php');
    } else {
        mxErrorScreen(_NOACCESS);
    }
}

function del_update_send($id)
{
    global $prefix, $module_name;
    if (MX_IS_ADMIN) {
        sql_query("delete from ${prefix}_siteupdate WHERE id = '". intval($id)."'");
        header("Location: modules.php?name=" . $module_name);
    } else {
        mxErrorScreen(_NOACCESS);
    }
}

function index()
{
  global $bgcolor1, $bgcolor2, $bgcolor3, $bgcolor2, $textcolor1, $textcolor2, $prefix;

  include ('header.php');
  OpenTable();
  update_nav(0);
  list_updates(0, 0);
  CloseTable();
  include ('footer.php');
}

function list_updates($mod, $del)
{
  global $prefix;

	$result = sql_query("SELECT * FROM ${prefix}_siteupdate ORDER BY id DESC");
  $numrows = 0;
  while ($myrow = sql_fetch_array($result)) {
    $myrow['mod'] = $mod;
    $myrow['del'] = $del;
    $myrow['aid'] = $myrow['name'];
    display_update_box($myrow);
    echo '<br />';
    $numrows ++;
  }
  echo _THEREARESU . ' ' . $numrows . ' ' . _UPDIN;
}

function mod_update($id)
{
	global $bgcolor1, $bgcolor2, $bgcolor3, $bgcolor2, $textcolor1, $textcolor2, $prefix, $module_name;

  if (MX_IS_ADMIN) {
    include ('header.php');
    OpenTable();
    update_nav(2);
    if ($id == 0) {
      list_updates(1, 0);
    } else if ($id != 0) {
        $result = sql_query("select * from ${prefix}_siteupdate where id = '".intval($id)."'");
        $myrow = sql_fetch_array($result);
        foreach($myrow as $key => $value) {
          $myrow1[$key] = mxPrepareToHTMLDisplay($value);
          $myrow2[$key] = mxPrepareToDisplay($value);
        }
        $myrow1['aid'] = $myrow1['name'];
        $myrow2['aid'] = $myrow2['name'];
        extract($myrow1, EXTR_PREFIX_ALL, "x");
        extract($myrow2);
        echo '<form method="post" action="modules.php">
							<input type="hidden" name="id" value="'.$id.'">
							<input type="hidden" name="name" value="' . $module_name . '">
							<input type="hidden" name="op" value="mod_update_send">
							<table border="0" width="100%" bgcolor="'.$bgcolor1.'">
								<tr>
									<td colspan="2" bgcolor="'.$bgcolor2.'">
										<font color="'.$textcolor1.'"><b>' . _ORIVER . '</b></font>
									</td>
									<td colspan="2" bgcolor="'.$bgcolor2.'">
										<font color="'.$textcolor1.'"><b>' . _MODVER . '</b></font>
									</td>
								</tr>
								<tr>
									<td width="12%" bgcolor="'.$bgcolor2.'">' . _NAMESU . ':</td>
									<td width="38%" bgcolor="'.$bgcolor3.'">'.$x_aid.'</td>
									<td width="12%" bgcolor="'.$bgcolor2.'">' . _NAMESU . ':</td>
									<td width="38%" bgcolor="'.$bgcolor3.'">
										<input type="text" name="aid" size="50" maxlength="40" value="'.$aid.'">
									</td>
								</tr>
								<tr>
									<td width="12%" bgcolor="'.$bgcolor2.'">' . _EMAILSU . ':</td>
									<td width="38%" bgcolor="'.$bgcolor3.'">'.$x_email.'</td>
									<td width="12%" bgcolor="'.$bgcolor2.'">' . _EMAILSU . ':</td>
									<td width="38%" bgcolor="'.$bgcolor3.'">
										<input type="text" name="email" size="50" maxlength="40" value="'.$email.'">
									</td>
								</tr>
								<tr>
									<td width="12%" bgcolor="'.$bgcolor2.'">' . _FILESSU . ':</td>
									<td width="38%" bgcolor="'.$bgcolor3.'">'.$x_files.'</td>
									<td width="12%" bgcolor="'.$bgcolor2.'">' . _FILESSU . ':</td>
									<td width="38%" bgcolor="'.$bgcolor3.'">
										<input type="text" name="files" size="50" maxlength="40" value="'.$files.'">
									</td>
								</tr>
								<tr>
									<td width="12%" bgcolor="'.$bgcolor2.'">' . _UPDATESSU . ':</td>
									<td width="38%" bgcolor="'.$bgcolor3.'">'.$x_updates.'</td>
									<td width="12%" bgcolor="'.$bgcolor2.'">' . _UPDATESSU . ':</td>
									<td width="38%" bgcolor="'.$bgcolor3.'">
										<textarea class="textbox" name="updates" rows="5" cols="55">'.$updates.'</textarea>
									</td>
								</tr>
								<tr>
									<td width="12%" bgcolor="'.$bgcolor2.'">' . _BUGSSU . ':</td>
									<td width="38%" bgcolor="'.$bgcolor3.'">'.$x_bugs.'</td>
									<td width="12%" bgcolor="'.$bgcolor2.'">' . _BUGSSU . ':</td>
									<td width="38%" bgcolor="'.$bgcolor3.'">
										<textarea class="textbox" name="bugs" rows="3" cols="55">'.$bugs.'</textarea>
									</td>
								</tr>
								<tr>
									<td width="12%" bgcolor="'.$bgcolor2.'">' . _DATESU . ':</td>
									<td width="38%" bgcolor="'.$bgcolor3.'">'.$x_date.'</td>
									<td width="12%" bgcolor="'.$bgcolor2.'">' . _DATESU . ':</td>
									<td width="38%" bgcolor="'.$bgcolor3.'">
										<input type="text" name="date" size="50" maxlength="19" value="'.$date.'">
									</td>
								</tr>
							</table>
							<p>
								<input type="hidden" name="op" value="mod_update_send">
								<input type="submit" value="' . _APPLYMOD . '">&nbsp;
								<input type="button" onClick="history.go(-1)" value="' . _CANCEL . '">
							</p>
							</form>';
        }
        CloseTable();
        include ('footer.php');
    } else {
        mxErrorScreen(_NOACCESS);
    }
}

function mod_update_send($pvs)
{
  global $bgcolor1, $bgcolor2, $bgcolor3, $bgcolor2, $textcolor1, $textcolor2, $prefix, $module_name;

	if (MX_IS_ADMIN) {
        $pvs = mxAddSlashesForSQL($pvs);
        extract($pvs);
        $error = 0;
        if ($aid == "") {
            $error = 1;
            $errormsg .= _INVNAME . '<br>';
        }

        if ($files == "") {
            $error = 1;
            $errormsg .= _INVFILES . '<br>';
        }

        if ($updates == "") {
            $error = 1;
            $errormsg .= _INVUPD . '<br>';
        }

        if (!(ereg ('^[-!#$%&\'*+\\./0-9=?A-Z^_`a-z{|}~]+' . '@' . '[-!#$%&\'*+\\/0-9=?A-Z^_`a-z{|}~]+\.' . '[-!#$%&\'*+\\./0-9=?A-Z^_`a-z{|}~]+$', $email))) {
            $error = 1;
            $errormsg .= _INVEMAIL . '<br>';
        }

        if ($error == 1) {
            include ('header.php');
            echo '<form method="post" action="modules.php">
										<input type="hidden" name="name" value="' . $module_name . '">
										<input type="hidden" name="op" value="add_update_send">';
            OpenTable();
            echo $errormsg.'<br /><input type="button" onClick="history.go(-1)" value="' . _GOBACKSU . '">';
            echo '</form>';
            CloseTable();
            include ('footer.php');
        } else {
            // exit;
            sql_query("UPDATE ${prefix}_siteupdate SET name='".$aid."', email='".$email."', files='".$files."', updates='".$updates."', bugs='".$bugs."', date='".$date."' WHERE id = '".intval($id)."'");
            header("Location: modules.php?name=" . $module_name);
        }
    } else {
        mxErrorScreen(_NOACCESS);
    }
}
$op = (isset($_REQUEST['op'])) ? $_REQUEST['op'] : "";
$id = (isset($_REQUEST['id'])) ? $_REQUEST['id'] : "";
switch ($op) {
    case "add":
        add($_POST, $msg = '');
        break;

    case "add_update":
        add_update();
        break;

    case "add_update_send":
        add_update_send($_POST);
        break;

    case "del_update":
        del_update($id);
        break;

    case "del_update_send":
        del_update_send($id);
        break;

    case "mod_update":
        mod_update($id);
        break;

    case "mod_update_send":
        mod_update_send($_POST);
        break;

    default:
        index();
        break;
}

?>