<?php
/**
 * This file is part of 
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.17.2.1 $
 * $Author: tora60 $
 * $Date: 2008/02/02 10:40:53 $
 *
 * this file based on:
 * php-nuke Web Portal System - http://phpnuke.org/
 * Thatware - http://thatware.org/
 */

defined('mxMainFileLoaded') or die('access denied');

if (!defined('PMX_VERSION')) {
    mxErrorScreen('pragmaMx >= 0.1.10 is required');
}

$module_name = basename(dirname(__FILE__));
mxGetLangfile($module_name);

$pagetitle = _TOP10;
include("header.php");

$top = (isset($_GET['top'])) ? intval($_GET['top']) : 10;
if (empty($top)) $top = 10;

if ($GLOBALS["multilingual"] == 1) {
    if (ereg("german", $GLOBALS["currentlang"])) $thislang = "german";
    else $thislang = $GLOBALS["currentlang"];
    /**
     * top stories
     */
    $queryalang = "WHERE (alanguage LIKE '$thislang%' OR alanguage='') AND `time` <= now()";
    /**
     * top stories
     */
    $querya1lang = "WHERE (alanguage LIKE '$thislang%' OR alanguage='') AND";
    /**
     * top section articles
     */
    $queryslang = "WHERE (slanguage LIKE '$thislang%' OR slanguage='') ";
    /**
     * top polls
     */
    $queryplang = "WHERE (planguage LIKE '$thislang%' OR planguage='') ";
    /**
     * top reviews
     */
    $queryrlang = "WHERE (rlanguage LIKE '$thislang%' OR rlanguage='') ";
} else {
    $queryalang = "WHERE `time` <= now()";
    $querya1lang = "WHERE";
    $queryslang = "";
    $queryplang = "";
    $queryrlang = "";
}

OpenTable();
echo "<center><font class=\"title\"><b>" . _TOPWELCOME . " $sitename!</b></font></center>";
CloseTable();
echo "<br />\n\n";
OpenTable();

/**
 * Top 10 read stories
 */

$result = sql_query("select sid, title, counter from ${prefix}_stories $queryalang ORDER BY counter DESC limit 0,$top");
if (sql_num_rows($result) > 0) {
    echo "<table border=\"0\" cellpadding=\"10\" width=\"100%\"><tr><td align=\"left\">\n"
     . "<font class=\"option\"><b>$top " . _READSTORIES . "</b></font><br /><br /><font class=\"content\">\n";
    $lugar = 1;
    while (list($sid, $title, $counter) = sql_fetch_row($result)) {
        if ($counter > 0) {
            echo "<strong><big>&middot;</big></strong>&nbsp;$lugar: <a href=\"modules.php?name=News&amp;file=article&amp;sid=$sid\">$title</a> - ($counter " . _READS . ")<br />\n";
            $lugar++;
        }
    }
    echo "</font></td></tr></table><br />\n";
}

/**
 * Top 10 most voted stories
 */

$result = sql_query("select sid, title, ratings from ${prefix}_stories $querya1lang score!=0 ORDER BY ratings DESC limit 0,$top");
if (sql_num_rows($result) > 0) {
    echo "<table border=\"0\" cellpadding=\"10\" width=\"100%\"><tr><td align=\"left\">\n"
     . "<font class=\"option\"><b>$top " . _MOSTVOTEDSTORIES . "</b></font><br /><br /><font class=\"content\">\n";
    $lugar = 1;
    while (list($sid, $title, $ratings) = sql_fetch_row($result)) {
        if ($ratings > 0) {
            echo "<strong><big>&middot;</big></strong>&nbsp;$lugar: <a href=\"modules.php?name=News&amp;file=article&amp;sid=$sid\">$title</a> - ($ratings " . _LVOTES . ")<br />\n";
            $lugar++;
        }
    }
    echo "</font></td></tr></table><br />\n";
}

/**
 * Top 10 best rated stories
 */

$result = sql_query("select sid, title, score, ratings from ${prefix}_stories $querya1lang score!=0 ORDER BY (ratings+score) DESC limit 0,$top");
if (sql_num_rows($result) > 0) {
    echo "<table border=\"0\" cellpadding=\"10\" width=\"100%\"><tr><td align=\"left\">\n"
     . "<font class=\"option\"><b>$top " . _BESTRATEDSTORIES . "</b></font><br /><br /><font class=\"content\">\n";
    $lugar = 1;
    while (list($sid, $title, $score, $ratings) = sql_fetch_row($result)) {
        if ($score > 0) {
            $rate = substr($score / $ratings, 0, 4);
            echo "<strong><big>&middot;</big></strong>&nbsp;$lugar: <a href=\"modules.php?name=News&amp;file=article&amp;sid=$sid\">$title</a> - ($rate " . _POINTS . ")<br />\n";
            $lugar++;
        }
    }
    echo "</font></td></tr></table><br />\n";
}

/**
 * Top 10 commented stories
 */

$result = sql_query("select sid, title, comments from ${prefix}_stories $queryalang ORDER BY comments DESC limit 0,$top");
if (sql_num_rows($result) > 0) {
    echo "<table border=\"0\" cellpadding=\"10\" width=\"100%\"><tr><td align=\"left\">\n"
     . "<font class=\"option\"><b>$top " . _COMMENTEDSTORIES . "</b></font><br /><br /><font class=\"content\">\n";
    $lugar = 1;
    while (list($sid, $title, $comments) = sql_fetch_row($result)) {
        if ($comments > 0) {
            echo "<strong><big>&middot;</big></strong>&nbsp;$lugar: <a href=\"modules.php?name=News&amp;file=article&amp;sid=$sid\">$title</a> - ($comments " . _COMMENTS . ")<br />\n";
            $lugar++;
        }
    }
    echo "</font></td></tr></table><br />\n";
}

/**
 * Top 10 categories
 */

$result = sql_query("select catid, title, counter from ${prefix}_stories_cat ORDER BY counter DESC limit 0,$top");
if (sql_num_rows($result) > 0) {
    echo "<table border=\"0\" cellpadding=\"10\" width=\"100%\"><tr><td align=\"left\">\n"
     . "<font class=\"option\"><b>$top " . _ACTIVECAT . "</b></font><br /><br /><font class=\"content\">\n";
    $lugar = 1;
    while (list($catid, $title, $counter) = sql_fetch_row($result)) {
        if ($counter > 0) {
            echo "<strong><big>&middot;</big></strong>&nbsp;$lugar: <a href=\"modules.php?name=News&amp;file=categories&amp;catid=$catid\">$title</a> - ($counter " . _HITS . ")<br />\n";
            $lugar++;
        }
    }
    echo "</font></td></tr></table><br />\n";
}

/**
 * Top 10 articles in special sections
 */

$result = sql_query("select artid, secid, title, content, counter from " . $prefix . "_seccont $queryslang ORDER BY counter DESC limit 0,$top");
if (sql_num_rows($result) > 0) {
    echo "<table border=\"0\" cellpadding=\"10\" width=\"100%\"><tr><td align=\"left\">\n"
     . "<font class=\"option\"><b>$top " . _READSECTION . "</b></font><br /><br /><font class=\"content\">\n";
    $lugar = 1;
    while (list($artid, $secid, $title, $content, $counter) = sql_fetch_row($result)) {
        echo "<strong><big>&middot;</big></strong>&nbsp;$lugar: <a href=\"modules.php?name=Sections&amp;artid=$artid\">$title</a> - ($counter " . _READS . ")<br />\n";
        $lugar++;
    }
    echo "</font></td></tr></table><br />\n";
}

/**
 * Top 10 users submitters
 */

$result = sql_query("select uname, counter from " . $user_prefix . "_users where counter > '0' ORDER BY counter DESC limit 0," . intval($top));
if (sql_num_rows($result) > 0) {
    echo "<table border=\"0\" cellpadding=\"10\" width=\"100%\"><tr><td align=\"left\">\n"
     . "<font class=\"option\"><b>$top " . _NEWSSUBMITTERS . "</b></font><br /><br /><font class=\"content\">\n";
    $lugar = 1;
    while (list($uname, $counter) = sql_fetch_row($result)) {
        if ($counter > 0) {
            echo "<strong><big>&middot;</big></strong>&nbsp;$lugar: <a href=\"modules.php?name=Userinfo&amp;uname=" . urlencode($uname) . "\">$uname</a> - ($counter " . _NEWSSENT . ")<br />\n";
            $lugar++;
        }
    }
    echo "</font></td></tr></table><br />\n";
}

/**
 * Top 10 Polls
 */

$result = sql_query("select * from " . $prefix . "_poll_desc $queryplang");
if (sql_num_rows($result) > 0) {
    echo "<table border=\"0\" cellpadding=\"10\" width=\"100%\"><tr><td align=\"left\">\n"
     . "<font class=\"option\"><b>$top " . _VOTEDPOLLS . "</b></font><br /><br /><font class=\"content\">\n";
    $lugar = 1;
    $result = sql_query("SELECT pollID, pollTitle, timeStamp, voters FROM " . $prefix . "_poll_desc $queryplang ORDER BY voters DESC limit 0,$top");
    $counter = 0;
    while ($object = sql_fetch_array($result)) {
        $resultArray[$counter] = array($object['pollID'], $object['pollTitle'], $object['timeStamp'], $object['voters']);
        $counter++;
    }
    for ($count = 0; $count < count($resultArray); $count++) {
        $id = $resultArray[$count][0];
        $pollTitle = $resultArray[$count][1];
        $voters = $resultArray[$count][3];
        $sum = 0;
        for($i = 0; $i < 12; $i++) {
            $result = sql_query("SELECT optionCount FROM " . $prefix . "_poll_data WHERE (pollID=$id) AND (voteID=$i)");
            $object = sql_fetch_array($result);
            $optionCount = $object['optionCount'];
            $sum = (int)$sum + $optionCount;
        }
        echo "<strong><big>&middot;</big></strong>&nbsp;$lugar: <a href=\"modules.php?name=Surveys&amp;pollID=$id\">$pollTitle</a> - ($sum " . _LVOTES . ")<br />\n";
        $lugar++;
        $sum = 0;
    }
    echo "</font></td></tr></table><br />\n";
}

/**
 * Top 10 authors
 */

$result = sql_query("select aid, counter from " . $prefix . "_authors WHERE counter>0 ORDER BY counter DESC limit 0,$top");
if (sql_num_rows($result) > 0) {
    echo "<table border=\"0\" cellpadding=\"10\" width=\"100%\"><tr><td align=\"left\">\n"
     . "<font class=\"option\"><b>$top " . _MOSTACTIVEAUTHORS . "</b></font><br /><br /><font class=\"content\">\n";
    $lugar = 1;
    while (list($aid, $counter) = sql_fetch_row($result)) {
        if ($counter > 0) {
            echo "<strong><big>&middot;</big></strong>&nbsp;$lugar: <a href=\"modules.php?name=Search&amp;query=&amp;author=$aid\">$aid</a> - ($counter " . _NEWSPUBLISHED . ")<br />\n";
            $lugar++;
        }
    }
    echo "</font></td></tr></table><br />\n";
}

/**
 * Top 10 downloads
 */

$result = sql_query("select lid, cid, title, hits from " . $prefix . "_downloads_downloads WHERE cid > 0 AND hits>0 ORDER BY hits DESC limit 0,$top");
if (sql_num_rows($result) > 0) {
    echo "<table border=\"0\" cellpadding=\"10\" width=\"100%\"><tr><td align=\"left\">\n"
     . "<font class=\"option\"><b>$top " . _DOWNLOADEDFILES . "</b></font><br /><br /><font class=\"content\">\n";
    $lugar = 1;
    while (list($lid, $cid, $title, $hits) = sql_fetch_row($result)) {
        if ($hits > 0) {
            $res = sql_query("select title from " . $prefix . "_downloads_categories where cid='" . intval($cid) . "'");
            list($ctitle) = sql_fetch_row($res);
            $utitle = str_replace(" ", "_", $title);
            echo "<strong><big>&middot;</big></strong>&nbsp;$lugar: <a href=\"modules.php?name=Downloads&amp;op=view&amp;lid=" . $lid . "\">" . $title . "</a> (" . _CATEGORY . ": " . $ctitle . ") - (" . $hits . " " . _LDOWNLOADS . ")<br />\n";
            $lugar++;
        }
    }
    echo "</font></td></tr></table>\n\n";
}
/**
 * Top 10 weblinks
 */

$result = sql_query("select lid, cid, title, hits from " . $prefix . "_links_links WHERE hits>0 ORDER BY hits DESC limit 0,$top");
if (sql_num_rows($result) > 0) {
    echo "<table border=\"0\" cellpadding=\"10\" width=\"100%\"><tr><td align=\"left\">\n"
     . "<font class=\"option\"><b>$top " . _LINKEDFILES . "</b></font><br /><br /><font class=\"content\">\n";
    $lugar = 1;
    while (list($lid, $cid, $title, $hits) = sql_fetch_row($result)) {
        if ($hits > 0) {
            $res = sql_query("select title from " . $prefix . "_links_categories where cid='" . intval($cid) . "'");
            list($ctitle) = sql_fetch_row($res);
            $utitle = str_replace(" ", "_", $title);
            echo "<strong><big>&middot;</big></strong>&nbsp;$lugar: <a href=\"modules.php?name=Web_Links&amp;op=view&amp;lid=$lid\">$title</a> (" . _CATEGORY . ": $ctitle) - ($hits " . _TIMESL . ")<br />\n";
            $lugar++;
        }
    }
    echo "</font></td></tr></table>\n\n";
}
/**
 * Top 10 Pages in Content
 */

$result = sql_query("select pid, title, counter from ${prefix}_pages where active='1' AND counter>0 ORDER BY counter DESC limit 0," . intval($top));
if (sql_num_rows($result) > 0) {
    echo "<table border=\"0\" cellpadding=\"10\" width=\"100%\"><tr><td align=\"left\">\n"
     . "<font class=\"option\"><b>$top " . _MOSTREADPAGES . "</b></font><br /><br /><font class=\"content\">\n";
    $lugar = 1;
    while (list($pid, $title, $counter) = sql_fetch_row($result)) {
        if ($counter > 0) {
            echo "<strong><big>&middot;</big></strong>&nbsp;$lugar: <a href=\"modules.php?name=Content&amp;pid=$pid\">$title</a> ($counter " . _READS . ")<br />\n";
            $lugar++;
        }
    }
    echo "</font></td></tr></table>\n\n";
}
// ############  START Userpoints Settings  by  www.shiba-design.de ####################
/**
 * Top xx Userpunkte
 */
$numusers = 20;

if (!defined("mxYALoaded")) define("mxYALoaded", 1);
include("modules/Your_Account/config.php");
if (!empty($useuserpoints) || MX_IS_ADMIN) {
    // SQL-bedingung fuer excluded Users erstellen
    $exusers = explode (",", $excludedusers);
    if (!MX_IS_ADMIN) {
        foreach ($exusers as $key => $value) {
            $xexusers[] = trim($value);
        }
    }
    $xexusers[] = $GLOBALS['anonymous'];
    $xexusers[] = "Anonymous";
    $excludedusers = "'" . implode("','", mxAddSlashesForSQL($xexusers)) . "'";

    $qry = "
SELECT ${prefix}_userpoints.punkte, ${user_prefix}_users.uname
FROM ${prefix}_userpoints
LEFT JOIN ${user_prefix}_users
ON ${prefix}_userpoints.uid = ${user_prefix}_users.uid
WHERE ${user_prefix}_users.user_stat=1 AND ${prefix}_userpoints.punkte>0 AND (${user_prefix}_users.uname not in($excludedusers))
ORDER BY ${prefix}_userpoints.punkte DESC, ${prefix}_userpoints.uid
LIMIT 0,$numusers;";
    $result = sql_query($qry);
    $content1 = "";
    $ipoints = 0;
    if ($result) {
        while (list($punkte, $xuname) = sql_fetch_row($result)) {
            $ipoints++;
            $content1 .= "<strong><big>&middot;</big></strong>&nbsp;$ipoints: <a href=\"modules.php?name=Userinfo&uname=$xuname\">$xuname</a> - ($punkte " . _USERPUNKTE1 . ")<br />\n";
        }
    }
    if ($ipoints > 0) {
        echo "<table border=\"0\" cellpadding=\"10\" width=\"100%\"><tr><td	align=\"left\">\n"
         . "<a name=\"POINT\"><font class=\"option\"><b>$ipoints " . _TOPUSERPUNKTE . "</b></font></a><br /><br /><font class=\"content\">\n";
        echo $content1;
        echo "</font></td></tr></table><br />\n";
    }
}
CloseTable();
include("footer.php");
