<?php
/**
 * This file is part of 
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.3.2.2 $
 * $Author: tora60 $
 * $Date: 2007/12/22 14:11:52 $
 *
 * this file based on:
 * php-nuke Web Portal System - http://phpnuke.org/
 * Thatware - http://thatware.org/
 * Based on Journey Links Hack
 * Copyright (c) 2000 by James Knickelbein
 * Journey Milwaukee (http://www.journeymilwaukee.com)
 */

defined('mxMainFileLoaded') or die('access denied');

function getit($lid)
{
    global $prefix, $module_name, $pagetitle;
    $qry = "SELECT dd.lid, dd.title, dd.url, dc.captcha, dc.cid
        FROM " . $prefix . "_links_links AS dd INNER JOIN " . $prefix . "_links_categories AS dc ON dd.cid = dc.cid
        WHERE dd.lid=" . intval($lid) . "
         AND dd.cid > 0
        LIMIT 1";
    $result = sql_query($qry);
    list($lid, $title, $url, $captcha, $cid) = sql_fetch_row($result);
    if (empty($lid)) {
        mxErrorScreen(_WLFNOTFOUND . ' (1)');
        exit;
    }

    $captchauseron = 0;
    if ($captcha && !MX_IS_ADMIN) {
        require("includes/captcha/settings.php");
    }

    if (!$captcha || (MX_IS_USER && !$captchauseron)) {
        getLinkNow($lid, $url);
        exit;
    }

    $msg = '';
    if (!empty($_POST['captcha']) && isset($_POST['pass']) && isset($_POST['lid'])) {
        require_once("includes/captcha/__captcha/PhraseFactory.php");
        $storedCaptcha = PhraseFactory::get('', $passphraselenght, $_POST['captcha'], $storagetype);
        if ($_POST['captcha'] === $storedCaptcha) {
            getLinkNow($lid, $url);
            exit;
        }
        $msg = _CAPTCHAWRONG;
    }
    if (isset($_POST['captcha']) && isset($_POST['pass'])) {
        $target = '_self';
    } else {
        $target = '_blank';
    }
    // Daten fuer header aufbereiten
    $pagetitle = strip_tags($title . ', ' . _LINKING);
    $pagesubmenu = modDetailsTopMenu($lid);
    include('modules/' . $module_name . '/includes/header.php');

    OpenTable();
    echo '<h4 class="option">' . _LINKING . '</h4>';
    echo "<p>" . _WLFBECAUSE . "</p>";
    if ($msg) {
        openTableAl();
        echo '<h3 style="text-align: center;">' . $msg . '!</h3>';
        closeTableAl();
        echo '<br>';
    }
    modFetchForm($lid, $title, $url, $target);
    echo "<p>" . _WLFYOUHAVE . ": &quot;<b>" . trim($title) . "</b>&quot;</p>";
    echo "<p align=\"center\">" . _GOBACK . "</p>";
    CloseTable();
    include('modules/' . $module_name . '/includes/footer.php');
}

function getLinkNow($lid, $url)
{
    global $prefix, $module_name, $pagetitle, $hidepath;

    $redir = false;
    $error = false;
    // die url aufsplitten
    $url_parsed = parse_url($url);
    // falls url direkt auf eine Datei auf dem eigenen Server verlinkt
    if (empty($url_parsed["scheme"]) || empty($url_parsed["host"])) {
        // und diese Datei wirklich existiert
        if (@is_file($url_parsed['path'])) {
            $redir = true;
        } else {
            $error = true;
        }
    } else {
        $redir = true;
        if (is_callable('readfile') && is_callable('fsockopen') && is_callable('fputs')) {
            // Falls deaktiviert
            @ini_set('allow_url_fopen', "1");
            // den Header abfragen
            $header = get_response_header($url);
            /**
             * wenn ungueltige URL, diesen Link als ungueltig in der
             * Administration kennzeichnen, aber trotzdem weiterleiten
             */
            if ($header['status'] === 404) {
                $error = true;
            }
            // falls die zuletzt weitergeleitete url gueltig war, direkt dorthin verlinken
            else if ($header['status'] === 200 && $header['url'] != $url) {
                $url = $header['url'];
            }
            // allow_url_fopen wieder zurcksetzen auf originalkonfig
            @ini_restore('allow_url_fopen');
        }
    }
    // weiterleiten?
    if ($redir) {
        if ($error) {
            modReportFalses($lid);
            header('HTTP/1.1 410 Gone');
        } else {
            header('HTTP/1.1 301 Moved Permanently');
        }
        // Increase the counter for total links
        sql_query("update " . $prefix . "_links_links set hits=hits+1 where lid=" . intval($lid));
        // hier normal umleiten...
        mxRedirect($url);
        exit;
    }
    /**
     * wenn keine Ausgabe/Umleitung stattgefunden hat, diesen Link als
     * ungueltig in der Administration kennzeichnen
     */
    modReportFalses($lid);
    // Userdaten ermitteln
    $udata = mxGetUserData();
    $username = (empty($udata['uname'])) ? $GLOBALS['anonymous'] : $udata['uname'];
    // Daten fuer header aufbereiten
    $result = sql_query("select title, cid from " . $prefix . "_links_links WHERE lid=" . intval($lid));
    list($title, $cid) = sql_fetch_row($result);
    $pagetitle = strip_tags($title . ', ' . _WLFNOTFOUND);
    $pagesubmenu = modDetailsTopMenu($lid);

    include('modules/' . $module_name . '/includes/header.php');
    OpenTable();
    echo '<h4 class="option">' . _LINKING . '</h4>';
    echo "<p>" . _WLFSORRY1 . " " . $username . " :-(</p><br><p>" . sprintf(_WLFSORRY2, $title) . "</p>";
    CloseTable();
    echo "<br>";
    include('modules/' . $module_name . '/includes/footer.php');
}

/**
 * fehlerhafte Links als Fehler melden
 */
function modReportFalses($lid)
{
    static $run = 0;
    if ($run) {
        // verhindern, dass doppelt ausgefuehrt wird
        return true;
    }
    $run = 1;
    global $prefix, $module_name, $linknotify;
    $result = sql_query("SELECT sid as reported FROM " . $prefix . "_links_links WHERE lid=" . intval($lid) . " LIMIT 1");
    $row = sql_fetch_row($result);
    if ($row['reported']) {
        // wenn bereits informiert, Funktion beenden
        return true;
    } else {
        // als informiert kennzeichnen, damit dieser Link nie wieder gemeldet
        // wird. Dies wird beim naechsten speichern des Links wieder zurueckgesetzt
        sql_query("UPDATE " . $prefix . "_links_links SET sid=1 WHERE lid=" . intval($lid));
    }
    $modifysubmitter = 'Linkscript at ';
    $result = sql_query("SELECT lid FROM " . $prefix . "_links_modrequest WHERE (lid=" . intval($lid) . " AND brokenlink=1 AND modifysubmitter LIKE '" . $modifysubmitter . "%') LIMIT 1");
    $row = sql_fetch_row($result);
    if (empty($row)) {
        $modifysubmitter .= date("Y-m-d g:i");
        $qry = "INSERT INTO " . $prefix . "_links_modrequest (lid, modifysubmitter, brokenlink)
                VALUES (
                " . intval($lid) . ",
                '" . mxAddSlashesForSQL($modifysubmitter) . "',
                1)";
        if (sql_query($qry)) {
            // mail an admin senden
            if ($linknotify) {
                $link = MX_HOME_URL . '/admin.php?op=LinksListBroken';
                $notify_message = mxHtmlEntityDecode("-- " . _DUSERREPBROKEN . " --\n" . $GLOBALS['notify_message'] . "\n\n========================================================\n" . $link . "\n\nat: " . strftime(_SHORTDATESTRING . ' %H:%M', time()) . "\nip/ip:" . MX_REMOTE_ADDR . "\nfrom: " . $modifysubmitter . "\n");
                mxMail($GLOBALS['notify_email'], mxHtmlEntityDecode($GLOBALS['notify_subject'] . ' (' . _MODUNAME . ')'), $notify_message, $GLOBALS['notify_from'], "text");
            }
        }
    }
}

?>