<?php
/**
 * This file is part of 
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.24 $
 * $Author: tora60 $
 * $Date: 2008/01/30 22:09:10 $
 */

defined('mxMainFileLoaded') or die('access denied');

/**
 * Identifikation von bereits installierten nuke oder pmx Versionen
 * checkt, ob es ein INSTALLIERTES pragmaMx ist
 */
function setupGetOldVersion()
{
    static $oldversion;
    if (isset($oldversion)) return $oldversion;
    $isconfig = false;
    $oldversion = 'new';
    // wenn config.php vorhanden ist
    if (@file_exists(FILE_CONFIG_ROOT)) {
        // diese versuchen zu includen, um Fehlermeldungen zu vermeiden innerhalb von Ausgabepuffer
        ob_start();
        @include(FILE_CONFIG_ROOT);
        ob_end_clean();
        if (isset($dbhost) && isset($dbuname) && isset($dbpass) && isset($dbname) && isset($prefix) && isset($user_prefix) && isset($dbtype)) {
            if ($dbtype == "MySQL") {
                $isconfig = true;
            }
        }
    }
    // wenn config.php includet wurde
    if ($isconfig) {
        // und darin die Variable $Version_Num vorhanden ist
        if (isset($Version_Num)) {
            // und die Konstante MX_FIRSTGROUPNAME definiert ist
            if (defined("MX_FIRSTGROUPNAME")) {
                // dann ist es eine vkpMx/mX Version
                $oldversion = 'pragmamx';
            } else {
                // ansonsten eine phpNuke Version vor 6.0
                $oldversion = 'nuke56';
            }
        } else { // wenn nicht, knnte es ein phpNuke >= 6.0 sein
            // versuchen Datenbankverbindung herzustellen
            $dbstat = setupConnectDb($dbhost, $dbuname, $dbpass, $dbname);
            if (isset($dbstat['dbi'])) {
                // versuchen die nuke-config Tabelle auszulesen
                $result = @mysql_query("SELECT Version_Num from ${prefix}_config");
                // wenn erfolgreich...
                if (is_resource($result)) {
                    // nukeversion feststellen
                    list($nukeversion) = @mysql_fetch_row($result);
                    // mxDebugFuncVars(doubleval($nukeversion));
                    if (doubleval($nukeversion) == 6.0) {
                        $oldversion = 'nuke56';
                    } else if (doubleval($nukeversion) > 6.0) {
                        $oldversion = 'nuke6x';
                    }
                }
            }
        }
    }
    // TODO: das muss dann wieder verbessert / aktualisiert werden...
    $oldversion = ($oldversion == 'new') ? 'new' : 'update';
    return $oldversion;
}

/**
 * sobald die config.php geschrieben ist, wird diese Verbindung verwendet
 */
function setupConnectDb($dbhost = '', $dbuname = '', $dbpass = '', $dbname = '')
{
    $out['msg'] = '';
    if (empty($dbhost) && empty($dbuname) && empty($dbpass) && empty($dbname)) {
        @ini_set('track_errors', '1');
        if (!@include(FILE_CONFIG_ROOT)) {
            $out['msg'] = '
            	<div class="warning">
								<p>' . _THEREERROR . ':</p>
								<p>' . _SERVERMESSAGE . ': ' . @$php_errormsg . '</p>
							</div>';
            return $out;
        }
    }
    $dbi = @mysql_connect($dbhost, $dbuname, $dbpass);
    if (!$dbi) {
        $out['msg'] .= '
        	<p><strong>' . _NOT_CONNECT . '</strong></p><p>' . _SERVERMESSAGE . ': ' . mysql_error() . ' (' . mysql_errno() . ')</p>';
    } else {
        if (!defined('MX_SQL_VERSION')) {
            list($mysqlversion) = mysql_fetch_row(mysql_query("SELECT VERSION() as version"));
            define('MX_SQL_VERSION', $mysqlversion);
        }
        if (!mysql_select_db($dbname , $dbi)) {
            $out['msg'] .= '<p>' . _DBNOTEXIST . '</p>
							<p>' . _SERVERMESSAGE . ': ' . mysql_error() . ' (' . mysql_errno() . ')</p>';
            // $out['dbnotexist'] = TRUE;
        } else {
            $out['dbi'] = $dbi;
            $out['msg'] .= sprintf(_DB_CONNECTSUCCESS, $dbname);
        }
    }
    return $out;
}

/**
 * checkt ob eine Tabelle vorhanden ist,
 * mit dem 2ten Parameter kann das Tabellenarray aktualisiert werden
 */
function setupTableExist($tablename, $refr_array = 0)
{
    global $tables;
    if (empty($tablename)) {
        return false;
    }
    $result = mysql_query("SHOW TABLES LIKE '${tablename}';");
    $is = mysql_num_rows($result);
    if ($is) {
        if ($refr_array) {
            $tables[$tablename] = $tablename;
        }
        return true;
    } else {
        if ($refr_array) {
            unset($tables[$tablename]);
        }
        return false;
    }
}

/**
 * liest alle Felder einer Tabelle in ein assoziatives Array
 * der Feldname dient als Index
 */
function setupGetTableFields($tablename)
{
    global $tables;
    // print "<h5>$tablename</h5>";
    $fields = array();
    $result = mysql_query("SHOW COLUMNS FROM `${tablename}`");
    if (!$result || mysql_error()) {
        // irgenwie kommt das ab und an zu dem Fehler:
        // - Can't create/write to file '/tmp/#sql_8c4_0.MYD' (Errcode: 13)
        // http://bugs.mysql.com/bug.php?id=25872
        // dann einfach etwas warten und nochmal probieren ;-))
        sleep(1);
        $result = mysql_query("SHOW COLUMNS FROM `${tablename}`");
    }
    while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
        $fields[$row['Field']] = $row;
    }
    mysql_free_result($result);
    return $fields;
}

/**
 * liest alle indexe einer Tabelle in ein Array
 */
function setupGetTableIndexes($tablename)
{
    $indexes = array();
    $result = mysql_query("SHOW INDEXES FROM `${tablename}`");
    if (!$result || mysql_error()) {
        // siehe dazu: setupGetTableFields()
        sleep(1);
        $result = mysql_query("SHOW INDEXES FROM `${tablename}`");
    }
    while ($row = mysql_fetch_array($result, MYSQL_ASSOC)) {
        if (!isset($indexes[$row['Key_name']])) {
            $indexes[$row['Key_name']] = $row;
        }
        $indexes[$row['Key_name']]['all_fields'][$row['Column_name']] = $row['Seq_in_index'];
    }
    mysql_free_result($result);
    return $indexes;
}

/**
 * dient nur zur Filterung von $_GET, $_POST, $_COOKIE
 */
function setupSecureValue($value)
{
    if (get_magic_quotes_gpc()) {
        $value = stripslashes($value);
    }
    $value = htmlspecialchars($value, ENT_QUOTES);
    // $value = str_replace('"','&quot;',$value);
    // $value = str_replace("'",'&acute;',$value);
    return $value;
}

/**
 * ermittelt die verfuegbaren Setup-Sprachen und zeigt eine Liste der Flaggen an
 */
function mxGetAllLanguages($goto, $folder = 'language')
{
    static $langlist;
    if (isset($langlist)) return $langlist;
    $out = '';
    // $pre = "border=\"0\" hspace=\"3\" vspace=\"3\" width=\"30\" height=\"16\"";
    $langlist = array();
    $handle = @opendir($folder);
    if (!$handle) die("<h2>Error: the language-folder (<em>/" . $folder . "</em>) is missing!</h2>");
    while (false !== ($file = readdir($handle))) {
        if (preg_match("#^lang\-(.+)\.php$#", $file, $matches)) {
            $key = ucwords(str_replace("_", " ", str_replace("german", "deutsch", $matches[1])));
            $langlist[$key] = "<li><a href=\"" . $goto . "&amp;slang=" . $matches[1] . "&amp;mxsetupid=" . SETUP_ID . "\" title=\"" . $key . "\"><img src=\"language/images/flag-" . $matches[1] . ".png\" alt=\"" . $key . "\" title=\"" . $key . "\"  />&nbsp;</a><a href=\"" . $goto . "&amp;slang=" . $matches[1] . "&amp;mxsetupid=" . SETUP_ID . "\" title=\"" . $key . "\">" . $key . "</a></li>\n";
        }
    }
    closedir($handle);
    if (!count($langlist)) die("<h2>Error: the language-folder (<em>/" . $folder . "</em>) is empty!</h2>");
    ksort($langlist);
    return '
    	<ul class="flag-list">
    		' . implode("", $langlist) . '
    	</ul>';
}

/**
 * ermittelt die verfuegbaren Setup-Sprachen und zeigt eine Liste der Flaggen an
 */
function setupLanguageSelect($selectname, $folder = PATH_MX_LANGUAGE)
{
    $clanguage = "";
    $handle = @opendir($folder);
    if (!$handle) return '<input type="hidden" name="language" value="' . $_REQUEST['slang'] . '" />' . $_REQUEST['slang'] . '';
    while (false !== ($file = readdir($handle))) {
        if (preg_match("#^lang\-(.+)\.php$#", $file, $matches)) {
            $key = ucwords(str_replace("_", " ", str_replace("german", "deutsch", $matches[1])));
            $clanguage .= "<option value=\"" . $matches[1] . "\"" . (($matches[1] == $_REQUEST['slang']) ? ' selected="selected"' : '') . ">" . $key . "</option>\n";
        }
    }
    closedir($handle);
    if (!$clanguage) return '<input type="hidden" name="language" value="' . $_REQUEST['slang'] . '" />' . $_REQUEST['slang'] . '';
    return "<select name=\"" . $selectname . "\">\n" . $clanguage . "</select>\n";
}

/**
 * ermittelt die Homepage-URL, der aktuellen pragmaMx Installation
 */
function mxSetupSetHomeDir()
{
    // // in Funktion gekapselt, um die Variablen nicht in den globalen scope zu kopieren ;)
    $requri = $_SERVER['REQUEST_URI'];
    if ((empty($requri)) || (substr($requri, -1, 1) == '/')) {
        // wenn leer oder an einen Pfad gebunden, PATH_INFO verwenden
        $requri = getenv('PATH_INFO');
        if (empty($requri)) { // auch leer, SCRIPT_NAME verwenden
            $requri = $_SERVER['SCRIPT_NAME'];
        }
    }
    if (empty($requri)) { // REQUEST_URI kann auf manchen Servern nicht verfgbar sein
        if (isset($_POST['name'])) {
            $_GET['name'] = $_POST['name'];
        }
        if (count($_GET)) {
            foreach ($_GET as $key => $value) {
                $parts[$key] = $key . "=" . $value;
            }
        }
        $requri = (isset($parts)) ? $_SERVER['PHP_SELF'] . "?" . implode("&amp;", $parts) : $_SERVER['PHP_SELF'];
        $_SERVER["REQUEST_URI"] = $requri;
    }
    $requri = preg_replace('/[#\?].*/', '', $requri);
    $requri = dirname(dirname($requri));
    if (preg_match('!^[/\\\]*$!', $requri)) {
        $requri = '';
    }
    $proto = (isset($_SERVER['HTTPS']))? 'https://' : 'http://';
    $server = $_SERVER['HTTP_HOST'];
    $mxroot = preg_replace('#[/]$#', '', $requri);

    if (!defined('PMX_HOME_URL')) define('PMX_HOME_URL', $proto . $server . $mxroot);
}

/**
 * neuen Prefix berprfen
 */
function setupCheckNewPrefixes($new_prefix, $new_user_prefix, $connected)
{
    if (empty($new_prefix)) {
        return(array('critical', _PRERR12));
    }
    if (strtolower($new_prefix) == 'nuke' || strtolower($new_prefix) == 'mx') {
        return(array('check', _PRERR13));
    }
    // [a-zA-Z_\x7f-\xff][a-zA-Z0-9_\x7f-\xff]*
    if (preg_match("#[^a-z0-9_]#", $new_prefix)) {
        return(array('critical', _PRERR14));
    }
    if (preg_match("#^[0-9]#", $new_prefix)) {
        return(array('critical', _PRERR15));
    }
    if (strlen($new_prefix) > PREFIX_MAXLENGTH) {
        return(array('check', _PRERR16));
    }
    if ($connected) {
        $err_new_prefix = intval(mysql_num_rows(mysql_query("SHOW TABLES LIKE '" . $new_user_prefix . "_users';")));
        $err_new_prefix += intval(mysql_num_rows(mysql_query("SHOW TABLES LIKE '" . $new_prefix . "%';"))) - $err_new_prefix;
        if ($err_new_prefix) {
            return(array('critical', sprintf(_PRERR17, $err_new_prefix)));
        }
    }
    // neuen User-Prefix berprfen
    if (empty($new_user_prefix)) {
        return(array('critical', _PRERR18));
    }
    if (preg_match("#[^a-zA-Z0-9_]#", $new_user_prefix)) {
        return(array('critical', _PRERR19));
    }
    if (preg_match("#^[0-9]#", $new_user_prefix)) {
        return(array('critical', _PRERR20));
    }
    if (strlen($new_user_prefix) > PREFIX_MAXLENGTH) {
        return(array('check', _PRERR21));
    }
    if ($connected) {
        $err_new_prefix = intval(mysql_num_rows(mysql_query("SHOW TABLES LIKE '" . $new_user_prefix . "_users';")));
        if ($err_new_prefix) {
            return(array('check', _PRERR22));
        }
    }
    return(array('ok', ''));
}

/**
 */
function setupDeleteFiles()
{
    include(FILE_DELETE_FILES);
    $err = array();
    foreach($delfiles as $delfile) {
        $delfile = PATH_MX_BASE . '/' . $delfile;
        $errcheck = setupKillFile($delfile);
        if ($errcheck) {
            $err[] = $delfile;
        }
    }
    foreach($deldirs as $deldir) {
        $deldir = PATH_MX_BASE . '/' . $deldir;
        if (@file_exists($deldir) && !is_file($deldir) && !is_link($deldir)) {
            setupDeleteFolders($deldir, true);
        }
        if (@file_exists($deldir)) {
            $err[] = $deldir;
        }
    }
    return $err;
}

/**
 * be careful with this.. you could remove your entire site if its pointed to root :)
 */
// ggarciaa at gmail dot com (04-July-2007 01:57)
// I needed to empty a directory, but keeping it
// so I slightly modified the contribution from
// stefano at takys dot it (28-Dec-2005 11:57)
// A short but powerfull recursive function
// that works also if the dirs contain hidden files
// $dir = the target directory
// $DeleteMe = if true delete also $dir, if false leave it alone
function setupDeleteFolders($dir, $DeleteMe = false)
{
    $dir = trim($dir, '\\/');
    if (!$dh = @opendir($dir)) {
        return;
    } while (false !== ($obj = readdir($dh))) {
        if ($obj == '.' || $obj == '..') {
            continue;
        }
        if (!@unlink($dir . '/' . $obj)) {
            setupDeleteFolders($dir . '/' . $obj, true);
        }
    }
    if ($DeleteMe) {
        closedir($dh);
        @rmdir($dir);
    }
}

/**
 * versucht eine Datei zu loeschen.
 * wenn nicht moeglich, wird zumindest versucht den Inhalt der Datei zu entfernen
 */
function setupKillFile($delfile)
{
    $err = array();
    $xdelfile = realpath($delfile);
    if ($xdelfile && is_file($xdelfile)) {
        @chmod($xdelfile, octdec(CHMODUNLOCK));
        @unlink($xdelfile);
    }
    if ($xdelfile && is_file($xdelfile)) {
        // zumindest versuchen zu leeren
        @file_put_contents($xdelfile, '');
        $err[] = $delfile;
    }
    return $err;
}

/**
 */
function hiddenrequest($nextop = '')
{
    // static $isop;
    // if (!$isop) {
    // $_REQUEST['opcount'] = (empty($_REQUEST['opcount'])) ? 2 : $_REQUEST['opcount']+1;
    // }
    // $isop = TRUE;
    $output = '';
    if ($_REQUEST["op"] != 'start' && $_REQUEST["op"] != 'select') {
        $output .= "<input type=\"hidden\" name=\"setupoption\" value=\"" . ((isset($_REQUEST['setupoption'])) ? $_REQUEST['setupoption'] : '') . "\" />\n";
    }
    $output .= "<input type=\"hidden\" name=\"mxsetupid\" value=\"" . SETUP_ID . "\" />\n";
    $output .= "<input type=\"hidden\" name=\"op\" value=\"" . ((empty($nextop)) ? '' : $nextop) . "\" />\n";
    $output .= "<input type=\"hidden\" name=\"slang\" value=\"" . ((isset($_REQUEST['slang'])) ? $_REQUEST['slang'] : SETUP_DEFAULTLANG) . "\" />\n";
    $output .= "<input type=\"hidden\" name=\"lastop\" value=\"" . ((isset($_REQUEST['op'])) ? $_REQUEST['op'] : 'start') . "\" />\n";
    // $output .= "<input type=\"hidden\" name=\"opcount\" value=\"".$_REQUEST['opcount']."\" />\n";
    // $output .= "<input type=\"hidden\" name=\"module\" value=\"".((isset($_REQUEST['module'])) ? $_REQUEST['module'] : '')."\" />\n";
    // $output .= $_REQUEST['opcount'];
    if (function_exists('additionalhiddenrequest')) {
        $output .= additionalhiddenrequest($nextop);
    }
    return $output;
}

/**
 * zeigt den Link zum loeschen der Setupdatei an
 */
function printdeleter($textbefore = '')
{
    return '<br /><br />' . $textbefore . '<div>
    	<label for="delete_self" class="printdeleter"><input type="checkbox" id="delete_self" onclick="doTheDelete();" />&nbsp;' . _DELETESETUPDIR . '</label>
	    <script type="text/javascript"><!-- // --><![CDATA[
  	      function doTheDelete()
    	    {
      	      var theCheck = document.getElementById ? document.getElementById("delete_self") : document.all.delete_self;
        	    var tempImage = new Image();

          	  tempImage.src = "' . $_SERVER['PHP_SELF'] . '?op=delsetupdir&ts=" + (new Date().getTime());
           		tempImage.width = 0;
            	theCheck.disabled = true;
        	}
        	// ]]>
    	</script>
        </div>';
}

/**
 */
function createadminform()
{
    $output = '
    	<fieldset>
    	<legend>' . _ADMIN_ACCOUNT . '</legend>
    	<div class="info"><p><strong>' . _NOADMINYET . '</strong></p><p>' . _CREATEUSERDATA . '</p></div>
    		<ol>
    			<li>
    				<label for="first_name">' . _NICKNAME . ':</label>
    				<input type="text" id="first_name" name="first_name" size="40" maxlength="25" value="' . ((isset($_REQUEST['first_name']))?$_REQUEST['first_name']:'') . '" />  <font class="tiny">' . _REQUIRED . '</font>
    			</li>
    			<li>
    				<label for="first_pwd">' . _PASSWORD . ':</label>
    				<input type="text" id="first_pwd" name="first_pwd" size="40" maxlength="20" value="" />  <font class="tiny">' . _REQUIRED . '</font>
    			</li>
    			<li>
    				<label for="first_email">' . _EMAIL . ':</label>
    				<input type="text" id="first_email" name="first_email" size="40" maxlength="255" value="' . ((isset($_REQUEST['first_email']))?$_REQUEST['first_email']:$_REQUEST['adminmail']) . '" />  <font class="tiny">' . _REQUIRED . '</font>
    			</li>
    			<li>
    				<label for="first_url">' . _HOMEPAGE . ':</label>
    				<input type="text" id="first_url" name="first_url" size="40" maxlength="255" value="' . ((isset($_REQUEST['first_url']))?$_REQUEST['first_url']:PMX_HOME_URL) . '" />
    			</li>
    		</ol>
    	<!-- <p>' . _CREATEUSERDATA . '  <input type="radio" name="first_createuser" value="1"' . ((empty($_REQUEST['first_createuser']))?'':' checked') . '>' . _YES . '&nbsp;&nbsp;<input type="radio" name="first_createuser" value="0"' . ((empty($_REQUEST['first_createuser']))?' checked':'') . '>' . _NO . '</p> -->
    	</fieldset>';
    return $output;
}

function additionalhiddenrequest($nextop = '')
{
    // print $nextop;
    $set = setupFormDefaults();
    $output = "\n";
    if ($_REQUEST['op'] != 'setup' && ($_REQUEST['op'] != 'checkdb' || $nextop == 'createdb' || $nextop == 'viewsettings')) {
        // print '<h4>VIEW 1 '.$nextop.'</h4>';
        // $output .= "<input type=\"hidden\" name=\"dbtype\" value=\"".((isset($_REQUEST['dbtype']))   ? $_REQUEST['dbtype']  : $set['dbtype'])."\" />\n";
        $output .= "<input type=\"hidden\" name=\"dbhost\" value=\"" . ((isset($_REQUEST['dbhost'])) ? $_REQUEST['dbhost'] : $set['dbhost']) . "\" />\n";
        $output .= "<input type=\"hidden\" name=\"dbuname\" value=\"" . ((isset($_REQUEST['dbuname'])) ? $_REQUEST['dbuname'] : $set['dbuname']) . "\" />\n";
        $output .= "<input type=\"hidden\" name=\"dbpass\" value=\"" . ((isset($_REQUEST['dbpass'])) ? $_REQUEST['dbpass'] : $set['dbpass']) . "\" />\n";
        $output .= "<input type=\"hidden\" name=\"dbname\" value=\"" . ((isset($_REQUEST['dbname'])) ? $_REQUEST['dbname'] : $set['dbname']) . "\" />\n";
    }
    if ($nextop != 'viewsettings') {
        // print '<h4>VIEW 2 '.$nextop.'</h4>';
        $output .= "<input type=\"hidden\" name=\"prefix\" value=\"" . ((isset($_REQUEST['prefix'])) ? $_REQUEST['prefix'] : $set['prefix']) . "\" />\n";
        $output .= "<input type=\"hidden\" name=\"user_prefix\" value=\"" . ((isset($_REQUEST['user_prefix'])) ? $_REQUEST['user_prefix'] : $set['user_prefix']) . "\" />\n";
        $output .= "<input type=\"hidden\" name=\"sitename\" value=\"" . ((isset($_REQUEST['sitename'])) ? $_REQUEST['sitename'] : $set['sitename']) . "\" />\n";
        $output .= "<input type=\"hidden\" name=\"startdate\" value=\"" . ((isset($_REQUEST['startdate'])) ? $_REQUEST['startdate'] : $set['startdate']) . "\" />\n";
        $output .= "<input type=\"hidden\" name=\"adminmail\" value=\"" . ((isset($_REQUEST['adminmail'])) ? $_REQUEST['adminmail'] : $set['adminmail']) . "\" />\n";
        $output .= "<input type=\"hidden\" name=\"vkpIntranet\" value=\"" . ((isset($_REQUEST['vkpIntranet'])) ? $_REQUEST['vkpIntranet'] : $set['vkpIntranet']) . "\" />\n";
        $output .= "<input type=\"hidden\" name=\"language\" value=\"" . ((isset($_REQUEST['language'])) ? $_REQUEST['language'] : $set['language']) . "\" />\n";
    }
    $output .= "\n";
    return $output;
}

function dbsettings($set)
{
    return '
    	<fieldset>
			<legend>' . _SERVER . '</legend>
			<p class="info">' . _DBSETTINGS . '</p>
			<ol>
				<li>
					<label for="dbhost">' . _DBSERVER . ':</label>
					<input id="dbhost" name="dbhost" class="text" type="text" value="' . $set['dbhost'] . '" size="40" />
				</li>
				<li>
					<label for="dbname">' . _DBNAME . ':</label>
					<input id="dbname" name="dbname" class="text" type="text" value="' . $set['dbname'] . '" size="40" />
				</li>
				<li>
					<label for="dbuname">' . _DBUSERNAME . ':</label>
					<input id="dbuname" name="dbuname" class="text" type="text" value="' . $set['dbuname'] . '" size="40" />
				</li>
				<li>
					<label for="dbpass">' . _DBPASS . ':</label>
					<input id="dbpass" name="dbpass" class="text" type="password" value="' . $set['dbpass'] . '" size="40" />
				</li>
			</ol>
		</fieldset>';
}

function pushsettings($section, $settings_array, $replace = false)
{
    global $prefix;
    // // sicherstellen, dass die Usertabelle bereits aktualisiert ist
    // include_once(PATH_SYSTABLES . '/_sys_config.php');
    $oldsql = version_compare(MX_SQL_VERSION, '3.23.55', '<');
    $current = array();
    $sql = array();

    $qry = " SELECT `key`, `value` FROM `{$prefix}_sys_config` WHERE `section`='" . $section . "'";
    $result = mysql_query($qry);
    while (list($key, $value) = mysql_fetch_row($result)) {
        if ($replace) {
            $current[$key] = $value;
        } else {
            unset($settings_array[$key]);
        }
    }
    // mxDebugFuncVars($current);
    foreach ($settings_array as $key => $value) {
        if (!is_scalar($value)) {
            $value = serialize($value);
            $isserial = 1;
        } else {
            $isserial = 0;
        }
        if (isset($current[$key])) {
            // aktualisieren
            $sql[] = "UPDATE `${prefix}_sys_config` SET `value`='" . mysql_real_escape_string($value) . "', `serialized`='" . $isserial . "' WHERE `section`='" . mysql_real_escape_string($section) . "' AND `key`='" . mysql_real_escape_string($key) . "'";
        } else {
            // einfuegen
            $part = "('" . mysql_real_escape_string($section) . "', '" . mysql_real_escape_string($key) . "', '" . mysql_real_escape_string($value) . "', '" . $isserial . "')";
            if ($oldsql) {
                $sql[] = "INSERT INTO `${prefix}_sys_config` (`section`, `key`, `value`, `serialized`) VALUES " . $part . "";
            } else {
                $parts[] = $part;
            }
        }
    }
    if (isset($parts)) {
        $part = implode(', ', $parts);
        $sql[] = "INSERT INTO `${prefix}_sys_config` (`section`, `key`, `value`, `serialized`) VALUES " . $part . "";
    }
    return $sql;
}

/*
// ////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Funktionen, die normalerweise im System vorhanden sind, aber genauso auch im Setup verwendet werden mssen ///
// ////////////////////////////////////////////////////////////////////////////////////////////////////////////////
 */

/**
 */
if (!function_exists('mxDemoSetCookie')) {
    function mxDemoSetCookie()
    {
        return true;
    }
}

/**
 */
if (!function_exists('mxGetModServiceContent')) {
    function mxGetModServiceContent($type)
    {
        $modservicecontent = '';
        if (is_file('FILE_CONFIG_ROOT')) {
            include('FILE_CONFIG_ROOT');
        }
        return $modservicecontent;
    }
}

/**
 */
if (!function_exists('mxDemoMode')) {
    function mxDemoMode()
    {
        return false;
    }
}

/**
 */
if (!function_exists('mxStripSlashes')) {
    function mxStripSlashes($text)
    {
        return stripslashes($text);
    }
}

/**
 */
if (!function_exists('mxGetAdminSession')) {
    function mxGetAdminSession()
    {
        $data['aid'] = '';
        $data['pwd'] = '';
        $data['admlanguage'] = '';
        return $data;
    }
}

/**
 * Local function to provide list of all possible HTML tags
 */
if (!function_exists('settingsGetHTMLTags')) {
    function settingsGetHTMLTags()
    {
        // Possible allowed HTML tags
        $allowed = array('!--',
            'a',
            'abbr',
            'acronym',
            'address',
            'applet',
            'area',
            'b',
            'base',
            'basefont',
            'bdo',
            'big',
            'blockquote',
            'br',
            'br /',
            'button',
            'caption',
            'center',
            'cite',
            'code',
            'col',
            'colgroup',
            'del',
            'dfn',
            'dir',
            'div',
            'dl',
            'dd',
            'dt',
            'em',
            'embed',
            'fieldset',
            'font',
            'form',
            'h1',
            'h2',
            'h3',
            'h4',
            'h5',
            'h6',
            'hr',
            'i',
            'iframe',
            'img',
            'input',
            'ins',
            'kbd',
            'label',
            'legend',
            'li',
            'map',
            'marquee',
            'menu',
            'nobr',
            'object',
            'ol',
            'optgroup',
            'option',
            'p',
            'param',
            'pre',
            'q',
            's',
            'samp',
            'script',
            'select',
            'small',
            'span',
            'strike',
            'strong',
            'sub',
            'sup',
            'table',
            'tbody',
            'td',
            'textarea',
            'tfoot',
            'th',
            'thead',
            'tr',
            'tt',
            'u',
            'ul',
            'var');
        asort($allowed);
        return $allowed;
    }
}

/**
 * kann verwendet werden um Variablen und Arrays in der HTML-Seite auszugeben
 * nur zum debuggen !!
 */
if (!function_exists('mxDebugFuncvars')) {
    function mxDebugFuncvars()
    {
        echo "<pre style=\"font-size: 11px; text-align: left; background: #FCFCFC; color: Black;\">\n";
        $arg_list = func_get_args();
        $numargs = func_num_args();
        for ($i = 0; $i < $numargs; $i++) {
            if (is_array($arg_list[$i])) {
                echo "Argument <strong>$i</strong> : ";
                ob_start();
                // var_dump($arg_list[$i]);
                print_r($arg_list[$i]);
                $out = ob_get_clean();
                echo wordwrap(htmlentities($out), 200);
            } else {
                echo "Argument <strong>$i</strong> : " . wordwrap(htmlentities($arg_list[$i]), 200) . "\n";
            }
        }
        echo "</pre>";
    }
}

/* ///////// PHP-Funktionen //////////////////////// */
/**
 * die entsprechende php-Funktion ist erst ab php 4.3.0 verfuegbar
 */
if (!function_exists("file_get_contents")) {
    function file_get_contents($filename, $use_include_path = 0)
    {
        $file = implode('', file($filename, $use_include_path));
        return $file;
    }
}

/**
 * die entsprechende php-Funktion ist erst ab php 4.3.0 verfuegbar
 */
if (!function_exists("ob_get_clean")) {
    function ob_get_clean()
    {
        $ob_contents = ob_get_contents();
        ob_end_clean();
        return $ob_contents;
    }
}

/**
 * die entsprechende php-Funktion ist erst ab php 5 verfuegbar
 * http://www.php.net/manual/de/function.file-put-contents.php
 * comment from: me at briandichiara dot com, 04-Oct-2007 12:20
 */
if (!function_exists("file_put_contents")) {
    @define('FILE_APPEND', 1);
    function file_put_contents($n, $d, $flag = false)
    {
        $mode = ($flag == FILE_APPEND || strtoupper($flag) == 'FILE_APPEND') ? 'a' : 'w';
        $f = @fopen($n, $mode);
        if ($f === false) {
            return 0;
        } else {
            if (is_array($d)) $d = implode($d);
            $bytes_written = fwrite($f, $d);
            fclose($f);
            return $bytes_written;
        }
    }
}

?>