<?php
/**
 * This file is part of 
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.12.2.15 $
 * $Author: tora60 $
 * $Date: 2008/01/29 20:48:36 $
 */

defined('mxMainFileLoaded') or die('access denied');

/**
 * Welches soll die Hauptsprache sein?
 * Dieser Wert wird benoetigt, wenn mehr Sprachen im System Setup existieren
 * als das eigentliche Setup tatschlich besitzt
 */
define("SETUP_DEFAULTLANG", "german");

define("MX_SETUP_VERSION", "pragmaMx 0.1.10");
define("MX_SETUP_VERSION_NUM", "0.1.10");
define("MX_SETUP_VERSION_SUB", "new-setup");
define("MX_SETUP_MIN_PHPVERSION", "4.2");
// only for phpNuke modules compatibility!
define("MX_NUKE_VERSION", "5.6");
// Gruppeneigenschaften, aus mainfile.php bernehmen !!
define('SYS_MAINGROUP_USER', -100);
define('SYS_MAINGROUP_ADMIN', -110);
define('SYS_MAINGROUP_ANONYM', -120);
define('SYS_GROUP_ID_ANONYMOUS' , -1); ///  Anonyme       , nicht angemeldete Benutzer
define('SYS_GROUP_ID_USER' , 0); ///  Standarduser  , Standardlevel fr alle angemeldeten User
define('SYS_GROUP_ID_SUPERADMIN', 1); ///  Administrator , Administratoren mit Vollzugriff
define('SYS_GROUP_ID_ADMIN' , 2); ///  Manager       , Administratoren mit beschrnktem Zugriff
define('SYS_GROUP_ID_MODERATOR' , 3); ///  Moderator     , Moderatoren

/* Sprachauswahl */
define('_SELECT_LANG', '
Bitte w&auml;hlen Sie eine Sprache<br />
&nbsp;&nbsp;&nbsp;Please select a language<br />
&nbsp;&nbsp;&nbsp;&nbsp;Veuillez s&eacute;lectionner votre langue<br />
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;L&uuml;tfen bir lisan se&#231;iniz
');

/**
 * Setup Optionen zur Auswahl
 */
// Neuinstallation
$opt[1]['type'] = 'system';
$opt[1]['version'] = 'new';
$opt[1]['name'] = '_SETUPOPTION_NEW';
$opt[1]['description'] = '_SETUPOPTION_NEW_DESC';
// Update
$opt[2]['type'] = 'system';
$opt[2]['version'] = 'update';
$opt[2]['name'] = '_SETUPOPTION_UPDATE';
$opt[2]['description'] = '_SETUPOPTION_UPDATE_DESC';
// Pfade zur eigentlichen Mx Installation, ausgehend vom setup-Ordner
define('PATH_MX_BASE', '..');
// define('PATH_MX_INCLUDES', PATH_MX_BASE . '/includes');
define('PATH_MX_MODULES', PATH_MX_BASE . '/modules');
define('PATH_MX_BLOCKS', PATH_MX_BASE . '/blocks');
define('PATH_MX_LANGUAGE', PATH_MX_BASE . '/language');
define('PATH_MX_SPAW', PATH_MX_BASE . '/spaw');
// Pfad fuer Logfiles
if (file_exists(PATH_MX_BASE . '/dynadata/logfiles') && is_writable(PATH_MX_BASE . '/dynadata/logfiles')) {
    define('PATH_LOGFILES', PATH_MX_BASE . '/dynadata/logfiles');
} else {
    define('PATH_LOGFILES', dirname(__FILE__) . '/logs');
}
// Pfad fuer Backup's
if (file_exists(PATH_MX_BASE . '/dynadata/backup') && is_writable(PATH_MX_BASE . '/dynadata/backup')) {
    define('PATH_BACKUP', PATH_MX_BASE . '/dynadata/backup');
} else {
    define('PATH_BACKUP', PATH_LOGFILES);
}
// Pfad fuer Setup Includes
define('PATH_SETUP_INCLUDES', dirname(__FILE__) . '/includes');
// html-template fr das setup
define("FILE_SETUP_TEMPLATE", "html/index.html");
// die bestehende config.php im ROOT
define('FILE_CONFIG_ROOT', PATH_MX_BASE . '/config.php');
// config.first.php entspricht der originalen config.php mit kleinen nderungen
// weitere Hinweise in dieser Datei !
define('FILE_CONFIG_BASE', PATH_SETUP_INCLUDES . '/config.first.php');
// der Code von mx_configstring.php wird direkt, ohne nderungen
// aus /admin/modules/settings.php kopiert !!
define('FILE_CONFIG_NEWCONTENT', PATH_SETUP_INCLUDES . '/mx_configstring.php');
// Array mit unnoetig gewordenen Dateien
define('FILE_DELETE_FILES', PATH_SETUP_INCLUDES . '/delfiles.php');
// Array mit einzufgenden Modulen
define('FILE_ADD_MODULES', PATH_SETUP_INCLUDES . '/addmodules.php');
// Standard chmod
// -- ACHTUNG, das muss fuer die Funktion chmod() mit octdec() noch umgewandelt werden
define("CHMODLOCK" , "0444");
define("CHMODNORMAL", "0644");
define("CHMODUNLOCK", "0666");
define("CHMODFULLOCK", "0400");
define("CHMODFULLUNOCK", "0777");
// Setup-ID: die Variable mxsetupid wird in allen Formularen und Links bergeben
if (empty($_REQUEST['mxsetupid'])) {
    define("SETUP_ID", date("Ymdhis"));
} else {
    define("SETUP_ID", $_REQUEST['mxsetupid']);
}
// Logfiles
define('FILE_LOG_ERR', PATH_LOGFILES . '/setup_' . SETUP_ID . '.errlog.txt');
define('FILE_LOG_OK', PATH_LOGFILES . '/setup_' . SETUP_ID . '.oklog.txt');
// Ordner mit den Systemtabellen-Definitionen
define('PATH_SYSTABLES', 'systabledefs');
// Tabellenstruktur-Tabelle
define('TABLE_STRUCTURE', '_mx_installed_tables');
// Prefix fr umbenannte Tabellen
define('RENAME_PREFIX', 'zz' . SETUP_ID . '_');
// Ordnername fr umbenanntes Setup-Dir
define('SETUP_RENAME', '_' . SETUP_ID . '.' . md5 (uniqid (rand())));
// die globale Aufraeumdatei mit zusaetzlichen sql-Befehlen
define('ADD_QUERIESFILE', PATH_SYSTABLES . '/update.php');
// versch. Links zu pragmaMx
define('_MXDOKUSITE' , 'http://docs.pragmamx.org/');
define('_MXSUPPORTSITE' , 'http://www.pragmamx.org/Forum.html');
define('_MXKNOWPROBSITE', 'http://www.pragmamx.org/Forum-board-103.html');
define('_MXCONVERTINFOSITE', 'http://www.pragmamx.org/Content-pid-65.html');
// Backupoptionen
define('FILE_BACKUP', realpath(PATH_BACKUP) . DIRECTORY_SEPARATOR . 'mxInstallBackup_' . SETUP_ID . '.sql');
$o[] = '--add-drop-table'; // Ein drop table vor jedem create-Statement hinzufgen.
$o[] = '--add-locks'; // Fhrt LOCK TABLES vor und UNLOCK TABLE nach jedem Tabellen-Dump durch (um schnelleres Einfgen in MySQL zu erreichen).
$o[] = '-a'; // Alle MySQL-spezifischen Optionen fr create benutzen.
$o[] = '-c'; // Vollstndige insert-Statements benutzen (mit Spaltennamen).
$o[] = '-f'; // Fortfahren, selbst wenn beim Dump einer Tabelle ein SQL-Fehler auftritt.
$o[] = '-l'; // Alle Tabellen sperren, bevor mit dem Dump begonnen wird. Die Tabellen werden mit READ LOCAL gesperrt, um gleichzeitiges Einfgen zu erlauben (bei MyISAM-Tabellen).
$o[] = '-C'; // Alle Informationen zwischen Client und Server komprimieren, wenn bei Kompression untersttzen.
// $o[] = '-n';                    // 'CREATE DATABASE /*!32312 IF NOT EXISTS*/ datenbank;' wird nicht in die Ausgabe gschrieben. Diese Zeile wird ansonsten hinzugefgt, wenn --databases oder --all-databases angegeben wurde.
define('BACKUP_DUMP_OPTIONS', ' ' . implode(' ', $o) . ' ');
unset($o);

if (!defined("SYS_BLOCKPOS_CENTER")) define("SYS_BLOCKPOS_CENTER", "c");
if (!defined("SYS_BLOCKPOS_LEFT")) define("SYS_BLOCKPOS_LEFT", "l");
if (!defined("SYS_BLOCKPOS_RIGHT")) define("SYS_BLOCKPOS_RIGHT", "r");
if (!defined("SYS_BLOCKPOS_DOWN")) define("SYS_BLOCKPOS_DOWN", "d");
if (!defined("SYS_BLOCKPOS_TOP")) define("SYS_BLOCKPOS_TOP", "t");
// max. Laenge des Tabellenprefix
define('PREFIX_MAXLENGTH', '20');

/**
 * Standardwerte fr Formulare, wenn irgendwelche Einstellungen leer oder nicht gesetzt sind
 */
function setupFormDefaults()
{
    if (@file_exists(FILE_CONFIG_ROOT)) {
        include(FILE_CONFIG_ROOT);
    }
    // Datenbankzugangsdaten
    $def['dbhost'] = (!empty($dbhost)) ? $dbhost : "localhost";
    $def['dbname'] = (!empty($dbname)) ? $dbname : "";
    $def['dbuname'] = (isset($dbuname)) ? $dbuname : "";
    $def['dbpass'] = (isset($dbpass)) ? $dbpass : "";
    // Tabellen-Prefixe
    $xpre = strtolower(substr(md5(SETUP_ID), 3, 6));
    $def['prefix'] = (!empty($prefix)) ? $prefix : 'mx' . $xpre;
    $def['user_prefix'] = (!empty($user_prefix)) ? $user_prefix : 'mx' . $xpre;
    // sonstige Einstellungen
    $def['sitename'] = (!empty($sitename)) ? $sitename : MX_SETUP_VERSION . " from pragmaMx.org";
    $def['startdate'] = (!empty($startdate)) ? $startdate : strftime(_DATESTRING, time());
    $def['adminmail'] = (!empty($adminmail)) ? $adminmail : $_SERVER['SERVER_ADMIN'];
    $def['language'] = (isset($language)) ? $language : SETUP_DEFAULTLANG;
    if (isset($vkpIntranet)) {
        $def['vkpIntranet'] = (empty($vkpIntranet)) ? 0 : 1;
    } else {
        // Intranet versuchen voreinzustellen, localhost oder kein Punkt im Servername >> ein
        $def['vkpIntranet'] = (strtolower($_SERVER['HTTP_HOST']) == 'localhost' || (strpos($_SERVER['HTTP_HOST'], '.') == false)) ? 1 : 0;
    }
    // mxDebugFuncVars($def);
    return $def;
}

/**
 * unbedingt noetige System-Tabellen die auf vorhandensein kontrolliert werden mssen
 * kann gleichzeitig als Array zur berprfung der entsprechenden Setup-Dateien verwendet werden
 */
function setupRequiredTables($prefix, $user_prefix)
{
    $table[$prefix . '_authors'] = '_authors';
    $table[$prefix . '_blocks'] = '_blocks';
    $table[$prefix . '_captcher'] = '_captcher';
    $table[$prefix . '_groups_access'] = '_groups_access';
    $table[$prefix . '_groups_blocks'] = '_groups_blocks';
    $table[$prefix . '_groups_modules'] = '_groups_modules';
    $table[$prefix . '_main'] = '_main';
    $table[$prefix . '_menu'] = '_menu';
    $table[$prefix . '_menu_var'] = '_menu_var';
    $table[$prefix . '_modules'] = '_modules';
    $table[$prefix . '_sys_session'] = '_sys_session';
    $table[$prefix . '_visitors'] = '_visitors';
    $table[$user_prefix . '_users'] = '_users';
    $table[$user_prefix . '_users_temptable'] = '_users_temptable';
    return $table;
}

/**
 * veraltete Setup-Dateien die als Karteileichen nicht mehr verwendet
 * werden duerfen und deswegen ignoriert werden, falls noch da...
 */
function setupIgnoreTabledefinitions()
{
    return array();
}

/**
 * Feststellen ob ein bestimmter Block mit dem Paket mitgeliefert wurde
 * Also alle Bloecke im Zipfile
 */
function is_vkp_block($blockfile)
{
    $blocks = array(

        'block-AdminAlert.php',
        'block-AdminNews.php',
        'block-Banner.php',
        'block-Big_Story_of_Today.php',
        'block-Birthday_2.php',
        'block-Birthday.php',
        'block-Calendar_centerlist_scroll.php',
        'block-Calendar_centerlist.php',
        'block-Calendar_combi.php',
        'block-Calendar_list.php',
        'block-Calendar_month.php',
        'block-Categories.php',
        'block-Content.php',
        'block-eBoard_Center.php',
        'block-Encyclopedia.php',
        'block-Ephemerids.php',
        'block-FAQs.php',
        'block-Gallery-center-Last_pictures_thumb.php',
        'block-Gallery-center-Random_pictures.php',
        'block-Gallery-center-scroll-Last_pictures_thumb.php',
        'block-Gallery-center-scroll-Last_pictures.php',
        'block-Gallery-center-scroll-Random_pictures.php',
        'block-Gallery-center-scroll-Top_rate_pictures.php',
        'block-Gallery-center-scroll-Top_view_pictures.php',
        'block-Gallery-center-Top_rate_pictures.php',
        'block-Gallery-Last_comments.php',
        'block-Gallery-Last_pictures_thumb.php',
        'block-Gallery-Random_pictures.php',
        'block-Gallery-scroll-Last_comments.php',
        'block-Gallery-scroll-Last_pictures_thumb.php',
        'block-Gallery-scroll-Random_pictures.php',
        'block-Gallery-scroll-Top_rate_pictures.php',
        'block-Gallery-scroll-Top_view_pictures.php',
        'block-Gallery-Top_rate_pictures.php',
        'block-Languages.php',
        'block-Last_5_Articles.php',
        'block-Last_Referers.php',
        'block-Last_Seen.php',
        'block-Letter.php',
        'block-Login.php',
        'block-Menu.php',
        'block-Modules_one.php',
        'block-Modules_three.php',
        'block-Modules_two.php',
        'block-Modules.php',
        'block-mxShoutbox.php',
        'block-mxTabs_center.php',
        'block-Newest_Downloads.php',
        'block-Newest_Links.php',
        'block-News_short-2spalten.php',
        'block-News_short-more-columns.php',
        'block-News_short.php',
        'block-News.php',
        'block-Old_Articles.php',
        'block-Random_Headlines.php',
        'block-Random_Survey.php',
        'block-RandomPic.php',
        'block-Recommend_Us.php',
        'block-Reviews.php',
        'block-Search.php',
        'block-Sections_Articles.php',
        'block-Sections_Lastpost.php',
        'block-smf_Center.php',
        'block-smf_stats.php',
        'block-smf-recentTopics.php',
        'block-smf-whosOnline.php',
        'block-Sommaire.php',
        'block-SponsorenLogin.php',
        'block-Survey.php',
        'block-Themetest.php',
        'block-Top10_Downloads.php',
        'block-Top10_Links.php',
        'block-Total_Hits.php',
        'block-Userblock.php',
        'block-Userpoints.php',
        'block-vkp_News_Lastarticles.php',
        'block-vkp_News_Login.php',
        'block-vkp_News_Options.php',
        'block-vkp_News_Poll.php',
        'block-vkp_News_Rating.php',
        'block-vkp_News_Related.php',
        'block-Who_is_Online.php',
        'block-Who-is-Where.php',
        );
    return (in_array($blockfile, $blocks)) ? true : false;
}

/**
 * Bloecke die nur fr das News-Modul vorhanden sind
 */
function setup_NewsBlocks()
{
    $path = 'modules/News/blocks/';
    // TODO: erst wenn Struktur umgestellt
    // $path = 'blocks/';
    $path = '';
    // Pfad.Dateiname => Blocktitel
    return array($path . 'block-vkp_News_Lastarticles.php' => 'Last Articles',
        $path . 'block-vkp_News_Login.php' => 'Login',
        $path . 'block-vkp_News_Options.php' => 'Options',
        $path . 'block-vkp_News_Poll.php' => 'Survey',
        $path . 'block-vkp_News_Rating.php' => 'Article Rating',
        $path . 'block-vkp_News_Related.php' => 'Related Links'
        );
}

?>
