<?php
/**
 * This file is part of 
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.11 $
 * $Author: tora60 $
 * $Date: 2007/12/26 23:39:18 $
 */

defined('mxMainFileLoaded') or die('access denied');
unset($sqlqry);
// sicherstellen, dass die Usertabelle bereits aktualisiert ist
include_once(dirname(__FILE__) . '/_users.php');
// --------------------------------------------------------
// Tabellenstruktur fuer Tabelle `mx_authors`
if (!isset($tables["${prefix}_authors"])) {
    // TODO: radmingroups bleibt vorerst noch drin, wird mit Einfuehrung der neuen Gruppenverwaltung aber entfernt
    $sqlqry[] = "
CREATE TABLE `${prefix}_authors` (
  `aid` varchar(25) NOT NULL default '',
  `name` varchar(50) NOT NULL default '',
  `url` varchar(255) NOT NULL default '',
  `email` varchar(100) NOT NULL default '',
  `pwd` varchar(32) NOT NULL default '',
  `counter` int(11) NOT NULL default '0',
  `radminarticle` tinyint(1) NOT NULL default '0',
  `radmintopic` tinyint(1) NOT NULL default '0',
  `radminuser` tinyint(1) NOT NULL default '0',
  `radminsurvey` tinyint(1) NOT NULL default '0',
  `radminsection` tinyint(1) NOT NULL default '0',
  `radminlink` tinyint(1) NOT NULL default '0',
  `radminephem` tinyint(1) NOT NULL default '0',
  `radminfaq` tinyint(1) NOT NULL default '0',
  `radmindownload` tinyint(1) NOT NULL default '0',
  `radminreviews` tinyint(1) NOT NULL default '0',
  `radminnewsletter` tinyint(1) NOT NULL default '0',
  `radminforum` tinyint(1) NOT NULL default '0',
  `radmincontent` tinyint(1) NOT NULL default '0',
  `radminency` tinyint(1) NOT NULL default '0',
  `radminsuper` tinyint(1) NOT NULL default '0',
  `radmingroups` tinyint(1) NOT NULL default '0',
  `radmincalendar` tinyint(1) NOT NULL default '0',
  `admlanguage` varchar(30) NOT NULL default '',
  `user_uid` int(11) unsigned default NULL,
  PRIMARY KEY  (`aid`),
  UNIQUE KEY `name` (`name`),
  KEY `user_uid` (`user_uid`),
  KEY `radminarticle` (`radminarticle`),
  KEY `radmintopic` (`radmintopic`),
  KEY `radminuser` (`radminuser`),
  KEY `radminsurvey` (`radminsurvey`),
  KEY `radminsection` (`radminsection`),
  KEY `radminlink` (`radminlink`),
  KEY `radminephem` (`radminephem`),
  KEY `radminfaq` (`radminfaq`),
  KEY `radmindownload` (`radmindownload`),
  KEY `radminreviews` (`radminreviews`),
  KEY `radminnewsletter` (`radminnewsletter`),
  KEY `radminforum` (`radminforum`),
  KEY `radmincontent` (`radmincontent`),
  KEY `radminency` (`radminency`),
  KEY `radminsuper` (`radminsuper`),
  KEY `admlanguage` (`admlanguage`),
  KEY `radmingroups` (`radmingroups`),
  KEY `radmincalendar` (`radmincalendar`)
) TYPE=MyISAM;
";
} else {
    // Felder aktualisieren
    $tf = setupGetTableFields("${prefix}_authors");
    // Felder ergaenzen/loeschen
    // fb war so schlau und hat die admintabelle ab nuke 7.4 kastriert, deshalb alle Felder checken
    if (!isset($tf['radminarticle'])) $sqlqry[] = "ALTER TABLE `${prefix}_authors` ADD radminarticle tinyint(1) NOT NULL DEFAULT '0' AFTER counter;";
    if (!isset($tf['radmintopic'])) $sqlqry[] = "ALTER TABLE `${prefix}_authors` ADD radmintopic tinyint(1) NOT NULL DEFAULT '0' AFTER radminarticle;";
    if (!isset($tf['radminuser'])) $sqlqry[] = "ALTER TABLE `${prefix}_authors` ADD radminuser tinyint(1) NOT NULL DEFAULT '0' AFTER radmintopic;";
    if (!isset($tf['radminsurvey'])) $sqlqry[] = "ALTER TABLE `${prefix}_authors` ADD radminsurvey tinyint(1) NOT NULL DEFAULT '0' AFTER radminuser;";
    if (!isset($tf['radminsection'])) $sqlqry[] = "ALTER TABLE `${prefix}_authors` ADD radminsection tinyint(1) NOT NULL DEFAULT '0' AFTER radminsurvey;";
    if (!isset($tf['radminlink'])) $sqlqry[] = "ALTER TABLE `${prefix}_authors` ADD radminlink tinyint(1) NOT NULL DEFAULT '0' AFTER radminsection;";
    if (!isset($tf['radminephem'])) $sqlqry[] = "ALTER TABLE `${prefix}_authors` ADD radminephem tinyint(1) NOT NULL DEFAULT '0' AFTER radminlink;";
    if (!isset($tf['radminfaq'])) $sqlqry[] = "ALTER TABLE `${prefix}_authors` ADD radminfaq tinyint(1) NOT NULL DEFAULT '0' AFTER radminephem;";
    if (!isset($tf['radmindownload'])) $sqlqry[] = "ALTER TABLE `${prefix}_authors` ADD radmindownload tinyint(1) NOT NULL DEFAULT '0' AFTER radminfaq;";
    if (!isset($tf['radminreviews'])) $sqlqry[] = "ALTER TABLE `${prefix}_authors` ADD radminreviews tinyint(1) NOT NULL DEFAULT '0' AFTER radmindownload;";
    if (!isset($tf['radminnewsletter'])) $sqlqry[] = "ALTER TABLE `${prefix}_authors` ADD radminnewsletter tinyint(1) NOT NULL DEFAULT '0' AFTER radminreviews;";
    if (!isset($tf['radminforum'])) $sqlqry[] = "ALTER TABLE `${prefix}_authors` ADD radminforum tinyint(1) NOT NULL DEFAULT '0' AFTER radminnewsletter";
    if (!isset($tf['radmincontent'])) $sqlqry[] = "ALTER TABLE `${prefix}_authors` ADD radmincontent tinyint(1) NOT NULL DEFAULT '0' AFTER radminforum";
    if (!isset($tf['radminency'])) $sqlqry[] = "ALTER TABLE `${prefix}_authors` ADD radminency tinyint(1) NOT NULL DEFAULT '0' AFTER radmincontent";
    if (!isset($tf['radminsuper'])) $sqlqry[] = "ALTER TABLE `${prefix}_authors` ADD radminsuper tinyint(1) NOT NULL DEFAULT '0' AFTER radminency";
    if (!isset($tf['radmincalendar'])) $sqlqry[] = "ALTER TABLE `${prefix}_authors` ADD radmincalendar tinyint(1) NOT NULL DEFAULT '0' AFTER radminsuper";
    if (!isset($tf['user_uid'])) $sqlqry[] = "ALTER TABLE `${prefix}_authors` ADD user_uid INT( 11 ) UNSIGNED;";
    // unnoetig da nie in nuke vorhanden
    if (isset($tf['radminfilem'])) $sqlqry[] = "ALTER TABLE `${prefix}_authors` DROP radminfilem;";
    // TODO: bleibt vorerst noch drin, wird mit Einfuehrung der neuen Gruppenverwaltung aber entfernt
    // if (isset($tf['radmingroups']))      $sqlqry[] ="ALTER TABLE `${prefix}_authors` DROP radmingroups;";
    if (!isset($tf['radmingroups'])) $sqlqry[] = "ALTER TABLE `${prefix}_authors` ADD radmingroups tinyint(1) NOT NULL DEFAULT '0' AFTER radminsuper";
    // ENDE TODO: bleibt vorerst noch drin, wird mit Einfuehrung der neuen Gruppenverwaltung aber entfernt
    $tf = setupGetTableFields("${prefix}_authors");
    if ($tf['aid']['Default'] === null || $tf['aid']['Type'] != 'varchar(25)' || $tf['name']['Default'] === null || $tf['name']['Type'] != 'varchar(50)' || $tf['url']['Default'] === null || $tf['url']['Type'] != 'varchar(255)' || $tf['email']['Default'] === null || $tf['email']['Type'] != 'varchar(100)' || $tf['pwd']['Type'] != 'varchar(32)'
        ) {
        $sqlqry[] = "ALTER TABLE `${prefix}_authors`
                CHANGE `aid` `aid` varchar(25) NOT NULL default '',
                CHANGE `name` `name` varchar(50) NOT NULL default '',
                CHANGE `url` `url` varchar(255) NOT NULL default '',
                CHANGE `email` `email` varchar(100) NOT NULL default '',
                CHANGE `pwd` `pwd` VARCHAR( 32 ) NOT NULL default ''
                ";
    }
}

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}

if (isset($tables["${prefix}_authors"])) {
    // Kontrolle, ob fuer name der eindeutige Index existiert, bzw. angelegt werden kann
    // dazu alle doppelten name suchen und ggf. den Namen mit der aid ergaenzen
    $qry = "SELECT a1.aid, a1.name, a2.aid AS aid2
            FROM `${prefix}_authors` AS a1 JOIN `${prefix}_authors` AS a2 ON (a1.name = a2.name)
            WHERE a1.aid <> a2.aid
            ORDER BY a1.name ASC, a1.aid ASC
            ";
    $result = mysql_query($qry);
    if ($result) {
        $names = array();
        while ($row = mysql_fetch_assoc($result)) {
            // fuer jeden name, der doppelt vorkommt, ein Array erstellen
            $names[strtolower($row['name'])][$row['aid2']] = $row;
        }
        if (!empty($names)) {
            $aids = array();
            // das Array mit den doppelten name durchlaufen
            foreach($names as $name => $row) {
                // immer den letzten gefundenen Datensatz entfernen, weil der das Original sein soll
                // Angenommen wird immer, dass der aelteste name der korrekte ist, dieser bleibt unveraendert
                array_pop($row);
                // alle aid's der doppelten names in ein Array einlesen
                foreach($row as $values) {
                    $aids[] = $values['aid2'];
                }
            }
            // die gesammelten aid's als Bedingung fuer die Aenderungsabfrage verwenden
            if (!empty($aids)) {
                $sqlqry[] = "UPDATE `${prefix}_authors` SET name=CONCAT(name, ' (', aid, ')') WHERE aid IN('" . implode("','", $aids) . "')";
            }
        }
    }
    // Indexe erstellen/aktualisieren
    $indexes = setupGetTableIndexes("${prefix}_authors");
    if (isset($indexes['aid'])) $sqlqry[] = "ALTER TABLE `${prefix}_authors` DROP INDEX `aid` ";
    if (isset($indexes['PRIMARY']) && $indexes['PRIMARY']['Column_name'] != 'aid') {
        $sqlqry[] = "ALTER TABLE `${prefix}_authors` DROP PRIMARY KEY, ADD PRIMARY KEY ( `aid` );";
    } else if (!isset($indexes['PRIMARY'])) {
        $sqlqry[] = "ALTER TABLE `${prefix}_authors` ADD PRIMARY KEY ( `aid` );";
    }
    // eindeutigen Index auch fuer Name, weil sonst aktualisierung im Adminmenue fehlschlaegt
    if (!isset($indexes['name'])) {
        $sqlqry[] = "ALTER TABLE `${prefix}_authors` ADD UNIQUE `name` ( `name` ) ;";
    } else if (isset($indexes['name']) && $indexes['name']['Non_unique'] != '0') {
        $sqlqry[] = "ALTER TABLE `${prefix}_authors` DROP INDEX `name` , ADD UNIQUE `name` ( `name` ) ;";
    }

    if (!isset($indexes['user_uid'])) $sqlqry[] = "ALTER TABLE `${prefix}_authors` ADD INDEX `user_uid` ( `user_uid` ) ;";
    if (!isset($indexes['radminarticle'])) $sqlqry[] = "ALTER TABLE `${prefix}_authors` ADD INDEX `radminarticle` ( `radminarticle` );";
    if (!isset($indexes['radmintopic'])) $sqlqry[] = "ALTER TABLE `${prefix}_authors` ADD INDEX `radmintopic` ( `radmintopic` );";
    if (!isset($indexes['radminuser'])) $sqlqry[] = "ALTER TABLE `${prefix}_authors` ADD INDEX `radminuser` ( `radminuser` );";
    if (!isset($indexes['radminsurvey'])) $sqlqry[] = "ALTER TABLE `${prefix}_authors` ADD INDEX `radminsurvey` ( `radminsurvey` );";
    if (!isset($indexes['radminsection'])) $sqlqry[] = "ALTER TABLE `${prefix}_authors` ADD INDEX `radminsection` ( `radminsection` );";
    if (!isset($indexes['radminlink'])) $sqlqry[] = "ALTER TABLE `${prefix}_authors` ADD INDEX `radminlink` ( `radminlink` );";
    if (!isset($indexes['radminephem'])) $sqlqry[] = "ALTER TABLE `${prefix}_authors` ADD INDEX `radminephem` ( `radminephem` );";
    if (!isset($indexes['radminfaq'])) $sqlqry[] = "ALTER TABLE `${prefix}_authors` ADD INDEX `radminfaq` ( `radminfaq` );";
    if (!isset($indexes['radmindownload'])) $sqlqry[] = "ALTER TABLE `${prefix}_authors` ADD INDEX `radmindownload` ( `radmindownload` );";
    if (!isset($indexes['radminreviews'])) $sqlqry[] = "ALTER TABLE `${prefix}_authors` ADD INDEX `radminreviews` ( `radminreviews` );";
    if (!isset($indexes['radminnewsletter'])) $sqlqry[] = "ALTER TABLE `${prefix}_authors` ADD INDEX `radminnewsletter` ( `radminnewsletter` );";
    if (!isset($indexes['radminforum'])) $sqlqry[] = "ALTER TABLE `${prefix}_authors` ADD INDEX `radminforum` ( `radminforum` );";
    if (!isset($indexes['radmincontent'])) $sqlqry[] = "ALTER TABLE `${prefix}_authors` ADD INDEX `radmincontent` ( `radmincontent` );";
    if (!isset($indexes['radminency'])) $sqlqry[] = "ALTER TABLE `${prefix}_authors` ADD INDEX `radminency` ( `radminency` );";
    if (!isset($indexes['radminsuper'])) $sqlqry[] = "ALTER TABLE `${prefix}_authors` ADD INDEX `radminsuper` ( `radminsuper` );";
    if (!isset($indexes['admlanguage'])) $sqlqry[] = "ALTER TABLE `${prefix}_authors` ADD INDEX `admlanguage` ( `admlanguage` );";
    if (!isset($indexes['radmingroups'])) $sqlqry[] = "ALTER TABLE `${prefix}_authors` ADD INDEX `radmingroups` ( `radmingroups` );";
    if (!isset($indexes['radmincalendar'])) $sqlqry[] = "ALTER TABLE `${prefix}_authors` ADD INDEX `radmincalendar` ( `radmincalendar` );";
}

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}
// Autologinfeld in Admintabelle anpassen
$i1 = 0;
if (isset($tables["${prefix}_authors_users"]) && !isset($tf['user_uid'])) {
    // wenn selfAdmin installiert war
    $result = mysql_query("SELECT user_uid, author_aid FROM `${prefix}_authors_users`;");
    while (list($uid, $aid) = mysql_fetch_row($result)) {
        $i1++;
        $sys_sql[] = "UPDATE `${prefix}_authors` set user_uid=$uid where aid='$aid' AND (user_uid Is Null Or user_uid=0);";
    }
} else if (isset($tables["${prefix}_authors"]) && isset($tf) && !isset($tf['user_uid'])) {
    // wenn selfAdmin NICHT installiert war
    $result = mysql_query("SELECT u.uid, a.aid FROM `${prefix}_authors` AS a LEFT JOIN `${user_prefix}_users` AS u ON (a.email = u.email) AND (a.aid = u.uname) WHERE (u.uid Is Not Null) AND (a.user_uid Is Null Or a.user_uid=0);");
    while (list($uid, $aid) = mysql_fetch_row($result)) {
        $i1++;
        $sys_sql[] = "UPDATE `${prefix}_authors` set user_uid=$uid where aid='$aid' AND (user_uid Is Null Or user_uid=0);";
    }
}
// ende Autologinfeld in Admintabelle anpassen
if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}

?>