<?php
/**
 * This file is part of 
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.10.2.5 $
 * $Author: tora60 $
 * $Date: 2008/02/02 10:40:53 $
 *
 * this file based on:
 * php-nuke Web Portal System - http://phpnuke.org/
 * Thatware - http://thatware.org/
 */

defined('mxMainFileLoaded') or die('access denied');

if (!defined('PMX_VERSION')) {
    mxErrorScreen('pragmaMx >= 0.1.10 is required');
}

if (!mxGetAdminPref('radminephem')) {
    mxErrorScreen("Access Denied");
    die();
}

$wysiwyg = 0;
$wysiwyg_ephem = 0;
include_once('spaw/spaw_control.class.php');

/**
 */
/* Ephemerids Functions to have a Historic Ephemerids    */
/**
 */

function Ephemerids()
{
    global $currentlang, $multilingual, $language;
    include ("header.php");
    GraphicAdmin();
    title(_EPHEMADMIN);
    
    OpenTable();
    echo "<fieldset><legend>" . _ADDEPHEM . "</legend>"
     . "<form action=\"admin.php\" method=\"post\">";
    $nday = "1";
    echo _DAY . ": <select name=\"did\">";
    while ($nday <= 31) {
        echo "<option>$nday</option>";
        $nday++;
    }
    echo "</select>";
    $nmonth = "1";
    echo _UMONTH . ": <select name=\"mid\">";
    while ($nmonth <= 12) {
        echo "<option>$nmonth</option>";
        $nmonth++;
    }
    echo "</select>" . _YEAR . ": <input type=\"text\" name=\"yid\" maxlength=\"4\" size=\"5\"><br><br>";
    if ($multilingual == 1) {
        echo "<b>" . _LANGUAGE . ": </b>" . mxLanguageSelect('elanguage', $currentlang, 'language') . "<br><br>";
    } else {
        echo "<input type=\"hidden\" name=\"elanguage\" value=\"\">";
    }
    echo "<b>" . _EPHEMDESC . ":</b><br>";

    if ($GLOBALS['wysiwyg'] && $GLOBALS['wysiwyg_ephem']) {
        $sw = new SPAW_Wysiwyg('content', '', _DOC_LANGUAGE, $GLOBALS['wysiwyg_toolbar'], $GLOBALS['wysiwyg_btnset'], '100%', '250');
        $sw->show();
    } else {
        echo "<textarea name=\"content\" cols=\"60\" rows=\"10\"></textarea>";
    }

    echo "<br><br>"

     . "<input type=\"hidden\" name=\"op\" value=\"Ephemeridsadd\">"
     . "<input type=\"submit\" value=\"" . _OK . "\">"
     . "</form></fieldset>";
    CloseTable();
    echo "<br>";
    OpenTable();
    echo "<fieldset><legend>" . _EPHEMMAINT . "</legend>"
     . "<center><form action=\"admin.php\" method=\"post\">";
    $nday = "1";
    echo _DAY . ": <select name=\"did\">";
    while ($nday <= 31) {
        echo "<option>$nday</option>";
        $nday++;
    }
    echo "</select>";
    $nmonth = "1";
    echo _UMONTH . ": <select name=\"mid\">";
    while ($nmonth <= 12) {
        echo "<option>$nmonth</option>";
        $nmonth++;
    }
    echo "</select>"
     . "<input type=\"hidden\" name=\"op\" value=\"Ephemeridsmaintenance\">"
     . "<input type=\"submit\" value=\"" . _EDIT . "\">"
     . "</form></center></fieldset>";
    CloseTable();
    include ("footer.php");
}

function Ephemeridsadd($did, $mid, $yid, $content, $elanguage)
{
    global $prefix;
    sql_query("insert into " . $prefix . "_ephem values (NULL, '$did', '$mid', '$yid', '$content', '$elanguage')");
    header("Location: admin.php?op=Ephemerids");
}

function Ephemeridsmaintenance($did, $mid)
{
    global $prefix;
    include ("header.php");
    GraphicAdmin();
    title(_EPHEMADMIN);
   
    OpenTable();
    echo "<center><font class=\"option\"><b>" . _EPHEMMAINT . "</b></font></center><br>";
    $result = sql_query("select eid, did, mid, yid, content, elanguage from " . $prefix . "_ephem where did=$did AND mid=$mid");
    while (list($eid, $did, $mid, $yid, $content, $elanguage) = sql_fetch_row($result)) {
        echo "<font class=\"content\"><b>$yid</b> - ($elanguage) - [&nbsp;<a href=\"admin.php?op=Ephemeridsedit&amp;eid=$eid&amp;did=$did&amp;mid=$mid\">" . _EDIT . "</a> | <a href=\"admin.php?op=Ephemeridsdel&amp;eid=$eid&amp;did=$did&amp;mid=$mid\">" . _DELETE . "</a>&nbsp;]<br>"
         . "<font class=\"tiny\">$content<br><br><br>";
    }
    CloseTable();
    include ('footer.php');
}

function Ephemeridsdel($eid, $did, $mid)
{
    global $prefix;
    sql_query("delete from " . $prefix . "_ephem where eid=$eid");
    header("Location: admin.php?op=Ephemeridsmaintenance&did=$did&mid=$mid");
}

function Ephemeridsedit($eid, $did, $mid)
{
    global $prefix, $multilingual;
    include ("header.php");
    GraphicAdmin();
    title(_EPHEMADMIN);
    
    $result = sql_query("select yid, content, elanguage from " . $prefix . "_ephem where eid=$eid");
    list($yid, $content, $elanguage) = sql_fetch_row($result);
    OpenTable();
    echo "<fieldset<legend>" . _EPHEMEDIT . "</legend>"
     . "<form action=\"admin.php\" method=\"post\">"
     . "<b>" . _YEAR . ":</b> <input type=\"text\" name=\"yid\" value=\"$yid\" maxlength=\"4\" size=\"5\"><br><br>";
    if ($multilingual == 1) {
        echo "<b>" . _LANGUAGE . ": </b>" . mxLanguageSelect('elanguage', $elanguage, 'language') . "<br><br>";
    } else {
        echo "<input type=\"hidden\" name=\"elanguage\" value=\"\">";
    }
    echo "<b>" . _EPHEMDESC . ":</b><br>";

    if ($GLOBALS['wysiwyg'] && $GLOBALS['wysiwyg_ephem']) {
        $sw = new SPAW_Wysiwyg('content', $content, _DOC_LANGUAGE, $GLOBALS['wysiwyg_toolbar'], $GLOBALS['wysiwyg_btnset'], '100%', '250');
        $sw->show();
    } else {
        echo "<textarea name=\"content\" cols=\"60\" rows=\"10\">$content</textarea>";
    }

    echo "<br><br>"

     . "<input type=\"hidden\" name=\"did\" value=\"$did\">"
     . "<input type=\"hidden\" name=\"mid\" value=\"$mid\">"
     . "<input type=\"hidden\" name=\"eid\" value=\"$eid\">"
     . "<input type=\"hidden\" name=\"op\" value=\"Ephemeridschange\">"
     . "<input type=\"submit\" value=\"" . _SAVECHANGES . "\">"
     . "</form></fieldset>";
    CloseTable();
    include ('footer.php');
}

function Ephemeridschange($eid, $did, $mid, $yid, $content, $elanguage)
{
    global $prefix;
    $content = mxAddSlashesForSQL(($content));
    sql_query("update " . $prefix . "_ephem set yid='$yid', content='$content', elanguage='$elanguage' where eid=$eid");
    header("Location: admin.php?op=Ephemeridsmaintenance&did=$did&mid=$mid");
}

switch ($op) {
    case "Ephemeridsedit":
        Ephemeridsedit($eid, $did, $mid);
        break;

    case "Ephemeridschange":
        Ephemeridschange($eid, $did, $mid, $yid, $content, $elanguage);
        break;

    case "Ephemeridsdel":
        Ephemeridsdel($eid, $did, $mid);
        break;

    case "Ephemeridsmaintenance":
        Ephemeridsmaintenance($did, $mid);
        break;

    case "Ephemeridsadd":
        Ephemeridsadd($did, $mid, $yid, $content, $elanguage);
        break;

    case "Ephemerids":
    default:
        Ephemerids();
        break;
}

?>
