<?php
/**
 * This file is part of 
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.21.2.14 $
 * $Author: dia_bolo $
 * $Date: 2008/01/08 11:17:48 $
 */

defined('mxMainFileLoaded') or die('access denied');

if (!mxGetAdminPref("radminsuper")) {
    mxErrorScreen("Access Denied");
    die();
}

/* Pfad zu den Editordateien */
if (!defined('MX_WYSIWYG_DIR')) define('MX_WYSIWYG_DIR', 'spaw');

/* Sprachdatei auswaehlen */
if (@file_exists('admin/language/editor/lang-' . $currentlang . '.php')) {
    include_once('admin/language/editor/lang-' . $currentlang . '.php');
} else {
    include_once('admin/language/editor/lang-german.php');
}

/* Bridgedatei vorhanden */
if (@!is_file(MX_WYSIWYG_DIR . '/mx_bridge.php')) {
    mxErrorScreen(_EDITOR_FCKMISS, _EDITOR_WARN, false);
    return;
}

/* Konfigurations-Datei einbinden zum auslesen */
require_once(MX_WYSIWYG_DIR . '/mx_bridge.php');

/* Einstellungen Formular */
function ReadEditor()
{
    global $wyscnf, $prefix;
    // Dateitypen
    if (@file_exists(MX_WYSIWYG_DIR . '/plugins/spawfm/lib/lang/' . _DOC_LANGUAGE . '.lang.inc.php')) {
        include(MX_WYSIWYG_DIR . '/plugins/spawfm/lib/lang/' . _DOC_LANGUAGE . '.lang.inc.php');
    } else {
        @include(MX_WYSIWYG_DIR . '/plugins/spawfm/lib/lang/en.lang.inc.php');
    }
    // toolbar sets (should start with "toolbarset_"
    // all core toolbars
    $toolbars = array('all' => _EDITOR_FULL,
        'standard' => _EDITOR_DEFAULT,
        'mini' => _EDITOR_MINI,
        );

    if (isset($spaw_lang_data['filetypes']) && is_array($spaw_lang_data['filetypes'])) {
        $filetype_options = array();
        foreach ($wyscnf['filetypegroups'] as $key => $value) {
            if (isset($spaw_lang_data['filetypes'][$key])) {
                $label = $spaw_lang_data['filetypes'][$key];
            } else {
                $label = $key;
            }
            $filetype_labels[$key] = '<label>' . htmlentities($label) . '</label>'; # &nbsp;(<i>' . $key . '</i>)
            foreach($wyscnf['groups'] as $group => $tmp) {
                $checked = (empty($wyscnf[$group]['filetype'][$key])) ? '': ' checked="checked"';
                $filetype_options[$group][$key] = '
                <input type="hidden" name="filetype[' . $group . '][' . $key . ']" value="0" />
                <input type="checkbox" name="filetype[' . $group . '][' . $key . ']" value="1"' . $checked . ' />
                ';
            }
        }
    } else {
        $filetype_options[$group][] = _EDITOR_ERROR_NOFILETYPES;
    }

    /* Die Liste der relevanten pragmaMx Module */
    $wyscnf['moduls'] = mxSpawGetAvailableModuleData();

    /* Die Liste der pragmaMx Usergruppen */
    $wyscnf['pmx_groups_list'] = mxSpawGetUsergroupsList();

    /* die Standard-Chmods */
    if (!isset($wyscnf['globals']['chmod_dir_to']) || $wyscnf['globals']['chmod_dir_to'] < 0) {
        $mode = mxEditorGetChmods('chmod_dir_to');
        $wyscnf['globals']['chmod_dir_to'] = sprintf("%o", $mode);
    }
    $wyscnf['globals']['chmod_dir_to'] = (empty($wyscnf['globals']['chmod_dir_to'])) ? '' : sprintf('%04d', $wyscnf['globals']['chmod_dir_to']);

    if (!isset($wyscnf['globals']['chmod_to']) || $wyscnf['globals']['chmod_to'] < 0) {
        $mode = mxEditorGetChmods('chmod_to');
        $wyscnf['globals']['chmod_to'] = sprintf("%o", $mode);
    }
    $wyscnf['globals']['chmod_to'] = (empty($wyscnf['globals']['chmod_to'])) ? '' : sprintf('%04d', $wyscnf['globals']['chmod_to']);
    
    /* Anzahl der Gruppenspalten */
    $colspan = count($wyscnf['groups']);
    // Breite der Gruppenspalten 65% / Anzahl der Spalten
    $tdwidth = ceil(65 / $colspan);

    include('header.php');
    GraphicAdmin();
    title(_EDITOR_MAINTITLE);
    OpenTable(); ?>
    <fieldset><legend><?php echo _EDITOR_SETTINGS; ?></legend>
    <form action="admin.php" method="post">
    <table border="0" width="100%" cellpadding="3" cellspacing="0">

    <tr style="text-align: left; vertical-align: top">
    <th>&nbsp;</th>
    <?php foreach($wyscnf['groups'] as $group => $groupdata):?>
        <th width="<?php echo $tdwidth; ?>%"><?php echo $groupdata['title']; ?></th>
    <?php endforeach; ?>

    </tr>

    <tr>
    <td colspan="<?php echo ($colspan + 1); ?>"><label><?php echo _EDITOR_ACTIVE; ?></label></td>
    </tr>
    <tr style="text-align: left; vertical-align: top">
    <td>&nbsp;</td>
    <?php foreach($wyscnf['groups'] as $group => $groupdata):?>
        <?php $checked = (empty($wyscnf[$group]['active'])) ? '': ' checked="checked"'; ?>

        <td>
            <input type="hidden" name="active[<?php echo $group; ?>]" value="0" />
            <input type="checkbox" name="active[<?php echo $group; ?>]" value="1"<?php echo $checked; ?> />
        </td>
    <?php endforeach; ?>

    </tr>

    <tr>
    <td colspan="<?php echo ($colspan + 1); ?>"><label><?php echo _EDITOR_TOOLMODE; ?></label></td>
    </tr>
    <tr style="text-align: left; vertical-align: top">
    <td>&nbsp;</td>
    <?php foreach($wyscnf['groups'] as $group => $groupdata):
    $toolbaroptions = array();
    foreach ($toolbars as $key => $value):
    $selected = ($wyscnf[$group]['toolbar'] == $key) ? ' selected="selected"': '';
    $toolbaroptions[] = '<option value="' . $key . '"' . $selected . '>' . $value . '</option>';
    endforeach;
    $toolbaroptions = implode("\n", $toolbaroptions); ?>

        <td><select name="toolbar[<?php echo $group; ?>]"><?php echo $toolbaroptions; ?></select></td>
    <?php endforeach; ?>

    </tr>

    <tr>
    <td colspan="<?php echo ($colspan + 1); ?>"><label><?php echo _EDITOR_ADMINFILES; ?></label></td>
    </tr>
    <tr style="text-align: left; vertical-align: top">
    <td>&nbsp;</td>
    <?php foreach($wyscnf['groups'] as $group => $groupdata):?>
        <?php $checked = (empty($wyscnf[$group]['allow_modify'])) ? '': ' checked="checked"'; ?>

        <td>
            <input type="hidden" name="allow_modify[<?php echo $group; ?>]" value="0" />
            <input type="checkbox" name="allow_modify[<?php echo $group; ?>]" value="1"<?php echo $checked; ?> />
        </td>
    <?php endforeach; ?>
    </tr>

    <tr>
    <td colspan="<?php echo ($colspan + 1); ?>"><label><?php echo _EDITOR_FILETYPES; ?></label></td>
    </tr>
    <?php foreach($filetype_labels as $key => $label):?>
    <tr>
        <td align="right"><?php echo $label; ?></td>
        <?php foreach($wyscnf['groups'] as $group => $groupdata):?>
            <td><?php echo $filetype_options[$group][$key]; ?></td>
        <?php endforeach; ?>

    </tr>
    <?php endforeach; ?>


    <tr>
    <td colspan="<?php echo ($colspan + 1); ?>"><label><?php echo _EDITOR_MFS; ?></label></td>
    </tr>
    <tr style="text-align: left; vertical-align: top">
    <td>&nbsp;</td>
    <?php foreach($wyscnf['groups'] as $group => $groupdata):?>
        <?php $value = (empty($wyscnf[$group]['upload_max_size'])) ? '0': intval($wyscnf[$group]['upload_max_size']); ?>

        <td><input type="text" size="6" maxlength="5" name="upload_max_size[<?php echo $group; ?>]" value="<?php echo $value; ?>" style="text-align: right">&nbsp;<?php echo _EDITOR_INKB; ?></td>
    <?php endforeach; ?>

    </tr>

    <?php if (count($wyscnf['pmx_groups_list']) > 1): ?>
    <tr>
    <td colspan="<?php echo ($colspan + 1); ?>"><label><a name="edgroups" id="edgroups"><b>*</b></a>&nbsp;<?php echo _EDITOR_WHICH_USERS; ?></label></td>
    </tr>
    <?php foreach($wyscnf['pmx_groups_list'] as $key => $label):?>
        <?php $checked = ((empty($wyscnf['globals']['pmxgroups'])) || (isset($wyscnf['globals']['pmxgroups']) && !empty($wyscnf['globals']['pmxgroups'][$key]))) ? ' checked="checked"': ''; ?>

    <tr>
        <td align="right">
            <input type="hidden" name="pmxgroups[<?php echo $key; ?>]" value="0" />
            <input type="checkbox" name="pmxgroups[<?php echo $key; ?>]" value="1"<?php echo $checked; ?> />
        </td>
        <td colspan="<?php echo ($colspan); ?>">&nbsp;<?php echo $label; ?></td>
    </tr>
    <?php endforeach; ?>

    <?php endif; ?>
    <tr>
    <td colspan="<?php echo ($colspan + 1); ?>"><label><?php echo _EDITOR_MAX_IMG_WIDTH; ?></label></td>
    </tr>
    <tr>
        <td align="right"></td>
        <td><input type="text" size="6" maxlength="5" name="globals[max_img_width]" value="<?php echo $wyscnf['globals']['max_img_width']; ?>" style="text-align: right">&nbsp;<?php echo _EDITOR_INPIXEL; ?></td>
    </tr>

    <tr>
    <td colspan="<?php echo ($colspan + 1); ?>"><label><?php echo _EDITOR_MAX_IMG_HEIGHT; ?></label></td>
    </tr>
    <tr>
        <td align="right"></td>
        <td><input type="text" size="6" maxlength="5" name="globals[max_img_height]" value="<?php echo $wyscnf['globals']['max_img_height']; ?>" style="text-align: right">&nbsp;<?php echo _EDITOR_INPIXEL; ?></td>
    </tr>

    <tr>
    <td colspan="<?php echo ($colspan + 1); ?>"><label><?php echo _EDITOR_CHMODFOLDER; ?></label></td>
    </tr>
    <tr>
        <td align="right"></td>
        <td><input type="text" size="5" maxlength="4" name="globals[chmod_dir_to]" value="<?php echo $wyscnf['globals']['chmod_dir_to']; ?>" style="text-align: right"></td>
    </tr>

    <tr>
    <td colspan="<?php echo ($colspan + 1); ?>"><label><?php echo _EDITOR_CHMODFILES; ?></label></td>
    </tr>
    <tr>
        <td align="right"></td>
        <td><input type="text" size="5" maxlength="4" name="globals[chmod_to]" value="<?php echo $wyscnf['globals']['chmod_to']; ?>" style="text-align: right"></td>
    </tr>

    <?php
    $rows = count($wyscnf['globals']['fontfamily']) + 1 ;
    $fonttypes = implode("\n", $wyscnf['globals']['fontfamily']); ?>

    <tr>
    <td colspan="<?php echo ($colspan + 1); ?>"><label><?php echo _EDITOR_AVAILABLEFONTS1; ?></label></td>
    </tr>
    <tr>
        <td align="right"></td>
        <td colspan="<?php echo ($colspan); ?>">
            <textarea rows="<?php echo $rows; ?>" cols="40" name="globals[fontfamily]"><?php echo $fonttypes; ?>

            </textarea><br /><span class="tiny"><?php echo _EDITOR_AVAILABLEFONTS2; ?></span>
        </td>
    </tr>

    <tr>
    <td colspan="<?php echo ($colspan + 1); ?>"><label><?php echo _EDITOR_AREAFORECOLOR; ?></label></td>
    </tr>
    <tr>
        <td align="right"></td>
        <td><input type="text" size="10" name="globals[area_foreground]" value="<?php echo @$wyscnf['globals']['area_foreground']; ?>"></td>
    </tr>

    <tr>
    <td colspan="<?php echo ($colspan + 1); ?>"><label><?php echo _EDITOR_AREABACKCOLOR; ?></label></td>
    </tr>
    <tr>
        <td align="right"></td>
        <td><input type="text" size="10" name="globals[area_background]" value="<?php echo @$wyscnf['globals']['area_background']; ?>"></td>
    </tr>

    <tr>
    <td colspan="<?php echo ($colspan + 1); ?>"><label><?php echo _EDITOR_CALLMODULES; ?></label></td>
    </tr>
    <?php foreach($wyscnf['moduls'] as $value):?>
        <?php $checked = (empty($wyscnf['modules'][$value['wygid']])) ? '': ' checked="checked"'; ?>

    <tr>
        <td align="right">
            <input type="hidden" name="modul[<?php echo $value['wygid']; ?>]" value="0" />
            <input type="checkbox" name="modul[<?php echo $value['wygid']; ?>]" value="1"<?php echo $checked; ?> />
        </td>
        <td colspan="<?php echo ($colspan); ?>">&nbsp;<?php echo $value['title']; ?></td>
    </tr>
    <?php endforeach; ?>

    </table>

    <input type="hidden" name="op" value="SaveEditor">
    <input type="submit" value="<?php echo _EDITOR_SAVE; ?>">
    </form>
  </fieldset>

    <?php
    CloseTable();
    include('footer.php');
}

/**
 * Editorkonfiguration in Datei speichern
 */
function SaveEditor()
{
    global $wyscnf;
    $conf_file = MX_WYSIWYG_DIR . '/editor_cnf.php';
    /* Konfigurations-Datei einbinden zum auslesen */
    // require_once($conf_file);
    /* Die anzubietenden Schrifarten */
    $fonts = array();
    // das Array anhand der Zeilenumbrueche aufteilen
    $temp = explode("\n", stripslashes($_POST['globals']['fontfamily']));
    // das Array durchlaufen
    foreach ($temp as $key => $value) {
        // leere Werte entfernen und Spaces um den Wert entfernen
        $value = trim($value);
        if ($value) {
            // Semikolons duch komma ersetzen und Anfuehrungszeichen entfernen
            $fonts[] = str_replace(array(';', '"', "'"), array(',', '', ''), $value);
        }
    }
    // Array alphabetisch sortieren
    natcasesort($fonts);
    // das Array nochmal durchlaufen
    foreach ($fonts as $key => $value) {
        // den Wert in ein Array splitten um einen kurzen Schluessel zu erhalten
        // der Schluessel ist die im Auswahlfeld angezeigte Beschriftung
        $temp = preg_split('#(\s|,|;)#', $value);
        $newfonts[$temp[0]] = $value;
    }
    /* spezielle Benutzergruppen, falls welche vorhanden */
    if (isset($_POST['pmxgroups']) && is_array($_POST['pmxgroups'])) {
        $newgroups = $_POST['pmxgroups'];
    } else {
        // wenn nicht, gilt das alles nur fuer die Standardgruppe
        $default_group = (empty($GLOBALS['default_group'])) ? 1 : $GLOBALS['default_group'];
        $newgroups = array($default_group => 1);
    }

    /* die Standard-Chmods */
    if ($_POST['globals']['chmod_dir_to'] < 0) {
        $mode = mxEditorGetChmods('chmod_dir_to');
        $_POST['globals']['chmod_dir_to'] = sprintf("%o", $mode);
    }
    $chmod_dir_to = (empty($_POST['globals']['chmod_dir_to'])) ? '' : sprintf('%04d', intval($_POST['globals']['chmod_dir_to']));

    if ($_POST['globals']['chmod_to'] < 0) {
        $mode = mxEditorGetChmods('chmod_to');
        $_POST['globals']['chmod_to'] = sprintf("%o", $mode);
    }
    $chmod_to = (empty($_POST['globals']['chmod_to'])) ? '' : sprintf('%04d', intval($_POST['globals']['chmod_to']));

    // die Farben der Textarea
    $area_foreground = (empty($_POST['globals']['area_foreground'])) ? '' : $_POST['globals']['area_foreground'];
    $area_background = (empty($_POST['globals']['area_background'])) ? '' : $_POST['globals']['area_background'];
   
    // globals-array erstellen
    $write['globals'] = serialize(array(
        'pmxgroups' => $newgroups,
        'fontfamily' => $newfonts,
        'max_img_width' => intval($_POST['globals']['max_img_width']),
        'max_img_height' => intval($_POST['globals']['max_img_height']),
        'chmod_dir_to' => $chmod_dir_to,
        'chmod_to' => $chmod_to,
        'area_foreground' => $area_foreground,
        'area_background' => $area_background,
        ));

    /* Die Liste der Module */
    $write['modules'] = serialize($_POST['modul']);

    /* Die Benutzer(gruppen) spezifischen Einstellungen */
    foreach ($_POST['active'] as $key => $value) {
        $group['active'] = intval($value);
        $group['toolbar'] = $_POST['toolbar'][$key];
        $group['upload_max_size'] = intval($_POST['upload_max_size'][$key]);
        $group['allow_modify'] = intval($_POST['allow_modify'][$key]);
        $group['filetype'] = $_POST['filetype'][$key];
        $write[$key] = serialize($group);
    }

    /* den zu schreibenden String erstellen */
    foreach ($write as $key => $value) {
        $str[] = '$wyscnf[\'' . $key . '\'] = unserialize(\'' . $value . '\');';
    }

    $out = '<?php
/**
 * pragmaMx - Web Content Management System
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * write with: $Id: mxeditor.php,v 1.21.2.14 2008/01/08 11:17:48 dia_bolo Exp $
 */

' . implode("\n", $str) . '

?>';
    /* Bei Readonly versuchen 777 zu setzen */
    if (!is_writable($conf_file)) {
        mxChangeFilePerms($conf_file, 'unlock');
    }
    /* Config speichern */
    $file = @fopen($conf_file, "w");
    $ok = @fwrite($file, trim($out));
    @fclose($file);
    /* Versuche aus Sicherheitsgrnden 444 zu setzen */
    mxChangeFilePerms($conf_file, 'lock');

    /* alles ok > redirect */
    if ($ok) {
        mxRedirect('admin.php?op=ReadEditor', _EDITOR_SETTINGSAVED, 1);
        return;
    }
    /* error > exit */
    mxErrorScreen(_EDITOR_SETTINGNOSAVED, _EDITOR_WARN, true);
    return;
}

/* chmods automatisch ermitteln */
function mxEditorGetChmods($mode) {
    /* die Standard-Chmods */
    if ($mode === 'chmod_dir_to') {
        if (@file_exists('images/iupload')) {
            $file = 'images/iupload';
            $mode = @fileperms($file);
            $mode &= 0x1ff; # Remove the bits we don't need
        } else if (@file_exists('media/images')) {
            $file = 'media/images';
            $mode = @fileperms($file);
            $mode &= 0x1ff; # Remove the bits we don't need
        } else {
            $mode = '777';
        }
    } else {
        $file = 'images/admin/editor.gif';
        $mode = @fileperms($file);
        $mode &= 0x1ff; # Remove the bits we don't need
    }
    return $mode;
}


/* Was ist zu tun... */
switch ($_REQUEST['op']) {
    case 'SaveEditor':
        SaveEditor();
        break;
    case 'ReadEditor':
        ReadEditor();
    default:

}

?>
