<?php
/**
 * This file is part of 
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.6.2.3 $
 * $Author: dia_bolo $
 * $Date: 2008/01/10 10:51:15 $
 *
 * this file based on: Nuke Guestbook v2.0.0
 * Copyright (c) 2001 by Christopher Thorjussen (joffer@online.no), http://www.nukemodules.com
 * Nuke Guestbook is based on Advanced Guestbook 1.01 (PHP/MySQL)
 * Copyright (c) 2001 Chi Kien Uong, http://www.proxy2.de
 * Modified by Francesco Bozzotta, (webmaster@nukeitalia.com), http://www.nukeitalia.com
 * Copyright (c) 2002 by Jochem Schausten (webmaster@tp-krefeld.de), http://www.tp-krefeld.de
 * php-nuke Web Portal System - http://phpnuke.org/
 * Thatware - http://thatware.org/
 */

if (!defined("mxAdminFileLoaded")) die("Access Denied");

$module_name = "Guestbook";
mxGetLangfile($module_name);

if (!mxGetAdminPref('radminsuper')) {
    mxErrorScreen("Access Denied");
    die();
}

include_once("modules/$module_name/include/lib.inc.php");
// / Konfiguration auslesen
$NB_setting = NB_GetSettings();
// mxDebugFuncVars($NB_setting);
// ==================================================
// function GuestBookAdmin
// Main admin page for Guestbook. Here you
// set the different guestbook options.
// ==================================================
function GuestBookAdmin()
{
    global $bgcolor1, $bgcolor2, $bgcolor3, $bgcolor4, $textcolor1, $textcolor2;
    global $prefix, $user_prefix, $module_name, $NB_setting;

    $qry = "SELECT G.*, G.name AS nbname, U.uid AS uid
	FROM {$prefix}_{$NB_setting['dbtable']}_queue AS G LEFT JOIN {$user_prefix}_users AS U ON G.name = U.uname
	ORDER BY G.date DESC";

    $result = sql_query($qry);
    $newentries = sql_num_rows($result);

    include('header.php');
    GraphicAdmin();
    title(_NBGUESTBOOKADMINISTRATION);

    if (!empty($newentries)) {
        if ($NB_setting['confirmation']) {
            title(_NBSUBMISSIONSADMIN);
            $msg = _NBNEWSUBMISSIONS;
        } else {
            $msg = _NBENTRYWARNING;
        }
        OpenTable();
        echo '<center><font class="option"><b>' . $msg . '</b></font></center><br>
		<table width="100%" border="0" cellspacing="0" cellpadding="2">
		';
        while ($entry = sql_fetch_assoc($result)) {
            NB_ViewEntry($entry, true);
            echo '<tr><td colspan="2" align="center"><span class="content">[
			<a href="admin.php?op=GuestBookSubmitEntry&amp;id=' . $entry['id'] . '&amp;qu=1">' . _NBCONFIRMENTRY . '</a> |
			<a href="admin.php?op=GuestBookEditEntry&amp;id=' . $entry['id'] . '&amp;qu=1">' . _NBEDITENTRY . '</a> |
			<a href="admin.php?op=GuestBookDeleteEntry&amp;id=' . $entry['id'] . '&amp;qu=1">' . _NBREJECTENTRY . '</a>
			]</span></td></tr>';
        }
        echo '</table>
		';
        CloseTable();
        echo '<br>';
    } else {
        if ($NB_setting['confirmation']) {
            title(_NOSUBMISSIONS);
        }
    }
    GuestBookSettings();
    OpenTable();
    echo '<div align="center"><a href="modules.php?name=' . $module_name . '">' . _NBREADGUESTBOOK . '</a></div>';
    CloseTable();
    include('footer.php');
}
// ==================================================
// function GuestBookSubmitEntry
// Function to confirm an entry in the queue-database.
// Accessed from admin guestbook page
// Added in Version 2.5.0
// ==================================================
function GuestBookSubmitEntry()
{
    global $module_name, $NB_setting, $prefix;

    $id = empty($_REQUEST['id']) ? 0 : intval($_REQUEST['id']);
    if (!$id) {
        header("Location: admin.php?op=GuestBookAdmin");
    }
    $qry = "INSERT INTO {$prefix}_{$NB_setting['dbtable']} (`name`, `email`, `url`, `date`, `host`, `comment`, `nukeuser`)
				SELECT `name`, `email`, `url`, `date`, `host`, `comment`, `nukeuser`
				FROM {$prefix}_{$NB_setting['dbtable']}_queue
				WHERE id=" . intval($id);
    $result = sql_query($qry);
    // mxDebugFuncVars(mysql_error());
    if ($result) {
        $sqlst = "DELETE FROM {$prefix}_{$NB_setting['dbtable']}_queue WHERE id='" . intval($id) . "'";
        $sql_result = sql_query($sqlst);
    }

    header("Location: admin.php?op=GuestBookAdmin");
}
// ==================================================
// function GuestBookDeleteEntry
// Function to delete a post in the database.
// Accessed from main guestbook page
// Function to reject and delete a post in the queue-database.
// Accessed from admin guestbook page
// ==================================================
function GuestBookDeleteEntry()
{
    global $bgcolor1, $bgcolor2, $bgcolor3, $bgcolor4, $textcolor1, $textcolor2;
    global $module_name, $NB_setting, $prefix;

    $id = empty($_REQUEST['id']) ? 0 : intval($_REQUEST['id']);
    if (!$id) {
        header("Location: admin.php?op=GuestBookAdmin");
    }
    $qu = empty($_REQUEST['qu']) ? 0 : 1;
    $ok = empty($_REQUEST['ok']) ? 0 : 1;
    $item = empty($_REQUEST['item']) ? 0 : intval($_REQUEST['item']);
    $goto = ($qu) ? 'admin.php?op=GuestBookAdmin' : "modules.php?name=" . $module_name . "&item=" . $item . "#gb-" . $id;

    if ($ok) {
        $table = ($qu) ? "{$prefix}_{$NB_setting['dbtable']}_queue" : "{$prefix}_{$NB_setting['dbtable']}";
        $qry = "DELETE FROM {$table} WHERE id='" . intval($id) . "'";
        $sql_result = sql_query($qry);
        header("Location: " . $goto);
        exit;
    }

    include('header.php');
    // GraphicAdmin();
    title(_NBGUESTBOOKADMINISTRATION);
    OpenTable();
    echo '<center><font class="option"><b>' . _NBDELETEENTRY . '</b></font></center><br>';
    echo "<center>[&nbsp;<a href=\"admin.php?op=GuestBookDeleteEntry&amp;id=" . $id . "&amp;qu=" . $qu . "&amp;item=" . $item . "&amp;ok=1\">" . _YES . "</a> | <a href=\"" . htmlentities($goto) . "\">" . _NO . "</a>&nbsp;]</center>";
    CloseTable();
    include('footer.php');
}
// ==================================================
// function GuestBookEditEntry
// Function to edit a post in the database.
// Accessed from main guestbook page
// ==================================================
function GuestBookEditEntry()
{
    global $bgcolor1, $bgcolor2, $bgcolor3, $bgcolor4, $textcolor1, $textcolor2;
    global $module_name, $NB_setting, $prefix, $user_prefix;

    $id = empty($_REQUEST['id']) ? 0 : intval($_REQUEST['id']);
    if (!$id) {
        header("Location: admin.php?op=GuestBookAdmin");
    }
    $qu = empty($_REQUEST['qu']) ? 0 : 1;
    $item = empty($_REQUEST['item']) ? 0 : intval($_REQUEST['item']);
    $cap1 = ($qu) ? _NBEDITENTRY . ' (' . _NBENTRYCHECK . ')' : _NBEDITENTRY;
    $cap2 = ($qu) ? _NBPREVIEW . ' (' . _NBENTRYCHECK . ')' : _NBPREVIEW;

    $table = ($qu) ? "{$prefix}_{$NB_setting['dbtable']}_queue" : "{$prefix}_{$NB_setting['dbtable']}";
    $qry = "SELECT G.*, G.name AS nbname, U.uid AS uid
	FROM {$table} AS G LEFT JOIN {$user_prefix}_users AS U ON G.name = U.uname
	WHERE id=" . intval($id);

    $result = sql_query($qry);
    $entry = sql_fetch_assoc($result);

    include('header.php');
    GraphicAdmin();
    title(_NBGUESTBOOKADMINISTRATION);
    OpenTable();
    NB_SubmitForm($entry, $cap1, true);
    echo '
	<br>
	<center><font class="option"><b>' . $cap2 . '</b></font></center><br>
	<table width="100%" border="0" cellspacing="0" cellpadding="2">
	';
    if (!$qu) {
        $entry['comment'] = NB_CutEditMessage($entry['comment']);
        $entry['comment'] = NB_SetEditMessage($entry['comment']);
    }
    NB_ViewEntry($entry, true);
    echo '<tr><td colspan="2" align="center"><span class="content">[';

    if ($qu) {
        echo '<a href="admin.php?op=GuestBookSubmitEntry&amp;id=' . $entry['id'] . '&amp;qu=1">' . _NBCONFIRMENTRY . '</a> |
		<a href="admin.php?op=GuestBookDeleteEntry&amp;id=' . $entry['id'] . '&amp;qu=1">' . _NBDELETEENTRY . '</a>';
    } else {
        echo '<a href="modules.php?name=' . $module_name . '&amp;item=' . $item . '#gb-' . $entry['id'] . '">' . _NBGOTOENTRY . '</a>';
    }
    echo ']</span></td></tr>';

    echo '</table>
	';
    CloseTable();
    include('footer.php');
}

function GuestBookEditEntryConfirm()
{
    global $module_name, $NB_setting, $prefix;
    $id = empty($_POST['id']) ? 0 : intval($_POST['id']);
    if (!$id) {
        header("Location: admin.php?op=GuestBookAdmin");
    }

    $qu = empty($_POST['qu']) ? 0 : 1;
    $item = empty($_POST['item']) ? 0 : intval($_POST['item']);
    $table = ($qu) ? "{$prefix}_{$NB_setting['dbtable']}_queue" : "{$prefix}_{$NB_setting['dbtable']}";

    $_POST['url'] = trim(mxCutHTTP(strip_tags($_POST['url'])));
    $_POST['email'] = trim(strip_tags($_POST['email']));
    $_POST['comment'] = trim($_POST['comment']);
    if (!$qu) {
        $_POST['comment'] = NB_SetEditMessage($_POST['comment']);
    }

    $qry = "UPDATE {$table} SET email='" . mxAddSlashesForSQL($_POST['email']) . "', url='" . mxAddSlashesForSQL($_POST['url']) . "', comment='" . mxAddSlashesForSQL($_POST['comment']) . "' WHERE id='" . intval($id) . "'";

    $sql_result = sql_query($qry);
    header("Location: admin.php?op=GuestBookEditEntry&id=" . $id . "&qu=" . $qu . "&item=" . $item);
}
// ==================================================
// function GuestBookSaveSettings
// This function writes the (new) settings to the
// config file
// ==================================================
function GuestBookSaveSettings()
{
    global $module_name;

    extract(NB_GetSettings() , EXTR_OVERWRITE);
    extract(mxStripSlashes($_POST), EXTR_OVERWRITE);
    if (empty($dbtable)) {
        $dbtable = 'nukebook';
    }

    $content .= "<?php // write with: \$Id: nukebook.php,v 1.6.2.3 2008/01/10 10:51:15 dia_bolo Exp $\n";
    $content .= "/************************************************************/\n";
    $content .= "/* Guestbook settings                                       */\n";
    $content .= "/* These settings should not be altered manually.           */\n";
    $content .= "/* All settings are altered from Admin section in pragmaMx. */\n";
    $content .= "/************************************************************/\n";
    $content .= "\n";
    $content .= "\$NB_setting['regonly']          = '" . $regonly . "';\n";
    $content .= "\$NB_setting['gbnotify']         = '" . $gbnotify . "';\n";
    $content .= "\$NB_setting['waitseconds']      = '" . $waitseconds . "';\n";
    $content .= "\$NB_setting['entries_per_page'] = '" . $entries_per_page . "';\n";
    $content .= "\$NB_setting['allow_html']       = '" . $allow_html . "';\n";
    $content .= "\$NB_setting['smilies']          = '" . $smilies . "';\n";
    $content .= "\$NB_setting['nbcode']           = '" . $nbcode . "';\n";
    $content .= "\$NB_setting['max_wordlength']   = '" . $max_wordlength . "';\n";
    $content .= "\$NB_setting['confirmation']     = '" . $confirmation . "';\n";
    $content .= "\$NB_setting['showurl']          = '" . $showurl . "';\n";
    $content .= "\$NB_setting['rightblocks']      = '" . $rightblocks . "';\n";
    $content .= "\n";
    $content .= "/************************************************************************/\n";
    $content .= "/* Below settings are not to be changed at all                          */\n";
    $content .= "/************************************************************************/\n";
    $content .= "\n";
    // $content .= "\$NB_setting['version'] = 'mx 3.0';\n";
    $content .= "\$NB_setting['dbtable'] = '" . $dbtable . "';\n";
    $content .= "\n";
    $content .= "?>\n";

    @chmod("modules/$module_name/include/config.inc.php", 0777);
    $file = fopen("modules/$module_name/include/config.inc.php", "w");
    fwrite($file, $content);
    fclose($file);
    @chmod("modules/$module_name/include/config.inc.php", 0444);

    header("Location: admin.php?op=GuestBookAdmin");
}

function GuestBookSettings()
{
    global $bgcolor1, $bgcolor2, $bgcolor3, $bgcolor4, $textcolor1, $textcolor2;
    global $prefix, $user_prefix, $module_name, $NB_setting;
    // start Settings
    OpenTable();
    echo "<fieldset><legend>" . _NBSETTINGS . "</legend>\n";

    ?>
     <form action="admin.php" method="post">
<table border="0" cellpadding="3" cellspacing="0" width="100%" align="left">
  <tr>
    <td class="content"><?php echo _NBONLYREGGEDUSERS;

    ?></td>
    <td>
      <select name="regonly">
        <option value="<?php echo (($NB_setting['regonly'] == 1) ? "1": "0") ?>" selected><?php echo (($NB_setting['regonly'] == 1) ? _YES : _NO) ?></option>
        <option value="<?php echo (($NB_setting['regonly'] == 1) ? "0": "1") ?>"><?php echo (($NB_setting['regonly'] == 1) ? _NO : _YES) ?></option>
      </select>
    </td>
  </tr>
  <tr>
    <td class="content"><?php echo _NBCONFIRMENTRIES;

    ?></td>
    <td>
      <select name="confirmation">
        <option value="<?php echo (($NB_setting['confirmation'] == 1) ? "1": "0") ?>" selected><?php echo (($NB_setting['confirmation'] == 1) ? _YES : _NO) ?></option>
        <option value="<?php echo (($NB_setting['confirmation'] == 1) ? "0": "1") ?>"><?php echo (($NB_setting['confirmation'] == 1) ? _NO : _YES) ?></option>
      </select>
    </td>
  </tr>
  <tr>
    <td class="content"><?php echo _NBNOTIFY;

    ?></td>
    <td>
      <select name="gbnotify">
        <option value="<?php echo (($NB_setting['gbnotify'] == 1) ? "1": "0") ?>" selected><?php echo (($NB_setting['gbnotify'] == 1) ? _YES : _NO) ?></option>
        <option value="<?php echo (($NB_setting['gbnotify'] == 1) ? "0": "1") ?>"><?php echo (($NB_setting['gbnotify'] == 1) ? _NO : _YES) ?></option>
      </select>
    </td>
  </tr>
  <tr>
    <td class="content"><?php echo _NBSPAMWAIT;

    ?></td>
    <td>
      <input type="text" name="waitseconds" value="<?php echo $NB_setting['waitseconds'];

    ?>" size="3">&nbsp;<?php echo _NBSPAMWAIT2;

    ?>
    </td>
  </tr>
  <tr>
    <td class="content"><?php echo _NBENTRIES;

    ?></td>
    <td>
      <input type="text" name="entries_per_page" value="<?php echo $NB_setting['entries_per_page'];

    ?>" size="3">
		</td>
  </tr>
  <tr>
    <td class="content"><?php echo _NBMAXWORDLENGTH;

    ?></td>
    <td>
      <input type="text" name="max_wordlength" value="<?php echo $NB_setting['max_wordlength'];

    ?>" size="3">
    </td>
  </tr>
  <tr>
    <td class="content"><?php echo _NBALLOWHTML;

    ?></td>
    <td>
      <select name="allow_html">
        <option value="<?php echo (($NB_setting['allow_html'] == 1) ? "1": "0") ?>" selected><?php echo (($NB_setting['allow_html'] == 1) ? _YES : _NO) ?></option>
        <option value="<?php echo (($NB_setting['allow_html'] == 1) ? "0": "1") ?>"><?php echo (($NB_setting['allow_html'] == 1) ? _NO : _YES) ?></option>
      </select>
    </td>
  </tr>
  <tr>
    <td class="content"><?php echo _NBALLOWNBCODE;

    ?></td>
    <td>
      <select name="nbcode">
        <option value="<?php echo (($NB_setting['nbcode'] == 1) ? "1": "0") ?>" selected><?php echo (($NB_setting['nbcode'] == 1) ? _YES : _NO) ?></option>
        <option value="<?php echo (($NB_setting['nbcode'] == 1) ? "0": "1") ?>"><?php echo (($NB_setting['nbcode'] == 1) ? _NO : _YES) ?></option>
      </select>
    </td>
  </tr>
  <tr>
    <td class="content"><?php echo _NBALLOWSMILIES;

    ?></td>
    <td>
      <select name="smilies">
        <option value="<?php echo (($NB_setting['smilies'] == 1) ? "1": "0") ?>" selected><?php echo (($NB_setting['smilies'] == 1) ? _YES : _NO) ?></option>
        <option value="<?php echo (($NB_setting['smilies'] == 1) ? "0": "1") ?>"><?php echo (($NB_setting['smilies'] == 1) ? _NO : _YES) ?></option>
      </select>
    </td>
  </tr>
  <tr>
    <td class="content"><?php echo _NBUSEWEBSITE;

    ?></td>
    <td>
      <select name="showurl">
        <option value="<?php echo ((empty($NB_setting['showurl'])) ? "0": "1") ?>" selected><?php echo ((empty($NB_setting['showurl'])) ? _NO : _YES) ?></option>
        <option value="<?php echo ((empty($NB_setting['showurl'])) ? "1": "0") ?>"><?php echo ((empty($NB_setting['showurl'])) ? _YES : _NO) ?></option>
      </select>
    </td>
  </tr>
  <tr>
    <td class="content"><?php echo _NBRIGHTBLOCKS;

    ?></td>
    <td>
      <select name="rightblocks">
        <option value="<?php echo (($NB_setting['rightblocks'] == 1) ? "1": "0") ?>" selected><?php echo (($NB_setting['rightblocks'] == 1) ? _YES : _NO) ?></option>
        <option value="<?php echo (($NB_setting['rightblocks'] == 1) ? "0": "1") ?>"><?php echo (($NB_setting['rightblocks'] == 1) ? _NO : _YES) ?></option>
      </select>
    </td>
  </tr>
  <tr>
    <td>
    </td>
    <td>
      <input type="hidden" name="op" value="GuestBookSaveSettings">
      <input type="submit" value="<?php echo _NBSUBMIT;

    ?>">
    </td>
  </tr>
</table>
</form>
</fieldset>
<?php
    CloseTable();
    // end Settings
}

switch ($op) {
    case "NukebookAdmin":
    case "GuestBookAdmin":
        GuestBookAdmin();
        break;

    case "NukebookSaveSettings":
    case "GuestBookSaveSettings":
        GuestBookSaveSettings();
        break;

    case "NukebookSubmitEntry":
    case "GuestBookSubmitEntry":
        GuestBookSubmitEntry();
        break;

    case "NukebookDeleteEntry":
    case "GuestBookDeleteEntry":
        GuestBookDeleteEntry();
        break;

    case "NukebookEditEntry":
    case "GuestBookEditEntry":
        GuestBookEditEntry();
        break;

    case "NukebookEditEntryConfirm":
    case "GuestBookEditEntryConfirm":
        GuestBookEditEntryConfirm();
        break;
}

?>