<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.19.2.17 $
 * $Author: tora60 $
 * $Date: 2008/01/21 01:26:08 $
 */

defined('mxMainFileLoaded') or die('access denied');

if (!mxGetAdminPref("radminsuper")) {
    mxErrorScreen("Access Denied");
    die();
}
// / hier kann die Anzeige der Demomodus-Konfiguration aktiviert werden.
// / Standardmaessig wird die nicht angezeigt, sondern der demomodus muss
// / manuell in der config.php geaendert werden.
$show_demo_mode = 0;

function Configure($ok = 0)
{
    global $fieldset_names;
    include ('config.php');

    /* falls config.php nicht schreibgeschuetzt, dieses tun... */
    if (is_writable('config.php')) {
        mxChangeFilePerms('config.php', 'lock');
    }

    setlocale (LC_TIME, $locale);
    extract(mxGetAdminSession());

    $vkpInactiveMins = (empty($vkpInactiveMins)) ? 10 : $vkpInactiveMins;
    $vkpSessLifetime = (!isset($vkpSessLifetime)) ? 30 : $vkpSessLifetime;
    $vkpIntranet = (empty($vkpIntranet)) ? 0 : 1;
    $sel_intranet['0'] = '';
    $sel_intranet['1'] = '';
    $sel_intranet[$vkpIntranet] = ' checked';

    $mailhost = (empty($mailhost)) ? "" : $mailhost;
    $mailuname = (empty($mailuname)) ? "" : $mailuname;
    $mailpass = (empty($mailpass)) ? "" : $mailpass;
    $mailport = (empty($mailport)) ? "25" : (int)$mailport;
    $mailauth = (empty($mailauth)) ? "mail" : $mailauth;
    $popauth = (empty($popauth)) ? "" : $popauth;

    $mxSiteService = (empty($mxSiteService)) ? 0 : 1;
    $mxSiteServiceText = (empty($mxSiteServiceText)) ? "" : $mxSiteServiceText;
    $mxUseThemecache = (empty($mxUseThemecache)) ? 0 : (int)$mxUseThemecache;
    $mxDebugService = (empty($mxDebugService)) ? 0 : (int)$mxDebugService;
    $mxSqlDebug = (empty($mxSqlDebug)) ? 0 : (int)$mxSqlDebug;
    $mxSqlErrorDebug = (empty($mxSqlErrorDebug)) ? 0 : (int)$mxSqlErrorDebug;

    $vkpTracking = (empty($vkpTracking)) ? 0 : 1;
    $storyhome_cols = (empty($storyhome_cols)) ? 1 : (int)$storyhome_cols;
    $foot1 = (empty($foot1)) ? "" : htmlentities($foot1);
    $foot2 = (empty($foot2)) ? "" : htmlentities($foot2);
    $foot3 = (empty($foot3)) ? "" : htmlentities($foot3);
    $foot4 = (empty($foot4)) ? "" : htmlentities($foot4);
    $pm_poptime = (empty($pm_poptime)) ? 0 : (int)$pm_poptime;

    $vkpSafeCookie1 = (empty($vkpSafeCookie1)) ? 0 : 1;
    $sel_vkpSafeCookie1['0'] = '';
    $sel_vkpSafeCookie1['1'] = '';
    $sel_vkpSafeCookie1[$vkpSafeCookie1] = ' checked';

    $vkpSafeCookie2 = (empty($vkpSafeCookie2)) ? 0 : 1;
    $sel_vkpSafeCookie2['0'] = '';
    $sel_vkpSafeCookie2['1'] = '';
    $sel_vkpSafeCookie2[$vkpSafeCookie2] = ' checked';

    $mxCreateNukeCookie = (empty($mxCreateNukeCookie)) ? 0 : 1;
    $sel_mxCreateNukeCookie['0'] = '';
    $sel_mxCreateNukeCookie['1'] = '';
    $sel_mxCreateNukeCookie[$mxCreateNukeCookie] = ' checked';

    $mxDeactNukeCompatible = (empty($mxDeactNukeCompatible)) ? 0 : 1;
    $sel_mxDeactNukeCompatible['0'] = '';
    $sel_mxDeactNukeCompatible['1'] = '';
    $sel_mxDeactNukeCompatible[$mxDeactNukeCompatible] = ' checked';

    $vkpSafeSqlinject = (empty($vkpSafeSqlinject)) ? ((isset($vkpSafeSqlinject)) ? 0 : 1) : 1;
    $sel_vkpSafeSqlinject['0'] = '';
    $sel_vkpSafeSqlinject['1'] = '';
    $sel_vkpSafeSqlinject[$vkpSafeSqlinject] = ' checked';

    $vkpUserregoption = (empty($vkpUserregoption)) ? 0 : $vkpUserregoption;
    $default_group = (empty($default_group)) ? 1 : $default_group;

    $vkpsec_logging = (empty($vkpsec_logging)) ? 0 : 1;
    $sel_sec_logging['0'] = '';
    $sel_sec_logging['1'] = '';
    $sel_sec_logging[$vkpsec_logging] = ' checked';

    $backend_active = (empty($backend_active)) ? ((isset($backend_active)) ? 0 : 1) : 1;
    // http://carsten-protsch.de/zwischennetz/doctype/einleitung.html
    $DOCTYPE = (empty($DOCTYPE)) ? 0 : intval($DOCTYPE);
    $doctype_array = mxDoctypeArray();

    $tidy_available = checktidyavailable();
    $TidyOutput = (empty($TidyOutput) || !$tidy_available) ? 0 : intval($TidyOutput);

    $cthemes = "";
    $themelist = array();
    $handle = opendir("themes");
    while ($file = readdir($handle)) {
        if (!ereg("[.]", $file)) {
            if (@file_exists("themes/$file/theme.php")) {
                $themelist[] = $file;
            }
        }
    }
    closedir($handle);
    sort($themelist);
    foreach($themelist as $varname => $value) {
        $sel = ($value == $Default_Theme) ? 'selected="selected"' : '';
        $cthemes .= "<option value=\"$value\" $sel>$value\n";
    }

    $clanguage = "";
    $languageslist = array();
    $handle = opendir('language');
    while ($file = readdir($handle)) {
        if (ereg("^lang\-(.+)\.php", $file, $matches)) {
            $languageslist[] = $matches[1];
        }
    }
    closedir($handle);
    sort($languageslist);
    foreach($languageslist as $varname => $value) {
        $sel = ($value == $language) ? "selected" : "";
        $clanguage .= "<option value=\"$value\" $sel>" . ucfirst($value) . "\n";
    }
    $CensorListUsers = (empty($CensorListUsers)) ? array() : $CensorListUsers;
    $metakeywords = (empty($metakeywords)) ? "" : $metakeywords;
    // $vkpUserGraphicMenu = (empty($vkpUserGraphicMenu)) ? 0 : 1;
    // option Bloecke
    $default = (isset($vkpBlocksRight)) ? $vkpBlocksRight : 0;
    $blockoptions1 = "";
    for ($i = 0; $i <= 2; $i++) {
        if (defined("_BLOCKSHOW_" . $i)) {
            $blockoptions1 .= "<option value=\"" . $i . "\" " . (($default == $i) ? 'selected="selected"' : "") . ">" . constant("_BLOCKSHOW_" . $i) . "</option>\n";
        }
    }
    // ende option Bloecke
    if (!isset($mxShowPragmaMxNews)) {
        $mxShowPragmaMxNews = 1;
    }

    if (!isset($mxEntitieLevel)) {
        $mxEntitieLevel = 1;
    }
    if (!isset($mxUseThemecache)) {
        $mxUseThemecache = 1;
    }

    if ($ok == 1) {
        $statmsg = "<b>" . _ADMIN_SETTINGNOSAVED . "</b><br /><br />";
        $statmsg .= "<font class=\"content\">" . _ADMIN_CANTCHANGE . " (config.php)</font>";
    } else if ($ok > 1) {
        $statmsg = "<b>" . _ADMIN_SETTINGSAVED . "</b>";
    }

    /**
     * JavaScript-Framework jQuery und fieldset events/styles einbinden
     */
    // TODO: das sollte in eine Api-Funktion, bzw. spaeter als Addon fuer die Template-Engine
    pmxHeader::add('<script type="text/javascript" src="includes/javascript/jquery.js"></script>');
    pmxHeader::add('<script type="text/javascript" src="includes/javascript/fieldset.js.php"></script>');

    include ("header.php");
    include ("includes/javascript/fieldset.js.php");
    GraphicAdmin();
    OpenTable();
    echo "<div id='slideToggle'>\n";
    OpenTable();
    echo "<h2 class=\"title\" style=\"text-align: center;\">" . MX_VERSION . " - " . _SITECONFIG . "</h2><p style=\"text-align: center;\">" . _ADMIN_LASTCHANGE . " " . mx_strftime(_DATESTRING . ' %H:%M:%S', filemtime('config.php')) . "</p>";
    CloseTable();
    if (!empty($statmsg)) {
        OpenTableAl();
        echo "<div align='center'><blockquote><font class=\"title\">" . $statmsg . "</font></blockquote></div>";
        CloseTableAl();
    }
    if (isset($_COOKIE['jsEnabled'])) {
        echo '<p align="right" style="margin-right:4em;"><button class="fieldset-exp_all">' . _EXPANDALL . '</button>&nbsp;&nbsp;<button class="fieldset-cls_all">' . _COLLAPSEALL . '</button></p>' . "\n";
    }
    echo "<form action=\"admin.php\" method=\"post\">"
     . "<input type=\"hidden\" name=\"op\" value=\"ConfigSave\">";
    // / Demo-modus 1
    if (!$GLOBALS['show_demo_mode']) {
        echo '<input type="hidden" name="xmxDemoMode" value="' . intval(!empty($mxDemoMode)) . '">'
         . '<input type="hidden" name="xmxDemoAdmins" value="' . ((empty($mxDemoAdmins)) ? '' : implode(',', $mxDemoAdmins)) . '">';
    }
    // / ende Demo-modus 1
    /* ---------------------------------------------------------------------------------------------------------*/
    fieldsetOpen(_SECOPT);
    echo "<table border=\"0\">"
     . "<tr valign=\"top\"><td colspan=\"3\"><b><span style=\"color: #FF0000;\">*</span></b>&nbsp;&nbsp;<span class=\"tiny\">" . _LOGGINWARNING . "</span></td></tr>";
    // / Minimale Passwortlaenge:
    $options = "";
    for ($i = 3; $i <= 12; $i++) {
        $options .= "<option value=\"" . $i . "\"" . (($minpass == $i) ? " selected" : "") . ">" . $i . "</option>\n";
    }
    echo "<tr valign=\"top\"><td>" . _PASSWDLEN . ":</td><td colspan='2'><select name=\"xminpass\">" . $options . "</select></td></tr>";
    // / SQL-Injection Gefahr verringern? (mx-Detection)
    echo "<tr valign=\"top\"><td><span " . ((!$vkpSafeSqlinject) ? 'style="color: #FF0000; font-weight: bold;"' : '') . ">" . _SECSQLINJECT1 . "</span> <span class=\"tiny\">(mx-Detection)</span></td><td colspan=\"2\"><input type=\"radio\" name=\"xvkpSafeSqlinject\" value=\"1\"" . $sel_vkpSafeSqlinject['1'] . ">" . _YES . " &nbsp;"
     . "<input type=\"radio\" name=\"xvkpSafeSqlinject\" value=\"0\"" . $sel_vkpSafeSqlinject['0'] . ">" . _NO . " &nbsp;<span class=\"tiny\">" . _SECSQLINJECT3 . "</span></td>"
     . "</tr>";
    // / Nicht zugelassenen HTML-Code aus uebergabeparametern filtern:
    $options = "";
    for ($i = 0; $i <= 2; $i++) {
        $options .= "<option value=\"" . $i . "\"" . (($mxEntitieLevel == $i) ? " selected" : "") . ">" . constant('_REQHTMLFILTER_' . $i) . "</option>\n";
    }
    echo "<tr valign=\"top\"><td>" . _REQHTMLFILTER . ":</td><td colspan='2'><select name=\"xmxEntitieLevel\">" . $options . "</select> <span class=\"tiny\">[&nbsp;<a href=\"#set-HTML\">" . _HTMLOPT . "</a>&nbsp;]</span></td></tr>";
    // / Gueltigkeit der Session und des Session-Cookies:
    echo "<tr valign=\"top\"><td>" . _SECMEDLENGTH . ":</td><td><input type=\"text\" name=\"xvkpSessLifetime\" value=\"" . $vkpSessLifetime . "\" size=\"4\"> " . _SECDAYS . "</td><td class=\"tiny\">" . _SECDAYS2 . "</td></tr>";
    // / Sicherheitscookie fuer Benutzer verwenden?
    echo "<tr valign=\"top\"><td>" . _SAFECOOKIE1 . "</td><td colspan='2'><input type=\"radio\" name=\"xvkpSafeCookie1\" value=\"1\"" . $sel_vkpSafeCookie1['1'] . ">" . _YES . " &nbsp;"
     . "<input type=\"radio\" name=\"xvkpSafeCookie1\" value=\"0\"" . $sel_vkpSafeCookie1['0'] . ">" . _NO . "&nbsp;&nbsp;<b><span style=\"color: #FF0000;\">*</span></b></td></tr>";
    // / Sicherheitscookie fuer Admins verwenden?
    echo "<tr valign=\"top\"><td>" . _SAFECOOKIE2 . "</td><td colspan='2'><input type=\"radio\" name=\"xvkpSafeCookie2\" value=\"1\"" . $sel_vkpSafeCookie2['1'] . ">" . _YES . " &nbsp;"
     . "<input type=\"radio\" name=\"xvkpSafeCookie2\" value=\"0\"" . $sel_vkpSafeCookie2['0'] . ">" . _NO . "&nbsp;&nbsp;<b><span style=\"color: #FF0000;\">*</span></b></td></tr>";
    // / Registrierung neuer Benutzer
    $regoptions = "";
    // for ($i = 0; $i <= 5; $i++) {
    for ($i = 0; $i <= 4; $i++) {
        $regoptions .= "<option value=\"" . $i . "\" " . (($vkpUserregoption == $i) ? "selected" : "") . ">" . constant("_ADMIN_UREGTYPE_" . $i) . "</option>\n";
    }
    echo "<tr valign=\"top\"><td>" . _ADMIN_USERREGTYPE . "</td><td colspan=\"2\">";
    echo "<select name=\"xvkpUserregoption\">\n" . $regoptions . "</select>\n";
    echo "</td></tr>";
    // / Setze eine Benutzergruppe als Standard
    $curdefgroup = mxGetGroupTitle($default_group);
    $groupoptions = getAllAccessLevelSelectOptions($default_group);
    echo "<tr valign=\"top\"><td>" . _ADMINGROUPDEF . "</td><td>";
    echo "<select name=\"xdefault_group\">" . $groupoptions . "</select> </td><td>" . _ADMINGROUPDEFCUR . ": <b>" . $curdefgroup . "</b>";
    echo "</td></tr>";
    // / Secure-Logging einschalten?
    echo "<tr valign=\"top\"><td>" . _SEC_LOGGING . "</td><td colspan=\"2\"><input type=\"radio\" name=\"xvkpsec_logging\" value=\"1\" " . $sel_sec_logging["1"] . ">" . _YES . " &nbsp;<input type=\"radio\" name=\"xvkpsec_logging\" value=\"0\" " . $sel_sec_logging["0"] . ">" . _NO . "</td></tr>";
    // / Demo-modus 2
    if ($GLOBALS['show_demo_mode']) {
        echo "<tr valign=\"top\"><td>" . _DEMOMODE . "</td><td>";
        echo "<input type=\"radio\" name=\"xmxDemoMode\" value=\"1\"" . ((empty($mxDemoMode)) ? "" : " checked") . ">" . _YES . " &nbsp;";
        echo "<input type=\"radio\" name=\"xmxDemoMode\" value=\"0\"" . ((empty($mxDemoMode)) ? " checked" : "") . ">" . _NO;
        echo "</td></tr>";
        if (mxDemoMode()) {
            $tempadmins = "************,*******,*****";
        } else {
            // den Beispielwert entfernen
            if (isset($mxDemoAdmins)) {
                $key = array_search('sampleadminname', $mxDemoAdmins);
                if (!($key === false)) unset($mxDemoAdmins[$key]);
            } else {
                $mxDemoAdmins = array();
            }
            // den aktuellen admin auf jeden Fall einfuegen, dass er sich nicht selbst aussperrt
            $aaa = mxGetAdminSession();
            if (!in_array($aaa['aid'], $mxDemoAdmins)) $mxDemoAdmins[] = $aaa['aid'];
            $tempadmins = (empty($mxDemoAdmins)) ? '' : implode(',', $mxDemoAdmins);
        }
        echo "<tr valign=\"top\"><td>" . _DEMOMODEADMINS . "</td><td>";
        echo "<input type=\"text\" name=\"xmxDemoAdmins\" size=\"50\" value=\"" . $tempadmins . "\"><br /><span class=\"tiny\">" . _CUTWITHCOMMATA . "</span>";
        echo "</td></tr>";
    }
    // / ende Demo-modus 2
    // / Intranet-Umgebung
    echo "<tr valign=\"top\"><td>" . _INTRANETOPT . "</td><td colspan=\"2\"><input type=\"radio\" name=\"xvkpIntranet\" value=\"1\" " . $sel_intranet["1"] . ">" . _YES . " &nbsp;<input type=\"radio\" name=\"xvkpIntranet\" value=\"0\" " . $sel_intranet["0"] . ">" . _NO . "&nbsp;&nbsp;<b><span style=\"color: #FF0000;\">*</span></b></td></tr>"
     . "<tr valign=\"top\"><td colspan=\"3\"><blockquote><span class=\"tiny\">" . _INTRANETWARNING . "</span></blockquote></td></tr>";
    echo "</table>\n";
    fieldsetClose();

    /* ---------------------------------------------------------------------------------------------------------*/
    fieldsetOpen(_MAILSETTINGS);
    if ($mailauth == 'smtp') {
        $mailoption = "<option value=\"smtp\" selected>" . _MAILAUTH_1 . "</option>\n<option value=\"mail\">" . _MAILAUTH_0 . "</option>\n";
    }
    if ($mailauth == 'mail') {
        $mailoption = "<option value=\"mail\" selected>" . _MAILAUTH_0 . "</option>\n<option value=\"smtp\">" . _MAILAUTH_1 . "</option>\n";
    }
    echo "<table border=\"0\">"
     . "<tr valign=\"top\"><td>" . _MAILAUTH . "</td><td><select name=\"xmailauth\">\n" . $mailoption . "</select></td>\n</tr>"
     . "<tr valign=\"top\"><td>" . _MAILHOST . ":</td><td><input type=\"text\" name=\"xmailhost\" value=\"" . $mailhost . "\" size=\"50\"><br /><span class=\"tiny\">" . _MAILHOST_2 . "</span></td></tr>"
     . "<tr valign=\"top\"><td>" . _MAILUNAME . ":</td><td><input type=\"text\" name=\"xmailuname\" value=\"" . $mailuname . "\" size=\"50\"></td></tr>"
     . "<tr valign=\"top\"><td>" . _MAILPASS . ":</td><td><input type=\"password\" name=\"xmailpass\" value=\"" . $mailpass . "\" size=\"20\"></td></tr>"
     . "<tr valign=\"top\"><td>" . _MAILPORT . ":</td><td><input type=\"text\" name=\"xmailport\" value=\"" . $mailport . "\" size=\"4\">&nbsp;<span class=\"tiny\">" . _MAILPORT_2 . "</span></td></tr>"
    /* if you need POP3 authetntication before SMTP delivery,
	 	* specify the host name here. The smtp_user and smtp_password above
	 	* should set to the POP3 user and password*/
     . "<tr valign=\"top\"><td>" . _MAILPOP3AUTH . ":</td><td><input type=\"text\" name=\"xpopauth\" value=\"" . $popauth . "\" size=\"50\" maxlength=\"200\"></td></tr>"
     . "</table>\n";
    fieldsetClose();

    /* ---------------------------------------------------------------------------------------------------------*/
    fieldsetOpen(_GENSITEINFO);
    echo "<table border=\"0\">"
     . "<tr valign=\"top\"><td>" . _SITENAME . ":</td><td><input type=\"text\" name=\"xsitename\" value=\"" . mxEntityQuotes($sitename) . "\" size=\"50\"></td></tr>"
     . "<tr valign=\"top\"><td>" . _SITESLOGAN . ":</td><td><input type=\"text\" name=\"xslogan\" value=\"" . mxEntityQuotes($slogan) . "\" size=\"50\"></td></tr>"
     . "<tr valign=\"top\"><td>" . _STARTDATE . ":</td><td><input type=\"text\" name=\"xstartdate\" value=\"" . mxEntityQuotes($startdate) . "\" size=\"20\"></td></tr>"
     . "<tr valign=\"top\"><td>" . _ADMINEMAIL . ":</td><td><input type=\"text\" name=\"xadminmail\" value=\"" . mxEntityQuotes($adminmail) . "\" size=30></td></tr>"
     . "<tr valign=\"top\"><td>" . _ANONYMOUSNAME . ":</td><td><input type=\"text\" name=\"xanonymous\" value=\"" . mxEntityQuotes($anonymous) . "\"></td></tr>"
    // ."<tr valign=\"top\"><td>"._DEFAULTTHEME.":</td><td><select name=\"xDefault_Theme\">".$cthemes."</select></td></tr>"
    . "<tr valign=\"top\"><td>" . _SELLANGUAGE . ":</td><td><select name=\"xlanguage\">" . $clanguage . "</select></td></tr>"
     . "<tr valign=\"top\"><td>" . _LOCALEFORMAT . ":</td><td>";
    echo "<select name=\"xlocale\" style=\"font-family: 'Courier New', Courier, monospace;\">\n";
    $sel_loclanguage[$GLOBALS['locale']] = ' selected';
    $loclang = localelanguagelist();
    foreach ($loclang as $k => $v) {
        $sel = (isset($sel_loclanguage[$k])) ? " selected" : "";
        echo "<option value=\"" . $k . "\"$sel>$v</option>\n\n";
    }
    echo "</select>&nbsp;&nbsp;<span class=\"tiny\">" . _DATESAMPLE . ": " . mx_strftime(_DATESTRING, time()) . "</span></td></tr>"
     . "<tr valign='top'><td>" . _KEYWORD_TXT . "<br /><br /><span class=\"tiny\">" . _CUTWITHCOMMATA . "</span></td><td>"
     . "<textarea name=\"xmetakeywords\" cols=\"50\" rows=\"5\">" . htmlentities($metakeywords) . "</textarea>"
     . "</td></tr>";
    echo "<tr valign=\"top\"><td>" . 'Google meta tag verification' . "</td><td colspan=\"2\">"
     . "<input type=\"text\" name=\"xmxGoogleMetaVeri\" value=\"" . ((empty($mxGoogleMetaVeri)) ? '' : mxEntityQuotes($mxGoogleMetaVeri)) . "\" size=\"50\">"
     . "</td></tr>";

    echo "</table>\n";
    fieldsetClose();

    /* ---------------------------------------------------------------------------------------------------------*/
    fieldsetOpen(_GRAPHICOPT);
    echo "<table border=\"0\">"
     . "<tr valign=\"top\"><td>" . _DEFAULTTHEME . ":</td><td><select name=\"xDefault_Theme\">" . $cthemes . "</select></td></tr>"
     . "<tr valign=\"top\"><td>" . _BLOCKSHOW_RIGHT . ":</td><td><select name=\"xvkpBlocksRight\">" . $blockoptions1 . "</select></td></tr>";

    echo "<tr valign=\"top\"><td>" . _ADMINPANEL . "</td><td>";
    if ($adminpanel == 1) {
        echo "<input type=\"radio\" name=\"xadminpanel\" value=\"1\" checked>" . _YES . " &nbsp;<input type=\"radio\" name=\"xadminpanel\" value=\"0\">" . _NO;
    } else {
        echo "<input type=\"radio\" name=\"xadminpanel\" value=\"1\">" . _YES . " &nbsp;<input type=\"radio\" name=\"xadminpanel\" value=\"0\" checked>" . _NO;
    }

    echo "<tr valign=\"top\"><td>" . _ADMINGRAPHIC . "</td><td>";
    if ($admingraphic == 1) {
        echo "<input type=\"radio\" name=\"xadmingraphic\" value=\"1\" checked>" . _YES . " &nbsp;<input type=\"radio\" name=\"xadmingraphic\" value=\"0\">" . _NO;
    } else {
        echo "<input type=\"radio\" name=\"xadmingraphic\" value=\"1\">" . _YES . " &nbsp;<input type=\"radio\" name=\"xadmingraphic\" value=\"0\" checked>" . _NO;
    }
    echo "<tr valign=\"top\"><td>" . _ACTBANNERS . "</td><td>";
    if ($banners == 1) {
        echo "<input type=\"radio\" name=\"xbanners\" value=\"1\" checked>" . _YES . " &nbsp;<input type=\"radio\" name=\"xbanners\" value=\"0\">" . _NO;
    } else {
        echo "<input type=\"radio\" name=\"xbanners\" value=\"1\">" . _YES . " &nbsp;<input type=\"radio\" name=\"xbanners\" value=\"0\" checked>" . _NO;
    }
    echo "</td></tr></table>\n";
    fieldsetClose();

    /* ---------------------------------------------------------------------------------------------------------*/
    fieldsetOpen(_NEWSMODULE);
    echo "<table border=\"0\">";
    $options = "";
    for ($i = 1; $i <= 30; $i++) {
        $options .= "<option value=\"" . $i . "\"" . (($storyhome == $i) ? " selected" : "") . ">" . $i . "</option>\n";
    }
    echo "<tr valign=\"top\"><td>" . _STORIESHOME . ":</td><td><select name=\"xstoryhome\">" . $options . "</select></td></tr>";
    $options = "";
    for ($i = 1; $i <= 5; $i++) {
        $options .= "<option value=\"" . $i . "\"" . (($storyhome_cols == $i) ? " selected" : "") . ">" . $i . "&nbsp;</option>\n";
    }
    echo "<tr valign=\"top\"><td>" . _STORIESHOMECOLS . ":</td><td><select name=\"xstoryhome_cols\">" . $options . "</select></td></tr>";
    $options = "";
    for ($i = 5; $i <= 30; $i++) {
        $options .= "<option value=\"" . $i . "\"" . (($top == $i) ? " selected" : "") . ">" . $i . "</option>\n";
    }
    echo "<tr valign=\"top\"><td>" . _ITEMSTOP . ":</td><td><select name=\"xtop\">" . $options . "</select></td></tr>";
    $options = "";
    for ($i = 5; $i <= 30; $i++) {
        $options .= "<option value=\"" . $i . "\"" . (($oldnum == $i) ? " selected" : "") . ">" . $i . "</option>\n";
    }
    echo "<tr valign=\"top\"><td>" . _OLDSTORIES . ":</td><td><select name=\"xoldnum\">" . $options . "</select></td></tr>"

     . "<tr valign=\"top\"><td rowspan=\"2\">" . _SITELOGO . ":</td><td>images/<input type=\"text\" name=\"xsite_logo\" value=\"" . mxEntityQuotes($site_logo) . "\" size=\"30\" maxlength=\"100\"></td></tr>"
     . "<tr><td>" . mxCreateImage('images/' . $site_logo) . "</td></tr>"

     . "<tr valign=\"top\"><td>" . _NOTIFYSUBMISSION . "</td><td>";
    if ($notify == 1) {
        echo "<input type=\"radio\" name=\"xnotify\" value=\"1\" checked>" . _YES . " &nbsp;<input type=\"radio\" name=\"xnotify\" value=\"0\">" . _NO;
    } else {
        echo "<input type=\"radio\" name=\"xnotify\" value=\"1\">" . _YES . " &nbsp;<input type=\"radio\" name=\"xnotify\" value=\"0\" checked>" . _NO;
    }
    echo "</td></tr>"
     . "<tr valign=\"top\"><td>" . _EMAIL2SENDMSG . ":</td><td><input type=\"text\" name=\"xnotify_email\" value=\"" . mxEntityQuotes($notify_email) . "\" size=\"40\" maxlength=\"100\"></td></tr>"
     . "<tr valign=\"top\"><td>" . _EMAILSUBJECT . ":</td><td><input type=\"text\" name=\"xnotify_subject\" value=\"" . mxEntityQuotes($notify_subject) . "\" size=\"40\" maxlength=\"100\"></td></tr>"
     . "<tr valign=\"top\"><td>" . _EMAILMSG . ":</td><td><textarea name=\"xnotify_message\" cols=\"40\" rows=\"4\">" . htmlentities($notify_message) . "</textarea></td></tr>"
     . "<tr valign=\"top\"><td>" . _EMAILFROM . ":</td><td><input type=\"text\" name=\"xnotify_from\" value=\"$notify_from\" size=\"40\" maxlength=\"100\"></td></tr>"
     . "</table>\n";
    fieldsetClose();

    /* ---------------------------------------------------------------------------------------------------------*/
    fieldsetOpen(_MULTILINGUALOPT);
    echo "<table border=\"0\">"
     . "<tr valign=\"top\"><td>" . _ACTMULTILINGUAL . "</td><td>";
    if ($multilingual == 1) {
        echo "<input type=\"radio\" name=\"xmultilingual\" value=\"1\" checked>" . _YES . " &nbsp;<input type=\"radio\" name=\"xmultilingual\" value=\"0\">" . _NO;
    } else {
        echo "<input type=\"radio\" name=\"xmultilingual\" value=\"1\">" . _YES . " &nbsp;<input type=\"radio\" name=\"xmultilingual\" value=\"0\" checked>" . _NO;
    }
    echo "</td></tr>"
     . "<tr valign=\"top\"><td>" . _ACTUSEFLAGS . "</td><td>";
    if ($useflags == 1) {
        echo "<input type=\"radio\" name=\"xuseflags\" value=\"1\" checked>" . _YES . " &nbsp;<input type=\"radio\" name=\"xuseflags\" value=\"0\">" . _NO;
    } else {
        echo "<input type=\"radio\" name=\"xuseflags\" value=\"1\">" . _YES . " &nbsp;<input type=\"radio\" name=\"xuseflags\" value=\"0\" checked>" . _NO;
    }
    echo "</td></tr></table>\n";
    fieldsetClose();

    /* ---------------------------------------------------------------------------------------------------------*/
    fieldsetOpen(_FOOTERMSG);
    echo "<table border=\"0\">"
     . "<tr valign=\"top\"><td>" . _FOOTERLINE1 . ":</td><td><textarea name=\"xfoot1\" cols=\"50\" rows=\"3\">" . trim($foot1) . "</textarea></td></tr>"
     . "<tr valign=\"top\"><td>" . _FOOTERLINE2 . ":</td><td><textarea name=\"xfoot2\" cols=\"50\" rows=\"3\">" . trim($foot2) . "</textarea></td></tr>"
     . "<tr valign=\"top\"><td>" . _FOOTERLINE3 . ":</td><td><textarea name=\"xfoot3\" cols=\"50\" rows=\"3\">" . trim((isset($foot3)) ? $foot3 : '') . "</textarea></td></tr>"
     . "<tr valign=\"top\"><td>" . _FOOTERLINE4 . ":</td><td><textarea name=\"xfoot4\" cols=\"50\" rows=\"3\">" . trim((isset($foot4)) ? $foot4 : '') . "</textarea></td></tr>"
     . "<tr valign=\"top\"><td colspan=\"2\"><br /><span class=\"tiny\">" . _ADMIN_FOOTCONSTMSG . "</span></td></tr>"
     . "</table>\n";
    fieldsetClose();

    /* ---------------------------------------------------------------------------------------------------------*/
    fieldsetOpen(_BACKENDCONF);

    ?>
	<table border="0">
		<tr valign="top">
			<td><?php echo _BACKENDACTIVE ?>:</td>
			<td>
				<input type="radio" name="xbackend_active" value="1" <?php echo ((!empty($backend_active)) ? " checked" : "") ?> /><?php echo _YES ?>&nbsp;
				<input type="radio" name="xbackend_active" value="0" <?php echo ((empty($backend_active)) ? " checked" : "") ?> /><?php echo _NO ?>
			</td>
		</tr>
      	<tr valign="top">
			<td><?php echo _BACKENDTITLE ?>:</td>
			<td>
				<input type="text" name="xbackend_title" value="<?php echo mxEntityQuotes($backend_title) ?>" size="40" maxlength="100" />
			</td>
		</tr>
		<tr valign="top">
			<td rowspan="2"><?php echo _BACKENDLOGOURL1 ?>:</td>
			<td>
				<table border="0" cellspacing="0" cellpadding="0" width="100%">
					<tr>
						<td><input type="text" name="xbackend_logo" value="<?php echo ((empty($backend_logo)) ? htmlentities('images/' . $site_logo) : htmlentities($backend_logo)) ?>" size="30" maxlength="100" /></td>
					</tr>
					<tr>
						<td><span class="tiny"><?php echo _BACKENDLOGOURL2 ?></span></td>
					</tr>
				</table>
			</td>
		</tr>
		<tr>
			<td><?php echo mxCreateImage(((empty($backend_logo)) ? 'images/' . $site_logo : $backend_logo)) ?></td>
		</tr>
		<tr valign="top">
			<td><?php echo _BACKENDLANG ?>:</td>
			<td>
				<select name="xbackend_language" size="1">
				<?php
    $sel_backendlanguage[$GLOBALS['backend_language']] = ' selected';
    $rsslang = rsslanguagelist();
    foreach ($rsslang as $k => $v) {
        $sel = (isset($sel_backendlanguage[$k])) ? " selected" : "";
        echo "<option value=\"" . $k . "\"$sel>[$k] $v</option>\n\n";
    }

    ?>
				</select>
			</td>
		</tr>
	</table>
	<table border="0">
		<tr>
			<td colspan="3"><?php echo _BACKENDOVERMSG ?></td>
		</tr>
		<tr valign="top">
			<td><?php echo _BACKENDLIMIT1 ?>:</td>
			<td>
				<input type="text" name="xbackend_limit" value="<?php echo ((empty($backend_limit) || $backend_limit > 15) ? 15 : intval($backend_limit)) ?>" size="3" maxlength="2" />
			</td>
			<td><?php echo _MAXIMALCHAR ?>&nbsp;&nbsp;&nbsp;15!</td>
		</tr>
		<tr valign="top">
			<td><?php echo _BACKENDRSSDESCRLEN ?>:</td>
			<td>
				<input type="text" name="xbackend_rssdecriptiontrunk" value="<?php echo ((empty($backend_rssdecriptiontrunk) || $backend_rssdecriptiontrunk > 255) ? 30 : intval($backend_rssdecriptiontrunk)) ?>" size="3" maxlength="3" />
			</td>
			<td><?php echo _MAXIMALCHAR ?> 255!</td>
		</tr>
		<tr valign="top">
			<td><?php echo _BACKENDIMGDESCRLEN ?>:</td>
			<td>
				<input type="text" name="xbackend_imagedescriptiontrunk" value="<?php echo ((empty($backend_imagedescriptiontrunk) || $backend_imagedescriptiontrunk > 255) ? 30 : intval($backend_imagedescriptiontrunk)) ?>" size="3" maxlength="3" />
			</td>
			<td><?php echo _MAXIMALCHAR ?> 255!</td>
		</tr>
		<tr valign="top">
			<td><?php echo _BACKENDITEMDESCRLEN ?>:</td>
			<td>
				<input type="text" name="xbackend_itemdescriptiontrunk" value="<?php echo ((empty($backend_itemdescriptiontrunk) || $backend_itemdescriptiontrunk > 255) ? 30 : intval($backend_itemdescriptiontrunk)) ?>" size="3" maxlength="3" />
			</td>
			<td><?php echo _MAXIMALCHAR ?> 255!</td>
		</tr>
    </table>
	<?php
    fieldsetClose();

    /* ---------------------------------------------------------------------------------------------------------*/
    fieldsetOpen(_MISCOPT);
    echo "<table border=\"0\">";

    if (@is_file('includes/mx_modrewrite.php')) {
        echo "<tr valign=\"top\"><td>" . _USEMODREWRITE . "</td><td colspan=\"2\">";
        if (!@file_exists('.htaccess')) {
            $rewwarn = _PROMODREWERROR1 . '<br />';
        } else {
            $htacc = file_get_contents('.htaccess');
            if (!preg_match('!(RewriteEngine\s+on).*(\sRewriteRule\s)!si', $htacc)) {
                $rewwarn = _PROMODREWERROR2 . '<br />';
            }
        }
        if (isset($rewwarn)) {
            echo '<b>' . _PROMODREWERROR . '</b><br />' . $rewwarn;
        } else {
            echo '<input type="checkbox" name="xmxUseModrewrite[anony]" value="1"' . ((empty($mxUseModrewrite['anony'])) ? "" : " checked") . '>' . _PROMODREWANON . '<br />';
            echo '<input type="checkbox" name="xmxUseModrewrite[users]" value="1"' . ((empty($mxUseModrewrite['users'])) ? "" : " checked") . '>' . _PROMODREWUSERS . '<br />';
            echo '<input type="checkbox" name="xmxUseModrewrite[admin]" value="1"' . ((empty($mxUseModrewrite['admin'])) ? "" : " checked") . '>' . _PROMODREWADMIN . '';
        }
        echo "</td></tr>";
    }

    if (@is_file("includes/jpcache/mx_jpcache.php")) {
        echo "<tr valign=\"top\"><td>" . _JPCACHEUSE1A . "</td><td>"
         . "<input type=\"radio\" name=\"xmxJpCacheUse\" value=\"1\"" . ((!empty($mxJpCacheUse)) ? " checked" : "") . ">" . _YES . " &nbsp;<input type=\"radio\" name=\"xmxJpCacheUse\" value=\"0\"" . ((empty($mxJpCacheUse)) ? " checked" : "") . ">" . _NO . "
		</td><td>" . _JPCACHEUSE1B . "</td></tr>";
        echo "<tr valign=\"top\"><td>" . _JPCACHEUSE2A . "</td><td colspan=\"2\"><input type=\"text\" name=\"xmxJpCacheTimeout\" value=\"" . ((empty($mxJpCacheTimeout)) ? MX_SETINACTIVE_MINS : $mxJpCacheTimeout) . "\" size=\"5\" maxlength=\"4\">&nbsp;" . _JPCACHEUSE2B . "</td></tr>";
    }

    if (extension_loaded("zlib") && (!mxIniGet("zlib.output_compression")) && (mxIniGet('output_handler') != 'ob_gzhandler')) {
        echo "<tr valign=\"top\"><td>" . _GZIPCOMPRESS . "</td><td colspan=\"2\">"
         . "<input type=\"radio\" name=\"xmxUseGzipCompression\" value=\"1\"" . ((!empty($mxUseGzipCompression)) ? " checked" : "") . ">" . _YES . " &nbsp;<input type=\"radio\" name=\"xmxUseGzipCompression\" value=\"0\"" . ((empty($mxUseGzipCompression)) ? " checked" : "") . ">" . _NO . ""
         . "</td></tr>";
    }

    $options = "";
    for ($i = 0; $i <= 3000;) {
        $options .= "<option value=\"" . $i . "\"" . (($httprefmax == $i) ? " selected" : "") . ">" . $i . "</option>\n";
        $i = ($i < 1000) ? $i + 50 : $i + 500;
    }
    echo "<tr valign=\"top\"><td>" . _MAXREF . "</td><td><select name=\"xhttprefmax\">" . $options . "</select></td><td><span class=\"tiny\">" . _ADMIN_NOREFS . "</span></td></tr>";

    echo "<tr valign=\"top\"><td>";
    echo _TRACK_ACTIVATEIT . "?</td><td colspan=\"2\">";
    if ($vkpTracking == 1) {
        echo "<input type=\"radio\" name=\"xvkpTracking\" value=\"1\" checked>" . _YES . " &nbsp;<input type=\"radio\" name=\"xvkpTracking\" value=\"0\">" . _NO;
    } else {
        echo "<input type=\"radio\" name=\"xvkpTracking\" value=\"1\">" . _YES . " &nbsp;<input type=\"radio\" name=\"xvkpTracking\" value=\"0\" checked>" . _NO;
    }
    echo "</td></tr>";

    echo "<tr valign=\"top\"><td>" . _SECINACTIVELENGTH . ":</td><td colspan=\"2\">" . _ADMIN_POPTIME1 . "<input type=\"text\" name=\"xvkpInactiveMins\" value=\"" . $vkpInactiveMins . "\" size=\"5\"> " . _SECMINUTES . "</td></tr>";
    echo "<tr valign=\"top\"><td>" . _ADMIN_POPTIME . ":</td><td>" . _ADMIN_POPTIME1 . " <input type='text' name='xpm_poptime' value='" . $pm_poptime . "' size='5'> " . _ADMIN_POPTIME2 . "</td><td><span class=\"tiny\">" . _ADMIN_NOREFS . "</span></td></tr>";
    echo "<tr valign=\"top\"><td>" . _SHOWPRAGMANEWS . "</td><td colspan=\"2\"><input type=\"radio\" name=\"xmxShowPragmaMxNews\" value=\"1\"" . ((!empty($mxShowPragmaMxNews)) ? " checked" : "") . ">" . _YES . " &nbsp;<input type=\"radio\" name=\"xmxShowPragmaMxNews\" value=\"0\"" . ((empty($mxShowPragmaMxNews)) ? " checked" : "") . ">" . _NO . "</td></tr>";
    // / Kompatibilitaet fuer phpNuke-Module abschalten?
    echo "<tr valign=\"top\"><td>" . _ADMIN_NUKECOMPATIBLE . "</td><td colspan='2'><input type=\"radio\" name=\"xmxDeactNukeCompatible\" value=\"1\"" . $sel_mxDeactNukeCompatible['1'] . ">" . _YES . " &nbsp;"
     . "<input type=\"radio\" name=\"xmxDeactNukeCompatible\" value=\"0\"" . $sel_mxDeactNukeCompatible['0'] . ">" . _NO . "</td></tr>";
    // / Cookies fuer phpNuke-Module erstellen?
    echo "<tr valign=\"top\"><td>" . _ADMIN_NUKECOOKIE . "</td><td colspan='2'><input type=\"radio\" name=\"xmxCreateNukeCookie\" value=\"1\"" . $sel_mxCreateNukeCookie['1'] . ">" . _YES . " &nbsp;"
     . "<input type=\"radio\" name=\"xmxCreateNukeCookie\" value=\"0\"" . $sel_mxCreateNukeCookie['0'] . ">" . _NO . "</td></tr>";

    echo "</table>\n";
    fieldsetClose();

    /* ---------------------------------------------------------------------------------------------------------*/
    fieldsetOpen(_COMMENTSOPT);
    // Kommentar-Einstellungen
    echo '<table border="0">'
     . '<tr valign="top">'
     . '<td>' . _ALLOWANONPOST . ' </td>'
     . '<td>'
     . '<input type="radio" name="xanonpost" value="1"' . ((!empty($anonpost)) ? ' checked="checked"' : '') . '>' . _YES . ' &nbsp;'
     . '<input type="radio" name="xanonpost" value="0"' . ((empty($anonpost)) ? ' checked="checked"' : '') . '>' . _NO
     . '</td>'
     . '</tr>';
    echo '<tr valign="top">'
     . '<td>' . _COMMENTSLIMIT . ':</td>'
     . '<td><input type="text" name="xcommentlimit" value="' . $commentlimit . '" size="11" maxlength="10">'
     . '</td>'
     . '</tr>';
    echo '<tr valign="top">'
     . '<td>' . _COMMENTSPOLLS . '</td>'
     . '<td>'
     . '<input type="radio" name="xpollcomm" value="1"' . (($pollcomm == 1) ? ' checked="checked"' : '') . '>' . _YES . '<br />'
     . '<input type="radio" name="xpollcomm" value="2"' . (($pollcomm == 2) ? ' checked="checked"' : '') . '>' . _COMMSCHOWONLY . '<br>'
     . '<input type="radio" name="xpollcomm" value="0"' . ((empty($pollcomm)) ? ' checked="checked"' : '') . '>' . _NO
     . '</td>'
     . '</tr>';
    echo '<tr valign="top">'
     . '<td>' . _COMMENTSARTICLES . '</td>'
     . '<td>'
     . '<input type="radio" name="xarticlecomm" value="1"' . (($articlecomm == 1) ? ' checked="checked"' : '') . '>' . _YES . '<br />'
     . '<input type="radio" name="xarticlecomm" value="2"' . (($articlecomm == 2) ? ' checked="checked"' : '') . '>' . _COMMSCHOWONLY . '<br />'
     . '<input type="radio" name="xarticlecomm" value="0"' . ((empty($articlecomm)) ? ' checked="checked"' : '') . '>' . _NO
     . '</td>'
     . '</tr>'
     . '</table>' . "\n";
    fieldsetClose();

    /* ---------------------------------------------------------------------------------------------------------*/
    fieldsetOpen(_CENSOROPTIONS);
    // Zensuroptionen
    $censorstring = implode(", ", $CensorList);
    $CensorMode = (empty($CensorMode)) ? 0 : $CensorMode;
    $sel0 = (empty($CensorMode)) ? "selected" : "";
    $sel1 = ($CensorMode == 1) ? "selected" : "";
    $sel2 = ($CensorMode == 2) ? "selected" : "";
    $sel3 = ($CensorMode == 3) ? "selected" : "";
    $CensorReplace = (empty($CensorReplace)) ? "*****" : $CensorReplace;
    $censorusers = implode(", ", $CensorListUsers);
    echo "<table border=\"0\">"
     . "<tr valign=\"top\"><td>" . _CENSORMODEWORDS . ":</td><td><textarea name=\"xCensorstring\" cols=\"50\" rows=\"5\">" . htmlentities($censorstring) . "</textarea><br /><span class=\"tiny\">" . _CUTWITHCOMMATA . "</span></td></tr>"
     . "<tr valign=\"top\"><td>" . _CENSORMODE . ":</td><td><select name=\"xCensorMode\">"
     . "<option value=\"0\" $sel0>" . _NOFILTERING . "</option>\n"
     . "<option value=\"1\" $sel1>" . _EXACTMATCH . "</option>\n"
     . "<option value=\"2\" $sel2>" . _MATCHBEG . "</option>\n"
     . "<option value=\"3\" $sel3>" . _MATCHANY . "</option>\n"
     . "</select></td></tr>"
     . "<tr valign=\"top\"><td>" . _CENSORREPLACE . ":</td><td><input type=\"text\" name=\"xCensorReplace\" value=\"" . mxEntityQuotes($CensorReplace) . "\" size=\"20\" maxlength=\"20\"></td></tr>";
    /**
     * Ausgelagert in -setban.php-
     */
    echo "<tr valign=\"top\"><td>" . _CENSORUSERNAMES . ":</td><td>- <a href=\"admin.php?op=ConfigureBan\" target=\"_blank\"><em>" . _CLCKHERE . "</em></a> -"
     . "<input type=\"hidden\" name=\"xCensorListUsers\" value=\"" . ($censorusers) . "\"></td></tr>";
    /**
     * Ende Kompatibilitaet -setban.php-
     */
    echo "</table>\n";
    // $CensorReplace:        String to replace bad words
    // //////////////////////////////
    fieldsetClose();

    /* ---------------------------------------------------------------------------------------------------------*/
    fieldsetOpen(_HTMLOPT);
    // DOCTYPE, http://carsten-protsch.de/zwischennetz/doctype/einleitung.html
    $options = array();
    foreach($doctype_array as $key => $var) {
        $options[] = '<option value="' . $key . '" ' . (($DOCTYPE == $key) ? 'selected="selected"' : '') . '>' . $var['name'] . '</option>';
    }
    // Allowed HTML
    $i = 0;
    $htmltags = settingsGetHTMLTags();
    $currenthtmltags = $GLOBALS['AllowableHTML'];
    $i2 = ceil(count($htmltags) / 2) + 1;
    echo "<table border=\"0\">"
     . "<tr valign=\"top\"><td><a name=\"set-HTML\" id=\"set-HTML\">&nbsp;</a>" . _SITEDOCTYPE . ":</td><td><select name=\"xDOCTYPE\">" . implode("\n", $options) . "</select></td></tr>";
    if ($tidy_available) {
        echo "<tr valign=\"top\"><td>&nbsp;" . _USEHTMLTIDY . ":</td><td>
        <input type=\"radio\" name=\"xTidyOutput\" value=\"1\"" . (($TidyOutput == 1) ? ' checked="checked"' : '') . ">" . _YES . " &nbsp;
        <input type=\"radio\" name=\"xTidyOutput\" value=\"0\"" . (($TidyOutput == 0) ? ' checked="checked"' : '') . ">" . _NO . "</td></tr>";
    }
    echo "</table>\n";
    echo '<h3 class="title" align="center">' . _HTMLALLOWED . '</h3>' . "\n";
    echo "<table border=\"0\" width=\"100%\">\n";
    echo "<tr valign=\"top\"><td>";
    foreach ($htmltags as $htmltag) {
        $i ++;
        if ($i == 1 || $i == $i2) {
            if ($i == $i2) {
                echo "</table></td><td>";
            }
            echo '<table border="0" cellspacing="1" cellpadding="3" width="100%">'
             . '<tr style="background-color:' . $GLOBALS['bgcolor2'] . '">'
             . '<th style="width:25%;">' . _HTMLTAGNAME . '</th>'
             . '<th style="text-align:center;"><img src="images/allowed.gif" border="0" title="' . _HTMLTAGALLOWED . '"    alt="" /></th>'
             . '<th style="text-align:center;"><img src="images/allowed-plus.gif" border="0" title="' . _HTMLTAGALLOWEDWITHPARAMS . '"    alt="" /></th>'
             . '<th style="text-align:center;"><img src="images/notallowed.gif" border="0" title="' . _HTMLTAGNOTALLOWED . '"    alt="" /></th>'
             . '</tr>';
        }
        $selected[0] = '';
        $selected[1] = '';
        $selected[2] = '';
        $bold_a = '';
        $bold_e = '';
        if (isset($currenthtmltags[$htmltag])) {
            $selected[$currenthtmltags[$htmltag]] = 'checked';
            $bold_a = '<b>';
            $bold_e = '</b>';
        } else {
            $selected[0] = 'checked';
        }
        echo '<tr style="background-color:' . $GLOBALS['bgcolor3'] . '">';
        echo '<td>' . $bold_a . '&lt;' . htmlentities($htmltag) . '&gt;' . $bold_e . '</td>';
        echo '<td align="center"><input type=radio value="1" name="htmlallow' . htmlentities($htmltag) . 'tag" ' . $selected[1] . '></td>';
        echo '<td align="center"><input type=radio value="2" name="htmlallow' . htmlentities($htmltag) . 'tag" ' . $selected[2] . '></td>';
        echo '<td align="center"><input type=radio value="0" name="htmlallow' . htmlentities($htmltag) . 'tag" ' . $selected[0] . '></td>';
        echo '</tr>';
    }

    echo '</table>';
    echo "</td></tr>"
     . "</table>\n";
    echo '<blockquote><font class="content"><b> ' . _HTMLWARNING . '</b></font></blockquote>
    <span style="color: ' . $GLOBALS['textcolor1'] . '; background-color: ' . $GLOBALS['bgcolor2'] . '">
    <input type="checkbox" name="do_html_opt_reset" value="1" />&nbsp;' . _HTMLOPTRESET . '</span>';
    // /////////////////////////////////
    // SiteService + DebugService
    fieldsetClose();

    /* ---------------------------------------------------------------------------------------------------------*/
    fieldsetOpen(_SETSERVICE);
    echo "<table border=\"0\">";
    echo "<tr valign=\"top\"><td>" . _SITESERVICE . "</td><td>"
     . "<input type=\"radio\" name=\"xmxSiteService\" value=\"1\"" . ((!empty($mxSiteService)) ? " checked" : "") . ">" . _YES . " &nbsp;<input type=\"radio\" name=\"xmxSiteService\" value=\"0\"" . ((empty($mxSiteService)) ? " checked" : "") . ">" . _NO . ""
     . "</td></tr>";

    echo "<tr valign=\"top\"><td>" . _SITESERVICETEXT . ":</td><td><textarea name=\"xmxSiteServiceText\" cols=\"50\" rows=\"5\">" . htmlentities($mxSiteServiceText) . "</textarea></td></tr>";
    // _DEACTHEMECACHEDES
    echo "<tr valign=\"top\"><td>" . _DEACTHEMECACHE . "</td><td>" // ACHTUNG!! umgekehrte Frage !!
    . "<input type=\"radio\" name=\"xmxUseThemecache\" value=\"0\"" . ((empty($mxUseThemecache)) ? " checked" : "") . ">" . _YES . " &nbsp;<input type=\"radio\" name=\"xmxUseThemecache\" value=\"1\"" . ((!empty($mxUseThemecache)) ? " checked" : "") . ">" . _NO . ""
     . "</td></tr>";

    echo "<tr valign=\"top\"><td>" . _SITEDEBUG . "</td><td>"
     . "<input type=\"radio\" name=\"xmxDebugService\" value=\"1\"" . ((!empty($mxDebugService)) ? " checked" : "") . ">" . _YES . " &nbsp;<input type=\"radio\" name=\"xmxDebugService\" value=\"0\"" . ((empty($mxDebugService)) ? " checked" : "") . ">" . _NO . ""
     . "</td></tr>";

    echo "<tr valign=\"top\"><td>" . _SHOWSQLERRORS . "</td><td>"
     . "<input type=\"radio\" name=\"xmxSqlErrorDebug\" value=\"1\"" . ((!empty($mxSqlErrorDebug)) ? " checked" : "") . ">" . _YES . " &nbsp;<input type=\"radio\" name=\"xmxSqlErrorDebug\" value=\"0\"" . ((empty($mxSqlErrorDebug)) ? " checked" : "") . ">" . _NO . ""
     . "</td></tr>";

    echo "<tr valign=\"top\"><td>" . _SHOWSQLQUERIES . "</td><td>"
     . "<input type=\"radio\" name=\"xmxSqlDebug\" value=\"1\"" . ((!empty($mxSqlDebug)) ? " checked" : "") . ">" . _YES . " &nbsp;<input type=\"radio\" name=\"xmxSqlDebug\" value=\"0\"" . ((empty($mxSqlDebug)) ? " checked" : "") . ">" . _NO . ""
     . "</td></tr>";
    echo "</table>\n";
    if (function_exists('mxpro_configure')) mxpro_configure();
    fieldsetClose();

    /* ---------------------------------------------------------------------------------------------------------*/
    fieldsetOpen(_DBSETTINGS);
    $dbhost = (empty($GLOBALS["mxDemoMode"])) ? $dbhost : _DBSERVER;
    $dbuname = (empty($GLOBALS["mxDemoMode"])) ? $dbuname : _DBUSERNAME;
    $dbpass = (empty($GLOBALS["mxDemoMode"])) ? $dbpass : _DBPASS;
    $dbname = (empty($GLOBALS["mxDemoMode"])) ? $dbname : _DBNAME;
    $prefix = (empty($GLOBALS["mxDemoMode"])) ? $prefix : _PREFIX;
    $user_prefix = (empty($GLOBALS["mxDemoMode"])) ? $user_prefix : _USERPREFIX;
    $dbpassclick = (empty($GLOBALS["mxDemoMode"])) ? "&nbsp;<a href=\"#\" onClick=\"alert('" . $dbpass . "'); return false;\">click</a>" : '';
    echo "<table border=\"0\">"
     . "<tr valign=\"top\"><td>" . _DBSERVER . "</td><td><input type=\"text\" name=\"xdbhost\" readonly value=\"" . $dbhost . "\" size=\"50\" maxlength=\"100\"></td></tr>"
     . "<tr valign=\"top\"><td>" . _DBUSERNAME . "</td><td><input type=\"text\" name=\"xdbuname\" readonly value=\"" . $dbuname . "\" size=\"50\" maxlength=\"200\"></td></tr>"
     . "<tr valign=\"top\"><td>" . _DBPASS . "</td><td><input type=\"password\" name=\"xdbpass\" readonly value=\"" . $dbpass . "\" size=\"20\" maxlength=\"25\">" . $dbpassclick . "</td></tr>"
     . "<tr valign=\"top\"><td>" . _DBNAME . "</td><td><input type=\"text\" name=\"xdbname\" readonly value=\"" . $dbname . "\" size=\"50\" maxlength=\"100\"></td></tr>"
     . "<tr valign=\"top\"><td>" . _PREFIX . "</td><td><input type=\"text\" name=\"xprefix\" readonly value=\"" . $prefix . "\" size=\"20\" maxlength=\"30\"></td></tr>"
     . "<tr valign=\"top\"><td>" . _USERPREFIX . "</td><td><input type=\"text\" name=\"xuser_prefix\" readonly value=\"" . $user_prefix . "\" size=30 maxlength=100></td></tr>"
     . "</table>\n";
    fieldsetClose(false);

    /* ---------------------------------------------------------------------------------------------------------*/

    echo "</form>";
    echo "</div>\n"; // </slidetoggle>
    // Browserweiche
    // in einigen mx-Themes verschwindet beim Opera der untere Bereich teilweise im footer
    if (preg_match("/Opera/i", getenv("HTTP_USER_AGENT"))) {
        echo '<div><img src="images/pix.gif" style="border:0; width:1px; height:80px" alt="" /></div>';
    }
    CloseTable();
    include ("footer.php");
}

function ConfigSave($pvs)
{
    global $aid;

    $allowedhtml = array();
    if (isset($pvs['do_html_opt_reset'])) {
        // -- Auf Standard zuruecksetzen ??
        // diese Zeile stammt 1:1 aus der /setup/includes/config.first.php
        // und muss mit dieser abgegelichen werden !!!
        $mxConf['AllowableHTML'] = array("a" => 2, "address" => 1, "b" => 1, "big" => 1, "blockquote" => 1, "br" => 1, "center" => 1, "dir" => 1, "font" => 2, "hr" => 1, "i" => 1, "img" => 2, "li" => 1, "ol" => 1, "p" => 1, "pre" => 1, "s" => 1, "small" => 1, "strike" => 1, "strong" => 1, "tt" => 1, "u" => 1, "ul" => 1);
        foreach ($mxConf['AllowableHTML'] as $key => $value) {
            $allowedhtml[] = "\"$key\"=>$value";
        }
    } else {
        $htmltags = settingsGetHTMLTags();
        foreach ($htmltags as $htmltag) {
            $tagval = mxStripSlashes($pvs['htmlallow' . $htmltag . 'tag']);
            unset($pvs['htmlallow' . $htmltag . 'tag']);
            if (($tagval != 1) && ($tagval != 2)) {
                $tagval = 0;
            }
            if (($tagval == 1) || ($tagval == 2)) {
                $allowedhtml[] = "\"$htmltag\"=>$tagval";
            }
        }
    }
    $newAllowableHTML = implode(",", $allowedhtml);
    $newAllowableHTML = "array(" . $newAllowableHTML . ")";

    include ("config.php");
    extract($pvs);
    $xvkpSessLifetime = (empty($xvkpSessLifetime)) ? 0 : $xvkpSessLifetime ;
    $xvkpInactiveMins = (empty($xvkpInactiveMins)) ? 10 : $xvkpInactiveMins;
    $xvkpIntranet = (empty($xvkpIntranet)) ? 0 : 1;
    $xvkpTracking = (empty($xvkpTracking)) ? 0 : 1;
    $xvkpSafeCookie1 = (empty($xvkpSafeCookie1)) ? 0 : 1;
    $xvkpSafeCookie2 = (empty($xvkpSafeCookie2)) ? 0 : 1;
    $xvkpSafeSqlinject = (empty($xvkpSafeSqlinject)) ? 0 : 1;
    $xmxEntitieLevel = (empty($xmxEntitieLevel)) ? 0 : intval($xmxEntitieLevel);
    $xvkpsec_logging = (empty($xvkpsec_logging)) ? 0 : 1;
    $xstoryhome_cols = (empty($xstoryhome_cols)) ? 1 : $xstoryhome_cols;
    $xdefault_group = (empty($xdefault_group)) ? 1 : $xdefault_group;
    $xmxDeactNukeCompatible = (empty($xmxDeactNukeCompatible)) ? 0 : 1;
    $xmxCreateNukeCookie = (empty($xmxCreateNukeCookie)) ? 0 : 1;
    $xvkpUserregoption = (empty($xvkpUserregoption)) ? 0 : $xvkpUserregoption;
    $xmetakeywords = (empty($xmetakeywords)) ? "" : $xmetakeywords;
    $xmailport = (empty($xmailport)) ? "25" : $xmailport;
    $xmailauth = (empty($xmailauth)) ? "mail" : $xmailauth;
    $xpopauth = (empty($xpopauth)) ? "" : $xpopauth; // ab 0.1.8
    $xpm_poptime = (empty($xpm_poptime)) ? 0 : (int)$xpm_poptime;
    $xpm_poptime = ($xpm_poptime < 0) ? 0 : (int)$xpm_poptime;
    $xpm_poptime = ($xpm_poptime < 10 && $xpm_poptime > 0) ? 10 : $xpm_poptime;
    $xanonymous = (empty($xanonymous)) ? "Anonymous" : $xanonymous;
    $xmxSiteService = ($xmxSiteService && empty($xmxSiteServiceText)) ? 0 : $xmxSiteService;
    $xUseGzipCompression = (empty($xUseGzipCompression)) ? 0 : (int)$xUseGzipCompression;
    $xmxJpCacheUse = (empty($xmxJpCacheUse) || (!@file_exists("includes/jpcache/mx_jpcache.php"))) ? 0 : (int)$xmxJpCacheUse;
    $xmxJpCacheTimeout = (empty($xmxJpCacheTimeout)) ? MX_SETINACTIVE_MINS : $xmxJpCacheTimeout;
    $xmxShowPragmaMxNews = (empty($xmxShowPragmaMxNews)) ? 0 : 1;
    // $xvkpUserGraphicMenu = (empty($xvkpUserGraphicMenu)) ? 0 : 1;
    $xvkpBlocksRight = (empty($xvkpBlocksRight)) ? 0 : (int)$xvkpBlocksRight;
    // $xvkpBlocksLeft  = (empty($xvkpBlocksLeft))  ? 0 : (int)$xvkpBlocksLeft;
    $xbackend_active = (empty($xbackend_active)) ? 0 : 1;
    $xbackend_logo = (empty($xbackend_logo)) ? 'images/' . $site_logo : $xbackend_logo;
    $xbackend_limit = (empty($xbackend_limit) || $xbackend_limit > 15) ? 15 : intval($xbackend_limit);
    $xbackend_rssdecriptiontrunk = (empty($xbackend_rssdecriptiontrunk) || $xbackend_rssdecriptiontrunk > 255) ? 30 : intval($xbackend_rssdecriptiontrunk);
    $xbackend_imagedescriptiontrunk = (empty($xbackend_imagedescriptiontrunk) || $xbackend_imagedescriptiontrunk > 255) ? 30 : intval($xbackend_imagedescriptiontrunk);
    $xbackend_itemdescriptiontrunk = (empty($xbackend_itemdescriptiontrunk) || $xbackend_itemdescriptiontrunk > 255) ? 30 : intval($xbackend_itemdescriptiontrunk);

    $xDOCTYPE = (empty($xDOCTYPE)) ? 0 : intval($xDOCTYPE);
    $xTidyOutput = (empty($xTidyOutput) || !checktidyavailable()) ? 0 : intval($xTidyOutput);

    if (!defined("MX_FIRSTGROUPNAME")) define("MX_FIRSTGROUPNAME", "User");

    $xcensorlist = explode(",", $xCensorstring);
    foreach ($xcensorlist as $word) {
        $xx = trim($word);
        if (!empty($xx)) {
            $words[] = "\"" . trim($word) . "\"";
        }
    }
    $newcensorlist = (isset($words)) ? "array(" . implode(",", $words) . ");" : "array();";
    $xCensorMode = (empty($xCensorMode)) ? 0 : $xCensorMode;
    $xCensorReplace = (empty($xCensorReplace)) ? "*****" : $xCensorReplace;

    $xcensorlist = explode(",", $xCensorListUsers);
    foreach ($xcensorlist as $word) {
        $xx = trim($word);
        if (!empty($xx)) {
            $users[] = "\"" . trim($word) . "\"";
        }
    }
    $newcensorlistusers = (isset($users)) ? "array(" . implode(",", $users) . ");" : "array();";
    // mod_rewrite
    if (!is_file('.htaccess') || !is_file('includes/mx_modrewrite.php')) {
        unset($xmxUseModrewrite);
    }
    $rew = "'anony' => " . ((isset($xmxUseModrewrite['anony'])) ? 1 : 0) . ', ';
    $rew .= "'users' => " . ((isset($xmxUseModrewrite['users'])) ? 1 : 0) . ', ';
    $rew .= "'admin' => " . ((isset($xmxUseModrewrite['admin'])) ? 1 : 0) . '';
    // Demomodus
    $xmxDemoMode = (empty($xmxDemoMode)) ? 0 : 1;
    $aaa = mxGetAdminSession();
    if (empty($xmxDemoAdmins)) {
        $temp = array($aaa['aid']);
    } else {
        $temp = ((is_array($xmxDemoAdmins)) ? $xmxDemoAdmins : explode(',', $xmxDemoAdmins));
    }
    foreach ($temp as $key => $value) {
        $value = trim($value);
        if ($value && $value != 'sampleadminname') {
            $tempadmins[$value] = "'" . $value . "'";
        }
    }
    // bei setup kann der Wert leer sein, deshalb nur, wenn wert auch gesetzt
    if (empty($aaa['aid'])) {
        $aaa['aid'] = "sampleadminname";
    }
    // den aktuellen admin auf jeden Fall einfuegen, dass er sich nicht selbst aussperrt
    if (!isset($tempadmins[$aaa['aid']], $tempadmins)) {
        $tempadmins[$aaa['aid']] = "'" . $aaa['aid'] . "'";
    }
    $tempadmins = implode(',', $tempadmins);
    // Ende Demomodus
    // //// beginn setup-string
    $cont = "<?php
/************************************
 pragmaMx - Web Content Management System
 Copyright (c) " . date('Y') . " pragmaMx Dev Team - http://pragmaMx.org
 write with: \$Id: settings.php,v 1.19.2.17 2008/01/21 01:26:08 tora60 Exp $
 Version: " . MX_VERSION . "
************************************/

/**
 * Database & System Config
 *   dbhost:      Database Hostname      (ask your Provider)
 *   dbname:      Database Name          (ask your Provider)
 *   dbuname:     Database Username      (ask your Provider)
 *   dbpass:      Database User-Password (ask your Provider)
 *   prefix:      Your Database table's prefix
 *   user_prefix: Your Users' Database table's prefix (To share it)
 */
\$mxConf['dbhost']      = '$dbhost';
\$mxConf['dbname']      = '$dbname';
\$mxConf['dbuname']     = '$dbuname';
\$mxConf['dbpass']      = '$dbpass';
\$mxConf['prefix']      = '$prefix';
\$mxConf['user_prefix'] = '$user_prefix';
/**
 * Demomode Config
 */
\$mxConf['mxDemoMode']   = '$xmxDemoMode';
\$mxConf['mxDemoAdmins'] = array($tempadmins);
/**
 * all others...
 */
if(!defined('MX_FIRSTGROUPNAME')) define('MX_FIRSTGROUPNAME','" . MX_FIRSTGROUPNAME . "');
\$mxConf['default_group']         = '$xdefault_group';
\$mxConf['vkpSessLifetime']       = '$xvkpSessLifetime';
\$mxConf['vkpInactiveMins']       = '$xvkpInactiveMins';
\$mxConf['vkpIntranet']           = '$xvkpIntranet';
\$mxConf['vkpSafeCookie1']        = '$xvkpSafeCookie1';
\$mxConf['vkpSafeCookie2']        = '$xvkpSafeCookie2';
\$mxConf['vkpSafeSqlinject']      = '$xvkpSafeSqlinject';
\$mxConf['mxEntitieLevel']        = '$xmxEntitieLevel';
\$mxConf['vkpUserregoption']      = '$xvkpUserregoption';
\$mxConf['vkpsec_logging']        = '$xvkpsec_logging';
\$mxConf['mxUseGzipCompression']  = '$xmxUseGzipCompression';
\$mxConf['mxJpCacheUse']          = '$xmxJpCacheUse';
\$mxConf['mxJpCacheTimeout']      = '$xmxJpCacheTimeout';
\$mxConf['mxShowPragmaMxNews']    = '$xmxShowPragmaMxNews';
\$mxConf['mxDeactNukeCompatible'] = '$xmxDeactNukeCompatible';
\$mxConf['mxCreateNukeCookie']    = '$xmxCreateNukeCookie';
\$mxConf['mailuname']        = '$xmailuname';
\$mxConf['mailhost']         = '$xmailhost';
\$mxConf['mailpass']         = '$xmailpass';
\$mxConf['mailport']         = '$xmailport';
\$mxConf['mailauth']         = '$xmailauth';
\$mxConf['popauth']          = '$xpopauth';
\$mxConf['sitename']         = '$xsitename';
\$mxConf['site_logo']        = '$xsite_logo';
\$mxConf['slogan']           = '$xslogan';
\$mxConf['startdate']        = '$xstartdate';
\$mxConf['adminmail']        = '$xadminmail';
\$mxConf['anonpost']         = '$xanonpost';
\$mxConf['DOCTYPE']          = '$xDOCTYPE';
\$mxConf['TidyOutput']       = '$xTidyOutput';
\$mxConf['Default_Theme']    = '$xDefault_Theme';
\$mxConf['foot1']            = '$xfoot1';
\$mxConf['foot2']            = '$xfoot2';
\$mxConf['foot3']            = '$xfoot3';
\$mxConf['foot4']            = '$xfoot4';
\$mxConf['commentlimit']     = '$xcommentlimit';
\$mxConf['anonymous']        = '$xanonymous';
\$mxConf['minpass']          = '$xminpass';
\$mxConf['pollcomm']         = '$xpollcomm';
\$mxConf['articlecomm']      = '$xarticlecomm';
\$mxConf['pm_poptime']       = '$xpm_poptime';
\$mxConf['vkpBlocksRight']   = '$xvkpBlocksRight';
\$mxConf['top']              = '$xtop';
\$mxConf['storyhome']        = '$xstoryhome';
\$mxConf['storyhome_cols']   = '$xstoryhome_cols';
\$mxConf['oldnum']           = '$xoldnum';
\$mxConf['banners']          = '$xbanners';
\$mxConf['backend_active']   = '$xbackend_active';
\$mxConf['backend_title']    = '$xbackend_title';
\$mxConf['backend_limit']    = '$xbackend_limit';
\$mxConf['backend_language'] = '$xbackend_language';
\$mxConf['backend_logo']     = '$xbackend_logo';
\$mxConf['backend_rssdecriptiontrunk']    = '$xbackend_rssdecriptiontrunk';
\$mxConf['backend_imagedescriptiontrunk'] = '$xbackend_imagedescriptiontrunk';
\$mxConf['backend_itemdescriptiontrunk']  = '$xbackend_itemdescriptiontrunk';
\$mxConf['language']          = '$xlanguage';
\$mxConf['locale']            = '$xlocale';
\$mxConf['multilingual']      = '$xmultilingual';
\$mxConf['useflags']          = '$xuseflags';
\$mxConf['notify']            = '$xnotify';
\$mxConf['notify_email']      = '$xnotify_email';
\$mxConf['notify_subject']    = '$xnotify_subject';
\$mxConf['notify_message']    = '$xnotify_message';
\$mxConf['notify_from']       = '$xnotify_from';
\$mxConf['admingraphic']      = '$xadmingraphic';
\$mxConf['adminpanel']        = '$xadminpanel';
\$mxConf['httprefmax']        = '$xhttprefmax';
\$mxConf['vkpTracking']       = '$xvkpTracking';
\$mxConf['AllowableHTML']     = $newAllowableHTML;
\$mxConf['metakeywords']      = '$xmetakeywords';
\$mxConf['mxGoogleMetaVeri']  = '$xmxGoogleMetaVeri';
\$mxConf['CensorList']        = $newcensorlist
\$mxConf['CensorMode']        = '$xCensorMode';
\$mxConf['CensorReplace']     = '$xCensorReplace';
\$mxConf['CensorListUsers']   = $newcensorlistusers
\$mxConf['tipath']            = 'images/topics/';
\$mxConf['mxSiteService']     = '$xmxSiteService';
\$mxConf['mxSiteServiceText'] = '$xmxSiteServiceText';
\$mxConf['mxUseThemecache']   = '$xmxUseThemecache';
\$mxConf['mxDebugService']    = '$xmxDebugService';
\$mxConf['mxSqlErrorDebug']   = '$xmxSqlErrorDebug';
\$mxConf['mxSqlDebug']        = '$xmxSqlDebug';
\$mxConf['mxUseModrewrite']   = array(" . $rew . ");
/**************************************
 * Do not touch the following options!
 */
if (preg_match('#config.php#i', \$_SERVER['PHP_SELF'])) {
  header(\"Location: index.php\");
  die();
}
// only used for phpNuke modules compatibility!
\$mxConf['Version_Num'] = '5.6';
// only dbtype MySQL is supported by " . MX_VERSION . "!
\$mxConf['dbtype'] = 'MySQL';
// set globals
foreach (\$mxConf as \$key => \$value) {
  \$mxConf[\$key] = (!is_array(\$value)) ? stripslashes(\$value) : \$value;
}
unset(\$key, \$value);
extract(\$mxConf, EXTR_OVERWRITE);
?>";
    // //// ende setup-string
    // mxDebugFuncvars($cont); exit;
    extract(mxGetAdminSession());
    if (empty($GLOBALS["mxDemoMode"])) {
        mxChangeFilePerms("config.php", "unlock");
        $file = @fopen("config.php", "w");
        $ok = @fwrite($file, $cont);
        @fclose($file);
        mxChangeFilePerms("config.php", "lock");
    }
    mxSecureLog("SecLog", "Change config.php");
    $ok = intval($ok) + 1;
    // print $ok;
    header("Location: admin.php?op=Configure&ok=$ok");
}

function fieldsetOpen($legend, $collapsible = true)
{
    $class = array_search($legend, $GLOBALS['fieldset_names']);
    if (isset($_COOKIE['jsEnabled']) && $collapsible == true) {
        echo "<fieldset class='" . $class . " closed'>\n"
         . "<legend><span class='collapsible collapsed'>" . $legend . "</span></legend>\n"
         . "<div class='toggle' style='display:none;'>\n";
    } else {
        echo "<fieldset>\n"
         . "<legend>" . $legend . "</legend>\n"
         . "<div style='display:block;'>\n";
    }
    // OpenTable();
}

function fieldsetClose($button = true)
{
    if ($button == true) {
        echo setSubmitButton();
    }
    // CloseTable();
    echo "</div>\n</fieldset>\n";
}

function setSubmitButton()
{
    return '<div style="margin: 1em 0 0.5em 5em"><input type="submit" value="' . _SAVECHANGES . '"></div>';
}

function ConfigChangePerm($mode)
{
    mxChangeFilePerms("config.php", $mode);
    header("Location: admin.php?op=Configure");
}

function settcutslashes($str)
{
    $str = str_replace(chr(92), chr(47), $str);
    $str = str_replace(chr(47) . chr(47), chr(47), $str);
    return $str;
}

function settcutcontrols($str)
{
    $str = ereg_replace("[[:cntrl:]]{1,}", " ", $str);
    return $str;
}
// Local function to provide list of all possible HTML tags
function settingsGetHTMLTags()
{
    // Possible allowed HTML tags
    $allowed = array('!--',
        'a',
        'abbr',
        'acronym',
        'address',
        'applet',
        'area',
        'b',
        'base',
        'basefont',
        'bdo',
        'big',
        'blockquote',
        'br',
        'button',
        'caption',
        'center',
        'cite',
        'code',
        'col',
        'colgroup',
        'del',
        'dfn',
        'dir',
        'div',
        'dl',
        'dd',
        'dt',
        'em',
        'embed',
        'fieldset',
        'font',
        'form',
        'h1',
        'h2',
        'h3',
        'h4',
        'h5',
        'h6',
        'hr',
        'i',
        'iframe',
        'img',
        'input',
        'ins',
        'kbd',
        'label',
        'legend',
        'li',
        'link',
        'map',
        'marquee',
        'menu',
        'meta',
        'nobr',
        'object',
        'ol',
        'optgroup',
        'option',
        'p',
        'param',
        'pre',
        'q',
        's',
        'samp',
        'script',
        'select',
        'small',
        'span',
        'strike',
        'strong',
        'sub',
        'sup',
        'table',
        'tbody',
        'td',
        'textarea',
        'tfoot',
        'th',
        'thead',
        'tr',
        'tt',
        'u',
        'ul',
        'var');
    // grundsaetzlich unerwuenschte Tags entfernen
    foreach ($GLOBALS['mxBadHtmlTags'] as $bad) {
        if ($i = array_search($bad, $allowed)) {
            unset($allowed[$i]);
        }
    }

    asort($allowed);
    return $allowed;
}

function rsslanguagelist()
{
    $rsslang['af'] = "Afrikaans";
    $rsslang['sq'] = "Albanian";
    $rsslang['ar-bh'] = "Arabic (Bahrain)";
    $rsslang['eu'] = "Basque";
    $rsslang['be'] = "Belarusian";
    $rsslang['bg'] = "Bulgarian";
    $rsslang['ca'] = "Catalan";
    $rsslang['zh-cn'] = 'Chinese (Simplified)';
    $rsslang['zh-tw'] = 'Chinese (Traditional)';
    $rsslang['hr'] = 'Croatian';
    $rsslang['cs'] = 'Czech';
    $rsslang['da'] = 'Danish';
    $rsslang['nl'] = 'Dutch';
    $rsslang['nl-be'] = 'Dutch (Belgium)';
    $rsslang['nl-nl'] = 'Dutch (Netherlands)';
    $rsslang['en'] = 'English';
    $rsslang['en-au'] = 'English (Australia)';
    $rsslang['en-bz'] = 'English (Belize)';
    $rsslang['en-ca'] = 'English (Canada)';
    $rsslang['en-ie'] = 'English (Ireland)';
    $rsslang['en-jm'] = 'English (Jamaica)';
    $rsslang['en-nz'] = 'English (New Zealand)';
    $rsslang['en-ph'] = 'English (Phillipines)';
    $rsslang['en-za'] = 'English (South Africa)';
    $rsslang['en-tt'] = 'English (Trinidad)';
    $rsslang['en-gb'] = 'English (United Kingdom)';
    $rsslang['en-us'] = 'English (United States)';
    $rsslang['en-zw'] = 'English (Zimbabwe)';
    $rsslang['fo'] = 'Faeroese';
    $rsslang['fi'] = 'Finnish';
    $rsslang['fr'] = 'French';
    $rsslang['fr-be'] = 'French (Belgium)';
    $rsslang['fr-ca'] = 'French (Canada)';
    $rsslang['fr-fr'] = 'French (France)';
    $rsslang['fr-lu'] = 'French (Luxembourg)';
    $rsslang['fr-mc'] = 'French (Monaco)';
    $rsslang['fr-ch'] = 'French (Switzerland)';
    $rsslang['gl'] = 'Galician';
    $rsslang['gd'] = 'Gaelic';
    $rsslang['de'] = 'German';
    $rsslang['de-at'] = 'German (Austria)';
    $rsslang['de-de'] = 'German (Germany)';
    $rsslang['de-li'] = 'German (Liechtenstein)';
    $rsslang['de-lu'] = 'German (Luxembourg)';
    $rsslang['de-ch'] = 'German (Switzerland)';
    $rsslang['el'] = 'Greek';
    $rsslang['hu'] = 'Hungarian';
    $rsslang['is'] = 'Icelandic';
    $rsslang['in'] = 'Indonesian';
    $rsslang['ga'] = 'Irish';
    $rsslang['it'] = 'Italian';
    $rsslang['it-it'] = 'Italian (Italy)';
    $rsslang['it-ch'] = 'Italian (Switzerland)';
    $rsslang['ja'] = 'Japanese';
    $rsslang['ko'] = 'Korean';
    $rsslang['mk'] = 'Macedonian';
    $rsslang['no'] = 'Norwegian';
    $rsslang['pl'] = 'Polish';
    $rsslang['pt'] = 'Portuguese';
    $rsslang['pt-br'] = 'Portuguese (Brazil)';
    $rsslang['pt-pt'] = 'Portuguese (Portugal)';
    $rsslang['ro'] = 'Romanian';
    $rsslang['ro-mo'] = 'Romanian (Moldova)';
    $rsslang['ro-ro'] = 'Romanian (Romania)';
    $rsslang['ru'] = 'Russian';
    $rsslang['KOI8-R'] = 'Russian KOI8-R';
    $rsslang['ru-mo'] = 'Russian (Moldova)';
    $rsslang['ru-ru'] = 'Russian (Russia)';
    $rsslang['sr'] = 'Serbian';
    $rsslang['sk'] = 'Slovak';
    $rsslang['sl'] = 'Slovenian';
    $rsslang['es'] = 'Spanish';
    $rsslang['es-ar'] = 'Spanish (Argentina)';
    $rsslang['es-bo'] = 'Spanish (Bolivia)';
    $rsslang['es-cl'] = 'Spanish (Chile)';
    $rsslang['es-co'] = 'Spanish (Colombia)';
    $rsslang['es-cr'] = 'Spanish (Costa Rica)';
    $rsslang['es-do'] = 'Spanish (Dominican Republic)';
    $rsslang['es-ec'] = 'Spanish (Ecuador)';
    $rsslang['es-sv'] = 'Spanish (El Salvador)';
    $rsslang['es-gt'] = 'Spanish (Guatemala)';
    $rsslang['es-hn'] = 'Spanish (Honduras)';
    $rsslang['es-mx'] = 'Spanish (Mexico)';
    $rsslang['es-ni'] = 'Spanish (Nicaragua)';
    $rsslang['es-pa'] = 'Spanish (Panama)';
    $rsslang['es-py'] = 'Spanish (Paraguay)';
    $rsslang['es-pe'] = 'Spanish (Peru)';
    $rsslang['es-pr'] = 'Spanish (Puerto Rico)';
    $rsslang['es-es'] = 'Spanish (Spain)';
    $rsslang['es-uy'] = 'Spanish (Uruguay)';
    $rsslang['es-ve'] = 'Spanish (Venezuela)';
    $rsslang['sv'] = 'Swedish';
    $rsslang['sv-fi'] = 'Swedish (Finland)';
    $rsslang['sv-se'] = 'Swedish (Sweden)';
    $rsslang['th'] = 'Thai';
    $rsslang['tr'] = 'Turkish';
    $rsslang['uk'] = 'Ukranian';
    $rsslang['ar'] = 'Arabic';
    $rsslang['ar-ae'] = 'Arabic (United Arab Emirates)';
    $rsslang['ar-bh'] = 'Arabic (Bahrain)';
    $rsslang['ar-dz'] = 'Arabic (Algeria)';
    $rsslang['ar-eg'] = 'Arabic (Egypt)';
    $rsslang['ar-iq'] = 'Arabic (Iraq)';
    $rsslang['ar-jo'] = 'Arabic (Jordan)';
    $rsslang['ar-kw'] = 'Arabic (Kuwait)';
    $rsslang['ar-lb'] = 'Arabic (Lebanon)';
    $rsslang['ar-ly'] = 'Arabic (Libya)';
    $rsslang['ar-ma'] = 'Arabic (Morocco)';
    $rsslang['ar-mr'] = 'Arabic (Mauritania)';
    $rsslang['ar-om'] = 'Arabic (Oman)';
    $rsslang['ar-qa'] = 'Arabic (Qatar)';
    $rsslang['ar-sa'] = 'Arabic (Saudi Arabia)';
    $rsslang['ar-sd'] = 'Arabic (Sudan)';
    $rsslang['ar-so'] = 'Arabic (Somalia)';
    $rsslang['ar-sy'] = 'Arabic (Syria)';
    $rsslang['ar-tn'] = 'Arabic (Tunisia)';
    $rsslang['ar-ye'] = 'Arabic (Yemen)';
    $rsslang['ar-km'] = 'Arabic (Comoros)';
    $rsslang['ar-dj'] = 'Arabic (Djibouti)';
    asort($rsslang);
    return $rsslang;
}

function localelanguagelist()
{
    $loclang['de_DE.iso8859-15'] = "D&nbsp;&nbsp; (de_DE.iso8859-15)";
    $loclang['da_DK.iso8859-15'] = "DK&nbsp; (da_DK.iso8859-15)";
    $loclang['es_ES.iso8859-15'] = "ES&nbsp; (es_ES.iso8859-15)";
    $loclang['fr_FR.iso8859-15'] = "F&nbsp;&nbsp; (fr_FR.iso8859-15)";
    $loclang['fi_FI.iso8859-15'] = "FIN (fi_FI.iso8859-15)";
    $loclang['en_GB.iso8859-15'] = "GB&nbsp; (en_GB.iso8859-15)";
    $loclang['hu_HU.iso8859-2'] = "H&nbsp;&nbsp; (hu_HU.iso8859-2)";
    $loclang['it_IT.iso8859-15'] = "I&nbsp;&nbsp; (it_IT.iso8859-15)";
    $loclang['no_NY.iso8859-1'] = "N&nbsp;&nbsp; (no_NY.iso8859-1)";
    $loclang['nl_NL.iso8859-15'] = "NL&nbsp; (nl_NL.iso8859-15)";
    $loclang['pt_PT.iso8859-15'] = "P&nbsp;&nbsp; (pt_PT.iso8859-15)";
    $loclang['pl_PL.iso8859-2'] = "PL&nbsp; (pl_PL.iso8859-2)";
    $loclang['ru_RU.iso8859-2'] = "RU&nbsp; (ru_RU.iso8859-2)";
    $loclang['sv_SE.iso8859-15'] = "S&nbsp;&nbsp; (sv_SE.iso8859-15)";
    $loclang['sk_SK.iso8859-2'] = "SK&nbsp; (sk_SK.iso8859-2)";
    $loclang['en_US.iso8859-15'] = "US&nbsp; (en_US.iso8859-15)";
    if (PHP_OS == "WINNT" || PHP_OS == "WIN32") {
        $loclang['ge'] = "D&nbsp;&nbsp; (de_DE.iso8859-15) Windows";
        $loclang['dk'] = "DK&nbsp; (da_DK.iso8859-15) Windows";
        $loclang['es'] = "ES&nbsp; (es_ES.iso8859-15) Windows";
        $loclang['fr'] = "F&nbsp;&nbsp; (fr_FR.iso8859-15) Windows";
        $loclang['fi'] = "FIN (fi_FI.iso8859-15) Windows";
        $loclang['en'] = "GB&nbsp; (en_GB.iso8859-15) Windows";
        $loclang['hu'] = "H&nbsp;&nbsp; (hu_HU.iso8859-2)&nbsp; Windows";
        $loclang['it'] = "I&nbsp;&nbsp; (it_IT.iso8859-15) Windows";
        $loclang['no'] = "N&nbsp;&nbsp; (no_NY.iso8859-1)&nbsp; Windows";
        $loclang['nl'] = "NL&nbsp; (nl_NL.iso8859-15) Windows";
        $loclang['pt'] = "P&nbsp;&nbsp; (pt_PT.iso8859-15) Windows";
        $loclang['pl'] = "PL&nbsp; (pl_PL.iso8859-2)&nbsp; Windows";
        $loclang['ru'] = "RU&nbsp; (ru_RU.iso8859-2)&nbsp; Windows";
        $loclang['se'] = "S&nbsp;&nbsp; (sv_SE.iso8859-15) Windows";
        $loclang['sk'] = "SK&nbsp; (sk_SK.iso8859-2)&nbsp; Windows";
        $loclang['en'] = "US&nbsp; (en_US.iso8859-15) Windows";
    }
    asort($loclang);
    return $loclang;
}

/* ist php-Tidy aktiv*/
function checktidyavailable()
{
    // return true;
    if (!extension_loaded('tidy') && is_callable('dl')) {
        @dl('tidy');
    }
    // tidy nur mit tidy 2.0
    if (class_exists('tidy') && !function_exists('tidy_set_encoding')) {
        return true;
    }
    return false;
}

/* Was ist zu tun ;-) */
if (isset($_COOKIE['jsEnabled'])) {
    setcookie ("jsEnabled", 1, time() + 3600); // bei speichern der seite cookie am leben erhalten fuer abfrage auf js
}
$ok = (empty($_REQUEST['ok'])) ? 0 : $_REQUEST['ok'];
switch ($_REQUEST['op']) {
    case "Configure":
        Configure($ok);
        break;

    case "ConfigSave":
        ConfigSave($_POST);
        break;
}

?>
