<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.17.2.10 $
 * $Author: tora60 $
 * $Date: 2008/01/29 12:21:20 $
 */

defined('mxMainFileLoaded') or die('access denied');

/**
 * definiert, dass diese Datei bereits includet wurde
 *     !! nicht veraendern !!
 */
if (isset($GLOBALS['footer_is_shown'])) {
    return;
}
$GLOBALS['footer_is_shown'] = true;
$GLOBALS['footer'] = 1;

/**
 * untere Centerbloecke anzeigen, direkt unter der Ausgabe des Moduls,
 * Bei vkpMx-Themes ist diese Ausgabe im Theme definiert
 */
if (!empty($GLOBALS["home"]) && empty($GLOBALS["VKPTheme"])) {
    blocks('down');
}

/**
 * Funktion 'themefooter' aus Theme aufrufen.
 * Darin werden auch die rechten Bloecke angezeigt
 */
themefooter();

/**
 * private Nachrichten der User abfragen
 */
if (MX_IS_USER) {
    $uinf = mxGetUserData();
    $checkpmtime = (intval($uinf['user_pm_poptime'])) * 1000; // Milisekunden !!!
    if ($checkpmtime > 0 && $GLOBALS['pm_poptime'] && mxModuleAllowed("Private_Messages")) {
        $checkpmfile = "modules.php?name=Private_Messages&amp;file=buddy&amp;op=check&amp;ref_intervall=" . $checkpmtime;
        echo '<div style="position: absolute; left: -10000px;"><iframe name="checkpm" src="' . $checkpmfile . '" marginwidth="0" marginheight="0" width="0" height="0" scrolling="no" frameborder="0"></iframe></div>';
    }
}

/**
 * zusaetzliche Datei fuer benutzerdefinierte Zusaetze am Ende der HTML-Ausgabe
 */
include('includes/my_footer.php');

/**
 * den Ausgabepuffer nachbehandeln
 * Der Ausgabepuffer wurde in mainfile.php explizit gestartet!
 * falls doch leer, ist z.B. nix mit mod_rewrite
 */
if (ob_get_length()) {
    /* die HTML-Ausgabe beenden */
?>

</body>
</html>
<?php

    $mxoutput = trim(ob_get_clean());

    /*
    if (@file_exists('includes/mx_output.php')) {
        include('includes/mx_output.php');
        $out = new mxOutput();
		echo $out->getOutput($mxoutput);
        return;
    }
*/

    $head_tags = pmxHeader::get();
    // tracker und backlinks von 4nc entschaerfen
    // $mxoutput = preg_replace('#(<script[^>]+)(4n-community|web46\.server1\.dce4u\.de)#is', '~~~ FIX 4nc tracker ~~~', $mxoutput);
    // Das Array mit den versch. Doc-Type Deklarationen auslesen
    $doctype_arr = mxDoctypeArray($GLOBALS['DOCTYPE']);

    /**
     * HTML-Validation
     */
    // tidy, falls vorhanden und eingeschaltet
    if ($GLOBALS['TidyOutput'] && !extension_loaded('tidy') && is_callable('dl')) {
        @dl('tidy');
    }
    if ($GLOBALS['TidyOutput'] && class_exists('tidy') && !function_exists('tidy_set_encoding')) {
        /* zusaetzliche headertags vorher noch an die korrekte Stelle setzen */
        $mxoutput = str_replace('<!-- pmx~header~' . MX_TIME . '~pmx -->', "\n" . $head_tags . "\n", $mxoutput);
        // Specify configuration: http://tidy.sourceforge.net/docs/quickref.html
        $tidyconfig = array('output-html' => $doctype_arr['html'],
            'output-xhtml' => $doctype_arr['xhtml'],
            'add-xml-decl' => $doctype_arr['xhtml'],
            'doctype' => $doctype_arr['tidy_doctype'],
            'wrap' => 0,
            'indent' => false,
            // 'indent-spaces' => 1,
            // 'clean'   => true,
            // 'alt-text' => 'img',
            );
        // mxDebugFuncVars($tidyconfig);
        // Tidy
        $tidy = new tidy;
        $tidy->parseString($mxoutput, $tidyconfig, 'latin1');
        $tidy->cleanRepair();
        $mxoutput = $tidy;
        // die tidy-Funktion fuegt vor </textara> einen Zeilenumbruch ein, diesen hier entfernen
        $mxoutput = preg_replace('#\s*</textarea>#', '</textarea>', $mxoutput);
        unset($tidy);
    } else {
        /* zusaetzliche headertags an die korrekte Stelle setzen */
        $mxoutput = str_replace('<!-- pmx~header~' . MX_TIME . '~pmx -->', "\n" . $head_tags . "\n", $mxoutput);
        // der spaw-Editor setzt manchmal leere align-Attribute, die werden hier entfernt
        // $mxoutput = preg_replace('#(<[[:alnum:]]+[^>]*)v?align\s*=\s*""([^>]*>)#i', '$1 $2', $mxoutput);
        // der spaw-Editor setzt manchmal leere align-Attribute, die werden hier entfernt
        // $mxoutput = preg_replace('#(<[[:alnum:]]+[^>]*)v?align\s*=\s*""([^>]*>)#i', '$1 $2', $mxoutput);
        // der spaw-Editor setzt manchmal komische type-Attribute dazu
        $mxoutput = str_replace(' type="_moz"', '', $mxoutput);
        if ($doctype_arr['xhtml']) {
            // versuchen, die xhtml-Endung anzufuegen
            $mxoutput = preg_replace('#<((?:img|input|hr|br|link|meta|base)(?:[^>]*[^/])?)>#i', '<$1 />', $mxoutput);
        } else {
            // die xhtml-Endung < /> entfernen, da Fehler in HTML 4.01
            $mxoutput = preg_replace('#(<[[:alnum:]]+[^>]*)/\s*>#', '$1>', $mxoutput);
            // bei <img> muss ein ALT Attribut spezifiert sein, hier versuchen die anzufuegen, falls es fehlt
            // nicht bei xhtml, weil da der regex nicht funzt...
            $mxoutput = preg_replace('#(<img[^>]*)>#ie', 'stripslashes((preg_match("!\s*alt\s*=\s*[\'\"]!i", "\1"))?"\0":"\1 alt=\"\">")', $mxoutput);
        }
        // Link auf ungueltige Verweise entfernen, kommt evtl. von Spaw, etc.
        $mxoutput = preg_replace('!\s+href="#?"!i', '', $mxoutput);
        // TODO:  / class="formbutton">
    }
    /**
     * ENDE HTML-Validation
     */

    /**
     * mod_rewrite, Ersetzen der Links in ein suchmaschinenfreundliches Format.
     */
    if ($mxoutput && ((!empty($GLOBALS['mxUseModrewrite']['anony']) && !MX_IS_USER && !MX_IS_ADMIN) ||
                (!empty($GLOBALS['mxUseModrewrite']['users']) && MX_IS_USER && !MX_IS_ADMIN) ||
                (!empty($GLOBALS['mxUseModrewrite']['admin']) && MX_IS_ADMIN)) && is_file('.htaccess')) {
        if (!function_exists('mxPrepareModRewrite')) {
            include_once('includes/mx_modrewrite.php');
        }
        $mxoutput = mxPrepareModRewrite($mxoutput);
    }

    /**
     * zusaetzliche optionale Datei um den Ausgabepuffer zu manipulieren
     */
    if (@file_exists('includes/prepareoutput.php')) {
        include('includes/prepareoutput.php');
    }

    /**
     * den html-Output (Ausgabepuffer) ausgeben
     */
    echo $mxoutput;

    /**
     * Speicher aufraeumen
     */
    unset($mxoutput, $matches, $allstyles);
} else {
    /* falls kein Ausgabepuffer vorhanden, die zusaetzlichen Header-Tags zumindest noch ans Ende schreiben... */
    pmxHeader::show();
    /* das Ende, der HTML-Ausgabe */
?>

</body>
</html>
<?php } ?>