<?php
/**
 * pragmaMx SMF Integration
 * Copyright by A.Ellsel (Andi) - http://pragmaMx.org
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * $Id: config.php,v 1.20 2008/06/17 17:54:22 tora60 Exp $
 */

if (!isset($mxsmf)) {
    global $mxsmf;
} 

/**
 * rechte Bloecke anzeigen?
 */
// global $index; $index = 1;

/**
 * berechtigte Administratorgruppen / valid Admingroups
 * mgliche Werte: radminarticle,radmintopic,radminuser,radminsurvey,radminsection,radminlink,radminephem,radminfaq,radmindownload,radminreviews,radminnewsletter,radminforum,radmincontent,radminency,radminsuper,radmingroups,radmincalendar
 * durch Komma trennen, ohne Leerzeichen dazwischen!!
 */
$mxsmf['valid_admingoups'] = 'radminforum';

/**
 * die Superadmin's des pragmaMx sind immer in der Administratorgruppe
 * wenn die oben definierten "berechtigte Administratorgruppen" auch Adminrechte
 * im Board haben sollen, den folgenden Wert auf 1 setzen,
 * bei 0 erhalten die nur globalen Moderatorstatus
 */
$mxsmf['admingoups_as_admin'] = false;

/**
 * neue User aus pragmaMx-Usertabelle automatisch anfuegen,
 * auch wenn der ensprechende User noch nicht im Forum war?
 */
$mxsmf['auto_insert_user'] = true;

/**
 * Der teil des Dateinamens der SMF Sprachdateien um die deutsch-DU Sprachversion zu identifizieren
 */
$mxsmf['german_du_convention'] = 'german-du';

/**
 * diese Option auf 1 setzen, wenn es Probleme mit der Meldung
 *   'Sie haben den Beitrag gerade erst geschrieben!' gibt.
 * der Check wird dann abgeschaltet, dafr aber expliziet der Check,
 * ob in der Zwischenzeit ein neuer Post eingegangen ist, eingeschaltet
 * TODO: evtl. in RC3 nicht mehr benoetigt...
 */
$mxsmf['skip_check_doublepost'] = false;

/**
 * Durch das speichern der Passwrter als SHA1-Hash im Smf seit 1.1 ist das Login im Standallone
 * nicht mehr mglich, wenn die Userdaten konvertiert sind. Durch diese Einstellung kann dies aber
 * fr Forenadmins wieder freigeschaltet werden.
 */
$mxsmf['allow_standallone_login'] = true;

/**
 * Probleme bei der charset-Konvertierung in eMails fixen
 * Info dazu: http://www.pragmamx.org/forum-topic-15076.0.html
 */
$mxsmf['disableQuotedPrintable'] = true;

/**
 * eMail-Adressen, bzw. die mailto: Tags im HTML-Quellcode unkenntlich machen
 */
$mxsmf['encodeEmailAdresses'] = true;


/**
 * //////////////////////////////////////////////////////////////////////////////////////////////
 * ab hier nichts verndern
 */
// den Modulnamen ermitteln und zwischenspeichern
$mxsmf['module_name'] = basename(dirname(__file__));
// Der (include) Ordner, in dem sich die SMF Dateien befinden
$mxsmf['boardsubfolder'] = 'smf';
$mxsmf['boarddir'] = realpath(dirname(__FILE__) . DIRECTORY_SEPARATOR . $mxsmf['boardsubfolder']);
$mxsmf['path'] = 'modules/' . $mxsmf['module_name'] . '/' . $mxsmf['boardsubfolder'];
$mxsmf['path_themes'] = $mxsmf['path'] . '/Themes'; // Themes GROSSGESCHRIEBEN !!
$mxsmf['pmxtheme'] = (function_exists('mxGetTheme')) ? mxGetTheme() : false;
$mxsmf['demomode'] = (function_exists('mxDemoMode') && mxDemoMode()) ? true : false;
?>