<?php
/**
 * pragmaMx SMF Integration
 * Copyright by A.Ellsel (Andi) - http://pragmaMx.org
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Id: style.php,v 1.11 2008/06/06 23:04:54 tora60 Exp $
 */

(defined('mxMainFileLoaded') && isset($_GET['st'])) or die('access denied');
#mxDebugFuncVars(get_defined_constants());

/* a rua is, hoast mi... */
error_reporting(0);

/* http-header senden */
header('Content-Type: text/css');
header('Expires: ' . gmdate('D, d M Y H:i:s GMT', time() + 3600 * 24)); // 1 day

// Der SMF Theme-Name
$theme_smf_dir = $_GET['st'];

/* Wenn caching aktiviert, checken, ob Cachedatei vorhanden */
if ($GLOBALS['mxUseThemecache']) {
    // der Pfad zum Ordner fuer die Cachedaten
    $dynapath = PMX_DYNADATA_DIR . DIRECTORY_SEPARATOR . 'cache';
    // der Name der Cachedatei
    $dynafile = $dynapath . DIRECTORY_SEPARATOR . $_SERVER['HTTP_HOST'] . '.' . basename(dirname(__FILE__)) . '.' . $theme_smf_dir . '.' . MX_THEME . '.css';
    /* wenn die Cachedatei existiert und Caching eingeschaltet, das script beenden */
    if (is_file($dynafile)) {
        echo "/* cached file: " . basename($dynafile) . " */\n\n";
        echo trim(file_get_contents($dynafile));
        exit;
    }
}

$theme_smf = dirname(__FILE__) . DIRECTORY_SEPARATOR . 'smf' . DIRECTORY_SEPARATOR . 'Themes' . DIRECTORY_SEPARATOR . $theme_smf_dir . DIRECTORY_SEPARATOR . 'style.css';
if (!file_exists($theme_smf)) {
    die('/* SMF Stylesheet "' . $theme_smf_dir . '" not found */');
}

$out_smf = file_get_contents($theme_smf);
// Pfad von Hintergrundbildern korrigieren
$out_smf = preg_replace('#(url\s*\()([^)]+\))#i', '$1modules/' . MX_MODULE . '/smf/Themes/' . $theme_smf_dir . '/$2$3', $out_smf);
// unerwuenschte Tags entfernen (nicht 100% moeglich)
$out_smf = preg_replace("~\n\s*[^.#}{]+{[^}]*}~i", "\n", $out_smf) . "\n";
// Kommentare entfernen
$out_smf = preg_replace('#/\*[^*{}]+\*/#', '', $out_smf);
// doppelte Zeilenumbrueche entfernen
$out_smf = preg_replace('#\n{2,}#', "\n", $out_smf);
// bei Bedarf Variablen umschreiben
$out_smf = st_prepare_themevars($out_smf);

/* Das Ergebnis an den Browser schicken */
echo $out_smf;

if (!$GLOBALS['mxUseThemecache']) {
    exit;
}

/* nach der Ausgabe, versuchen den Inhalt als .css Datei zwischenzuspeichern */
ob_start();
if (!is_writable($dynapath)) {
    @chmod($dynapath, 0777);
}
if (is_writable($dynapath)) {
    if (file_exists($dynafile)) {
        @chmod($dynafile, 0777);
    }
    $file = fopen($dynafile, 'w');
    fwrite($file, $out_smf);
    fclose($file);
}
ob_end_clean();

/**
 * die theme.php des eingestellten Themes includen
 */
function st_prepare_themevars($out_smf)
{
    // Variablen nur bei Bedarf umschreiben
    if (strpos($out_smf, '#smfoutput') === false) {
        return $out_smf;
    }

    $themevars = includetheme();
    extract($themevars);

    /* Standardwerte, fuer die bgColor-Klassen, alles in Graustufen */
    $required = array('bgcolor1' => '#F0F0F0',
        'bgcolor2' => '#D0D0D0',
        'bgcolor3' => '#E0E0E0',
        'bgcolor4' => '#C0C0C0',
        'textcolor1' => '#2F2F2F',
        'textcolor2' => '#5F5F5F',
        );
    $part = array();
    foreach ($required as $key => $value) {
        /* Wenn passender $_GET-Key vorhanden, diesen anstatt dem Standard verwenden */
        if (isset($$key)) {
            $value = htmlspecialchars($$key);
        }
        /* suche/ersetze Array erstellen */
        $search[$key] = '___' . $key . '___';
        $replace[$key] = $value;
    }

    /* erstelltes suche/ersetze Array anwenden */
    $out_smf = str_replace($search, $replace, $out_smf);
    return $out_smf;
}

if (!function_exists('file_get_contents')) {
    function file_get_contents($txt)
    {
        return implode('', file($txt, 0));
    }
}

?>