<?php
/**
 * This file is part of 
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.6 $
 * $Author: tora60 $
 * $Date: 2007/12/22 14:15:56 $
 *
 * thanks to uwe slick! http://www.deruwe.de/captcha.html
 * - just copy/pasted his thoughts GPLed!
 * modified by (c) 2007 by jubilee
 */

/**
 * this class allows to have multiple
 * "handshake backends" (i.e. session, file, db)
 * just call this class and you should receive a captchaPhrase
 */
class PhraseFactory {
    function get($reset = false, $phraseLength = '', $given = '', $DEPRECATED_storage = '')
    {
        // Speichern des Vergleichswertes in der Datenbank
        include_once(dirname(__FILE__) . '/MysqlPhrase.php');

        if (isset($GLOBALS['casesensitive'])) {
            $casesensitive = $GLOBALS['casesensitive'];
        } else {
            include(dirname(dirname(__FILE__)) . '/settings.php');
        }

        if ($given) {
            $return = MysqlPhrase::get($reset, '', $given);
            // beim Check, ob der eingegebene Wert mit dem gespeicherten Wert uebereinstimmt,
            // wird die uebergebene post-Variable $given mit dem Rueckgabewert $return
            // dieser Funktion verglichen.
            if (empty($casesensitive)) {
                // Wenn die Gross-Kleinschreibung nicht beachtet werden soll, einfach hier bereits
                // vergleichen und bei Erfolg den Eingabewert als Rueckgabewert zurueckgeben.
                if (strtolower($given) == strtolower($return)) {
                    return $given;
                }
            }

            return $return;
        } else {
            return MysqlPhrase::get($reset, PhraseFactory::getPhrase($phraseLength), '');
        }
    }

    function getPhrase($phraseLength)
    {
        static $captchaPhrase = null;
        $idx = 0;

        if ($captchaPhrase == null) {
            if (empty($GLOBALS['charstouse'])) {
                // avoid heavy readable and ambiguous chars
                $availableChars = "23456789abcdfghjkmnpqrstvwxABCDEFGHJKLMNPRSTUVWXYZ";
            } else {
                $availableChars = str_shuffle($GLOBALS['charstouse']);
            } while ($idx < $phraseLength) {
                $currentChar = $availableChars[rand(0, strlen($availableChars)-1)];
                if (!strstr($captchaPhrase, $currentChar)) {
                    $captchaPhrase .= $currentChar;
                    $idx++;
                }
            }
        }

        return $captchaPhrase;
    }
}

?>
