<?php
/**
 * This file is part of 
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.8.2.4 $
 * $Author: tora60 $
 * $Date: 2008/01/29 20:32:12 $
 */

defined('mxMainFileLoaded') or die('access denied');
include_once(PMX_SYSTEM_DIR . '/detection/config.php');

/**
 * /////
 */
function mxDetectStart()
{
    // den RequestString erstellen und in Konstante speichern
    define('___MXREQUESTSTRING___', mxDetectGetRequestString($_REQUEST));
    // mxDebugFuncVars(___MXREQUESTSTRING___);
    // alle vorhandenen Signaturen importieren
    $sig = mxDetectGetSignatures(md5($GLOBALS['prefix']));
    // Schleife durch alle definierten Signaturen
    foreach ($sig['req'] as $i => $sigreq) {
        // prfen ob die Signatur vollstndig ist
        if (!isset($sig['msg'][$i])) {
            echo '<pre><b>Fehler in Signatur #' . $i . '</b></pre>';
            $sig['msg'][$i] = 'Hack detected (Fehler in Signatur)';
        }
        // prfen ob verdchtiger String auch in den requests vorkommt
        if (preg_match($sigreq, ___MXREQUESTSTRING___, $matches)) {
            // mxDebugFuncVars($i,$sigreq, $matches);
            // / wenn passende sql Signatur vorhanden
            if (isset($sig['sql'][$i])) {
                $sql_detect['sql'][$i] = $sig['sql'][$i];
                $sql_detect['msg'][$i] = $sig['msg'][$i];
                mxDetectLogging($sig['msg'][$i] . " ($i)", false);
            } else {
                // sonstige
                $req_detect['req'] = $sig['req'][$i];
                $req_detect['msg'] = $sig['msg'][$i] . " ($i)";
                // mxDebugFuncVars($i,$sigreq, $matches);
                $critical = true;
                break;
            }
        }
    }
    if (isset($sql_detect)) {
        // / das Array mit den ermittelten "mglichen" sql_injects als string in einer Konstante zwischenspeichern
        // / dieses Array wird spter beim query-check verwendet, anstatt der eigentlichen Signaturen
        define('___MXSQLDETECT___', serialize($sql_detect));
        // / todo: Logging von verdchtigen Variablen
    }
    // wenn eine Request-Injection gefunden wurde, oder ein Fehler vorliegt
    if (isset($req_detect)) {
        // Konfigurationsvariablen einlesen
        $conf = sqlCheckConfig();
        // verhindern, dass SQL-Fehlermeldungen bei eingeschaltetem debugmode ausgegeben werden
        $GLOBALS["mxSqlErrorDebug"] = false;
        // zustzlich error_reporting abschalten
        // error_reporting(0);
        //  @ini _set("display_errors",FALSE);
        // Log-Eintrag & mail
        mxDetectLogging($req_detect['msg'], false);
        // destroy session?
        if ($conf['killsession']) {
            mxSessionDestroy();
        }
        // banning?
        if ($conf['ipbanning'] > 1) {
            mxDetectBannThisIp();
        }
        // wenn weitergeleitet werden soll, oder die Detection als Kritisch eingestuft wurde
        if ($conf['redirect'] || isset($critical)) {
            if (!headers_sent()) {
                mxRedirect($conf['redirect'], "Bad Request:<br />$req_detect[msg]<br /><br />", 60);
            }
            // auf jeden Fall abbrechen, falls header nicht funktioniert
            die("Bad Request:<br />$req_detect[msg]");
        }
    }
}

/**
 * /////
 */
function mxDetectGetSignatures($key)
{
    // ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    // Teile fr patterns und sonstige funktionsspezifische Variablen, nicht verndern !!
    // - alle Zeichen, die in mysql einen Kommentar oder Leerzeichen darstellen knnen
    // und das normale Leerzeichen ersetzen knnten
    $sqlspace = '(?:--[[:space:]]|\/\*|\*\/|[[:space:]]){1,}';
    // Teil fr pattern
    // - evtl. fhrend der Datenbankname mit einem folgenden Punkt
    // - der prefix oder userprefix oder standard-mx oder standard-nuke gefolgt von einem _
    // - nach dem _ mindestens 1 alhanumerisches Zeichen oder ein weiterer _
    $table = '(?:\.|`|' . $sqlspace . ')(?:' . $GLOBALS['prefix'] . '|' . $GLOBALS['user_prefix'] . '|mx)(?:[[:alnum:]]|_|-){1,64}(?:`|' . $sqlspace . ')';
    // eindeutigen Index fr Signaturen initialisieren
    $i = 0;
    // ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    // ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    // Definition der Prf-Signaturen
    // $sig['sql'] : der Suchstring fr die Datenbankanfrage
    // $sig['req'] : der Suchstring fr die Request-Parameter
    // $sig['msg'] : Die entsprechende Meldung fr den Log-Eintrag, falls beide Bedingungen wahr sind
    // - fr sql-berprfung mssen immer diese 3 Teile vorhanden sein
    // - der erste Match ($matches[1]) stellt immer die evtl. gltige Datenbankabfrage dar und wird von der Funktion zurckgegeben
    // - der Rest wird radikal abgeschnitten
    // nach jeder Signatur, nicht vergessen, den Zhler zu erhhen !!
    // ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    // Union Hack
    $sig['req'][$i] = "#${sqlspace}UNION(?:|${sqlspace})(?:ALL|SELECT).*?FROM.*?${table}#isU";
    $sig['sql'][$i] = "#(SELECT.*${table}.*?)${sqlspace}UNION(?:|${sqlspace})(?:ALL|SELECT).*?FROM.*?${table}#isU";
    $sig['msg'][$i] = '[Union] Hack detected';
    $i++;
    // OR/AND WHERE Hack
    // / das ist noch nicht ausgereift !!!!
    // $sig['sql'][$i] = "#(.*?${table}.*${sqlspace}WHERE.*)${sqlspace}(or|and)${sqlspace}([a-zA-Z]{1}[[:alnum:]]*)${sqlspace}(?:=|like|in${sqlspace}?\(|between).*#isU";
    // $sig['req'][$i] = "#${sqlspace}(or|and)${sqlspace}([a-zA-Z][[:alnum:]]*$)${sqlspace}(=|like|in${sqlspace}?\(|between)(.*)#isU";
    // $sig['sql'][$i] = "#(.*?(${table}).*${sqlspace}WHERE.*)${sqlspace}(or|and)${sqlspace}([a-zA-Z]{1}[[:alnum:]]*)${sqlspace}(?:=|like|in${sqlspace}?\(|between).*#isU";
    // $sig['sql'][$i] = "#${sqlspace}(or|and)${sqlspace}([a-zA-Z][[:alnum:]]*$)${sqlspace}(=|like|in${sqlspace}?\(|between)(.*)#isU";
    // $sig['req'][$i] = "#${sqlspace}(or|and)${sqlspace}([a-zA-Z][[:alnum:]]*$)${sqlspace}(=|like|in${sqlspace}?\(|between)(.*)#isU";
    // $sig['msg'][$i] = '[OR/AND WHERE] Hack detected';
    // $i++;
    // UPDATE Table Hack
    $sig['req'][$i] = "#;(?:|${sqlspace})UPDATE.*(${table}).*?SET#isU";
    $sig['sql'][$i] = "#(.*);(?:|${sqlspace})UPDATE.*(${table}).*?SET#isU";
    $sig['msg'][$i] = '[UPDATE_SET] Hack detected';
    $i++;
    // Insert / Replace Hack
    $sig['req'][$i] = "#;(?:|${sqlspace})(?:INSERT|REPLACE).*(${table}|OUTFILE|DUMPFILE).*?(?:VALUES|SELECT|SET)#isU";
    $sig['sql'][$i] = "#(.*);(?:|${sqlspace})(?:INSERT|REPLACE).*(${table}|OUTFILE|DUMPFILE).*?(?:VALUES|SELECT|SET)#isU";
    $sig['msg'][$i] = '[INSERT/REPLACE] Hack detected';
    $i++;
    // DELETE From Hack
    $sig['req'][$i] = "#;(?:|${sqlspace})DELETE.*?FROM.*?(${table})#isU";
    $sig['sql'][$i] = "#(.*);(?:|${sqlspace})DELETE.*?FROM.*?(${table})#isU";
    $sig['msg'][$i] = '[DELETE_FROM] Hack detected';
    $i++;
    // Truncate/Drop Table
    $sig['req'][$i] = "#;(?:|${sqlspace})(?:TRUNCATE|DROP|ALTER).*TABLE.*?(${table})#isU";
    $sig['sql'][$i] = "#(.*);(?:|${sqlspace})(?:TRUNCATE|DROP|ALTER).*TABLE.*?(${table})#isU";
    $sig['msg'][$i] = '[TRUNCATE/DROP/ALTER_TABLE] Hack detected';
    $i++;
    // LOAD DATA INFILE Hack
    $sig['req'][$i] = "#;(?:|${sqlspace})LOAD${sqlspace}DATA.*?INFILE#isU";
    $sig['sql'][$i] = "#(.*);(?:|${sqlspace})LOAD${sqlspace}DATA.*?INFILE#isU";
    $sig['msg'][$i] = '[LOAD_DATA_INFILE] Hack detected';
    $i++;
    // Select Into Hack
    $sig['req'][$i] = "#;(?:|${sqlspace})SELECT.*?INTO${sqlspace}(?:OUTFILE|DUMPFILE)#isU";
    $sig['sql'][$i] = "#(.*);(?:|${sqlspace})SELECT.*?INTO${sqlspace}(?:OUTFILE|DUMPFILE)#isU";
    $sig['msg'][$i] = '[SELECT_INTO] Hack detected';
    $i++;
    // HANDLER Hack
    $sig['req'][$i] = "#;(?:|${sqlspace})HANDLER.*?(${table}).*?(?:OPEN|READ)#isU";
    $sig['sql'][$i] = "#(.*);(?:|${sqlspace})HANDLER.*?(${table}).*?(?:OPEN|READ)#isU";
    $sig['msg'][$i] = '[HANDLER] Hack detected';
    $i++;
    // / sonstige Signaturen, die nur auf Request berprft werden
    $sig['req'][$i] = '#\<(?:img|i?frame|object|embed|i?layer|script|link)[^\>]+(?:[[:space:]]{0,})(?:src|rel)(?:[[:space:]]{0,})?=(?:[^\>]+)?admin\.php[^\>]+\>|\[img(?:.+)?(?:admin\.php).+?\[/img#si';
    $sig['msg'][$i] = '[Admin Intrusion] Hack detected';
    $i++;
    // / interne Sicherung, dass Signaturen nicht ausgelesen werden knnen
    if (md5($GLOBALS['prefix']) != $key) {
        $sig = array();
    }
    return $sig;
}

/**
 * /////
 */
function mxDetectCheckQuery($query)
{
    static $requestlen, $skipcheck;
    // abschliessende Semikolons und umgebende spaces vom querystring immer entfernen
    $query = trim($query, '; ');
    // abbrechen, wenn Query nicht geprueft werden muss
    if ($skipcheck || ($GLOBALS['mxSkipSqlDetect'])) {
        return $query;
    }
    if (!$requestlen) {
        $requestlen = strlen(___MXREQUESTSTRING___);
    }
    // Konfigurationsvariablen einlesen
    $conf = sqlCheckConfig();
    // nur zum testen:
    // $query .= $_REQUEST['qsl'];
    // ende nur zum testen:
    // nur lngere Strings testen und nur, wenn im Request bereits etwas gefunden wurde
    if ((!defined('___MXSQLDETECT___')) || ($requestlen < $conf['minlen_req'])) {
        $skipcheck = true;
        return $query;
    }
    if ((strlen($query) < $conf['minlen_sql'])) {
        return $query;
    }
    // / den string mit den ermittelten "mglichen" sql_injects als Array umwandeln
    $sig = unserialize(___MXSQLDETECT___);
    // Anzahl der vorhandenen Signaturen ermitteln
    $countsigs = count($sig['sql']);
    // mxDebugFuncVars($countsigs, $sig); #exit;
    // wenn Signaturen vorhanden
    if ($countsigs) {
        // Schleife durch alle definierten Signaturen
        foreach ($sig['sql'] as $i => $sigsql) {
            // mxDebugFuncVars($i,$sigsql, $query);
            // wenn die SQL-Bedingung zutrifft
            if (preg_match($sigsql, $query, $matches)) {
                // mxDebugFuncVars($i,$sigsql, $matches);
                // Fehlermeldung fr Logging zwischenspeichern
                // - die entsprechende Nachricht
                $detect['msg'] = $sig['msg'][$i] . " ($i)";
                // - die unvernderte Datenbankanfrage
                // - die komplette Request-Stringkette
                $detect['qry'] = "\r\nquery:\r\n" . mxStripSlashes($query) . "\r\nrequest:\r\n" . mxDetectGetMessage($_REQUEST);
                // Wenn es nur ein select Befehl ist, die Datenbankabfrage so abndern, damit nur der erste
                // gefundene Match zurckgegeben wird und die Datenbankabfrage ausgefhrt werden kann
                if (preg_match("#SELECT.*(?:^INTO)#isA", $matches[1])) {
                    $query = $matches[1];
                }
                // ansonsten, die Datenbankabfrage komplett lschen
                else {
                    $query = '';
                    $critical = true;
                }
                // bei der ersten Fundstelle die Schleife abbrechen
                break;
            }
        }
    }
    // mxDebugFuncVars($detect); exit;
    // wenn eine Injection gefunden wurde, oder ein Fehler vorliegt
    if (isset($detect)) {
        // verhindern, dass SQL-Fehlermeldungen bei eingeschaltetem debugmode ausgegeben werden
        $GLOBALS["mxSqlErrorDebug"] = false;
        // zustzlich error_reporting abschalten
        error_reporting(0);
        @ini_set("display_errors", false);
        // Log-Eintrag & mail
        mxDetectLogging($detect['msg'], true, $detect['qry']);
        // destroy session?
        if ($conf['killsession']) {
            mxSessionDestroy();
        }
        // banning?
        if ($conf['ipbanning'] > 1) {
            mxDetectBannThisIp();
        }
        // wenn weitergeleitet werden soll, oder die Detection als Kritisch eingestuft wurde
        if ($conf['redirect'] || isset($critical)) {
            if (!headers_sent()) {
                mxRedirect($conf['redirect'], "Bad Request:<br />$detect[msg]<br /><br />", 60);
            }
            // auf jeden Fall abbrechen, falls header nicht funktioniert
            die("Bad Request:<br />$detect[msg]");
        }
    }
    // die berprfte und evtl. genderte Datenbankabfrage zurckgeben
    return $query;
}

/**
 * /////
 */
function mxDetectLogging($msg, $showmore, $addinfo = '')
{
    global $prefix;
    // mxDebugFuncVars($addinfo);
    // Konfigurationsvariablen einlesen
    $conf = sqlCheckConfig();
    // Benutzerdaten ermitteln falls vorhanden
    $aid = $GLOBALS['anonymous'];
    $uname = $GLOBALS['anonymous'];
    if (mxSessionGetVar("user")) {
        $stat = explode(":", preg_replace('#[[:cntrl:]]#', ' ', base64_decode(mxSessionGetVar("user"))));
        $uname = substr($stat[1], 0, 25);
    }
    if (mxSessionGetVar("admin")) {
        $stat = explode(":", preg_replace('#[[:cntrl:]]#', ' ', base64_decode(mxSessionGetVar("admin"))));
        $aid = substr($stat[0], 0, 25);
    }

    $trace = '';
    if ($showmore) {
        // die komplette Ausgabe der Funktion mxDebugBacktrace()
        $trace = trim("Backtrace:\r\n" . str_replace(array("\n ", "\n", "\n\n", "details: "), array("\n", "\n", "\r\n", ""), preg_replace('#( |&nbsp;){1,}#i', ' ', strip_tags(mxDebugBacktrace(false)))));
    } // end if ($showmore)
    // versch. Serverinformationen
    $serverdata = @"
Serverinfo:
REMOTE_ADDR:          $_SERVER[REMOTE_ADDR]
QUERY_STRING:         $_SERVER[QUERY_STRING]
REQUEST_URI:          $_SERVER[REQUEST_URI]
REMOTE_PORT:          $_SERVER[REMOTE_PORT]
REMOTE_HOST:          $_SERVER[REMOTE_HOST]
HTTP_REFERER:         $_SERVER[HTTP_REFERER]
HTTP_USER_AGENT:      $_SERVER[HTTP_USER_AGENT]
HTTP_X_FORWARDED_FOR: $_SERVER[HTTP_X_FORWARDED_FOR]
$trace
";

    $addinfo = (empty($addinfo)) ? '' : "\r\n" . $addinfo;
    $logentry = "\r\n" . str_repeat('-', 50) . "\r\n" . date("d-m-Y H:i:s") . ' ' . $msg . "\r\nuser: " . $uname . "\r\nadmin: " . $aid . $addinfo . "\r\nrequest:\r\n" . mxDetectGetMessage($_REQUEST) . $serverdata;
    $logentry = preg_replace("/(\r\n)|(\r)|(\n)/", "\r\n", $logentry);
    // mxDebugFuncVars($logentry);
    // / Meldung in Logdatei schreiben
    if ($conf['logtype'] == 'file' || $conf['logtype'] == 'both' || !isset($GLOBALS['dbi'])) {
        @error_log($logentry, 3, $conf['logfile']);
    }

    if (($conf['logtype'] == 'sql' || $conf['logtype'] == 'both') && isset($GLOBALS['dbi']) && defined('MX_VERSION_NUM')) {
        $qry = "INSERT INTO ${prefix}_securelog
						(log_ip, log_time, log_eventid, log_event, uname, aid, request) VALUES
						('" . MX_REMOTE_ADDR . "', " . time() . ", 'Hack-Attack', '" . mxAddSlashesForSQL($msg) . "', '" . mxAddSlashesForSQL($uname) . "', '" . mxAddSlashesForSQL($aid) . "', '" . mxAddSlashesForSQL(trim($logentry)) . "')";
        $GLOBALS['mxSkipSqlDetect'] = true;
        sql_query($qry);
    }
    // mail senden
    if (isset($conf['sendmail'])) {
        $logentry .= "\r\nsiteadress: " . PMX_HOME_URL;
        // Remove \x00 (nullbyte) from any passed variable for security reasons
        $logentry = str_replace("\x00", '', $logentry);
        $subject = mxHtmlEntityDecode($msg . ', on ' . $GLOBALS['sitename']);
        // mxDebugFuncVars($logentry);
        foreach ($conf['sendmail'] as $mailto) {
            if (ereg('@', $mailto)) {
                if (isset($GLOBALS['dbi'])) {
                    $GLOBALS['mxSkipSqlDetect'] = true;
                    mxMail($mailto, $subject, $logentry, $GLOBALS['adminmail'], 'text', null);
                } else {
                    mail($mailto, $subject, $logentry, "From: " . $GLOBALS['adminmail'] . "\nReply-To: " . $GLOBALS['adminmail'] . "\nX-Mailer: PHP/" . phpversion());
                }
            }
        }
    }
    return $logentry;
}

/**
 * /////
 */
// gibt smtliche von $_REQUEST bergebenen Scriptparameter als eine gemeinsame Zeichenkette zurck
// dies ist die Grundlage zur berprfung der request-Variablen
function mxDetectGetRequestString($request)
{
    // die Sessioncookies nicht prfen
    unset($request[MX_SESSION_NAME], $request[MX_SAFECOOKIE_NAME_ADMIN], $request[MX_SAFECOOKIE_NAME_USER]);
    $thisrequest = '';
    $thisrequestenc = '';
    // alle Request-Parameter durchlaufen und prfen, ob der verdchtige String vorkommt
    foreach ($request as $var => $value) {
        // bei numerischen Werten, die Schleife direkt fortsetzen
        if (is_numeric($value)) {
            continue;
        }
        // bei Arrays, die Funktion rekursiv aufrufen
        if (is_array($value)) {
            $value = mxDetectGetRequestString($value);
        }
        // nur lngere Strings testen
        if (strlen($value) > 12) {
            // den Wert an die Stringkette anhngen, falls url-codiert, decodieren
            $thisrequest .= $value . ' ';
            // wenn bestimmte Parameternamen vorhanden, oder der Parametername ein cookie ist, den Wert base64 decodieren
            // tit: fr stories, pic & data fr coppermine, db fr eBoard, cookie fr hotornot, p_msg fr public-message aus nuke6.5
            // if (preg_match('#(admin|user|tit|pic|data|db|cookie|p_msg|auth)#i', $var, $base64match) || isset($_COOKIE[$var])) {
            // $thisrequest .= preg_replace('#[[:cntrl:]]#', ' ', base64_decode($value)) . ' ';
            // }
        }
    }
    // This will reproduce the option magic_quotes_gpc=1
    if (!get_magic_quotes_gpc()) {
        $thisrequest = addslashes($thisrequest);
    }
    // Stringkette von umgebenden Leerzeichen befreit, zurckgeben
    return trim(mxHtmlEntityDecode(rawurldecode($thisrequest)));
}

/**
 * /////
 */
// gibt smtliche von $_REQUEST bergebenen Scriptparameter als eine gemeinsame Zeichenkette zurck
// dies ist die Grundlage zur berprfung der request-Variablen
function mxDetectGetMessage($request)
{
    // die Sessioncookies nicht prfen
    unset($request[MX_SESSION_NAME]);
    unset($request[MX_SAFECOOKIE_NAME_ADMIN]);
    unset($request[MX_SAFECOOKIE_NAME_USER]);
    $thisrequest = '';
    $thisrequestenc = '';
    // alle Request-Parameter durchlaufen und prfen, ob der verdchtige String vorkommt
    foreach ($request as $var => $value) {
        // wenn String leer, weitermachen...
        if (!$value) {
            continue;
        }
        // bei Arrays, die Funktion rekursiv aufrufen
        if (is_array($value)) {
            $value = mxDetectGetMessage($value);
        }
        // den Wert an die Stringkette anhngen
        if (isset($_COOKIE[$var])) $type = '_COOKIE';
        else if (isset($_POST[$var])) $type = '_POST';
        else $type = '_GET';
        $thisrequest .= " \r\n" . $type . "[" . $var . "] = " . $value . ' ';
        // wenn bestimmte Parameternamen vorhanden, oder der Parametername ein cookie ist, den Wert base64 decodieren
        // tit: fr stories, pic & data fr coppermine, db fr eBoard, cookie fr hotornot
        // if ((preg_match('#(admin|user|tit|pic|data|db|cookie)#i', $var, $base64match) || isset($_COOKIE[$var])) && !is_numeric($value)) {
        // $thisrequest .= " \r\n" . $type . "[" . $var . " (encoded)] = " . preg_replace('#[[:cntrl:]]#', ' ', base64_decode($value)) . ' ';
        // }
    }
    // evtl. vorhandene backslashes entfernen und die Stringkette von umgebenden Leerzeichen befreit, zurckgeben
    return trim(stripslashes($thisrequest));
}

/**
 * /////
 */
function mxDetectCheckBanning()
{
    // Konfigurationsvariablen einlesen
    $conf = sqlCheckConfig();
    // wenn ipbanning abgeschaltet, Funktion beenden
    if (empty($conf['ipbanning'])) {
        return;
    }
    if (!@is_file($conf['ipfile'])) {
        return;
    }
    $realip = MX_REMOTE_ADDR;
    // / in mx/vkp-Versionen vor 2.2 wurde HTTP_X_FORWARDED_FOR nicht beachtet
    if (!defined('MX_VERSION_NUM')) {
        if (isset($_SERVER["HTTP_X_FORWARDED_FOR"])) $realip = $_SERVER["HTTP_X_FORWARDED_FOR"];
        else if (isset($_SERVER["HTTP_CLIENT_IP"])) $realip = $_SERVER["HTTP_CLIENT_IP"];
        else $realip = $_SERVER["REMOTE_ADDR"];
    }
    $allips = file_get_contents($conf['ipfile']);
    // if ($conf['proxybanning']) {
    // if (is_file($conf['proxyfile'])) {
    // $allips .= file_get_contents($conf['proxyfile']);
    // mxDebugFuncVars($allips);
    // }
    // }
    if (strstr($allips, $realip)) {
        $info = "\r\n" . str_repeat('-', 50) . @"
REMOTE_ADDR:          $_SERVER[REMOTE_ADDR]
HTTP_X_FORWARDED_FOR: $_SERVER[HTTP_X_FORWARDED_FOR]
HTTP_REFERER:         $_SERVER[HTTP_REFERER]
QUERY_STRING:         $_SERVER[QUERY_STRING]
REQUEST_URI:          $_SERVER[REQUEST_URI]
REMOTE_PORT:          $_SERVER[REMOTE_PORT]
REMOTE_HOST:          $_SERVER[REMOTE_HOST]
HTTP_USER_AGENT:      $_SERVER[HTTP_USER_AGENT]
"
         . mxDetectGetMessage($_REQUEST) . "\r\n";
        @error_log($info, 3, $conf['visitsfile']);
        die($conf['ipbanmsg']);
    }
}

/**
 * /////
 */
function mxDetectBannThisIp()
{
    // Konfigurationsvariablen einlesen
    $conf = sqlCheckConfig();
    $realip = MX_REMOTE_ADDR;
    // / in mx/vkp-Versionen vor 2.2 wurde HTTP_X_FORWARDED_FOR nicht beachtet
    if (!defined('MX_VERSION_NUM')) {
        if (isset($_SERVER["HTTP_X_FORWARDED_FOR"])) $realip = $_SERVER["HTTP_X_FORWARDED_FOR"];
        else if (isset($_SERVER["HTTP_CLIENT_IP"])) $realip = $_SERVER["HTTP_CLIENT_IP"];
        else $realip = $_SERVER["REMOTE_ADDR"];
    }
    @error_log($realip . "\r\n", 3, $conf['ipfile']);
    // mail senden
    if (isset($conf['sendmail'])) {
        $msg = "siteadress: " . MX_HOME_URL . "\r\nbanned-ip: " . $realip;
        foreach ($conf['sendmail'] as $mailto) {
            if (ereg('@', $mailto)) {
                $GLOBALS['mxSkipSqlDetect'] = true;
                mxMail($mailto, mxHtmlEntityDecode('IP ' . $realip . ' banned, on ' . $GLOBALS['sitename']), $msg, $GLOBALS['adminmail'], 'text', null);
            }
        }
    }
}

if (!function_exists('sqlCheckConfig')) {
    // ##############################################################################
    // die Konfiguration ist in eine Funktion gekapselt, um die Variablen nicht global zu setzen
    // die Funktion befindet sich normalerweise in der /includes/detection/config.php
    // falls die Datei fehlt oder nicht includet werden kann, wird diese Funktion hier mit Standardwerten verwendet
    function sqlCheckConfig()
    {
        static $conf;
        if ($conf) {
            return $conf;
        }
        $conf['logtype'] = 'file'; # file, sql, both
        $conf['logfile'] = PMX_DYNADATA_DIR . '/logfiles/detect.' . date('Y-m-d') . '.log';
        $conf['redirect'] = './'; #
        $conf['sendmail'][] = $GLOBALS['adminmail'];
        $conf['sendmail'][] = 'ids@pragmamx.org';
        $conf['minlen_req'] = 12; #
        $conf['minlen_sql'] = 15; #
        $conf['killsession'] = 0;
        $conf['ipbanning'] = 0;
        $conf['ipfile'] = PMX_DYNADATA_DIR . '/logfiles/banned.log';
        $conf['ipbanmsg'] = "<html><head><title>banned</title></head><body bgcolor='#DDDDDD'>
		<table width='99%' height='99%' border='10' cellspacing='30' cellpadding='100'>
		<tr align='center' valign='middle'><td>
		<img src='images/logo.gif' alt='" . $GLOBALS['sitename'] . "' border='0'>
		<h2><font color='#800000'>sorry, ip " . MX_REMOTE_ADDR . " is banned from our site</font></h2>
		<h4><br /><a href='mailto:" . mxPrepareToDisplay($GLOBALS['adminmail']) . "'>" . mxPrepareToDisplay($GLOBALS['adminmail']) . "</a></h4>
		</td></tr></table>
		</body></html>";
        $conf['visitsfile'] = PMX_DYNADATA_DIR . '/logfiles/banned_visitors.' . date('Y-m-d') . '.log';
        return $conf;
    }
}

/**
 * /////
 */
mxDetectCheckBanning();
mxDetectStart();

?>