<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.7.2.9 $
 * $Author: tora60 $
 * $Date: 2008/02/01 23:56:11 $
 */

defined('mxMainFileLoaded') or die('access denied');

/**
 * alles beginnt, mit dem Aufruf der Funktion theme_get_template() am Ende dieser Datei
 */
$GLOBALS['index'] = (empty($GLOBALS['index'])) ? 0 : 1;

global $VKPTheme;
$VKPTheme = true;
global $mxTheme;
$mxTheme = true;
global $theme_template;
$theme_template = array();

/**
 * mit dem GET-Parameter themerefresh kann das Cachefile
 * fuer das Grafikarray neu erstellt werden
 */
if (isset($_GET['themerefresh'])) {
    if (mxGetAdminPref('radminsuper')) {
        echo "<h1>themerefresh</h1>";
        theme_getmore_parts('refresh');
    }
}

/**
 * info
 */
function theme_get_template()
{
    global $theme_template;
    // wennn das Theme cacheable ist, versuchen aus dem Cache zu lesen
    if (!empty($GLOBALS['mxUseThemecache']) && defined('MX_THEME_CACHABLE') && MX_THEME_CACHABLE === true) {
        $cachefile = PMX_DYNADATA_DIR . '/cache/' . $_SERVER['HTTP_HOST'] . '.' . MX_THEME . '.template.main.php';
        if (!isset($_GET['themerefresh']) && @file_exists($cachefile) && @include($cachefile)) {
            if ($cachedata) {
                $theme_template = unserialize($cachedata);
                return $theme_template;
            }
        }
    }
    // template einlesen
    $template = file_get_contents(MX_THEME_DIR . "/" . MX_THIS_THEMEFILE);
    // alle template-Kommentare entfernen
    theme_extract_comments($template);
    // Die Funktion theme_replace_start enthaelt die Definitionen und muss in der theme.php oder functions.php vorhanden sein
    // bestimmte Texte, vor allem Image-Pfade, die ersetzt werden sollen, definieren (suche/ersetze)
    $template = theme_replace_start($template);
    // alle Bloecke auslesen und den entsprechenden Positionen zuordnen
    $allblocks = theme_define_blocks();
    foreach ($allblocks as $type => $var) {
        $theme_template[$type] = theme_extract_part($template, $type);
        if (isset($var['container']) && isset($var['position'])) {
            $theme_template['blockcontainers'][$var['container']]['posi'] = $var['position'];
            $theme_template['blockcontainers'][$var['container']]['function'] = $var['function'];
        }
    }
    $contentvars = theme_define_content();
    // die Teile fuer das Newsmodul aus dem Template extrahieren
    foreach ($contentvars['themeindex'] as $name) {
        $theme_template[$name] = theme_extract_part($template, $name);
    }
    $theme_template['themearticle'] = theme_extract_part($template, $contentvars['themearticle']);
    foreach ($contentvars['opentabs'] as $function => $arr) {
        $theme_template[$function] = theme_extract_part($template, $arr['templatevar']);
    }
    // zusaetzliche Header-Tags des Themes auslesen
    $theme_template['more_header'] = theme_extract_optional_part($template, $contentvars['add_header']);
    $theme_template['more_header'] .= "\n<!-- build with mx-templatesystem v." . mx_theme_engineversion() . " @ shiba-design.de -->\n";
    // den eigentlichen Output (body) extrahieren <body></body> muss komplett enthalten sein)
    $pattern = '#(<body[^>]*>)(.*)</body>#si';
    preg_match($pattern, $template, $matches);
    // wenn der body-Tag nicht gefunden werden konnte ist das template unbrauchbar
    if (empty($matches[2])) {
        die('<b>Template error</b><br />Failed to find valid theme body-tag (' . htmlspecialchars($pattern) . ') in :<br /><pre>' . htmlspecialchars($template) . '</pre>');
    }
    // das template enthaelt jetzt nur noch den Inhalt zwischen <body> und </body>
    $theme_template['template'] = trim($matches[2]);
    /**
     * seit pragmaMx 0.1.9 koennen die Platzhalter in einer zentralen Funktion
     * zusammengestellt und gemeinsam am Ende ersetzt werden, diese Platzhalter
     * werden hier durch einen eindeutigen String ersetzt, der verhindern soll,
     * dass diese Platzhalter durch Usereingaben beeinflusst werden koennen
     */
    if (function_exists('theme_define_placeholders')) {
        $theme_template['template'] = str_replace('{', '-:_' . md5($GLOBALS['mxSecureKey']) . '_:-', $theme_template['template']);
    }
    // body-Tag gesondert in das template-Array speichern damit er spaeter weiterbehandelt werden kann
    $theme_template['body_tag'] = $matches[1];
    // wenn die Dokumentsprache im sprachfile nicht definiert ist, wird diese aus der lokalen Einstellung generiert
    if (!defined("_DOC_LANGUAGE")) define("_DOC_LANGUAGE", strtolower(substr($GLOBALS['locale'], 0, 2)));
    // und Sprachparameter im bodytag durch lokale Einstellung ersetzen
    $pattern = '#' . sql_regcase('lang') . '.*?=.*?["|\'](.*?)["|\']#s';
    $theme_template['body_tag'] = preg_replace($pattern, ' lang="' . _DOC_LANGUAGE . '" ', $theme_template['body_tag']);
    // wennn das Theme cacheable ist, den Cache schreiben
    if (!empty($GLOBALS['mxUseThemecache']) && defined('MX_THEME_CACHABLE') && MX_THEME_CACHABLE == true) {
        $cachedata = "<?php\n"
         . "/****************************************/\n"
         . "/* pragmaMx - Web Content Management System  */\n"
         . "/****************************************/\n"
         . "defined('mxMainFileLoaded') or die('access denied');\n\n"
         . "\$cachedata='" . str_replace("'", "\'", serialize($theme_template)) . "';\n?>";
        mxChangeFilePerms($cachefile, "unlock");
        $file = @fopen($cachefile, 'w');
        @fwrite($file, $cachedata);
        @fclose($file);
    }

    return $theme_template;
    // die naechsten Ausgaben sind dann die hardgecodeten <head> Teile in der header.php
}

/**
 * info
 */
if (!function_exists('themeheader')) {
    function themeheader()
    {
        global $theme_template;
        // die Ausgaben der header.php zwischenspeichern und die Ausgabe verwerfen
        $header = ob_get_clean();
        // Puffer muesste danach Level 1 oder Level 2 bei obgzhandler sein, test:
        // mxDebugFuncVars('ob_get_status:',ob_get_status());
        // optionalen Header aus template file an die richtige stelle setzen, direkt vor bzw. nach <head>
        $header = preg_replace('#</head>#i', $theme_template['more_header'], $header);
        // die Siteservice und Debugfuncvars vorher extrahieren, falls vorhanden
        $siteservice = trim(theme_extract_optional_part($header, 'mx_site_message'));
        $debugservice = trim(theme_extract_optional_part($header, 'mx_debug_message'));
        // weitere Aenderungen am Header konfigurierbar in theme.php
        $header = theme_header($header);
        // die aus dem header extrahierten Nachrichten hier wieder anfgen,
        // dies ist dann nach dem body-Tag
        $header .= $debugservice . $siteservice;
        // Header bereits vorher abschicken
        echo trim($header);
        // den Puffer wieder neu starten fuer die weiteren Ausgaben des Moduls etc.
        ob_start();
    }
}

/**
 * Seite parsen
 */
if (!function_exists('themefooter')) {
    function themefooter()
    {
        global $theme_template;
        $part = array();
        // Im Puffer stehen hier die Ausgaben des Moduls
        $theme_template['script_output'] = ob_get_clean();
        // Spezielle Ausgabe fuer admin.php ??
        // if (defined('mxAdminFileLoaded')) {
        // echo $theme_template['script_output'];
        // exit;
        // }
        // print $theme_template['script_output'];
        // hier ist das Modul komplett durchgelaufen und die Variablen koennen jetzt im Template ersetzt werden
        $theme_template['template'] = theme_replace_vars($theme_template['template']);
        $contentvars = theme_define_content();
        theme_extract_part($theme_template['template'], $contentvars['output_container'], $theme_template['script_output']);
        unset($theme_template['script_output']);
        foreach ($theme_template['blockcontainers'] as $container => $sidex) {
            $allblocks = '';
            $blockcount[$container] = 0;
            $blocks = mxGetAllBlocks($sidex['posi']);
            foreach ($blocks as $block) {
                // nur Kompatibilitaet zu aelteren Themes
                $block['pop_javascript'] = '';
                $func = $sidex['function'];
                $created = $func($block["title"], $block["content"], $block, 'noecho');
                // Inhalte der Bloecke bei Bedarf ersetzen
                if (function_exists('theme_replace_blocks')) {
                    $created = theme_replace_blocks($created, $block);
                }
                // und den fertigen Block anfuegen
                $allblocks .= $created;
                $blockcount[$container]++;
            }
            // hier steht der Blockinhalt komplett formatiert zur Verfuegung
            theme_extract_part($theme_template['template'], $container, $allblocks);
        }
        unset($allblocks, $block, $container, $sidex, $theme_template['blockcontainers']);
        // pruefen ob ueberhaupt rechte Bloecke aktiv sind, wenn nicht $index auf 0 stellen
        // dies verhindert, dass eine leere rechte Spalte angezeigt wird
        $GLOBALS['index'] = ($blockcount[$contentvars['index_on_block_container']] > 0) ? $GLOBALS['index'] : 0;
        // je nach $index, die Tabellenspalten der rechten Bloecke extrahieren oder entfernen
        if (empty($GLOBALS['index'])) {
            $contentvars = theme_define_content();
            theme_extract_part($theme_template['template'], $contentvars['index_on_container']);
        }
        // ersetzen von eigenen Theme-Elementen, kann veraendert und ergaenzt werden
        $theme_template['template'] = theme_replace_end($theme_template['template']);
        // hier Testen der zu ersetzenden Dinge....
        // preg_match_all('#( class="(?:formbutton|formcheckbox)"){2}#si',$theme_template['template'],$matches);
        // images innerhalb von TextArea's 'entwerten', damit diese nicht ersetzt werden
        $match = 0;
        // Mist, der letzte Parameter von preg_replace_callback() ist erst ab php 5.1 verwendbar :(
        if (version_compare(PHP_VERSION, '5.1', '<')) {
            $theme_template['template'] = preg_replace_callback('#(<textarea[^>]*>.*)(\.(?:gif|jpe?g|png))?(.*</textarea>)#isU', 'theme_killimages', $theme_template['template'], -1);
            // in alten php Versionen wird dann eben die naechste Funktion immer ausgefuehrt
            $match = 1;
        } else {
            $theme_template['template'] = preg_replace_callback('#(<textarea[^>]*>.*)(\.(?:gif|jpe?g|png))?(.*</textarea>)#isU', 'theme_killimages', $theme_template['template'], -1, $match);
        }
        // Struktur des Ordners sys_images analysieren
        // ersetzen und Ausgabe in das template-Array speichern
        $theme_template['template'] = theme_replace_parts($theme_template['template'], theme_getmore_parts());
        // images innerhalb von TextArea's wieder herstellen
        if ($match) {
            $theme_template['template'] = theme_unkillimages($theme_template['template']);
        }
        // falls der sys_images-Pfad doppelt ersetzt wurde
        $folder = MX_THEME_DIR . '/sys_images/';
        $theme_template['template'] = preg_replace("#($folder){2,}#", '$1', $theme_template['template']);

        /**
         * hier wird der eindeutige String fuer die Platzhalter durch die
         * eigentlichen Platzhalter, bzw. dessen Werte ersetzt (ab 0.1.9)
         */
        if (function_exists('theme_define_placeholders')) {
            $parts = theme_define_placeholders();
            $key = '-:_' . md5($GLOBALS['mxSecureKey']) . '_:-';
            foreach ($parts as $uups) {
                $searches[] = $key . trim($uups[0], '{');
                $replaces[] = $uups[1];
            }
            $theme_template['template'] = str_replace($searches, $replaces, $theme_template['template']);
        }
        // Puffer wieder starten fuer evtl. mod_rewrite
        if (function_exists('ob_get_level')) {
            // leider ist diese Funktion erst ab php4.2 verfuegbar
            if (!ob_get_level()) {
                // Falls keine Pufferebene mehr vorhanden, obwohl in mxBaseconfig explizit gestartet...
                ob_start();
            }
        }
        // Inhalt abschicken
        echo $theme_template['template'];
    }
}

/**
 * ersetzt alle Dateiendungen von Bildern durch einen eindeutigen String
 * wird verwendet um in <textarea> die Bilderpfade/Namen unkenntlich zu machen
 * damit diese nicht durch sys_images ersetzt werden
 */
function theme_killimages($inputfield)
{
    return $inputfield[1] . preg_replace('#(gif|jpe?g|png)#i', '~~\\1~~', $inputfield[2]) . $inputfield[3];
}

/**
 * macht die Aenderungen von theme_killimages() rckgngig
 */
function theme_unkillimages($template)
{
    return preg_replace('#~~(gif|jpe?g|png)~~#i', '\\1', $template);
}

/**
 * ersetzt die php-Variablen und Konstanten innerhalb des Templates
 * Beispiele:  {$sitename} {_HOME}
 */
function theme_replace_vars($content, $searcharray = array())
{
    static $pattern;
    if (!$pattern) {
        if (function_exists('theme_define_placeholders')) {
            $key = preg_quote('-:_' . md5($GLOBALS['mxSecureKey']) . '_:-');
            $pattern = "#(?:\{|" . $key . ")([\$]?)([[:alpha:]0-9_]*)}#s";
        } else {
            $pattern = "#\{([\$]?)([[:alpha:]0-9_]*)}#s";
        }
    }
    if (preg_match_all($pattern, $content, $matches)) {
        if (isset($matches[2])) {
            if (!count($searcharray)) {
                $searcharray = $GLOBALS;
            }
            foreach($matches[2] as $key => $vari) {
                if ($matches[1][$key] == '$') {
                    if (isset($searcharray[$vari])) {
                        $search[$key] = $matches[0][$key];
                        $replace[$key] = $searcharray[$vari];
                    }
                } else if (defined($vari)) {
                    $search[$key] = $matches[0][$key];
                    $replace[$key] = constant($vari);
                }
            }
            if (isset($search)) {
                $content = str_replace($search, $replace, $content);
            }
        }
    }
    return $content;
}

/**
 * info
 */
if (!function_exists('OpenTable')) {
    function OpenTable()
    {
        ob_start();
    }
}

/**
 * info
 */
if (!function_exists('CloseTable')) {
    function CloseTable()
    {
        global $theme_template;
        $alltables = theme_define_content();
        if (isset($theme_template['OpenTable'])) {
            $out = str_replace($alltables['opentabs']['OpenTable']['innerreplace'], trim(ob_get_clean()), $theme_template['OpenTable']);
        } else {
            die('<br /><br /><b>Template error</b><br />Failed to find theme part \'OpenTable\'');
        }
        echo $out;
    }
}

/**
 * info
 */
if (!function_exists('OpenTable2')) {
    function OpenTable2()
    {
        ob_start();
    }
}

/**
 * info
 */
if (!function_exists('CloseTable2')) {
    function CloseTable2()
    {
        global $theme_template;
        $alltables = theme_define_content();
        if (isset($theme_template['OpenTable2'])) {
            $out = str_replace($alltables['opentabs']['OpenTable2']['innerreplace'], trim(ob_get_clean()), $theme_template['OpenTable2']);
        } else {
            die('<br /><br /><b>Template error</b><br />Failed to find theme part \'OpenTable2\'');
        }
        echo $out;
    }
}

/**
 * info
 */
if (!function_exists('OpenTableAl')) {
    function OpenTableAl()
    {
        ob_start();
    }
}

/**
 * info
 */
if (!function_exists('CloseTableAl')) {
    function CloseTableAl()
    {
        global $theme_template;
        $alltables = theme_define_content();
        if (isset($theme_template['OpenTableAl'])) {
            $out = str_replace($alltables['opentabs']['OpenTableAl']['innerreplace'], trim(ob_get_clean()), $theme_template['OpenTableAl']);
        } else {
            die('<br /><br /><b>Template error</b><br />Failed to find theme part \'OpenTableAl\'');
        }
        echo $out;
    }
}

/**
 * info
 */
function theme_get_morefiles($folder)
{
    $mthemedir = MX_THEME_DIR . '/sys_images';
    $string = '';
    $dir_path = $folder;
    $dir = opendir($dir_path);
    $out = array();
    while (false !== ($file = readdir($dir))) {
        if (is_dir($folder . '/' . $file) && $file != "." && $file != "..") {
            $thisdir = $folder . '/' . $file;
            $target = opendir($thisdir);
            while (false !== ($filex = readdir($target))) {
                if (preg_match("#\.gif$|\.jpe?g$|\.png$#i", $filex)) {
                    $search = addslashes(str_replace($mthemedir . '/', '', $thisdir . '/' . $filex));
                    $replace = addslashes($thisdir . '/' . $filex);
                    $out[] = "array('" . $search . "', '" . $replace . "')";
                }
            }
            $out = array_merge($out, theme_get_morefiles($folder . '/' . $file));
        }
    }
    closedir($dir);
    return $out;
}

/**
 * hier wird die Struktur des Ordners sys_images in ein Textfile gelesen
 * Anhand des darin gespeicherten Arrays werden dann die Bilder etc.
 * beim rendern der Gesamtausgabe ersetzt
 */
function theme_getmore_parts($refresh = 0)
{
    $folder = MX_THEME_DIR . '/sys_images';
    $morefile = PMX_DYNADATA_DIR . '/cache/' . $_SERVER['HTTP_HOST'] . '.' . MX_THEME . '.sys_images.php';

    if (!@is_dir($folder)) {
        if ($refresh) {
            die("<h2>Ordner " . $folder . " existiert nicht</h2>");
        }
        return array();
    }
    if (@file_exists($morefile) && !($refresh)) {
        include($morefile);
    }
    if (isset($part)) {
        return $part;
    }
    $search = "\$part = array(\n" . implode(",\n", theme_get_morefiles($folder)) . "\n);";

    $out = "<?php\n"
     . "/****************************************/\n"
     . "/* pragmaMx - Web Content Management System  */\n"
     . "/****************************************/\n"
     . "defined('mxMainFileLoaded') or die('access denied');\n"
     . "\n" . $search . "\n?>";

    mxChangeFilePerms($morefile, "unlock");
    $file = @fopen($morefile, "w");
    $ok = @fwrite($file, $out);
    @fclose($file);

    eval($search);
    return (isset($part)) ? $part : array();
}

/**
 * Extract and return block '$part_name' from the template, the part is replaced by $subst
 */
function theme_extract_part(&$template, $part_name, $subst = '')
{
    $pattern = "#(<!-- START $part_name -->)(.*?)(<!-- END $part_name -->)#s";
    if (!preg_match($pattern, $template, $matches)) {
        die('<b>Template error</b><br />Failed to find theme part \'' . $part_name . '\'(' . htmlspecialchars($pattern) . ') in :<br /><pre>' . htmlspecialchars($template) . '</pre>');
    }
    $template = str_replace($matches[1] . $matches[2] . $matches[3], $subst, $template);
    return $matches[2];
}

/**
 * Extract and return optional block '$part_name' from the template, the part is replaced by $subst
 */
function theme_extract_optional_part(&$template, $part_name, $subst = '')
{
    $pattern = "#(<!-- START $part_name -->)(.*?)(<!-- END $part_name -->)#s";
    if (!preg_match($pattern, $template, $matches)) {
        return '';
    }
    $template = str_replace($matches[1] . $matches[2] . $matches[3], $subst, $template);
    return $matches[2];
}

/**
 * Extract and return block '$part_name' from the template, the part is replaced by $subst
 */
function theme_extract_comments(&$template)
{
    $pattern = "#(<!-- START comment -->)(.*?)(<!-- END comment -->)#s";
    if (preg_match_all($pattern, $template, $matches)) {
        $template = str_replace($matches[0], '', $template);
    }
    return $matches;
}

/**
 * bestimmte Texte, vor allem Image-Pfade, die ersetzt werden sollen, definieren (suche/ersetze).
 */
function theme_replace_parts($string, $part)
{
    // wenn nix zu ersetzen, wieder zurueck
    if (!count($part)) return $string;
    // array fuer ersetzungsvorgang fuellen
    foreach ($part as $i => $item) {
        if (!is_array($item[0])) { // preg rausnehmen
            $searches[$i] = $item[0];
            $replaces[$i] = $item[1];
        }
    }
    // ersetzen und das Ergebnis in das template-Array speichern
    if (isset($searches)) {
        $string = str_replace($searches, $replaces, $string);
    }
    // die oben definierten Elemente per preg_replace ersetzen
    if (isset($part['preg'])) {
        // alte Arrays wieder loeschen
        $searches = array();
        $replaces = array();
        // array fuer ersetzungsvorgang fuellen
        foreach ($part['preg'] as $i => $item) {
            $searches[$i] = $item[0];
            $replaces[$i] = $item[1];
        }
        // ersetzen und Ausgabe in das template-Array speichern
        if (count($searches)) {
            $string = preg_replace($searches, $replaces, $string);
        }
    }
    return $string;
}

/**
 * ermittelt die Version der aktuellen Theme-Engine
 */
function mx_theme_engineversion()
{
    // ACHTUNG!! wird automatisch aus dem CVS-Header generiert !
    $eng = "\$Id: mx_themes.php,v 1.7.2.9 2008/02/01 23:56:11 tora60 Exp $";
    @ereg("([0-9]{1,2}).([0-9]{1,2}) ([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})", $eng, $regs);
    $eng = "$regs[1].$regs[2]/$regs[3]-$regs[4]-$regs[5]";
    return $eng;
}
/**
 * /////////////////////////////////////////////////////////////////////////////////
 */

/**
 * template einlesen, Funktion ist in der theme.php!
 */
theme_get_template();

/**
 * sicherstellen, dass die Ausgabe auf jeden Fall gepuffert wird
 * gzipTest: http://www.desilva.biz/gzip-test.php
 */
ob_start();

/**
 * die naechsten Ausgaben sind dann die hardgecodeten <head> Teile in der header.php
 * diese werden in den Puffer geschrieben. Danach geht es weiter mit der Funktion themeheader()
 */
?>