<?php
/**
 * This file is part of 
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.15.2.3 $
 * $Author: tora60 $
 * $Date: 2008/01/14 14:35:56 $
 */

defined('mxMainFileLoaded') or die('access denied');

// initialisiert die Variable zum Zaehlen der SQL-Abfragen
$GLOBALS['mxQueryCount'] = 0;
// Datenbanktyp explizit auf MySql stellen
$GLOBALS['dbtype'] = "MySQL";
// MySql Fehler in PHP-Errorlog speichern
if ($GLOBALS['mxSqlErrorDebug']) {
    @ini_set('track_errors', true);
    @ini_set('display_errors', true);
} 

/**
 * Datenbankverbindung herstellen
 */
function sql_connect($host, $user, $password)
{
    global $dbi; 
    // / wenn bereits Datenbankverbindung besteht....
    if (!is_resource($dbi)) {
        $dbi = @mysql_connect($host, $user, $password);
    } 
    $ok = sql_select_db($dbi);
    return $dbi;
} 

/**
 * Datenbank auswaehlen
 */
function sql_select_db($dbi)
{
    if (empty($dbi)) {
        if (mysql_errno() == 1045) {
            $msg = ("Die Benutzerdaten zur Datenbank sind falsch angegeben!");
        } else if (mysql_errno() == 2005) {
            $msg = ("Der Datenbank-Host ist falsch angegeben!");
        } else {
            $msg = mysql_error();
        } 
    } 
    if (!isset($msg)) {
        $isdb = @mysql_select_db(@$GLOBALS['dbname'], $dbi);
        if (!$isdb) {
            if (mysql_errno() == 1049) {
                $msg = ("Der Datenbank-Name ist falsch angegeben!");
            } else {
                $msg = mysql_error();
            } 
        } 
    } 
    if (isset($msg)) {
        if (!defined('MX_SQL_VERSION')) {
            define('MX_SQL_VERSION', '0');
        } 
        if ($GLOBALS['mxSqlErrorDebug']) {
            $msg = "Selection from database failed, please check the settings.<br/>Kein Zugriff auf die Datenbank moeglich, bitte ueberpruefen Sie die Einstellungen.<br/><br/><b>" . $msg . "</b><br/> mysql-error: " . mysql_errno() . '<br/><br/>' . mxDebugBacktrace(false);
        } else {
            $msg = "Sorry, wir haben zur Zeit Probleme mit der Datenbank.<br/>Sorry, we have some database-problems.<br/><br/>(" . mysql_errno() . ")";
        } 
        $msg = mxSqlPrepareMessage('<html><head><title>' . $GLOBALS['sitename'] . '</title></head><body text="#000080"><h1>' . $GLOBALS['sitename'] . '</h1>' . $msg . '<br/><br/><br/>' . MX_VERSION . '</body></html>');
        die($msg);
    } 
    if (!defined('MX_SQL_VERSION')) {
        list($mysqlversion) = mysql_fetch_row(mysql_query("SELECT VERSION() as version"));
        define('MX_SQL_VERSION', $mysqlversion);
    } 
    // Probleme mit evtl. falschem Charset beheben, ab mysql 4.1
    if (version_compare(MX_SQL_VERSION, '4.1', '>=')) {
        mysql_query('SET NAMES latin1, CHARACTER SET latin1;');
    } 
    // Datenbank-Handle zurueckgeben
    return $dbi;
} 

/**
 * nicht benoetigt, die Session beendet die Verbindung
 */
function sql_logout($dbid = "")
{
    return true;
} 

/**
 * Liefert die ID einer vorherigen INSERT-Operation
 */
function sql_insert_id($dbid = "")
{
    if (empty($dbid)) $dbid = $GLOBALS['dbi'];
    return @mysql_insert_id($dbid);
} 

/**
 * liefert die Anzahl betroffener Datensaetze durch die letzte INSERT, UPDATE oder DELETE Anfrage
 * an den Server, die mit der angegebenen Verbindungs-Kennung assoziiert wird.
 * Wird die Verbindungskennung nicht angegeben, wird die letzte durch mysql_connect() geoeffnete Verbindung angenommen
 */
function sql_affected_rows($dbid = "")
{
    if (empty($dbid)) $dbid = $GLOBALS['dbi'];
    return intval(@mysql_affected_rows($dbid));
} 

/**
 * sql_query($query, $dbid)
 * executes an SQL statement, returns a result identifier
 */
function sql_query($query, $dbid = "")
{
    global $mxSqlDebug;
    if (empty($dbid)) $dbid = $GLOBALS['dbi']; 
    // wenn sql_inject berpruefung eingeschaltet
    if (!$GLOBALS['mxSkipSqlDetect'] && $GLOBALS['vkpSafeSqlinject']) {
        $query = mxDetectCheckQuery($query);
    } 
    $GLOBALS['mxSkipSqlDetect'] = false; 
    // $query = convert65(trim($query));
    $GLOBALS["mxQueryCount"] ++; // Counter fuer Query-Zaehlung erhoehen  
    if ($mxSqlDebug) {
        echo '<p class="tiny" style="text-align: left;"><b>SQL query</b>:<br/>' . mxSqlPrepareMessage($query) . '</p>';
    } 
    if (mxDemoMode()) {
        if (mxDemoCheckSql($query)) {
            return true;
        } 
    } 
    $php_errormsg = null; 
    // die eigentliche DB-Anfrage ausfuehren
    $result = @mysql_query($query, $dbid); 
    // Fehlerbehandlung
    if ($GLOBALS['mxSqlErrorDebug'] && (!$result || mysql_errno() || $php_errormsg)) {
        if (!is_resource($dbid)) {
            echo ("Keine gueltige Datenbankverbindung (\$dbi = $dbid)");
        } else {
            $n1 = (isset($php_errormsg)) ? $php_errormsg : mysql_error();
            $n2 = (isset($php_errormsg)) ? "php" : "mysql " . mysql_errno();
            echo mxSqlPrepareMessage('<br/><b>Error sql_query():</b><br/>qry: <b>' . $query . '</b><br/>descr:<b> ' . $n1 . '</b> ( ' . $n2 . ' )<br/><br/>' . mxDebugBacktrace(false));
        } 
        return false;
    } else {
        return $result;
    } 
} 

/**
 * sql_num_rows($result)
 * given a result identifier, returns the number of affected rows
 */
function sql_num_rows($result)
{
    $rows = intval(@mysql_num_rows($result));
    if (!empty($php_errormsg) && $GLOBALS['mxSqlErrorDebug']) {
        $n1 = (isset($php_errormsg)) ? $php_errormsg : mysql_error();
        echo mxSqlPrepareMessage('<br/><b>Error sql_num_rows():</b><br/>descr:<b> ' . $n1 . '</b><br/><br/>' . mxDebugBacktrace(false));
    } 
    return $rows;
} 

/**
 * sql_fetch_row($result,$row)
 * given a result identifier, returns an array with the resulting row
 */
function sql_fetch_row($result)
{
    $row = array();
    $row = @mysql_fetch_row($result);
    if (!empty($php_errormsg) && $GLOBALS['mxSqlErrorDebug']) {
        $n1 = (isset($php_errormsg)) ? $php_errormsg : mysql_error();
        echo mxSqlPrepareMessage('<br/><b>Error sql_fetch_row():</b><br/>descr:<b> ' . $n1 . '</b><br/><br/>' . mxDebugBacktrace(false));
    } 
    return $row;
} 

/**
 * sql_fetch_array($result,$row)
 * given a result identifier, returns an associative and numeric array
 * with the resulting row using field names as keys.
 */
function sql_fetch_array($result, $xx = "")
{
    $row = array();
    $row = @mysql_fetch_array($result);
    if (!empty($php_errormsg) && $GLOBALS['mxSqlErrorDebug']) {
        $n1 = (isset($php_errormsg)) ? $php_errormsg : mysql_error();
        echo mxSqlPrepareMessage('<br/><b>Error sql_fetch_array():</b> <br/>descr:<b> ' . $n1 . '</b><br/><br/>' . mxDebugBacktrace(false));
   } 
    return $row;
} 

/**
 * sql_fetch_assoc($result,$row)
 * given a result identifier, returns an associative array
 * with the resulting row using field names as keys.
 */
function sql_fetch_assoc($result)
{
    $row = array();
    $row = @mysql_fetch_array($result, MYSQL_ASSOC);
    if (!empty($php_errormsg) && $GLOBALS['mxSqlErrorDebug']) {
        $n1 = (isset($php_errormsg)) ? $php_errormsg : mysql_error();
        echo mxSqlPrepareMessage('<br/><b>Error sql_fetch_assoc():</b> <br/>descr:<b> ' . $n1 . '</b><br/><br/>' . mxDebugBacktrace(false));
    } 
    return $row;
} 

/**
 * sql_fetch_assoc($result,$row)
 * given a result identifier, returns an object
 */
function sql_fetch_object($result, $dbid = "")
{ 
    $row = @mysql_fetch_object($result);
    if (!empty($php_errormsg) && $GLOBALS['mxSqlErrorDebug']) {
        $n1 = (isset($php_errormsg)) ? $php_errormsg : mysql_error();
        echo mxSqlPrepareMessage('<br/><b>Error sql_fetch_object():</b> <br/>descr:<b> ' . $n1 . '</b><br/><br/>' . mxDebugBacktrace(false));
    } 
    if ($row) return $row;
    else return false;
} 

/**
 * Fetch all rows in an array
 */
function sql_fetch_rowset($result)
{
    $rowset = array();
    while ($row = @mysql_fetch_array($result, MYSQL_ASSOC)) {
        $rowset[] = $row;
    } 
    return $rowset;
} 

/**
 * Function Free Result for function free the memory **
 */
function sql_free_result($result)
{
    $row = @mysql_free_result($result);
    return $row;
} 

/**
 * compatibility for phpNuke Modules
 */
function convert65($query)
{
    if (!ereg($GLOBALS['user_prefix'] . "_users", $query)) {
        return $query;
    } 
    if ($GLOBALS['mxSqlErrorDebug']) echo "before = $query<br/>";
    $search = array(" username " , ",username" , "username," , "username=");
    $replace = array(" uname AS username " , ",uname AS username" , "uname AS username," , "uname=");
    $query = str_replace($search, $replace, $query);
    $search = array(" user_id " , ",user_id" , "user_id," , "user_id=");
    $replace = array(" uid AS user_id " , ",uid AS user_id" , "uid AS user_id," , "uid=");
    $query = str_replace($search, $replace, $query);
    $search = array(" user_email " , ",user_email" , "user_email," , "user_email=");
    $replace = array(" email AS user_email " , ",email AS user_email" , "email AS user_email," , "email=");
    $query = str_replace($search, $replace, $query);
    $search = array(" user_password " , ",user_password" , "user_password," , "user_password=");
    $replace = array(" pass AS user_password " , ",pass AS user_password" , "pass AS user_password," , "pass=");
    $query = str_replace($search, $replace, $query);
    $search = array(" user_website " , ",user_website" , "user_website," , "user_website=");
    $replace = array(" url AS user_website " , ",url AS user_website" , "url AS user_website," , "url=");
    $query = str_replace($search, $replace, $query);
    $search = array(" user_interests " , ",user_interests" , "user_interests," , "user_interests=");
    $replace = array(" user_intrest AS user_interests " , ",user_intrest AS user_interests" , "user_intrest AS user_interests," , "user_intrest=");
    $query = str_replace($search, $replace, $query);
    $query = preg_replace('#(.*\s*)((?:order by|where)\s*.*)(uname)(\s*=.*)#is', '\1\2username\4', $query);
    $query = preg_replace('#(.*\s*)((?:order by|where)\s*.*)(uid)(\s*=.*)#is', '\1\2user_id\4', $query);
    if ($GLOBALS['mxSqlErrorDebug']) echo "after = $query<br/>";
    return $query;
} 

/**
 * Check der Datenbankabfragen, ob im Demomode ausfuehren oder nicht
 */
function mxDemoCheckSql($query)
{
    global $prefix;
    $query = strtoupper(trim($query)); 
    // / hier koennen Strings z.B. Tabellennamen angegeben werden, die die Abfrage ungueltig machen
    $search = array("^INSERT ", "^REPLACE ", "^UPDATE ", "^DELETE ");
    $search = implode("|", $search);
    if (ereg($search, $query)) {
        // / hier koennen Strings z.B. Tabellennamen angegeben werden, die die Abfrage gueltig machen
        $search = array("${prefix}_securelog", "${prefix}_tracking", "${prefix}_counter", "${prefix}_stats", "${prefix}_visitors", MX_SESSION_DBTABLE, "set `cache_");
        $search = implode("|", $search);
        if (!ereg($search, $query)) {
            return true;
        } 
    } 
    return false;
} 

/**
 * u.A. die Datenbankverbindungsdaten aus den Fehlermeldungen entfernen
 */
function mxSqlPrepareMessage($msg) {
      $search = array(',', $GLOBALS['dbhost'], $GLOBALS['dbname'] , $GLOBALS['dbuname'] , $GLOBALS['dbpass'], $GLOBALS['prefix'], $GLOBALS['user_prefix']);
      $relace= array(', ', '{dbhost}', '{dbname}' , '{dbuname}' , '{dbpass}', '{prefix}', '{user_prefix}');
      $msg= str_replace($search, $relace, $msg);
      return $msg;      
}
?>
