<?php
/**
 * This file is part of 
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.5 $
 * $Author: tora60 $
 * $Date: 2008/02/03 18:40:13 $
 */

defined('mxMainFileLoaded') or die('access denied');
$modname = basename(dirname(dirname(__FILE__)));

unset($sqlqry);

if (!isset($tables["${prefix}_downloads_downloads"])) {
    $sqlqry[] = "
CREATE TABLE `${prefix}_downloads_downloads` (
  `lid` int(11) NOT NULL auto_increment,
  `cid` int(11) NOT NULL default '0',
  `sid` int(11) NOT NULL default '0',
  `title` varchar(100) NOT NULL default '',
  `url` varchar(255) NOT NULL default '',
  `description` text NULL,
  `date` datetime default NULL,
  `name` varchar(100) NOT NULL default '',
  `email` varchar(100) NOT NULL default '',
  `hits` int(11) NOT NULL default '0',
  `submitter` varchar(60) NOT NULL default '',
  `downloadratingsummary` double(6,4) NOT NULL default '0.0000',
  `totalvotes` int(11) NOT NULL default '0',
  `totalcomments` int(11) NOT NULL default '0',
  `filesize` int(11) NOT NULL default '0',
  `version` varchar(20) NOT NULL default '',
  `homepage` varchar(200) NOT NULL default '',
  PRIMARY KEY  (`lid`),
  KEY `cid` (`cid`),
  KEY `hits` (`hits`),
  KEY `title` (`title`),
  KEY `date` (`date`),
  KEY `downloadratingsummary` (`downloadratingsummary`)
) TYPE=MyISAM;";
}

if (!isset($tables["${prefix}_downloads_newdownload"])) {
    $sqlqry[] = "
CREATE TABLE `${prefix}_downloads_newdownload` (
  `lid` int(11) NOT NULL auto_increment,
  `cid` int(11) NOT NULL default '0',
  `sid` int(11) NOT NULL default '0',
  `title` varchar(100) NOT NULL default '',
  `url` varchar(255) NOT NULL default '',
  `description` text NULL,
  `name` varchar(100) NOT NULL default '',
  `email` varchar(100) NOT NULL default '',
  `submitter` varchar(60) NOT NULL default '',
  `filesize` int(11) NOT NULL default '0',
  `version` varchar(10) NOT NULL default '',
  `homepage` varchar(200) NOT NULL default '',
  `updated` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`lid`)
) TYPE=MyISAM;";
}

if (isset($tables["${prefix}_downloads_categories"])) {
    // Felder aktualisieren
    $tf = setupGetTableFields("${prefix}_downloads_categories");
    if (!isset($tf['parentid'])) {
        // nuke < 5.5
        $sqlqry[] = "ALTER TABLE `${prefix}_downloads_categories` ADD `parentid` INT( 11 ) NOT NULL DEFAULT '0'";
        $nukebefore55 = true;
    } else {
        if ($tf['parentid']['Type'] != 'int(11)') $sqlqry[] = "ALTER TABLE `${prefix}_downloads_categories` CHANGE `parentid` `parentid` INT( 11 ) NOT NULL DEFAULT '0';";
    }
} else {
    $sqlqry[] = "
CREATE TABLE `${prefix}_downloads_categories` (
  `cid` int(11) NOT NULL auto_increment,
  `title` varchar(100) NOT NULL default '',
  `cdescription` text NULL,
  `parentid` int(11) NOT NULL default '0',
  `captcha` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`cid`),
  KEY `title` (`title`)
) TYPE=MyISAM;";
}

if (!isset($tables["${prefix}_downloads_editorials"])) {
    $sqlqry[] = "
CREATE TABLE `${prefix}_downloads_editorials` (
  `downloadid` int(11) NOT NULL default '0',
  `adminid` varchar(60) NOT NULL default '',
  `editorialtimestamp` datetime NOT NULL default '0000-00-00 00:00:00',
  `editorialtext` text NULL,
  `editorialtitle` varchar(100) NOT NULL default '',
  PRIMARY KEY  (`downloadid`)
) TYPE=MyISAM;";
}

if (!isset($tables["${prefix}_downloads_modrequest"])) {
    $sqlqry[] = "
CREATE TABLE `${prefix}_downloads_modrequest` (
  `requestid` int(11) NOT NULL auto_increment,
  `lid` int(11) NOT NULL default '0',
  `cid` int(11) NOT NULL default '0',
  `sid` int(11) NOT NULL default '0',
  `title` varchar(100) NOT NULL default '',
  `url` varchar(100) NOT NULL default '',
  `description` text NULL,
  `modifysubmitter` varchar(60) NOT NULL default '',
  `brokendownload` int(3) NOT NULL default '0',
  `name` varchar(100) NOT NULL default '',
  `email` varchar(100) NOT NULL default '',
  `filesize` int(11) NOT NULL default '0',
  `version` varchar(10) NOT NULL default '',
  `homepage` varchar(200) NOT NULL default '',
  `updated` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`requestid`)
) TYPE=MyISAM;";
}

if (!isset($tables["${prefix}_downloads_votedata"])) {
    $sqlqry[] = "
CREATE TABLE `${prefix}_downloads_votedata` (
  `ratingdbid` int(11) NOT NULL auto_increment,
  `ratinglid` int(11) NOT NULL default '0',
  `ratinguser` varchar(60) NOT NULL default '',
  `rating` int(11) NOT NULL default '0',
  `ratinghostname` varchar(60) NOT NULL default '',
  `ratingcomments` text NULL,
  `ratingtimestamp` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`ratingdbid`)
) TYPE=MyISAM;";
}

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}
// downloads Tabelle aendern nuke < 5.5
// based on: Links Table Alteration - patched by simplywebdesign.com  20-01-2002
if (isset($tables["${prefix}_downloads_subcategories"]) && isset($nukebefore55)) {
    $result = @mysql_query("select sid, cid, title from ${prefix}_downloads_subcategories order by sid");
    while (list($sid, $cid, $title) = @mysql_fetch_row($result)) {
        setupDoAllQueries("insert into ${prefix}_downloads_categories SET title='" . addslashes(strip_tags($title)) . "', parentid=" . intval($cid) . "");
        $result1 = @mysql_query("select max(cid) from ${prefix}_downloads_categories");
        while (list($lastcat) = @mysql_fetch_row($result1)) {
            $result2 = @mysql_query("select lid from ${prefix}_downloads_downloads where sid = " . intval($sid) . "");
            while (list($lid) = @mysql_fetch_row($result2)) {
                $sqlqry[] = "UPDATE ${prefix}_downloads_downloads set cid = " . intval($lastcat) . " where lid= " . intval($lid) . "";
            }
        }
    }
    $sqlqry[] = "RENAME TABLE `${prefix}_downloads_subcategories` TO `" . RENAME_PREFIX . "${prefix}_downloads_subcategories`;";
    unset($sid, $cid, $title, $lastcat, $lid, $nukebefore55);
}

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}

if (isset($tables["${prefix}_downloads_modrequest"])) {
    $tf = setupGetTableFields("${prefix}_downloads_modrequest");
    if (!isset($tf['updated']))$sqlqry[] = "ALTER TABLE `${prefix}_downloads_modrequest` ADD `updated` DATETIME NOT NULL";
}

if (isset($tables["${prefix}_downloads_newdownload"])) {
    $tf = setupGetTableFields("${prefix}_downloads_newdownload");
    if (!isset($tf['updated']))$sqlqry[] = "ALTER TABLE `${prefix}_downloads_newdownload` ADD `updated` DATETIME NOT NULL";
    if ($tf['url']['Type'] != 'varchar(255)') $sqlqry[] = "ALTER TABLE `${prefix}_downloads_newdownload` CHANGE `url` `url` VARCHAR( 255 ) NOT NULL";
}

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}

if (isset($tables["${prefix}_downloads_categories"])) {
    $tf = setupGetTableFields("${prefix}_downloads_categories");
    if ($tf['cid']['Type'] != 'int(11)') $sqlqry[] = "ALTER TABLE `${prefix}_downloads_categories` CHANGE `cid` `cid` INT( 11 ) NOT NULL DEFAULT '0' AUTO_INCREMENT;";
    if ($tf['title']['Type'] != 'varchar(100)') $sqlqry[] = "ALTER TABLE `${prefix}_downloads_categories` CHANGE `title` `title` VARCHAR( 100 ) NOT NULL default ''";
    if (isset($tf['parentid']) && $tf['parentid']['Type'] != 'int(11)') $sqlqry[] = "ALTER TABLE ${prefix}_downloads_categories CHANGE parentid parentid INT(11) NOT NULL default '0';";
    if (isset($tf['view'])) $sqlqry[] = "ALTER TABLE `${prefix}_downloads_categories` DROP `view` "; // cp
    if (isset($tf['mainid'])) $sqlqry[] = "ALTER TABLE `${prefix}_downloads_categories` DROP `mainid` "; // cp
    if (!isset($tf['captcha'])) {
        $sqlqry[] = "ALTER TABLE `${prefix}_downloads_categories` ADD `captcha` TINYINT( 1 ) NOT NULL DEFAULT '0'";
        $sqlqry[] = "UPDATE `${prefix}_downloads_categories` SET `captcha` = 0";
    }
    $tf = setupGetTableFields("${prefix}_downloads_categories");
    if ($tf['cdescription']['Default'] !== null || $tf['title']['Default'] === null) {
        $sqlqry[] = "ALTER TABLE `${prefix}_downloads_categories`
                CHANGE `cdescription` `cdescription` text NULL,
                CHANGE `title` `title` VARCHAR( 100 ) NOT NULL DEFAULT '' ";
    }
}

if (isset($tables["${prefix}_downloads_downloads"])) {
    // Felder aktualisieren
    $tf = setupGetTableFields("${prefix}_downloads_downloads");
    if ($tf['url']['Type'] != 'varchar(255)') $sqlqry[] = "ALTER TABLE `${prefix}_downloads_downloads` CHANGE `url` `url` VARCHAR( 255 ) NOT NULL default ''";
    if ($tf['date']['Type'] != 'datetime') $sqlqry[] = "ALTER TABLE `${prefix}_downloads_downloads` CHANGE `date` `date` datetime default NULL;";
    if ($tf['version']['Type'] != 'varchar(20)') $sqlqry[] = "ALTER TABLE `${prefix}_downloads_downloads` CHANGE `version` `version` VARCHAR( 20 ) NOT NULL default ''";
    if (isset($tf['view'])) $sqlqry[] = "ALTER TABLE `${prefix}_downloads_downloads` DROP `view` "; // cp
    #mxDebugFuncVars($tf); #exit;
    if ($tf['description']['Default'] !== null || $tf['url']['Default'] === null || $tf['version']['Default'] === null) {
        $sqlqry[] = "ALTER TABLE `${prefix}_downloads_downloads`
                CHANGE `description` `description` text NULL,
                CHANGE `url` `url` varchar(255) NOT NULL default '',
                CHANGE `version` `version` varchar(20) NOT NULL default '' ";
    }
}

if (isset($tables["${prefix}_downloads_editorials"])) {
    $tf = setupGetTableFields("${prefix}_downloads_editorials");
    if ($tf['editorialtext']['Default'] !== null) {
        $sqlqry[] = "ALTER TABLE `${prefix}_downloads_editorials`
                CHANGE `editorialtext` `editorialtext` text NULL";
    }
}

if (isset($tables["${prefix}_downloads_modrequest"])) {
    $tf = setupGetTableFields("${prefix}_downloads_modrequest");
    if ($tf['description']['Default'] !== null || $tf['updated']['Default'] === null) {
        $sqlqry[] = "ALTER TABLE `${prefix}_downloads_modrequest`
                CHANGE `description` `description` text NULL,
                CHANGE `updated` `updated` datetime NOT NULL default '0000-00-00 00:00:00'";
    }
}

if (isset($tables["${prefix}_downloads_newdownload"])) {
    $tf = setupGetTableFields("${prefix}_downloads_newdownload");
    if ($tf['description']['Default'] !== null || $tf['updated']['Default'] === null || $tf['url']['Default'] === null) {
        $sqlqry[] = "ALTER TABLE `${prefix}_downloads_newdownload`
                CHANGE `description` `description` text NULL,
                CHANGE `updated` `updated` datetime NOT NULL default '0000-00-00 00:00:00',
                CHANGE `url` `url` varchar(255) NOT NULL default '' ";
    }
}

if (isset($tables["${prefix}_downloads_votedata"])) {
    $tf = setupGetTableFields("${prefix}_downloads_votedata");
    if ($tf['ratingcomments']['Default'] !== null) {
        $sqlqry[] = "ALTER TABLE `${prefix}_downloads_votedata`
                CHANGE `ratingcomments` `ratingcomments` text NULL";
    }
}

/**
 * feststellen, ob Kategorien vorhanden sind, die als Parent wieder auf sich
 * selbst verweisen und versuchen dies zu aendern, indem bei diesen Kategorien
 * die Parent-Id auf 0 gesetzt wird, also der Hauptkategorie zugeordnet wird
 */
$arr = array();
$qry = "SELECT cid, parentid FROM `${prefix}_downloads_categories` ORDER BY cid";
$result = mysql_query($qry);
while ($row = mysql_fetch_assoc($result)) {
    $arr[$row['cid']] = intval($row['parentid']);
}
if ($arr) {
    $flip = array_flip($arr);
    foreach($flip as $parent => $cid) {
        if (isset($arr[$parent]) && $arr[$parent] == $cid) {
            $sqlqry[] = "UPDATE `${prefix}_downloads_categories` SET `parentid` = 0 WHERE cid=" . $cid . " OR cid=" . $parent . "";
        }
    }
}
// ENDE ab pragmaMx 0.1.9
if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}
// indexe aktualisieren
$indexes = setupGetTableIndexes("${prefix}_downloads_categories");
if (isset($indexes['cid'])) $sqlqry[] = "ALTER TABLE `${prefix}_downloads_categories` DROP INDEX `cid` ";
if (!isset($indexes['title'])) $sqlqry[] = "ALTER TABLE `${prefix}_downloads_categories` ADD INDEX `title` ( `title` )";

$indexes = setupGetTableIndexes("${prefix}_downloads_downloads");
if (!isset($indexes['cid'])) $sqlqry[] = "ALTER TABLE `${prefix}_downloads_downloads` ADD INDEX `cid` ( `cid` )";
if (!isset($indexes['hits'])) $sqlqry[] = "ALTER TABLE `${prefix}_downloads_downloads` ADD INDEX `hits` ( `hits` )";
if (!isset($indexes['title'])) $sqlqry[] = "ALTER TABLE `${prefix}_downloads_downloads` ADD INDEX `title` ( `title` )";
if (!isset($indexes['date'])) $sqlqry[] = "ALTER TABLE `${prefix}_downloads_downloads` ADD INDEX `date` ( `date` )";
if (isset($indexes['ddate'])) $sqlqry[] = "ALTER TABLE `${prefix}_downloads_downloads` DROP INDEX ddate";
if (!isset($indexes['downloadratingsummary'])) $sqlqry[] = "ALTER TABLE `${prefix}_downloads_downloads` ADD INDEX `downloadratingsummary` ( `downloadratingsummary` )";
if (isset($indexes['lid'])) $sqlqry[] = "ALTER TABLE `${prefix}_downloads_downloads` DROP INDEX `lid` ";
if (isset($indexes['sid'])) $sqlqry[] = "ALTER TABLE `${prefix}_downloads_downloads` DROP INDEX `sid` ";

$indexes = setupGetTableIndexes("${prefix}_downloads_modrequest");
if (isset($indexes['requestid'])) $sqlqry[] = "ALTER TABLE `${prefix}_downloads_modrequest` DROP INDEX `requestid` ";
if (isset($indexes['PRIMARY']) && $indexes['PRIMARY']['Column_name'] != 'requestid') {
    $sqlqry[] = "ALTER TABLE `${prefix}_downloads_modrequest` DROP PRIMARY KEY , ADD PRIMARY KEY ( `requestid` ) ";
} else if (!isset($indexes['PRIMARY'])) {
    $sqlqry[] = "ALTER TABLE `${prefix}_downloads_modrequest` ADD PRIMARY KEY ( `requestid` ) ";
}

$indexes = setupGetTableIndexes("${prefix}_downloads_editorials");
if (isset($indexes['downloadid'])) $sqlqry[] = "ALTER TABLE `${prefix}_downloads_editorials` DROP INDEX `downloadid` ";

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}

?>