<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.8.2.6 $
 * $Author: tora60 $
 * $Date: 2008/01/28 15:35:56 $
 *
 * this file based on:
 * Automated FAQ
 * Copyright 2001 by Richard Tirtadji AKA King Richard (rtirtadji@hotmail.com)
 * and Hutdik Hermawan AKA hotFix (hutdik76@hotmail.com)
 * http://www.phpnuke.web.id
 * php-nuke Web Portal System - http://phpnuke.org/
 * Thatware - http://thatware.org/
 */

defined('mxMainFileLoaded') or die('access denied');

$module_name = basename(dirname(__FILE__));
mxGetLangfile($module_name);

/* Captchas verwenden? */
require("includes/captcha/settings.php");
$captcha_faqon = (!empty($faqon) && ((!MX_IS_USER) || ((MX_IS_USER) && ($captchauseron))) && (!MX_IS_ADMIN));

/* Seitentitel-Fallback */
$pagetitle = _FAQ2;


/* was du wolle? */
switch (true) {

    /* neue FAQ anfuegen */
    case (isset($_REQUEST['faqaddnew']) && $faqaddnew == 'y'):
        $faqaddsave = (empty($_POST['faqaddsave'])) ? "" : $_POST['faqaddsave'];
        $faqname = (empty($_POST['faqname'])) ? "" : mxStripSlashes($_POST['faqname']);
        $faqemail = (empty($_POST['faqemail'])) ? "" : mxStripSlashes($_POST['faqemail']);
        $faqquestion = (empty($_POST['faqquestion'])) ? "" : mxStripSlashes($_POST['faqquestion']);
        $faqaddcat = (empty($_POST['faqaddcat'])) ? 0 : $_POST['faqaddcat'];

        $error = "";

        if ($faqaddsave == 'y') {
            $faqname = str_replace('"', "'", $faqname);
            $faqquestion = str_replace('"', "'", $faqquestion);
            $faqaddsave = '';

            if ($faqquestion == '') {
                // Frage gestellt?
                $error = _QUESTION . '?';
            } else if (!empty($faqemail) && !mxCheckEmail($faqemail)) {
                // gueltige Mailadresse?
                $error = "'" . $faqemail . "' " . _WRONGMAIL;
                $faqemail = '';
            } else if (empty($faqname)) {
                // Name vorhanden?
                $error = _ENTERNAME;
            }
            // captcha pruefen
            if (!$error && $captcha_faqon) {
                if (empty($_POST['captcha'])) {
                    $error = _CAPTCHAWRONG;
                } else {
                    require_once("includes/captcha/__captcha/PhraseFactory.php");
                    $storedCaptcha = PhraseFactory::get('', $GLOBALS['passphraselenght'], $_POST['captcha'], $GLOBALS['storagetype']);
                    if ($_POST['captcha'] !== $storedCaptcha) {
                        $error = _CAPTCHAWRONG;
                    }
                }
            }
            // wenn kein Fehler, Frage anfuegen
            if (!$error) {
                $faqaddsave = 'y';
                // Frage anfuegen
                $query = "INSERT INTO ${prefix}_faqnew (name,email,question,date,id_cat,ip) VALUES (
    			'" . mxAddSlashesForSQL(strip_tags($faqname)) . "',
    			'" . mxAddSlashesForSQL(strip_tags($faqemail)) . "',
    			'" . mxAddSlashesForSQL(strip_tags($faqquestion)) . "',
    			NOW(),
    			" . intval($faqaddcat) . ",
    			'" . MX_REMOTE_ADDR . "')";
                $result1 = sql_query($query);
                if (!$result1) {
                    mxErrorScreen("Database-Error");
                    return;
                }
                // User benachrichtigen
                if (!empty($faqemail) && $result1) {
                    $message = _DEAR . " " . $faqname . "\n\n"
                     . _USEMAIL1 . " " . MX_REMOTE_ADDR . " " . _USEMAIL2 . "\n"
                     . _USEMAIL3 . "\n"
                     . $GLOBALS['sitename'] . " (" . MX_HOME_URL . ")\n\n"
                     . _QUEST1 . "\n"
                     . "\t$faqquestion\n\n"
                     . _NOMESS . "\n\n"
                     . _SEE1 . " " . $GLOBALS['sitename'] . " " . _WEBSITE . "\n\n"
                     . _GREETS . "\n"
                     . $GLOBALS['sitename'] . " " . _TEAM;
                    $subject = _THANKS1 . " " . $GLOBALS['sitename'];
                    $sender = $faqemail;
                    // mxDebugFuncVars($message);
                    mxMail($faqemail, $subject, $message, $sender, "text", "", "" . $GLOBALS['sitename'] . " " . _VISITOR . "");
                }
                // Admin benachrichtigen
                if (!empty($GLOBALS['notify']) && !empty($GLOBALS['notify_email']) && $result1) {
                    $message = _HI . " " . $GLOBALS['sitename'] . " " . _ADMIN . ",\n\n"
                     . _USER1 . " '" . $faqname . "' ($faqemail) [" . MX_REMOTE_ADDR . "] " . _QUESTION3 . "\n\n"
                     . "\t$faqquestion\n\n"
                     . _DIRECT . " " . MX_HOME_URL . "/admin.php?op=FaqAnswerNew " . _ANSWER . "\n\n"
                     . _GREETS . "\n" . _TEAM;
                    $subject = _QUESTION2 . " '" . $GLOBALS['sitename'] . "'";
                    $sender = $faqemail;
                    // mxDebugFuncVars($sender, $subject);
                    @mxMail($GLOBALS['adminmail'], $subject, $message, $sender, "text", "", "" . $GLOBALS['sitename'] . " " . _VISITOR . "");
                }
                // die("Subject:".$subject.", Message:".$message." Senderemail:".$sender."
                $msg = '<b>' . _THANKS1 . '</b><br>' . _THANKS3;
                mxRedirect('modules.php?name=' . $module_name . '&cat=' . intval($faqaddcat), $msg, 5);
                return;
            }
        }

        if (MX_IS_USER) {
            $usersession = mxGetUserSession();
            $faqname = $usersession[1];
        } else {
            $faqname = $GLOBALS['anonymous'];
        }

        if ($faqaddsave != 'y') {
            $categories = (empty($_REQUEST['categories'])) ? "" : $_REQUEST['categories'];
            $cat = (empty($_REQUEST['cat'])) ? "" : $_REQUEST['cat'];

            if ($GLOBALS["multilingual"] == 1) {
                if (ereg("german", $GLOBALS["currentlang"])) $thislang = "german";
                else $thislang = $GLOBALS["currentlang"];
                $querylang = "WHERE (flanguage LIKE '" . $thislang . "%' OR flanguage='')";
            } else {
                $querylang = "";
            }
            $result = sql_query("select id_cat, categories from ${prefix}_faqcategories $querylang ORDER BY categories");
            while (list($idcat, $categorie) = sql_fetch_row($result)) {
                $sel = ($cat == $idcat) ? " selected='selected'" : '';
                $options[] = "<option value='" . $idcat . "'" . $sel . ">" . $categorie . "</option>";
            }
            include('header.php');
            title(_ADDFAQ);
            if ($error) {
                openTableAl();
                echo '<b>' . _FERROR . '</b>:<br>' . $error . '';
                closeTableAl();
                echo '<br><br>';
            }
            OpenTable();
            echo '<font class="title">' . _NEWQUEST . ':</font>';
            echo '<form method="post" action="modules.php?name=' . $module_name . '">';
            echo '<table border="0" cellspacing="0" cellpadding="5">';
            echo '<tr><td>' . _YNAME . '</td><td><input type="text" size="25" name="faqname" value="' . $faqname . '"></td></tr>';
            echo '<tr><td>' . _YMAIL . '</td><td>' . _YMAILINFO . '<br><input type="text" size="40" name="faqemail" value="' . $faqemail . '"></td></tr>';
            echo '<tr><td>' . _YQUEST . '</td><td>' . _MAXCHAR . '<br><input type="text" size="80" name="faqquestion" value="' . $faqquestion . '"></td></tr>';
            if (isset($options)) {
                echo '<tr><td>' . _CATEGORY . '</td><td><select name="cat">' . implode("\n", $options) . '</select></td></tr>';
            }
            if ($captcha_faqon) {
                require('includes/captcha/captcha_java.php');
                echo '<tr><td>&nbsp;</td><td>
            <img id="captchaimage" src="includes/captcha/captchaimg.php?' . md5(crypt(uniqid(""))) . '" alt=""><br />
            <input type="text" name="captcha" value="" size="20" maxlength="20">
            <input type="button" value="' . _CAPTCHARELOAD . '" onclick="do_reload(); return false;">
            <br />' . _CAPTCHAINSERT . '</td></tr>';
            }
            echo '<tr><td colspan="2"><input type="submit" value="' . _FAQSEND . '">';
            echo '<input type="hidden" name="categories" value="' . $categories . '">';
            echo '<input type="hidden" name="faqaddcat" value="' . $cat . '">';
            echo '<input type="hidden" name="faqaddnew" value="y">';
            echo '<input type="hidden" name="faqaddsave" value="y">';
            echo '<input type="hidden" name="name" value="' . $module_name . '"> </td></tr>';
            echo '</table>';
            echo '</form>';
            CloseTable();
            include('footer.php');
        }

        break;


    /* Liste aller Kategorien (faq-Startseite) */
    case empty($_GET['cat']):
        if ($GLOBALS["multilingual"] == 1) {
            if (ereg("german", $GLOBALS["currentlang"])) $thislang = "german";
            else $thislang = $GLOBALS["currentlang"];
            $querylang = "WHERE (flanguage LIKE '" . $thislang . "%' OR flanguage='')";
        } else {
            $querylang = "";
        }
        $result = sql_query("select id_cat, categories from ${prefix}_faqcategories $querylang");
        include('header.php');
        title(_FAQ2);
        OpenTable();
        echo "<table width=\"100%\" cellpadding=\"4\" cellspacing=\"0\" border=\"0\">"
         . "<tr><td bgcolor=\"$bgcolor2\"><font class=\"option\"><b>" . _CATEGORIES . "</b></font></td></tr><tr><td>";
        while (list($idcat, $categories) = sql_fetch_row($result)) {
            echo"<strong><big>&middot;</big></strong>&nbsp;<a href=\"modules.php?name=" . $module_name . "&amp;cat=" . $idcat . "\">$categories</a><br>";
        }
        echo "</td></tr></table>";
        CloseTable();
        include('footer.php');

        break;


    /* Anzeige einer Kategorie */
    default:

        $cat = (empty($_REQUEST['cat'])) ? 0 : intval($_REQUEST['cat']);
        $result = sql_query("select categories from ${prefix}_faqcategories where id_cat=" . intval($cat));
        list($categories) = sql_fetch_row($result);
        $pagetitle = _FAQ . ': ' . $categories;
        include('header.php');
        title(_FAQ2);
        OpenTable();
        $categories = strip_tags(urldecode($categories));
        $result = sql_query("select id, question, answer from ${prefix}_faqanswer where id_cat='" . intval($cat) . "' order by id");
        echo"<a name=\"top\">&nbsp;</a>"
         . "<br>" . _CATEGORY . ": <a href=\"modules.php?name=" . $module_name . "\">" . _MAIN . "</a> -&gt; " . ($categories) . "<br><br>";
        echo "<table width=\"100%\" cellpadding=\"4\" cellspacing=\"0\" border=\"0\">"
         . "<tr bgcolor=\"$bgcolor2\"><td><font class=\"option\"><font class='option'>" . _QUESTION . "</font></font></td></tr><tr><td>";
        while (list($id, $question, $answer) = sql_fetch_row($result)) {
            echo"<strong><big>&middot;</big></strong>&nbsp;&nbsp;<a href=\"#f$id\">$question</a><br>";
        }
        echo "<br><b>" . _INFO1 . " <a href='modules.php?name=" . $module_name . "&amp;faqaddnew=y&amp;cat=" . $cat . "'>" . _INFO2 . "</a> " . _INFO3 . "</b>";
        echo "</td></tr></table><br>";
        CloseTable();
        echo '<br>';
        OpenTable();
        $result = sql_query("select id, question, answer from ${prefix}_faqanswer where id_cat='" . intval($cat) . "' order by id");
        echo "<table width=\"100%\" cellpadding=\"4\" cellspacing=\"0\" border=\"0\">"
         . "<tr bgcolor=\"$bgcolor2\"><td><font class=\"option\"><font class='option'>" . _ANSWER . "</font></font></td></tr>";
        while (list($id, $question, $answer) = sql_fetch_row($result)) {
            echo"<tr><td class='content'><a id=\"f" . $id . "\" name=\"f" . $id . "\"></a>"
             . "<hr size='1' noshade style='border: 1px solid $bgcolor3;'><strong><big>&middot;</big></strong>&nbsp;&nbsp;<b><span style='font-size:larger'>" . $question . "</span></b>"
             . "<div align=\"justify\" class='content'>" . $answer . "</div>"
             . "<br><div align='right'>[&nbsp;<a href=\"#top\">" . _BACKTOTOP . "</a>&nbsp;]</div><br>"
             . "</td></tr>";
        }
        echo "</table><br><br>"
         . "<div align=\"center\"><b>[&nbsp;<a href=\"modules.php?name=" . $module_name . "\">" . _BACKTOFAQINDEX . "</a>&nbsp;]</b></div>";
        CloseTable();
        include('footer.php');
}

?>