<?php
/**
 * This file is part of 
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.3 $
 * $Author: tora60 $
 * $Date: 2007/12/22 14:15:56 $
 */

defined('mxMainFileLoaded') or die('access denied');
$modname = basename(dirname(dirname(__FILE__)));

unset($sqlqry);
// -- Tabellenstruktur fuer Tabelle `${prefix}_gallery_categories`
if (!isset($tables["${prefix}_gallery_categories"])) {
    $sqlqry[] = "
CREATE TABLE `${prefix}_gallery_categories` (
  `gallid` int(3) NOT NULL auto_increment,
  `gallname` varchar(30) NOT NULL default '',
  `gallimg` varchar(50) NOT NULL default '',
  `galloc` longtext,
  `description` text NULL,
  `parent` int(3) NOT NULL default '-1',
  `visible` tinyint(3) unsigned NOT NULL default '0',
  `template` int(10) unsigned NOT NULL default '2',
  `thumbwidth` int(2) unsigned NOT NULL default '70',
  `numcol` tinyint(3) unsigned NOT NULL default '3',
  `total` int(10) unsigned NOT NULL default '0',
  `lastadd` date NOT NULL default '0000-00-00',
  PRIMARY KEY  (`gallid`)
) TYPE=MyISAM;
";
    // -- Daten fuer Tabelle `${prefix}_gallery_categories`
    $sqlqry[] = "INSERT INTO `${prefix}_gallery_categories` VALUES (1, 'Fun4You', 'chikin_thumb.jpg', 'fun4you', 'Fun und nochmals fun :))...', -1, 2, 2, 70, 2, 2, '2002-03-07')";
}
// -- --------------------------------------------------------
// -- Tabellenstruktur fuer Tabelle `${prefix}_gallery_comments`
if (!isset($tables["${prefix}_gallery_comments"])) {
    $sqlqry[] = "
CREATE TABLE `${prefix}_gallery_comments` (
  `cid` int(10) unsigned NOT NULL auto_increment,
  `pid` int(10) unsigned NOT NULL default '0',
  `comment` text NULL,
  `date` datetime NOT NULL default '0000-00-00 00:00:00',
  `name` varchar(255) default NULL,
  `member` tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (`cid`)
) TYPE=MyISAM;
";
}
// -- --------------------------------------------------------
// -- Tabellenstruktur fuer Tabelle `${prefix}_gallery_media_class`
if (!isset($tables["${prefix}_gallery_media_class"])) {
    $sqlqry[] = "
CREATE TABLE `${prefix}_gallery_media_class` (
  `id` int(2) NOT NULL default '0',
  `class` varchar(10) NOT NULL default '',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;
";
    // -- Daten fuer Tabelle `${prefix}_gallery_media_class`
    $sqlqry[] = "INSERT INTO `${prefix}_gallery_media_class` VALUES (1, 'Image')";
    $sqlqry[] = "INSERT INTO `${prefix}_gallery_media_class` VALUES (2, 'Audio')";
    $sqlqry[] = "INSERT INTO `${prefix}_gallery_media_class` VALUES (3, 'Video')";
}
// -- --------------------------------------------------------
// -- Tabellenstruktur fuer Tabelle `${prefix}_gallery_media_types`
if (!isset($tables["${prefix}_gallery_media_types"])) {
    $sqlqry[] = "
CREATE TABLE `${prefix}_gallery_media_types` (
  `extension` varchar(10) NOT NULL default '',
  `description` text NULL,
  `filetype` varchar(20) NOT NULL default '',
  `displaytag` text NULL,
  `thumbnail` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`extension`)
) TYPE=MyISAM;
";
    // -- Daten fuer Tabelle `${prefix}_gallery_media_types`
    $sqlqry[] = "INSERT INTO `${prefix}_gallery_media_types` VALUES ('bmp', 'Image/BMP', '1', '<img src=\"<:FILENAME:>\" border=\"0\" alt=\"<:DESCRIPTION:>\">', 'image_gif.gif')";
    $sqlqry[] = "INSERT INTO `${prefix}_gallery_media_types` VALUES ('gif', 'Image/GIF', '1', '<img src=\"<:FILENAME:>\" border=\"0\" width=\"<:WIDTH:>\" height=\"<:HEIGHT:>\" alt=\"<:DESCRIPTION:>\">', 'image_gif.gif')";
    $sqlqry[] = "INSERT INTO `${prefix}_gallery_media_types` VALUES ('jpg', 'Image/JPG', '1', '<img src=\"<:FILENAME:>\" border=\"0\" width=\"<:WIDTH:>\" height=\"<:HEIGHT:>\" alt=\"<:DESCRIPTION:>\">', 'image_jpg.gif')";
    $sqlqry[] = "INSERT INTO `${prefix}_gallery_media_types` VALUES ('png', 'Image/PNG', '1', '<img src=\"<:FILENAME:>\" border=\"0\" width=\"<:WIDTH:>\" height=\"<:HEIGHT:>\" alt=\"<:DESCRIPTION:>\">', 'image_png.gif')";
    $sqlqry[] = "INSERT INTO `${prefix}_gallery_media_types` VALUES ('mov', 'Video/Quicktime', '3', '<embed controller=\"true\" width=\"<:WIDTH:>\" height=\"<:HEIGHT:>\" src=\"<:FILENAME:>\" border=\"0\" pluginspage=\"http://www.apple.com/quicktime/download/indext.html\"></embed>', 'video_mov.gif')";
    $sqlqry[] = "INSERT INTO `${prefix}_gallery_media_types` VALUES ('avi', 'Video/AVI', '3', '<embed src=\"<:FILENAME:>\" border=\"0\" width=\"<:WIDTH:>\" height=\"<:HEIGHT:>\" type=\"application/x-mplayer2\"></embed>', 'video_avi.gif')";
    $sqlqry[] = "INSERT INTO `${prefix}_gallery_media_types` VALUES ('mpg', 'Video/MPEG', '3', '<embed src=\"<:FILENAME:>\" border=\"0\" width=\"<:WIDTH:>\" height=\"<:HEIGHT:>\" type=\"application/x-mplayer2\"></embed>', 'video_mpg.gif')";
    $sqlqry[] = "INSERT INTO `${prefix}_gallery_media_types` VALUES ('mp3', 'Audio/MP3', '2', '<embed controller=\"true\" width=\"200\" height=\"20\" src=\"<:FILENAME:>\" border=\"0\" pluginspage=\"http://www.apple.com/quicktime/download/indext.html\"></embed>', 'audio_mp3.gif')";
    $sqlqry[] = "INSERT INTO `${prefix}_gallery_media_types` VALUES ('mid', 'Audio/MIDI', '2', '<embed src=\"<:FILENAME:>\" type=\"audio/midi\" hidden=\"false\" autostart=\"true\" loop=\"true\" height=\"20\" width=\"200\"></embed>', 'audio_mid.gif')";
    $sqlqry[] = "INSERT INTO `${prefix}_gallery_media_types` VALUES ('swf', 'Video/Flash', '3', '<embed src=\"<:FILENAME:>\" pluginspage=\"http://www.macromedia.com/shockwave/download/index.cgi?P1_Prod_Version=ShockwaveFlash\" type=\"application/x-shockwave-flash\" width=\"<:WIDTH:>\" height=\"<:HEIGHT:>\" play=\"true\" loop=\"true\" quality=\"high\" scale=\"showall\" menu=\"true\"></embed>', 'video_swf.gif')";
    $sqlqry[] = "INSERT INTO `${prefix}_gallery_media_types` VALUES ('rm', 'Video/RealMedia', '3', '<OBJECT>\" height=\"<:HEIGHT:>\">\n<param name=\"CONTROLS\" value=\"ImageWindow\" />\n<param name=\"AUTOSTART\" Value=\"true\" />\n<param name=\"SRC\" value=\"<:FILENAME:>\" />\n<embed height=\"<:HEIGHT:>\" width=\"<:WIDTH:>\" controls=\"ImageWindow\" src=\"<:FILENAME:>?embed\" type=\"audio/x-pn-realaudio-plugin\" autostart=\"true\" nolabels=\"0\" autogotourl=\"-1\"></OBJECT>', 'video_realmedia.gif')";
}
// -- --------------------------------------------------------
// -- Tabellenstruktur fuer Tabelle `${prefix}_gallery_pictures`
if (!isset($tables["${prefix}_gallery_pictures"])) {
    $sqlqry[] = "
CREATE TABLE `${prefix}_gallery_pictures` (
  `pid` int(10) unsigned NOT NULL auto_increment,
  `gid` int(3) NOT NULL default '0',
  `img` varchar(255) NOT NULL default '',
  `counter` int(10) unsigned NOT NULL default '0',
  `submitter` varchar(24) NOT NULL default 'Webmaster',
  `date` datetime default NULL,
  `name` varchar(255) NOT NULL default '',
  `description` text NULL,
  `votes` int(10) unsigned NOT NULL default '0',
  `rate` float NOT NULL default '0',
  `extension` varchar(10) NOT NULL default 'image',
  `width` smallint(5) unsigned NOT NULL default '0',
  `height` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`pid`)
) TYPE=MyISAM;
";
    // -- Daten fuer Tabelle `${prefix}_gallery_pictures`
    $sqlqry[] = "INSERT INTO `${prefix}_gallery_pictures` VALUES (1, 1, 'Nordsee_1.jpg', 38, 'AdminTeam', '2002-03-07 18:56:21', 'Nordsee_1.jpg', '', 0, 0, 'jpg', 297, 417)";
    $sqlqry[] = "INSERT INTO `${prefix}_gallery_pictures` VALUES (2, 1, 'Nordsee_2.jpg', 28, 'AdminTeam', '2002-03-07 18:56:21', 'Nordsee_2.jpg', '', 0, 0, 'jpg', 295, 420)";
}
// -- --------------------------------------------------------
// -- Tabellenstruktur fuer Tabelle `${prefix}_gallery_pictures_newpicture`
if (!isset($tables["${prefix}_gallery_pictures_newpicture"])) {
    $sqlqry[] = "
CREATE TABLE `${prefix}_gallery_pictures_newpicture` (
  `pid` int(10) unsigned NOT NULL auto_increment,
  `gid` int(3) NOT NULL default '0',
  `img` varchar(255) NOT NULL default '',
  `counter` int(10) unsigned NOT NULL default '0',
  `submitter` varchar(24) NOT NULL default 'Webmaster',
  `date` datetime default NULL,
  `name` varchar(255) NOT NULL default '',
  `description` text NULL,
  `votes` int(10) unsigned NOT NULL default '0',
  `rate` float NOT NULL default '0',
  `extension` varchar(10) NOT NULL default 'image',
  `width` smallint(5) unsigned NOT NULL default '0',
  `height` smallint(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`pid`)
) TYPE=MyISAM;
";
}
// -- --------------------------------------------------------
// -- Tabellenstruktur fuer Tabelle `${prefix}_gallery_rate_check`
if (!isset($tables["${prefix}_gallery_rate_check"])) {
    $sqlqry[] = "
CREATE TABLE `${prefix}_gallery_rate_check` (
  `ip` varchar(20) NOT NULL default '',
  `time` varchar(14) NOT NULL default '',
  `pid` int(10) unsigned NOT NULL default '0'
) TYPE=MyISAM;
";
}
// -- --------------------------------------------------------
// -- Tabellenstruktur fuer Tabelle `${prefix}_gallery_template_types`
if (!isset($tables["${prefix}_gallery_template_types"])) {
    $sqlqry[] = "
CREATE TABLE `${prefix}_gallery_template_types` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `title` varchar(255) NOT NULL default '',
  `type` tinyint(3) unsigned NOT NULL default '2',
  `templateCategory` longtext NULL,
  `templatePictures` longtext NULL,
  `templateCSS` longtext,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM;
";
    // -- Daten fuer Tabelle `${prefix}_gallery_template_types`
    $sqlqry[] = "INSERT INTO `${prefix}_gallery_template_types` VALUES (1, 'Default Main Page Template', 1, '<table align=\"center\">\n<tr>\n<td colspan=\"2\">\n<:GALLNAME:>\n</td>\n</tr>\n<tr>\n<td>\n<:IMAGE:>\n</td>\n<td valign=\"top\" align=\"left\">\n<:DESCRIPTION:>\n</td>\n</tr>\n</table>', '2', '.common_text_black {text-color:#000000}\n.common_text_white {text-color:#ffffff}')";
    $sqlqry[] = "INSERT INTO `${prefix}_gallery_template_types` VALUES (2, 'Default', 2, '<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\">\n<tr>\n<td>\n<:IMAGE:>\n</td>\n<td valign=\"top\">\n<p>\n<table>\n<tr>\n<td align=\"center\">\n<:DATE:>\n</td>\n<td align=\"center\">\n<:RATE:>\n</td>\n<td align=\"center\">\n<:HITS:>\n</td>\n<td align=\"center\">\n<:NEW:>\n</td>\n</tr>\n</table>\n</p>\n<p>\n<:DESCRIPTION:>\n</p>\n<p>\n<:NBCOMMENTS:>|<:FORMAT:>|<:SIZE:>\n</p>\n	</td>\n</tr>\n</table>', '<table>\n<tr>\n	<td valign=\"top\" align=\"center\">\n<:NAMESIZE:>\n<br /><br />\n<TABLE CellPadding=\"0\" CellSpacing=\"0\">\n<TR>\n<TD valign=\"top\">\n<:SUBMITTER:>\n<:DATE:>\n<:HITS:>\n<:RATE:>\n</TD>\n	</TR>\n	</table><br />\n<:RATINGBAR:><br />\n<:POSTCARD:><br />\n<:DOWNLOAD:><br />\n<:PRINT:>\n</td>\n	<td width=\"80%\" align=\"center\">\n<:IMAGE:>\n</td>\n</tr>\n<tr>\n<td colspan=\"2\"><:DESCRIPTION:></td>\n</tr>\n<tr>\n	<td colspan=\"2\">\n		<:COMMENTS:>\n	</td>\n</tr>\n</table>', '.common_text_black {text-color:#000000}\n.common_text_white {text-color:#ffffff}')";
}
// -- --------------------------------------------------------
if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}

$indexes = setupGetTableIndexes("${prefix}_gallery_categories");
if (isset($indexes['gallid'])) $sqlqry[] = "ALTER TABLE `${prefix}_gallery_categories` DROP INDEX `gallid` ";
if (isset($indexes['PRIMARY']) && $indexes['PRIMARY']['Column_name'] != 'gallid') {
    $sqlqry[] = "ALTER TABLE `${prefix}_gallery_categories` DROP PRIMARY KEY , ADD PRIMARY KEY ( `gallid` ) ";
} else if (!isset($indexes['PRIMARY'])) {
    $sqlqry[] = "ALTER TABLE `${prefix}_gallery_categories` ADD PRIMARY KEY ( `gallid` ) ";
}
$indexes = setupGetTableIndexes("${prefix}_gallery_media_class");
if (isset($indexes['id'])) $sqlqry[] = "ALTER TABLE `${prefix}_gallery_media_class` DROP INDEX `id` ";
if (isset($indexes['PRIMARY']) && $indexes['PRIMARY']['Column_name'] != 'id') {
    $sqlqry[] = "ALTER TABLE `${prefix}_gallery_media_class` DROP PRIMARY KEY , ADD PRIMARY KEY ( `id` ) ";
} else if (!isset($indexes['PRIMARY'])) {
    $sqlqry[] = "ALTER TABLE `${prefix}_gallery_media_class` ADD PRIMARY KEY ( `id` ) ";
}
$indexes = setupGetTableIndexes("${prefix}_gallery_pictures");
if (isset($indexes['pid'])) $sqlqry[] = "ALTER TABLE `${prefix}_gallery_pictures` DROP INDEX `pid` ";
if (isset($indexes['PRIMARY']) && $indexes['PRIMARY']['Column_name'] != 'pid') {
    $sqlqry[] = "ALTER TABLE `${prefix}_gallery_pictures` DROP PRIMARY KEY , ADD PRIMARY KEY ( `pid` ) ";
} else if (!isset($indexes['PRIMARY'])) {
    $sqlqry[] = "ALTER TABLE `${prefix}_gallery_pictures` ADD PRIMARY KEY ( `pid` ) ";
}
$indexes = setupGetTableIndexes("${prefix}_gallery_pictures_newpicture");
if (isset($indexes['pid'])) $sqlqry[] = "ALTER TABLE `${prefix}_gallery_pictures_newpicture` DROP INDEX `pid` ";
if (isset($indexes['PRIMARY']) && $indexes['PRIMARY']['Column_name'] != 'pid') {
    $sqlqry[] = "ALTER TABLE `${prefix}_gallery_pictures_newpicture` DROP PRIMARY KEY , ADD PRIMARY KEY ( `pid` ) ";
} else if (!isset($indexes['PRIMARY'])) {
    $sqlqry[] = "ALTER TABLE `${prefix}_gallery_pictures_newpicture` ADD PRIMARY KEY ( `pid` ) ";
}

if (isset($tables["${prefix}_gallery_categories"])) {
    $tf = setupGetTableFields("${prefix}_gallery_categories");
    if ($tf['description']['Default'] !== null) {
        $sqlqry[] = "ALTER TABLE `${prefix}_gallery_categories`
                CHANGE `description` `description` text NULL";
    }
}

if (isset($tables["${prefix}_gallery_comments"])) {
    $tf = setupGetTableFields("${prefix}_gallery_comments");
    if ($tf['comment']['Default'] !== null) {
        $sqlqry[] = "ALTER TABLE `${prefix}_gallery_comments`
                CHANGE `comment` `comment` text NULL";
    }
}

if (isset($tables["${prefix}_gallery_media_types"])) {
    $tf = setupGetTableFields("${prefix}_gallery_media_types");
    if ($tf['description']['Default'] !== null || $tf['displaytag']['Default'] !== null) {
        $sqlqry[] = "ALTER TABLE `${prefix}_gallery_media_types`
                CHANGE `description` `description` text NULL,
                CHANGE `displaytag` `displaytag` text NULL";
    }
}

if (isset($tables["${prefix}_gallery_pictures"])) {
    $tf = setupGetTableFields("${prefix}_gallery_pictures");
    if ($tf['description']['Default'] !== null) {
        $sqlqry[] = "ALTER TABLE `${prefix}_gallery_pictures`
                CHANGE `description` `description` text NULL";
    }
}

if (isset($tables["${prefix}_gallery_pictures_newpicture"])) {
    $tf = setupGetTableFields("${prefix}_gallery_pictures_newpicture");
    if ($tf['description']['Default'] !== null) {
        $sqlqry[] = "ALTER TABLE `${prefix}_gallery_pictures_newpicture`
                CHANGE `description` `description` text NULL";
    }
}

if (isset($tables["${prefix}_gallery_template_types"])) {
    $tf = setupGetTableFields("${prefix}_gallery_template_types");
    if ($tf['templateCategory']['Default'] !== null || $tf['templatePictures']['Default'] !== null) {
        $sqlqry[] = "ALTER TABLE `${prefix}_gallery_template_types`
                CHANGE `templateCategory` `templateCategory` longtext NULL,
                CHANGE `templatePictures` `templatePictures` longtext NULL";
    }
}

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}

?>