<?php
/**
 * This file is part of 
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.3.2.3 $
 * $Author: tora60 $
 * $Date: 2007/12/24 02:16:03 $
 *
 * this file based on:
 * My_eGallery
 * Copyright (c) 2001 by ~ MarsIsHere ~ (marsishere@yahoo.fr), http://www.marsishere.net
 * php-nuke Web Portal System - http://phpnuke.org/
 * Thatware - http://thatware.org/
 */

if (!defined("mxMainFileLoaded")) die ("You can't access this file directly...");

function RatioResizeImg($src_file, $dest_file, $gid)
{
    global $gallerypath, $galleryvar, $prefix, $dbi;
    list($newWidth) = sql_fetch_array(sql_query("SELECT thumbwidth from " . $prefix . "_gallery_categories WHERE gallid=" . intval($gid) . "", $dbi), $dbi);

    switch ($galleryvar['imageSoftware']) {
        case "GD":
            return RatioResizeImgGD($src_file, $dest_file, $newWidth);
            break;
        case "ImageMagick":
            return RatioResizeImgImageMagick($src_file, $dest_file, $newWidth);
            break;
        case "none":
            return $src_file;
            break;
        case "browser":
            return 'browser';
            break;
        case "NetPBM":
            return RatioResizeImgNetPBM($src_file, $dest_file, $newWidth);
            break;
        default: return $src_file;
            break;
    }
}
// GD Library
function RatioResizeImgGD($src_file, $dest_file, $newWidth)
{
    global $gallerypath;
    if (!function_exists('imagecreate')) {
        return $src_file;
    }
    $imginfo = @getimagesize($src_file);

    switch ($imginfo[2]) {
        case 1:
            $type = IMG_GIF;
            break;

        case 2:
            $type = IMG_JPG;
            break;

        case 3:
            $type = IMG_PNG;
            break;

        case 4:
            $type = IMG_WBMP;
            break;

        default:
            return $src_file;
            break;
    }
    switch ($type) {
        case IMG_GIF:
            if (!function_exists('imagecreatefromgif')) {
                return $src_file;
            }
            $srcImage = @imagecreatefromgif("$src_file");
            break;

        case IMG_JPG:
            if (!function_exists('imagecreatefromjpeg')) {
                return $src_file;
            }
            $srcImage = @ImageCreateFromJpeg($src_file);
            break;

        case IMG_PNG:
            if (!function_exists('imagecreatefrompng')) {
                return $src_file;
            }
            $srcImage = @imagecreatefrompng("$src_file");
            break;

        case IMG_WBMP:
            if (!function_exists('imagecreatefromwbmp')) {
                return $src_file;
            }
            $srcImage = @imagecreatefromwbmp("$src_file");
            break;

        default: return $src_file;
    }
    if ($srcImage) {
        // height/width
        $srcWidth = $imginfo[0];
        $srcHeight = $imginfo[1];
        $ratioWidth = $srcWidth / $newWidth;
        $destWidth = $newWidth;
        $destHeight = $srcHeight / $ratioWidth;
        // resize
        $destImage = @imagecreate($destWidth, $destHeight);
        imagecopyresized($destImage, $srcImage, 0, 0, 0, 0, $destWidth, $destHeight, $srcWidth, $srcHeight);
        // create and save final picture
        switch ($type) {
            case IMG_GIF:
                @imagegif($destImage, "$dest_file");
                break;

            case IMG_JPG:
                @imagejpeg($destImage, "$dest_file");
                break;

            case IMG_PNG:
                @imagepng($destImage, "$dest_file");
                break;

            case IMG_WBMP:
                @imagewbmp($destImage, "$dest_file");
                break;
        }
        // free the memory
        @imagedestroy($srcImage);
        @imagedestroy($destImage);
        return $dest_file;
    } else {
        return $src_file;
    }
}

function RatioResizeImgImageMagick($src_file, $dest_file, $newWidth)
{
    global $gallerypath, $galleryvar;
    // find the image size
    $imginfo = @getimagesize($src_file);
    if ($imginfo == null) {
        return $src_file;
    }
    // height/width
    $srcWidth = $imginfo[0];
    $srcHeight = $imginfo[1];
    $ratioWidth = $srcWidth / $newWidth;
    $ratioHeight = 0;
    // $destWidth = $newWidth;
    $destHeight = $srcHeight / $ratioWidth;
    // resize
    // echo "convert -quality 80 -antialias -sample \"".$destWidth."x".$destHeight."\" \"$src_file\" \"$dest_file\"";
    // exec("convert -quality 80 -antialias -sample \"".$destWidth."x".$destHeight."\" \"$src_file\" \"$dest_file\"");
    if ($galleryvar['imageSoftwarePath'] == '') {
        exec("convert -geometry \"" . $newWidth . "x" . $newWidth . "\" \"$src_file\" \"$dest_file\"");
    } else {
        exec($galleryvar['imageSoftwarePath'] . "/convert -geometry \"" . $newWidth . "x" . $newWidth . "\" \"$src_file\" \"$dest_file\"");
    }
    return $dest_file;
}

function RatioResizeImgNetPBM($src_file, $dest_file, $newWidth)
{
    global $galleryvar;
    if (strtoupper(substr(PHP_OS, 0, 3)) == "WIN") {
        $imginfo = @getimagesize($src_file);
        if (!$galleryvar['imageSoftwarePath'] == '') {
            $cmd1 = $galleryvar['imageSoftwarePath'] . "\\";
            $cmd2 = $galleryvar['imageSoftwarePath'] . "\\";
            $cmd3 = $galleryvar['imageSoftwarePath'] . "\\";
            $cmd4 = $galleryvar['imageSoftwarePath'] . "\\";
        } else {
            $cmd1 = "";
        }
        switch ($imginfo[2]) {
            case 1:
                $cmd1 .= "giftopnm $src_file >tmp.ppm";
                $cmd2 .= "pnmscale -width $newWidth tmp.ppm >tmp1.ppm";
                $cmd3 .= "ppmquant 256 tmp1.ppm >tmp2.ppm";
                $cmd4 .= "ppmtogif tmp2.ppm >$dest_file";
                break;

            case 2:
                $cmd1 .= "jpegtopnm $src_file >tmp.ppm";
                $cmd2 .= "pnmscale -width $newWidth tmp.ppm >tmp1.ppm";
                $cmd3 .= "ppmquant 256 tmp1.ppm >tmp2.ppm";
                $cmd4 .= "ppmtogif tmp2.ppm >$dest_file";
                break;

            case 3:
                $cmd1 .= "pngtopnm $src_file >tmp.ppm";
                $cmd2 .= "pnmscale -width $newWidth tmp.ppm >tmp1.ppm";
                $cmd3 .= "ppmquant 256 tmp1.ppm >tmp2.ppm";
                $cmd4 .= "ppmtogif tmp2.ppm >$dest_file";
                break;

            default:
                return $src_file;
                break;
        }

        $cmd1 = str_replace("/", "\\", $cmd1);
        $cmd2 = str_replace("/", "\\", $cmd2);
        $cmd3 = str_replace("/", "\\", $cmd3);
        $cmd4 = str_replace("/", "\\", $cmd4);
        exec($cmd1);
        exec($cmd2);
        exec($cmd3);
        exec($cmd4);
        unlink("tmp.ppm");
        unlink("tmp1.ppm");
        unlink("tmp2.ppm");
        return $dest_file;
    } else {
        $imginfo = @getimagesize($src_file);
        if (!$galleryvar['imageSoftwarePath'] == '') {
            $cmd99 = $galleryvar['imageSoftwarePath'] . "/";
        } else {
            $cmd = "";
        }
        switch ($imginfo[2]) {
            case 1:
                If ($imginfo[0] > $imginfo[1]) {
                    $cmd .= "" . $cmd99 . "giftopnm $src_file | " . $cmd99 . "pnmscale -height $newWidth | " . $cmd99 . "ppmquant 256 | " . $cmd99 . "ppmtogif > $dest_file";
                } else if ($imginfo[0] <= $imginfo[1]) {
                    $cmd .= "" . $cmd99 . "giftopnm $src_file | " . $cmd99 . "pnmscale -width $newWidth | " . $cmd99 . "ppmquant 256 | " . $cmd99 . "ppmtogif > $dest_file";
                }

                break;

            case 2:
                If ($imginfo[0] > $imginfo[1]) {
                    $cmd .= "" . $cmd99 . "jpegtopnm $src_file | " . $cmd99 . "pnmscale -height $newWidth | " . $cmd99 . "ppmquant 256 | " . $cmd99 . "ppmtogif >$dest_file";
                } else if ($imginfo[0] <= $imginfo[1]) {
                    $cmd .= "" . $cmd99 . "jpegtopnm $src_file | " . $cmd99 . "pnmscale -width $newWidth | " . $cmd99 . "ppmquant 256 | " . $cmd99 . "ppmtogif >$dest_file";
                }
                break;

            case 3:
                If ($imginfo[0] > $imginfo[1]) {
                    $cmd .= "" . $cmd99 . "pngtopnm $src_file | " . $cmd99 . "pnmscale -height $newWidth | " . $cmd99 . "ppmquant 256 | " . $cmd99 . "ppmtogif >$dest_file";
                } else if ($imginfo[0] <= $imginfo[1]) {
                    $cmd .= "" . $cmd99 . "pngtopnm $src_file | " . $cmd99 . "pnmscale -width $newWidth | " . $cmd99 . "ppmquant 256 | " . $cmd99 . "ppmtogif >$dest_file";
                }
                break;

            default:
                return $src_file;
                break;
        }
        // $cmd --quiet $src_file | pnmscale --quiet -xscale 0.5 -yscale 0.5| ppmquant --quiet 128 | $cmd1 --quiet > $dest_file
        exec($cmd);
        return $dest_file;
    }
}

?>
