<?php
/**
 * This file is part of 
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.5.2.2 $
 * $Author: tora60 $
 * $Date: 2007/12/22 14:11:52 $
 *
 * this file based on:
 * php-nuke Web Portal System - http://phpnuke.org/
 * Thatware - http://thatware.org/
 * Part of phpBB integration
 * Copyright (c) 2001 by
 * Richard Tirtadji AKA King Richard (rtirtadji@hotmail.com)
 * Hutdik Hermawan AKA hotFix (hutdik76@hotmail.com)
 * http://www.phpnuke.web.id
 */

defined('mxMainFileLoaded') or die('access denied');
global $url_smiles, $smilie;
// #####################################################################
function pmPrepDisplay($msg)
{
    return mxNL2BR(msg_smile(msg_bbencode(make_clickable($msg))));
}
// #####################################################################
function pmUndoPrepDisplay($msg)
{
    return msg_bbdecode(msg_desmile(mxUndoNltobr($msg)));
}
// #####################################################################
/*
 * Changes :) to an <IMG> tag based on the smiles table in the database.
 * Smilies must be either:
 *   - at the start of the message.
 *   - at the start of a line.
 *   - preceded by a space or a period.
 * This keeps them from breaking HTML code and BBCode.
 * TODO: Get rid of global variables.
 */
function msg_smile($message)
{
    global $url_smiles, $smilie;
    if (empty($url_smiles) || empty($smilie)) {
        include("modules/" . basename(dirname(__FILE__)) . "/config.php");
    }
    reset($smilie);
    $message = " " . $message; // Pad it with a space so the regexp can match.
    $message = str_replace(array('&#41;', '&#124;'), array(')', '|'), $message); /// macht mxSecureValue() rckgngig
    foreach ($smilie as $vals) {
        $smile_code = preg_quote($vals[0]);
        $smile_code = str_replace('/', '//', $smile_code);
        $message = preg_replace("/([\n\\ \\.])$smile_code/si", '\1<IMG SRC="' . $url_smiles . '/' . $vals[2] . '">', $message);
    }
    // Remove padding, return the new string.
    $message = trim($message);
    return($message);
}

/*
 * Changes a Smiliy <IMG> tag into its corresponding smile
 * TODO: Get rid of golbal variables, and implement a method of distinguishing between :D and :grin: using the <IMG> tag
 */
function msg_desmile($message)
{
    global $url_smiles, $smilie;
    if (empty($url_smiles) || empty($smilie)) {
        include("modules/" . basename(dirname(__FILE__)) . "/config.php");
    }
    reset($smilie);
    $message = str_replace(array('&#41;', '&#124;'), array(')', '|'), $message); /// macht mxSecureValue() rckgngig
    foreach ($smilie as $vals) {
        $smile_code = preg_quote($vals[0]);
        $smile_code = str_replace('/', '//', $smile_code);
        $message = str_replace(" <IMG SRC=\"$url_smiles/" . $vals[2] . "\"> ", $smile_code, $message);
    }
    return($message);
}
// #####################################################################
function msg_bbencode($message)
{
    global $prefix;
    // [CODE] and [/CODE] for posting code (HTML, PHP, C etc etc) in your posts.
    $message = str_replace(array('&#41;', '&#124;'), array(')', '|'), $message); /// macht mxSecureValue() rckgngig
    $matchCount = preg_match_all("#\[code\](.*?)\[/code\]#si", $message, $matches);
    for ($i = 0; $i < $matchCount; $i++) {
        $currMatchTextBefore = preg_quote($matches[1][$i]);
        $currMatchTextAfter = htmlspecialchars($matches[1][$i]);
        $message = preg_replace("#\[code\]$currMatchTextBefore\[/code\]#si", "<!-- BBCode Start --><TABLE BORDER=\"0\" ALIGN=\"CENTER\" WIDTH=\"85%\"><TR><TD><font class=\"tiny\">Code:</font><hr size=1 noshade></TD></TR><TR><TD><font class=\"tiny\"><PRE>$currMatchTextAfter</PRE></FONT></TD></TR><TR><TD><hr size=1 noshade></TD></TR></TABLE><!-- BBCode End -->", $message);
    }
    // [QUOTE] and [/QUOTE] for posting replies with quote, or just for quoting stuff.
    $message = preg_replace("#\[quote\](.*?)\[/quote]#si", "<!-- BBCode Quote Start --><TABLE BORDER=\"0\" ALIGN=\"CENTER\" WIDTH=\"85%\"><TR><TD><font class=\"tiny\">Quote:</font><hr size=1 noshade></TD></TR><TR><TD><BLOCKQUOTE><font class=\"tiny\">\\1</FONT></BLOCKQUOTE></TD></TR><TR><TD><hr size=1 noshade></TD></TR></TABLE><!-- BBCode Quote End -->", $message);
    // [b] and [/b] for bolding text.
    $message = preg_replace("#\[b\](.*?)\[/b\]#si", "<!-- BBCode Start --><B>\\1</B><!-- BBCode End -->", $message);
    // [i] and [/i] for italicizing text.
    $message = preg_replace("#\[i\](.*?)\[/i\]#si", "<!-- BBCode Start --><I>\\1</I><!-- BBCode End -->", $message);
    // [url]www.phpbb.com[/url] code..
    $message = preg_replace("#\[url\](http://)?(.*?)\[/url\]#si", "<!-- BBCode Start --><A HREF=\"http://\\2\" TARGET=\"_blank\">\\2</A><!-- BBCode End -->", $message);
    // [url=www.phpbb.com]phpBB[/url] code..
    $message = preg_replace("#\[url=(http://)?(.*?)\](.*?)\[/url\]#si", "<!-- BBCode Start --><A HREF=\"http://\\2\" TARGET=\"_blank\">\\3</A><!-- BBCode End -->", $message);
    // [email]user@domain.tld[/email] code..
    $message = preg_replace("#\[email\](.*?)\[/email\]#si", "<!-- BBCode Start --><A HREF=\"mailto:\\1\">\\1</A><!-- BBCode End -->", $message);
    // [img]image_url_here[/img] code..
    $message = preg_replace("#\[img\](.*?)\[/img\]#si", "<!-- BBCode Start --><IMG SRC=\"\\1\"><!-- BBCode End -->", $message);
    // unordered list code..
    $matchCount = preg_match_all("#\[list\](.*?)\[/list\]#si", $message, $matches);
    for ($i = 0; $i < $matchCount; $i++) {
        $currMatchTextBefore = preg_quote($matches[1][$i]);
        $currMatchTextAfter = preg_replace("#\[\*\]#si", "<LI>", $matches[1][$i]);
        $message = preg_replace("#\[list\]$currMatchTextBefore\[/list\]#si", "<!-- BBCode ulist Start --><UL>$currMatchTextAfter</UL><!-- BBCode ulist End -->", $message);
    }
    // ordered list code..
    $matchCount = preg_match_all("#\[list=([a1])\](.*?)\[/list\]#si", $message, $matches);
    for ($i = 0; $i < $matchCount; $i++) {
        $currMatchTextBefore = preg_quote($matches[2][$i]);
        $currMatchTextAfter = preg_replace("#\[\*\]#si", "<LI>", $matches[2][$i]);
        $message = preg_replace("#\[list=([a1])\]$currMatchTextBefore\[/list\]#si", "<!-- BBCode olist Start --><OL TYPE=\\1>$currMatchTextAfter</OL><!-- BBCode olist End -->", $message);
    }
    return($message);
}
// #####################################################################
function msg_bbdecode($message)
{
    $message = str_replace(array('&#41;', '&#124;'), array(')', '|'), $message); /// macht mxSecureValue() rckgngig
    // Undo [code]
    // $code_start_html = "<!-- BBCode Start --><TABLE BORDER=\"0\" ALIGN=\"CENTER\" WIDTH=\"85%\"><TR><TD><font class=\"tiny\">Code:</font><hr size=1 noshade></TD></TR><TR><TD><font class=\"tiny\"><PRE>";
    // $code_end_html = "</PRE></FONT></TD></TR><TR><TD><hr size=1 noshade></TD></TR></TABLE><!-- BBCode End -->";
    // $message = str_replace($code_start_html, "[code]", $message);
    // $message = str_replace($code_end_html, "[/code]", $message);
    // Undo [quote]
    $quote_start_html = "<!-- BBCode Quote Start --><TABLE BORDER=\"0\" ALIGN=\"CENTER\" WIDTH=\"85%\"><TR><TD><font class=\"tiny\">Quote:</font><hr size=1 noshade></TD></TR><TR><TD><BLOCKQUOTE><font class=\"tiny\">";
    $quote_end_html = "</FONT></BLOCKQUOTE></TD></TR><TR><TD><hr size=1 noshade></TD></TR></TABLE><!-- BBCode Quote End -->";
    $message = str_replace($quote_start_html, "[quote]", $message);
    $message = str_replace($quote_end_html, "[/quote]", $message);
    // Undo [b] and [i]
    $message = preg_replace("#<!-- BBCode Start --><B>(.*?)</B><!-- BBCode End -->#s", "[b]\\1[/b]", $message);
    $message = preg_replace("#<!-- BBCode Start --><I>(.*?)</I><!-- BBCode End -->#s", "[i]\\1[/i]", $message);
    // Undo [url] (long form)
    $message = preg_replace("#<!-- BBCode u2 Start --><A HREF=\"([a-z]+?://)(.*?)\" TARGET=\"_blank\">(.*?)</A><!-- BBCode u2 End -->#s", "[url=\\1\\2]\\3[/url]", $message);
    // Undo [url] (short form)
    $message = preg_replace("#<!-- BBCode u1 Start --><A HREF=\"([a-z]+?://)(.*?)\" TARGET=\"_blank\">(.*?)</A><!-- BBCode u1 End -->#s", "[url]\\3[/url]", $message);
    // Undo [email]
    $message = preg_replace("#<!-- BBCode Start --><A HREF=\"mailto:(.*?)\">(.*?)</A><!-- BBCode End -->#s", "[email]\\1[/email]", $message);
    // Undo [img]
    $message = preg_replace("#<!-- BBCode Start --><IMG SRC=\"(.*?)\" BORDER=\"0\"><!-- BBCode End -->#s", "[img]\\1[/img]", $message);
    // Undo lists (unordered/ordered)
    // <li> tags:
    $message = str_replace("<!-- BBCode --><LI>", "[*]", $message);
    // [list] tags:
    $message = str_replace("<!-- BBCode ulist Start --><UL>", "[list]", $message);
    // [list=x] tags:
    $message = preg_replace("#<!-- BBCode olist Start --><OL TYPE=([A1])>#si", "[list=\\1]", $message);
    // [/list] tags:
    $message = str_replace("</UL><!-- BBCode ulist End -->", "[/list]", $message);
    $message = str_replace("</OL><!-- BBCode olist End -->", "[/list]", $message);
    return($message);
}
// #####################################################################
/**
 * Nathan Codding - Jan. 12, 2001.
 * Performs [quote][/quote] bbencoding on the given string, and returns the results.
 * Any unmatched "[quote]" or "[/quote]" token will just be left alone.
 * This works fine with both having more than one quote in a message, and with nested quotes.
 * Since that is not a regular language, this is actually a PDA and uses a stack. Great fun.
 *
 * Note: This function assumes the first character of $message is a space, which is added by
 * msg_bbencode().
 */
function msg_bbencode_quote($message)
{
    // $message = mxPrepareToHTMLDisplay($message);
    $message = str_replace(array('&#41;', '&#124;'), array(')', '|'), $message); /// macht mxSecureValue() rckgngig
    // First things first: If there aren't any "[quote]" strings in the message, we don't
    // need to process it at all.
    if (!strpos(strtolower($message), "[quote]")) {
        return $message;
    }
    $stack = Array();
    $curr_pos = 1;
    while ($curr_pos && ($curr_pos < strlen($message))) {
        $curr_pos = strpos($message, "[", $curr_pos);
        // If not found, $curr_pos will be 0, and the loop will end.
        if ($curr_pos) {
            // We found a [. It starts at $curr_pos.
            // check if it's a starting or ending quote tag.
            $possible_start = substr($message, $curr_pos, 7);
            $possible_end = substr($message, $curr_pos, 8);
            if (strcasecmp("[quote]", $possible_start) == 0) {
                // We have a starting quote tag.
                // Push its position on to the stack, and then keep going to the right.
                array_push($stack, $curr_pos); #bbcode_array_push($stack, $curr_pos);
                ++$curr_pos;
            } else if (strcasecmp("[/quote]", $possible_end) == 0) {
                // We have an ending quote tag.
                // Check if we've already found a matching starting tag.
                if (sizeof($stack) > 0) {
                    // There exists a starting tag.
                    // We need to do 2 replacements now.
                    $start_index = array_pop($stack); #bbcode_array_pop($stack);
                    // everything before the [quote] tag.
                    $before_start_tag = substr($message, 0, $start_index);
                    // everything after the [quote] tag, but before the [/quote] tag.
                    $between_tags = substr($message, $start_index + 7, $curr_pos - $start_index - 7);
                    // everything after the [/quote] tag.
                    $after_end_tag = substr($message, $curr_pos + 8);
                    $message = $before_start_tag . "<!-- BBCode Quote Start --><TABLE BORDER=\"0\" ALIGN=\"CENTER\" WIDTH=\"85%\"><TR><TD><font class=\"tiny\">Quote:</font><hr size=1 noshade></TD></TR><TR><TD><BLOCKQUOTE><font class=\"tiny\">";
                    $message .= $between_tags . "</FONT></BLOCKQUOTE></TD></TR><TR><TD><hr size=1 noshade></TD></TR></TABLE><!-- BBCode Quote End -->";
                    $message .= $after_end_tag;
                    // Now.. we've screwed up the indices by changing the length of the string.
                    // So, if there's anything in the stack, we want to resume searching just after it.
                    // otherwise, we go back to the start.
                    if (sizeof($stack) > 0) {
                        $curr_pos = array_pop($stack); #bbcode_array_pop($stack);
                        array_push($stack, $curr_pos); #bbcode_array_push($stack, $curr_pos);
                        ++$curr_pos;
                    } else {
                        $curr_pos = 1;
                    }
                } else { // No matching start tag found. Increment pos, keep going.
                    ++$curr_pos;
                }
            } else { // No starting tag or ending tag.. Increment pos, keep looping.,
                ++$curr_pos;
            }
        }
    } // while
    return $message;
} // msg_bbencode_quote()
// #####################################################################
/**
 * Rewritten by Nathan Codding - Feb 6, 2001.
 * - Goes through the given string, and replaces xxxx://yyyy with an HTML <a> tag linking
 *      to that URL
 * - Goes through the given string, and replaces www.xxxx.yyyy[zzzz] with an HTML <a> tag linking
 *      to http://www.xxxx.yyyy[/zzzz]
 * - Goes through the given string, and replaces xxxx@yyyy with an HTML mailto: tag linking
 *       to that email address
 * - Only matches these 2 patterns either after a space, or at the beginning of a line
 * Notes: the email one might get annoying - it's easy to make it more restrictive, though.. maybe
 * have it require something like xxxx@yyyy.zzzz or such. We'll see.
 */
if (!function_exists('make_clickable')) {
    function make_clickable($text)
    {
        // $text = mxPrepareToHTMLDisplay($text);
        $text = str_replace(array('&#41;', '&#124;'), array(')', '|'), $text); /// macht mxSecureValue() rckgngig
        // pad it with a space so we can match things at the start of the 1st line.
        $ret = " " . $text;
        // matches an "xxxx://yyyy" URL at the start of a line, or after a space.
        // xxxx can only be alpha characters.
        // yyyy is anything up to the first space, newline, or comma.
        $ret = preg_replace("#([\n ])([a-z]+?)://([^, \n\r]+)#i", "\\1 <a href=\"\\2://\\3\" target=\"_blank\">\\2://\\3</a> ", $ret);
        // matches a "www.xxxx.yyyy[/zzzz]" kinda lazy URL thing
        // Must contain at least 2 dots. xxxx contains either alphanum, or "-"
        // yyyy contains either alphanum, "-", or "."
        // zzzz is optional.. will contain everything up to the first space, newline, or comma.
        // This is slightly restrictive - it's not going to match stuff like "forums.foo.com"
        // This is to keep it from getting annoying and matching stuff that's not meant to be a link.
        $ret = preg_replace("#([\n ])www\.([a-z0-9\-]+)\.([a-z0-9\-.\~]+)((?:/[^, \n\r]*)?)#i", "\\1 <a href=\"http://www.\\2.\\3\\4\" target=\"_blank\">www.\\2.\\3\\4</a> ", $ret);
        // matches an email@domain type address at the start of a line, or after a space.
        // Note: before the sign, the only valid characters are the alphanums and "-", "_", or ".".
        // After the sign, we accept anything up to the first space, linebreak, or comma.
        $ret = preg_replace("#([\n ])([a-z0-9\-_.]+?)@([^, \n\r]+)#i", "\\1<!-- BBcode auto-mailto start --><a href=\"mailto:\\2@\\3\">\\2@\\3</a><!-- BBCode auto-mailto end -->", $ret);
        // Remove our padding..
        $ret = substr($ret, 1);
        return($ret);
    }
}

if (!function_exists('pmxSigBbCode')) {
    /**
     * diese Funktion stammt aus dem mxBoard und ergaenzt das alte Teil aus den PM's ;)
     */
    function pmxSigBbCode($message)
    {
        // eventuelle Zeilenumbrche bei bestimmten bbCode-Tags entfernen, damit nl2br keine zustzlichen anfgt...
        $message = preg_replace('#[[:cntrl:]]?(\[/?(?:p|li|center|blink|strike|h[1-7]|marquee|quote|list(?:=[1Aa])?)\])[[:cntrl:]]?#is', '\1', $message);

        $message = preg_replace('#\[size=([1-7])\](.*)\[\/size\]#isU', "<font size=\"\\1\">\\2</font>", $message);
        $message = preg_replace("/\[color=([^\[]*)\](.*)\[\/color\]/isU", "<font color=\"\\1\">\\2</font>", $message);
        $message = preg_replace("/\[font=([^\[]*)\](.*)\[\/font\]/isU", "<font face=\"\\1\">\\2</font>", $message);
        $message = preg_replace("/\[align=([^\[]*)\](.*)\[\/align\]/isU", "<p align=\"\\1\">\\2</p>", $message);
        // unterstrichen extra behandeln
        $message = preg_replace('#\[([u])\]#is', '<u style="text-decoration: underline;">', $message);
        // Formatierungen, fett, unterstrichen, kursiv, absatz
        $message = preg_replace('#\[(/?[abiup])\]#is', '<\1>', $message);
        $message = preg_replace('#\[(/?(?:center|blink|strike|li|strong|h[1-7]|sup|marquee))\]#is', '<\1>', $message);
        $message = preg_replace("/(^|[>[:space:]\n])([[:alnum:]]+):\/\/([^[:space:]]*)([[:alnum:]#?\/&=])([<[:space:]\n]|$)/mi", "\\1<a href=\"\\2://\\3\\4\" target=\"_blank\">\\2://\\3\\4</a>\\5", $message);
        $message = str_replace("[list]", "<ul type=\"square\">", $message);
        $message = str_replace("[/list]", "</ul>", $message);
        $message = preg_replace('#\[list=([1Aa])\]#i', '<ol type="\1">', $message);
        $message = preg_replace('#\[/?list=([1Aa])\]#i', '</ol>', $message);
        $message = str_replace("[*]", "<li>", $message);
        $message = str_replace("[line]", "<hr width=\"95%\" size=\"1\" noshade>", $message);
        $message = str_replace("[hr]", "<hr width=\"95%\" size=\"1\" noshade>", $message);
        $message = preg_replace("/\[img(?:[^\]]*)\]([^\[]*)\[\/img\]/i", "<img src=\"\\1\" border=\"0\" alt=\"\">", $message);
        // # Img-Link fix
        $patterns = array();
        $replacements = array();
        $patterns[0] = "/\[url\]www.([^\[]*)\[\/url\]/i";
        $replacements[0] = "<a href=\"http://www.\\1\" target=_blank>\\1</a>";
        $patterns[1] = "/\[url\]([^\[]*)\[\/url\]/i";
        $replacements[1] = "<a href=\"\\1\" target=_blank>\\1</a>";
        $patterns[2] = "/\[url=([^\[]*)\]([^\[]*)\[\/url\]/i";
        $replacements[2] = "<a href=\"\\1\" target=_blank>\\2</a>";
        $patterns[3] = "/\[email\]([^\[]*)\[\/email\]/i";
        $replacements[3] = "<a href=\"mailto:\\1\">\\1</a>";
        $patterns[4] = "/\[email=([^\[]*)\]([^\[]*)\[\/email\]/i";
        $replacements[4] = "<a href=\"mailto:\\1\">\\2</a>";
        $message = preg_replace($patterns, $replacements, $message);

        return $message;
    }
}

?>
