<?php
/**
 * This file is part of 
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.3 $
 * $Author: tora60 $
 * $Date: 2007/12/22 14:15:56 $
 */

defined('mxMainFileLoaded') or die('access denied');
$modname = basename(dirname(dirname(__FILE__)));

unset($sqlqry);
// private Nachrichten (user_prefix !!)
// falls noch alte Version mit prefix, Tabelle umbenennen
if (isset($tables["${prefix}_priv_msgs"]) && !isset($tables["${prefix}_priv_msgs"]) && $prefix != $user_prefix) {
    $sql = "RENAME TABLE `${prefix}_priv_msgs` TO `${prefix}_priv_msgs`;";
    setupDoAllQueries($sql);
    unset($sql);
    if (setupTableExist("${prefix}_priv_msgs", 'refresh')) {
        unset($tables["${prefix}_priv_msgs"]);
    }
}

if (!isset($tables["${prefix}_priv_msgs"])) {
    $sqlqry[] = "
CREATE TABLE `${prefix}_priv_msgs` (
  `msg_id` int(10) NOT NULL auto_increment,
  `msg_image` varchar(100) default NULL,
  `subject` varchar(100) default NULL,
  `from_userid` int(10) NOT NULL default '0',
  `to_userid` int(10) NOT NULL default '0',
  `msg_time` datetime NOT NULL default '0000-00-00 00:00:00',
  `msg_text` text,
  `read_msg` tinyint(10) NOT NULL default '0',
  PRIMARY KEY  (`msg_id`),
  KEY `to_userid` (`to_userid`),
  KEY `read_msg` (`read_msg`),
  KEY `from_userid` (`from_userid`),
  KEY `msg_time` (`msg_time`)
) TYPE=MyISAM;";
} else {
    // Felder aktualisieren
    $tf = setupGetTableFields("${prefix}_priv_msgs");
    // ab mX 2.2
    // if (!isset($tf['outbox'])) {
    // $sqlqry[] = "ALTER TABLE `${prefix}_priv_msgs` ADD `outbox` TINYINT( 1 ) NOT NULL DEFAULT '0' ;";
    // }
    if ($tf['msg_time']['Type'] != 'datetime') {
        $sqlqry[] = "ALTER TABLE `${prefix}_priv_msgs` CHANGE `msg_time` `msg_time` DATETIME NOT NULL default '0000-00-00 00:00:00' ;";
    }
    // indexe
    $indexes = setupGetTableIndexes("${prefix}_priv_msgs");
    if (!isset($indexes['PRIMARY'])) {
        $sqlqry[] = "ALTER TABLE `${prefix}_priv_msgs` ADD PRIMARY KEY ( `msg_id` );";
    } else if ($indexes['PRIMARY']['Column_name'] != 'msg_id') {
        $sqlqry[] = "ALTER TABLE `${prefix}_priv_msgs` DROP PRIMARY KEY, ADD PRIMARY KEY ( `msg_id` );";
    }
    if (isset($indexes['msg_id'])) $sqlqry[] = "ALTER TABLE `${prefix}_priv_msgs` DROP INDEX `msg_id`;";
    if (!isset($indexes['to_userid'])) $sqlqry[] = "ALTER TABLE `${prefix}_priv_msgs` ADD INDEX to_userid( `to_userid` );";
    if (!isset($indexes['read_msg'])) $sqlqry[] = "ALTER TABLE `${prefix}_priv_msgs` ADD INDEX `read_msg` ( `read_msg` ) ";
    if (!isset($indexes['from_userid'])) $sqlqry[] = "ALTER TABLE `${prefix}_priv_msgs` ADD INDEX `from_userid` ( `from_userid` ) ";
    if (!isset($indexes['msg_time'])) $sqlqry[] = "ALTER TABLE `${prefix}_priv_msgs` ADD INDEX `msg_time` ( `msg_time` ) ";
    // if (!isset($indexes['outbox'])) $sqlqry[] = "ALTER TABLE `${prefix}_priv_msgs` ADD INDEX outbox( `outbox` ) ";
}

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}

/*
// private Nachrichten von nuke >= 6.5 importieren
if (isset($tables["${prefix}_bbprivmsgs"]) && isset($tables["${prefix}_bbprivmsgs_text"])) {
    // 1 = ungelesen / inbox
    // 5 = ungelesen / inbox aber mitgeteilt
    // 0 = gelesen / inbox
    // 3 = gelesen / savebox
    // 2 = gesendet / outbox
    // 4 = gesendet / savebox
    $numrows = mysql_num_rows(mysql_query("SELECT privmsgs_id FROM ${prefix}_bbprivmsgs LIMIT 1;"));
    if ($numrows) {
        // ungelesene
        $sqlqry[] = "INSERT INTO ${prefix}_priv_msgs ( read_msg, from_userid, to_userid, msg_time, subject, msg_text, outbox )
		SELECT 0 as read_msg, pm.privmsgs_from_userid, pm.privmsgs_to_userid, FROM_UNIXTIME(pm.privmsgs_date), pm.privmsgs_subject, t.privmsgs_text, 0 as outbox
		FROM ((${prefix}_bbprivmsgs AS pm LEFT JOIN ${prefix}_bbprivmsgs_text AS t ON pm.privmsgs_id = t.privmsgs_text_id) LEFT JOIN ${user_prefix}_users AS uto ON pm.privmsgs_to_userid = uto.uid) LEFT JOIN ${user_prefix}_users AS ufrom ON pm.privmsgs_from_userid = ufrom.uid
		WHERE ((t.privmsgs_text_id Is Not Null) AND (uto.uid Is Not Null) AND (ufrom.uid Is Not Null))
		AND (pm.privmsgs_type = 1 OR pm.privmsgs_type = 5)
		ORDER BY pm.privmsgs_date;";
        // gelesene
        $sqlqry[] = "INSERT INTO ${prefix}_priv_msgs ( read_msg, from_userid, to_userid, msg_time, subject, msg_text, outbox )
		SELECT 1 as read_msg, pm.privmsgs_from_userid, pm.privmsgs_to_userid, FROM_UNIXTIME(pm.privmsgs_date), pm.privmsgs_subject, t.privmsgs_text, 0 as outbox
		FROM ((${prefix}_bbprivmsgs AS pm LEFT JOIN ${prefix}_bbprivmsgs_text AS t ON pm.privmsgs_id = t.privmsgs_text_id) LEFT JOIN ${user_prefix}_users AS uto ON pm.privmsgs_to_userid = uto.uid) LEFT JOIN ${user_prefix}_users AS ufrom ON pm.privmsgs_from_userid = ufrom.uid
		WHERE ((t.privmsgs_text_id Is Not Null) AND (uto.uid Is Not Null) AND (ufrom.uid Is Not Null))
		AND (pm.privmsgs_type = 0 OR pm.privmsgs_type = 3)
		ORDER BY pm.privmsgs_date;";
        // gesendet
        $sqlqry[] = "INSERT INTO ${prefix}_priv_msgs ( read_msg, from_userid, to_userid, msg_time, subject, msg_text, outbox )
		SELECT 0 as read_msg, pm.privmsgs_from_userid, pm.privmsgs_to_userid, FROM_UNIXTIME(pm.privmsgs_date), pm.privmsgs_subject, t.privmsgs_text, 1 as outbox
		FROM ((${prefix}_bbprivmsgs AS pm LEFT JOIN ${prefix}_bbprivmsgs_text AS t ON pm.privmsgs_id = t.privmsgs_text_id) LEFT JOIN ${user_prefix}_users AS uto ON pm.privmsgs_to_userid = uto.uid) LEFT JOIN ${user_prefix}_users AS ufrom ON pm.privmsgs_from_userid = ufrom.uid
		WHERE ((t.privmsgs_text_id Is Not Null) AND (uto.uid Is Not Null) AND (ufrom.uid Is Not Null))
		AND (pm.privmsgs_type = 2 OR pm.privmsgs_type = 4)
		ORDER BY pm.privmsgs_date;";
    }
    $sqlqry[] = "RENAME TABLE `${prefix}_bbprivmsgs`      TO `" . RENAME_PREFIX . "${prefix}_bbprivmsgs`;";
    $sqlqry[] = "RENAME TABLE `${prefix}_bbprivmsgs_text` TO `" . RENAME_PREFIX . "${prefix}_bbprivmsgs_text`;";
}
// PM-Tabelle aufraeumen, alle loeschen, die nicht in outbox und Empfaenger nicht mehr existiert
$msgids = array();
$result = mysql_query("SELECT pm.msg_id FROM ${prefix}_priv_msgs AS pm LEFT JOIN ${user_prefix}_users AS uto ON pm.to_userid = uto.uid WHERE ((uto.uid Is Null) AND (pm.outbox=0));");
while (list($mid) = mysql_fetch_row($result)) {
    $msgids[] = $mid;
}
if (count($msgids)) {
    $msgids = implode(',', $msgids);
    $sqlqry[] = "DELETE FROM ${prefix}_priv_msgs WHERE msg_id in (" . $msgids . ");";
}


if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}

 */
?>