<?php
/**
 * This file is part of 
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.8.2.2 $
 * $Author: tora60 $
 * $Date: 2007/12/22 14:11:52 $
 *
 * this file based on:
 * php-nuke Web Portal System - http://phpnuke.org/
 * Thatware - http://thatware.org/
 */

defined('mxMainFileLoaded') or die('access denied');

$module_name = basename(dirname(__FILE__));
mxGetLangfile($module_name);
include_once("includes/mxNewsFunctions.php");

require("includes/captcha/settings.php");
$newson = (($newson) && ((!MX_IS_USER) || ((MX_IS_USER) && ($captchauseron))) && (!MX_IS_ADMIN));

$pagetitle = _SUBMITNEWS;

/**
 */
function defaultDisplay()
{
    include("header.php");
    OpenTable();
    echo "<center><font class=\"title\"><b>" . _SUBMITNEWS . "</b></font></center>";
    echo "<p class=\"content\">" . _SUBMITADVICE . "</p>";
    CloseTable();
    echo "<br>";
    vkpNewsForm();
    include ('footer.php');
}

/**
 */
function PreviewStory($story)
{
    $story = mxStripSlashes($story);
    include("header.php");
    if (isset($story['errmsg'])) {
        title(_SUBMITNEWS);
        openTableAl();
        echo '<div style="text-align: left;"><h2>' . _ERROROCCURS . '</h2><ul><li>' . implode('</li><li>', $story['errmsg']) . '</li></ul></div>';
        closeTableAl();
        echo '<br>';
    } else {
        title(_NEWSUBPREVIEW);
        OpenTable();
        echo "<center><i>" . _STORYLOOK . "</i><br><br>";
        vkpStoryPreview($story);
        echo "<font class=\"tiny\">" . _CHECKSTORY . "</font></center>";
        CloseTable();
        echo "<br>";
    }
    vkpNewsForm($story);
    include ('footer.php');
}

/**
 */
function submitStory($story)
{
    global $prefix, $newson, $passphraselenght, $storagetype;
    if (empty($story['topic'])) {
        $story['errmsg'][] = _ERRNOTOPIC;
    }
    if (empty($story['title'])) {
        $story['errmsg'][] = _ERRNOTITLE;
    }
    if (empty($story['hometext'])) {
        $story['errmsg'][] = _ERRNOTEXT;
    }
    if ($newson) {
        require_once("includes/captcha/__captcha/PhraseFactory.php");
        if (empty($story['captcha'])) {
            $story['errmsg'][] = _CAPTCHAWRONG;
        } else {
            $storedCaptcha = PhraseFactory::get('', $passphraselenght, $story['captcha'], $storagetype);
            if ($story['captcha'] !== $storedCaptcha) {
                $story['errmsg'][] = _CAPTCHAWRONG;
            }
        }
    }
    // wenn Fehler aufgetreten, einfach die Vorschau aufrufen und abbrechen
    if (isset($story['errmsg'])) {
        $story['op'] = _PREVIEW;
        PreviewStory($story);
        exit;
    }

    extract($story);
    if (MX_IS_USER) {
        $cookie = mxGetUserSession();
        $uid = $cookie[0];
        $name = $cookie[1];
    } else {
        $uid = 1;
        $name = $GLOBALS['anonymous'];
    }
    $qry = "insert into " . $prefix . "_queue
	        (uid,uname,subject,story,storyext,timestamp,topic,alanguage) values
					(" . intval($uid) . ", '" . mxAddSlashesForSQL(strip_tags($name)) . "', '" . mxAddSlashesForSQL(strip_tags($title)) . "', '" . mxAddSlashesForSQL($hometext) . "', '" . mxAddSlashesForSQL($bodytext) . "', now(), " . intval($topic) . ", '" . mxAddSlashesForSQL(strip_tags($alanguage)) . "')";
    // print $qry;
    // mxDebugFuncVars($story);
    // exit;
    $result = sql_query($qry);
    if ($result) {
        if (!empty($GLOBALS['notify'])) {
            $qid = sql_insert_id();
            $story = mxStripSlashes($story);
            extract($story);
            $notify_message = mxHtmlEntityDecode("-- " . _NEWSARTICLES . " --\n" . $GLOBALS['notify_message'] . "\n\n\n========================================================\n" . MX_HOME_URL . "/admin.php?op=DisplayStory&qid=" . $qid . "\n\n" . $title . "\n\n\n" . $hometext . "\n" . $bodytext . "\n\nfrom: " . $name);
            mxMail($GLOBALS['notify_email'], mxHtmlEntityDecode($GLOBALS['notify_subject']), $notify_message, $GLOBALS['notify_from'], "text");
        }
        header("Location: modules.php?name=" . $GLOBALS['module_name'] . "&op=thanks");
    } else {
        $story['errmsg'] = _ERRNOSAVED;
        PreviewStory($story);
        exit;
    }
}

/**
 */
function thankspage()
{
    global $prefix;
    $waiting = 1;
    $result = sql_query("select count(qid) from " . $prefix . "_queue");
    list($waiting) = sql_fetch_row($result);
    include("header.php");
    title(_SUBSENT);
    OpenTable();
    echo "<center><font class=\"content\">" . _SUBTEXT . "<br>" . _WEHAVESUB . " " . $waiting . " " . _WAITING . "<br><br>"
     . "<b>" . _THANKSSUB . "</b></font></center>";
    CloseTable();
    include ('footer.php');
}

/**
 */
function vkpNewsForm($story = array())
{
    global $newson;
    $story["topic"] = (empty($story["topic"])) ? vkpGetFirstTopic() : $story["topic"];
    $story["alanguage"] = (empty($story["alanguage"])) ? "" : $story["alanguage"];
    $story["title"] = (empty($story["title"])) ? "" : strip_tags($story["title"]);
    $story["hometext"] = (empty($story["hometext"])) ? "" : $story["hometext"];
    $story["bodytext"] = (empty($story["bodytext"])) ? "" : $story["bodytext"];
    OpenTable();
    echo "<div class=\"content\"><form name=\"snews\" action=\"modules.php?name=" . $GLOBALS['module_name'] . "\" method=\"post\">";
    echo"<input type=\"hidden\" name=\"name\" value=\"" . $GLOBALS['module_name'] . "\">\n";
    echo "<br><br>";
    vkpSelectTopic($story["topic"]);
    echo "<br><br>";
    addNewsTextFields($story);
    echo "<br><br>";
    vkpNewsSelectLanguage($story["alanguage"]);
    echo "<br><br>";
    if ($newson && isset($story["op"])) {
        require("includes/captcha/captcha_java.php");
        echo "<br><br><img id=\"captchaimage\" src=\"includes/captcha/captchaimg.php?" . md5(crypt(uniqid(''))) . "\" alt=\"\"><br><br>";
        echo "<b>" . _CAPTCHAINSERT . "</b><br>";
        echo "<input type=\"text\" name=\"captcha\" value=\"\" size=\"20\" maxlength=\"20\"><br><br>";
    }
    echo "<input type=\"submit\" name=\"op\" value=\"" . _PREVIEW . "\">";
    if (isset($story["op"])) {
        echo "&nbsp;&nbsp;<input type=\"submit\" name=\"op\" value=\"" . _OK . "\">";
        if ($newson) {
            echo '&nbsp;&nbsp;<input type="button" value="' . _CAPTCHARELOAD . '" onclick="do_reload(); return false;"> ';
        }
    }
    echo "</form></div>";
    CloseTable();
}

$op = (empty($_REQUEST['op'])) ? "" : $_REQUEST['op'];
switch ($op) {
    case _PREVIEW:
        PreviewStory($_POST);
        break;
    case _OK:
        SubmitStory($_POST);
        break;
    case "thanks":
        thankspage();
        break;
    default:
        defaultDisplay();
        break;
}

?>
