<?php
/**
 * This file is part of 
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.3 $
 * $Author: tora60 $
 * $Date: 2007/12/22 14:15:56 $
 */

defined('mxMainFileLoaded') or die('access denied');
$modname = basename(dirname(dirname(__FILE__)));

unset($sqlqry);
// Umfragen-Tabelle anpassen und Standardwert eintragen
if (!isset($tables["${prefix}_poll_desc"])) {
    $sqlqry[] = "
CREATE TABLE `${prefix}_poll_desc` (
  `pollID` int(11) NOT NULL auto_increment,
  `pollTitle` varchar(100) NOT NULL default '',
  `timeStamp` int(11) NOT NULL default '0',
  `voters` mediumint(9) NOT NULL default '0',
  `planguage` varchar(30) NOT NULL default '',
  `artid` int(10) NOT NULL default '0',
  `pollactive` tinyint(1) unsigned NOT NULL default '1',
  `pollcomments` tinyint(1) unsigned NOT NULL default '1',
  PRIMARY KEY  (`pollID`),
  KEY `pollactive` (`pollactive`),
  KEY `planguage` (`planguage`),
  KEY `artid` (`artid`)
) TYPE=MyISAM;";
}

if (!isset($tables["${prefix}_poll_data"])) {
    $sqlqry[] = "
CREATE TABLE `${prefix}_poll_data` (
  `pollID` int(11) NOT NULL default '0',
  `optionText` varchar(50) NOT NULL default '',
  `optionCount` int(11) NOT NULL default '0',
  `voteID` int(11) NOT NULL default '0',
  PRIMARY KEY  (`pollID`,`voteID`),
  KEY `pollID` (`pollID`),
  KEY `voteID` (`voteID`),
  KEY `optionText` (`optionText`)
) TYPE=MyISAM;";
}
// todo: eindeutiger index
if (!isset($tables["${prefix}_poll_check"])) {
    $sqlqry[] = "
CREATE TABLE `${prefix}_poll_check` (
  `ip` varchar(20) NOT NULL default '',
  `time` varchar(14) NOT NULL default '',
  `pollID` int(10) NOT NULL default '0',
  PRIMARY KEY  (`ip`,`pollID`)
) TYPE=MyISAM;";
}

if (!isset($tables["${prefix}_pollcomments"])) {
    $sqlqry[] = "
CREATE TABLE `${prefix}_pollcomments` (
  `tid` int(11) NOT NULL auto_increment,
  `pid` int(11) default '0',
  `pollID` int(11) default '0',
  `date` datetime default NULL,
  `name` varchar(60) NOT NULL default '',
  `email` varchar(60) default NULL,
  `url` varchar(60) default NULL,
  `host_name` varchar(60) default NULL,
  `subject` varchar(60) NOT NULL default '',
  `comment` text NULL,
  `score` tinyint(4) NOT NULL default '0',
  `reason` tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (`tid`),
  KEY `pollID` (`pollID`),
  KEY `date` (`date`),
  KEY `name` (`name`),
  KEY `host_name` (`host_name`)
) TYPE=MyISAM;";
}

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}
// Daten einfuegen
$numrows = mysql_num_rows(mysql_query("SELECT `pollID` FROM `${prefix}_poll_data` LIMIT 1"));
if (!$numrows) {
    $sqlqry[] = "INSERT INTO ${prefix}_poll_data (pollID, optionText, optionCount, voteID) VALUES (1, 'sehr gut', 0, 1);";
    $sqlqry[] = "INSERT INTO ${prefix}_poll_data (pollID, optionText, optionCount, voteID) VALUES (1, 'gut', 0, 2);";
    $sqlqry[] = "INSERT INTO ${prefix}_poll_data (pollID, optionText, optionCount, voteID) VALUES (1, 'ganz nett', 0, 3);";
    $sqlqry[] = "INSERT INTO ${prefix}_poll_data (pollID, optionText, optionCount, voteID) VALUES (1, 'gew&ouml;hnungsbed&uuml;rftig', 0, 4);";
    $sqlqry[] = "INSERT INTO ${prefix}_poll_data (pollID, optionText, optionCount, voteID) VALUES (1, 'na ja ....', 0, 5);";
    $sqlqry[] = "INSERT INTO ${prefix}_poll_data (pollID, optionText, optionCount, voteID) VALUES (1, '', 0, 6);";
    $sqlqry[] = "INSERT INTO ${prefix}_poll_data (pollID, optionText, optionCount, voteID) VALUES (1, '', 0, 7);";
    $sqlqry[] = "INSERT INTO ${prefix}_poll_data (pollID, optionText, optionCount, voteID) VALUES (1, '', 0, 8);";
    $sqlqry[] = "INSERT INTO ${prefix}_poll_data (pollID, optionText, optionCount, voteID) VALUES (1, '', 0, 9);";
    $sqlqry[] = "INSERT INTO ${prefix}_poll_data (pollID, optionText, optionCount, voteID) VALUES (1, '', 0, 10);";
    $sqlqry[] = "INSERT INTO ${prefix}_poll_data (pollID, optionText, optionCount, voteID) VALUES (1, '', 0, 11);";
    $sqlqry[] = "INSERT INTO ${prefix}_poll_data (pollID, optionText, optionCount, voteID) VALUES (1, '', 0, 12);";
}
// Umfragen-Tabelle anpassen und Standardwert eintragen
if (isset($tables["${prefix}_poll_desc"])) {
    // Felder aktualisieren
    $tf = setupGetTableFields("${prefix}_poll_desc");
    if (!isset($tf['pollactive'])) {
        $sqlqry[] = "ALTER TABLE `${prefix}_poll_desc` ADD `pollactive` TINYINT( 1 ) unsigned NOT NULL DEFAULT '1';";
    } else if ($tf['pollactive']['Type'] != 'tinyint(1) unsigned') {
        $sqlqry[] = "ALTER TABLE `${prefix}_poll_desc` CHANGE `pollactive` `pollactive` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '1'";
    }
    if (!isset($tf['pollcomments'])) {
        $sqlqry[] = "ALTER TABLE `${prefix}_poll_desc` ADD `pollcomments` TINYINT( 1 ) unsigned NOT NULL DEFAULT '1';";
    } else if ($tf['pollcomments']['Type'] != 'tinyint(1) unsigned') {
        $sqlqry[] = "ALTER TABLE `${prefix}_poll_desc` CHANGE `pollcomments` `pollcomments` TINYINT( 1 ) UNSIGNED NOT NULL DEFAULT '1'";
    }
}

$numrows = mysql_num_rows(mysql_query("SELECT `pollID` FROM `${prefix}_poll_desc` LIMIT 1"));
if (!$numrows) {
    $sqlqry[] = "INSERT INTO ${prefix}_poll_desc (pollID, pollTitle, timeStamp, voters, planguage, artid, pollactive) VALUES (1, 'Wie gef&auml;llt Ihnen diese Seite', 1058898752, 0, 'german', 0, 1);";
} else {
    if (!isset($tf['pollactive'])) {
        // wenn das Feld pollactive noch nicht vorhanden war
        $sqlqry[] = "UPDATE `${prefix}_poll_desc` SET `pollactive` = 1;";
    }
    if (!isset($tf['pollcomments'])) {
        // wenn das Feld pollactive noch nicht vorhanden war
        $sqlqry[] = "UPDATE `${prefix}_poll_desc` SET `pollcomments` = 1;";
    }
}

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}

if (isset($tables["${prefix}_poll_data"])) {
    // Indexe
    $indexes = setupGetTableIndexes("${prefix}_poll_data");
    if (!isset($indexes['PRIMARY'])) {
        $sqlqry[] = "ALTER TABLE `${prefix}_poll_data` ADD PRIMARY KEY ( `pollID` , `voteID` );";
    } else if (!isset($indexes['PRIMARY']['all_fields']['pollID']) || !isset($indexes['PRIMARY']['all_fields']['voteID'])) {
        $sqlqry[] = "ALTER TABLE `${prefix}_poll_data` DROP PRIMARY KEY , ADD PRIMARY KEY ( `pollID` , `voteID` );";
    }
    if (!isset($indexes['pollID'])) $sqlqry[] = "ALTER TABLE `${prefix}_poll_data` ADD INDEX `pollID` ( `pollID` ) ";
    if (!isset($indexes['voteID'])) $sqlqry[] = "ALTER TABLE `${prefix}_poll_data` ADD INDEX `voteID` ( `voteID` ) ";
    if (!isset($indexes['optionText'])) $sqlqry[] = "ALTER TABLE `${prefix}_poll_data` ADD INDEX `optionText` ( `optionText` ) ";

    $tf = setupGetTableFields("${prefix}_poll_data");
    if (isset($tf['optionTextE'])) $sqlqry[] = "ALTER TABLE `${prefix}_poll_data` DROP `optionTextE` "; // cp
    if (isset($tf['optionText'])) {
        if ($tf['optionText']['Type'] != 'varchar(50)') $sqlqry[] = "ALTER TABLE `${prefix}_poll_data` CHANGE `optionText` `optionText` VARCHAR( 50 ) NOT NULL DEFAULT '';";
    }
}

if (isset($tables["${prefix}_poll_check"])) {
    $indexes = setupGetTableIndexes("${prefix}_poll_check");
    if (!isset($indexes['PRIMARY'])) {
        if (version_compare(MX_SQL_VERSION, '3.23.28', "<")) {
            $sqlqry[] = "DELETE FROM ${prefix}_poll_check";
        } else {
            // This is special: it only works in 3.23.28 and above, but.. it resets the increment. (it may fail in 3.23.4, etc.)
            $sqlqry[] = "TRUNCATE ${prefix}_poll_check";
        }
        $sqlqry[] = "ALTER TABLE `${prefix}_poll_check` ADD PRIMARY KEY ( `ip` , `pollID` )";
    }
}

if (isset($tables["${prefix}_poll_desc"])) {
    $indexes = setupGetTableIndexes("${prefix}_poll_desc");
    if (!isset($indexes['pollactive'])) $sqlqry[] = "ALTER TABLE `${prefix}_poll_desc` ADD INDEX `pollactive` ( `pollactive` ) ";
    if (!isset($indexes['planguage'])) $sqlqry[] = "ALTER TABLE `${prefix}_poll_desc` ADD INDEX `planguage` ( `planguage` ) ";
    if (!isset($indexes['artid'])) $sqlqry[] = "ALTER TABLE `${prefix}_poll_desc` ADD INDEX `artid` ( `artid` ) ";

    $tf = setupGetTableFields("${prefix}_poll_desc");
    if (isset($tf['comments'])) $sqlqry[] = "ALTER TABLE `${prefix}_poll_desc` DROP `comments` "; // ab nuke 7.x
    if (isset($tf['pollTitleE'])) $sqlqry[] = "ALTER TABLE `${prefix}_poll_desc` DROP `pollTitleE` "; // cp
}

if (isset($tables["${prefix}_pollcomments"])) {
    $indexes = setupGetTableIndexes("${prefix}_pollcomments");
    if (!isset($indexes['pollID'])) $sqlqry[] = "ALTER TABLE `${prefix}_pollcomments` ADD INDEX `pollID` ( `pollID` ) ";
    if (!isset($indexes['date'])) $sqlqry[] = "ALTER TABLE `${prefix}_pollcomments` ADD INDEX `date` ( `date` ) ";
    if (!isset($indexes['name'])) $sqlqry[] = "ALTER TABLE `${prefix}_pollcomments` ADD INDEX `name` ( `name` ) ";
    if (!isset($indexes['host_name'])) $sqlqry[] = "ALTER TABLE `${prefix}_pollcomments` ADD INDEX `host_name` ( `host_name` ) ";
    // nuke 7.9
    $tf = setupGetTableFields("${prefix}_pollcomments");
    if (isset($tf['last_moderation_ip'])) $sqlqry[] = "ALTER TABLE `${prefix}_pollcomments` DROP `last_moderation_ip` ";
}

if (isset($tables["${prefix}_pollcomments"])) {
    $tf = setupGetTableFields("${prefix}_pollcomments");
    if ($tf['comment']['Default'] !== null) {
        $sqlqry[] = "ALTER TABLE `${prefix}_pollcomments`
                CHANGE `comment` `comment` text NULL";
    }
}

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}
// aufraeumen
unset($numrows);

?>