<?php
/**
 * This file is part of 
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.19 $
 * $Author: tora60 $
 * $Date: 2008/02/03 18:39:41 $
 */
// Sets PHP Error-Reporting to a lower level
error_reporting(E_ERROR);
// error_reporting(E_ALL);
@ini_Set('track_errors', '1');
@ini_set("max_execution_time", 400);
// Benchmarkanzeige initialisieren
if (!defined("MX_TIME")) {
    $vstarttime = explode(" ", microtime());
    define("MX_TIME", (float)$vstarttime[1] + (float)$vstarttime[0]);
    unset($vstarttime);
}
// Ausgabe puffern, damit Cookies und Weiterleitungen nicht durch Fehlermeldungen gestoert werden
ob_start();

if (!defined("mxMainFileLoaded")) define("mxMainFileLoaded", "mxMainFileLoaded");
if (!defined("mxAdminFileLoaded")) define("mxAdminFileLoaded", "mxAdminFileLoaded");
if (!defined("mxRunInSetup")) define("mxRunInSetup", "mxRunInSetup");

if (!defined("MX_SETUP_DIR")) define("MX_SETUP_DIR", dirname(__FILE__));

include_once("includes/functions.php");
// ///////////////////////////////////
// /// - simuliert magic_quotes_gpc=1
if (count($_GET)) {
    foreach ($_GET as $key => $value) {
        $_GET[$key] = setupSecureValue($value);
    }
}
if (count($_POST)) {
    foreach ($_POST as $key => $value) {
        $_POST[$key] = setupSecureValue($value);
    }
}
if (count($_COOKIE)) {
    foreach ($_COOKIE as $key => $value) {
        $_COOKIE[$key] = setupSecureValue($value);
    }
}
// falsche Reihenfolge, damit evtl. existierende Cookies berschrieben werden
$_REQUEST = array_merge($_COOKIE, $_GET, $_POST);

include_once("setup-settings.php");

if (!get_cfg_var("register_globals")) {
    extract($_SERVER, EXTR_OVERWRITE);
}
// Initialisiere Startsprache und Option
$_REQUEST["slang"] = (empty($_REQUEST["slang"])) ? SETUP_DEFAULTLANG : $_REQUEST["slang"];
$_REQUEST["op"] = (empty($_REQUEST["op"])) ? 'start' : $_REQUEST["op"];
// mxDebugFuncVars(array_merge($_GET, $_POST));
/**
 * Sprache einstellen
 */
if (empty($_REQUEST['slang']) || !file_exists("language/lang-" . $_REQUEST['slang'] . ".php")) {
    $_REQUEST['slang'] = SETUP_DEFAULTLANG;
}
include_once("language/lang-" . $_REQUEST['slang'] . ".php");
// Laendereinstellung, mit den Werten aus dem globalen Sprachfile
setlocale(LC_TIME, _SETLOCALE);

$caption = '';
$option = '';
$output = '';
// Behandlung der Setup-Schritte
switch ($_REQUEST["op"]) {
    // ###############################
    case 'start':
        $mainsetupstep = 1;
        if (version_compare(PHP_VERSION, MX_SETUP_MIN_PHPVERSION, '<')) {
            $output = '
            	<h3>Sorry, PHP-Version >= ' . MX_SETUP_MIN_PHPVERSION . ' is required.</h3>
            	<p>Your current Version is: ' . PHP_VERSION . '</p>';
        } else {
            $goto = 'index.php?op=select';
            $langlist = mxGetAllLanguages($goto, 'language');
            $output = $langlist;
        }
        $option = _SELECT_LANG;
        break;
    // ###############################
    case 'select':
        $mainsetupstep = 2;
        $option = _STEP_SELECT;
        $default = setupGetOldVersion();
        foreach($opt as $opt => $arr) {
            // mxDebugFuncVars($arr['version'], $default);
            $select[] = '
            <h3><input type="radio" name="setupoption" value="' . $opt . '"' . (($arr['version'] == $default) ? ' checked="checked"': '') . ' />&nbsp;' . constant($arr['name']) . '</h3>
            <p>' . constant($arr['description']) . '</p>';
        }
        $output = '
        	<div class="info">
        		<p>' . _HELLOINSTALL2 . '</p>
        		<p>' . _WHATWILLYOUDO . '</p>
        	</div>
    			<form action="index.php" method="post">' . implode('', $select) . '
    				<p><a href="index.php?mxsetupid=' . SETUP_ID . '">' . _GOBACK . '</a>&nbsp;
    					' . hiddenrequest('license') . '
    					<input type="submit" value="' . _SUBMIT . '" />
     				</p>
    			</form>
    			<hr />
 					<div>' . printdeleter(_OR . ':') . '</div>';
        break;
    case 'delsetupdir':
        if (!isset($_GET['ts'])) die('puhh...');
        $new = basename(__FILE__) . SETUP_RENAME;
        // index.php umbenennen
        $ok = @rename(basename(__FILE__), $new);
        if ($ok) {
            print 'OK!<br /><br />' . $new;
        } else {
            print 'FAILED!<br /><br />' . $new;
        }
        clearstatcache();
        // .htaccess anlegen
        $file = @fopen(dirname(__FILE__) . '/.htaccess', "w");
        @fwrite($file, "deny from all\n");
        @fclose($file);
        exit;
}
// ZWEITE Behandlung der Setup-Schritte, weil $op evtl. durch vorige Behandlung gendert wurde
switch ($_REQUEST["op"]) {
    // ###############################
    case 'license';
        $mainsetupstep = 5;

        $newversion = $GLOBALS['opt'][$_REQUEST['setupoption']]['version'];
        $oldversion = setupGetOldVersion();
        // print "set: $newversion, old: $oldversion";
        // mxDebugFuncVars($GLOBALS['opt']);
        if (($newversion != $oldversion) && empty($_REQUEST['versionignore'])) {
            $mainsetupstep = 3;
            $option = _STEP_ISINCORRECT;
            $output = '
            	<p class="warning">' . _OLDVERSION_ERR1 . '</p>
							<p>' . _OLDVERSION_ERR2 . '</p>
            	<form action="index.php" method="post" class="inline">
        				<p>' . hiddenrequest('license') . '
        					<input type="hidden" name="setupoption" value="' . $_REQUEST['setupoption'] . '" />
        					<input type="submit" name="versionignore" value="' . _YES . '" />
        				</p>
        			</form>
        			<form action="index.php" method="post" class="inline">
        				<p>' . hiddenrequest('select') . '
        					<input type="submit" value="' . _NO . '" />
        				</p>
        			</form>';
        } else {
            $option = _STEP_LICENSE;
            // $text = file_get_contents('language/'.$GLOBALS['opt'][$_REQUEST['setupoption']]['license'].'-'.$_REQUEST['slang'].'.txt');
            $text = htmlentities(file_get_contents('gpl.txt'));
            $output = '
            	<textarea cols="80" rows="15" readonly="readonly" style="padding: 6px; font-size: 12px;">' . $text . '</textarea>
    					<p>' . _ACCEPT . '</p>
 							<form action="index.php" method="post" class="inline">
    						<p>' . hiddenrequest('cancel') . '
        					<input type="submit" name="goback" value="' . _NO . '" />
        				</p>
        			</form>
        			<form action="index.php" method="post" class="inline">
        				<p>' . hiddenrequest('setup') . '
        					<input type="submit" value="' . _YES . '" />
        				</p>
        			</form>';
        }

        break;
    // ###############################
    case 'cancel'; /// Lizenz abgelehnt
        $mainsetupstep = 0;
        $option = _SETUPCANCELED;
        $output = '
        	<p><a href="index.php?mxsetupid=' . SETUP_ID . '">' . _START . '</a></p>';
        break;
    // ###############################
    default;
        if (empty($mainsetupstep)) {
            $output = '';
            $setupfile = PATH_SETUP_INCLUDES . '/option_' . $GLOBALS['opt'][$_REQUEST['setupoption']]['version'] . '.php';
            if (@file_exists($setupfile)) {
                include_once($setupfile);
            } else {
                $option = _ERROR_FATAL;
                $output = '
                	<p class="warning">' . sprintf(_SETUPMODNOTFOUND1, basename($setupfile)) . '</p>';
            }
        }
        break;
}
// Ausgabe von evtl. umgebenden Zeilenumbrchen befreien
$output = preg_replace('#^(<br\s*/?>|[[:space:]])*(.*)#i', '\2', $output);
$output = trim(preg_replace('#(<br\s*/?>|[[:space:]])*$#i', '', $output));
// parsen der Ausgabe
if (empty($htmlfile)) $htmlfile = FILE_SETUP_TEMPLATE;
if (empty($caption)) $caption = _HELLOINSTALL;
ob_start();
include($htmlfile);
$htmlfile = ob_get_clean();
$htmlfile = str_replace('{_CHARSET}', _CHARSET, $htmlfile);
$htmlfile = str_replace("images/", "html/images/", $htmlfile);
$htmlfile = str_replace("style/", "html/style/" , $htmlfile);
$htmlfile = str_replace('{VERSIONNUM}', MX_SETUP_VERSION , $htmlfile);
$htmlfile = str_replace('{CAPTION}', strip_tags($caption) , $htmlfile);
$htmlfile = str_replace('{OPTION}', strip_tags($option, '<br>') , $htmlfile);
$htmlfile = str_replace('{TITLE}', strip_tags($option) , $htmlfile);
$htmlfile = str_replace('{OUTPUT}', $output , $htmlfile);
// $htmlfile = str_replace("<hr />", '<img src="html/images/graypixel.gif" alt="" width="450" height="1" vspace="5" border="0" />', $htmlfile);
echo $htmlfile;

?>