<?php
/**
 * This file is part of 
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.11 $
 * $Author: tora60 $
 * $Date: 2008/02/03 18:40:13 $
 */

defined('mxMainFileLoaded') or die('access denied');
unset($sqlqry);
// Variable zum feststellen, ob bereits pragmaMx installiert war
$is_pmx = false;
// Tabellenstruktur fuer Tabelle `mx_blocks`
if (!isset($tables["${prefix}_blocks"])) {
    $sqlqry[] = "
CREATE TABLE `${prefix}_blocks` (
  `bid` int(10) NOT NULL auto_increment,
  `bkey` varchar(15) NOT NULL default '',
  `title` varchar(60) NOT NULL default '',
  `content` text,
  `url` varchar(200) NOT NULL default '',
  `position` char(1) NOT NULL default 'l',
  `weight` int(10) NOT NULL default '1',
  `active` int(1) NOT NULL default '1',
  `refresh` int(10) NOT NULL default '0',
  `time` int(10) NOT NULL default '0',
  `blanguage` varchar(30) NOT NULL default '',
  `blockfile` varchar(255) NOT NULL default '',
  `view` int(1) NOT NULL default '0',
  PRIMARY KEY  (`bid`),
  KEY `blanguage` (`blanguage`),
  KEY `active` (`active`),
  KEY `view` (`view`),
  KEY `posweight` (`position`,`weight`)
) TYPE=MyISAM;
    ";
} else {
    $tf = setupGetTableFields("${prefix}_blocks");
    // Cachefelder entfernen, falls vorhanden = reset-blockcache
    foreach ($tf as $fieldname => $temp) {
        if (preg_match('#^cache_([[:alnum:]]|_)*#i', $fieldname)) {
            $sqlqry[] = "ALTER TABLE `${prefix}_blocks` DROP `$fieldname`";
            unset($tf[$fieldname]);
            // Wenn bereits ein Block-Cache Feld vorhanden war, dann
            // war bereits pragmaMx installiert
            $is_pmx = true;
        }
    }
    // zusaetzliche Felder
    if (!isset($tf['view'])) $sqlqry[] = "ALTER TABLE `${prefix}_blocks` ADD `view` int(1) NOT NULL default '0' AFTER blockfile;";
    // ////  ab mX 2.2:
    // if (!isset($tf['morepara'])) $sqlqry[] = "ALTER TABLE `${prefix}_blocks` ADD `morepara` text";
    // if (!isset($tf['start_date'])) $sqlqry[] = "ALTER TABLE `${prefix}_blocks` ADD `start_date` INT( 11 ) NOT NULL DEFAULT '0'";
    // if (!isset($tf['end_date'])) $sqlqry[] = "ALTER TABLE `${prefix}_blocks` ADD `end_date` INT( 11 ) NOT NULL DEFAULT '0'";
    // Felder aus bestimmten nuke Versionen umbenennen und aendern
    if (isset($tf['bposition']) && !isset($tf['position'])) $sqlqry[] = "ALTER TABLE `${prefix}_blocks` CHANGE `bposition` `position` CHAR( 1 ) NOT NULL DEFAULT '" . SYS_BLOCKPOS_LEFT . "';";
    if (isset($tf['position']) && ($tf['position']['Type'] != 'char(1)' || $tf['position']['Default'] != 'l')) $sqlqry[] = "ALTER TABLE `${prefix}_blocks` CHANGE `position` `position` CHAR( 1 ) NOT NULL DEFAULT 'l'";
    if (isset($tf['time']) && $tf['time']['Type'] != 'int(10)') {
        $sqlqry[] = "UPDATE `${prefix}_blocks` SET `time` = 0";
        $sqlqry[] = "ALTER TABLE `${prefix}_blocks` CHANGE `time` `time` int(10) NOT NULL default 0";
    }
    // nuke >= 7.0
    if (isset($tf['expire'])) $sqlqry[] = "ALTER TABLE `${prefix}_blocks` DROP `expire` ;";
    if (isset($tf['action'])) $sqlqry[] = "ALTER TABLE `${prefix}_blocks` DROP `action` ;";
    // nuke >= 7.1
    if (isset($tf['subscription'])) $sqlqry[] = "ALTER TABLE `${prefix}_blocks` DROP `subscription` ;";
    if (isset($tf['custom_title_german'])) $sqlqry[] = "ALTER TABLE `${prefix}_blocks` DROP `custom_title_german` "; // cp
    if (isset($tf['custom_title_english'])) $sqlqry[] = "ALTER TABLE `${prefix}_blocks` DROP `custom_title_english` "; // cp
    // Standardwert fuer content fixen
    if (isset($tf['content']) && $tf['content']['Null'] != 'YES') $sqlqry[] = "ALTER TABLE `${prefix}_blocks` CHANGE `content` `content` TEXT NULL ;";
    // mxDebugFuncVars($tf, $sqlqry); exit;
}

if (isset($tables["${prefix}_blocks"])) {
    $tf = setupGetTableFields("${prefix}_blocks");
    if ($tf['content']['Default'] !== null) {
        $sqlqry[] = "ALTER TABLE `${prefix}_blocks`
                CHANGE `content` `content` text NULL";
    }
}

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}
// array der News-Bloecke
$newsblocks = setup_NewsBlocks();
$isnewsblock = array();
// Daten fuer Blocktabelle
if (!isset($tables["${prefix}_blocks"])) {
    // Daten fuer Tabelle `mx_blocks`
    // ACHTUNG!!! ohne `bid`
    $sqlqry[] = "INSERT INTO `${prefix}_blocks` (`title`, `content`, `url`, `position`, `weight`, `active`, `refresh`, `time`, `blanguage`, `blockfile`, `view`) VALUES ('" . _BLOCK_CAPTION_1 . "', '', '', '" . SYS_BLOCKPOS_LEFT . "', 1, 1, 0, 0, '', 'block-AdminAlert.php', 2);";
    $sqlqry[] = "INSERT INTO `${prefix}_blocks` (`title`, `content`, `url`, `position`, `weight`, `active`, `refresh`, `time`, `blanguage`, `blockfile`, `view`) VALUES ('" . _BLOCK_CAPTION_2 . "', '', '', '" . SYS_BLOCKPOS_LEFT . "', 2, 1, 0, 0, '', 'block-AdminNews.php', 2);";
    $sqlqry[] = "INSERT INTO `${prefix}_blocks` (`title`, `content`, `url`, `position`, `weight`, `active`, `refresh`, `time`, `blanguage`, `blockfile`, `view`) VALUES ('" . _BLOCK_CAPTION_3 . "', '', '', '" . SYS_BLOCKPOS_RIGHT . "', 11, 1, 3600, 0, '', 'block-Languages.php', 0);";
    $sqlqry[] = "INSERT INTO `${prefix}_blocks` (`title`, `content`, `url`, `position`, `weight`, `active`, `refresh`, `time`, `blanguage`, `blockfile`, `view`) VALUES ('" . _BLOCK_CAPTION_4 . "', '', '', '" . SYS_BLOCKPOS_RIGHT . "', 3, 1, 0, 0, '', 'block-Login.php', 3);";
    $sqlqry[] = "INSERT INTO `${prefix}_blocks` (`title`, `content`, `url`, `position`, `weight`, `active`, `refresh`, `time`, `blanguage`, `blockfile`, `view`) VALUES ('" . _BLOCK_CAPTION_5 . "', '" . _BLOCK_CAPTION_5A . "', '', '" . SYS_BLOCKPOS_RIGHT . "', 5, 1, 0, 0, '', 'block-Userblock.php', 1);";
    $sqlqry[] = "INSERT INTO `${prefix}_blocks` (`title`, `content`, `url`, `position`, `weight`, `active`, `refresh`, `time`, `blanguage`, `blockfile`, `view`) VALUES ('" . _BLOCK_CAPTION_6 . "', '', '', '" . SYS_BLOCKPOS_RIGHT . "', 7, 1, 0, 0, '', 'block-Who_is_Online.php', 1);";
    $sqlqry[] = "INSERT INTO `${prefix}_blocks` (`title`, `content`, `url`, `position`, `weight`, `active`, `refresh`, `time`, `blanguage`, `blockfile`, `view`) VALUES ('" . _BLOCK_CAPTION_8 . "', '', '', '" . SYS_BLOCKPOS_RIGHT . "', 10, 1, 3600, 0, '', 'block-Survey.php', 1);";
    $sqlqry[] = "INSERT INTO `${prefix}_blocks` (`title`, `content`, `url`, `position`, `weight`, `active`, `refresh`, `time`, `blanguage`, `blockfile`, `view`) VALUES ('" . _BLOCK_CAPTION_9 . "', '', 'http://www.pragmamx.org/backend.php?op=story', '" . SYS_BLOCKPOS_RIGHT . "', 12, 1, 36000, 1079910549, '', '', 0);";
    // $sqlqry[] = "INSERT INTO `${prefix}_blocks` (`title`, `content`, `url`, `position`, `weight`, `active`, `refresh`, `time`, `blanguage`, `blockfile`, `view`) VALUES ('" . _NEWINSTALLMESSAGEBLOCKTITLE . "', '" . _NEWINSTALLMESSAGEBLOCK . "', '', '" . SYS_BLOCKPOS_CENTER . "', 1, 1, 0, 0, '', '', 0);";
}

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}

$result2 = mysql_query("SELECT * FROM ${prefix}_blocks");
$blcount = mysql_num_rows($result2);
// wenn bloecke in Tabelle vorhanden
if ($blcount) {
    // neue Bloecke fur vkpmx
    // alle Bloecke in Tabelle pruefen
    while ($block = mysql_fetch_assoc($result2)) {
        // veraltete Nuke-Bloecke ausblenden
        if (!$block['blockfile'] && $block['content'] && $block['active']) {
            if (strpos($block['content'], 'user.php') !== false || strpos($block['content'], 'phpnuke.gif') !== false) {
                $sqlqry[] = "UPDATE `${prefix}_blocks` SET `active` = '0', `view` = '2' WHERE `content` like '%" . '"user.php"' . "%' OR  `content` like '%" . 'phpnuke.gif' . "%';";
                continue;
            }
        }
        if ($block['blockfile']) {
            if (!file_exists(PATH_MX_BLOCKS . '/' . $block['blockfile'])) {
                $sqlqry[] = "DELETE FROM `${prefix}_blocks` WHERE `blockfile` = '" . $block['blockfile'] . "';";
                continue;
            }
            // alle Dateibloecke in extra Array speichern
            $allblocks[$block['blockfile']] = $block;
            // nicht-vkpMx Bloecke deaktivieren
            if (!is_vkp_block($block['blockfile']) && $block['active']) {
                $sqlqry[] = "UPDATE `${prefix}_blocks` SET `active` = '0' WHERE `blockfile` = '" . $block['blockfile'] . "';";
            }
        }
        // alte Systembloecke von nuke und VKP-MAxi in Dateibloecke umwandeln
        if ($block['blockfile'] == 'block-AdminLogin.php' || $block['bkey'] == 'admin') {
            $sqlqry[] = "UPDATE `${prefix}_blocks` SET `blockfile` = 'block-AdminNews.php', view='2', bkey='' WHERE `blockfile` = 'block-AdminLogin.php' OR `bkey`='admin';";
        } else if ($block['bkey'] == 'userbox') {
            $sqlqry[] = "UPDATE `${prefix}_blocks` SET `blockfile` = 'block-Userblock.php', view='1', bkey='' where bkey='userbox';";
        }
        // neue Bloecke fur vkpmx, bzw. nuke-Bloecke umschreiben
        else if ($block['blockfile'] == 'block-Advertising.php') {
            $sqlqry[] = "UPDATE `${prefix}_blocks` SET `blockfile` = 'block-Banner.php' WHERE `blockfile` = 'block-Advertising.php';";
        } else if ($block['blockfile'] == 'block-Banner_Footer.php' || $block['blockfile'] == 'block-Banner_Center.php') {
            $sqlqry[] = "UPDATE `${prefix}_blocks` SET `blockfile` = 'block-Banner.php' WHERE `blockfile` = 'block-Banner_Footer.php' OR  `blockfile` = 'block-Banner_Center.php';";
        } else if ($block['blockfile'] == 'block-User_Info.php') {
            $sqlqry[] = "UPDATE `${prefix}_blocks` SET `blockfile` = 'block-Who_is_Online.php' WHERE `blockfile` = 'block-User_Info.php';";
        }
        // news-Bloecke pruefen
        if (isset($newsblocks[$block['blockfile']])) {
            $isnewsblock[$block['blockfile']] = 1;
            // news-Bloecke an richtige Position setzen
            if ($block['position'] != SYS_BLOCKPOS_RIGHT) {
                $sqlqry[] = "UPDATE ${prefix}_blocks set position='" . SYS_BLOCKPOS_RIGHT . "' WHERE blockfile='" . $block['blockfile'] . "';";
            }
        }
        // Setup-Alarm-Block aktivieren
        if ($block['blockfile'] == 'block-AdminAlert.php' && $block['active'] != 1 && $block['view'] != 2) {
            $sqlqry[] = "UPDATE `${prefix}_blocks` SET `active` = 1, view=2 WHERE `blockfile` = 'block-AdminAlert.php'";
        }
    }
}
// sonstige Pflichtbloecke bei Neuinstall oder Update von Nuke einfuegen
if (!isset($tables["${prefix}_blocks"]) || !$is_pmx) {
    if (!isset($allblocks['block-Modules_one.php'])) $sqlqry[] = "INSERT INTO `${prefix}_blocks` (`title`, `content`, `url`, `position`, `weight`, `active`, `refresh`, `time`, `blanguage`, `blockfile`, `view`) VALUES ('" . _BLOCK_CAPTION_MAINMENU . "', '', '', '" . SYS_BLOCKPOS_LEFT . "', 3, 1, 3600, 0, '', 'block-Modules_one.php', 0);";
    if (!isset($allblocks['block-Modules_two.php'])) $sqlqry[] = "INSERT INTO `${prefix}_blocks` (`title`, `content`, `url`, `position`, `weight`, `active`, `refresh`, `time`, `blanguage`, `blockfile`, `view`) VALUES ('" . _BLOCK_CAPTION_INTERNAL . "', '', '', '" . SYS_BLOCKPOS_LEFT . "', 4, 1, 3600, 0, '', 'block-Modules_two.php', 0);";
    if (!isset($allblocks['block-Modules_three.php'])) $sqlqry[] = "INSERT INTO `${prefix}_blocks` (`title`, `content`, `url`, `position`, `weight`, `active`, `refresh`, `time`, `blanguage`, `blockfile`, `view`) VALUES ('" . _BLOCK_CAPTION_COMMUNITY . "', '', '', '" . SYS_BLOCKPOS_LEFT . "', 5, 1, 0, 0, '', 'block-Modules_three.php', 0);";
    if (!isset($allblocks['block-Modules.php'])) $sqlqry[] = "INSERT INTO `${prefix}_blocks` (`title`, `content`, `url`, `position`, `weight`, `active`, `refresh`, `time`, `blanguage`, `blockfile`, `view`) VALUES ('" . _BLOCK_CAPTION_OTHER . "', '', '', '" . SYS_BLOCKPOS_LEFT . "', 6, 1, 0, 0, '', 'block-Modules.php', 0);";
}

if (!isset($allblocks['block-AdminAlert.php'])) {
    $sqlqry[] = "INSERT INTO `${prefix}_blocks` (`title`, `position`, `weight`, `active`, `blockfile`, `view`) VALUES ('setup-alarm', '" . SYS_BLOCKPOS_CENTER . "', 1, 1, 'block-AdminAlert.php', 2);";
} else if (empty($allblocks['block-AdminAlert.php']['active'])) {
    $sqlqry[] = "UPDATE `${prefix}_blocks` SET `active` = 1, view=2 WHERE `blockfile` = 'block-AdminAlert.php';";
}
// ENDE Bloecke einfuegen / aendern
// wenn nicht alle news-Bloecke in Tabelle vorhanden sind
if (count($newsblocks) != count($isnewsblock)) {
    // News-Bloecke anfuegen
    $qry = "SELECT Max(weight) AS bmax FROM ${prefix}_blocks WHERE position='" . SYS_BLOCKPOS_RIGHT . "';";
    list($bmax) = mysql_fetch_row(mysql_query($qry));
    $bmax = intval($bmax);
    foreach($newsblocks as $blockfile => $blocktitle) {
        if (!isset($isnewsblock[$blockfile])) {
            $bmax++;
            $sqlqry[] = "INSERT INTO `${prefix}_blocks` (title, position, weight, active, refresh, blockfile, view) VALUES ('" . $blocktitle . "'  , '" . SYS_BLOCKPOS_RIGHT . "', " . $bmax . ", 1, 0, '" . $blockfile . "'  , 0);";
        }
    }
}
// Indexe aktualisieren
$indexes = setupGetTableIndexes("${prefix}_blocks");
if (!isset($indexes['blanguage'])) $sqlqry[] = "ALTER TABLE `${prefix}_blocks` ADD INDEX `blanguage` ( `blanguage` ) ;";
if (!isset($indexes['active'])) $sqlqry[] = "ALTER TABLE `${prefix}_blocks` ADD INDEX `active` ( `active` ) ;";
if (!isset($indexes['view'])) $sqlqry[] = "ALTER TABLE `${prefix}_blocks` ADD INDEX `view` ( `view` ) ;";
if (!isset($indexes['posweight'])) $sqlqry[] = "ALTER TABLE `${prefix}_blocks` ADD INDEX `posweight` ( `position` , `weight` ) ;";
if (isset($indexes['bid'])) $sqlqry[] = "ALTER TABLE `${prefix}_blocks` DROP INDEX `bid` ";
if (isset($indexes['title'])) $sqlqry[] = "ALTER TABLE `${prefix}_blocks` DROP INDEX `title` ";

if (isset($sqlqry)) {
    setupDoAllQueries($sqlqry);
    unset($sqlqry);
}

?>