<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.16.2.16 $
 * $Author: tora60 $
 * $Date: 2008/01/14 14:40:04 $
 */

unset($wyscnf);
@include(dirname(__FILE__) . '/editor_cnf.php');
@include_once(dirname(__FILE__) . '/mx_functions.php');

/* Falls noch eine alte, oder gar keine Konfigurationsdatei vorhanden ist,
* Standardwerte verwenden (direkt aus der config hierher kopieren)
*/
if (!isset($wyscnf)) {
    $wyscnf['globals'] = unserialize('a:8:{s:9:"pmxgroups";a:4:{i:1;s:1:"1";i:4;s:1:"0";i:3;s:1:"0";i:5;s:1:"0";}s:10:"fontfamily";a:5:{s:5:"Arial";s:5:"Arial";s:7:"Courier";s:7:"Courier";s:6:"Tahoma";s:6:"Tahoma";s:5:"Times";s:15:"Times New Roman";s:7:"Verdana";s:7:"Verdana";}s:13:"max_img_width";i:350;s:14:"max_img_height";i:300;s:12:"chmod_dir_to";s:0:"";s:8:"chmod_to";s:0:"";s:15:"area_foreground";s:0:"";s:15:"area_background";s:0:"";}');
    $wyscnf['modules'] = unserialize('a:11:{s:4:"news";s:1:"1";s:7:"content";s:1:"1";s:8:"sections";s:1:"1";s:4:"dolo";s:1:"1";s:4:"linx";s:1:"1";s:6:"review";s:1:"1";s:4:"enzy";s:1:"1";s:3:"faq";s:1:"1";s:5:"ephem";s:1:"1";s:8:"comments";s:1:"1";s:6:"topbox";s:1:"1";}');
    $wyscnf['admin'] = unserialize('a:5:{s:6:"active";i:1;s:7:"toolbar";s:3:"all";s:15:"upload_max_size";i:0;s:12:"allow_modify";i:1;s:8:"filetype";a:6:{s:6:"images";s:1:"1";s:5:"flash";s:1:"1";s:9:"documents";s:1:"1";s:5:"audio";s:1:"1";s:5:"video";s:1:"1";s:8:"archives";s:1:"1";}}');
    $wyscnf['user'] = unserialize('a:5:{s:6:"active";i:1;s:7:"toolbar";s:8:"standard";s:15:"upload_max_size";i:50;s:12:"allow_modify";i:0;s:8:"filetype";a:6:{s:6:"images";s:1:"1";s:5:"flash";s:1:"1";s:9:"documents";s:1:"0";s:5:"audio";s:1:"0";s:5:"video";s:1:"0";s:8:"archives";s:1:"0";}}');
    $wyscnf['other'] = unserialize('a:5:{s:6:"active";i:1;s:7:"toolbar";s:8:"standard";s:15:"upload_max_size";i:1;s:12:"allow_modify";i:0;s:8:"filetype";a:6:{s:6:"images";s:1:"0";s:5:"flash";s:1:"0";s:9:"documents";s:1:"0";s:5:"audio";s:1:"0";s:5:"video";s:1:"0";s:8:"archives";s:1:"0";}}');
}

/* Dateityp-Gruppen, analog zu den Spaw-Sprachdateien
 *(wird im Konfigurationsdialog benoetigt)
 */
$wyscnf['filetypegroups'] = array('images' => array('.jpg', '.jpeg', '.gif', '.png'),
    'flash' => array('.swf'),
    'documents' => array('.doc', '.xls', '.pdf', '.rtf', '.odt', '.ods', '.sxw', '.sxc', '.txt'),
    'audio' => array('.wav', '.mp3', '.ogg', '.wma'),
    'video' => array('.avi', '.mpg', '.mpeg', '.mov', '.wmv'),
    'archives' => array('.zip', '.rar', '.gz'),
    );

$wyscnf['font_replaces'] = array('Arial' => 'Arial, Helvetica, sans-serif',
    'Courier' => 'Courier New, Courier, monospace',
    'Times New Roman' => 'Times New Roman, Times, serif',
    'Verdana' => 'Verdana, Geneva, Arial, Helvetica, sans-serif',
    'sans-serif' => 'MS Sans Serif, Geneva, sans-serif',
    'serif' => 'MS Serif, New York, serif',
    );

/**
 * folgende Konstanten sind am Ende dieses Scriptes verfuegbar:
 * WYSIWYG_IS_USER (integer) = ist der Besucher ein angemeldeter Benutzer
 * WYSIWYG_IS_ADMIN (integer) = hat der Besucher Administratorrechte
 * WYSIWYG_IS_ADMIN_SUPER (integer) = hat der Besucher Super-Administratorrechte
 * WYSIWYG_THEME (string, *) = das eingestellte pragmaMx-Theme des Besuchers
 */
// die IP-Adresse wie in der mx_baseconfig behandeln
$_SERVER['REMOTE_ADDR'] = (!isset($_SERVER['REMOTE_ADDR'])) ? getenv('REMOTE_ADDR') : $_SERVER['REMOTE_ADDR'];
// die config.php vom pragmaMx includen, wird fuer Datenbankverbindung und defaulttheme benoetigt
// if (!isset($GLOBALS['dbuname']) && isset($_COOKIE['wysiswyg_id'])) {
if (!isset($GLOBALS['dbuname'])) {
    include(dirname(dirname(__file__)) . '/config.php');
}
// einen eindeutig(er)en Schluessel fuer den Cookiecheck erstellen
$wysiswyg_key = md5($GLOBALS['dbuname'] . '%#f~S' . __file__ . $_SERVER['REMOTE_ADDR']);

/**
 * Wenn die spaw_control.config.php ueber das Modul includiert wird, sind saemtliche
 * pragmaMx Funktionen verfuegbar. Hier werden dann alle relevanten Daten ermittelt
 * und in einem Cookie gespeichert.
 */
if (defined('mxMainFileLoaded')) {
    /* zur Abwaertskompatibilitaet, die alten Modulvariablen erstellen */
    foreach ($wyscnf['modules'] as $key => $value) {
        $xx['wysiwyg_' . $key] = $value;
    }
    $xx['wysiwyg_snews'] = $xx['wysiwyg_news'];
    $xx['wysiwyg_anews'] = $xx['wysiwyg_news'];
    extract($xx);
    unset($xx);

    /* Die Gruppenauaswahl zur Berechtigungs-Konfiguration */
    $wyscnf['pmx_groups_list'] = mxSpawGetUsergroupsList();
    if (count($wyscnf['pmx_groups_list']) > 1) {
        $usertitle = _USERSGROUPS . '&nbsp;<span><a href="#edgroups">*</a></span>';
    } else {
        $usertitle = _USERSMEMBERS;
    }
    $wyscnf['groups']['admin'] = array('title' => _USERSADMINS);
    $wyscnf['groups']['user'] = array('title' => $usertitle);
    $wyscnf['groups']['other'] = array('title' => _USERSOTHERS);

    /*
     * hier jetzt die benoetigten Konstanten definieren, da die mainfile ja verfuegbar ist,
     * koennen die Konstanten direkt gefuellt und verwendet werden
     */

    /* Feststellen, ob der User, in einer der speziell angegebenen Gruppen im Editor ist */
    $wysiswyg_restricted = mxDemoMode();
    if (MX_IS_USER && !$wysiswyg_restricted) {
        $userdata = mxGetUserData();
        if (empty($wyscnf['globals']['pmxgroups'][$userdata['user_ingroup']])) {
            define('WYSIWYG_IS_USER', 0);
        } else {
            define('WYSIWYG_IS_USER', 1);
        }
    } else {
        define('WYSIWYG_IS_USER', 0);
    }
    define('WYSIWYG_IS_ADMIN', intval(MX_IS_ADMIN && !$wysiswyg_restricted));
    // ermitteln ob Superadmin
    define('WYSIWYG_IS_ADMIN_SUPER', intval(mxGetAdminPref('radminsuper') && !$wysiswyg_restricted));
    // das aktuelle Theme auslesen
    define('WYSIWYG_THEME', mxGetTheme());

    /*
     * nur wenn user oder admin und kein Demomodus, den cookie generieren, es
     * ist auch nur dann sicher, dass cookies ueberhaupt akzeptiert werden
     */
    if ((WYSIWYG_IS_USER || WYSIWYG_IS_ADMIN || WYSIWYG_IS_ADMIN_SUPER) && !$wysiswyg_restricted) {
        $wysiswyg_id = base64_encode(serialize(array(
                    session_id(),
                    WYSIWYG_IS_USER,
                    WYSIWYG_IS_ADMIN,
                    WYSIWYG_IS_ADMIN_SUPER,
                    WYSIWYG_THEME,
                    $wysiswyg_key,
                    )));
        /* wenn der Cookie noch nicht vorhanden, oder falsche Daten enthaelt */
        if (!isset($_COOKIE['wysiswyg_id']) || $_COOKIE['wysiswyg_id'] != $wysiswyg_id) {
            /* den Cookie anlegen, mit Verfallszeit 0, damit er beim beednen der Sitzung geloescht wird */
            mxSetCookie('wysiswyg_id', $wysiswyg_id, 0);
        }
    } else {
        /* wenn kein user oder admin, aber ein entsprechender Cookie existiert, diesen loeschen */
        if (isset($_COOKIE['wysiswyg_id'])) {
            mxSetCookie('wysiswyg_id', '', -20000000);
            unset($_COOKIE['wysiswyg_id']);
        }
    }
    // endif mainfile
} else {
    // Wenn die spaw_control.config.php ueber eine Datei des Editors ohne die mainfile includiert
    // wird, sind keine pragmaMx Funktionen oder Werte verfuegbar. Die Daten muessen jetzt aus dem
    // vorher gesetzten Cookie gelesen werden. Die Gueltigkeit des Cookies wird durch den Gegencheck
    // zum eindeutigen Key validiert.
    // nur wenn der Cookie ueberhaupt vorhanden ist
    if (isset($_COOKIE['wysiswyg_id'])) {
        // das im cookie gespeichert Array wieder aufdroeseln
        $wysiswyg_data = unserialize(base64_decode($_COOKIE['wysiswyg_id']));
        // var_dump($wysiswyg_data, $wysiswyg_data[5], $wysiswyg_key);
        // checken, ob die darin mitgespeicherte Session-Id auch wirklich eine Session-Id sein koennte
        if (!preg_match('#^[[:alnum:]]{32}$#', $wysiswyg_data[0])) {
            die('unaccepted Sessionkey: ' . $wysiswyg_data[0]);
        }
        // checken, ob der darin mitgespeicherte Key korrekt ist
        if ($wysiswyg_data[5] === $wysiswyg_key) {
            // anhand der in der config.php gespeicherten Zugangsdaten eine Datenbankverbindung aufbauen
            $wysiswyg_dbi = mysql_connect($dbhost, $dbuname, $dbpass);
            if (!mysql_select_db($dbname, $wysiswyg_dbi)) {
                die(mysql_error());
            }
            // die Sessiontabelle auslesen. Es wird einfach nur geprueft ob zu der im Cookie uebergebenen
            // Session-Id eine gueltige Session vorhanden ist
            $qry = "SELECT data FROM ${prefix}_sys_session WHERE sesskey = '" . $wysiswyg_data[0] . "' AND expiry >= " . time(); # '
            if (mysql_num_rows(mysql_query($qry, $wysiswyg_dbi)) === 1) {
                // wenn exakt ein Datensatz diesen Bedingungen entspricht, dann ist der Cookie gueltig und
                // mit dessen Daten werden jetzt die benoetigten Konstanten gefuellt
                define('WYSIWYG_IS_USER', intval($wysiswyg_data[1]));
                define('WYSIWYG_IS_ADMIN', intval($wysiswyg_data[2]));
                define('WYSIWYG_IS_ADMIN_SUPER', intval($wysiswyg_data[3]));
                define('WYSIWYG_THEME', $wysiswyg_data[4]);
            }
            // die Datenbankverbindung kann hier wieder beendet werden
            mysql_close($wysiswyg_dbi);
        }
    }
    // falls kein gueltiger Cookie vorhanden, werden hier die Konstanten mit Standardwerten definiert
    if (!defined('WYSIWYG_IS_USER')) {
        define('WYSIWYG_IS_USER', 0);
        define('WYSIWYG_IS_ADMIN', 0);
        define('WYSIWYG_IS_ADMIN_SUPER', 0);
        define('WYSIWYG_THEME', ((isset($Default_Theme)) ? $Default_Theme : ''));
    }
}
/* den Speicher aufraeumen */

/* Die fuer die entsprechende Usergruppe festgelegte Konfiguration ermitteln */
switch (true) {
    case WYSIWYG_IS_ADMIN_SUPER:
    case WYSIWYG_IS_ADMIN:
        // Admin
        $my_wyscnf = $wyscnf['admin'];
        break;
    case WYSIWYG_IS_USER:
        // User
        $my_wyscnf = $wyscnf['user'];
        break;
    default:
        // Anonyme
        $my_wyscnf = $wyscnf['other'];
        // $wysiswyg_restricted = true;
}
/* die globalen Einstellungen anfuegen */
$my_wyscnf = array_merge($my_wyscnf, $wyscnf['globals']);

/* toolbar-Voreinstellung, kann aber bei Aufruf der Editorklasse verndert werden */
$wysiwyg_toolbar = $my_wyscnf['toolbar'];

/* Kompatibilitaet fuer alte Aufrufe */
$wysiwyg = $my_wyscnf['active'];
$wysiwyg_btnset = '';

/* die erlaubten Dateitypen aufbereiten */
if (WYSIWYG_IS_ADMIN_SUPER) {
    $my_wyscnf['filetype'] = array('any');
    $my_wyscnf['allow_upload'] = 1;
    $my_wyscnf['allow_modify'] = 1;
    $my_wyscnf['upload_max_size'] = 0;
    $my_wyscnf['max_img_width'] = 0;
    $my_wyscnf['max_img_height'] = 0;
} else {
    $types = array();
    foreach ($my_wyscnf['filetype'] as $key => $value) {
        $types[] = $key;
    }
    $my_wyscnf['filetype'] = $types;
    /* feststellen, ob upload allowed, das ist der Fall, wenn min. 1 Dateityp erlaubt ist */
    $my_wyscnf['allow_upload'] = count($types);
    /* wenn upload mnicht erlaubt ist, dann ist logischerweise auch das Aendern nicht erlaubt */
    if (!$my_wyscnf['allow_upload']) {
        $my_wyscnf['allow_modify'] = 0;
    }
    if ($my_wyscnf['allow_upload']) {
        if (intval($my_wyscnf['upload_max_size']) > 0) {
            // Wert wird in Spaw mit bytes gerechnet, aber in der pmx-Config in kb eingestellt
            $my_wyscnf['upload_max_size'] = $my_wyscnf['upload_max_size'] * 1024;
        } else {
            // unbegrenzt
            $my_wyscnf['upload_max_size'] = 0;
        }
    } else {
        // 1 byte, das ist so gut wie nix :))
        $my_wyscnf['upload_max_size'] = 1;
        $my_wyscnf['max_img_width'] = 1;
        $my_wyscnf['max_img_height'] = 1;
    }
}

/* Sicherstellen, dass das richtig belegt ist */
$my_wyscnf['chmod_to'] = (empty($my_wyscnf['chmod_to'])) ? '' : intval($my_wyscnf['chmod_to']);
$my_wyscnf['chmod_dir_to'] = (empty($my_wyscnf['chmod_dir_to'])) ? '' : intval($my_wyscnf['chmod_dir_to']);

$my_wyscnf['doctype_xhtml'] = false;
if (function_exists('mxDoctypeArray')) {
    // Das Array mit den versch. Doc-Type Deklarationen auslesen
    $doctype_arr = mxDoctypeArray($GLOBALS['DOCTYPE']);
    $my_wyscnf['doctype_xhtml'] = $doctype_arr['xhtml'];
}

?>
